<?php
Hook::register('actual_expense_payments');


function actual_expense_payments_object_definition($type, &$ret) {
	if ($type == 'PaymentReceipt') {
		$ret['paid'] = DATA_TYPE_BOOLEAN;
		$ret['payment_method'] = DATA_TYPE_INTEGER;
		$ret['payment_account'] = DATA_TYPE_INTEGER;
		$ret['paid_date'] = DATA_TYPE_DATE;
	}
}


function actual_expense_payments_object_edit_categories($object, &$categories) {
	if ($object instanceof PaymentReceipt) {

		tpl_assign('object', $object);

		$categories[] = array(
			'id' => 'actual_expense_payments',
			'name' => lang('payment'),
			'required' => false,
			'visible' => true,
			'content' => tpl_fetch(get_template_path('payments_tab', 'actual_expense_payments', 'actual_expense_payments')),
		);

	}
}

function actual_expense_payments_before_generate_payment_columns($payment_receipt, &$info) {
	$info[] = "payment_method_name";
	$info[] = "payment_account_name";
}

function actual_expense_payments_additional_actual_expense_array_info_data(PaymentReceipt $actual_expense, &$info) {

	if (Plugins::instance()->isActivePlugin('quickbooks')) {
		
		$p_method = QuickbooksPaymentMethods::findById($actual_expense->getColumnValue('payment_method'));
		$p_account = QuickbooksAccounts::findById($actual_expense->getColumnValue('payment_account'));

		$info['payment_method_name'] = $p_method instanceof QuickbooksPaymentMethod ? $p_method->getName() : '';
		$info['payment_account_name'] = $p_account instanceof QuickbooksAccount ? $p_account->getName() : '';
		
	} else {
		$info['payment_method_name'] = '';
		$info['payment_account_name'] = '';
	}
}
