<?php

  /**
  * BaseAdditionalMemberPermission class
  *
  * @author Alvaro Torterola <alvaro.torterola@fengoffice.com>
  */
  abstract class BaseAdditionalMemberPermission extends DataObject {
  
  	  
    // -------------------------------------------------------
    //  Access methods
    // -------------------------------------------------------
    
  	/**
  	 * Return value of 'id' field
  	 *
  	 * @access public
  	 * @param void
  	 * @return string
  	 */
  	function getId() {
  		return $this->getColumnValue('id');
  	} // getId()
  	
  	/**
  	 * Set value of 'id' field
  	 *
  	 * @access public
  	 * @param string $value
  	 * @return boolean
  	 */
  	function setId($value) {
  		return $this->setColumnValue('id', $value);
  	} // setId()
  
    /**
    * Return value of 'name' field
    *
    * @access public
    * @param void
    * @return string 
    */
    function getName() {
      return $this->getColumnValue('name');
    } 
    
    /**
    * Set value of 'name' field
    *
    * @access public   
    * @param string $value
    * @return boolean
    */
    function setName($value) {
      return $this->setColumnValue('name', $value);
    } 
    
    /**
    * Return value of 'type' field
    *
    * @access public
    * @param void
    * @return string 
    */
    function getType() {
      return $this->getColumnValue('type');
    } 
    
    /**
    * Set value of 'type' field
    *
    * @access public   
    * @param string $value
    * @return boolean
    */
    function setType($value) {
      return $this->setColumnValue('type', $value);
    } 
    

    
    /**
    * Return value of 'possible_values' field
    *
    * @access public
    * @param void
    * @return string 
    */
    function getPossibleValues() {
      return $this->getColumnValue('possible_values');
    }
    
    /**
    * Set value of 'possible_values' field
    *
    * @access public   
    * @param string $value
    * @return boolean
    */
    function setPossibleValues($value) {
      return $this->setColumnValue('possible_values', $value);
    }
    
    
    /**
     * Return value of 'possible_member_types' field
     *
     * @access public
     * @param void
     * @return string
     */
    function getPossibleMemberTypes() {
    	return $this->getColumnValue('possible_member_types');
    }
    
    /**
     * Set value of 'possible_member_types' field
     *
     * @access public
     * @param string $value
     * @return boolean
     */
    function setPossibleMemberTypes($value) {
    	return $this->setColumnValue('possible_member_types', $value);
    }

    
    /**
    * Return manager instance
    *
    * @access protected
    * @param void
    * @return AdditionalMemberPermissions 
    */
    function manager() {
      if(!($this->manager instanceof AdditionalMemberPermissions)) $this->manager = AdditionalMemberPermissions::instance();
      return $this->manager;
    } // manager
  
  } // BaseAdditionalMemberPermission 

?>