<?php
Hook::register("additional_timeslot_permissions");



function additional_timeslot_permissions_before_add_to_members($params, &$has_permissions) {
	
	$timeslot = array_var($params, 'object');
	$members = array_var($params, 'members');
	
	if ($timeslot instanceof Timeslot) {
		
		$task = $timeslot->getRelObject();
		// we must use task's members because if it is locked, we don't want the user to add time on it
		if ($task instanceof ProjectTask) {
			$members = $task->getMembers();
		}
		
		Env::useHelper('functions', 'additional_timeslot_permissions');
		$has_permissions = check_if_user_can_add_timeslot_in_status_member(logged_user(), $timeslot, $members);
		if (!$has_permissions) {
			throw new Exception(lang("no access permissions"));
		}
	}
}

