<?php 
	$genid = gen_id();
	$object = $payment_receipt;
	$show_billing_info = true;
	Hook::fire('get_can_see_billing_information', array('user'=>logged_user()), $show_billing_info);
	$show_cost_info = true;
	Hook::fire('get_can_see_cost_information', array('user'=>logged_user()), $show_cost_info);
	$currencies = Currencies::getAllCurrencies();
	$show_currencies = !(count($currencies) <= 1);
	
	$budgeted_expenses_disabled = config_option('disable_expenses_subtab');
	/* @var $payment_receipt PaymentReceipt */
	
	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.submit_modal_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	
	//$product_types = ProductTypes::getAllProductTypesData();
	
	$currencies_info = Currencies::getCurrenciesInfo();
	//$status_info = ExpensesStatuses::instance()->getAllStatusInfo();
	
	$categories = array();
	Hook::fire('object_edit_categories', $object, $categories);

	$main_cp_count = CustomProperties::countVisibleCustomPropertiesByObjectType($object->getObjectTypeId());
	$other_cp_count = CustomProperties::countHiddenCustomPropertiesByObjectType($object->getObjectTypeId());
	
	$action_for_empty_amount_payments = config_option("action_for_empty_amounts");
	
	if (!$expense instanceof Expense) {
		$expense = new Expense();
	}
	
	$display_image_preview = true;
	$preview_url = "";
	if ($payment_receipt->getDocumentId() != "" && FileRepository::isInRepository($payment_receipt->getDocumentId())) {
		$preview_url = get_url('files', 'get_public_file', array('id' => $payment_receipt->getDocumentId()));
		$file_attributes = FileRepository::getFileAttributes($payment_receipt->getDocumentId());
		if ($file_attributes['type'] == 'application/pdf') {
			$display_image_preview = false;
		}
	}
	
	$is_new_pr = $payment_receipt->isNew() ? '1' : '0';
	
	// @TODO: use a config option for this
	$disable_member_selectors = false;
	
	
	// TAXES
	$taxes = ActualExpenseTaxes::getAvailableTaxes();
	
?>
<style>
.add-payment{
	min-width: 1140px!important;
}
.add-payment .coInputMainBlock .dimension-selector-container label {
	margin-right: 10px;
	min-width: 0px;
}
.add-payment .left-section {
	width: 480px;
	float: left;
	padding-right: 20px;

}

.add-payment .coInputMainBlock label {
	min-width: 140px;
}

.add-payment .right-section {
	float: left;
}
</style>

<form class="add-payment" id="<?php echo $genid ?>submit-edit-form" onsubmit="<?php echo $on_submit?>" action="<?php echo $payment_receipt->isNew() ? get_url('payment_receipt', 'add') : $payment_receipt->getEditUrl() ?>" method="post" enctype="multipart/form-data" >
<div class="payment">
<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $object->getAddEditFormTitle(); ?>
	</div>
  </div>

  <div>
      
	<div class="coInputName">
		<?php echo text_field('payment_receipt[name]', $payment_receipt->getName(), array('id' => $genid . 'payment_receipt_name', 'class' => 'title', 'placeholder' => lang('type name here'))) ?>
	</div>	
	<div class="coInputButtons" style="float: right;">
		<?php echo submit_button($object->getSubmitButtonFormTitle(),'s', array('style'=>'margin-top:0px;margin-left:10px;', 'id' => $genid.'submit_button')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>

<div class="coInputMainBlock">
	
	<input id="<?php echo $genid?>genid" type="hidden" name="genid" value="<?php echo $genid ?>">
	<input id="<?php echo $genid?>updated-on-hidden" type="hidden" name="updatedon" value="<?php echo !$payment_receipt->isNew() ? $payment_receipt->getUpdatedOn()->getTimestamp() : '' ?>">
	
	<input id="<?php echo $genid?>expense-id" type="hidden" name="payment_receipt[expense_id]" value="<?php echo $expense->getId() ?>">
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_payment_details"><?php echo lang('details') ?></a></li>
			
			<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
			<li><a href="#<?php echo $genid?>add_custom_properties_div"><?php echo lang('custom properties') ?></a></li>
			<?php } ?>
			
			<li><a href="#<?php echo $genid?>add_subscribers_div"><?php echo lang('object subscribers') ?></a></li>
			
			<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
			<li><a href="#<?php echo $genid?>add_linked_objects_div"><?php echo lang('linked objects') ?></a></li>
			<?php } ?>
			
			<?php foreach ($categories as $category) {
					if (array_var($category, 'hidden')) continue;
				?>
			<li><a href="#<?php echo $genid . $category['name'] ?>"><?php echo $category['name'] ?></a></li>
			<?php } ?>
		</ul>
	
		<div id="<?php echo $genid ?>add_payment_details" class="form-tab">
		
		
			<?php 
				$using_expenses = true; 
				Hook::fire('payments_use_expenses', array('object' => $object, 'genid' => $genid), $using_expenses);

				if ($using_expenses) {
			?>
			<!-- SECTION 'Select a budgeted expense' -->
			<div id="select-budgeted-expense" style="width: 100%; min-height: 250px; display: flex; flex-direction: column; align-items: center; justify-content: center; " class="dataBlock">
					<button class="submit" onclick="og.selectInitialBudgetedExpense(event)" style="width: 500px; margin-bottom: 15px;"><?php echo lang('select a budgeted expense'); ?></button>
					<p style="margin-bottom: 15px;"><?php echo lang('select the budgeted expense to which this actual expense relates to'); ?></p>
					<p style="margin-bottom: 15px; text-transform: uppercase; font-weight: 600;"><?php echo lang('or'); ?></p>
					<p><a href="#" onclick="og.showPaymentReceiptDetails()" style="text-decoration: underline; margin-bottom: 15px;"><?php echo lang('manually enter all the information for this expense'); ?></a></p>
			</div>


			<!-- SECTION 'Payment receipt details' -->
			<div id="payment-receipt-details">
			<div class="dataBlock" style="<?php echo ($budgeted_expenses_disabled ? 'display:none;' : '')?>"><?php
				echo label_tag(lang('expense'));
				?><span id="<?php echo $genid?>paymentExpenseName"><?php
					echo $expense->getName();
				?></span>
				&nbsp;&nbsp;
				
				<input type="hidden" name="payment_receipt[expense_id]" value="<?php echo $payment_receipt->getExpenseId()?>" id="<?php echo $genid?>paymentExpenseId"/>
				<a class="link-ico ico-edit underline" id="<?php echo $genid ?>exp_change_link" href="#" onclick="og.changeExpense(this);" style="font-size:13px;"><?php 
					echo $payment_receipt->getExpenseId() > 0 ? lang('change expense') : lang('select expense');
				?></a>
				&nbsp;
				<a class="link-ico ico-delete underline" id="<?php echo $genid ?>exp_remove_link" href="#" onclick="og.removePaymentExpense('<?php echo $genid?>', true);" 
					style="font-size:13px;<?php echo $payment_receipt->getExpenseId() > 0 ? "" : "display:none;" ?>"><?php 
					echo lang('remove');
				?></a>
				    			
			</div>
			<div class="clear"></div>
			<?php } ?>
		


			<!-- RIGHT BOTTOM SECTION OF THE FORM -->
			<div class="right-section">

			<?php $null = null; Hook::fire('before_render_member_selectors', array('object' => $object, 'genid' => $genid), $null);?>
		
			<div id="<?php echo $genid ?>add_payment_select_context_div" class="dataBlock"> 
				<?php
				//$expense_id = $payment_receipt->getExpenseId();
				$update_receipt_name_fn = "og.expenses2.update_payment_receipt_name('".$genid."', $is_new_pr);";
				
				$listeners = array(
					'on_remove_relation' => $update_receipt_name_fn,
					'on_selection_change' => 'og.reload_subscribers("'.$genid.'",'.$object->manager()->getObjectTypeId().');'
						. 'og.checkCanHaveExpense("'.$genid.'"); ' . $update_receipt_name_fn
				);
				Hook::fire('modify_member_selector_listeners', array('genid' => $genid, 'object' => $object), $listeners);
				
				$skipped_dimensions = array();
				Hook::fire('add_member_selector_skipped_dimensions', array('genid' => $genid, 'object' => $object), $skipped_dimensions);
				
				if ($payment_receipt->isNew()) {
					render_member_selectors($payment_receipt->manager()->getObjectTypeId(), $genid, null, array('select_current_context' => true, 'listeners' => $listeners, 'object' => $object), $skipped_dimensions, null, false);
				} else {
					render_member_selectors($payment_receipt->manager()->getObjectTypeId(), $genid, $payment_receipt->getMemberIds(), array('listeners' => $listeners, 'object' => $object), $skipped_dimensions, null, false);
				} 
				?>
			</div>
			<div class="clear"></div>
			
			<?php $null = null; Hook::fire('after_render_member_selectors', array('object' => $object, 'genid' => $genid), $null);?>
			

			
			
			<?php $null = null; Hook::fire('before_render_main_custom_properties', array('object' => $object, 'genid' => $genid), $null);?>
			
			</div> 
			<div class="clear"></div>
			<!-- END OF RIGHT BOTTOM SECTION -->


			
			<?php

			?>

			<div class="expense" style="margin-bottom: 40px; margin-top: 30px;">
			<table class="expense-items">
				<?php 
					if(!$show_currencies){
						echo input_field('payment_receipt[currency_id]', count($currencies) == 1 ? $currencies[0]->getId() : 0, array('type' => 'hidden'));
					}
				?>

				<tbody>
				<tr>
					<!--<th style="width:"><?php echo lang('product type'); ?></th>-->
					<th><?php echo lang('quantity'); ?></th>
					
					<th style="width: 80px;"><?php echo lang('date'); ?></th>
					<?php if($show_currencies){ ?>
						<th></th>
					<?php } ?>
					<th class="right"><?php echo $show_cost_info ? lang('subtotal cost') : ''; ?></th>
					<?php
					if ($taxes && count($taxes) > 0) {
						foreach ($taxes as $tax) {
							?><th class="right"><?php echo $tax->getName(); ?></th><?php
						}
					}
					?>
					<th class="right"><?php echo $show_cost_info ? lang('total cost') : ''; ?></th>
					<!--<th class="right"><?php echo $show_billing_info ? lang('unit price') : ''; ?></th>
					<th class="right"><?php echo $show_billing_info ? lang('total price') : ''; ?></th> -->
				</tr>
				<tr>
					<!-- PRODUCT TYPE -->
					<!--<td><?php 
					// Comment out selecting product types from Budgeted expense
					
					/*if($expense->getId() > 0){
						$expense_items = ExpenseItems::findAll(array('conditions' => 'expense_id ='.$expense->getId()));
						$filtered_product_types = array();
						foreach($expense_items as $item){
							if($item->getProductTypeId() > 0){
								/* Keep it for later to use expense item info in product type lists
								$product_type = ProductTypes::findById($item->getProductTypeId())->getArrayInfo();
								$product_type['hourly_cost'] = $item->getUnitCost();
								$product_type['hourly_rate'] = $item->getUnitPrice();
								$product_type['uses_price_multiplier'] = 0;*/
								/*$pt = ProductTypes::findById($item->getProductTypeId());
								if ($pt instanceof ProductType) {
									$filtered_product_types[] = $pt->getArrayInfo();
								}
							}
						}
					} else {*/
						/*$members_to_filter = $payment_receipt->isNew() ? active_context() : $payment_receipt->getMembers();
						$filtered_product_types = ProductTypes::getFilteredProductTypesData($members_to_filter);
					//}

					// Get budgeted expense product type ids
					$use_budget_expense_product_type = false;
					if($expense->getId() > 0){
						$expense_items = ExpenseItems::findAll(array('conditions' => 'expense_id='.$expense->getId()));
						if(count($expense_items) == 1){
							$use_budget_expense_product_type = true;
							$expense_item = $expense_items[0];
						}
					}

					//Get product type id of the budgeted expense
					if($payment_receipt->getProductTypeId() || !$is_new_pr){
						$selected_product_type_id = $payment_receipt->getProductTypeId();
					} else {
						if ($use_budget_expense_product_type) {
							$selected_product_type_id = $expense_item->getProductTypeId();
						} else {
							$selected_product_type_id = 0;
						}
					} 
					
					
					echo product_types_select_box('payment_receipt[product_type_id]', $selected_product_type_id, $filtered_product_types, array('id' => $genid.'_0_product_type_id', 'onchange' => 'og.expenses2.onItemProductTypeChange("'.$genid.'", 0)', 'style' => 'max-width: 200px')); */?></td>-->

					<!-- QUANTITY -->
					<td><?php echo text_field('payment_receipt[quantity]', 1, array(
						'class' => 'short',
						'id' => $genid.'_0_quantity',
						'disabled' => ''
						//'onchange' => 'og.expenses2.updateItemTotals("'.$genid.'", 0)',
					)); ?></td>

					
					<!-- DATE -->
					<td><?php 
					$date_listeners = array(
						"change" => "function(){ og.expenses2.update_payment_receipt_name('".$genid."', $is_new_pr); }",
					);
					$now = DateTimeValueLib::now();
					$now->advance(logged_user()->getUserTimezoneValue());
					$payment_receipt_date = $payment_receipt->isNew() ? $now : $payment_receipt->getDate();
					echo pick_date_widget2('payment_receipt[date]', $payment_receipt_date, $genid, null, true, $genid."payment_receipt_date", $date_listeners);
					?></td>

					<!-- Currency -->
					<?php if($show_currencies){ ?>
					<td><?php 
					$currency = $payment_receipt->isNew() ? null : $payment_receipt->getCurrencyId();
					echo currency_select_box('payment_receipt[currency_id]', $currency);
					?></td>
					<?php } ?>

					<!-- UNIT COST -->
					<td class="right"><?php 

					$subtotal_cost = $payment_receipt->getUnitCost();
					if($payment_receipt->isNew() && $expense->getId() > 0){
						$expense_items = ExpenseItems::findAll(array('conditions' => 'expense_id='.$expense->getId()));
						$subtotal_cost = 0;
						foreach($expense_items as $item){
							$subtotal_cost += $item->getTotalCost();
						}
					}
					
					
					
					echo text_field('payment_receipt[unit_cost]', $subtotal_cost, array(
						'class' => 'amount',
						'id' => $genid.'_0_unit_cost',
						'onchange' => 'og.expenses2.updateItemTotalCost("'.$genid.'", 0)',
						'type' => $show_cost_info ? 'text' : 'hidden',
					));
					?></td>
					
					<?php 
					if ($taxes && count($taxes) > 0) {
						foreach ($taxes as $tax) {
							$tax_val = 0;
							if (!$payment_receipt->isNew()) {
								$tax_val_obj = ActualExpenseTaxValues::getByObjectAndTaxId($payment_receipt->getId(), $tax->getId());
								if ($tax_val_obj) $tax_val = format_money_amount($tax_val_obj->getValue(), '', config_option('product_type_decimals'));
							}
							?><td class="tax-cell right"><?php 
							echo text_field('payment_receipt[taxes]['.$tax->getId().']', $tax_val, array(
									'class' => 'amount',
									'id' => $genid.'_0_tax_'.$tax->getId(),
									'onchange' => 'og.expenses2.updateItemTotalCost("'.$genid.'", 0)',
									'type' => $show_cost_info ? 'text' : 'hidden',
									'disabled' => $tax->getIsPercentage() ? "disabled" : "",
							));
							?></td><?php
						}
					}
					?>

					<!-- TOTAl COST -->
					<td class="right"><?php 
					echo text_field('payment_receipt[amount]', $payment_receipt->getAmount(), array(
						'class' => 'amount',
						'id' => $genid.'_0_total_cost',
						'type' => $show_cost_info ? 'text' : 'hidden',
					));
					?></td>

					<!-- UNIT PRICE -->
					<!--<td class="right"><?php 
					/*if ($is_new_pr && $use_budget_expense_product_type) {
						$unit_price = $expense_item->getUnitPrice();
					} else {
						$unit_price = $payment_receipt->getUnitPrice();
					}

					echo text_field('payment_receipt[unit_price]', $unit_price, array(
						'class' => 'amount',
						'id' => $genid.'_0_unit_price',
						'onchange' => 'og.expenses2.updateItemTotalPrice("'.$genid.'", 0)',
						'type' => $show_billing_info ? 'text' : 'hidden',
					));*/
					?></td>-->

					<!-- TOTAL PRICE -->
					<!--<td class="right"><?php 
					/*echo text_field('payment_receipt[total_price]', $payment_receipt->getTotalPrice(), array(
						'class' => 'amount',
						'id' => $genid.'_0_total_price',
						'type' => $show_billing_info ? 'text' : 'hidden',
					));*/
					?></td>-->
				</tr>
				
				<tr>
					<?php $total_cols = count($taxes) + 5;?>
					<!-- DESCRIPTION -->
					<td colspan="<?php echo $total_cols?>"><?php 
						echo text_field('payment_receipt[description]', $payment_receipt->getDescription(), 
							array('class' => 'long', 'placeholder' => lang('description'), 'style' => 'width: calc(100% - 8px);')
						);
					?></td>
				</tr>
				</tbody>
			</table>
			</div>

			
			<!-- LEFT BOTTOM SECTION OF THE FORM -->
			<div class="left-section"> 

			<div class="dataBlock"><?php
				echo label_tag(lang('receipt image'), $genid . 'file_input_document_id');
			?>
				<div id="<?php echo $genid ?>cp-image-selector-container" class="cp-image-selector-container">
				  <div id="<?php echo $genid ?>cp-image-preview"
					class="cp-image-preview" style="<?php echo ($preview_url != "" ? "" : "display:none;")?>max-width: 315px;">
				
					<div id="<?php echo $genid ?>cp-document-name"><?php
					try {
						if ($payment_receipt->getDocumentId()) {
							$document_name = FileRepository::getFileAttribute($payment_receipt->getDocumentId(), 'name');
							echo $document_name;
						}
					} catch (FileNotInRepositoryError $e) {

					}
					?></div>
					<img id="<?php echo $genid?>cp-preview" alt="" src="<?php echo $preview_url?>" style="<?php $display_image_preview ? "" : "display:none;"?>max-width: 315px;"/>
					<!--<iframe id="<?php echo $genid?>cp-preview-iframe" alt="" src="<?php echo $preview_url?>" style="border:0px none;<?php !$display_image_preview ? "" : "display:none;"?>"></iframe> -->
				
					<div class="remove-link" style="float:none; text-align:right; margin-top:0; margin-bottom:10px;">
						<a href="#" onclick="og.remove_payment_receipt_image('<?php echo $genid?>','<?php echo $genid ?>payment_receipt_document_id')"
							class="remove link-ico ico-delete"><?php echo lang('remove')?></a>
					</div>
				  </div>
				</div>
				
			<?php 
				echo file_field('file_input_document_id', null, array('id' => $genid . 'file_input_document_id', 'style' => ($preview_url == "" ? "" : "display:none;")));
			?>
				<input type="hidden" name="payment_receipt[document_id]" 
					id="<?php echo $genid ?>payment_receipt_document_id" value="<?php echo $payment_receipt->getDocumentId() ?>" />
			</div>
			<div class="clear"></div>
		
			<div class="dataBlock">
			<?php
				// Get the contacts for the select box for 'Paid by' field	
				if (logged_user()->isAdministrator()) {
					$users = Contacts::getAllUsers();
				} else {
					if (SystemPermissions::userHasSystemPermission(logged_user(), 'can_see_expenses_of_others')){
						$users = logged_user()->getCompanyId() > 0 ? Contacts::getAllUsers(" AND `company_id` = ". logged_user()->getCompanyId()) : array(logged_user());
					} else {
						$users = array(logged_user());
					}
				}
				if ($payment_receipt->isNew()) {
					$pr_members = active_context();
				} else {
					$pr_members = $payment_receipt->getMembers();
				}
				$tmp_users = array();
				foreach ($users as $user) {
					if ($user->getId()==logged_user()->getId() || can_add($user, $pr_members, PaymentReceipts::instance()->getObjectTypeId())) {
						$tmp_users[] = $user;
					}
				}
				$users = $tmp_users;

				// Generate options for the select box, create custom name for the logged_user
				$paid_by_id = $payment_receipt->isNew() ? logged_user()->getId() : $payment_receipt->getPaidById();
				$user_options = array();
				foreach ($users as $user) {
					$user_option_tag = option_tag( logged_user()->getObjectId() == $user->getObjectId() ?
					lang('me') . " (" . $user->getObjectName() . ")": $user->getObjectName(), $user->getId(), $paid_by_id == $user->getId() ? array("selected" => "selected") : null);
					if(logged_user()->getObjectId() == $user->getObjectId()){
						array_unshift($user_options, $user_option_tag);
					} else {
						$user_options[] = $user_option_tag;
					}
				}
				// Add 'don't assign' to the list of options
				if (SystemPermissions::userHasSystemPermission(logged_user(), 'can_see_expenses_of_others')){
					$dont_assign_option = option_tag(lang('dont assign'), 0, $payment_receipt->getPaidById() == 0 ? array("selected" => "selected") : null);
					array_unshift($user_options, $dont_assign_option);
				}

				// Print 'paid by' field name and display select box
				echo label_tag(lang("paid by"));
				echo select_box("payment_receipt[paid_by_id]", $user_options);
			?>
			</div>

			<div class="clear"></div>
			<!--<div class="dataBlock"><?php 
				echo label_tag(lang('billable'), $genid . 'prFormIsBillable', false);
			//	echo checkbox_field('payment_receipt[is_billable]', $payment_receipt->getIsBillable(), array('id' => $genid . 'prFormIsBillable'));
				echo yes_no_widget('payment_receipt[is_billable]', $genid."is_billable", $payment_receipt->getIsBillable(), lang('yes'), lang('no'), null, array('id' => $genid . 'prFormIsBillable'));
			?></div>-->
			
			
			<?php foreach ($taxes as $tax) { /* @var $tax ActualExpenseTax */?>
			<div class="clear"></div>
			<div class="dataBlock"><?php 
			
				if ($payment_receipt->isNew()) {
					$apply_tax = $tax->getSelectByDefault();
				} else {
					$tax_val_obj = ActualExpenseTaxValues::getByObjectAndTaxId($payment_receipt->getId(), $tax->getId());
					$apply_tax = $tax_val_obj ? true : false;
				}
				$tax_name = $tax->getName();
				if ($tax->getIsPercentage()) $tax_name .= " (".$tax->getValue()."%)";
				echo label_tag($tax_name, $genid . '_tax_checkbox_'.$tax->getId(), false);
				echo checkbox_field('payment_receipt[apply_tax_'.$tax->getId().']', $apply_tax, array('id' => $genid . '_tax_checkbox_'.$tax->getId(), 
						'onchange' => "og.expenses2.on_tax_change(".$tax->getId().", '$genid')"));
			?></div>
			<?php } ?>

			
			</div> <!-- END OF LEFT BOTTOM SECTION -->



			<div class="main-custom-properties-div"><?php
				if ($main_cp_count) {
					echo render_object_custom_properties($object, false, null, 'visible_by_default');
				}
			?></div>
			
			<div class="clear"></div>

			<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
			<div id="<?php echo $genid ?>add_custom_properties_div" class="form-tab other-custom-properties-div">
				<?php  echo render_object_custom_properties($object, false, null, 'other') ?>
				<?php  echo render_add_custom_properties($object); ?>
			</div>
			<?php } ?>
			</div>
			
		</div>
		
	
		<div id="<?php echo $genid ?>add_subscribers_div" class="form-tab">
			<div id="<?php echo $genid ?>add_subscribers_content"><?php
				$subscribers = $payment_receipt->isNew() ? $expense->getSubscribers() : $payment_receipt->getSubscribers();
				$subscriber_members = $payment_receipt->isNew() ? $expense->getMembers() : $payment_receipt->getMembers();
				
				echo render_add_subscribers($object, $genid, $subscribers, $subscriber_members);
				
				if (isset($subscriber_ids) && is_array($subscriber_ids)) {
					foreach ($subscriber_ids as $subid) {
						echo '<input type="hidden" name="subscribers[user_'.$subid.']" value="1"/>';
					}
				}
			?></div>
		</div>
	
		<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
		<div id="<?php echo $genid ?>add_linked_objects_div" class="form-tab">
			<?php echo render_object_link_form($object) ?>
		</div>
		<?php } // if ?>
		
		
		
		
		<?php foreach ($categories as $category) { ?>
		<div id="<?php echo $genid . $category['name'] ?>" class="form-tab">
			<?php echo $category['content'] ?>
		</div>
		<?php } ?>

	</div>
	<?php if (!array_var($_REQUEST, 'modal')) {
		echo submit_button($payment_receipt->isNew() ? lang('add payment receipt') : lang('save changes'),'s', array('tabindex' => '20000')); 
	}?>
	<div class="clear"></div>
</div>
<div class="clear"></div>
</div>
</form>

<script>
var genid = '<?php echo $genid?>';
og.expenses2.action_for_empty_amount_payments = '<?php echo $action_for_empty_amount_payments?>';

//og.expenses2.product_types = Ext.util.JSON.decode('<?php echo(json_encode($product_types))?>');
//og.expenses2.filtered_product_types = Ext.util.JSON.decode('<?php echo(json_encode($filtered_product_types))?>');

og.expenses2.amount_decimals = <?php echo config_option('product_type_decimals'); ?>;

<?php if (!$payment_receipt->isNew()) { ?>
og.expenses2.user_has_changed_object_name = true;
<?php } else { ?>
og.expenses2.user_has_changed_object_name = false;
og.expenses2.update_payment_receipt_name(genid, '1');
<?php } ?>

og.expenses2.taxes = {};
<?php foreach ($taxes as $tax) { ?>
og.expenses2.taxes[<?php echo $tax->getId() ?>] = Ext.util.JSON.decode('<?php echo json_encode($tax->getArrayInfo()); ?>');
<?php } ?>

og.expenses2.on_tax_change = function(tax_id, genid, dont_call_update_totals) {
	var tax = og.expenses2.taxes[tax_id];
	if (!tax) return;

	var apply_tax = $('#'+ genid +'_tax_checkbox_'+ tax_id).attr("checked") == "checked";
	
	var tax_value = 0;
	if (apply_tax) {
		var unit_cost = $("#"+genid+"_0_unit_cost").val();
		var qty = $("#"+genid+"_0_quantity").val();

		unit_cost = og.clean_thousand_separator(unit_cost);
		qty = og.clean_thousand_separator(qty);
		
		if (tax.is_percentage) {
			tax_value = qty * unit_cost * (tax.value / 100);
		} else {
			tax_value = tax.value;
		}
	}
	tax_value = og.format_money_amount(tax_value);

	$('#'+ genid +'_0_tax_'+ tax_id).val(tax_value);

	if (!dont_call_update_totals) {
		og.expenses2.updateItemTotalCost(genid, 0);
	}
}

$(function(){
	$("#<?php echo $genid?>tabs").tabs();
	// if the expense is new hide payment receipt details, otherwise show it
	<?php if(($payment_receipt->isNew() && !$budgeted_expenses_disabled) && !$expense->getId() > 0) {?>
		$("#payment-receipt-details").hide();
	<?php } else { ?>
		$("#select-budgeted-expense").hide();
	<?php } ?>

	var listenerId = og.eventManager.addListener('after member_selector init', function(){
		og.expenses2.update_payment_receipt_name(genid, <?php echo $is_new_pr ?>);
		og.eventManager.removeListener(listenerId) ;
	});

	$("#" + genid + "payment_receipt_name").keypress(function() {
		og.expenses2.user_has_changed_object_name = true;
	});

	var amount_input_ids = ["_0_unit_cost", "_0_total_cost"];

	for (var i=0; i<amount_input_ids.length; i++) {
		var amount_input_id = amount_input_ids[i];
		$("#" + genid + amount_input_id).change(function() {
			$(this).val(og.format_money_amount($(this).val(), og.expenses2.amount_decimals));
		});
		$("#" + genid + amount_input_id).val(og.format_money_amount($("#" + genid + amount_input_id).val(), og.expenses2.amount_decimals));
	}
	
	//og.product_types.reload_product_type_selectors_for_payment_receipt("<?php echo $genid ?>");
	
	<?php if ($disable_member_selectors) { ?>
	
	$("#"+genid+"-member-selectors-panel-<?php echo PaymentReceipts::instance()->getObjectTypeId()?>-container .member-chooser-container").each(function() {

		var dim_id = $(this).attr('id').replace(genid, "").replace("-member-chooser-panel-", "").replace("-container", "");

		var tree = Ext.getCmp(genid + "-member-chooser-panel-" + dim_id);
		if (tree) tree.disable();
		
	});
	<?php } ?>

	
	// prepare instant preview
	$("#"+genid+"file_input_document_id").change(function(){
		
		$("#"+genid+"cp-image-preview").hide();

		// For browsers with HTML5 compatibility
		if (window.FileReader) {
			var fr = new FileReader();
			fr.readAsDataURL(document.getElementById($(this).attr('id')).files[0]);
			fr.finput_id = $(this).attr('id');

			fr.onload = function (fevent) {
				
				var hf_id = genid + 'payment_receipt_document_id';
				var file_input_name = "file_input_document_id";
				
				var file_full_name = $("#"+genid+"file_input_document_id").val();
				if (file_full_name) {
					var start_index = (file_full_name.indexOf('\\') >= 0 ? file_full_name.lastIndexOf('\\') : file_full_name.lastIndexOf('/'));
					var filename = file_full_name.substring(start_index);
					if (filename.indexOf('\\') === 0 || filename.indexOf('/') === 0) {
						filename = filename.substring(1);
					}
					$("#"+genid+"cp-document-name").html(filename);
				}
				
				if (fevent.target.result.indexOf('data:application/pdf;') == 0) {
					$("#"+genid+"cp-preview-iframe").attr('src', fevent.target.result).show();
					$("#"+genid+"cp-preview").hide();
				} else {
					$("#"+genid+"cp-preview").attr('src', fevent.target.result).show();
					$("#"+genid+"cp-preview-iframe").hide();
				}
				$("#"+genid+"cp-image-preview").fadeIn();
				$("#"+genid+"file_input_document_id").hide();

				$("#"+genid+"submit_button").attr("disabled", "disabled").addClass("disabled");

				og.upload_payment_receipt_image(genid, this.finput_id, file_input_name, hf_id); 
			};
		}
	});

});

og.selectInitialBudgetedExpense = function (event) {
	event.preventDefault();
	og.changeExpense(event);
}

og.showPaymentReceiptDetails = function () {
	$("#select-budgeted-expense").hide();
	$("#payment-receipt-details").show();
}

og.remove_payment_receipt_image = function (genid, hf_id) {
	$("#"+hf_id).val("");
	$("#"+genid+"cp-image-preview").hide();
	$("#"+genid+"file_input_document_id").show();
}

og.upload_payment_receipt_image = function(genid, file_input_id, file_input_name, hf_id) {
	var fileInput = document.getElementById(file_input_id);

	var fileParent = fileInput.parentNode;
	fileParent.removeChild(fileInput);
	
	var form = document.createElement('form');
	form.method = 'post';
	form.enctype = 'multipart/form-data';
	form.encoding = 'multipart/form-data';
	form.action = og.getUrl('object', 'tmp_file_upload', {'id': genid + "payment_receipt_document_id", 'input_name': file_input_name});
	form.style.display = 'none';
	form.appendChild(fileInput);
	document.body.appendChild(form);
	
	og.submit(form, {
		callback: function(d) {
			$("#"+genid+"submit_button").removeAttr("disabled").removeClass("disabled");;
			
			form.removeChild(fileInput);
			fileParent.appendChild(fileInput);
			document.body.removeChild(form);
			
			// set the hidden input
			if (d && d.id) {
				$("#"+hf_id).val(d.id);
			}
		}
	});
}

og.after_selecting_payment_expense = false;

/**
 * This function checks where the expense is classified
 * If the expense is classified on a context that is not compatible with the classification already entered for the payment receipt:
 * The selected expense is removed.
 *  
 * This function is currently deactivated, as it needs further refinement to check the context.
 * Also, ideally, this function should be 
 */
og.checkCanHaveExpense = function(genid) {
	if (og.after_selecting_payment_expense) return;

	//This variable was loaded when the Expense was selected
	var expense_id = $("#"+genid+"paymentExpenseId").val();

	//If there is an expense selected, we'll check that it is 'compatible' (It is in the same context or sub-context)
	if (expense_id) {

		//Here are all the members where the Payment Receipt is classified
		var members = $("#"+genid+"members").val();

		//This removes the payment if it is not 'compatible'
// 		og.openLink(og.getUrl('expense', 'check_expense_members', {id: expense_id, member_ids: members}), {
// 			callback: function(success, data) {
// 				if (!data.ok) {
// 					og.removePaymentExpense(genid, false);
// 				}
// 			}
// 		});
	}
}

og.removePaymentExpense = function(genid, remove_classification) {

	$("#"+genid+"paymentExpenseId").val("");
	$("#"+genid+"paymentExpenseName").html("");
	$("#"+genid+"exp_change_link").html(lang('select expense'));
	$("#"+genid+"exp_remove_link").hide();

	if (remove_classification) {
		$("#"+genid+"members").val("[]");
		member_selector.reset_all_selections(genid);
	}
	
}

//This classifies
og.resetPaymentMembersByExpense = function(genid, expense_id) {
	og.openLink(og.getUrl('expense', 'get_expense_data', {id: expense_id}), {
		callback: function(success, data) {
			if (data && data.expense && data.expense.memPath) {

				// remove previous classification
				//member_selector.remove_all_selections(genid);
				//$("#"+genid+"members").val("[]");

				var all_member_ids = Ext.util.JSON.decode($("#"+genid+"members").val());
				
				for (dim_id in data.expense.memPath) {
					// remove relations for dimension dim_id
					member_selector.remove_all_dimension_selections(genid, dim_id);
					
					var member_ids_by_ot = data.expense.memPath[dim_id];
					if (typeof(member_ids_by_ot) == 'function') continue;

					for (ot in member_ids_by_ot) {
						if (isNaN(ot)) continue;
						var member_ids = member_ids_by_ot[ot];
						if (typeof(member_ids) == 'function') continue;

						if (member_selector[genid].properties[dim_id]) {
							for (var j=0; j<member_ids.length; j++) {
								var mem_id = member_ids[j];
								var d = dim_id;
								// add member to payment classification
								if ((!member_selector[genid].sel_context[dim_id] || member_selector[genid].sel_context[dim_id].length == 0) 
										&& member_selector[genid].properties[dim_id]) {

									member_selector.add_relation(d, genid, mem_id);
									
									//all_member_ids.push(parseInt(mem_id));
									//$("#"+genid+"members").val(Ext.util.JSON.encode(all_member_ids));

									$("#"+genid+"-member-chooser-panel-"+d+"-tree-current-selected .empty-text").hide();
								}
								
								if (!member_selector[genid].properties[d].isMultiple) break;
							}
						}
					}
				}
			}
			if (data && data.expense) {
				if (data.expense.is_billable) {
					$("#"+genid+"prFormIsBillable").attr('checked', 'checked');
				} else {
					$("#"+genid+"prFormIsBillable").removeAttr('checked');
				}
			}
			og.after_selecting_payment_expense = false;
		}
	});
}


/**
  * This function returns the list of expenses that can be selected for this Payment Receipt
  * After you select the expense, it loads the members for which the expense is classified, 
  * and it classifies the Payment Receipt in that same context
*/

og.membersToFilterBEinActualExpenses = function(genid) {
	var mem_str = $("#"+genid+"members").val();
	var member_ids = Ext.util.JSON.decode(mem_str);
	project_member_id = '';

	for (var i=0; i<member_ids.length; i++) {
		var mem_id = member_ids[i];
		var node = og.contextManager.getTreeNode(og.projects.dimension_id, mem_id);
		if (node){
			project_member_id = mem_id;
		}
	}
	
	if (project_member_id != '') {
		return '['+project_member_id+']';
	} else {
		return '';
	}
}

og.changeExpense = function(before) {
	og.ObjectPicker.show(function (objs) {
		if (objs && objs.length > 0) {
			var obj = objs[0].data;
			if (obj.type != 'expense') {
				og.msg(lang("error"), lang("object type not supported"), 4, "err");
			} else {
				og.showPaymentReceiptDetails();
				$("#"+genid+"paymentExpenseId").val(obj.object_id);
				$("#"+genid+"paymentExpenseName").html(obj.name);
				$("#"+genid+"exp_change_link").html(lang("change expense"));

				$("#"+genid+"exp_remove_link").show();

				og.after_selecting_payment_expense = true;

				//This is where the Payment Receipt is classified to the same context as the Expense
				og.resetPaymentMembersByExpense(genid, obj.object_id);
				og.setSubtotalCost(genid, obj.object_id);
				//og.setActualExpenseProductType(genid, obj.object_id);
			}
		}
	}, before, {
		hideFilters: true,
		hideUploadButton: true,
		ignore_context: true,
		extra_member_ids: og.membersToFilterBEinActualExpenses('<?php echo $genid?>'),
		types: ['expense'],
		selected_type: 'expense'
	});
	
};

og.setSubtotalCost = function(genid, expense_id){
	og.openLink(og.getUrl('addu_account_payables','get_expense_total',{id:expense_id}), {
		callback: function (success, data) {
			if(data.subtotal_cost > 0){
				$("#" + genid + '_0_unit_cost').val(data.subtotal_cost);
			}
			og.expenses2.updateItemTotals(genid, 0);
		}
	});
};

// Function to get unique values from array
og.onlyUnique = function(value, index, self) {
  return self.indexOf(value) === index;
};

og.setActualExpenseProductType = function(genid, expense_id) {
	og.openLink(og.getUrl('expense','get_expense_items',{id:expense_id}), {
		callback: function (success, data) {
			// Set actual expense product type if there is only one product type
			if(data.expense_items.length == 1){
				$("#" + genid + '_0_product_type_id').val(data.expense_items[0].product_type_id);
				$("#" + genid + '_0_unit_cost').val(data.expense_items[0].unit_cost);
				//$("#" + genid + '_0_unit_price').val(data.expense_items[0].unit_price);
				og.expenses2.updateItemTotals(genid, 0);
			}
			
		}
	});
};


<?php
	if (isset($expense_id) && $expense_id > 0 && $payment_receipt->getExpenseId() == 0) {
		$exp = Expenses::findById($expense_id);
		if ($exp instanceof Expense) {
?>
	$("#"+genid+"paymentExpenseId").val(<?php echo $exp->getId() ?>);
	$("#"+genid+"paymentExpenseName").html('<?php echo $exp->getObjectName() ?>');
	<?php if ($payment_receipt->isNew() && $exp->getIsBillable()) { ?>
	$("#"+genid+"prFormIsBillable").attr('checked', 'checked');
	<?php } ?>
	$("#"+genid+"exp_change_link").html(lang("change expense"));
	$("#"+genid+"exp_remove_link").show();
	
	og.resetPaymentMembersByExpense(genid, '<?php echo $exp->getId() ?>');
<?php 	}
	}
?>

// calculate taxes
var tax_ids = [];
<?php 
if ($taxes && count($taxes) > 0) {
	foreach ($taxes as $tax) { ?>
		var tax_id = <?php echo $tax->getId(); ?>;
		tax_ids.push(tax_id);
	<?php 
	}
} 
?>
for (var i = 0; i < tax_ids.length; i++) {
	og.expenses2.on_tax_change(tax_ids[i], genid, false);
}


</script>