<?php
	class BillingDefinition extends BaseBillingDefinition {
		
		
		function getUser() {
			return Contacts::findById($this->getUserId());
		}
		
		function getUserName() {
			$user = $this->getUser();
			if ($user instanceof Contact) {
				return $user->getObjectName();
			}
			
			return lang('all');
		}
		
		
		function getUpdatedByDisplayName() {
			$updated_by = Contacts::findById($this->getUpdatedById());
			return $updated_by instanceof Contact ? $updated_by->getObjectName() : lang('n/a');
		}
		
		function getCreatedByDisplayName() {
			$updated_by = Contacts::findById($this->getCreatedById());
			return $updated_by instanceof Contact ? $updated_by->getObjectName() : lang('n/a');
		}
		
		
		
		function getArrayInfo() {
			
			return array(
				"id" => $this->getId(),
				"name" => $this->getObjectName(),
				'user_id' => $this->getUserId(),
				'rate_currency_id' => $this->getRateCurrencyId(),
				'cost_currency_id' => $this->getCostCurrencyId(),
				'hourly_rate' => $this->getHourlyRate(),
				'hourly_cost' => $this->getHourlyCost(),
				"date" => $this->getUpdatedOn() instanceof DateTimeValue ? ($this->getUpdatedOn()->isToday() ? format_time($this->getUpdatedOn()) : format_datetime($this->getUpdatedOn())) : '',
				"is_today" => $this->getUpdatedOn() instanceof DateTimeValue ? $this->getUpdatedOn()->isToday() : 0,
				"updaterId" => $this->getUpdatedById() ? $this->getUpdatedById() : $this->getCreatedById(),
				"updaterName" => $this->getUpdatedById() ? $this->getUpdatedByDisplayName() : $this->getCreatedByDisplayName(),
			);
		}
	}
	 
