<?php

class ObjectBilling extends BaseObjectBilling {

    function canAdd(Contact $user, $context, &$notAllowedMember = '') {
        return can_add($user, $context, Forms::instance()->getObjectTypeId(), $notAllowedMember);
    }

    /**
     * Returns true if $user can access this message
     *
     * @param Contact $user
     * @return boolean
     */
    function canView(Contact $user) {
        return can_read($user, $this->getMembers(), $this->getObjectTypeId());
    }

// canView

    /**
     * Check if specific user can edit this messages
     *
     * @access public
     * @param Contact $user
     * @return boolean
     */
    function canEdit(Contact $user) {
        return can_write($user, $this->getMembers(), $this->getObjectTypeId());
    }

// canEdit

    protected $force_recalculate_billing = false;
    /**
     * Check if specific user can delete this messages
     *
     * @access public
     * @param Contact $user
     * @return boolean
     */
    function canDelete(Contact $user) {
        return can_delete($user, $this->getMembers(), $this->getObjectTypeId());
    }

    function setForceRecalculateBilling($force) {
        $this->force_recalculate_billing = $force;
    }
    function getForceRecalculateBilling() {
        return $this->force_recalculate_billing;
    }


}
