<?php
	$genid = gen_id();
	$object = $billing_definition;
	
	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.submit_modal_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	
	$rate_enabled = $object->isNew() || $object->getEnableRate();
	$cost_enabled = $object->isNew() || $object->getEnableCost();
?>

<form onsubmit="<?php echo $on_submit?>" class="add-billing_definition" id="<?php echo $genid ?>submit-edit-form" action="<?php echo $billing_definition->isNew() ? get_url('billing_definition', 'add') : get_url('billing_definition', 'edit', array('id' => $billing_definition->getId())) ?>" method="post" enctype="multipart/form-data">
<div class="billing_definition">

<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $billing_definition->isNew() ? lang('new billing category') : lang('edit billing category') ?>
	</div>
  </div>

  <div>
	<div class="coInputButtons" style="float:right;">
		<?php echo submit_button($billing_definition->isNew() ? lang('add billing category') : lang('save changes'),'s',array('style'=>'margin-top:0px;margin-left:10px')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>

<div class="coInputMainBlock">
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_billing_definition_details"><?php echo lang('details') ?></a></li>
			<li><a href="#<?php echo $genid?>add_billing_definition_description"><?php echo lang('description') ?></a></li>
			
		</ul>

		
		<div id="<?php echo $genid ?>add_billing_definition_details" class="editor-container form-tab">
			
			<div class="dataBlock"><?php 
				echo label_tag(lang('category name'), $genid . 'billing_definition_title');
				echo text_field('billing_definition[name]', $object->getName(),
					array('id' => $genid . 'billing_definition_title', 'class' => 'title', 'placeholder' => lang('type name here')));
			?></div>
			
			<div class="dataBlock <?php echo ($rate_enabled ? "" : "block-disabled")?>" id="<?php echo $genid?>rate_def"><?php 
				echo currency_selector('billing_definition[rate_currency_id]', $object->getRateCurrencyId(), array('id' => $genid.'rateCurrencyId'));
				echo label_tag(lang('hourly rate'), $genid . 'billing_definition_rate');
				?>
				<input class="money" id="<?php echo $genid?>billing_definition_rate" name="billing_definition[hourly_rate]" value="<?php echo number_format($object->getHourlyRate(), 2)?>"/>
				
				<input type="checkbox" name="billing_definition[enable_rate]" <?php echo ($rate_enabled ? 'checked="checked"' : '') ?> id="<?php echo $genid?>rate_enabled"
					onchange="og.advanced_billing.def_ratecost_toggle('<?php echo $genid?>','rate',this);" /> 
					<?php echo label_tag(lang('enabled'), $genid."rate_enabled", false, array('style' => 'display:inline;float:none;'))?>
			</div>
			
			<div class="dataBlock <?php echo ($cost_enabled ? "" : "block-disabled")?>" id="<?php echo $genid?>cost_def"><?php 
				echo currency_selector('billing_definition[cost_currency_id]', $object->getCostCurrencyId(), array('id' => $genid.'costCurrencyId'));
				echo label_tag(lang('hourly cost'), $genid . 'billing_definition_cost');
				?>
				<input class="money" id="<?php echo $genid?>billing_definition_cost" name="billing_definition[hourly_cost]" value="<?php echo number_format($object->getHourlyCost(), 2)?>"/>
				
				<input type="checkbox" name="billing_definition[enable_cost]" <?php echo ($cost_enabled ? 'checked="checked"' : '') ?> id="<?php echo $genid?>cost_enabled"
					onchange="og.advanced_billing.def_ratecost_toggle('<?php echo $genid?>','cost',this);" /> 
					<?php echo label_tag(lang('enabled'), $genid."cost_enabled", false, array('style' => 'display:inline;float:none;'))?>
			</div>
		
		
			<div class="dataBlock"><table><tr><td><?php
				echo label_tag(lang('user'), $genid . 'billing_definition_user_id', false);
			?></td><td>
				<div id="<?php echo $genid?>user_id_combo_container"></div>
				
				<div class="desc" style="margin-top:5px;"><?php echo lang('adv billing user selector help') ?></div>
			  </td></tr></table>
			</div>
			<div class="clear"></div>
			
		<?php
			$allowed_dimension_ids = config_option('adv_billing_dimensions');
			$allowed_dimension_ids = array_filter($allowed_dimension_ids, 'is_numeric');
			if (is_array($allowed_dimension_ids) && count($allowed_dimension_ids) > 0) {
				$dimensions = Dimensions::findAll(array('conditions' => "id IN (".implode(',', $allowed_dimension_ids).")"));
			} else {
				$dimensions = array();
			}
			
			if (!isset($selected_members)) $selected_members = array();
			
			foreach ($dimensions as $dimension) {
				$gid = $genid."-".$dimension->getId();
				
				render_single_member_selector($dimension, $gid, $selected_members, array(
					'allow_non_manageable' => true,
					'is_multiple' => false,
					'root_lang' => lang('All'),
					'width' => 400,
					'hidden_field_name' => "billing_definition[dim_".$dimension->getId()."][member_id]",
				), false);

				echo '<div class="clear"></div>';
			}

			$null = null;
			Hook::fire('billing_definition_form_more_inputs', array('billing_definition' => $object, 'genid' => $genid), $null);
		?>
		</div>
		
		<div id="<?php echo $genid ?>add_billing_definition_description" class="editor-container form-tab">
			<textarea name="billing_definition[description]" style="width:99%; height:200px;"><?php echo $object->getDescription();?></textarea>
		</div>
		
	</div>

	
	<?php if (!array_var($_REQUEST, 'modal')) {
		echo submit_button($billing_definition->isNew() ? lang('add billing_definition') : lang('save changes'),'s', array('style'=>'margin-top:0px')); 
	}?>
</div>
</div>
</form>
<script>
$(function() {
	var genid = '<?php echo $genid?>';

	$(".billing_definition input.money").change(function(){
		var money = $(this).val();
		if (isNaN(money)) {
			$(this).val("0.00");
		}
	});
	
	$("#"+ genid +"tabs").tabs();

	var user_filters = {
		is_user: 1
	};

	og.renderContactSelector({
		genid: genid,
		id: genid + 'billing_definition_user_id',
		name: 'billing_definition[user_id]',
		render_to: "user_id_combo_container",
		listWidth: 380,
		width: 380,
		filters: user_filters,
        cp_type:'user',
		selected: <?php echo ($object->getUserId() > 0 ? $object->getUserId() : '0')?>,
		selected_name: '<?php echo $object->getUserName() ?>',
		empty_text: '<?php echo lang ('select user').'...' ?>'
	});
});
</script>