<?php
    if (!isset($genid)) $genid = gen_id();
    if (Plugins::instance()->isActivePlugin('multiple_currencies')) {
        Env::useHelper('functions', 'multiple_currencies');
    }
    $can_see_billing_info = true;
    Hook::fire('get_can_see_billing_information', array('user'=>logged_user()), $can_see_billing_info);
    $can_see_cost_info = true;
    Hook::fire('get_can_see_cost_information', array('user'=>logged_user()), $can_see_cost_info);
?>

<table>

<!-- Estimated cost Row -->
<tr style="<?php echo $can_see_cost_info ? '' : 'display: none;' ?>">
    <td class="bold task-financials-tab__td--label" ><?php echo lang('estimated_cost')?>:</td>
    <td class="task-financials-tab__td">
        <?php 
        $is_calculated_estimated_cost = !$task->isNew() || array_var($task_data, 'copyId') ? $task->getColumnValue('is_calculated_estimated_cost') : 1;
        $is_manual_estimated_cost = $is_calculated_estimated_cost ? 0 : 1;
        echo radio_field('task[is_calculated_estimated_cost]', $is_calculated_estimated_cost, array('onchange' => 'og.toggleAndHide("' . $genid. 'estimated_cost_value")', 
            'value' => '1', 'style' => 'width:16px; padding: 0 5px;')) . lang('calculated'); 
            
        echo radio_field('task[is_calculated_estimated_cost]', $is_manual_estimated_cost, array('onchange' => 'og.toggleAndHide("' . $genid. 'estimated_cost_value")', 
            'value' => '0', 'style' => 'width:16px; padding: 0 5px;')) . lang('manually');
        ?>
    </td>
    <td class="task-financials-tab__td--input">
        <div id="<?php echo $genid ?>estimated_cost_value">
            <?php
            //$estimated_cost_value = $task->getColumnValue('estimated_cost');
            //echo currency_selector('task[task_currency_id]', null, array());
            echo text_field('task[estimated_cost_value]', 0, array('id' => $genid.'addEstimatedCostValue', 'class' => 'amount', 'onchange' => 'og.updateElementMoneyAmount("'.$genid.'addEstimatedCostValue",this.value);')) ?>
        </div>
    </td>
</tr>
<tr><td colspan='3' class='task-financials-tab__td--description'><?php echo lang('Estimated cost is calculated based on the Estimated time for this task multiplied by the hourly cost. It has to be assigned in order for the system to calculate it') ?></td></tr>

<!-- Executed Cost Row -->
<tr style="<?php echo $can_see_cost_info ? '' : 'display: none;' ?>">
    <td class="bold task-financials-tab__td--label"><?php echo lang('executed_cost')?>:</td>
    <td class="task-financials-tab__td">
        <?php 
        $is_calculated_exec_cost = !$task->isNew() || array_var($task_data, 'copyId') ? $task->getColumnValue('is_calculated_executed_cost') : 1;
        $is_manual_exec_cost = $is_calculated_exec_cost ? 0 : 1;
        echo radio_field('task[is_calculated_executed_cost]',  $is_calculated_exec_cost, array('onchange' => 'og.toggleAndHide("' . $genid. 'executed_cost_amount")', 
            'value' => '1', 'style' => 'width:16px; padding: 0 5px;')) . lang('calculated'); 
            
        echo radio_field('task[is_calculated_executed_cost]', $is_manual_exec_cost, array('onchange' => 'og.toggleAndHide("' . $genid. 'executed_cost_amount")', 
            'value' => '0', 'style' => 'width:16px; padding: 0 5px;')) . lang('manually');
        ?>
    </td>
    <td class="task-financials-tab__td--input">
        <div id="<?php echo $genid ?>executed_cost_amount">
            <?php
            //$executed_cost_value = $task->getColumnValue('executed_cost');
            //echo currency_selector('task[task_currency_id]', null, array());
            echo text_field('task[executed_cost_value]', 0, array('id' => $genid.'addExecutedCostValue', 'class' => 'amount','onchange' => 'og.updateElementMoneyAmount("'.$genid.'addExecutedCostValue",this.value);')) ?>
        </div>
    </td>
</tr>
<tr><td colspan='3' class='task-financials-tab__td--description'><?php echo lang('Executed cost is calculated based on the Worked time (time entries) for this task multiplied by the hourly cost. It has to be assigned in order for the system to calculate it') ?></td></tr>

<!-- Estimated Price Row -->
<tr style="<?php echo $can_see_billing_info ? '' : 'display: none;' ?>">
    <td class="bold task-financials-tab__td--label"><?php echo lang('estimated_price')?>:</td>
    <td class="task-financials-tab__td">
        <?php 
        $is_calculated_estimated_price = !$task->isNew() || array_var($task_data, 'copyId') ? $task->getColumnValue('is_calculated_estimated_price') : 1;
        $is_manual_estimated_price = $is_calculated_estimated_price ? 0 : 1;
        echo radio_field('task[is_calculated_estimated_price]', $is_calculated_estimated_price, array('onchange' => 'og.toggleAndHide("' . $genid. 'estimated_price_value")', 
            'value' => '1', 'style' => 'width:16px; padding: 0 5px;')) . lang('calculated'); 
            
        echo radio_field('task[is_calculated_estimated_price]', $is_manual_estimated_price, array('onchange' => 'og.toggleAndHide("' . $genid. 'estimated_price_value")', 
            'value' => '0', 'style' => 'width:16px; padding: 0 5px;')) . lang('manually');
        ?>
    </td>
    <td class="task-financials-tab__td--input">
        <div id="<?php echo $genid ?>estimated_price_value">
            <?php
            //$estimated_price_value = $task->getColumnValue('estimated_price');
            //echo currency_selector('task[task_currency_id]', null, array());
            echo text_field('task[estimated_price_value]', 0, array('id' => $genid.'addEstimatedPriceValue', 'class' => 'amount','onchange' => 'og.updateElementMoneyAmount("'.$genid.'addEstimatedPriceValue",this.value);')) ?>
        </div>
    </td>
</tr>
<tr><td colspan='3' class='task-financials-tab__td--description'><?php echo lang('Estimated revenue is calculated based on the Estimated time for this task multiplied by the hourly rate, depending on the labor category assigned to this task') ?></td></tr>

<!-- Earned Value Row -->
<tr style="<?php echo $can_see_billing_info ? '' : 'display: none;' ?>">
    <td class="bold task-financials-tab__td--label"><?php echo lang('earned_value')?>:</td>
    <td class="task-financials-tab__td">
        <?php 
        $is_calculated_earned_value = !$task->isNew() || array_var($task_data, 'copyId') ? $task->getColumnValue('is_calculated_earned_value') : 1;
        $is_manual_earned_value = $is_calculated_earned_value ? 0 : 1;
        echo radio_field('task[is_calculated_earned_value]', $is_calculated_earned_value, array('onchange' => 'og.toggleAndHide("' . $genid. 'earned_value_amount")', 
            'value' => '1', 'style' => 'width:16px; padding: 0 5px;')) . lang('calculated'); 
            
        echo radio_field('task[is_calculated_earned_value]', $is_manual_earned_value, array('onchange' => 'og.toggleAndHide("' . $genid. 'earned_value_amount")', 
            'value' => '0', 'style' => 'width:16px; padding: 0 5px;')) . lang('manually');
        ?>
    </td>
    <td class="task-financials-tab__td--input">
        <div id="<?php echo $genid ?>earned_value_amount">
            <?php
            //$earned_value_amount = $task->getColumnValue('earned_value');
            //echo currency_selector('task[task_currency_id]', null, array());
            echo text_field('task[earned_value_amount]', 0, array('id' => $genid.'addEarnedValueAmount', 'class' => 'amount','onchange' => 'og.updateElementMoneyAmount("'.$genid.'addEarnedValueAmount",this.value);')) ?>
        </div>
    </td>
</tr>
<tr><td colspan='3' class='task-financials-tab__td--description'><?php echo lang('Earned value is calculated based on the Worked time (time entries) for this task multiplied by the hourly rate, depending on the labor category assigned to this task') ?></td></tr>

</table>





<script>
    var genid = '<?php echo $genid ?>';
    var formatted_default_value = og.format_money_amount(0);
    
    // Show or Hide estimated cost input
    var is_calculated_estimated_cost = <?php echo $is_calculated_estimated_cost ? 1 : 0 ?>;
    var div_estimated_cost_value = Ext.getDom(genid + 'estimated_cost_value');
    if(is_calculated_estimated_cost){
        $("#" + genid + 'addEstimatedCostValue').val(formatted_default_value);
        div_estimated_cost_value.style.display = 'none';
    } else {
        // Set formatted estimated cost value
        var estimated_cost_value = <?php echo $task->getColumnValue('estimated_cost') ? $task->getColumnValue('estimated_cost') : 0 ?>;
        var formatted_est_cost_value = og.format_money_amount(estimated_cost_value);
        $("#" + genid + 'addEstimatedCostValue').val(formatted_est_cost_value);
        // Show estimated cost input
		div_estimated_cost_value.style.display = 'block';
    }
    
    // Show or Hide executed cost input
    var is_calculated_exec_cost = <?php echo $is_calculated_exec_cost ? 1 : 0 ?>;
    var div_executed_cost = Ext.getDom(genid + 'executed_cost_amount');
    if(is_calculated_exec_cost){
        $("#" + genid + 'addExecutedCostValue').val(formatted_default_value);
        div_executed_cost.style.display = 'none';
    } else {
        // Set formatted executed cost value
        var executed_cost_value = <?php echo $task->getColumnValue('executed_cost') ? $task->getColumnValue('executed_cost') : 0 ?>;
        var formatted_ex_cost_value = og.format_money_amount(executed_cost_value);
        $("#" + genid + 'addExecutedCostValue').val(formatted_ex_cost_value);
        // Show executed cost input
		div_executed_cost.style.display = 'block';
    }
    
    // Show or Hide estimated price input
    var is_calculated_estimated_price = <?php echo $is_calculated_estimated_price ? 1 : 0; ?>;
    var div_estimated_price_value = Ext.getDom(genid + 'estimated_price_value');
    if(is_calculated_estimated_price){
        $("#" + genid + 'addEstimatedPriceValue').val(formatted_default_value);
        div_estimated_price_value.style.display = 'none';
    } else {
        // Set formatted estimated price value
        var estimated_price_value = <?php echo $task->getColumnValue('estimated_price') ? $task->getColumnValue('estimated_price') : 0 ?>;
        var formatted_est_price_value = og.format_money_amount(estimated_price_value);
        $("#" + genid + 'addEstimatedPriceValue').val(formatted_est_price_value);
        // Show estimated price input
		div_estimated_price_value.style.display = 'block';
    }
    
    // Show or Hide earned value input
    var is_calculated_earned_value = <?php echo $is_calculated_earned_value ? 1 : 0; ?>;
    var div_earned_value = Ext.getDom(genid + 'earned_value_amount');
    if(is_calculated_earned_value){
        $("#" + genid + 'addEarnedValueAmount').val(formatted_default_value);
        div_earned_value.style.display = 'none';
    } else {
         // Set formatted earned value
        var earned_value_amount = <?php echo $task->getColumnValue('earned_value') ? $task->getColumnValue('earned_value') : 0 ?>;
        var formatted_earned_value_amount = og.format_money_amount(earned_value_amount);
        $("#" + genid + 'addEarnedValueAmount').val(formatted_earned_value_amount);
        // Show earned value input
		div_earned_value.style.display = 'block';
    }
    
</script>
