
INSERT INTO `<?php echo $table_prefix ?>config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
 ('system', 'adv_billing_dimensions', '', 'AllDimensionsConfigHandler', 1, 0, '')
ON DUPLICATE KEY UPDATE `category_name`=`category_name`;

INSERT INTO `<?php echo $table_prefix ?>contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
 ('general', 'timeReportShowCost', '0', 'BoolConfigHandler', 1, 0, '')
ON DUPLICATE KEY UPDATE `category_name`=`category_name`;

INSERT INTO <?php echo $table_prefix ?>billing_definitions (`name`, `description`, `user_id`, `hourly_rate`, `hourly_cost`, `created_by_id`, `created_on`, `updated_by_id`, `updated_on`)
  SELECT concat(b.name,' - ', c.first_name, ' ', c.surname) as catname, b.description, c.object_id, b.default_value, 0, created_by_id, created_on, updated_by_id, updated_on
  FROM <?php echo $table_prefix ?>contacts c INNER JOIN <?php echo $table_prefix ?>billing_categories b ON b.id=c.default_billing_id
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>billing_definitions.id=<?php echo $table_prefix ?>billing_definitions.id;

UPDATE `<?php echo $table_prefix ?>config_options` 
SET value = (SELECT GROUP_CONCAT(`id`) FROM `<?php echo $table_prefix ?>dimensions` WHERE `code` in ('customer_project','workspaces')) 
WHERE name='adv_billing_dimensions';


-- rate schedules dimension


INSERT INTO `<?php echo $table_prefix ?>dimensions` (`code`,`name`,`is_root`,`is_manageable`,`allows_multiple_selection`,`defines_permissions`,`default_order`, `is_default`, `options`, `permission_query_method`) VALUES 
('rate_schedules','Rate Schedules',1,1,0,1,15,0,'{"defaultAjax":{"controller":"dashboard","action":"main_dashboard"},"useLangs":true,"quickAdd":true,"showInPaths":true}', 'not_mandatory' );

INSERT INTO <?php echo $table_prefix ?>dimension_options (`dimension_id`, `name`, `value`) VALUES
 ((SELECT `id` FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='rate_schedules'),'useLangs','1'),
 ((SELECT `id` FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='rate_schedules'),'showInPaths','1')
ON DUPLICATE KEY UPDATE `value`=`value`;

INSERT INTO `<?php echo $table_prefix ?>object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
 ('rate_schedule', 'RateSchedules', 'rate_schedules', 'dimension_object', '', (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='advanced_billing'), 0)
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_types` (`dimension_id`,`object_type_id`,`is_root`,`options`) VALUES 
 ((SELECT id from <?php echo $table_prefix ?>dimensions WHERE code = 'rate_schedules'), (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name = 'rate_schedule'), 1, '{"defaultAjax":{"controller":"dashboard", "action": "main_dashboard"}}'),
 ((SELECT id from <?php echo $table_prefix ?>dimensions WHERE code = 'rate_schedules'), (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name = 'folder'), 1, '{"defaultAjax":{"controller":"dashboard", "action": "main_dashboard"}}')
ON DUPLICATE KEY UPDATE dimension_id=dimension_id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_hierarchies` (dimension_id, parent_object_type_id, child_object_type_id)
VALUES (
  (SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code='rate_schedules'),
  (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name = 'folder'),
  (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name = 'folder')
),(
  (SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code='rate_schedules'),
  (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name = 'folder'),
  (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name = 'rate_schedule')
),(
  (SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code='rate_schedules'),
  (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name = 'rate_schedule'),
  (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name = 'rate_schedule')
);

INSERT INTO <?php echo $table_prefix ?>dimension_object_type_options (`dimension_id`, `object_type_id`, `name`, `value`) VALUES 
 ((SELECT `id` FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='rate_schedules'), (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='rate_schedule'),'select_after_creation','1'),
 ((SELECT `id` FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='rate_schedules'), (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='folder'),'select_after_creation','1')
ON DUPLICATE KEY UPDATE `value`=`value`;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
 SELECT
 	(SELECT `id` FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='rate_schedules'),
 	(SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='rate_schedule'),
 	`id`, 0, 0
 FROM `<?php echo $table_prefix ?>object_types`
 WHERE  `type` IN ('content_object', 'comment', 'located')
ON DUPLICATE KEY UPDATE dimension_id=dimension_id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
 SELECT
 	(SELECT `id` FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='rate_schedules'),
 	(SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='folder'),
 	`id`, 0, 0
 FROM `<?php echo $table_prefix ?>object_types`
 WHERE  `type` IN ('content_object', 'comment', 'located')
ON DUPLICATE KEY UPDATE dimension_id=dimension_id;

UPDATE `<?php echo $table_prefix ?>contact_config_options` 
 SET default_value = concat(default_value,',', (SELECT GROUP_CONCAT(`id`) FROM `<?php echo $table_prefix ?>dimensions` WHERE `code` IN ('rate_schedules')) ) 
 WHERE name='root_dimensions';

UPDATE `<?php echo $table_prefix ?>config_options` 
 SET value = concat(`<?php echo $table_prefix ?>config_options`.`value`,',', (SELECT GROUP_CONCAT(`id`) FROM `<?php echo $table_prefix ?>dimensions` WHERE `code` IN ('rate_schedules')) ) 
 WHERE name='enabled_dimensions';

INSERT INTO <?php echo $table_prefix ?>contact_dimension_permissions (permission_group_id, dimension_id, permission_type)
 SELECT c.permission_group_id, (SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code='rate_schedules'), 'allow all'
 FROM <?php echo $table_prefix ?>contacts c where c.user_type = (SELECT id FROM <?php echo $table_prefix ?>permission_groups WHERE name='Super Administrator' AND `type`='roles')
ON DUPLICATE KEY UPDATE dimension_id=dimension_id;

INSERT INTO `<?php echo $table_prefix ?>contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`) VALUES
 ('listing preferences', concat('lp_dim_rate_schedules_show_as_column'), '1', 'BoolConfigHandler', 0, 0)
ON DUPLICATE KEY UPDATE name=name;

INSERT INTO `<?php echo $table_prefix ?>dimension_content_object_options` (`dimension_id`,`content_object_type_id`,`option`,`value`) 
	SELECT d.id, ot.id, 'hide_member_selector_in_forms', '0'
	FROM <?php echo $table_prefix ?>dimensions d LEFT JOIN <?php echo $table_prefix ?>object_types ot ON true
	WHERE d.code IN ('rate_schedules') 
		AND ot.type IN ('content_object', 'located', 'comment')
ON DUPLICATE KEY UPDATE `value`=`value`;


INSERT INTO `<?php echo $table_prefix ?>custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
	SELECT mt.id, 'Color', 'color_special','color','','','',0,0,30,1, 1, 0
	FROM <?php echo $table_prefix ?>object_types mt WHERE name IN ('rate_schedule')
ON DUPLICATE KEY UPDATE `code`=`code`;

INSERT INTO `<?php echo $table_prefix ?>custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
	SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,31,1, 1, 0
	FROM <?php echo $table_prefix ?>object_types mt WHERE name IN ('rate_schedule')
ON DUPLICATE KEY UPDATE `code`=`code`;

INSERT INTO `<?php echo $table_prefix ?>dimension_member_associations` (`dimension_id`,`object_type_id`,`associated_dimension_id`, `associated_object_type_id`, `is_required`,`is_multiple`, `keeps_record`, `allows_default_selection`) VALUES
 ((SELECT id from <?php echo $table_prefix ?>dimensions WHERE code = 'customer_project'),(SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name = 'project'),(SELECT id from <?php echo $table_prefix ?>dimensions WHERE code = 'rate_schedules'),(SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name = 'rate_schedule'),0,0,0,1)
ON DUPLICATE KEY UPDATE dimension_id=dimension_id;

INSERT INTO <?php echo $table_prefix ?>dimension_associations_config (association_id, config_name, value)
	SELECT id, 'autoclassify_in_property_member', '1'
	FROM <?php echo $table_prefix ?>dimension_member_associations 
	WHERE dimension_id=(SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code='customer_project')
		AND associated_dimension_id=(SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code='rate_schedules')
ON DUPLICATE KEY UPDATE value=value;

INSERT INTO <?php echo $table_prefix ?>dimension_associations_config (association_id, config_name, value)
	SELECT id, 'allow_remove_from_property_member', '1'
	FROM <?php echo $table_prefix ?>dimension_member_associations 
	WHERE dimension_id=(SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code='customer_project')
		AND associated_dimension_id=(SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code='rate_schedules')
ON DUPLICATE KEY UPDATE value=value;

INSERT INTO `<?php echo $table_prefix ?>contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
('task panel', 'tasksShowEstimatedCost', '0', 'BoolConfigHandler', 1, 0, ''),
('task panel', 'tasksShowEstimatedPrice', '0', 'BoolConfigHandler', 1, 0, ''),
('task panel', 'tasksShowExecutedCost', '0', 'BoolConfigHandler', 1, 0, ''),
('task panel', 'tasksShowExecutedPrice', '0', 'BoolConfigHandler', 1, 0, ''),
('task panel', 'tasksShowIsBillable', '0', 'BoolConfigHandler', 1, 0, '')
ON DUPLICATE KEY UPDATE `name`=`name`;

INSERT INTO `<?php echo $table_prefix ?>config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
 ('general', 'disable_billing_tab_in_timeslot', '0', 'BoolConfigHandler', 0, 1000, '')
ON DUPLICATE KEY UPDATE `id`=`id`;

INSERT INTO `<?php echo $table_prefix ?>config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
 ('general', 'hide_billing_tab_in_timeslot', '0', 'BoolConfigHandler', 0, 1000, '')
ON DUPLICATE KEY UPDATE `id`=`id`;

INSERT INTO `<?php echo $table_prefix ?>config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
('task_workflow', 'use_is_billable_value_in_tasks', 0, 'BoolConfigHandler', '0', '5', NULL);

INSERT INTO `<?php echo $table_prefix ?>config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
('task_workflow', 'show_financial_tab_in_task_form', 0, 'BoolConfigHandler', '0', '5', NULL);