og.onBillingDefinitionMemberRemove = function (genid, dimension_id){
	og.onAssociatedMemberTypeRemove(genid, "billing_definition[dim_"+dimension_id+"][member_id]");
}

og.onBillingDefinitionMemberSelect = function (genid, dimension_id, member_id){
	og.onAssociatedMemberTypeSelect(genid, dimension_id, member_id, "billing_definition[dim_"+dimension_id+"][member_id]");
}


og.onAdvancedBillingDimensionChanged = function(checkbox, dim_id) {
	var enable = $(checkbox).attr('checked') == 'checked' ? '1' : '0';
	og.openLink(og.getUrl('billing_definition', 'enable_disable_dimension', {dim_id:dim_id, enable:enable}), {
		silent:true,
		callback: function(success, data) {

			og.advanced_billing.reload_allowed_dimensions(parseInt(dim_id));
			
		}
	});
	
}


og.advanced_billing = {
	init: function() {
		og.advanced_billing.reload_allowed_dimensions();
		
		if (!og.additional_timeslot_type_filter_values) og.additional_timeslot_type_filter_values = [];
		og.additional_timeslot_type_filter_values.push(['conflict', lang('timeslots with billing category conflict')]);

		// Add 'tasksShowEstimatedCost'
		if(og.loggedUser.can_see_cost_info){
			var has_col = false;
			if (ogTasks.additional_task_list_columns) {
				for (var i = 0; i < ogTasks.additional_task_list_columns.length; i++) {
					if (ogTasks.additional_task_list_columns[i].id == 'tasksShowEstimatedCost') has_col = true; 
				}
			} else {
				ogTasks.additional_task_list_columns = [];
			}
			if (!has_col) {
				ogTasks.additional_task_list_columns.push({
					id: 'tasksShowEstimatedCost',
					data: 'data-resizable=1',
					width: 'auto',
					name: lang('estimated cost'),
					group_total_field: 'estimated_cost_string',
                	row_field: 'estimated_cost_string',
				});
			}
		}

		// Add 'tasksShowExecutedCost'
		if(og.loggedUser.can_see_cost_info){
			var has_col = false;
			if (ogTasks.additional_task_list_columns) {
				for (var i = 0; i < ogTasks.additional_task_list_columns.length; i++) {
					if (ogTasks.additional_task_list_columns[i].id == 'tasksShowExecutedCost') has_col = true; 
				}
			} else {
				ogTasks.additional_task_list_columns = [];
			}
			if (!has_col) {
				ogTasks.additional_task_list_columns.push({
					id: 'tasksShowExecutedCost',
					data: 'data-resizable=1',
					width: 'auto',
					name: lang('executed cost'),
					group_total_field: 'executed_cost_string',
                	row_field: 'executed_cost_string',
				});
			}
		}

		// Add 'tasksShowEstimatedPrice'
		if(og.loggedUser.can_see_billing_info){
			var has_col = false;
			if (ogTasks.additional_task_list_columns) {
				for (var i = 0; i < ogTasks.additional_task_list_columns.length; i++) {
					if (ogTasks.additional_task_list_columns[i].id == 'tasksShowEstimatedPrice') has_col = true; 
				}
			} else {
				ogTasks.additional_task_list_columns = [];
			}
			if (!has_col) {
				ogTasks.additional_task_list_columns.push({
					id: 'tasksShowEstimatedPrice',
					data: 'data-resizable=1',
					width: 'auto',
					name: lang('estimated price'),
					group_total_field: 'estimated_price_string',
                	row_field: 'estimated_price_string',
				});
			}
		}

		// Add 'tasksShowExecutedPrice'
		if(og.loggedUser.can_see_billing_info){
			var has_col = false;
			if (ogTasks.additional_task_list_columns) {
				for (var i = 0; i < ogTasks.additional_task_list_columns.length; i++) {
					if (ogTasks.additional_task_list_columns[i].id == 'tasksShowExecutedPrice') has_col = true; 
				}
			} else {
				ogTasks.additional_task_list_columns = [];
			}
			if (!has_col) {
				ogTasks.additional_task_list_columns.push({
					id: 'tasksShowExecutedPrice',
					data: 'data-resizable=1',
					width: 'auto',
					name: lang('earned value'),
					group_total_field: 'earned_value_string',
                	row_field: 'earned_value_string'
				});
			}
		}

		var use_task_billable = og.config['use_is_billable_value_in_tasks'];
		if(use_task_billable){
			// Add 'tasksShowIsBillable'
			var is_billable_has_col = false;
			if (ogTasks.additional_task_list_columns) {
				for (var i = 0; i < ogTasks.additional_task_list_columns.length; i++) {
					if (ogTasks.additional_task_list_columns[i].id == 'tasksShowIsBillable') is_billable_has_col = true; 
				}
			} else {
				ogTasks.additional_task_list_columns = [];
			}
			if (!is_billable_has_col) {
				ogTasks.additional_task_list_columns.unshift({
					id: 'tasksShowIsBillable',
					data: 'data-resizable=1',
					width: 'auto',
					name: lang('billable')
				});
			}
			
			if (!ogTasks.additional_mark_actions) {
				ogTasks.additional_mark_actions = [];
			}
			ogTasks.additional_mark_actions.push({
				action_name: 'markAsBillable',
				text: lang('mark as billable'),
				tooltip: lang('mark as billable desc'),
				iconCls: 'ico-income',
				handler: function() {
					ogTasks.executeAction('markasbillable');
				},
			});
			ogTasks.additional_mark_actions.push({
				action_name: 'markAsNonBillable',
				text: lang('mark as non-billable'),
				tooltip: lang('mark as non-billable desc'),
				iconCls: 'ico-income',
				handler: function() {
					ogTasks.executeAction('markasnonbillable');
				},
			});
		}

		// Add 'budgeted revenue' and 'budgeted cost' columns to the project list
		og.openLink(og.getUrl('project', 'get_dimension_info'), {
			callback: function(success, data) {
				if (!data || !data.dim_info) return;
				og.projects.dimension_id = data.dim_info.dimension_id;
				og.projects.object_type_id = data.dim_info.object_type_id;

				og.eventManager.fireEvent('after get projects dimension info', data.dim_info);

				var dim = data.dim_info; 
				if (!og.listing_member_type_cols) og.listing_member_type_cols = [];
				if (!og.listing_member_type_cols[dim.dimension_id]) og.listing_member_type_cols[dim.dimension_id] = [];
				if (!og.listing_member_type_cols[dim.dimension_id][dim.object_type_id]) og.listing_member_type_cols[dim.dimension_id][dim.object_type_id] = [];
				if(og.loggedUser.can_see_billing_info){
					og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
						id: 'budgeted_price',
						name: lang('budgeted revenue'),
						renderer: og.clean,
						hidden: true
					});
				}
				if(og.loggedUser.can_see_cost_info){
					og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
						id: 'budgeted_cost',
						name: lang('budgeted cost'),
						renderer: og.clean,
						hidden: true
					});
				}

				// Add estimated labor project totals info
				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_labor_minutes',
					name: lang('estimated labor hours'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_labor_billable_price',
					name: lang('estimated labor billable price'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_labor_non_billable_price',
					name: lang('estimated labor non-billable price'),
					renderer: og.clean,
					hidden: true
				});


				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_labor_total_price',
					name: lang('estimated labor total price'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_labor_billable_cost',
					name: lang('estimated labor billable cost'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_labor_non_billable_cost',
					name: lang('estimated labor non-billable cost'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_labor_total_cost',
					name: lang('estimated labor total cost'),
					renderer: og.clean,
					hidden: true
				});

				// Add executed labor project totals info
				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_labor_minutes',
					name: lang('executed labor hours'),
					renderer: og.clean,
					hidden: true
				});

				/*og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_labor_billable_price',
					name: lang('executed labor billable price'),
					renderer: og.clean,
					hidden: true
				});*/

				/*og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_labor_non_billable_price',
					name: lang('executed labor non-billable price'),
					renderer: og.clean,
				});*/


				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_labor_total_price',
					name: lang('executed labor total price'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_labor_billable_cost',
					name: lang('executed labor billable cost'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_labor_non_billable_cost',
					name: lang('executed labor non-billable cost'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_labor_total_cost',
					name: lang('executed labor total cost'),
					renderer: og.clean,
					hidden: true
				});

				// Add estimated overall project totals info
				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_overall_billable_price',
					name: lang('estimated overall billable price'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_overall_non_billable_price',
					name: lang('estimated overall non-billable price'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_overall_total_price',
					name: lang('estimated overall total price'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_overall_billable_cost',
					name: lang('estimated overall billable cost'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_overall_non_billable_cost',
					name: lang('estimated overall non-billable cost'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_overall_total_cost',
					name: lang('estimated overall total cost'),
					renderer: og.clean,
					hidden: true
				});

				// Add executed overall project totals info	
				/*og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_overall_billable_price',
					name: lang('executed overall billable price'),
					renderer: og.clean,
					hidden: true
				});*/

				/*og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_overall_non_billable_price',
					name: lang('executed overall non-billable price'),
					renderer: og.clean,
				});*/

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_overall_total_price', 
					name: lang('executed overall total price'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_overall_billable_cost',
					name: lang('executed overall billable cost'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_overall_non_billable_cost',
					name: lang('executed overall non-billable cost'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_overall_total_cost',
					name: lang('executed overall total cost'),
					renderer: og.clean,
					hidden: true
				});
			}
		});
		
	},
	
	def_ratecost_toggle: function(genid, type, checkbox) {
		var id = genid + (type == 'cost' ? 'cost_def' : 'rate_def');

		if ($(checkbox).attr('checked') == 'checked') {
			$("#"+id).removeClass('block-disabled');
		} else {
			$("#"+id).addClass('block-disabled');
		}
	},
	
	recalculate_timeslots_billing: function(grid_id) {
		var ids = [];
        var grid = Ext.getCmp(grid_id);
        if (grid) {
            ids = grid.getSelectedIds();
        }
        
        var params = {};
        if (ids.length > 0) {
        	params.timeslot_ids = ids;
        } else {
        	params.all_timeslots = true;
        	if (grid) {
        		Ext.apply(params, grid.store_params);
        	}
        }
        
    	og.openLink(og.getUrl('billing_definition', 'recalculate_timeslots_billing', params));
	},

	reload_allowed_dimensions: function(changed_dim) {
		og.openLink(og.getUrl('billing_definition', 'get_allowed_dimensions'), {
			silent: true,
			callback: function(success, data) {
				if (success) {
					og.advanced_billing_allowed_dimensions = [];
					for (i=0; i<data.allowed_dimensions.length; i++) {
						og.advanced_billing_allowed_dimensions.push(parseInt(data.allowed_dimensions[i]));
					}
					
					var man = Ext.getCmp('advanced-billing-manager');
					if (man) {
						var cm = man.getColumnModel();
						if (cm) {
						  for (var i=0; i<og.advanced_billing_allowed_dimensions.length; i++) {
							var dim_id = og.advanced_billing_allowed_dimensions[i];
							
							var col = cm.getColumnById('dim_' + dim_id);
							if (!col && og.advanced_billing_allowed_dimensions.indexOf(parseInt(dim_id)) >= 0) {
								cm.config.push({
									id: 'dim_' + dim_id,
									header: og.dimensions_info[dim_id].name,
									dataIndex: 'dim_' + dim_id,
									sortable: true,
									renderer: og.renderDimCol
								});
								cm.fireEvent('configchange', cm);
								man.reset();
							}
						  }
						}
						
						if (changed_dim) {
							if (og.advanced_billing_allowed_dimensions.indexOf(parseInt(changed_dim)) > -1) {
								$("#advanced-billing-manager .x-grid3-col.x-grid3-cell.x-grid3-td-dim_"+changed_dim).show();
								$("#advanced-billing-manager .x-grid3-hd.x-grid3-cell.x-grid3-td-dim_"+changed_dim).show();
							} else {
						//		$("#advanced-billing-manager .x-grid3-col.x-grid3-cell.x-grid3-td-dim_"+changed_dim).hide();
						//		$("#advanced-billing-manager .x-grid3-hd.x-grid3-cell.x-grid3-td-dim_"+changed_dim).hide();
							}
						}
					}
				}
			}
		});
	}
}
