<?php 

function advanced_billing_update_1_2() {

	$p_controller = new PluginController();
	$p_controller->ensure_installed_and_activated('multiple_currencies');

	if (!check_column_exists(TABLE_PREFIX."billing_definitions", "rate_currency_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."billing_definitions` ADD `rate_currency_id` int(10) NOT NULL DEFAULT 0;
		");
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."billing_definitions` ADD `cost_currency_id` int(10) NOT NULL DEFAULT 0;
		");
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."timeslots` ADD `cost_currency_id` int(10) NOT NULL DEFAULT 0;
		");
		
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."billing_definitions`
				CHANGE `hourly_rate` `hourly_rate` decimal(20,3) NOT NULL DEFAULT 0,
				CHANGE `hourly_cost` `hourly_cost` decimal(20,3) NOT NULL DEFAULT 0;
		");
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."timeslots`
				CHANGE `fixed_cost` `fixed_cost` decimal(20,3) NOT NULL DEFAULT 0,
				CHANGE `hourly_cost` `hourly_cost` decimal(20,3) NOT NULL DEFAULT 0;
		");
		
		DB::execute("
			UPDATE `".TABLE_PREFIX."billing_definitions` SET 
				rate_currency_id = (SELECT id FROM ".TABLE_PREFIX."currencies LIMIT 1),
				cost_currency_id = (SELECT id FROM ".TABLE_PREFIX."currencies LIMIT 1);
		");
		DB::execute("
			UPDATE `".TABLE_PREFIX."timeslots` SET
				cost_currency_id = (SELECT id FROM ".TABLE_PREFIX."currencies LIMIT 1);
		");
	}
}


function advanced_billing_update_2_3() {
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."billing_definition_members`
		CHANGE `dimension_id` `dimension_id` int(10) NOT NULL DEFAULT 0,
		CHANGE `member_id` `member_id` int(10) NOT NULL DEFAULT 0;
	");
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."billing_definition_members`
		ADD PRIMARY KEY `definition_id_dimension_id_member_id` (`definition_id`, `dimension_id`, `member_id`),
		DROP INDEX `PRIMARY`;
	");
}

function advanced_billing_update_3_4() {
	if (!check_column_exists(TABLE_PREFIX."timeslots", "billing_category_status")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."timeslots` ADD COLUMN `billing_category_status` VARCHAR(255) NOT NULL DEFAULT '';
		");
	}
}

function advanced_billing_update_4_5() {
	if (!check_column_exists(TABLE_PREFIX."billing_definitions", "enable_rate")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."billing_definitions` ADD `enable_rate` tinyint(1) NOT NULL DEFAULT '1'
		");
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."billing_definitions` ADD `enable_cost` tinyint(1) NOT NULL DEFAULT '1'
		");
	}
}


function advanced_billing_update_5_6() {
    if (!checkTableExists(TABLE_PREFIX."object_billing")) {
        DB::execute("
            CREATE TABLE `".TABLE_PREFIX."object_billing` (
            `object_id` INT(11) NOT NULL AUTO_INCREMENT,
              `rel_object_id` INT(10) NULL DEFAULT NULL,
              `contact_id` INT(10) NULL DEFAULT NULL,
              `time` INT(10) NULL DEFAULT NULL,
              `total_price` DECIMAL(20,3) NOT NULL DEFAULT '0.000',
              `billing_rate` DECIMAL(20,3) NOT NULL DEFAULT '0.000',
              `is_total_price` TINYINT(1) UNSIGNED NOT NULL DEFAULT '0',
              `rate_currency_id` INT(10) UNSIGNED NOT NULL DEFAULT '0',
              `invoicing_status` VARCHAR(50) CHARACTER SET 'utf8' NOT NULL DEFAULT 'pending',
              `invoice_id` INT(10) UNSIGNED NOT NULL DEFAULT '0',
              `total_cost` DECIMAL(20,3) NOT NULL DEFAULT '0.000',
              `cost_rate` DECIMAL(20,3) NOT NULL DEFAULT '0.000',
              `is_total_cost` TINYINT(1) NOT NULL DEFAULT '0',
              `adv_billing_id` INT(10) UNSIGNED NOT NULL DEFAULT '0',
              `adv_cost_id` INT(10) UNSIGNED NOT NULL DEFAULT '0',
              `cost_currency_id` INT(10) UNSIGNED NOT NULL DEFAULT '0',
              `billing_category_status` VARCHAR(255) CHARACTER SET 'utf8' NOT NULL DEFAULT '',
              PRIMARY KEY (`object_id`))
                    ");
    }

}



function advanced_billing_update_6_7() {

	if (Plugins::instance()->isActivePlugin('advanced_reports')) {
		Env::useHelper('default_member_reports', 'advanced_reports');

		create_fixed_report('timeslot','Billing rate and Cost rate');
	}
}


/**
 * adds Rate Schedules dimension
 */
function advanced_billing_update_7_8() {
	
	DB::execute("
		CREATE TABLE `".TABLE_PREFIX."rate_schedules` (
		  `object_id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
		  PRIMARY KEY (`object_id`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimensions` (`code`,`name`,`is_root`,`is_manageable`,`allows_multiple_selection`,`defines_permissions`,`default_order`, `is_default`, `options`, `permission_query_method`) VALUES 
		('rate_schedules','Rate Schedules',1,1,0,1,15,0,'{\"defaultAjax\":{\"controller\":\"dashboard\",\"action\":\"main_dashboard\"},\"useLangs\":true,\"quickAdd\":true,\"showInPaths\":true}', 'not_mandatory' );
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."dimension_options (`dimension_id`, `name`, `value`) VALUES
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='rate_schedules'),'useLangs','1'),
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='rate_schedules'),'showInPaths','1')
		ON DUPLICATE KEY UPDATE `value`=`value`;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
		 ('rate_schedule', 'RateSchedules', 'rate_schedules', 'dimension_object', '', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='advanced_billing'), 0)
		ON DUPLICATE KEY UPDATE id=id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_types` (`dimension_id`,`object_type_id`,`is_root`,`options`) VALUES 
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'rate_schedules'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'rate_schedule'), 1, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}'),
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'rate_schedules'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'folder'), 1, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_hierarchies` (dimension_id, parent_object_type_id, child_object_type_id)
		VALUES (
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='rate_schedules'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'folder'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'folder')
		),(
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='rate_schedules'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'folder'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'rate_schedule')
		),(
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='rate_schedules'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'rate_schedule'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'rate_schedule')
		);
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."dimension_object_type_options (`dimension_id`, `object_type_id`, `name`, `value`) VALUES 
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='rate_schedules'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='rate_schedule'),'select_after_creation','1'),
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='rate_schedules'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='folder'),'select_after_creation','1')
		ON DUPLICATE KEY UPDATE `value`=`value`;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='rate_schedules'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='rate_schedule'),
		 	`id`, 0, 0
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `type` IN ('content_object', 'comment', 'located')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='rate_schedules'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='folder'),
		 	`id`, 0, 0
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `type` IN ('content_object', 'comment', 'located')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		UPDATE `".TABLE_PREFIX."contact_config_options` 
		 SET default_value = concat(default_value,',', (SELECT GROUP_CONCAT(`id`) FROM `".TABLE_PREFIX."dimensions` WHERE `code` IN ('rate_schedules')) ) 
		 WHERE name='root_dimensions';
	");
	
	DB::execute("
		UPDATE `".TABLE_PREFIX."config_options` 
		 SET value = concat(`".TABLE_PREFIX."config_options`.`value`,',', (SELECT GROUP_CONCAT(`id`) FROM `".TABLE_PREFIX."dimensions` WHERE `code` IN ('rate_schedules')) ) 
		 WHERE name='enabled_dimensions';
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."contact_dimension_permissions (permission_group_id, dimension_id, permission_type)
		 SELECT c.permission_group_id, (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='rate_schedules'), 'allow all'
		 FROM ".TABLE_PREFIX."contacts c where c.user_type = (SELECT id FROM ".TABLE_PREFIX."permission_groups WHERE name='Super Administrator' AND `type`='roles')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`) VALUES
		 ('listing preferences', concat('lp_dim_rate_schedules_show_as_column'), '1', 'BoolConfigHandler', 0, 0)
		ON DUPLICATE KEY UPDATE name=name;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_content_object_options` (`dimension_id`,`content_object_type_id`,`option`,`value`) 
			SELECT d.id, ot.id, 'hide_member_selector_in_forms', '0'
			FROM ".TABLE_PREFIX."dimensions d LEFT JOIN ".TABLE_PREFIX."object_types ot ON true
			WHERE d.code IN ('rate_schedules') 
				AND ot.type IN ('content_object', 'located', 'comment')
		ON DUPLICATE KEY UPDATE `value`=`value`;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
			SELECT mt.id, 'Color', 'color_special','color','','','',0,0,30,1, 1, 0
			FROM ".TABLE_PREFIX."object_types mt WHERE name IN ('rate_schedule')
		ON DUPLICATE KEY UPDATE `code`=`code`;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
			SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,31,1, 1, 0
			FROM ".TABLE_PREFIX."object_types mt WHERE name IN ('rate_schedule')
		ON DUPLICATE KEY UPDATE `code`=`code`;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_member_associations` (`dimension_id`,`object_type_id`,`associated_dimension_id`, `associated_object_type_id`, `is_required`,`is_multiple`, `keeps_record`) VALUES
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'project'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'rate_schedules'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'rate_schedule'),0,0,0)
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."dimension_associations_config (association_id, config_name, value)
			SELECT id, 'autoclassify_in_property_member', '1'
			FROM ".TABLE_PREFIX."dimension_member_associations 
			WHERE dimension_id=(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='customer_project')
				AND associated_dimension_id=(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='rate_schedules')
		ON DUPLICATE KEY UPDATE value=value;
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."dimension_associations_config (association_id, config_name, value)
			SELECT id, 'allow_remove_from_property_member', '1'
			FROM ".TABLE_PREFIX."dimension_member_associations 
			WHERE dimension_id=(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='customer_project')
				AND associated_dimension_id=(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='rate_schedules')
		ON DUPLICATE KEY UPDATE value=value;
	");
	
	if (Plugins::instance()->isActivePlugin('advanced_core')) {
		Env::useHelper('functions', 'advanced_core');
		fill_property_groups_default_data();
	}
}

function advanced_billing_update_8_9() {
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."object_billing`
			ADD INDEX `rel_object_id` (`rel_object_id`),
			ADD INDEX `contact_id` (`contact_id`),
			ADD INDEX `adv_billing_id` (`adv_billing_id`),
			ADD INDEX `adv_cost_id` (`adv_cost_id`);
	");
}

function advanced_billing_update_9_10() {
	
	DB::execute("
		UPDATE `".TABLE_PREFIX."dimension_member_associations`
		SET allows_default_selection=1
		WHERE
			dimension_id = (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='customer_project')
			AND object_type_id = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project')
			AND associated_dimension_id = (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='rate_schedules')
			AND associated_object_type_id = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='rate_schedule');
	");
}

function advanced_billing_update_10_11() {
	// Add 'Estimated cost' contact config option
	$estimated_cost_config = ContactConfigOptions::getByName('tasksShowEstimatedCost');
	if(!$estimated_cost_config instanceof ContactConfigOption){
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES 
			('task panel', 'tasksShowEstimatedCost', '0', 'BoolConfigHandler', 1, 0, '');
	 	");
	}
	// Add 'Estimated price' contact config option
	$estimated_price_config = ContactConfigOptions::getByName('tasksShowEstimatedPrice');
	if(!$estimated_price_config instanceof ContactConfigOption){
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES 
			('task panel', 'tasksShowEstimatedPrice', '0', 'BoolConfigHandler', 1, 0, '');
	 	");
	}
	// Add 'Executed cost' contact config option
	$executed_cost_config = ContactConfigOptions::getByName('tasksShowExecutedCost');
	if(!$executed_cost_config instanceof ContactConfigOption){
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES 
			('task panel', 'tasksShowExecutedCost', '0', 'BoolConfigHandler', 1, 0, '');
	 	");
	}
	// Add 'Executed price' contact config option
	$executed_price_config = ContactConfigOptions::getByName('tasksShowExecutedPrice');
	if(!$executed_price_config instanceof ContactConfigOption){
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES 
			('task panel', 'tasksShowExecutedPrice', '0', 'BoolConfigHandler', 1, 0, '');
	 	");
	}
}

function advanced_billing_update_11_12() {

	// Add 'disable_billing_tab_in_timeslot' contact config option
	$config_option_exists = ConfigOptions::getByName("disable_billing_tab_in_timeslot");
	if (!($config_option_exists instanceof ConfigOption)) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`) VALUES
				('general', 'disable_billing_tab_in_timeslot', '0', 'BoolConfigHandler', '0', '1000')
				ON DUPLICATE KEY UPDATE id=id;
			");
	}


	if (check_column_exists(TABLE_PREFIX."timeslots", "invoicing_status")) {
		DB::execute("
			UPDATE ".TABLE_PREFIX."timeslots
			SET is_fixed_billing='0', fixed_billing='0', hourly_billing='0', rate_currency_id='1', adv_billing_id=0
			WHERE invoicing_status='non_billable';
		");
	}
}

function advanced_billing_update_12_13() {

	if (!check_column_exists(TABLE_PREFIX."project_tasks", 'executed_cost')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."project_tasks` ADD COLUMN `executed_cost` DECIMAL(20,3) NOT NULL default '0';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."project_tasks", 'earned_value')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."project_tasks` ADD COLUMN `earned_value` DECIMAL(20,3) NOT NULL default '0';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."project_tasks", 'estimated_cost')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."project_tasks` ADD COLUMN `estimated_cost` DECIMAL(20,3) NOT NULL default '0';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."project_tasks", 'estimated_price')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."project_tasks` ADD COLUMN `estimated_price` DECIMAL(20,3) NOT NULL default '0';
		");
	}

}

function advanced_billing_update_13_14() {

	// Add 'disable_billing_tab_in_timeslot' contact config option
	$config_option_exists = ConfigOptions::getByName("hide_billing_tab_in_timeslot");
	if (!($config_option_exists instanceof ConfigOption)) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`) VALUES
				('general', 'hide_billing_tab_in_timeslot', '0', 'BoolConfigHandler', '0', '1000')
				ON DUPLICATE KEY UPDATE id=id;
			");
	}

}

function advanced_billing_update_14_15() {
	if (!check_column_exists(TABLE_PREFIX."project_tasks", 'is_calculated_executed_cost')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."project_tasks` ADD COLUMN `is_calculated_executed_cost` tinyint(1) NOT NULL DEFAULT '1';
		");
	}
	if (!check_column_exists(TABLE_PREFIX."project_tasks", 'is_calculated_earned_value')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."project_tasks` ADD COLUMN `is_calculated_earned_value` tinyint(1) NOT NULL DEFAULT '1';
		");
	}
	if (!check_column_exists(TABLE_PREFIX."project_tasks", 'is_calculated_estimated_cost')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."project_tasks` ADD COLUMN `is_calculated_estimated_cost` tinyint(1) NOT NULL DEFAULT '1';
		");
	}
	if (!check_column_exists(TABLE_PREFIX."project_tasks", 'is_calculated_estimated_price')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."project_tasks` ADD COLUMN `is_calculated_estimated_price` tinyint(1) NOT NULL DEFAULT '1';
		");
	}

	@set_time_limit(0);
	ini_set("memory_limit", "2G");

	$max_depth_sql = "SELECT MAX(depth) as max_depth  FROM " . TABLE_PREFIX . "project_tasks;";
	$max_depth_row = DB::executeAll($max_depth_sql);
	$max_depth = $max_depth_row[0]['max_depth'] ? $max_depth_row[0]['max_depth'] : 0;

	Env::useHelper('additional_tasks_columns_functions', 'advanced_billing');
	while($max_depth >= 0){
		$tasks_query = "SELECT `object_id` FROM " . TABLE_PREFIX . "project_tasks WHERE `depth`='".$max_depth."';";
		$rows = DB::executeAll($tasks_query);

		foreach ($rows as $row) {
			$task_id = $row['object_id'];
			$task_values = getTaskEstimatedExecutedValues($task_id);
			$estimated_cost = $task_values['estimated_cost'];
			$estimated_price = $task_values['estimated_price'];
			$earned_value = $task_values['earned_value'];
			$executed_cost = $task_values['executed_cost'];


			$update_tasks_sql = "UPDATE ".TABLE_PREFIX."project_tasks SET 
			estimated_cost=".$estimated_cost.",
			estimated_price=".$estimated_price.",
			earned_value=".$earned_value.",
			executed_cost=".$executed_cost."
			WHERE object_id=".$task_id.";\n";

			DB::executeAll($update_tasks_sql);
		}
		$max_depth--;
	}
}

function advanced_billing_update_15_16() {
	if (Plugins::instance()->isActivePlugin('hour_types')) {
		$hour_type_object_type_id = ObjectTypes::findByName('hour_type')->getId();
		$billable_mcp = MemberCustomProperties::findOne(array('conditions' => '`object_type_id`='.$hour_type_object_type_id.' AND `code`="is_billable"'));

		// Add 'is_billable' custom property to the labor category
		if(!$billable_mcp instanceof MemberCustomProperty){
			$billable_name = lang('billable');
			DB::execute("
				INSERT INTO `" . TABLE_PREFIX . "member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`) VALUES
				('".$hour_type_object_type_id."', '".$billable_name."', 'is_billable', 'boolean', '', '',
				1, 0, 0, 0, 5, 1, 1, 0)
				ON DUPLICATE KEY UPDATE `code`=`code`;
			");

			if (Plugins::instance()->isActivePlugin('advanced_core')) {
				$property_group = PropertyGroups::findOne(array('conditions' => '`object_type_id`='.$hour_type_object_type_id.' AND `code`="default"'));
				if($property_group instanceof PropertyGroup){
					$billable_mcp = MemberCustomProperties::findOne(array('conditions' => '`object_type_id`='.$hour_type_object_type_id.' AND `code`="is_billable"'));
					if($billable_mcp instanceof MemberCustomProperty){
						$group_id = $property_group->getId();
						$property_id = $billable_mcp->getId();
						DB::execute("
							INSERT INTO `" . TABLE_PREFIX . "property_group_properties` (`group_id`, `property_id`, `order`, `is_inheritable`) VALUES
							('".$group_id."', '".$property_id."', 5, 0)
							ON DUPLICATE KEY UPDATE `property_id`=`property_id`;
						");
					}
				}
			}
		}
	}

	// Add 'is_billable' column to the fo_project_tasks
	if (!check_column_exists(TABLE_PREFIX."project_tasks", 'is_billable')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."project_tasks` ADD COLUMN `is_billable` tinyint(1) NOT NULL DEFAULT '1';
		");
	}

	// Add 'is_billable' column to the fo_template_tasks
	if (!check_column_exists(TABLE_PREFIX."template_tasks", 'is_billable')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."template_tasks` ADD COLUMN `is_billable` tinyint(1) NOT NULL DEFAULT '1';
		");
	}

	// Add 'tasksShowIsBillable' contact config option
	$task_is_billable_config = ContactConfigOptions::getByName('tasksShowIsBillable');
	if(!$task_is_billable_config instanceof ContactConfigOption){
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES 
			('task panel', 'tasksShowIsBillable', '0', 'BoolConfigHandler', 1, 0, '');
	 	");
	}

	// Add config option 'use_is_billable_value_in_tasks'
	$config_option_exists = ConfigOptions::getByName("use_is_billable_value_in_tasks");
	if (!$config_option_exists instanceof ConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
			('task_workflow', 'use_is_billable_value_in_tasks', 0, 'BoolConfigHandler', '0', '5', NULL, NULL);
		");
	}
}

function advanced_billing_update_17_18() {
	// Add config option 'use_is_billable_value_in_tasks'
	$config_option_exists = ConfigOptions::getByName("show_financial_tab_in_task_form");
	if (!$config_option_exists instanceof ConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
			('task_workflow', 'show_financial_tab_in_task_form', 0, 'BoolConfigHandler', '0', '5', NULL, NULL);
		");
	}

}


function advanced_billing_update_18_19() {
	if(!checkTableExists(TABLE_PREFIX . "member_totals")){
		DB::execute("
			CREATE TABLE `" . TABLE_PREFIX . "member_totals` (
			`id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
			`member_id` INT(10) unsigned NOT NULL default 0,
			`estimated_labor_minutes` DECIMAL(50,3) NOT NULL default 0,
			`estimated_labor_billable_price` DECIMAL(50,3) NOT NULL default 0,
			`estimated_labor_non_billable_price` DECIMAL(50,3) NOT NULL default 0,
			`estimated_labor_total_price` DECIMAL(50,3) NOT NULL default 0,
			`estimated_labor_billable_cost` DECIMAL(50,3) NOT NULL default 0,
			`estimated_labor_non_billable_cost` DECIMAL(50,3) NOT NULL default 0,
			`estimated_labor_total_cost` DECIMAL(50,3) NOT NULL default 0,
			`executed_labor_minutes` DECIMAL(50,3) NOT NULL default 0,
			`executed_labor_billable_price` DECIMAL(50,3) NOT NULL default 0,
			`executed_labor_non_billable_price` DECIMAL(50,3) NOT NULL default 0,
			`executed_labor_total_price` DECIMAL(50,3) NOT NULL default 0,
			`executed_labor_billable_cost` DECIMAL(50,3) NOT NULL default 0,
			`executed_labor_non_billable_cost` DECIMAL(50,3) NOT NULL default 0,
			`executed_labor_total_cost` DECIMAL(50,3) NOT NULL default 0,
			`estimated_expense_billable_price` DECIMAL(50,3) NOT NULL default 0,
			`estimated_expense_non_billable_price` DECIMAL(50,3) NOT NULL default 0,
			`estimated_expense_total_price` DECIMAL(50,3) NOT NULL default 0,
			`estimated_expense_billable_cost` DECIMAL(50,3) NOT NULL default 0,
			`estimated_expense_non_billable_cost` DECIMAL(50,3) NOT NULL default 0,
			`estimated_expense_total_cost` DECIMAL(50,3) NOT NULL default 0,
			`executed_expense_billable_price` DECIMAL(50,3) NOT NULL default 0,
			`executed_expense_non_billable_price` DECIMAL(50,3) NOT NULL default 0,
			`executed_expense_total_price` DECIMAL(50,3) NOT NULL default 0,
			`executed_expense_billable_cost` DECIMAL(50,3) NOT NULL default 0,
			`executed_expense_non_billable_cost` DECIMAL(50,3) NOT NULL default 0,
			`executed_expense_total_cost` DECIMAL(50,3) NOT NULL default 0,
			`estimated_overall_billable_price` DECIMAL(50,3) NOT NULL default 0,
			`estimated_overall_non_billable_price` DECIMAL(50,3) NOT NULL default 0,
			`estimated_overall_total_price` DECIMAL(50,3) NOT NULL default 0,
			`estimated_overall_billable_cost` DECIMAL(50,3) NOT NULL default 0,
			`estimated_overall_non_billable_cost` DECIMAL(50,3) NOT NULL default 0,
			`estimated_overall_total_cost` DECIMAL(50,3) NOT NULL default 0,
			`executed_overall_billable_price` DECIMAL(50,3) NOT NULL default 0,
			`executed_overall_non_billable_price` DECIMAL(50,3) NOT NULL default 0,
			`executed_overall_total_price` DECIMAL(50,3) NOT NULL default 0,
			`executed_overall_billable_cost` DECIMAL(50,3) NOT NULL default 0,
			`executed_overall_non_billable_cost` DECIMAL(50,3) NOT NULL default 0,
			`executed_overall_total_cost` DECIMAL(50,3) NOT NULL default 0,
			`invoiced_total` DECIMAL(50,3) NOT NULL default 0,
			`invoiced_subtotal` DECIMAL(50,3) NOT NULL default 0,
			`invoiced_paid_amount` DECIMAL(50,3) NOT NULL default 0,
			`invoiced_due_amount` DECIMAL(50,3) NOT NULL default 0,
			PRIMARY KEY  (`id`),
			INDEX `member_id`(`member_id`)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
		");
	}

	@set_time_limit(0);
	ini_set("memory_limit", "2G");

	// Populate member_totals table with calculated estimated values
	if(checkTableExists(TABLE_PREFIX . "member_totals")){
		// Get helper functions
		Env::useHelper('persisting_member_totals_functions', 'advanced_billing');
		if (Plugins::instance()->isActivePlugin('expenses2')) {
			Env::useHelper('persist_member_expense_totals_functions', 'expenses2');
		}
		if (Plugins::instance()->isActivePlugin('income')) {
			Env::useHelper('persist_member_invoice_totals', 'income');
		}

		$project_ot_id = ObjectTypes::findByName('project')->getId();
		$project_members = Members::findAll(array('conditions' => array('`object_type_id`='.$project_ot_id)));
		foreach($project_members as $pm){
			$pm_id = $pm->getId();

			// Set estimated labor values
			$labor_info = get_estimated_labor_info_for_member($pm_id);
			set_new_member_totals_values($pm_id, $labor_info);

			// Set executed labor values
			$exec_labor_info = get_executed_labor_info_for_member($pm_id);
        	set_new_member_totals_values($pm_id, $exec_labor_info);

			if (Plugins::instance()->isActivePlugin('expenses2')) {
				// Set estimated expense values
				$expenses_info = get_estimated_expense_info_for_member($pm_id);
				set_new_member_totals_values($pm_id, $expenses_info);

				// Set executed expense values
				$exectued_expenses_info = get_executed_expense_info_for_member($pm_id);
        		set_new_member_totals_values($pm_id, $exectued_expenses_info);
			}

			// Update overall values
			update_estimated_overall_totals_for_member($pm_id);
			update_executed_overall_totals_for_member($pm_id);

			// Update invoiced values
			$invoices_info = get_invoice_totals_for_member($pm_id);
       		set_new_member_totals_values($pm_id, $invoices_info);
		}
	}
}
