<?php

function get_member_history_tab_html($genid, $member){
	ob_start();
	render_member_history_tab($genid, $member);
	return ob_get_clean();
}


function render_member_history_tab($genid, $member, $start=0, $limit=10){
	
	if ($member instanceof Member) {
		
		tpl_assign('member', $member);
		tpl_assign('start', $start);
		tpl_assign('limit', $limit);
		
		echo '<div id="'. $genid .'member_history" class="form-tab">';
		
		include get_template_path("member_history_list", "member_history", "advanced_core");
		
		echo '</div>';
	}
	
}


function get_member_history_log_single_html ($log, $member=null) {
	if (!$log instanceof MemberHistory) return "";
	
	if (!$member instanceof Member) {
		$member = Members::findById($log->getMemberId());
	}
	if (!$member instanceof Member) return "";
	
	switch ($log->getType()) {
		// member columns logs
		case 'property':
			break;
			
		// custom property logs
		case 'cp':
			break;
			
		// member association logs
		case 'relation':
			
			$a = DimensionMemberAssociations::findById($log->getProperty());
			if (!$a instanceof DimensionMemberAssociation) return "";
			
			// if not multiple don't show the removed associations
			if ($log->getAction() == 'delete' && !$a->getIsMultiple()) return "";
			
			$assoc_dim_id = $member->getDimensionId() == $a->getDimensionId() ? $a->getAssociatedDimensionMemberAssociationId() : $a->getDimensionId();
			$assoc_dim = Dimensions::findById($assoc_dim_id);
			
			$member_ids = array_filter(explode(',', $log->getValue()));
			if (count($member_ids) == 0) return "";
			
			$members = Members::findAll(array("conditions" => "id IN (".$log->getValue().")"));
			
			
			$dim_mem_path = array($assoc_dim_id => array());
			foreach ($members as $m) {
				$ot_id = $m->getObjectTypeId();
				if (!isset($dim_mem_path[$assoc_dim_id][$ot_id])) $dim_mem_path[$assoc_dim_id][$ot_id] = array();
				$dim_mem_path[$assoc_dim_id][$ot_id][] = $m->getId();
			}
			
			
			$gid = gen_id();
			$member_breadcrumbs_html = '
					<div class="breadcrumb-container" id="breadcrumb-container-'. $gid . '">
						<script>
							var dim_mem_path = \''. json_encode($dim_mem_path).'\';
							var mpath = null;
							if (dim_mem_path){
								mpath = Ext.util.JSON.decode(dim_mem_path);
							}
							var mem_path = "";			
							if (mpath){
								mem_path = og.getEmptyCrumbHtml(mpath, \'.breadcrumb-container\');
							}
							$("#breadcrumb-container-'.$gid.'").html(mem_path);
						</script>
					</div>';
			
			$lang_action_key = $a->getIsMultiple() ? $log->getAction() : "change";
			
			return lang("member history $lang_action_key association with", $assoc_dim->getName()) ."&nbsp;". $member_breadcrumbs_html;
			
			break;
		default:
			return '';
	}
}




function render_view_member_history_pagination($member_id, $current_page, $total_pages, $genid, $limit=10) {
	
	$onclick = "og.member_history_change_page($member_id, [pagenum], '$genid', $limit);";
	
	echo '<div class="pagination">';
	
	if ($current_page > 1) {
		echo '<a class="internalLink pagitem x-tbar-page-first" onclick="'. str_replace("[pagenum]", "1", $onclick) .'">&nbsp;</a>';
		echo '<a class="internalLink pagitem x-tbar-page-prev" onclick="'. str_replace("[pagenum]", ($current_page - 1), $onclick) .'">&nbsp;</a>';
	}

	echo '<span class="pagitem text">'. lang("page") . " $current_page " . strtolower(lang('of')) . " $total_pages" . '</span>';

	if ($current_page < $total_pages) {
		echo '<a class="internalLink pagitem x-tbar-page-next" onclick="'. str_replace("[pagenum]", ($current_page + 1), $onclick) .'">&nbsp;</a>';
		echo '<a class="internalLink pagitem x-tbar-page-last" onclick="'. str_replace("[pagenum]", $total_pages, $onclick) .'">&nbsp;</a>';
	}
	
	echo '</div>';
}
