<?php 
	class MemberHistories extends BaseMemberHistories {
		
		
		function getMemberHistory($member_id, $start=0, $limit=0) {
			
			if (!is_numeric($member_id) || $member_id == 0) return array();
			
			if ($limit > 0) {
				// calculate start and limit dates
				$sql = "SELECT DISTINCT(created_on) FROM ".TABLE_PREFIX."member_history 
						WHERE member_id='$member_id'
						ORDER BY created_on DESC
						LIMIT $start, $limit;";
				$rows = DB::executeAll($sql);
				
				if (count($rows) == 0) return array();
				
				$start_date = $rows[count($rows)-1]['created_on'];
				$end_date = $rows[0]['created_on'];
				
				$date_limits_sql = "AND created_on>='$start_date' AND created_on<='$end_date'";
				
			} else {
				// return all logs
				$date_limits_sql = "";
			}
			
			$logs = $this->findAll(array("conditions" => "member_id='$member_id' $date_limits_sql", "order" => "created_on DESC"));
			
			$total_count = $this->countMemberHistory($member_id);
			
			return array(
				'logs' => $logs,
				'total_count' => $total_count,
				'page' => floor($start / $limit) + 1,
			);
		}
		
		
		function countMemberHistory($member_id) {
			$total_count_row = DB::executeOne("SELECT count(DISTINCT(created_on)) as total FROM ".TABLE_PREFIX."member_history WHERE member_id='$member_id'");
			return array_var($total_count_row, 'total');
		}
		
		
		
		function saveMemberHistory($member, $previous_data, $is_new) {
			
			$log_date = DateTimeValueLib::now();
			
			// save fixed columns changes
			$this->saveMemberColumnsHistory($member, $previous_data, $is_new, $log_date);
			
			// save custom properties changes
			$this->saveMemberCustomPropertiesHistory($member, $previous_data, $is_new, $log_date);
			
			// save member relation changes
			$this->saveMemberRelationsHistory($member, $previous_data, $is_new, $log_date);
			
		}
		
		
		
		function saveMemberColumnsHistory($member, $previous_data, $is_new, $log_date, $user_id=null) {
			// @TODO: save history changes for member columns and its associated object
		}
		
		
		
		function saveMemberCustomPropertiesHistory($member, $previous_data, $is_new, $log_date, $user_id=null) {
			// @TODO: save history changes for member custom properties
		}
		
		
		
		function saveMemberRelationsHistory($member, $previous_data, $is_new, $log_date, $user_id=null) {
			
			if (is_null($user_id)) {
				$user_id = logged_user()->getId();
			}
			
			// direct associations
			$associations = MemberPropertyMembers::getAllAssociatedMemberIds($member->getId());
			// reverse associations
			$reverse_assocs = MemberPropertyMembers::getAllAssociatedMemberIds($member->getId(), true);
			foreach ($reverse_assocs as $a_id => $mem_ids) $associations[$a_id] = $mem_ids;
			
			
			$associations_added = array();
			$associations_removed = array();
			
			if ($is_new) {
				
				// log all associations
				$associations_added = $associations;
				
			} else {
				
				// check which associations have changed and which members have been added/removed
				foreach ($associations as $a_id => $mem_ids) {
					$prev = array_var($previous_data['associations'], $a_id, array());
					$mem_removed = array_diff($prev, $mem_ids);
					$mem_added = array_diff($mem_ids, $prev);
					
					if (is_array($mem_added) && count($mem_added) > 0) {
						$associations_added[$a_id] = $mem_added;
					}
					if (is_array($mem_removed) && count($mem_removed) > 0) {
						$associations_removed[$a_id] = $mem_removed;
					}
					
				}
			}
			
			
			// save added associations history
			foreach ($associations_added as $a_id => $mem_ids) {
				$mem_history = new MemberHistory();
				$mem_history->setMemberId($member->getId());
				$mem_history->setType('relation');
				$mem_history->setProperty($a_id);
				$mem_history->setAction('add');
				$mem_history->setValue(implode(',', $mem_ids));
				$mem_history->setCreatedOn($log_date);
				$mem_history->setCreatedById($user_id);
				$mem_history->save();
			}
			// save removed associations history
			foreach ($associations_removed as $a_id => $mem_ids) {
				$mem_history = new MemberHistory();
				$mem_history->setMemberId($member->getId());
				$mem_history->setType('relation');
				$mem_history->setProperty($a_id);
				$mem_history->setAction('delete');
				$mem_history->setValue(implode(',', $mem_ids));
				$mem_history->setCreatedOn($log_date);
				$mem_history->setCreatedById($user_id);
				$mem_history->save();
			}
			
		}
		
		
	}
 