<?php

$genid = gen_id();


?>
<style>
.dimension-management .section {
	border-bottom: 1px solid #ddd;
	padding-bottom: 10px;
	margin-bottom: 10px;
}
</style>

<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo lang('change members dimension') ?></div>
	</div>
	<div style="padding:5px 0"><?php echo lang('change members dimension desc') ?></div>
</div>

<div class="coInputMainBlock adminMainBlock dimension-management">

<form class="internalForm" method="post" enctype="multipart/form-data" action="<?php echo get_url('dimension_management', 'change_members_dimension') ?>">

	<div id="dummy-section" class="section"></div>
	
	<div class="clear"></div>
	<div id="source-dimension-section" class="section">
		<h1><?php echo lang('select members to move')?></h1>
		<div class="dataBlock">
			<label><?php echo lang('dimension')?></label>
			<?php 
				$options = array(option_tag(lang('none'), 0));
				foreach ($all_dimensions as $dim) {
					$options[] = option_tag($dim->getName(), $dim->getId());
				}
				echo select_box('source_dimension', $options, array('onchange' => "og.advanced_core.dim_management.on_source_dimension_change(this, '$genid');"));
			?>
		</div>
		
		<div class="dataBlock" id="<?php echo $genid?>source_member_selector_container"></div>
	</div>
	
	

	<div class="clear"></div>
	<div id="operation-section" class="section">
		<h1><?php echo lang('settings')?></h1>
		
		<div class="dataBlock">
			<label><?php echo lang('operation')?></label>
			<?php
				$options = array(
					option_tag(lang('move members to destiny dimension'), 'move'),
					option_tag(lang('merge all source members in selected destiny member'), 'merge'),
				);
				echo select_box('operation', $options, array('id' => $genid.'operation_selector', 
						'onchange' => "og.advanced_core.dim_management.on_operation_change(this, '$genid')"));
			?>
		</div>
		
		<div class="dataBlock">
			<label for="keep_source_classficiation_in_parent"><?php echo lang('keep objects classified in parent of source member')?></label>
			&nbsp;&nbsp;<?php echo checkbox_field('keep_source_classficiation_in_parent', true, array('id' => 'keep_source_classficiation_in_parent', 'style' => 'vertical-align:bottom;')); ?>
		</div>
		
		<div class="dataBlock" style="display:none;">
			<label for="include_source_child_members"><?php echo lang('include child members of the source selected members')?></label>
			&nbsp;&nbsp;<?php echo checkbox_field('include_source_child_members', false, array('id' => 'include_source_child_members', 'style' => 'vertical-align:bottom;')); ?>
		</div>
	</div>
	
	
	
	<div class="clear"></div>
	<div id="destiny-dimension-section" class="section">
		<h1><?php echo lang('select destiny')?></h1>
		<div class="dataBlock">
			<label><?php echo lang('dimension and type')?></label>
		<?php 
			$options = array(option_tag(lang('none'), 0));
			foreach ($all_dimensions as $dim) {
				$options[] = option_tag($dim->getName(), $dim->getId());
			}
			echo select_box('destiny_dimension', $options, array('id' => $genid.'destiny_dimension_selector', 
					'onchange' => "og.advanced_core.dim_management.on_destiny_dimension_change(this, '$genid');"));
		?>
		
			<span id="<?php echo $genid?>destiny_type_selector_container"></span>
		</div>
		
		<div class="dataBlock" id="<?php echo $genid?>destiny_member_selector_container"></div>
	</div>
	
	
	<?php echo submit_button(lang('perform changes')); ?></div>
</form>

</div>

<script>

var genid = '<?php echo $genid; ?>';

og.advanced_core.dim_management = {
	
	on_operation_change: function(input, genid) {
		var dim_id = $("#" + genid + "destiny_dimension_selector").val();
		
		if (dim_id > 0) {
			var operation = $(input).val();
			switch (operation) {
				case 'move':
					$("#"+genid+"destiny_type_selector_container").show();
					label = lang('parent member');
					break
				case 'merge':
					$("#"+genid+"destiny_type_selector_container").hide();
					label = lang('merge with');
					break;
				default: break;
			}
			this.render_destiny_member_selector(dim_id, genid, label);
		}
	},
	
	on_source_dimension_change: function(input, genid) {
		var dim_id = $(input).val();
		if (dim_id > 0) {
			og.openLink(og.getUrl('dimension_management', 'render_member_selector', {
				dim_id: dim_id,
				is_multiple: true,
				hf_name: 'source_member_ids',
				label: lang('members to move')
			}), {
				preventPanelLoad: true,
				hideLoading: true,
				callback: function(success, data) {
					if (success) {
						var container_id = genid + 'source_member_selector_container';
						$("#" + container_id).html(data.current.data);
					}
				}
			});
		} else {
			$("#"+genid+"source_member_selector_container").html('');
		}
	},


	on_destiny_dimension_change: function(input, genid) {
		var dim_id = $(input).val();
		this.render_destiny_member_type_combo(dim_id, genid);
	},

	on_destiny_member_type_change: function(input, genid) {
		var dim_id = $(input).val();
		if (dim_id > 0) {
			var ot_id = $("#destiny_member_type").val();
			// poner este ot_id como el member type válido luego de seleccionar un miembro.
		}
	},

	render_destiny_member_type_combo: function(dim_id, genid) {

		$("#"+genid+"destiny_type_selector_container").html('');
		
		if (dim_id > 0 && og.dimension_object_type_descendants[dim_id]) {

			// render member type selector
			var s = $('<select id="destiny_member_type" name="destiny_member_type" onchange="og.advanced_core.dim_management.on_destiny_member_type_change(this,\''+genid+'\')"/>');
			var first = true;
			for (type_id in og.dimension_object_type_descendants[dim_id]) {
				var ot = og.objectTypes[type_id];
				if (ot) {
					var type_text = lang(ot.name);
					if (ot.name == 'customer_folder' || ot.name == 'project_folder') {
						type_text = ot.name;
					}
					var opt_config = {value: type_id, text: type_text};
					if (first) opt_config.selected = 'selected';
					$("<option />", opt_config).appendTo(s);
					first = false;
				}
			}
			s.appendTo("#"+genid+"destiny_type_selector_container");

			var operation = $("#"+genid+"operation_selector").val();
			if (operation == 'merge') {
				$("#"+genid+"destiny_type_selector_container").hide();
			} else {
				$("#"+genid+"destiny_type_selector_container").show();
			} 

			// render member selector
			var mem_sel_label = operation == 'merge' ? lang('merge with') : lang('parent member');
			this.render_destiny_member_selector(dim_id, genid, mem_sel_label);
			
		} else {
			$("#"+genid+"destiny_member_selector_container").html('');
		}
	},

	render_destiny_member_selector: function(dim_id, genid, label) {

		og.openLink(og.getUrl('dimension_management', 'render_member_selector', {
			dim_id: dim_id,
			is_multiple: 0,
			hf_name: 'destiny_member_id',
			label: label
		}), {
			preventPanelLoad: true,
			hideLoading: true,
			callback: function(success, data) {
				if (success) {
					var container_id = genid + 'destiny_member_selector_container';
					$("#" + container_id).html(data.current.data);
				}
			}
		});

		this.on_destiny_member_type_change($("#"+genid+"destiny_dimension_selector"), genid);
	}
}

</script>