<?php 
	$genid = gen_id();
	$formId = "$genid-save-dimension-options";
	$action = get_url('dimension_options', 'dimension_options_submit');
	
	// use the same genid in subviews
	tpl_assign('genid', $genid);
?>


<div class="dimensionOptionsConfiguration">


<div class="adminMainBlock">
	<div class="coInputHeader">
		<table><tr><td>
		  <div class="coInputHeaderUpperRow">
			<div class="coInputTitle">
				<?php echo lang('dimension options') ?>
			</div>
			<div class="desc" style="margin-top:10px;"><?php echo lang('dimension options desc'); ?></div>
		  </div>
		</td><td>
		  <div class="coInputButtons"><?php echo submit_button(lang('save changes'), null, array('style' => 'margin:0;' , 'id' => $genid.'_top_submit')) ?></div>
		</td></tr></table>
	
		<div class="clear"></div>
	</div>
	
	<div class="coInputMainBlock adminMainBlock">
		<form method="post" enctype="multipart/form-data" id="<?php echo $formId ?>" action="<?php echo $action?>">
		
		  <div class="section">
		
			<h1><?php echo lang('dimension names') ?></h1>
			<div class="description desc"><?php echo lang('dimension names desc')?></div>
			<table class="bordered">
				<tr><th><?php echo lang('default name')?></th><th><?php echo lang('custom name')?></th></tr>
				<?php 
				$isAlt = true;
				foreach ($custom_dimension_names as $dimension_id => $custom_dimension_name) {
					$isAlt = !$isAlt;
					$dimension = Dimensions::getDimensionById($dimension_id);
					if (!$dimension instanceof Dimension) continue;
					
					$default_name = lang($dimension->getCode());
					Hook::fire("edit_dimension_name", array('dimension' => $dimension), $default_name);
				?>
				<tr class="<?php echo ($isAlt ? 'altRow ' : '') ?>">
				
					<td><?php echo $default_name ?></td>
					
					<td><?php echo text_field('custom_names['.$dimension_id.']', $custom_dimension_name, array('class' => 'long')) ?></td>
					
				</tr>
				<?php 
				}
				?>
			</table>
		  </div>
		  
		  <div class="section">
		  	<h1><?php echo lang('member names') ?></h1>
		  	<div class="description desc"><?php echo lang('member names desc')?></div>
	  		<table class="bordered">
				<tr><th><?php echo lang('dimension')?></th><th><?php echo lang('type')?></th><th class="center"><?php echo lang('custom name')?></th><th class="center"><?php echo lang('custom name plural')?></th></tr>
				<?php 
				$last_dim = 0;
				$isAlt = true;
				foreach ($dimension_ots as $dimension_ot) {
					$dim_changed = $last_dim != $dimension_ot->getDimensionId();
					if ($dim_changed) {
						$isAlt = !$isAlt;
					}
					$dimension = Dimensions::getDimensionById($dimension_ot->getDimensionId());
					if (!$dimension instanceof Dimension || !$dimension->getIsManageable()) continue;
					
					$dimension_name = $dimension->getName();
					
					$ot = ObjectTypes::findById($dimension_ot->getObjectTypeId());
					if (!$ot instanceof ObjectType || in_array($ot->getName(), array('customer_folder', 'project_folder'))) continue;
					$ot_name = lang($ot->getName());
				?>
				<tr class="<?php echo ($isAlt ? 'altRow ' : '') . ($dim_changed ? 'bordered-top' : '') ?>">
				
					<td><?php echo $dim_changed ? $dimension_name : ""?></td>
					
					<td><span class="link-ico <?php echo $ot->getIconClass()?>"><?php echo $ot_name ?></span></td>
					
					<td class="center"><?php
					   $custom_ot_name = trim( Members::getCustomMemberNameToShow($dimension_ot->getDimensionId(), $dimension_ot->getObjectTypeId()));

					   echo text_field('custom_ot_names['.$dimension_ot->getDimensionId().']['.$dimension_ot->getObjectTypeId().']', $custom_ot_name, array('class' => 'long'));
						
					?></td>
					
					<td class="center"><?php
					   $custom_ot_name_plural = trim( Members::getCustomMemberNameToShow($dimension_ot->getDimensionId(), $dimension_ot->getObjectTypeId(), true));

					   echo text_field('custom_ot_names_plural['.$dimension_ot->getDimensionId().']['.$dimension_ot->getObjectTypeId().']', $custom_ot_name_plural, array('class' => 'long'));
						
					?></td>
				</tr>
				<?php
					$last_dim = $dimension_ot->getDimensionId();
				}
				?>
			</table>		  
		  </div>
		  
		  <div class="section">
		  
			<h1><?php echo lang('enable or disable dimension types') ?></h1>
			<div class="description desc"><?php echo lang('enable or disable dimension types desc')?></div>
			<table class="bordered">
				<tr><th><?php echo lang('dimension')?></th><th><?php echo lang('type')?></th><th class="center"><?php echo lang('status')?></th></tr>
				<?php 
				$last_dim = 0;
				$isAlt = true;
				foreach ($dimension_ots as $dimension_ot) {
					$dim_changed = $last_dim != $dimension_ot->getDimensionId();
					if ($dim_changed) {
						$isAlt = !$isAlt;
					}
					$dimension = Dimensions::getDimensionById($dimension_ot->getDimensionId());
					if (!$dimension instanceof Dimension || !$dimension->getIsManageable()) continue;
					
					$dimension_name = $dimension->getName();
					
					$ot = ObjectTypes::findById($dimension_ot->getObjectTypeId());
					if (!$ot instanceof ObjectType || in_array($ot->getName(), array('customer_folder', 'project_folder'))) continue;
					$ot_name = lang($ot->getName());
				?>
				<tr class="<?php echo ($isAlt ? 'altRow ' : '') . ($dim_changed ? 'bordered-top' : '') ?>">
				
					<td><?php echo $dim_changed ? $dimension_name : ""?></td>
					
					<td><span class="link-ico <?php echo $ot->getIconClass()?>"><?php echo $ot_name ?></span></td>
					
					<td class="center"><?php
						$input_id = $genid."_".$dimension_ot->getDimensionId()."_".$dimension_ot->getObjectTypeId();
						echo yes_no_widget('enabled_dots['.$dimension_ot->getDimensionId().']['.$dimension_ot->getObjectTypeId().'][enabled]', $input_id, $dimension_ot->getEnabled(), lang('enabled'), lang('disabled'));
					?></td>
				</tr>
				<?php
					$last_dim = $dimension_ot->getDimensionId();
				}
				?>
			</table>
		  </div>
		  
		  
		  
		  <div class="section">
		  
			<h1><?php echo lang('dimension association options') ?></h1>
			<div class="description desc"><?php echo lang('dimension association options desc')?></div>
			<table class="bordered">
				<tr><th style="min-width:120px;"><?php echo lang('dimension')?></th>
					<th style="min-width:120px;"><?php echo lang('type')?></th>
					<th><?php echo lang('associated to')?></th><th><?php echo lang('option')?></th><th></th></tr>
				<?php 
				
				$last_dim = 0;
				$isAlt = true;
				foreach ($associations as $a) { /* @var $a DimensionMemberAssociation */
					$dim_changed = $last_dim != $a->getDimensionId();
					if ($dim_changed) {
						$isAlt = !$isAlt;
					}
					$dimension = Dimensions::getDimensionById($a->getDimensionId());
					if (!$dimension instanceof Dimension || !$dimension->getIsManageable()) continue;
					
					$dimension_name = $dimension->getName();
					
					$ot = ObjectTypes::findById($a->getObjectTypeId());
					if (!$ot instanceof ObjectType || in_array($ot->getName(), array('customer_folder', 'project_folder'))) continue;
					$ot_name = lang($ot->getName());
					
					$assoc_ot = ObjectTypes::findById($a->getAssociatedObjectType());
					$assoc_ot_name = lang($assoc_ot->getName());
				?>
				<tr class="<?php echo ($isAlt ? 'altRow ' : '') . 'bordered-top' ?>" style="font-weight:bold;">
				
					<td><?php echo $dim_changed ? $dimension_name : ""?></td>
					<td><span class="link-ico <?php echo $ot->getIconClass()?>"><?php echo $ot_name ?></span></td>
					
					<td><?php echo $assoc_ot_name ?></td>
					<td></td>
					<td></td>
					
				</tr>
				<?php
					$association_configs = $a->getConfig();
					$association_config_types = $a->getConfigTypes();
					foreach ($association_configs as $key => $value) {
					?>
					<tr class="<?php echo ($isAlt ? 'altRow ' : '') ?>">
					  <td></td>
					  <td></td>
					  <td></td>
					  <td>
					  	<div title="<?php echo lang('dim assoc config desc '.$key, $ot_name, $assoc_ot_name)?>">
					  		<?php echo lang('dim assoc config name '.$key, $ot_name, $assoc_ot_name)?></div>
					  </td>
					  <td class="center"><?php
					  $input_id = $genid."_".$a->getId()."_".$key;
					  
					  if (array_var($association_config_types, $key) == 'boolean') {
					  	$bool_value = is_numeric($value) ? $value > 0 : (bool)$value;
						echo yes_no_widget('assoc_config_option['.$a->getId().']['.$key.']', $input_id, $bool_value, lang('yes'), lang('no'));
					  
					  } else if (array_var($association_config_types, $key) == 'text') {
					  	echo text_field('assoc_config_option['.$a->getId().']['.$key.']', $value);
					  }
					?></td>
					</tr>
				<?php 
					}
				
					$last_dim = $a->getDimensionId();
				}
				?>
			</table>
		  </div>
				
		  <?php 
		  $this->includeTemplate(get_template_path('admin_dimension_selectors', 'dimension_options', 'advanced_core'));
		  ?>
		  
		  <?php 
		  $this->includeTemplate(get_template_path('dimension_default_values', 'dimension_options', 'advanced_core'));
		  ?>
		  
			<?php echo submit_button(lang('save changes')) ?>
		</form>
	</div>
</div>
</div>

<script>
$(function(){
	$(".dimensionOptionsConfiguration .coInputMainBlock table").css('min-width', '500px').css('margin', '15px 0');
	$(".dimensionOptionsConfiguration .coInputMainBlock .dimension-selector-container .x-toolbar.x-small-editor table").css('min-width', '300px').css('margin', '0');
	$(".dimensionOptionsConfiguration .coInputMainBlock .dimension-selector-container").css('width', 'auto').css('margin', '0');

	$("#<?php echo $genid?>_top_submit").click(function(){
		$("#<?php echo $formId?>").submit();
	});
});
</script>