
<div style="display:none;" id="<?php echo $genid?>_property_selectbox_template">
<?php
	$options = array();
	foreach ($properties as $id => $propname) {
		$options[] = option_tag($propname, $id);
	}
	echo select_box('property_selector', $options, array('id' => $genid.'_property_selector'));
?>
</div>


<?php
$loc = user_config_option('localization');
if (strlen($loc) > 2) $loc = substr($loc, 0, 2);

$sections = array('top','left','right','bottom');
?>
<div id="<?php echo $genid?>_print_options" class="print-options">

	<div id="header-container">
		<div class="editor-title"><?php echo lang('header')?></div>
		<div id="<?php echo $genid ?>ckcontainer">
			<textarea id="<?php echo $genid ?>_header_editor" name="header_content"><?php echo clean($header_content) ?></textarea>
		</div>
	</div>

<?php foreach ($sections as $section) {
		if ($section == 'bottom') {
			echo '<div class="clear"></div>';
		}
?>

	<div id="<?php echo $section ?>" class="position <?php echo $section ?>">
		<div class="position-title"><?php echo lang($section)?></div>
		<div class="position-values <?php echo $section ?>">
		<?php 
		foreach ($object_print_options as $option) {
			if ($option->getPosition() == $section) {
				if (is_numeric($option->getProperty()) && $option->getProperty()==0) continue;
				?><div id="prop-<?php echo $option->getProperty()?>" class="property"><?php
				if (is_numeric($option->getProperty())) {
					$cp = CustomProperties::findById($option->getProperty());
					echo $cp->getName();
				} else {
					echo lang('field '.$object_type->getHandlerClass(). ' ' . $option->getProperty());
				}
				?></div><?php
			}
		} ?>
		</div>
		<div class="actions">
			<a class="link-ico ico-add" href="#" onclick="og.printOptionsAddPropertyToSection(this, '<?php echo $genid?>');"><?php echo lang('add a property to this section')?></a>
		</div>
	</div>
	
<?php } ?>
	
	<div id="footer-container">
		<div class="editor-title"><?php echo lang('footer')?></div>
		<div id="<?php echo $genid ?>ckcontainer">
			<textarea id="<?php echo $genid ?>_footer_editor" name="footer_content"><?php echo clean($footer_content) ?></textarea>
		</div>
	</div>
	
</div>

<script>
$(function() {
	
	$( ".position-values" ).sortable({
		connectWith: ".position-values"
	}).disableSelection();

	var header_editor = CKEDITOR.replace('<?php echo $genid ?>_header_editor', {
    	height: '100px',
    	allowedContent: true,
    	resize_enabled: false,
    	enterMode: CKEDITOR.ENTER_BR,
    	shiftEnterMode: CKEDITOR.ENTER_BR,
    	disableNativeSpellChecker: false,
    	language: '<?php echo $loc ?>',
    	customConfig: '',
    	contentsCss: ['<?php echo get_javascript_url('ckeditor/contents.css').'?rev='.product_version_revision();?>', '<?php echo get_stylesheet_url('og/ckeditor_override.css').'?rev='.product_version_revision();?>'],
    	toolbar: [ ['Bold','Italic','Underline','Strike','-',
					 'Source', '-', 'Font','FontSize','-', 'Blockquote','-',
					 'SpellChecker', 'Scayt','-', 'NumberedList','BulletedList','-',
					 'TextColor','BGColor','RemoveFormat','-', 'Link','Unlink','-',
					 'JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'
				] ],
        on: {
                instanceReady: function(ev) {
                        og.adjustCkEditorArea('<?php echo $genid ?>');
                        header_editor.resetDirty();
                }
        },
        fillEmptyBlocks: false,
		removePlugins: 'scayt,liststyle,magicline',
		entities_additional : '#39,#336,#337,#368,#369,#124'
    });

	var footer_editor = CKEDITOR.replace('<?php echo $genid ?>_footer_editor', {
    	height: '100px',
    	allowedContent: true,
    	resize_enabled: false,
    	enterMode: CKEDITOR.ENTER_BR,
    	shiftEnterMode: CKEDITOR.ENTER_BR,
    	disableNativeSpellChecker: false,
    	language: '<?php echo $loc ?>',
    	customConfig: '',
    	contentsCss: ['<?php echo get_javascript_url('ckeditor/contents.css').'?rev='.product_version_revision();?>', '<?php echo get_stylesheet_url('og/ckeditor_override.css').'?rev='.product_version_revision();?>'],
    	toolbar: [ ['Bold','Italic','Underline','Strike','-',
					 'Source', '-', 'Font','FontSize','-', 'Blockquote','-',
					 'SpellChecker', 'Scayt','-', 'NumberedList','BulletedList','-',
					 'TextColor','BGColor','RemoveFormat','-', 'Link','Unlink','-',
					 'JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'
				] ],
        on: {
                instanceReady: function(ev) {
                        og.adjustCkEditorArea('<?php echo $genid ?>');
                        footer_editor.resetDirty();
                }
        },
        fillEmptyBlocks: false,
		removePlugins: 'scayt,liststyle,magicline',
        entities_additional : '#39,#336,#337,#368,#369,#124'
    });
});
</script>