<?php

	Env::useHelper('time_weekly_functions', 'advanced_core');
	$users = get_users_for_the_combo_in_weekly_view();
	$user_id = $current_filters['weekly_user_id'];
	$user_date_format = user_config_option('date_format');
	$from_date_input = $current_filters['from_date'];
	$until_date_input = $current_filters['until_date'];
	$selected_task_ids = json_encode($weekly_data['selected_task_ids']);
	$projects_with_no_tasks_rows = json_encode($weekly_data['projects_with_no_tasks_rows']);
	$has_project_selected = $weekly_data['has_project_selected'];
	$selected_project_member_id = '['.$weekly_data['selected_project_member_id'].']';

	$from_date = DateTimeValueLib::dateFromFormatAndString("Y-m-d", $current_filters['from_date']);
	$until_date = DateTimeValueLib::dateFromFormatAndString("Y-m-d", $current_filters['until_date']);
	$date_range = $from_date->format($user_date_format) . ' - ' . $until_date->format($user_date_format);
	$weekly_panel_style = user_config_option('time_list_view') == 'weekly' ? '' : "display:none;";

	$projects_dim = Dimensions::findByCode('customer_project');
	$dimension_id = $projects_dim->getId();

?>
<div id="time-panel_timeslots_module_weekly_container" style="<?php echo $weekly_panel_style; ?>">

	<div id="<?php echo $genid ?>weekly-toolbar-container" class="x-panel-tbar"></div>

	<input type="hidden" id="<?php echo $genid ?>weekly-from-date" value="<?php echo $from_date_input; ?>" />
	<input type="hidden" id="<?php echo $genid ?>weekly-until-date" value="<?php echo $until_date_input; ?>" />
	<input type="hidden" id="<?php echo $genid ?>weekly-user-id" value="<?php echo $user_id; ?>" />
	<input type="hidden" id="<?php echo $genid ?>selected-task-ids" value="<?php echo $selected_task_ids; ?>" />
	<input type="hidden" id="<?php echo $genid ?>project-ids-with-no-tasks" value="<?php echo $projects_with_no_tasks_rows; ?>" />
	<input type="hidden" id="<?php echo $genid ?>member-selector-genid" value="" />
	<input type="hidden" id="<?php echo $genid ?>has-project-selected" value="<?php echo $has_project_selected; ?>" />
	<input type="hidden" id="<?php echo $genid ?>selected_project_member_id" value="<?php echo $selected_project_member_id; ?>" />
	<div id="<?php echo $genid ?>main-weekly-div">
		<?php echo $weekly_html; ?>
	</div>

</div>

<script>
	var from_date = $('#<?php echo $genid ?>weekly-from-date').val();
	var until_date = $('#<?php echo $genid ?>weekly-until-date').val();
	var date_range = <?php echo json_encode($date_range); ?>;
	var user_date_format = <?php echo json_encode($user_date_format); ?>;
	var genid = <?php echo json_encode($genid); ?>;
	var initial_user_id = <?php echo $user_id; ?>;
	var user_options = [];
	<?php foreach ($users as $user) {
		$user_display_name = clean(escape_character(str_replace("\\'", "'", $user->getObjectName())));
		?>
		user_options.push([<?php echo $user->getId() ?>, '<?php echo $user_display_name; ?>']);	
	<?php } ?>


	// Close open popovers, except the one that is clicked
	og.closeOtherPopover  = function(this_obj){
		var compare_id = this_obj.id + "_btn";
		$('[data-toggle="popover"]').each(function() {
			if(compare_id != $(this).attr('id')){
				$(this).popover('hide');
			}
		}); 
	} 

	og.clearTime = function(this_obj){
		var input_id = "#"+this_obj.id;
		if($(input_id).val() == '00:00'){
			$(input_id).val('');
			$(input_id).attr('class','weekly--time-input');
		}
	}

	og.checkTimeValue = function(this_obj){
		var input_id = "#"+this_obj.id;
		if($(input_id).val() == ''){
			$(input_id).val('00:00');
			$(input_id).attr('class','weekly--time-input-grey');
		}else if($(input_id).val() == '00:00'){
			$(input_id).attr('class','weekly--time-input-grey');
		}else{
			$(input_id).attr('class','weekly--time-input');
		}

	}

	// Add popover to description buttons
	og.addPopoverToDescriptionButtons = function(){
		$(document).ready(function(){
			$('[data-toggle="popover"]').popover({
				html: true,
				sanitize: false,
			});   
		});
	}
	og.addPopoverToDescriptionButtons();

	
	
	// toolbar items
	var weekly_toolbar_items = [

		new Ext.Button({
			iconCls: 'ico-properties',
			text: '<?php echo lang('list view') ?>',
			id: 'list_view_btn',
			handler: function () {
				og.time_weekly_view.switch_interface('');
			}
		}),

		new Ext.Action({
			tooltip: lang('prev'),
			iconCls: 'ico-prevmonth',
			handler: function() {
				// Set previous week dates 
				var userId = $('#<?php echo $genid ?>weekly-user-id').val();
				var fromDate = new Date($('#<?php echo $genid ?>weekly-from-date').val());
				var untilDate = new Date($('#<?php echo $genid ?>weekly-until-date').val());
				fromDate.setUTCDate(fromDate.getUTCDate() - 7);
				untilDate.setUTCDate(untilDate.getUTCDate() - 7);
				fromDateFormatted = fromDate.toISOString().split('T')[0];
				untilDateFormatted = untilDate.toISOString().split('T')[0];
				$('#<?php echo $genid ?>weekly-from-date').val(fromDateFormatted);
				$('#<?php echo $genid ?>weekly-until-date').val(untilDateFormatted);
				
				var dateRange = Ext.getCmp('weeklyToolbarDateRange');
				og.openLink(og.getUrl('time_weekly', 'format_date_range_for_weekly_view', {from_date: fromDateFormatted, until_date: untilDateFormatted}), {
					callback: function(success, data) {
						dateRange.setText(data.range);
					}
				});

				og.openLink(og.getUrl('time_weekly', 'get_data_for_time_weekly_view', {genid: genid, from_date: fromDateFormatted, until_date: untilDateFormatted, user_id: userId}), {
					callback: function(success, data) {
						og.updage_weekly_html_and_hidden_inputs(data);
					}
				});
			}
		}),

		new Ext.Action({
			text: date_range,
			id: 'weeklyToolbarDateRange',
			xtype: 'tbtext',
		}),

		new Ext.Action({
			tooltip: lang('next'),
			iconCls: 'ico-nextmonth',
			handler: function() {
				var userId = $('#<?php echo $genid ?>weekly-user-id').val();
				var fromDate = new Date($('#<?php echo $genid ?>weekly-from-date').val());
				var untilDate = new Date($('#<?php echo $genid ?>weekly-until-date').val());
				fromDate.setUTCDate(fromDate.getUTCDate() + 7);
				untilDate.setUTCDate(untilDate.getUTCDate() + 7);
				fromDateFormatted = fromDate.toISOString().split('T')[0];
				untilDateFormatted = untilDate.toISOString().split('T')[0];
				$('#<?php echo $genid ?>weekly-from-date').val(fromDateFormatted);
				$('#<?php echo $genid ?>weekly-until-date').val(untilDateFormatted);

				var dateRange = Ext.getCmp('weeklyToolbarDateRange');
				og.openLink(og.getUrl('time_weekly', 'format_date_range_for_weekly_view', {from_date: fromDateFormatted, until_date: untilDateFormatted}), {
					callback: function(success, data) {
						dateRange.setText(data.range);
					}
				});
				
				og.openLink(og.getUrl('time_weekly', 'get_data_for_time_weekly_view', {genid: genid, from_date: fromDateFormatted, until_date: untilDateFormatted, user_id: userId}), {
					callback: function(success, data) {
						og.updage_weekly_html_and_hidden_inputs(data);
					}
				});
			}
		}),

		new Ext.Button({
			text: '<?php echo lang('current week') ?>',
			handler: function() { 
				var userId = $('#<?php echo $genid ?>weekly-user-id').val();
				og.openLink(og.getUrl('time_weekly', 'get_current_week_date_range_for_weekly', {user_id: userId}), {
					callback: function(success, data) {
						var fromDateFormatted = data.from;
						var untilDateFormatted = data.until;
						
						$('#<?php echo $genid ?>weekly-from-date').val(fromDateFormatted);
						$('#<?php echo $genid ?>weekly-until-date').val(untilDateFormatted);
						
						var dateRange = Ext.getCmp('weeklyToolbarDateRange');
						og.openLink(og.getUrl('time_weekly', 'format_date_range_for_weekly_view', {from_date: fromDateFormatted, until_date: untilDateFormatted}), {
							callback: function(success, data) {
								dateRange.setText(data.range);
							}
						});

						og.openLink(og.getUrl('time_weekly', 'get_data_for_time_weekly_view', {genid: genid, from_date: fromDateFormatted, until_date: untilDateFormatted, user_id: userId}), {
							callback: function(success, data) {
								og.updage_weekly_html_and_hidden_inputs(data);
							}
						});
					}
				});
			}
		}),

		new Ext.form.ComboBox({
			id: 'weekly_person_id',
			store: new Ext.data.SimpleStore({
				fields: ['value', 'text'],
				data : user_options
			}),
			displayField: 'text',
			mode: 'local',
			triggerAction: 'all',
			selectOnFocus: true,
			width: 150,
			value: initial_user_id,
			valueField: 'value',
			valueNotFoundText: '',
			//grid_id: config.grid_id,
			listeners: {
				'select' : function(combo, record) {
						var new_user_id = combo.getValue();
						$('#<?php echo $genid ?>weekly-user-id').val(new_user_id);

						var fromDate = new Date($('#<?php echo $genid ?>weekly-from-date').val());
						var untilDate = new Date($('#<?php echo $genid ?>weekly-until-date').val());
						fromDateFormatted = fromDate.toISOString().split('T')[0];
						untilDateFormatted = untilDate.toISOString().split('T')[0];
				
						og.openLink(og.getUrl('time_weekly', 'get_data_for_time_weekly_view', {genid: genid, from_date: fromDateFormatted, until_date: untilDateFormatted, user_id: new_user_id}), {
							callback: function(success, data) {
								og.updage_weekly_html_and_hidden_inputs(data);
							}
						});
				},
			}
		}),

	];


	og.closePopovers = function(){
		$('[data-toggle="popover"]').popover('hide');
	}

	og.updateTimeFromWeekly = function(this_obj){
		var time_info = this_obj.id;
		var userId = $('#<?php echo $genid ?>weekly-user-id').val();
		var time_input = $('#'+time_info);
		var prev_value = time_input.attr('prevvalue');
		var time_value = time_input.val();
		var is_valid = og.checkTimeEntryPattern(time_value);

		if(!is_valid){
			var other_valid_results = og.checkOtherTimePatterns(time_value);
			is_valid = other_valid_results['is_valid'];
			time_value = other_valid_results['updated_value'];
			if(is_valid){
				time_input.val(time_value);
			} else {
				time_input.val(prev_value);
				return;
			}
		}
		if(is_valid && time_value.length == 4){
			time_value = '0' + time_value;
			time_input.val(time_value);
		}
		// Abort the update if the new value is the same as previous
		if(prev_value == time_value) return;

		// Confirm if the user wants to delete the time entry
		if(time_value == '00:00' && !confirm(lang('confirm delete time'))) {
			time_input.val(prev_value);
			//time_input.attr("class","weekly--time-input-gray");
			return;
		}

		og.openLink(og.getUrl('time_weekly', 'update_time_from_time_weekly_view', {genid: genid, time_info: time_info, user_id: userId, time_value: time_value,  multiple: false}), {
			callback: function(success, data) {
				if(data.new_time_added || data.deleted_timeslot){
					time_input.attr('id', data.new_view_time_hours_id);
					time_input.attr('prevvalue', time_value);

					// Update description button and content
					if(data.new_time_added){
						$('#' + data.popover_id + ' .weekly--desc-button').attr('data-toggle', 'popover');
						$('#' + data.popover_id + ' .weekly--desc-button').attr('data-content', data.description_input);
					} else if(data.deleted_timeslot) {
						$('#' + data.popover_id + ' .weekly--desc-button').removeAttr('data-toggle');
						$('#' + data.popover_id + ' .weekly--desc-button').attr('data-content', data.description_input);
						$('#' + data.popover_id + ' .weekly--desc-button').popover('disable');
					}
					$('#' + data.popover_id + ' .weekly-time-with-desc path').attr('fill', data.desc_btn_color);
					if(data.new_time_added){
						$('#' + data.popover_id + ' .weekly--desc-button').popover({
							html: true,
							sanitize: false
						}); 
						$('#' + data.popover_id).attr('timeId', data.new_view_time_hours_id); 
						$('#' + data.popover_id + ' .weekly--desc-button').popover('enable');
					}
					og.updateTotalsAfterTimeChange(data.new_view_time_hours_id, false);
				} else {
					og.updateTotalsAfterTimeChange(time_info, false);
					time_input.attr('prevvalue', time_value);

				}
			}
		});
	}

	og.updage_weekly_html_and_hidden_inputs = function(data) {
		var weekly_div = $('#<?php echo $genid ?>main-weekly-div');
		weekly_div.html(data.weekly_html);
		og.addPopoverToDescriptionButtons();
		og.updateProjectSelector();
		// update selected task ids
		var selectedTaskIds = data.weekly_data.selected_task_ids;
		var stringSelectedTaskIds = '[' + selectedTaskIds.toString() + ']';
		$('#'+genid+'selected-task-ids').val(stringSelectedTaskIds);
		// update project member ids list with no task
		var selecterProjectIdsWithNoTasks = data.weekly_data.projects_with_no_tasks_rows;
		var stringSelecterProjectIdsWithNoTasks = '[' + selecterProjectIdsWithNoTasks.toString() + ']';
		$('#'+genid+'project-ids-with-no-tasks').val(stringSelecterProjectIdsWithNoTasks);
	}


	og.updateTimeFromWeeklyDescDiv = function(this_obj){
		var time_info = this_obj.id;
		var userId = $('#<?php echo $genid ?>weekly-user-id').val();
		var time_input = $('#'+time_info);
		var prev_value = time_input.attr('prevvalue');
		var time_value = time_input.val();
		var is_valid = og.checkTimeEntryPattern(time_value);
		
		if(!is_valid){
			var other_valid_results = og.checkOtherTimePatterns(time_value);
			is_valid = other_valid_results['is_valid'];
			time_value = other_valid_results['updated_value'];
			if(is_valid){
				time_input.val(time_value);
			} else {
				time_input.val(prev_value);
				return;
			}
		}
		if(is_valid && time_value.length == 4){
			time_value = '0' + time_value;
			time_input.val(time_value);
		}
		// Abort the update if the new value is the same as previous
		if(prev_value == time_value) return;

		// Confirm if the user wants to delete the time entry
		if(time_value == '00:00' && !confirm(lang('confirm delete time'))) {
			time_input.val(prev_value);
			return;
		}

		og.openLink(og.getUrl('time_weekly', 'update_time_from_time_weekly_view', {genid: genid, time_info: time_info, user_id: userId, time_value: time_value, multiple: true}), {
			callback: function(success, data) {
				var action = data.new_time_added ? 'add' : data.deleted_timeslot ? 'delete' : 'edit';
				if(data.new_time_added ){
					time_info = data.new_view_time_hours_id;
					time_input.attr('id', time_info);
					time_input.attr('prevvalue', time_value);
				} 
				og.updateTotalsAfterTimeChange(time_info, true);

				og.openLink(og.getUrl('time_weekly', 'get_updated_time_and_desc_input_after_mult_time_change', {genid: genid, time_info: time_info, user_id: userId, action: action}), {
					callback: function(success, multi_data) {

						if(data.new_time_added){
							$('#' + multi_data.popover_id + ' .popover-content').html(multi_data.description_content);
							$('#' + multi_data.popover_id  + ' .weekly--desc-button').attr('data-content', multi_data.description_content);
							$('#' + multi_data.popover_id + ' .weekly--desc-button').popover({
								html: true,
								sanitize: false
							}); 
							if(multi_data.count_timeslots == 2){

								var time_id = $('#' + multi_data.popover_id).attr('timeId');
								$('#' + time_id).attr('id', multi_data.multi_time_input_id);
								$('#' + multi_data.multi_time_input_id).attr('disabled', 'disabled');
								$('#' + multi_data.multi_time_input_id).val(multi_data.formatted_time_value);
								$('#' + multi_data.multi_time_input_id).attr('prevvalue', multi_data.formatted_time_value);
								$('#' + multi_data.multi_time_input_id).attr('readonly', 'readonly');
								$('#' + multi_data.multi_time_input_id).attr('onclick', "og.loadTimeInputPopover("+'"'+time_id+'"'+")");
							
								// Change icon to 3 lines
								$('#' + multi_data.popover_id).html(multi_data.description_button);
								$('#' + multi_data.popover_id + ' .weekly--desc-button').popover({
									html: true,
									sanitize: false
								});  
								$('#' + multi_data.popover_id  + ' .weekly--desc-button').popover('show');
							}
						}
						if(action == 'edit'){
							$('#' + multi_data.popover_id  + ' .weekly--desc-button').attr('data-content', multi_data.description_content);
							$('#' + multi_data.popover_id + ' .weekly--desc-button').popover({
								html: true,
								sanitize: false
							});  
							
							// Update the edited time input and prev value with rounded value
							var getTime = multi_data.description_content.split("id='"+this_obj.id+"' type='text' value='");
							getTime = getTime[1].split("'");
							$("#"+this_obj.id).val(getTime[0]);
							$('#'+this_obj.id).attr('prevvalue',getTime[0]);


						} else if(action == 'delete'){
							$('#' + multi_data.popover_id  + ' .weekly--desc-button').popover('hide');
							$('#' + multi_data.popover_id).html(multi_data.description_button);
							$('#' + multi_data.popover_id + ' .weekly--desc-button').popover({
								html: true,
								sanitize: false
							});  
							$('#' + multi_data.popover_id  + ' .weekly--desc-button').popover('show');
							if(multi_data.count_timeslots == 1){
								$('#' + multi_data.multi_time_input_id).attr('id', multi_data.time_input_id);
								$('#' + multi_data.time_input_id).removeAttr('readonly');
								$('#' + multi_data.time_input_id).removeAttr('onclick');
								$('#' + multi_data.popover_id).attr('timeId', multi_data.time_input_id);
							}

						}

					}
				});
			}
		});
	}


	og.updateTotalsAfterTimeChange = function(time_info, multiple_time){
		var userId = $('#<?php echo $genid ?>weekly-user-id').val();
		var fromDate = new Date($('#<?php echo $genid ?>weekly-from-date').val());
		var untilDate = new Date($('#<?php echo $genid ?>weekly-until-date').val());
		fromDateFormatted = fromDate.toISOString().split('T')[0];
		untilDateFormatted = untilDate.toISOString().split('T')[0];
		og.openLink(og.getUrl('time_weekly', 'get_updated_totals_for_weekly_view', {genid: genid, time_info: time_info, user_id: userId, from_date: fromDateFormatted, until_date: untilDateFormatted}), {
			callback: function(success, data) {
				if(multiple_time){
					$('#'+data.task_day_total_id).val(data.task_day_total);
					$('#'+data.task_day_total_id).attr('prevvalue', data.task_day_total);
				}
				$('#'+time_info).val(data.task_day_total);
				$('#'+time_info).attr('prevvalue',data.task_day_total);

				$('#'+data.task_total_id).html(data.task_total);
				$('#'+data.day_total_id).html(data.day_total);
				$('#'+data.grand_total_id).html(data.grand_total);
			}
		});
	}


	og.checkTimeEntryPattern = function(time_value){
		var isValid = /^([0-1]?[0-9]|2[0-3]):[0-5][0-9]$/.test(time_value);
		return isValid;
	}

	og.checkOtherTimePatterns = function(time_value){
		var result = {
			'is_valid': '',
			'updated_value': ''
		};

		var time_integer = parseInt(time_value);
		var time_string = time_value.toString();
		var num_length = time_string.length;
		if(!Number.isInteger(time_integer) || num_length == 0 || num_length>4){
			result['is_valid'] = false;
			return result;
		}

		if(num_length == 1){
			var updated_value = '0' + time_string + ':00';
		} else if(num_length == 2){
			if(time_value > 14){
				var updated_value = '00:' + time_string;
			} else {
				var updated_value = time_string + ':00';
			}
		} else if(num_length == 3){
			var updated_value = time_string.slice(0, 1) + ':' + time_string.slice(1);
		} else if(num_length == 4){
			var updated_value = time_string.slice(0, 2) + ':' + time_string.slice(2);
		}
		var is_valid = og.checkTimeEntryPattern(updated_value);
		result['is_valid'] = is_valid;
		result['updated_value'] = updated_value;

		return result;
	}

	og.updateDescFromWeekly = function(this_obj){
		var desc_input_id = this_obj.id;
		var desc_input = $('#'+ desc_input_id);
		var desc_input_value = desc_input.val();
		og.openLink(og.getUrl('time_weekly', 'update_time_description_from_weekly_view', {desc_info: desc_input_id, desc_value: desc_input_value}), {
			callback: function(success, data) {
				$('#' + data.popover_id  + ' .weekly--desc-button').attr('data-content', data.description_input);
				$('#' + data.popover_id + ' .weekly-time-with-desc path').attr('fill', data.desc_btn_color);
				$('#' + data.popover_id + ' .weekly--desc-button').popover({
					html: true,
					sanitize: false
				});  
			}
		});
	}

	og.addWeeklyTimeToPopover = function(popover_id){
		og.openLink(og.getUrl('time_weekly', 'get_new_time_input_for_popover_view', {popover_id: popover_id}), {
			callback: function(success, data) {
				var dataContent = $('#' + popover_id  + ' .weekly--desc-button').attr('data-content');
				var timeslotsHtml = $('.popover-timeslots', dataContent).html();
				var updatedTimeHtml = timeslotsHtml + data.new_input;
				$('#' + popover_id + ' .popover-timeslots').html(updatedTimeHtml);
				$('#' + data.day_time_input_id).focus();
			}
		});
	}

	og.updateDescFromWeeklyDescDiv = function(this_obj){
		var inputval = $(".popover #"+this_obj.id).val();
		var desc_input_id = this_obj.id;
		var desc_input = $('#'+ desc_input_id);
		var desc_input_value = desc_input.val();

		og.openLink(og.getUrl('time_weekly', 'update_time_description_from_weekly_view_multi_entries', {desc_info: desc_input_id, desc_value: desc_input_value}), {
			callback: function(success, data) {
				og.openLink(og.getUrl('time_weekly', 'get_updated_description_html_multi_entries', {desc_info: desc_input_id}), {
					callback: function(success, data) {

						$('#' + data.popover_id  + ' .weekly--desc-button').attr('data-content', data.description_content);
						$('#' + data.popover_id + ' .weekly--desc-button').popover({
							html: true,
							sanitize: false
						});
						$('#' + data.popover_id + ' .weekly-time-with-desc path').attr('fill', data.desc_color);
					}
				});
			}
		});
	}

	og.deleteTimeEntryWeeklyDescPopover = function(time_info){
		if(confirm(lang('confirm delete time'))){
			var userId = $('#<?php echo $genid ?>weekly-user-id').val();
			var time_input = $('#'+time_info);
			var prev_value = time_input.attr('prevvalue');
			var time_value = '00:00';
			// Delete time entry
			og.openLink(og.getUrl('time_weekly', 'update_time_from_time_weekly_view', {genid: genid, time_info: time_info, user_id: userId, time_value: time_value, multiple: true}), {
				callback: function(success, data) {
					og.updateTotalsAfterTimeChange(time_info, true);
					var action = 'delete';
					
					// Update popover view
					og.openLink(og.getUrl('time_weekly', 'get_updated_time_and_desc_input_after_mult_time_change', {genid: genid, time_info: time_info, user_id: userId, action: action}), {
						callback: function(success, multi_data) {	
							$('#' + multi_data.popover_id  + ' .weekly--desc-button').popover('hide');
							$('#' + multi_data.popover_id).html(multi_data.description_button);
							$('#' + multi_data.popover_id + ' .weekly--desc-button').popover({
								html: true,
								sanitize: false
							});  
							$('#' + multi_data.popover_id  + ' .weekly--desc-button').popover('show');
							if(multi_data.count_timeslots == 1){
								$('#' + multi_data.multi_time_input_id).attr('id', multi_data.time_input_id);
								$('#' + multi_data.time_input_id).removeAttr('readonly');
								$('#' + multi_data.time_input_id).removeAttr('onclick');
								$('#' + multi_data.popover_id).attr('timeId', multi_data.time_input_id);
							}
						}
					});
				}
			});
		}
	}

	og.loadTimeInputPopover = function(inputId){
		var popoverBtnId = '';

		// change "multiple_time" or "edit" on inputId for "popover" in order to get the button id 
		// that has the data-content
		if(inputId.search("multiple_time") >= 0){
			popoverBtnId = inputId.replace("multiple_time", "popover")+"_btn";
		}else{

			// add "_btn" and remove last number on inputId (on edit i have an extra number on the end)
			inputId = inputId.replace("edit", "popover");
			var match = inputId.match(/.*_(..)/g);
			popoverBtnId = match+"_btn";
		}
		$("#"+popoverBtnId).click();
	}

	// panel toolbar
	var weekly_toolbar = new Ext.Toolbar({
		id: '<?php echo $genid ?>weekly_toolbar',
		renderTo: '<?php echo $genid ?>weekly-toolbar-container',
		items: weekly_toolbar_items,
	});
	
</script>

<script>
	og.updateProjectSelector = function () {
		var newGenid = '<?php echo gen_id(); ?>';
		$('#<?php echo $genid ?>member-selector-genid').val(newGenid);
		var selector_config = {
			genid: newGenid,
			context: og.contextManager.plainContext(),
			dim_id: '<?php echo $dimension_id ?>',
			is_multiple: 0,
			hide_label: true,
			root_lang: lang('select a project'),
			listeners: JSON.stringify({'on_selection_change' : 'og.updateTaskSelectorWeeklyView(\''+newGenid+'\');', 'on_remove_relation' : 'og.updateTaskSelectorWeeklyView(\''+newGenid+'\');'})
		};

		og.openLink(og.getUrl('dimension', 'render_member_selector', selector_config), { 
			preventPanelLoad: true,
			hideLoading: true,
			callback: function(success, data) {
				if (success) {
					var container_id = 'project-selector-container';
					$("#" + container_id).html(data.current.data);
					
				}
			}
		});
	}
	og.updateProjectSelector();

	og.updateTaskSelectorWeeklyView = function (memberSelectorGenid) {
		var member_id = $('#'+memberSelectorGenid+'members').val();
		var has_project_selected = $('#<?php echo $genid ?>has-project-selected').val() ? 1 : 0;
		if(has_project_selected) {
			member_id = $('#<?php echo $genid ?>selected_project_member_id').val();
		}
		var genid = '<?php echo $genid ?>';
		var userId = $('#'+genid+'weekly-user-id').val();
		var selectedTaskIds = $('#'+genid+'selected-task-ids').val();

		og.openLink(og.getUrl('time_weekly', 'get_task_selector_html_for_weekly', {project_member_id: member_id, user_id: userId, selected_task_ids: selectedTaskIds, genid: genid}), {
			callback: function(success, data) {
				$('#' + genid + 'task-selector-td').html(data.selector_html);
			}
		});
	}

	og.addTaskRowToWeeklyList = function() {
		// Get project and task selectors
		var member_genid = $('#<?php echo $genid ?>member-selector-genid').val();
		var member_id = $('#'+member_genid+'members').val();
		var task_id = $('#<?php echo $genid ?>-task-selector-weekly-view').val();
		var has_project_selected = $('#<?php echo $genid ?>has-project-selected').val() ? 1 : 0;
		var selectedTaskIds = $('#'+genid+'selected-task-ids').val();
		var arraySelectedTaskIds = eval(selectedTaskIds);
		var projectIdsWithNoTasks = $('#'+genid+'project-ids-with-no-tasks').val();
		var add_button = $('#'+genid+'button-add-row-weekly-view');
		var arrayProjectIdsWithNoTasks = eval(projectIdsWithNoTasks);
		var arrayMemberId = member_id == '[]' ? [0] : eval(member_id);

		if(!has_project_selected && task_id == 0) {
			if(arrayProjectIdsWithNoTasks.includes(arrayMemberId[0])){
				alert(lang('the selected row already exists'));
				return;
			}
		}
		if(has_project_selected && task_id == 0) {
			if(arraySelectedTaskIds.includes(0)){
				alert(('the selected row already exists'));
				return;
			}
		}

		// Get current filters
		var userId = $('#<?php echo $genid ?>weekly-user-id').val();
		var fromDate = new Date($('#<?php echo $genid ?>weekly-from-date').val());
		var untilDate = new Date($('#<?php echo $genid ?>weekly-until-date').val());
		fromDateFormatted = fromDate.toISOString().split('T')[0];
		untilDateFormatted = untilDate.toISOString().split('T')[0];

		add_button.attr('disabled', true);

		og.openLink(og.getUrl('time_weekly', 'get_task_row_for_weekly_view', {project_member_id: member_id, user_id: userId, task_id: task_id, genid: genid, from_date: fromDateFormatted, until_date: untilDateFormatted, has_project_selected: has_project_selected}), {
			callback: function(success, data) {
				var group_name = task_id == 0 ? 'no_tasks' : 'other_tasks';
				var group = $('#<?php echo $genid ?>-group_name-' + group_name);
				var group_header = $('#<?php echo $genid ?>-header_group_name-' + group_name);
				var has_rows = group.attr('hasTasks') == '1';
				// Add row to the group
				if(has_rows) {
					var group_html = group.html();
					var updated_html = group_html + data.task_row;
					group.html(updated_html);
				} else {
					group.html(data.task_row);
					group.attr('hasTasks', 1);
					if(group_name == 'no_tasks'){
						group.show();
						group_header.show();
					}
				}
				// Update selected task ids array
				arraySelectedTaskIds.push(task_id);
				var newSelectedTaskIdsString = '[' + arraySelectedTaskIds.toString() + ']';
				$('#'+genid+'selected-task-ids').val(newSelectedTaskIdsString);
				// Update task selector
				og.updateTaskSelectorWeeklyView(member_genid);
				// Add project ids to the project with no tasks
				if(!has_project_selected && task_id == 0) {
					arrayProjectIdsWithNoTasks.push(arrayMemberId[0]);
					var newArrayProjectIdsWithNoTasks = '[' + arrayProjectIdsWithNoTasks.toString() + ']';
					$('#'+genid+'project-ids-with-no-tasks').val(newArrayProjectIdsWithNoTasks);
				}
				add_button.removeAttr('disabled');
			}
		});
		add_button.removeAttr('disabled');
	}

</script>

