<?php

Hook::register('advanced_calendar');


function advanced_calendar_override_object_color($object, &$color) {
	
	if ($object instanceof ContentDataObject) {
		$dimension_id_for_color = user_config_option('dimension_that_dictates_color');
		if ($dimension_id_for_color > 0) {
			$color_set = false;
			$members = $object->getMembers();
			foreach ($members as $member) {
				if ($member->getDimensionId() == $dimension_id_for_color) {
					$color = $member->getColor();
					$color_set = true;
					break;
				}
			}
			if (!$color_set) $color = 0;
		}
	}
	
}

function advanced_calendar_override_calendar_object_data($params, &$object) {
	
	if ($object instanceof ContentDataObject) {
		
		$member_ot_id = user_config_option('additional_data_in_name');
		if ($member_ot_id > 0) {
			
			$member_ot_dimension_ids = DimensionObjectTypes::instance()->getDimensionIdsByObjectTypeId($member_ot_id);
			
			$members = $object->getMembers();
			foreach ($members as $member) {
				/* @var $member Member */
				$member_to_append_name = null;
				if ($member->getObjectTypeId() == $member_ot_id) {
					$member_to_append_name = $member;
				} else if (in_array($member->getDimensionId(), $member_ot_dimension_ids)) {
					$all_parent_members = $member->getAllParentMembersInHierarchy();
					foreach ($all_parent_members as $parent_member) {
						if ($parent_member->getObjectTypeId() == $member_ot_id) {
							$member_to_append_name = $parent_member;
							break;
						}
					}
				}
				
				if ($member_to_append_name instanceof Member) {
					if (strpos($object->getObjectName(), $member_to_append_name->getName() . " - ") === false) {
						$new_name = $member_to_append_name->getName() . " - " . $object->getObjectName();
						$object->setObjectName($new_name);
					}
				}
			}
			
		}
	}
	
}
