<?php

include_once dirname(__FILE__)."/../../../application/helpers/plugin_installer_functions.php";

function _advanced_core_check_column_exists($db_connection, $table_name, $col_name) {
	$res = mysqli_query($db_connection, "DESCRIBE `$table_name`");
	while($row = mysqli_fetch_array($res)) {
		if ($row['Field'] == $col_name) return true;
	}
	return false;
}

function advanced_core_get_additional_install_queries($db_connection, $table_prefix) {
	
	$queries = array();
	
	$is_installed_mem_custom_props = check_is_installed_plugin($db_connection, $table_prefix, 'member_custom_properties');
	
	if ($is_installed_mem_custom_props) {
		if (!_advanced_core_check_column_exists($db_connection, $table_prefix.'member_custom_properties', 'total_operation')) {
			$queries[] = "ALTER TABLE `".$table_prefix."member_custom_properties`
				ADD COLUMN `total_operation` varchar(50) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '';";
		}
		
		$queries[] = "INSERT INTO ".$table_prefix."property_group_properties (group_id, property_id, `order`)
				SELECT pg.id, cp.id, cp.property_order
				FROM ".$table_prefix."property_groups pg
				LEFT JOIN ".$table_prefix."member_custom_properties cp ON cp.object_type_id=pg.object_type_id
				WHERE pg.code='default' AND pg.object_type_id=cp.object_type_id
					AND pg.object_type_id IN (SELECT id FROM ".$table_prefix."object_types WHERE `type` = 'dimension_group')
			ON DUPLICATE KEY UPDATE group_id=group_id;";
	}
	
	return $queries;

}