<?php

if ($quota instanceof Quota) {
	$currency = Currencies::getCurrency($quota->getCurrencyId());
	$symbol = $currency instanceof Currency ? $currency->getSymbol() : '$';

	$formatted_total = format_money_amount($quota->getAmount(), $symbol);
	$formatted_spent = format_money_amount($quota->getSpentAmount(), $symbol);
	$formatted_available = format_money_amount($quota->getAvailableAmount(), $symbol);
?>

<div class="commentsTitle"><?php echo lang('quota data') ?></div>
<div class="view-data-block">
	<div class="label"><?php echo lang('total amount') ?></div>
	<div class="content"><?php echo $formatted_total ?></div>
	<div class="clear"></div>
	
	<div class="label"><?php echo lang('spent amount') ?></div>
	<div class="content"><?php echo $formatted_spent ?></div>
	<div class="clear"></div>
	
	<div class="label"><?php echo lang('available amount') ?></div>
	<div class="content"><?php echo $formatted_available ?></div>
	<div class="clear"></div>
</div>

<div class="commentsTitle"><?php echo lang('payments') ?></div>
<div id="<?php echo $genid?>_quota_payments_grid_container" class="payments-grid-container"></div>

<?php 
// include payment grid columns and toolbar configuration
tpl_assign("genid", $genid);
$this->includeTemplate(get_template_path('payments_list_grid_config/columns', 'quota', 'advanced_expenses'));
$this->includeTemplate(get_template_path('payments_list_grid_config/toolbar', 'quota', 'advanced_expenses'));

?>


<script>

var grid_id = '<?php echo $genid?>_quota_payments_grid';
var quota_id = <?php echo $quota->getId()?>;

var quota_paymentsgrid = new og.ObjectGrid({
	renderTo: '<?php echo $genid?>_quota_payments_grid_container',
	url: og.getUrl('payment', 'list_all'),
	type_name: 'payment',
	response_objects_root: 'payments',
	grid_id: grid_id,
	nameRenderer: og.gridObjectNameRenderer,
	store_params: {
		url_controller: 'payment',
		url_action: 'list_all',
		quota_id: quota_id
	},
	forceFit: false,
	checkbox_sel_model: true,
	columns: payment_columns,
	add_default_actions_column: false,
	tbar_items: tbar_items,
	no_totals_row: true,
	stateId: 'quota-payments-list', // to remember the gui state independent of the panel
});

var active_tab = Ext.getCmp('tabs-panel').activeTab;
if (active_tab.events.resize.listeners.length < 2) {
	active_tab.on('resize', function() {
		var g = Ext.getCmp(grid_id)
		if (g) g.fireEvent('resize');
	});
}

quota_paymentsgrid.load();

</script>

<?php

}