<?php 
$quota_id = $object->getColumnValue('quota_id');
$quota = Quotas::findById($quota_id);

$selected_quota_id = $quota_id;
if (!$quota instanceof Quota) {// when creating payment from quota view
	$quota_id = get_id('quota_id');
	$quota = Quotas::findById($quota_id);
	if ($quota instanceof Quota) {
		$selected_quota_id = $quota->getId();
		$quotas = array($quota);
	}
}

$init_items_filtered = false;
$items_dimension = Dimensions::findByCode('items');
$divisions_dimension = Dimensions::findByCode('divisions');

if (!isset($quotas)) {
	$extra_conditions = "";
	
	if (Plugins::instance()->isActivePlugin('object_subtypes')) {
		if ($object instanceof Payment && !$object->isNew()) {
			$subtype_id = $object->getColumnValue('object_subtype_id');
		} else {
			$subtype_id = array_var($_REQUEST, 'object_subtype_id', 0);
			if ($subtype_id == 0) {
				// look into the active context and check if a division is selected
				foreach (active_context() as $selection) {
					if ($selection instanceof Member && $selection->getDimensionId() == $divisions_dimension->getId()) {
						$forced_subtype = ObjectSubtypes::findOne(array("conditions" => "object_type_id=".Payments::instance()->getObjectTypeId()." AND member_id=".$selection->getId()));
						if ($forced_subtype instanceof ObjectSubtype) {
							$subtype_id = $forced_subtype->getId();
						}
						break;
					}
				}
			}
		}
		
		$subtype = ObjectSubtypes::findById($subtype_id);
		if ($subtype instanceof ObjectSubtype) {
			$filtering_member_id = $subtype->getMemberId();
			if ($filtering_member_id > 0) {
				$extra_conditions = "
				AND EXISTS (
					SELECT * FROM ".TABLE_PREFIX."object_members om 
					WHERE om.member_id='$filtering_member_id' AND om.object_id=e.object_id 
				)";
				
				$init_items_filtered = true;
			}
		}
	}
	
	// filter quotas by the selected context
	foreach (active_context() as $selection) {
		if ($selection instanceof Member) {
			if ($selection->canContainObject(Quotas::instance()->getObjectTypeId())) {
				$extra_conditions .= "
				AND EXISTS (
					SELECT * FROM ".TABLE_PREFIX."object_members omx
					WHERE omx.member_id='".$selection->getId()."' AND omx.object_id=e.object_id
				)";
			}
		}
	}
	
	
	$all_quotas = Quotas::findAll(array('order' => 'name', 'conditions' => "trashed_by_id=0 " . $extra_conditions));
	
	$quotas = array();
	
	foreach ($all_quotas as $q) {
		if ($q->canView(logged_user())) {
			$quotas[] = $q;
		}
	}
}

?>

<div class="dataBlock">

	<?php echo label_tag(lang('quota'), null, true); ?>
	
	<input type="hidden" name="payment[quota_id]" value="<?php echo $selected_quota_id ?>" id="<?php echo $genid?>quota_id"/>
	
	<div id="<?php echo $genid?>quota_selector_container" style="float:left;"></div>
	    			
</div>
<div class="clear"></div>

<script>



//sets the payment subtype id associated to the quota's division member
og.after_quota_selected = function(genid, quota_id) {
	
	og.openLink(og.getUrl('quota', 'get_quota_data', {id: quota_id}), {
		callback: function(success, data) {

			// UPDATE THE PAYMENT SUBTYPE USING THE DIVISION MEMBER
			if (data && data.quota && data.quota.memPath) {
				
				var all_member_ids = Ext.util.JSON.decode($("#"+genid+"members").val());

				var divisions_dim_id = 0;
				var items_dim_id = 0;

				for (var k=0; k<og.dimensionPanels.length; k++) {
					var dpanel = og.dimensionPanels[k];
					if (dpanel && dpanel.dimensionCode == 'divisions') {
						divisions_dim_id = dpanel.dimensionId;
					}
					if (dpanel && dpanel.dimensionCode == 'items') {
						items_dim_id = dpanel.dimensionId;
					}
				}

				if (items_dim_id == 0 || divisions_dim_id == 0) return;
				
				for (dim_id in data.quota.memPath) {
					if (dim_id == divisions_dim_id) {
						var member_ids_by_ot = data.quota.memPath[dim_id];
						if (typeof(member_ids_by_ot) == 'function') continue;
						
						for (ot in member_ids_by_ot) {
							var member_ids = member_ids_by_ot[ot];
							if (typeof(member_ids) == 'function') continue;

							var division_member_id = member_ids[0];

							if (division_member_id > 0) {
								
								// assign the corresponding object subtype
								if (og.object_subtype_names['payment']) {
									
									for (var idx=0; idx<og.object_subtype_names['payment'].length; idx++) {
										var subtype = og.object_subtype_names['payment'][idx];
										
										// update and reload properties only if subtype has changed
										if (subtype && subtype.member_id == division_member_id) {
											if (subtype.id != $("#"+genid+"submit-edit-form #payment_object_subtype_id").val()) {
												$("#"+genid+"submit-edit-form #payment_object_subtype_id").val(subtype.id).change();
											}
											break;
										}
									}
								}
								
								// filter the items dimension selector
								// og.filter_items_selector_tree(genid, items_dim_id, division_member_id);
							}
														
							break;
						}
					}
				}
			}
		}
	});
}

og.filter_items_selector_tree = function(genid, items_dim_id, division_member_id) {
	
	if (division_member_id) {
		// clear selected items
		member_selector.remove_all_dimension_selections(genid, items_dim_id);

		// get the items tree and filter it using the dimension_member_id
		var items_tree = Ext.getCmp(genid + '-member-chooser-panel-' + items_dim_id + '-tree');
		if (items_tree) {
			items_tree.filterByMember([division_member_id]);
		}
	}
}


var quotas_store = [];
<?php
	$projects_dimension = Dimensions::findByCode('customer_project');
	$activities_dimension = Dimensions::findByCode('activities');
	$exec_units_dimension = Dimensions::findByCode('executor_units');
	foreach ($quotas as $quota) {
		$quota_name = "";//$quota->getName();
		$activity_name = "";
		$item_name = "";
		$eu_name = "";
		$project_name = "";
		$div_name = "";
		$quota_members = $quota->getMembers();
		foreach ($quota_members as $qm) {
			if ($projects_dimension && $qm->getDimensionId() == $projects_dimension->getId()) {/* @var $qm Member */
				$project_name = $qm->getPath(" - ");
				$project_name .= ($project_name != "" ? " - " : "") . $qm->getName();
			}
			if ($qm->getDimensionId() == $activities_dimension->getId()) {
				$activity_name = $qm->getName();
			}
			if ($items_dimension && $qm->getDimensionId() == $items_dimension->getId()) {/* @var $qm Member */
				$item_name = $qm->getPath(" - ");
				$item_name .= ($item_name != "" ? " - " : "") . $qm->getName();
			}
			if (!$items_dimension && $qm->getDimensionId() == $divisions_dimension->getId()) {/* @var $qm Member */
				$div_name = $qm->getPath(" - ");
				$div_name .= ($div_name != "" ? " - " : "") . $qm->getName();
			}
			if ($qm->getDimensionId() == $exec_units_dimension->getId()) {/* @var $qm Member */
				$eu_name = $qm->getPath(" - ");
				$eu_name .= ($eu_name != "" ? " - " : "") . $qm->getName();
			}
		}
		if ($project_name != "") $quota_name .= ($quota_name == "" ? "" : " | ") . $project_name;
		if ($item_name != "") $quota_name .= ($quota_name == "" ? "" : " | ") . $item_name;
		else if ($div_name != "") $quota_name .= ($quota_name == "" ? "" : " | ") . $div_name;
		if ($eu_name != "") $quota_name .= ($quota_name == "" ? "" : " | ") . $eu_name;
		if ($activity_name != "") $quota_name .= ($quota_name == "" ? "" : " | ") . $activity_name;
?>
		quotas_store.push(['<?php echo $quota->getId() ?>', '<?php echo $quota_name ?>']);
<?php
	}
?>

var quota_selector = new Ext.form.ComboBox({
    renderTo:'<?php echo $genid ?>quota_selector_container',
    name: 'quota_selector',
    id: '<?php echo $genid ?>quota_selector_id_combo',
    value: '<?php echo $selected_quota_id ?>',
    store: quotas_store,
    displayField:'text',
    mode: 'local',
    //cls: 'assigned-to-combo',
    triggerAction: 'all',
    selectOnFocus:true,
    width: 418,
    listWidth: 518,
    //listClass: 'assigned-to-combo-list',
    valueField: 'value',
    emptyText: (lang('select quota') + '...'),
    valueNotFoundText: ''
});
quota_selector.on('select', function(combo, selected, idx) {
    combo = Ext.getCmp('<?php echo $genid ?>quota_selector_id_combo');
    assignedto = document.getElementById('<?php echo $genid ?>quota_id');
    if (assignedto) assignedto.value = combo.getValue();

    og.after_quota_selected('<?php echo $genid ?>', combo.getValue());
});
if (quotas_store.length == 1) {
	quota_selector.setValue(quotas_store[0][0]);
}

</script>