<?php
Hook::register('advanced_expenses');



function advanced_expenses_object_definition($type, &$ret) {
	if ($type == 'Payment' || $type == 'PaymentHistory') {
		$ret['quota_id'] = DATA_TYPE_INTEGER;
	}
}

function advanced_expenses_additional_system_columns($manager, &$columns) {
	if ($manager instanceof Payments) {
		//$columns[] = 'quota_id';
	}
}

function advanced_expenses_additional_external_columns($manager, &$columns) {
	if ($manager instanceof Payments) {
		$columns[] = 'quota_id';
	}
}

function advanced_expenses_additional_view_payment_data($payment, &$content) {
	if ($payment instanceof Payment) {
		$quota_name = $payment->getExternalColumnValue('quota_id');
		if ($quota_name) {
			$content .= '<div><span class="bold">'.lang('quota').': </span>'.$quota_name.'</div>';
		}
	}
}


function advanced_expenses_custom_reports_get_external_column_value($parameters, &$value) {
	$external_id = array_var($parameters, 'external_id');
	$manager = array_var($parameters, 'manager');
	$field = array_var($parameters, 'field');
	$object = array_var($parameters, 'object');

	if ($manager instanceof Payments) {
		if ($field == 'quota_id' && $external_id > 0) {
			$quota = Quotas::findById($external_id);
			if ($quota instanceof Quota) {
				$value = $quota->getName();
			}
		}
	}
}

function advanced_expenses_before_render_member_selectors($params, &$categories) {

	$object = array_var($params, 'object');
	$genid = array_var($params, 'genid');
	
	if ($object instanceof Payment) {
		tpl_assign('object', $object);
		tpl_assign('genid', $genid);
		
		tpl_display(get_template_path('quota_selectbox', 'quota', 'advanced_expenses'));
	}
}
/*
function advanced_expenses_modify_member_selector_listeners($params, &$listeners) {

	$object = array_var($params, 'object');
	$genid = array_var($params, 'genid');
	
	if ($object instanceof Payment) {
		$listeners['on_selection_change'] .= 'og.checkCanHaveQuota("'.$genid.'");';
	}
}
*/
function advanced_expenses_add_member_selector_skipped_dimensions($params, &$skipped_dimensions) {
	
	$object = array_var($params, 'object');
	$genid = array_var($params, 'genid');
	
	if ($object instanceof Payment) {
		Env::useHelper('functions', 'advanced_expenses');
		$skipped_dimensions = get_quota_dimension_ids();
	}
}

function advanced_expenses_before_save_payment($args, &$member_ids) {
	$object = array_var($args, 'object');
	if ($object instanceof Payment) {
		Env::useHelper('functions', 'advanced_expenses');
		$quota_dimensions = get_quota_dimension_ids();
		
		$quota = Quotas::findById($object->getColumnValue('quota_id'));
		if ($quota instanceof Quota) {
			$quota_members = $quota->getMembers();
			
			$more_member_ids = array();
			
			$dimensions_to_override = array();
			
			foreach ($quota_members as $quota_member) {
				if ($quota_member instanceof Member && in_array($quota_member->getDimensionId(), $quota_dimensions)) {
					$more_member_ids[] = $quota_member->getId();
					
					$dimensions_to_override[] = $quota_member->getDimensionId();
					
					$dmas = DimensionMemberAssociations::getAllAssociatationsForObjectType($quota_member->getDimensionId(), $quota_member->getObjectTypeId());
					foreach ($dmas as $dma) {/* @var $dma DimensionMemberAssociation */
						$d = Dimensions::getDimensionById($dma->getAssociatedDimensionMemberAssociationId());
						$o = ObjectTYpes::findById($dma->getAssociatedObjectType());
						$assoc_mem_ids = get_all_associated_status_member_ids($quota_member, $d, $o);
						
						if (!empty($assoc_mem_ids)) $more_member_ids = array_merge($more_member_ids, $assoc_mem_ids);
						
						$dimensions_to_override[] = $dma->getAssociatedDimensionMemberAssociationId();
					}
					
				}
			}
			
			$tmp_member_ids = array();
			foreach ($member_ids as $pmid) {
				$m = Members::getMemberById($pmid);
				if (!in_array($m->getDimensionId(), $dimensions_to_override)) {
					$tmp_member_ids[] = $pmid;
				}
			}
			
			$member_ids = array_merge($tmp_member_ids, $more_member_ids);
			
			
		} else {
			throw new Exception(lang('no quota selected'));
		}
	}
}

function advanced_expenses_payments_use_expenses($params, &$using_expenses) {
	$object = array_var($params, 'object');
	$genid = array_var($params, 'genid');
	
	if ($object instanceof Payment) {
		$using_expenses = false;
	}
}

function advanced_expenses_after_save_payment($params, &$ignored) {
	$object = array_var($params, 'object');
	$data = array_var($params, 'data');
	$old_data = array_var($params, 'old_data');

	if ($object instanceof Payment) {
		
		$qid = array_var($data, 'quota_id');
		
		$quota = Quotas::findById($qid);
		/*
		if ($quota instanceof Quota) {
			if(!count($old_data)){
			    $available = $quota->getAvailableAmount() - $object->getAmount();
			}else{
			    
			    $available = $quota->getAvailableAmount();
			    
			    foreach($old_data['amounts'] as $key => $value){
			        $available = $available + $value;
			    }
			    
			    $available = $available - $object->getAmount();		    
			}
		}
		*/
		
		// show alerts if no quota or payment amount is greater than quota available amount
		if ($quota instanceof Quota) {
			$available = $quota->getAmount() - $quota->getSpentAmount();
			if ($available < 0) {
				evt_add("popup", array('title' => lang("warning"), 'message' => lang("payment amount is greater than quota amount")));
			}
		} else {
			evt_add("popup", array('title' => lang("warning"), 'message' => lang("no quota selected")));
		}
	}
}

/**
 * To recalculate quota spent amount after add, edit and trash
 */
function advanced_expenses_before_object_save($object, &$ignored) {
	if ($object instanceof Payment) {
		$quotas_to_recalculate = array();
		if ($object->getId() > 0) {
			$prow = DB::executeOne("SELECT * FROM ".TABLE_PREFIX."payments WHERE object_id=".$object->getId());
			if ($prow && isset($prow['quota_id']) && $prow['quota_id'] > 0) {
				$quotas_to_recalculate[] = $prow['quota_id'];
			}
		}
		
		if ($object->getColumnValue('quota_id') > 0) {
			$quotas_to_recalculate[] = $object->getColumnValue('quota_id');
		}
		
		if (count($quotas_to_recalculate) > 0) {
			$_SESSION['quotas_to_recalculate'] = array_unique($quotas_to_recalculate);
		}
	}
}

/**
 * To recalculate quota spent amount when deleted directly
 */
function advanced_expenses_before_delete($object, &$ignored) {
	if ($object instanceof Payment && $object->getTrashedById()==0) {
		$quota_id = $object->getColumnValue('quota_id');
		if ($quota_id > 0) {
			if (!isset($_SESSION['quotas_to_recalculate'])) $_SESSION['quotas_to_recalculate'] = array();
			$_SESSION['quotas_to_recalculate'][] = $quota_id;
		}
	}
}

/**
 * To recalculate quota spent amount after add, edit and trash
 */
function advanced_expenses_after_object_save($object, &$ignored) {
	if ($object instanceof Payment) {
		Env::useHelper('functions', 'advanced_expenses');
		recalulate_pending_quotas();
		evt_add('reload tab panel', 'expenses-panel');
	}
}

/**
 * To recalculate quota spent amount when deleted directly
 */
function advanced_expenses_after_delete($object, &$ignored) {
	if ($object instanceof Payment) {
		Env::useHelper('functions', 'advanced_expenses');
		recalulate_pending_quotas();
		evt_add('reload tab panel', 'expenses-panel');
	}
}


function advanced_expenses_listing_extra_conditions($params, &$extra_conditions) {
	$manager = array_var($params, 'manager');
	$request = array_var($params, 'request');
	
	$text_filter = array_var($request, 'text_filter');
	$controller = array_var($request, 'c');
	
	if ($manager instanceof Payments) {
		$quota_id_filter = array_var($request, 'quota_id');
		if (is_numeric($quota_id_filter) && $quota_id_filter > 0) {
			$extra_conditions .= " AND quota_id='$quota_id_filter' ";
		}
	}
	
	if (trim($text_filter) != '') {
		$text_filter = str_replace("'", "\'", trim($text_filter));
		switch ($controller) {
			case 'quota': 
				$extra_conditions .= " AND o.name LIKE '%".$text_filter."%' "; 
				break;
			default:
				break;
		}
	}
}


function advanced_expenses_view_expense_pay_table_col_values($params, &$ignored) {
	$exp = $params['expense'];
	$p = $params['payment'];
	
	$fs_dim = Dimensions::findByCode('funding_sources');
	$exe_dim = Dimensions::findByCode('executor_units');
	
	$fs_mems = ObjectMembers::getMembersByObjectAndDimension($p['id'], $fs_dim->getId());
	$exe_mems = ObjectMembers::getMembersByObjectAndDimension($p['id'], $exe_dim->getId());
	
	$fs_mem_name = count($fs_mems) > 0 ? $fs_mems[0]->getName() : "";
	$exe_mem_name = count($exe_mems) > 0 ? $exe_mems[0]->getName() : "";
	
	$fs_mem_text = "";
	if ($fs_mems[0]) {
		$fs_mem_text = '<span class="member-path real-breadcrumb og-wsname-color-'.$fs_mems[0]->getColor().'">'.$fs_mem_name.'</span>';
	}
	$exe_mem_text = "";
	if ($exe_mems[0]) {
		$exe_mem_text = '<span class="member-path real-breadcrumb og-wsname-color-'.$exe_mems[0]->getColor().'">'.$exe_mem_name.'</span>';
	}
	
	echo "<td>$fs_mem_text</td><td>$exe_mem_text</td>";
}

function advanced_expenses_view_expense_pay_table_col_headers($params, &$ignored) {
	$fs_dim = Dimensions::findByCode('funding_sources');
	$exe_dim = Dimensions::findByCode('executor_units');
	
	echo "<th>".$fs_dim->getName()."</th><th>".$exe_dim->getName()."</th>";
}

function advanced_expenses_view_expense_pay_table_col_totals($params, &$ignored) {
	echo "<td></td><td></td>";
}


function advanced_expenses_get_expense_payments_more_data($params, &$payment_info) {

	$fs_dim = Dimensions::findByCode('funding_sources');
	$exe_dim = Dimensions::findByCode('executor_units');
/*
	$fs_mem_ids = ObjectMembers::getMembersByObjectAndDimension($payment_info['id'], $fs_dim->getId(), "", true);
	$exe_mem_ids = ObjectMembers::getMembersByObjectAndDimension($payment_info['id'], $exe_dim->getId(), "", true);
	
	$fs_to_show = array();
	foreach ($fs_mem_ids as $mid) {
		$fs_to_show[$mid] = $mid;
	}
	$exe_to_show = array();
	foreach ($exe_mem_ids as $mid) {
		$exe_to_show[$mid] = $mid;
	}
	
	$mem_path = array(
			$fs_dim->getId() => $fs_to_show,
			$exe_dim->getId() => $exe_to_show,
	);
	$payment_info['memPath'] = json_encode($mem_path);
	*/
	
	$fs_mems = ObjectMembers::getMembersByObjectAndDimension($payment_info['id'], $fs_dim->getId());
	$exe_mems = ObjectMembers::getMembersByObjectAndDimension($payment_info['id'], $exe_dim->getId());
	
	$fs_mem_text = "";
	foreach ($fs_mems as $m) {
		$fs_mem_text .= '<span class="member-path real-breadcrumb og-wsname-color-'.$m->getColor().'">'.$m->getName().'</span>';
	}
	$exe_mem_text = "";
	foreach ($exe_mems as $m) {
		$exe_mem_text .= '<span class="member-path real-breadcrumb og-wsname-color-'.$m->getColor().'">'.$m->getName().'</span>';
	}
	
	$payment_info['dim_'.$fs_dim->getId()] = $fs_mem_text;
	$payment_info['dim_'.$exe_dim->getId()] = $exe_mem_text;
}


function advanced_expenses_custom_reports_object_types($parameters, &$object_types) {
	
	$enabled_dimensions = config_option('enabled_dimensions');
	
	$objs_dim = Dimensions::findByCode('objectives_activities');
	if (in_array($objs_dim->getId(), $enabled_dimensions)) {
		$object_types[] = ObjectTypes::findByName('strategic_objective');
	}
	
	$objs_dim = Dimensions::findByCode('activities');
	if (in_array($objs_dim->getId(), $enabled_dimensions)) {
		$object_types[] = ObjectTypes::findByName('activity');
		$object_types[] = ObjectTypes::findByName('sub_activity');
	}
	
	$axes_dim = Dimensions::findByCode('strategic_axes');
	if (in_array($axes_dim->getId(), $enabled_dimensions)) {
		$object_types[] = ObjectTypes::findByName('strategic_axe');
	}
	
	$divs_dim = Dimensions::findByCode('divisions');
	if (in_array($divs_dim->getId(), $enabled_dimensions)) {
		$object_types[] = ObjectTypes::findByName('division');
	}
	
	$fs_dim = Dimensions::findByCode('funding_sources');
	if (in_array($fs_dim->getId(), $enabled_dimensions)) {
		$object_types[] = ObjectTypes::findByName('funding_source');
	}
	
	$exe_dim = Dimensions::findByCode('executor_units');
	if (in_array($exe_dim->getId(), $enabled_dimensions)) {
		$object_types[] = ObjectTypes::findByName('executor_unit');
	}

}

function advanced_expenses_additional_dashboard_actions($ignored, &$actions) {
	
	$enabled_dimensions = config_option("enabled_dimensions");

	$links = array(
/*		array('d' => 'objectives_activities', 'o' => 'strategic_objective'),
		array('d' => 'objectives_activities', 'o' => 'activity'),
		array('d' => 'objectives_activities', 'o' => 'sub_activity'),
		array('d' => 'divisions', 'o' => 'division'),
	//	array('d' => 'funding_sources', 'o' => 'funding_source'),
	//	array('d' => 'executor_units', 'o' => 'executor_unit'),*/
	);
	
	foreach ($links as $link) {
		
		$dim_code = $link['d'];
		$ot_name = $link['o'];

		$dim = Dimensions::findByCode($dim_code);
		if (in_array($dim->getId(), $enabled_dimensions)) {
			$pot = ObjectTypes::findByName($ot_name);
			$pdot = DimensionObjectTypes::findOne(array('conditions' => 'dimension_id='.$dim->getId().' AND object_type_id='.$pot->getId()));
			if ($pdot instanceof DimensionObjectType && $pdot->getEnabled()) {
				if (active_context_can_contain_member_type($dim->getId(), $pot->getId())) {
					$actions[] = array(
							'id' => $pot->getName().'-list',
							'assoc_ot' => $pot->getId(),
							'assoc_dim' => $dim->getId(),
							'name' => lang($pot->getName().' list'),
							'class' => 'link-ico ico-'.$pot->getName(),
							'onclick' => "og.openLink(og.getUrl('member', 'init', {dim_id:".$dim->getId().", type_id:".$pot->getId()."}), {caller:'".$pot->getName()." list'}); return false;",
					);
				}
			}
		}
	}
}



function advanced_expenses_custom_reports_additional_columns($args, &$ret) {
	// the dim columns are added by this plugin too
	if (Plugins::instance()->isActivePlugin('advanced_reports')) return;

	$ot = array_var($args, 'object_type');
	if ($ot instanceof ObjectType && in_array($ot->getType(), array('dimension_object','dimension_group'))) return;

	$dimensions = Dimensions::findAll ( array("conditions" => "code IN ('strategic_axes','objectives_activities','activities','divisions','funding_sources','executor_units')") );
	foreach ($dimensions as $dimension) {
		if (in_array($dimension->getId(), config_option('enabled_dimensions'))) {
				
			$name = $dimension->getName();
				
			$ret[] =  array('id' => 'dim_'.$dimension->getId(), 'name' => $name, 'type' => DATA_TYPE_STRING);
		}
	}
}


// if filtering the suppliers dimension by item => use the item parent (division) to make the filter, using the dim association
function advanced_expenses_list_dimension_members_tree_modify_member_filter($params, &$selected_members) {
	
	$dimension = array_var($params, 'dimension');
	
	if ($dimension->getCode() == 'suppliers') {
		
		$divisions_dim = Dimensions::findByCode('divisions');
		$item_ot = ObjectTypes::findByName('item');
		
		$new_selected_members = array();
		
		foreach ($selected_members as $member) {
			/* @var $member Member */
			if ($member->getObjectTypeId() == $item_ot->getId() && $member->getDimensionId() == $divisions_dim->getId()) {
				$parent_member = $member->getParentMember();
				if ($parent_member instanceof Member) {
					$new_selected_members[] = $parent_member;
				}
			} else {
				$new_selected_members[] = $member;
			}
		}
		$selected_members = $new_selected_members;
	}
}



function advanced_expenses_list_totals_accumulate_total_rows($params, &$info) {
	$ot = array_var($params, 'object_type');

	if ($ot instanceof ObjectType && ($ot->getName() == 'quota')) {

		$info['available_amount'] = array('operation' => 'sum', 'format' => 'money', 'currency_id_col' => 'currency_id', 'group_by' => 'currency_id');

	}
}


function advanced_expenses_more_list_total_columns($parameters, &$total_rows) {
	$ot = array_var($parameters, 'object_type');
	$params = array_var($parameters, 'original_params');

	if ($ot instanceof ObjectType && $ot->getName() == 'quota') {

		$from_sql = array_var($params, 'from_sql');
		$joins_sql = array_var($params, 'joins_sql');
		$conditions_sql = array_var($params, 'conditions_sql');

		$group_by_sql = "GROUP BY e.currency_id";
		$joins_sql .= "
			INNER JOIN ".TABLE_PREFIX."quotas q ON q.object_id=o.id
		";
		$columns = "SUM(q.amount - q.spent_amount) as available_amount, q.currency_id";
		
		// remove dimension order joins to prevent duplicated rows
		$joins_sql = remove_dimension_order_joins_from_joins_sql($joins_sql);
		
		if (is_array($params['member_ids'])) {
			foreach ($params['member_ids'] as $mid) {
				if (is_numeric($mid) && $mid > 0) {
					$conditions_sql .= "
					and exists (select object_id from ".TABLE_PREFIX."object_members where object_id=o.id and member_id=$mid) ";
				}
			}
			if (count($params['member_ids']) > 0) {
				$group_by_sql .= ", om.member_id";
			}
		}

		$totals_sql = "
			SELECT $columns
			$from_sql
			$joins_sql
			WHERE
			$conditions_sql
			$group_by_sql
		";

		if (!is_array($total_rows)) $total_rows = array();

		$rows = DB::executeAll($totals_sql);
		
		if (is_array($rows)) {
			foreach ($rows as $r) {
				foreach ($total_rows as &$total_row) {
					if ($total_row['currency_id'] == $r['currency_id']) {
						$total_row['available_amount'] = $r['available_amount'];
						break;
					}
				}
			}
		}
	}

}

// extra quota report columns

function advanced_expenses_get_calculated_column_value($params, &$value) {
	$report = array_var($params, 'report');
	$object = array_var($params, 'object');
	$column = array_var($params, 'column');

	if ( $report->getReportObjectTypeId() == Quotas::instance()->getObjectTypeId()  ) {
			
		switch ($column) {
			case 'available_amount':
				$info = $object->getArrayInfo();
				$balance = $object->getAmount() - $object->getSpentAmount();
				$value = '<div class="amount-container"><div style="float:right;">'. $balance .'</div></div>';
				break;
			default:
				break;
		}
	}
}

function advanced_expenses_more_object_calculated_columns($manager, &$columns) {
	if ($manager instanceof Quotas) {
		$columns[] = 'available_amount';
	}
}


function advanced_expenses_custom_reports_override_column_format($parameters, &$value) {
	$manager = array_var($parameters, 'manager');
	$field = array_var($parameters, 'field');
	$object = array_var($parameters, 'object');

	if ($manager instanceof Quotas) {

		if ($field == 'amount' || $field == 'spent_amount' || $field == 'available_amount') {
			$currency = Currencies::getCurrency($object->getCurrencyId());
			$csymbol = null;
			if ($currency instanceof Currency) {
				$csymbol = $currency->getSymbol();
			}
			if ($field == 'available_amount') {
				$value = format_money_amount($object->getColumnValue('amount') - $object->getColumnValue('spent_amount'), $csymbol);
			} else {
				$value = format_money_amount($object->getColumnValue($field), $csymbol);
			}
		}
	}
}


function advanced_expenses_more_report_group_totals($params, &$level_gr_totals) {
	$report_ot = array_var($params, 'object_type');

	if ($report_ot && $report_ot->getName() == 'quota') {
		foreach ($level_gr_totals as &$gr_total) {
			$gr_total['available_amount'] = $gr_total['amount'] - $gr_total['spent_amount'];
		}
	}
}


// extra expense and payment list columns
/*
function advanced_expenses_list_totals_accumulate_total_rows($params, &$info) {
	$ot = array_var($params, 'object_type');
	
	if ($ot instanceof ObjectType && ($ot->getName() == 'expense')) {

		$info['balance'] = array('operation' => 'sum', 'format' => 'money', 'currency_id_col' => 'currency', 'group_by' => 'currency');
		
	}
}


function advanced_expenses_modify_object_get_array_info($params, &$info) {
	$object = array_var($params, 'object');
	
	$all_statuses = ExpensesStatuses::instance()->getAllStatusInfo();
	foreach ($all_statuses as $status) {
		if ($status['code'] == 'budgeted') $budgeted_id = $status['id'];
		else if ($status['code'] == 'executed') $executed_id = $status['id'];
		else if ($status['code'] == 'in_process') $in_process_id = $status['id'];
	}
	
	if ($object instanceof Payment) {
		$balance = 0;
		if (array_var($info['amounts'], $budgeted_id)) $balance += $info['amounts'][$budgeted_id];
		if (array_var($info['amounts'], $executed_id)) {
			$balance -= $info['amounts'][$executed_id];
		} else if (array_var($info['amounts'], $in_process_id)) {
			$balance -= $info['amounts'][$in_process_id];
		}
		$info['balance'] = format_money_amount($balance, $info['currency']);
		
	} else if ($object instanceof Expense) {
		
		$balances_by_currency = array();
		
		$bud_st = ExpensesStatuses::instance()->getStatusByCode('budgeted');
		$exe_st = ExpensesStatuses::instance()->getStatusByCode('executed');
		$inp_st = ExpensesStatuses::instance()->getStatusByCode('in_process');
		
		$context_condition = "";
		$context_condition2 = "";
		$members = active_context_members(false);
		if (count($members) > 0) {
			$context_condition = " AND (
				EXISTS (SELECT om.object_id
					FROM  ".TABLE_PREFIX."object_members om
					WHERE	om.member_id IN (" . implode ( ',', $members ) . ") AND pp.object_id = om.object_id
					GROUP BY object_id
					HAVING count(member_id) = ".count($members)."
				))
			";
			$context_condition2 = str_replace("pp.object_id", "pp2.object_id", $context_condition);
		}
		
		$totals_sql = "
			SELECT sum(pt.amount) - (
				SELECT COALESCE(sum(pt2.amount), 0)
			    	FROM ".TABLE_PREFIX."payments pp2 
			    	INNER JOIN ".TABLE_PREFIX."payment_totals pt2 ON pt2.payment_id=pp2.object_id
			    	WHERE pp2.expense_id=".$object->getId()."
						and pt2.payment_id=pp2.object_id  
						and pt2.status_id=IF(pp2.status_id=".$inp_st->getId().", ".$inp_st->getId().", ".$exe_st->getId().")
						and pt2.currency_id=pp.currency
						$context_condition2
			) as balance, pt.currency_id
			
			FROM ".TABLE_PREFIX."payments pp 
			INNER JOIN ".TABLE_PREFIX."payment_totals pt ON pt.payment_id=pp.object_id
			WHERE pp.expense_id=".$object->getId()." and pt.payment_id=pp.object_id AND pt.status_id=".$bud_st->getId()."
			$context_condition
			GROUP BY pp.currency
		";
			
		$rows = DB::executeAll($totals_sql);
		foreach ($rows as $r) {
			$c = Currencies::instance()->getCurrency($r['currency_id']);
			$sym = $c instanceof Currency ? $c->getSymbol() : null;
			$balances_by_currency[$r['currency_id']] = format_money_amount($r['balance'], $sym);
		}
		
		$info['balance'] = $balances_by_currency;
	}
}


function advanced_expenses_more_list_total_columns_expenses($parameters, &$total_rows) {
	$ot = array_var($parameters, 'object_type');
	$params = array_var($parameters, 'original_params');
	
	if ($ot instanceof ObjectType && ($ot->getName() == 'expense' )) {
	
		$from_sql = array_var($params, 'from_sql');
		$joins_sql = array_var($params, 'joins_sql');
		$conditions_sql = array_var($params, 'conditions_sql');

		$bud_st = ExpensesStatuses::instance()->getStatusByCode('budgeted');
		$exe_st = ExpensesStatuses::instance()->getStatusByCode('executed');
		$inp_st = ExpensesStatuses::instance()->getStatusByCode('in_process');
	
		if ($ot instanceof ObjectType && $ot->getName() == 'expense') {
			
			$joins_sql .= "
				LEFT JOIN ".TABLE_PREFIX."payments pp ON pp.expense_id=o.id
				INNER JOIN ".TABLE_PREFIX."payment_totals pt ON pt.payment_id=pp.object_id
			";
			
			$conditions_sql = str_replace("AND o.id = om.object_id", "AND pp.object_id = om.object_id", $conditions_sql);
			
			$cond_sub_q = str_replace("pp.object_id", "pp2.object_id", $conditions_sql); 
			$conditions_sql .= " and pt.payment_id=pp.object_id ";
			
			$group_by_sql = "GROUP BY currency_id";
			
			$columns = "
				SUM(IF(pt.status_id=".$bud_st->getId().", pt.amount, 0)) - (
					SELECT COALESCE(sum(pt2.amount), 0)
				    	FROM ".TABLE_PREFIX."payments pp2 
				    	INNER JOIN ".TABLE_PREFIX."payment_totals pt2 ON pt2.payment_id=pp2.object_id
				    	WHERE pt2.payment_id=pp2.object_id  
							and pt2.status_id=IF(pp2.status_id=".$inp_st->getId().", ".$inp_st->getId().", ".$exe_st->getId().")
							and pt2.currency_id=pp.currency
							and $cond_sub_q
				) as balance, pt.currency_id
			";
			
			
		} else if ($ot instanceof ObjectType && $ot->getName() == 'payment') {
			
			$context_condition = "";
			$members = active_context_members(false);
			if (count($members) > 0) {
				$context_condition = " AND (
					EXISTS (SELECT om.object_id
						FROM  ".TABLE_PREFIX."object_members om
						WHERE	om.member_id IN (" . implode ( ',', $members ) . ") AND pp2.object_id = om.object_id
						GROUP BY object_id
						HAVING count(member_id) = ".count($members)."
					))
				";
			}
			
			$joins_sql .= "
				INNER JOIN ".TABLE_PREFIX."payment_totals pt ON pt.payment_id=e.object_id
			";
			
			$group_by_sql = "GROUP BY currency_id";
			
			$columns = "
				SUM(IF(pt.status_id=".$bud_st->getId().", pt.amount, 0)) - (
					SELECT COALESCE(sum(pt2.amount), 0)
				    	FROM ".TABLE_PREFIX."payments pp2
				    	INNER JOIN ".TABLE_PREFIX."payment_totals pt2 ON pt2.payment_id=pp2.object_id
				    	WHERE pt2.payment_id=pp2.object_id
							and pt2.status_id=IF(pp2.status_id=".$inp_st->getId().", ".$inp_st->getId().", ".$exe_st->getId().")
							and pt2.currency_id=e.currency
							$context_condition
				) as balance, pt.currency_id
			";
			
		}
		
		$totals_sql = "
			SELECT $columns
				$from_sql
				$joins_sql
			WHERE
				$conditions_sql
				$group_by_sql
		";
		
		$rows = DB::executeAll($totals_sql);
			
		if (!is_array($total_rows)) $total_rows = array();
		$data = array();
		if (is_array($rows)) {
			foreach ($rows as $r) {
				$total_rows[] = array('currency' => $r['currency_id'], 'balance' => $r['balance']);
			}
		}
	}
}


// extra expense and payment report columns

function advanced_expenses_get_calculated_column_value($params, &$value) {
	$report = array_var($params, 'report');
	$object = array_var($params, 'object');
	$column = array_var($params, 'column');

	if ( $report->getReportObjectTypeId() == Expenses::instance()->getObjectTypeId()  ) {
			
		switch ($column) {
			case 'balance':
				$info = $object->getArrayInfo();
				$balance = $info['balance'];
				if ($object instanceof Payment) {
					$value = '<div class="amount-container"><div style="float:right;">'. $balance .'</div></div>';;
				} else {
					foreach ($balance as $c_id => $amount) {
						$value .= '<div class="amount-container"><div style="float:right;">'. $amount .'</div></div>';
					}
				}
			default:
				break;
		}
	}
}

function advanced_expenses_more_object_calculated_columns($manager, &$columns) {
	if ($manager instanceof Expenses) {
		$columns[] = 'balance';
	}
}



function advanced_expenses_more_report_group_totals($params, &$level_gr_totals) {
	$report_ot = array_var($params, 'object_type');
	
	if ($report_ot && $report_ot->getName() == 'expense') {
		foreach ($level_gr_totals as &$gr_total) {
			$gr_total['balance'] = $gr_total['total_budgeted'] - max(array($gr_total['total_executed'], $gr_total['total_in_process']));
			$gr_total['currency_id_balance'] = $gr_total['currency_id_budgeted'];	
		}
	}
}
*/


function advanced_expenses_modify_group_totals_sql($params, &$results) {
	
	$ot = array_var($params, 'object_type');

	if ($ot instanceof ObjectType && ($ot->getName()=='expense' /*|| $ot->getName()=='payment'*/)) {

			if (!isset($results['cols_sql'])) $results['cols_sql'] = array();
			if (!isset($results['join_sql'])) $results['join_sql'] = array();
			if (!isset($results['gb_sql'])) $results['gb_sql'] = array();
			
			$bud_st = ExpensesStatuses::instance()->getStatusByCode('budgeted');
				
			if ($ot->getName()=='expense') {
			
				/*
				$results['cols_sql'][] = "
					(SUM(SELECT pt.amount FROM ".TABLE_PREFIX."payment_totals pt
						INNER JOIN ".TABLE_PREFIX."payments pp ON pp.object_id=pt.payment_id
							
						 WHERE pt.payment_id IN (SELECT pp.object_id FROM ".TABLE_PREFIX."payments pp ON pp.expense_id=e.object_id) 
							AND pt.status_id=".$bud_st->getId().") -
						
						SUM(IF ((SELECT pp.status_id FROM ".TABLE_PREFIX."payments pp ON pp.expense_id=e.object_id limit 1) = ".$bud_st->getId().", 0,
						 		(SELECT pt2.amount FROM ".TABLE_PREFIX."payment_totals pt2
						 		WHERE pt2.payment_id=pp.object_id AND pt2.status_id=pp.status_id )
						 	))) as balance,
					(SELECT pp.currency FROM ".TABLE_PREFIX."payments pp WHERE pp.expense_id=e.object_id limit 1) as currency_id_balance
				";
					
				
				/*	
					$active_member_ids = active_context_members(false);
					if (count($active_member_ids) > 0) {
						$payment_context_cond = "
							AND EXISTS (
								SELECT om.object_id FROM ".TABLE_PREFIX."object_members om
								WHERE om.member_id IN (".implode(',', $active_member_ids).") AND et".$status['id'].".payment_id = om.object_id
								GROUP BY object_id
								HAVING count(member_id) = ".count($active_member_ids)."
							)";
					}
	*/
					
						
					//			$payment_context_cond
	
				//	$results['gb_sql'][] = " currency_id_balance";
				
			} else {
				/*
				$results['cols_sql'][] = "
					SUM((SELECT pt.amount FROM ".TABLE_PREFIX."payment_totals pt 
					 WHERE pt.payment_id=o.id AND pt.status_id=".$bud_st->getId().") -
					 IF (e.status_id = ".$bud_st->getId().", 0, 
					 		(SELECT pt2.amount FROM ".TABLE_PREFIX."payment_totals pt2 
					 		WHERE pt2.payment_id=o.id AND pt2.status_id=e.status_id )
					 	)) as balance,
					e.currency as currency_id_balance";
				
				$results['gb_sql'][] = " currency_id_balance";
				*/
			}
	}

}

