og.advanced_expenses = {
	
	init: function() {
		for (x in og.dimension_object_types) {
			if (!og.dimension_object_types[x] || typeof(og.dimension_object_types[x])=='function') continue;
			if (og.dimension_object_types[x] == 'strategic_axe') {
				og.additional_on_dimension_object_click[x] = "og.memberTreeExternalClick('strategic_axes', <parameters>);";
			} else if (og.dimension_object_types[x] == 'strategic_objective') {
				og.additional_on_dimension_object_click[x] = "og.memberTreeExternalClick('objectives_activities', <parameters>);";
			} else if (og.dimension_object_types[x] == 'activity' || og.dimension_object_types[x] == 'sub_activity') {
				og.additional_on_dimension_object_click[x] = "og.memberTreeExternalClick('activities', <parameters>);";
			} else if (og.dimension_object_types[x] == 'division') {
				og.additional_on_dimension_object_click[x] = "og.memberTreeExternalClick('divisions', <parameters>);";
			} else if (og.dimension_object_types[x] == 'funding_source') {
				og.additional_on_dimension_object_click[x] = "og.memberTreeExternalClick('funding_sources', <parameters>);";
			} else if (og.dimension_object_types[x] == 'executor_unit') {
				og.additional_on_dimension_object_click[x] = "og.memberTreeExternalClick('executor_units', <parameters>);";
			}
		}
		
		if (!og.expenses.modify_expenses_subtabs) og.expenses.modify_expenses_subtabs = [];
		og.expenses.modify_expenses_subtabs.push(function(expenses_subtabs) {
			// remove expenses tab -> should be configurable
			for (var j=0; j<expenses_subtabs.length; j++) {
				if (expenses_subtabs[j].id == 'subtab-expense') {
					expenses_subtabs.splice(j, 1);
					j--;
				}
			}
			
			// add quotas subtab
			expenses_subtabs.push({
				title:lang("quotas"),
				id: 'subtab-quota',
				panel_id: 'exp-subtab-quotas',
				html:'<div id="exp-tab-quotas" style="height:100%;"></div>'
			});
		});
		
		// quota listing configuration for columns and toolbars
		og.openLink(og.getUrl('quota', 'get_quota_list_config'), {
			preventPanelLoad: true,
			callback: function(success, data){
				eval(data.html);
				return;
			}
		});
		
		// Quotas listing load function
		if (!og.expenses.load_subtab_functions) og.expenses.load_subtab_functions = [];
		og.expenses.load_subtab_functions.push(function(t) {
			if (t.panel_id == 'exp-subtab-quotas') {
				var p = Ext.getCmp(t.panel_id);
				if (!p) {
					var quotas_panel = new og.ObjectGrid({
						renderTo: 'exp-tab-quotas',
						url: og.getUrl('quota', 'list_all'),
						type_name: 'quota',
						response_objects_root: 'quotas',
						grid_id: t.panel_id,
						nameRenderer: og.gridObjectNameRenderer,
						fixed_height: true,
						forceFit: false,
						store_params: {
							url_controller: 'quota',
							url_action: 'list_all'
						},
						checkbox_sel_model: true,
						add_default_actions_column: false,
						columns: og.expenses.quota_list_grid_config.columns,
						tbar_items: og.expenses.quota_list_grid_config.tbar_items,
						filters: og.expenses.quota_list_grid_config.filters,
						allowed_dimension_columns: og.expenses.quota_dimension_ids
					});
					
					if (!og.ExpenseManagerPanel.other_panels) og.ExpenseManagerPanel.other_panels = [];
					og.ExpenseManagerPanel.other_panels.push(quotas_panel);
					quotas_panel.load();
				}
			}
		});
		
		


		// SHOW OR HIDE NEW PAYMENT MENU ITEMS DEPENDING ON THE SELECTED DIVISION
		og.eventManager.addListener('member changed', function(node) {
			
			if (node.ownerTree.dimensionCode == 'divisions') {
				
				var new_payment_menu = Ext.getCmp('pgrid_new_payment_btn');
				if (!new_payment_menu) return;
				
				if (node.isRoot) {
					// show all menu items
					for (var i=0; i<new_payment_menu.menu.items.items.length; i++) {
						var menu_item = new_payment_menu.menu.items.items[i];
						if (menu_item) menu_item.show();
					}
					
				} else {
					var index_to_enable = -1;
					// hide all menu items
					for (var i=0; i<new_payment_menu.menu.items.items.length; i++) {
						var menu_item = new_payment_menu.menu.items.items[i];
						if (menu_item) menu_item.hide();

						if (node.id == menu_item.member_id) {
							index_to_enable = i;
						}
					}
					// show only the menu item corresponding to the division
					if (index_to_enable > -1) {
						new_payment_menu.menu.items.items[index_to_enable].show();
					}
				}
			}
				
		}, this);
		
		/*
		if (!og.extra_expense_list_columns) og.extra_expense_list_columns = [];
		og.extra_expense_list_columns.push({
			id: 'balance',
			name: 'balance',
			dataIndex: 'balance',
			header: lang('balance'),
			align: 'right',
			renderer: og.renderAmountColumn
		});*/
	}
}

