<?php 

function advanced_expenses_update_1_2() {
	// expense-payment hierarchy options
	
	DB::executeAll("
		INSERT INTO ".TABLE_PREFIX."object_type_hierarchies (parent_object_type_id, child_object_type_id) VALUES
			((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='expense'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment'))
		ON DUPLICATE KEY UPDATE id=id;
	");
	
	DB::executeAll("
		INSERT INTO ".TABLE_PREFIX."object_type_hierarchy_options (hierarchy_id, dimension_id, member_type_id, `option`, `value`) VALUES
		(
			(SELECT id FROM ".TABLE_PREFIX."object_type_hierarchies WHERE parent_object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='expense') AND child_object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment')),
			(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='funding_sources'),
			(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='funding_source'),
			'filter_by_parent_members',
			'1'
		),(
			(SELECT id FROM ".TABLE_PREFIX."object_type_hierarchies WHERE parent_object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='expense') AND child_object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment')),
			(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='funding_sources'),
			(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='funding_source'),
			'autoclassify_in_parent_members',
			'1'
		),(
			(SELECT id FROM ".TABLE_PREFIX."object_type_hierarchies WHERE parent_object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='expense') AND child_object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment')),
			(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='executor_units'),
			(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='executor_unit'),
			'filter_by_parent_members',
			'1'
		),(
			(SELECT id FROM ".TABLE_PREFIX."object_type_hierarchies WHERE parent_object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='expense') AND child_object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment')),
			(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='executor_units'),
			(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='executor_unit'),
			'autoclassify_in_parent_members',
			'1'
		),(
			(SELECT id FROM ".TABLE_PREFIX."object_type_hierarchies WHERE parent_object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='expense') AND child_object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment')),
			(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='divisions'),
			(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='division'),
			'filter_by_parent_members',
			'1'
		),(
			(SELECT id FROM ".TABLE_PREFIX."object_type_hierarchies WHERE parent_object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='expense') AND child_object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment')),
			(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='divisions'),
			(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='division'),
			'autoclassify_in_parent_members',
			'1'
		)
		ON DUPLICATE KEY UPDATE hierarchy_id=hierarchy_id;
	");
	
	DB::executeAll("
		INSERT INTO ".TABLE_PREFIX."dimension_associations_config (association_id, config_name, value)
			SELECT id, 'autoclassify_in_property_member_by_child', '1'
			FROM ".TABLE_PREFIX."dimension_member_associations 
			WHERE dimension_id = (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='objectives_activities')
				AND associated_dimension_id = (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='strategic_axes')
		ON DUPLICATE KEY UPDATE value=value;
	");
	
	DB::executeAll("
		INSERT INTO `".TABLE_PREFIX."dimension_content_object_options` (`dimension_id`,`content_object_type_id`,`option`,`value`) 
			SELECT d.id, ot.id, 'hide_member_selector_in_forms', '1'
			FROM ".TABLE_PREFIX."dimensions d LEFT JOIN ".TABLE_PREFIX."object_types ot ON true
			WHERE ot.name IN ('payment','expense') AND d.code IN ('strategic_axes')
		ON DUPLICATE KEY UPDATE `value`=`value`;
	");
	
	DB::executeAll("
		INSERT INTO `".TABLE_PREFIX."dimension_content_object_options` (`dimension_id`,`content_object_type_id`,`option`,`value`) 
			SELECT d.id, ot.id, 'hide_member_selector_in_forms', '0'
			FROM ".TABLE_PREFIX."dimensions d LEFT JOIN ".TABLE_PREFIX."object_types ot ON true
			WHERE ot.name IN ('payment') AND d.code IN ('divisions','activities')
		ON DUPLICATE KEY UPDATE `value`='0';
	");
	
	// ensure that payments classification is not multiple for this plugin's dimensions
	DB::executeAll("
		UPDATE `".TABLE_PREFIX."dimension_object_type_contents` SET is_multiple = 0
		WHERE content_object_type_id = (SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'payment')
			AND dimension_id IN (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code IN ('strategic_axes','objectives_activities','divisions','funding_sources','executor_units'));
	");
	
	// set expenses classification multiple only for divisions, funding_sources and executor_units
	DB::executeAll("
		UPDATE `".TABLE_PREFIX."dimension_object_type_contents`
			SET is_multiple = (dimension_object_type_id IN (SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name IN ('division', 'funding_source', 'executor_unit')))
			WHERE content_object_type_id = (SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'expense')
			AND dimension_id IN (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code IN ('strategic_axes','objectives_activities','divisions','funding_sources','executor_units'));
	");
}


function advanced_expenses_update_2_3() {
	// new payment state: in process
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."expenses_status` (`order`, `code`, `name`, `description`, `editable`, `created_on`, `created_by_id`, `enabled`, `is_final`, `is_temporal`, `only_for_expenses`)
		VALUES ('5', 'in_process', '', '', '', now(), '2', '1', '', '1', '');
	");
}


function advanced_expenses_update_3_4() {
	// quota content object
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."quotas` (
		  `object_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
		  `currency_id` int(10) unsigned NOT NULL DEFAULT 0,
		  `amount` decimal(20,3) NOT NULL DEFAULT 0,
		  `spent_amount` decimal(20,3) NOT NULL DEFAULT 0,
		  PRIMARY KEY (`object_id`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."payments` ADD `quota_id` int(10) unsigned NOT NULL DEFAULT 0;");
	
	DB::execute("ALTER TABLE `".TABLE_PREFIX."payments` ADD INDEX `quota_id` (`quota_id`);");
	
	DB::execute("ALTER TABLE `".TABLE_PREFIX."payment_history` ADD `quota_id` int(10) unsigned NOT NULL DEFAULT 0;");
	DB::execute("ALTER TABLE `".TABLE_PREFIX."payment_history` ADD INDEX `quota_id` (`quota_id`);");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
		 ('quota', 'Quotas', 'quotas', 'content_object', 'quota', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='advanced_expenses'), 0)
		ON DUPLICATE KEY UPDATE id=id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT dimension_id, dimension_object_type_id, (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='quota'),
		 (d.code IN ('objectives_activities', 'divisions', 'funding_sources', 'executor_units')), 1
		 FROM `".TABLE_PREFIX."dimension_object_type_contents` x
		 INNER JOIN ".TABLE_PREFIX."dimensions d ON d.id=x.dimension_id
		 WHERE x.`content_object_type_id` = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='task')
		 AND d.code IN ('objectives_activities', 'divisions', 'funding_sources', 'executor_units')
		ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."dimension_object_type_contents.dimension_id=".TABLE_PREFIX."dimension_object_type_contents.dimension_id;
	");
	
	DB::execute("
		DELETE FROM `".TABLE_PREFIX."dimension_object_type_contents` WHERE `dimension_id`=0 OR dimension_id IS NULL;
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 1, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('quota')
			 AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 0, 0
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('quota')
			 AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 1, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('quota')
			AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
		 SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='quota'), cmp.can_delete, cmp.can_write 
		 FROM ".TABLE_PREFIX."contact_member_permissions cmp
		 INNER JOIN ".TABLE_PREFIX."members m ON m.id=cmp.member_id
		 WHERE cmp.object_type_id = (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='task')
		 AND m.dimension_id IN (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code IN ('objectives_activities', 'divisions', 'funding_sources', 'executor_units'))
		ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."contact_member_permissions.member_id=".TABLE_PREFIX."contact_member_permissions.member_id;
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."custom_properties (`object_type_id`,`name`,`code`,`type`,`visible_by_default`,`property_order`) VALUES
		((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='quota'), '".lang('description')."', 'description', 'memo', 1, 1);
	");
	
}


// separate activities to other dimension
function advanced_expenses_update_4_5() {
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimensions` (`code`,`name`,`is_root`,`is_manageable`,`allows_multiple_selection`,`defines_permissions`,`default_order`, `is_default`, `options`) VALUES
		('activities','Activities',1,1,0,1,11,1,'{\"defaultAjax\":{\"controller\":\"dashboard\",\"action\":\"main_dashboard\"},\"useLangs\":true,\"quickAdd\":true,\"showInPaths\":true}' );
	");
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."dimension_options (`dimension_id`, `name`, `value`) VALUES
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='activities'),'useLangs','1'),
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='activities'),'showInPaths','1')
		ON DUPLICATE KEY UPDATE `value`=`value`;
	");
	DB::execute("
		-- associate dimension with member object types
		INSERT INTO `".TABLE_PREFIX."dimension_object_types` (`dimension_id`,`object_type_id`,`is_root`,`options`) VALUES
		(
		   (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='activities'),
		   (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'activity' ),
		   1, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}'
		),(
		   (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='activities'),
		   (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'sub_activity' ),
		   0, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}'
		);
	");
	DB::execute("
		DELETE FROM `".TABLE_PREFIX."dimension_object_types`
		WHERE dimension_id=(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='objectives_activities')
		AND object_type_id IN (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name IN ('activity','sub_activity'));
	");
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."dimension_object_type_options (`dimension_id`, `object_type_id`, `name`, `value`) VALUES
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='activities'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='activity'),'select_after_creation','1'),
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='activities'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='sub_activity'),'select_after_creation','1')
		ON DUPLICATE KEY UPDATE `value`=`value`;
	");
	DB::execute("
		DELETE FROM ".TABLE_PREFIX."dimension_object_type_options
		WHERE dimension_id=(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='objectives_activities')
		AND object_type_id IN (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name IN ('activity','sub_activity'));
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='activities'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='activity'),
		 	`id`, 0, 1
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `type` IN ('content_object', 'comment', 'located')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='activities'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='sub_activity'),
		 	`id`, 0, 1
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `type` IN ('content_object', 'comment', 'located')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	DB::execute("
		DELETE FROM ".TABLE_PREFIX."dimension_object_type_contents
		WHERE dimension_id=(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='objectives_activities')
		AND dimension_object_type_id IN (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name IN ('activity','sub_activity'));
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_hierarchies` (dimension_id, parent_object_type_id, child_object_type_id)
		VALUES
		(
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='activities'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'activity'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'activity')
		),(
		  (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='activities'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'activity'),
		  (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'sub_activity')
		)
	");
	DB::execute("
		DELETE FROM ".TABLE_PREFIX."dimension_object_type_hierarchies
		WHERE dimension_id=(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='objectives_activities')
		AND parent_object_type_id IN (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name IN ('activity','sub_activity'));
	");
	DB::execute("
		DELETE FROM ".TABLE_PREFIX."dimension_object_type_hierarchies
		WHERE dimension_id=(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='objectives_activities')
		AND child_object_type_id IN (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name IN ('activity','sub_activity'));
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_member_associations` (`dimension_id`,`object_type_id`,`associated_dimension_id`, `associated_object_type_id`, `is_required`,`is_multiple`, `keeps_record`) VALUES
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'activities'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'activity'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'strategic_axes'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'strategic_axe'),0,1,0),
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'activities'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'activity'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'objectives_activities'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'strategic_objective'),0,1,0)
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	DB::execute("
		DELETE FROM ".TABLE_PREFIX."dimension_member_associations
		WHERE dimension_id=(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='objectives_activities')
		AND associated_dimension_id=(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='strategic_axes');
	");
	DB::execute("
		UPDATE `".TABLE_PREFIX."contact_config_options`
		 SET default_value = concat(default_value,',', (SELECT GROUP_CONCAT(`id`) FROM `".TABLE_PREFIX."dimensions` WHERE `code` IN ('activities')) )
		WHERE name='root_dimensions';
	");
	DB::execute("
		UPDATE `".TABLE_PREFIX."config_options`
		 SET value = concat(`".TABLE_PREFIX."config_options`.`value`,',', (SELECT GROUP_CONCAT(`id`) FROM `".TABLE_PREFIX."dimensions` WHERE `code` IN ('activities')) )
		WHERE name='enabled_dimensions';
	");
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."contact_dimension_permissions (permission_group_id, dimension_id, permission_type)
		 SELECT c.permission_group_id, (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='activities'), 'allow all'
		 FROM ".TABLE_PREFIX."contacts c
		 WHERE c.user_type = (SELECT pg.id FROM ".TABLE_PREFIX."permission_groups pg WHERE pg.type='roles' AND pg.name IN ('Super Administrator'))
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`) VALUES
		 ('listing preferences', 'lp_dim_activities_show_as_column', '1', 'BoolConfigHandler', 0, 0)
		ON DUPLICATE KEY UPDATE name=name;
	");
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."dimension_associations_config (association_id, config_name, value)
			SELECT id, 'autoclassify_in_property_member_by_child', '1'
			FROM ".TABLE_PREFIX."dimension_member_associations
			WHERE dimension_id = (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='activities')
				AND associated_dimension_id = (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='strategic_axes')
		ON DUPLICATE KEY UPDATE value=value;
	");
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."dimension_associations_config (association_id, config_name, value)
			SELECT id, 'autoclassify_in_property_member_by_child', '1'
			FROM ".TABLE_PREFIX."dimension_member_associations
			WHERE dimension_id = (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='activities')
				AND associated_dimension_id = (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='objectives')
		ON DUPLICATE KEY UPDATE value=value;
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT dimension_id, dimension_object_type_id, (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='quota'), 1, 0
		 FROM `".TABLE_PREFIX."dimension_object_type_contents` x
		 INNER JOIN ".TABLE_PREFIX."dimensions d ON d.id=x.dimension_id
		 WHERE x.`dimension_object_type_id` = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='activity')
		 AND x.`content_object_type_id` = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='task')
		 AND d.code IN ('activities')
		ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."dimension_object_type_contents.dimension_id=".TABLE_PREFIX."dimension_object_type_contents.dimension_id;
	");
	DB::execute("
		DELETE FROM ".TABLE_PREFIX."dimension_object_type_contents
		WHERE dimension_id=(SELECT id from ".TABLE_PREFIX."dimensions WHERE code='objectives_activities')
		AND content_object_type_id=(SELECT id from ".TABLE_PREFIX."object_types WHERE name='quota');
	");
	DB::executeAll("
		UPDATE `".TABLE_PREFIX."dimension_object_type_contents` SET is_multiple = 0, is_required=1
		WHERE content_object_type_id = (SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'quota')
			AND dimension_id IN (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code IN ('activities','divisions','funding_sources','executor_units'));
	");
	DB::executeAll("
		UPDATE `".TABLE_PREFIX."dimension_object_type_contents` SET is_multiple = 0
		WHERE content_object_type_id = (SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'payment')
			AND dimension_id IN (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code IN ('activities'));
	");
	DB::execute("
		DELETE FROM ".TABLE_PREFIX."dimension_object_type_contents
		WHERE dimension_id=(SELECT id from ".TABLE_PREFIX."dimensions WHERE code='activities')
		AND dimension_object_type_id=(SELECT id from ".TABLE_PREFIX."object_types WHERE name='sub_activity')
		AND content_object_type_id=(SELECT id from ".TABLE_PREFIX."object_types WHERE name='quota');
	");

	$act_dim = Dimensions::findByCode('activities');
	$obj_dim = Dimensions::findByCode('objectives_activities');
	$act_ot = ObjectTypes::findByName('activity');
	$sub_act_ot = ObjectTypes::findByName('sub_activity');
	$a = DimensionMemberAssociations::findOne(array(
		"conditions" => "dimension_id=".$act_dim->getId()." AND associated_dimension_id=".$obj_dim->getId()
	));
	
	DB::execute("INSERT INTO ".TABLE_PREFIX."member_property_members (association_id, member_id, property_member_id, is_active, created_on, created_by_id)
		SELECT ".$a->getId().", m.id, m.parent_member_id, 1, NOW(), 0
		FROM ".TABLE_PREFIX."members m
		WHERE m.object_type_id=".$act_ot->getId().";
	");

	DB::execute("
		UPDATE ".TABLE_PREFIX."members SET parent_member_id=0, depth=1, dimension_id=".$act_dim->getId()."
		WHERE object_type_id = ".$act_ot->getId()."
	");
	DB::execute("
		UPDATE ".TABLE_PREFIX."members SET depth=3, dimension_id=".$act_dim->getId()."
		WHERE object_type_id = ".$sub_act_ot->getId()."
	");
}

// relations with suppliers and new item member
function advanced_expenses_update_5_6() {
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_member_associations` (`dimension_id`,`object_type_id`,`associated_dimension_id`, `associated_object_type_id`, `is_required`,`is_multiple`, `keeps_record`) VALUES
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'suppliers'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'supplier'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'divisions'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'division'),0,0,0),
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'suppliers'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'supplier'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'executor_units'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'executor_unit'),0,0,0)
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`) VALUES
		 ('item', '', '', 'dimension_group', '', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='advanced_expenses'))
		ON DUPLICATE KEY UPDATE id=id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_types` (`dimension_id`,`object_type_id`,`is_root`,`options`) VALUES 
		(
		   (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='divisions'),
		   (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'item' ),
		   0, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}'
		);
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='divisions'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='item'),
		 	`id`, 0, 1
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `type` IN ('content_object', 'comment', 'located')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		UPDATE ".TABLE_PREFIX."dimension_object_type_hierarchies
		SET child_object_type_id=(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='item')
		WHERE dimension_id=(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='divisions')
			AND parent_object_type_id=(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='division');
	");
	
	DB::execute("
		UPDATE ".TABLE_PREFIX."members SET object_type_id=(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='item')
		WHERE dimension_id=(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='divisions')
			AND parent_member_id>0;
	");
}

function advanced_expenses_update_6_7() {
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_content_object_options` (`dimension_id`,`content_object_type_id`,`option`, `value`) VALUES
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'divisions'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'payment'), 'forces_object_subtype', '1')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
}

function advanced_expenses_update_7_8() {
	// Update every quota's searchable objects registries
	$quotas = Quotas::findAll();
	foreach ($quotas as $quota) {
		$quota->addToSearchableObjects(true);
	}
	
}

