<?php
	class MailAccountMember extends BaseMailAccountMember {
		
		function getEditUrl() {
			
			if (!$this->getAccountId()) {
				$data = DB::executeOne("SELECT * FROM ".$this->getTableName()." WHERE object_id=".$this->getObjectId());
				if (is_array($data)) {
					$this->setFromAttributes($data);
				}
			}
			
			$mail_account = MailAccounts::findById($this->getAccountId());
			if ($mail_account instanceof MailAccount) {
				return get_url('mail', 'edit_account', array('id' => $mail_account->getId()));
			}
			return " ";
		}
		
		function canAdd(Contact $user, $context, &$notAllowedMember = ''){
			//return can_add($user, $context, MailAccountMembers::instance()->getObjectTypeId(), $notAllowedMember);
		}
		
		/**
		 * Returns true if $user can access this mail account
		 *
		 * @param Contact $user
		 * @return boolean
		 */
		function canView(Contact $user) {
			$mail_account = MailAccounts::findById($this->getAccountId());
			if ($mail_account instanceof MailAccount) {
				$mac = MailAccountContacts::instance()->getByAccountAndContact($mail_account, $user);
				if ($mac instanceof MailAccountContact) {
					return true;
				}
			}
			return false;
		} // canView
	
		/**
		 * Check if specific user can edit this mail accounts
		 *
		 * @access public
		 * @param Contact $user
		 * @return boolean
		 */
		function canEdit(Contact $user) {
			$mail_account = MailAccounts::findById($this->getAccountId());
			if ($mail_account instanceof MailAccount) {
				$mac = MailAccountContacts::instance()->getByAccountAndContact($mail_account, $user);
				if ($mac instanceof MailAccountContact && $mac->getCanEdit()) {
					return true;
				}
			}
			return false;
		} // canEdit
	
	
		/**
		 * Check if specific user can delete this mail accounts
		 *
		 * @access public
		 * @param Contact $user
		 * @return boolean
		 */
		function canDelete(Contact $user) {
			$mail_account = MailAccounts::findById($this->getAccountId());
			if ($mail_account instanceof MailAccount) {
				$mac = MailAccountContacts::instance()->getByAccountAndContact($mail_account, $user);
				if ($mac instanceof MailAccountContact && $mac->getCanEdit()) {
					return true;
				}
			}
			return false;
		} // canDelete
	
		/**
		 * Check if specific user can comment this mail account
		 *
		 * @access public
		 * @param void
		 * @return boolean
		 */
		function canAddComment(Contact $user) {
			return false;
		} // canAddComment
	}