<?php


	function file_access_report_print_group($group_obj, $grouped_objects, $options, $skip_groups = array(), $level = 0, $prev = "", &$crumbJs = "") {
		
		$margin_left = 15 * $level;
		$cls_suffix = $level > 2 ? "all" : $level;
		$next_level = $level + 1;
		
		$group_name = $group_obj['group']['name'];
		echo '<div style="margin-left:' . $margin_left.'px;" class="report-group-heading-'.$cls_suffix.'">' . $group_name . '</div>';
		
		$mem_index = $prev . $group_obj['group']['id'];
		
		// draw the table for the values
		if (isset($grouped_objects[$mem_index]) && count($grouped_objects[$mem_index]) > 0) {
			file_access_report_print_table($grouped_objects[$mem_index], $margin_left, $options, $group_name, $crumbJs);
		}
		
		if (!is_array($group_obj['subgroups'])) return;
		
		$subgroups = order_groups_by_name($group_obj['subgroups']);
		foreach ($subgroups as $subgroup) {
			file_access_report_print_group($subgroup, $grouped_objects, $options, array(), $next_level, $prev . $group_obj['group']['id'] . "_", $crumbJs);
		}
	}
	
	
	function file_access_report_print_table($objects, $left, $options, $group_name, &$crumbJs = "") {
		echo '<div style="padding-left:'. $left .'px;">';
		echo '<table class="reporting-table"><tr class="reporting-table-heading">';
		echo '<th>' . lang('date') . '</th>';
		echo '<th>' . lang('file') . '</th>';
		echo '<th>' . lang('related to') . '</th>';
		echo '<th>' . lang('action') . '</th>';
		echo '<th>' . lang('user') . '</th>';
		echo '</tr>';
		
		$alt_cls = "";
		$cols = 5;
		foreach ($objects as $t) {
			file_access_report_print_log($t, 0, $cols, $options, $alt_cls, $crumbJs);
			$alt_cls = $alt_cls == "" ? 'class="alt-row"' : "";
		}
		
		echo '</table></div>';
	}
	
	
	function file_access_report_print_log(ApplicationReadLog $log, $margin_left, $cols, $options, &$alt_cls='', &$crumbJs='') {
		echo "<tr $alt_cls>";
		echo "<td class='person'><span style='padding-left:".$margin_left."px;'>" . format_datetime($log->getCreatedOn()) ."</td>";
		
		$document = Objects::findObject($log->getRelObjectId());
		echo "<td>" . ($document instanceof ContentDataObject ? $document->getObjectName() : lang('n/a')) . "</td>";
		
		echo '<td class="person"><span id="log-'.$log->getId().'" style="font-weight:normal;"></span></td>';
		
		$obj = $log->getObject();
		$crumbOptions = $obj->getMembersToDisplayPath();
		$crumbJs .= escape_character("var crumbHtml = og.getEmptyCrumbHtml(".json_encode($crumbOptions).", null, null, null, 13, 50);");
		$crumbJs .= 'document.getElementById("log-'. $log->getId().'").innerHTML = crumbHtml;';
		
		echo "<td class='person'>" . lang($log->getAction()) ."</td>";
		
		$person_name = isset($options['users'][$log->getCreatedById()]) ? $options['users'][$log->getCreatedById()]->getObjectName() : lang('n/a');
		echo "<td class='person'>" . clean($person_name) . "</td>";
		
		
		echo "</tr>";
	}
	

	$date_format = user_config_option('date_format');
	if ($start_time instanceof DateTimeValue) { ?>
		<span class="bold"><?php echo lang('from')?></span>:&nbsp;<?php echo $start_time->format($date_format) ?>
	<?php }
	if ($end_time instanceof DateTimeValue) { ?>
		<span class="bold" style="padding-left:10px"><?php echo lang('to date')?></span>:&nbsp;<?php echo $end_time->format($date_format) ?>
	<?php } ?>
	
	<?php if (count(active_context_members(false)) > 0) : ?>
	<div class="clear"></div>
	<div style="margin-bottom: 10px; padding-bottom: 5px; float:left;">
		<h5><?php echo lang('showing information for')?>:</h5>
		<ul>
		<?php
			$context = active_context();
			foreach ($context as $selection) :
				if ($selection instanceof Member) : ?>
					<li><span class="coViewAction <?php echo $selection->getIconClass()?>"><?php echo $selection->getName()?></span></li>
		<?php 	endif;
			endforeach;
		?>
		</ul>
	</div>
	<div class="clear"></div>
	<?php endif; ?>
	
	<div class="tasks-report-container">
	<?php
	$crumbJs = "";
	
	$options = array_var($_SESSION, 'file_access_report_data', array());
	$options['users'] = $users;
	
	$groups = order_groups_by_name($grouped_logs['groups']);
	foreach ($groups as $gid => $group_obj) {
		file_access_report_print_group($group_obj, $grouped_logs['grouped_objects'], $options, array(), 0, "", $crumbJs);
	}
	?>
	</div>
	<script>
	$(function() {
		eval('<?php echo $crumbJs; ?>');
		og.eventManager.fireEvent('replace all empty breadcrumb');
	});
	</script>
<?php //} ?>