<?php
	$genid = gen_id();
	$report_data = array_var($_SESSION, 'file_access_report_data');
	if (!isset($report_data['filter_by_users'])) $report_data['filter_by_users'] = 'users';
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('advanced_reports', 'file_access_report') ?>" method="post" enctype="multipart/form-data">

<div class="reportTotalTimeParams">
<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo lang('file access report') ?>
		<?php //echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;margin-left:10px')) ?></div>
	</div>
	<div style="padding:5px 0"><?php echo lang('file access report description') ?></div>
</div>
<div class="coInputSeparator"></div>
<div class="coInputMainBlock">
	
	<?php if (count(active_context_members(false)) > 0) : ?>
	<div style="margin-bottom: 15px; padding-bottom: 5px; border-bottom:1px dotted #aaa;">
		<h5><?php echo lang('showing information for')?>:</h5>
		<ul>
		<?php
			$context = active_context();
			foreach ($context as $selection) :
				if ($selection instanceof Member) : ?>
					<li><span class="coViewAction <?php echo $selection->getIconClass()?>"><?php echo $selection->getName()?></span></li>	
		<?php 	endif;
			endforeach;
		?>
		</ul>
	</div>
	<?php else: ?>
	<div style="padding:5px;"></div>
	<?php endif; ?>

	<table>
		<tr style='height:30px;'>
			<td><span class="bold"><?php echo lang("date") ?>:&nbsp;</span></td>
			<td align='left'><?php 
				echo select_box('report[date_type]', array(
					option_tag(lang('none'), -1, array_var($report_data, "date_type") == -1 ? array('selected' => 'selected'):null),
					option_tag(lang('today'), 1, array_var($report_data, "date_type") == 1 ? array('selected' => 'selected'):null),
					option_tag(lang('this week'), 2, array_var($report_data, "date_type") == 2 ? array('selected' => 'selected'):null),
					option_tag(lang('last week'), 3, array_var($report_data, "date_type") == 3 ? array('selected' => 'selected'):null),
					option_tag(lang('this month'), 4, array_var($report_data, "date_type") == 4 ? array('selected' => 'selected'):null),
					option_tag(lang('last month'), 5, array_var($report_data, "date_type") == 5 ? array('selected' => 'selected'):null),
					option_tag(lang('select dates...'), 6, array_var($report_data, "date_type") == 6 ? array('selected' => 'selected'):null)
				), array('onchange' => 'og.dateselectchange(this)'));
			?></td>
		</tr>
		<?php
			if (array_var($report_data, "date_type") == 6) {
				$style = "";
		       	$st = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'date_start_value'));
		       	$et = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'date_end_value'));
			} else {
				$style = 'display:none;';
				$st = DateTimeValueLib::now();
				$et = $st;
			} 
		?>
		<tr class="dateTr"  style="<?php echo $style ?>">
			<td><span class="bold"><?php echo lang("start date") ?>:&nbsp;</span></td>
			<td align='left'><?php echo pick_date_widget2('report[date_start_value]', $st, $genid);?></td>
		</tr>
		<tr class="dateTr"  style="<?php echo $style ?>">
			<td style="padding-bottom:18px"><span class="bold"><?php echo lang("end date") ?>:&nbsp;</span></td>
			<td align='left'><?php echo pick_date_widget2('report[date_end_value]', $et, $genid);?></td>
		</tr>
	
		


		<tr style='height:30px;'>
			<td><span class="bold"><?php echo lang("user filter") ?>:&nbsp;</span></td>
			<td align='left'><?php
				$filter_by_users_options = array();
				$filter_by_users_options[] = option_tag(lang('users'), 'users', array_var($report_data, "filter_by_users") == 'users' ? array('selected' => 'selected') : null);
				$filter_by_users_options[] = option_tag(lang('groups'), 'groups', array_var($report_data, "filter_by_users") == 'groups' ? array('selected' => 'selected') : null);
				$filter_by_users_options[] = option_tag(lang('companies'), 'companies', array_var($report_data, "filter_by_users") == 'companies' ? array('selected' => 'selected') : null);
				echo select_box('report[filter_by_users]', $filter_by_users_options, array('id' => $genid.'filter_by_users_combo', 'onchange' => 'og.on_filter_users_change(this,\''.$genid.'\')'));
			
				$filter_select = array_var($report_data, 'filter_by_users');
				
				$user_options = array();
				$user_options[] = option_tag('-- ' . lang('anyone') . ' --', 0, array_var($report_data, "user") == null?array('selected' => 'selected'):null);
				foreach($users as $user){
					$user_options[] = option_tag($user->getObjectName(),$user->getId(), array_var($report_data, "user") == $user->getId()?array('selected' => 'selected'):null);
				}
				echo select_box('report[user]', $user_options, array('id' => $genid.'users_combo', 'style' => $filter_select == 'users' ? '' : 'display:none;'));
				
				$group_options = array();
				$group_options[] = option_tag('-- ' . lang('All') . ' --', 0, array_var($report_data, "group") == null?array('selected' => 'selected'):null);
				foreach($user_groups as $group){
					$group_options[] = option_tag($group->getName(), $group->getId(), array_var($report_data, "group") == $group->getId()?array('selected' => 'selected'):null);
				}
				echo select_box('report[group]', $group_options, array('id' => $genid.'groups_combo', 'style' => $filter_select == 'groups' ? '' : 'display:none;'));
				
				$company_options = array();
				$company_options[] = option_tag('-- ' . lang('All') . ' --', 0, array_var($report_data, "company") == null?array('selected' => 'selected'):null);
				foreach($companies as $company){
					$company_options[] = option_tag($company->getObjectName(), $company->getId(), array_var($report_data, "company") == $company->getId()?array('selected' => 'selected'):null);
				}
				echo select_box('report[company]', $company_options, array('id' => $genid.'companies_combo', 'style' => $filter_select == 'companies' ? '' : 'display:none;'));
			?></td>
		</tr>



		
		<tr style='height:30px;'>
			<td><span class="bold"><?php echo lang("action") ?>:&nbsp;</span></td>
			<td align='left'><?php 
				$options = array();
				$options[] = option_tag(lang('download'), ApplicationReadLogs::ACTION_DOWNLOAD, array_var($report_data, "action") == ApplicationReadLogs::ACTION_DOWNLOAD ?array('selected' => 'selected'):null);
				$options[] = option_tag(lang('read'), ApplicationReadLogs::ACTION_READ, array_var($report_data, "action") == ApplicationReadLogs::ACTION_READ ? array('selected' => 'selected'):null);
				$options[] = option_tag(lang('All'), 'all', array_var($report_data, "action") == 'all' ? array('selected' => 'selected'):null);
				echo select_box('report[action]', $options);
			?></td>
		</tr>
		
		
		<tr style='height:30px;' id="<?php echo $genid ?>repGroupBy">
			<td><span class="bold"><?php echo lang("group by") ?>:&nbsp;</span></td>
			<td align='left'>
				<span id="<?php echo $genid ?>gbspan">
					<?php for ($i = 1; $i <= 3; $i++){ 
						$gbVal = array_var($report_data, "group_by_$i");
						?>
					<select id="<?php echo $genid ?>group_by_<?php echo $i ?>" name="report[group_by_<?php echo $i ?>]" )">
						<option value="0"<?php if ($gbVal == null) echo ' selected="selected"' ?>><?php echo lang('none') ?></option>
						<option value="created_by_id"<?php if ($gbVal == 'created_by_id') echo ' selected="selected"' ?>><?php echo lang('user') ?></option>
						<?php
							$gbs = array();
							Hook::fire('total_task_timeslots_group_by_criterias', null, $gbs);
							foreach($gbs as $gb) { ?>
								<option value="<?php echo $gb['val']?>"<?php if ($gbVal == $gb['val']) echo ' selected="selected"' ?>><?php echo $gb['name']?></option>
						<?php } ?>
					</select>
					<?php } // for ?>
				</span>
			</td>
		</tr>
		
	</table>
	
<br/>
<?php echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;')) ?>
</div>
</div>

</form>
<script>
og.on_filter_users_change = function(combo, genid) {

	document.getElementById(genid + 'users_combo').style.display = 'none';
	document.getElementById(genid + 'groups_combo').style.display = 'none';
	document.getElementById(genid + 'companies_combo').style.display = 'none';

	var sel_value = combo.options[combo.selectedIndex].value;
	document.getElementById(genid + sel_value + '_combo').style.display = '';
}
</script>