<?php
if (!isset($genid)) $genid = gen_id();
if (!isset($allow_export)) $allow_export = true;
if (!isset($allow_export_pdf)) $allow_export_pdf = true;
if (!isset($allow_export_csv)) $allow_export_csv = true;
if (!isset($hide_print_report_header)) $hide_print_report_header = 'false';

tpl_assign('genid', $genid);

if (!isset($print_action_url)) {
	$print_action_url = get_url('advanced_reports', $template_name . '_print');
}
if (!isset($report_template_path)) {
	$report_template_path = get_template_path($template_name, 'advanced_reports');
}
  	/*add_page_action(lang('print view'), '#', "ico-print", "_blank", array('onclick' => 'this.form' . $genid . '.submit'));*/
?>
<form id="form<?php echo $genid ?>" name="form<?php echo $genid ?>" action="<?php echo $print_action_url ?>" method="post" enctype="multipart/form-data" target="_download">

    <input id="post<?php echo $genid ?>" name="post" type="hidden" value="<?php echo isset($post) ? str_replace('"',"'", json_encode($post)) : ''?>"/>
    
<div class="report">
	<table class="report-wrapper--main-container">

			<tr><td class="report-wrapper--header-container">
				<div class="coViewTitle report-wrapper--title"><?php echo $title ?></div>
				<div class="report-wrapper--export-buttons">

					<input type="submit" name="print" value="<?php echo lang('print') ?>" onclick="og.reports.printNoPaginatedReport('<?php echo $genid?>','<?php echo $title ?>', <?php echo $hide_print_report_header ?>); return false;"/>

					<?php if ($allow_export) { ?>
						<?php if ($allow_export_csv) { ?>
						<input type="submit" name="exportCSV" value="<?php echo lang('csv') ?>" onclick="og.advanced_reports.submit_csv_form('<?php echo $genid ?>');return false;"/>
						<?php } ?>
						<?php if ($allow_export_pdf) { ?>
						<input type="button" name="exportPDFOptions" onclick="og.openPDFOptions('<?php echo $genid?>');" value="<?php echo lang('pdf') ?>"/>
						<?php } ?>
						<?php if (Plugins::instance()->isActivePlugin('advanced_core') && 
								isset($excel_export_action) && $excel_export_action) { ?>
						<input type="submit" name="exportExcel" value="<?php echo lang('excel') ?>" onclick="<?php echo $excel_export_action ?>('<?php echo $genid ?>');return false;"/>
						<?php } ?>
					<?php } ?>
					<?php
					// close button
                      $on_close_click = "og.closeView();";
                      if (array_var($_REQUEST, 'go_to_tab')) {
                      	$on_close_click .= "var tab = Ext.getCmp('".array_var($_REQUEST, 'go_to_tab')."'); if (tab) Ext.getCmp('tabs-panel').setActiveTab(tab);" ;
					  }
					?>
					<input type="button" name="closeReport" class="report-wrapper--button-close" onclick="<?php echo $on_close_click?>" value="<?php echo lang('close') ?>"/>

					<input name="parameters" type="hidden" value="<?php echo isset($post) ? str_replace('"',"'", json_encode($post)) : ''?>"/>
					<input name="context" type="hidden" value="" id="<?php echo $genid?>_plain_context"/>
				</div>
			</td></tr>
		
		
			<tr><td class="report-wrapper--report-container" id="<?php echo $genid?>report_container">
				<?php $this->includeTemplate($report_template_path);?>
			</td></tr>			
	</table>
</div>
</form>

<div id="pdfOptions" style="display:none;">
  <div class="coInputMainBlock" style="background-color:white; padding:10px; border-radius: 5px;">
	<div class="coInputTitle" style="min-width: 100px;margin-bottom:15px;">
		<?php echo lang('report pdf options') ?>
	</div>

	<?php 
		// Get config options to set default pdf layout and pdf size
		$pdf_layout = user_config_option('pdf_page_layout');
		$pdf_page_size = user_config_option('pdf_page_size');
		if($pdf_page_size == '') $pdf_page_size = 'A4';
	?>

	<div class="dataBlock">
		<label><?php echo lang('report pdf page layout') ?></label>
		<select name="pdfPageLayout" id="{gen_id}pdfPageLayout">
			<option value="P" <?php if($pdf_layout == 'Portrait') echo 'selected' ?>><?php echo lang('report pdf vertical') ?></option>
			<option value="L" <?php if($pdf_layout == 'Landscape') echo 'selected' ?>><?php echo lang('report pdf landscape') ?></option>
		</select>
	</div>
	
	<div class="dataBlock">
		<label><?php echo lang('page size') ?></label>
		<select name="pdfPageSize" id="{gen_id}pdfPageSize">
			<option value="A0"<?php if($pdf_page_size == 'A0') echo 'selected' ?>>A0</option>
			<option value="A1"<?php if($pdf_page_size == 'A1') echo 'selected' ?>>A1</option>
			<option value="A2" <?php if($pdf_page_size == 'A2') echo 'selected' ?>>A2</option>
			<option value="A3" <?php if($pdf_page_size == 'A3') echo 'selected' ?>>A3</option>
			<option value="A4" <?php if($pdf_page_size == 'A4') echo 'selected' ?>>A4</option>
			<option value="A5" <?php if($pdf_page_size == 'A5') echo 'selected' ?>>A5</option>
			<option value="Legal" <?php if($pdf_page_size == 'Legal') echo 'selected' ?>>Legal</option>
			<option value="Letter" <?php if($pdf_page_size == 'Letter') echo 'selected' ?>>Letter</option>
		</select>
	</div>
	
	<div class="dataBlock" style="display:none;">
		<label><?php echo lang('report font size') ?></label>
		<select name="pdfFontSize" id="{gen_id}pdfFontSize">
			<option value="8">8</option>
			<option value="9">9</option>
			<option value="10">10</option>
			<option value="11">11</option>
			<option value="12" selected>12</option>
			<option value="13">13</option>
			<option value="14">14</option>
			<option value="15">15</option>
			<option value="16">16</option>
		</select>
	</div>
	<?php if (!isset($pdf_export_function)) $pdf_export_function = 'og.submit_pdf_form'; ?>
	<button type="submit" class="submit" name="exportPDF" onclick="<?php echo $pdf_export_function ?>('<?php echo $genid?>');">
	<?php echo lang('export') ?>
	</button>
	<div class="clear"></div>
	
  </div>
</div>
<script>
document.getElementById('<?php echo $genid?>_plain_context').value = og.contextManager.plainContext();

// get the sticky element and toggle 'isSticky' class
/*var stickyElm = document.querySelector('.report-wrapper--header-container');
var observer = new IntersectionObserver(function (_ref) {
  var e = _ref[0];
  return e.target.classList.toggle('isSticky', e.intersectionRatio < 1);
}, {
  threshold: [1]
});
observer.observe(stickyElm);
*/
</script>