

<table class="gruoped-timeslots report" style="width:100%;">
<?php 
	$ts_ot = ObjectTypes::findByName('timeslot');
	
	$external_columns = Timeslots::instance()->getExternalColumns();
	$total_columns = Timeslots::instance()->getColumnsToAggregateInTotals();
	$total_col_names = array_keys($total_columns);
	
	$col_align_right = array_keys($total_columns);
	$col_align_right[] = 'hourly_billing';
	$col_align_right[] = 'hourly_cost';
	
	$money_columns = array(
		'hourly_billing' => 'rate_currency_id', 'fixed_billing' => 'rate_currency_id',
		'hourly_cost' => 'cost_currency_id', 'fixed_cost' => 'cost_currency_id'
	);
	$money_column_names = array_keys($money_columns);
	
	$table_columns = array();
	
	foreach ($report_data['columns'] as $col => $order) {
		if ($order > 0) {
			if (str_starts_with($col, 'dim_')) {
				$col_lang = Dimensions::getDimensionById(str_replace('dim_', '', $col))->getName();
			} else {
				$col_lang = Localization::instance()->lang('field Timeslots '.$col);
				if (!$col_lang) $col_lang = lang('field Objects '.$col);
			}
			$col_data = array('id' => $col, 'name' => $col_lang);
			if (in_array($col, $col_align_right)) $col_data['align'] = 'right';
			
			$table_columns[$order] = $col_data;
		}
	}
	ksort($table_columns, SORT_NUMERIC);
	
?>

	<tbody><tr class="custom-report-table-heading"><?php
		foreach ($table_columns as $col) {
			?><th style="text-align:<?php echo array_var($col, 'align', 'left')?>"><?php echo $col['name']; ?></th><?php
		}
	?></tr></tbody>
	
<?php
	
	$all_totals = array(); // level => array(gid => totals)

	// first level groups
	foreach ($grouped_timeslots as $first_group_id => $second_level_groups) {
		
		$group_name = grouped_timeslots_get_group_name($first_group_id, $groups_config[0], $user_names);
		
	?>
	<tbody class="report-data">
	
	<?php if (array_var($report_data, 'show_details')) { ?>
		<tr><th class="report-group-heading-0 indent-0" colspan="<?php echo count($table_columns)?>"><?php echo $group_name ?></th></tr>
	<?php } ?>
	
	<?php 
		$first_total = array();
		// second level groups
		foreach ($second_level_groups as $second_group_id => $third_level_groups) {
			
		  if (isset($groups_config[1])) {
			$second_group_name = grouped_timeslots_get_group_name($second_group_id, $groups_config[1], $user_names);
	?>
	
		<?php if (array_var($report_data, 'show_details')) { ?>
		<tr><th class="report-group-heading-1 indent-1" colspan="<?php echo count($table_columns)?>"><?php echo $second_group_name ?></th></tr>
		<?php } ?>
	<?php 
		  }
	
		// third level groups
		$second_total = array();
		foreach ($third_level_groups as $third_group_id => $timeslots) {
			
		  if (isset($groups_config[2])) {
			$third_group_name = grouped_timeslots_get_group_name($third_group_id, $groups_config[2], $user_names);
	?>
	
		<?php if (array_var($report_data, 'show_details')) { ?>
		<tr><th class="report-group-heading-2 indent-2" colspan="<?php echo count($table_columns)?>"><?php echo $third_group_name ?></th></tr>
		<?php } ?>
		
	<?php 
		  }
	?>
		
	<?php 	$third_total = array();
			foreach ($timeslots as $ts) {
	?>
			<tr>
			<?php foreach ($table_columns as $col) {
					$field = $col['id'];
					$text_align = array_var($col, 'align', 'left');
					
					if (in_array($field, $total_col_names)) {
						
						if ($total_columns[$field]['format'] == 'money') {
							if (!isset($third_total[$field])) $third_total[$field] = array();
							$curr_id = $ts[$total_columns[$field]['currency_id_col']];
							if ($curr_id > 0) {
								if (!isset($third_total[$field][$curr_id])) $third_total[$field][$curr_id] = 0;
								$third_total[$field][$curr_id] = $third_total[$field][$curr_id] + $ts[$field];
							}
						} else {
							if (!isset($third_total[$field])) $third_total[$field] = 0;
							$third_total[$field] += $ts[$field];
						}
					}
					
					if (array_var($report_data, 'show_details')) {
					?>
						<td style="text-align:<?php echo $text_align?>">
						<?php 
						if ($field == 'name') {
							echo '<div style="padding-left:'.((count($groups_config)-1)*10 - 5).'px">';
							echo array_var($related_task_names, $ts['rel_object_id'], array_var($ts, 'description', ''));
							echo '</div>';
							
						} else if ($field == 'rel_object_id') {
							echo array_var($related_task_names, $ts['rel_object_id'], '');
							
						} else if (in_array($field, $money_column_names)) {
							$currency_col_id = $money_columns[$field];
							$c = Currencies::getCurrency($ts[$currency_col_id]);
							$sym = $c instanceof Currency ? $c->getSymbol() : config_option('currency_code');
							echo format_money_amount($ts[$field], $c instanceof Currency ? $c->getSymbol() : null);
							
						} else if (in_array($field, $external_columns)) {
							$ext_value = clean(Reports::instance()->getExternalColumnValue($field, $ts[$field], Timeslots::instance()));
							echo $ext_value;
							
						} else if (str_starts_with($field, "dim_")) {
							$dim_id = str_replace("dim_", "", $field);
							
							$member_names = array_var($timeslot_member_names, $ts['id']);
							if ($members_info = array_var($member_names, $dim_id)) {
								foreach ($members_info as $mid => $info) {
									echo '<span class="member-path real-breadcrumb og-wsname-color-'.$info['color'].'" style="height: 100%;display: inline-block;">'.$info['name'].'</span>';
								}
							}
							
						} else if ($field == 'start_time' || $field == 'end_time') {
							$dt = DateTimeValueLib::dateFromFormatAndString(DATE_MYSQL, $ts[$field]);
							echo $dt instanceof DateTimeValue ? format_datetime($dt) : '';

						} else if ($field == 'worked_time' && !$report_data['show_descriptive_worked_time']) {
							echo $ts[$field] / 60;
						} else {
							echo format_value_to_print($field, $ts[$field], Timeslots::instance()->getColumnType($field), $ts_ot->getId());
						}
						?>
						</td>
					<?php }
				  } ?>
			</tr>
	<?php 	}
	
			
			if (isset($groups_config[2]) && array_var($report_data, 'show_details')) {
				grouped_timeslots_echo_totals_row($table_columns, $third_group_name, $third_total, $total_columns, 2, $report_data);
			}
			
			$all_totals[2][$first_group_id ."-". $second_group_id ."-". $third_group_id] = $third_total;
			
			// accumulate for prev level group
			foreach ($third_total as $k => $v) {
				if (is_array($v)) {
					if (!isset($second_total[$k])) $second_total[$k] = array();
					foreach ($v as $cur => $am) {
						if (!isset($second_total[$k][$cur])) $second_total[$k][$cur] = 0;
						$second_total[$k][$cur] += $am;
					}
				} else {
					if (!isset($second_total[$k])) $second_total[$k] = 0;
					$second_total[$k] += $v;
				}
			}
			
		  }
		  
		  if (isset($groups_config[1]) && array_var($report_data, 'show_details')) {
			grouped_timeslots_echo_totals_row($table_columns, $second_group_name, $second_total, $total_columns, 1, $report_data);
		  }
		  
		  $all_totals[1][$first_group_id ."-". $second_group_id] = $second_total;
		  
		  // accumulate for prev level group
		  foreach ($second_total as $k => $v) {
		  	if (is_array($v)) {
		  		if (!isset($first_total[$k])) $first_total[$k] = array();
		  		foreach ($v as $cur => $am) {
		  			if (!isset($first_total[$k][$cur])) $first_total[$k][$cur] = 0;
		  			$first_total[$k][$cur] += $am;
		  		}
		  	} else {
		  		if (!isset($first_total[$k])) $first_total[$k] = 0;
		  		$first_total[$k] += $v;
		  	}
		  }
		
		}
		
		if (isset($groups_config[0]) && array_var($report_data, 'show_details')) {
			grouped_timeslots_echo_totals_row($table_columns, $group_name, $first_total, $total_columns, 0, $report_data);
		}
		
		$all_totals[0][$first_group_id] = $first_total;
		
		// not showing details => draw only totals
		if (!array_var($report_data, 'show_details')) {
			
			$group_name = grouped_timeslots_get_group_name($first_group_id, $groups_config[0], $user_names);
			$first_total = array_var($all_totals[0], $first_group_id);
			grouped_timeslots_echo_totals_row($table_columns, $group_name, $first_total, $total_columns, 0, $report_data);
			
			if (isset($groups_config[1])) {
				foreach ($second_level_groups as $second_group_id => $third_level_groups) {
					
					$second_group_name = grouped_timeslots_get_group_name($second_group_id, $groups_config[1], $user_names);
					$second_total = array_var($all_totals[1], $first_group_id ."-". $second_group_id);
					grouped_timeslots_echo_totals_row($table_columns, $second_group_name, $second_total, $total_columns, 1, $report_data);
					
					if (isset($groups_config[2])) {
						foreach ($third_level_groups as $third_group_id => $timeslots) {
							
							$third_group_name = grouped_timeslots_get_group_name($third_group_id, $groups_config[2], $user_names);
							$third_total = array_var($all_totals[2], $first_group_id ."-". $second_group_id ."-". $third_group_id);
							grouped_timeslots_echo_totals_row($table_columns, $third_group_name, $third_total, $total_columns, 2, $report_data);
						}
					}
				}
			}
		}
	?>
		
	</tbody>
	
	<tbody class="separator"><tr><td>&nbsp;</td></tr></tbody>
<?php
	}
?>
</table>
