<?php
	echo stylesheet_tag("og/reporting.css");
	require_javascript("og/ReportingFunctions.js");
	require_javascript('og/modules/doubleListSelCtrl.js');
	
	$genid = gen_id();
	
	$report_data = null;
	if ($preset_parameters) { 
		$report_data = get_grouped_timeslots_report_preset_config($preset_parameters);
	}
	if (!$report_data) {
		$report_data = array_var($_SESSION, 'grouped_timeslots_report_data');
	}

	// dimension selector template
	$options = array();
	$options[] = option_tag(lang('none'), '0');
	foreach ($dimensions as $d) {
		$options[] = option_tag($d->getName(), 'dim_'.$d->getId());
	}
	echo select_box('report[group_by][i][j]', $options, array('style' => 'display:none;', 'id' => $genid."_group_by_i_dim_j"));
	
	// group by type selector template
	$options = array();
	$options[] = option_tag(lang('none'), '0');
	$options[] = option_tag(lang('person'), 'contact_id', array('id' => 'contact_id'));
	$options[] = option_tag(lang('intersection'), 'member_ids', array('id' => 'member_ids'));
	$options[] = option_tag(lang('dimension'), 'dim', array('id' => 'dim'));
	echo select_box('report[group_by_type][i]', $options, array('style' => 'display:none;', 'id' => $genid."_group_by_type_i"));
	
	
	// previous selected group by
	$selected_group_by_type = array_filter(array_var($report_data, 'group_by_type', array()));
	$selected_group_by = array_filter(array_var($report_data, 'group_by', array()));
	
	// columns
	$selected_columns = array_var($report_data, 'columns');
	$ordered_col_options = array();
	$ordered_sel_col_options = array();
	
	foreach ($column_options as &$col) {
		if (str_starts_with($col['id'], 'dim_')) {
			$col_lang = Dimensions::getDimensionById(str_replace('dim_', '', $col['id']))->getName();
		} else {
			$col_lang = Localization::instance()->lang('field Timeslots '.$col['id']);
			if (!$col_lang) $col_lang = lang('field Objects '.$col['id']);
		}
		$col['text'] = $col_lang;
		
		$col_order = array_var($selected_columns, $col['id']);
		
		$col['order'] = $col_order;
		$col['selected'] = $col_order > 0;
		
		if ($col_order > 0) {
			$ordered_sel_col_options[$col_order] = $col;
		} else {
			$ordered_col_options[] = $col;
		}
	}
	ksort($ordered_sel_col_options);
	$ordered_col_options = array_merge($ordered_sel_col_options, $ordered_col_options);
	
	$column_options = $ordered_col_options;
	
	$report_key = 'grp_times_'.$preset_parameters;
?>
<style>
.grouped-timeslots-report-params tr {
	height: 30px;
}
.grouped-timeslots-report-params td.label {
	min-width: 175px;
}
.group-by-container .group-by-selector-container {
	margin: 0 0 5px 0;
}
</style>

<form style='height:100%;background-color:white' class="internalForm applyPreloadFilters" id="formReportGen" method="post" enctype="multipart/form-data" 
	action="<?php echo get_url('advanced_timeslot_reports', 'grouped_timeslots') ?>">
	
	<input type="hidden" name="report[preset_parameters]" value="<?php echo $preset_parameters ?>" />
	
  <div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo array_var($report_data, 'report_name', lang('grouped timeslots report')) ?>
		<?php //echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;margin-left:10px')) ?></div>
	</div>
	<div style="padding:5px 0"><?php echo array_var($report_data, 'report_desc', lang('grouped timeslots report description')) ?></div>
  </div>
  
  <div class="coInputMainBlock">

	<table class="grouped-timeslots-report-params">
		<tr>
			<td class="label"><span class="bold"><?php echo lang("date") ?>:&nbsp;</span></td>
			<td align='left'><?php 
				echo select_box('report[date_type]', array(
					option_tag(lang('today'), 1, array_var($report_data, "date_type") == 1 ? array('selected' => 'selected'):null),
					option_tag(lang('this week'), 2, array_var($report_data, "date_type") == 2 ? array('selected' => 'selected'):null),
					option_tag(lang('last week'), 3, array_var($report_data, "date_type") == 3 ? array('selected' => 'selected'):null),
					option_tag(lang('this month'), 4, array_var($report_data, "date_type") == 4 ? array('selected' => 'selected'):null),
					option_tag(lang('last month'), 5, array_var($report_data, "date_type") == 5 ? array('selected' => 'selected'):null),
					option_tag(lang('select dates...'), 6, array_var($report_data, "date_type") == 6 ? array('selected' => 'selected'):null)
				), array('onchange' => 'og.dateselectchange(this)'));
			?></td>
		</tr>
		<?php
			if (array_var($report_data, "date_type") == 6) {
				$style = "";
		       	$st = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'start_value'));
		       	$et = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'end_value'));
			} else {
				$style = 'display:none;';
				$st = DateTimeValueLib::now();
				$et = $st;
			} 
		?>
		<tr class="dateTr" style="<?php echo $style ?>">
			<td class="label"><span class="bold"><?php echo lang("start date") ?>:&nbsp;</span></td>
			<td align='left'><?php echo pick_date_widget2('report[start_value]', $st, $genid);?></td>
		</tr>
		<tr class="dateTr" style="<?php echo $style ?>">
			<td class="label"><span class="bold"><?php echo lang("end date") ?>:&nbsp;</span></td>
			<td align='left'><?php echo pick_date_widget2('report[end_value]', $et, $genid);?></td>
		</tr>

		<?php 
			$tr_style = '';
			if($preset_parameters == 'billing_and_cost_by_client'){
				$tr_style = "display:none;";
			}
		?>

		<tr style="<?php echo $tr_style; ?>">
			<td class="label"><span class="bold"><?php echo lang("group by") ?>:&nbsp;</span></td>
			<td id="<?php echo $genid ?>_group_by_container" class="group-by-container"></td>
		</tr>
		
		<tr style="<?php echo $tr_style; ?>">
			<td class="label"><span class="bold"><?php echo lang("show details") ?>:&nbsp;</span></td>
			<td><?php echo yes_no_widget("report[show_details]", "report_show_details", array_var($report_data, 'show_details', true), lang('yes'), lang('no')); ?></td>
		</tr>
		
		<tr style="<?php echo $tr_style; ?>">
			<td class="label"><span class="bold"><?php echo lang("show descriptive worked_time") ?>:&nbsp;</span></td>
			<td><?php echo yes_no_widget("report[show_descriptive_worked_time]", "show_descriptive_worked_time", array_var($report_data, 'show_descriptive_worked_time'), lang('yes'), lang('no')); ?></td>
		</tr>
		
		<tr style="<?php echo $tr_style; ?>">
			<td class="label"><span class="bold"><?php echo lang("columns") ?>:&nbsp;</span></td>
			<td>
				<div id="<?php echo $genid?>column_list_container">
						<?php echo doubleListSelect("report[columns]", $column_options, array('id' => $genid."columns", 'size' => 20)); ?>
				</div>
			</td>
		</tr>
		
	</table>
	
	<?php echo submit_button(lang('generate report'),"s",array('onclick'=>'og.setMemoryFilttersReport(this,"'.$report_key.'")')) ?>
  </div>
	
</form>


<script>
var genid = '<?php echo $genid?>';

og.loadFiltersReport("<?php echo $report_key; ?>");

og.groupedts_report_group_by_render_options = function(genid, index, selected_val, opt_index) {
	if (!opt_index) opt_index = 0;

	var exists = document.getElementById(genid+"_group_by_"+index+"_dim_"+opt_index);
	if (!exists) {
		
		var type_selected = $("#"+genid+"_group_by_type_"+index).val();
	
		if (type_selected == 'dim' || type_selected == 'member_ids') {
			
			var selector = $("#"+genid+"_group_by_i_dim_j").clone();
			$(selector).attr('id', $(selector).attr('id').replace("_group_by_i_dim_j", "_group_by_"+index+"_dim_"+opt_index));
			$(selector).attr('name', $(selector).attr('name').replace("[i]", "["+index+"]"));
			$(selector).attr('name', $(selector).attr('name').replace("[j]", "["+opt_index+"]"));
			if (type_selected == 'member_ids') {
				$(selector).attr('onchange', "og.groupedts_report_group_by_render_options('"+genid+"',"+index+", null,"+(opt_index+1)+");");
			}
			$(selector).show();
			if (selected_val) {
				$(selector).val(selected_val);
			}
			
			var sel_container_id = genid+"_sel_container_"+index;
			$("#"+genid+"_group_by_container #"+sel_container_id+".group-by-selector-container").append($(selector));
		}
	}
}

og.add_groupedts_report_group_by_type_selector = function(genid, index, selected, remove_opt) {
	var selector = $("#"+genid+"_group_by_type_i").clone();
	$(selector).attr('id', $(selector).attr('id').replace("_group_by_type_i", "_group_by_type_"+index));
	$(selector).attr('name', $(selector).attr('name').replace("[i]", "["+index+"]"));
	$(selector).attr('onchange', "og.on_groupedts_report_group_by_type_selector_change('"+genid+"',"+(index+1)+");");
	$(selector).show();
	if (selected) {
		$(selector).val(selected);
	}
	
	var sel_container_id = genid+"_sel_container_"+index;
	
	$("#"+genid+"_group_by_container").append('<div id="'+sel_container_id+'" class="group-by-selector-container"></div>');
	$("#"+genid+"_group_by_container #"+sel_container_id).append($(selector));

	// remove unique options (contact_id and intersection)
	if (remove_opt) {
		for (var i=0; i<remove_opt.length; i++) {
			$("#"+$(selector).attr('id')+" #"+remove_opt[i]).css('display','none');
		}
	}
}

og.on_groupedts_report_group_by_type_selector_change = function(genid, next_index) {
	var exists = document.getElementById(genid+"_group_by_type_"+next_index);
	if (!exists && next_index < 3) {
		var remove_opt = []; // options to remove from next selector
		for (var i=0; i<next_index; i++) {
			var combo = $("#"+genid+"_group_by_type_"+i);
			if (combo.val() != 'dim') remove_opt.push(combo.val());
		}
		
		og.add_groupedts_report_group_by_type_selector(genid, next_index, null, remove_opt);
	}

	var index = next_index - 1;
	og.groupedts_report_group_by_render_options(genid, index, $("#"+genid+"_group_by_"+(index)).val());
}

<?php if (count($selected_group_by_type) == 0) { ?>

	og.add_groupedts_report_group_by_type_selector(genid, 0);
	
<?php } else {
	
	$i=0;
	foreach ($selected_group_by_type as $gb) { ?>
		og.add_groupedts_report_group_by_type_selector(genid, <?php echo $i?>, '<?php echo $gb?>');
	<?php
		if ($gb == 'dim' || $gb == 'member_ids') {
			foreach ($selected_group_by[$i] as $j => $dsel) { ?>
				og.groupedts_report_group_by_render_options(genid, <?php echo $i?>, '<?php echo $dsel?>', <?php echo $j?>);
		<?php
			}
		}
		$i++;
	}
	if ($i < 3) { ?>
		og.add_groupedts_report_group_by_type_selector(genid, <?php echo $i?>);
<?php } ?>
	
<?php } ?>
</script>