<?php

if(count($data['users']) > 0 && count($data['users'][0]['permissions'][1]) > 0){
    foreach($data['users'] as $user_data){
        render_user_permissions($user_data, $data['max_depth']);
    }
} else {
    echo lang('no permissions found for the current selection');
}

function render_user_permissions($user_data, $max_depth){
    // Render user name as table name
    echo '<div style="page-break-inside: avoid;">';
	echo '<table id="permissions-report">';
    echo '<thead><tr><th colspan="2" class="table-name"><span style="color: #0a85d8; margin-right: 20px;">'.lang('user').'</span>'.$user_data['name'].'</th></tr></thead>';

    // Render table header
    echo '<tbody>';
    echo '<tr>';
    echo '<th>'.lang('member name').'</th>';
    echo '<th>'.lang('permissions').'</th>';
    echo '</tr>';
    
    // Render permission rows
    $depth = 1;
    $user_permissions = $user_data['permissions'];
    foreach($user_permissions[$depth] as $permissions){ 
        render_permission_row($permissions, $depth, $user_permissions);
    }
    echo '</tbody>';
    echo '</table>';
}

function render_permission_row($perm_data, $depth, $user_permissions){
    // Get permissions for children members
    $member_id = $perm_data['member_id'];
    $next_depth = $depth + 1;
    $child_permissions = array_var($user_permissions[$next_depth], $member_id, array());

    // Get indentation
    $indentation = 8 + ($depth - 1) * 35;

    // Specify specisl character
    $special_character = '';
    $special_character = count($child_permissions) ? $special_character = '&dtrif;' : '&nbsp;&nbsp;&nbsp;';

    // Get permission string
    $can_write = $perm_data['can_write'] == 1;
    $can_delete = $perm_data['can_delete'] == 1;
    $permission_string = "<span class='read-label'>".ucwords(lang('read'))."</span>";
    if($can_write && $can_delete){
        $permission_string = "<span class='read-label'>".ucwords(lang('read'))."</span> <span class='write-label'>".ucwords(lang('write'))."</span> <span class='delete-label'>".ucwords(lang('delete'))."</span>";
    } else if ($can_write){
        $permission_string = "<span class='read-label'>".ucwords(lang('read'))."</span> <span class='write-label'>".ucwords(lang('write'))."</span>";
    }

    
    // Render permission row
    $member_name = $perm_data['member_name'];
    echo '<tr><td style="padding-left: '.$indentation.'px;">'.$special_character.' '.$member_name.'</td><td style="width: 200px;">'.$permission_string.'</td></tr>';

    // Render children
    if(count($child_permissions)){
        foreach($child_permissions as $child_perm){
            render_permission_row($child_perm, $next_depth, $user_permissions);
        }
    }
}
