<?php

require_javascript("og/ReportingFunctions.js");
$genid = gen_id();
if (!isset($conditions)) $conditions = array();

$report_data = array_var($_SESSION, 'permissions_report_data');
?>

<style>
.permission_report_contact_seletor{
	width: 500px;
}
</style>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('permissions_reports', 'permissions_report') ?>" method="post" enctype="multipart/form-data">
<input type="hidden" id="<?php echo $genid?>report[report_object_type_id]" name="report[report_object_type_id]" value="<?php echo ProjectTasks::instance()->getObjectTypeId()?>"/>

<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo $title; ?>
	</div>
</div>
<div class="coInputSeparator"></div>

<div class="coInputMainBlock">
	<!-- Contact Selector -->
	<div class="dataBlock" id="group_expenses_by">
		<label><?php echo lang('user')?>:</label>
		<div id="<?php echo $genid?>user_permissions_report"></div>
	</div>

	<!-- Dimension Selector -->
	<?php
	$enabled_dimensions = config_option('enabled_dimensions');
	$dimensions_select_array = array();
	foreach($enabled_dimensions as $dim_id){
		$dimension = Dimensions::findById($dim_id);
		if($dimension instanceof Dimension && $dimension->getPermissionQueryMethod()){
			$dimensions_select_array[] = array($dim_id, $dimension->getName());
		}
	}
	?>
	<div class="dataBlock" id="get_by_dimension">
		<label><?php echo lang('dimensions')?>:</label>
		<?php echo simple_select_box('report[dimension]', $dimensions_select_array, array_var($report_data, 'dimension'))?>
	</div>

	<!-- Object Type Selector -->
	<?php
	$object_types = ObjectTypes::getAvailableObjectTypes();
	$object_types[] = ObjectTypes::findByName('timeslot');
	$object_types_select_array = array();
	foreach ($object_types as $ot) {	    
			$object_types_select_array[] = array($ot->getId(), lang($ot->getName()));
	}
	?>
	<div class="dataBlock" id="object_type_selector">
		<label><?php echo lang('object type')?>:</label>
		<?php echo simple_select_box('report[object_type]', $object_types_select_array, array_var($report_data, 'object_type'))?>
	</div>

	<!-- Submit Button -->
	<?php echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;')) ?>
</div>


</form>

<script>
var genid = '<?php echo $genid?>';
$(function(){
	var filters = {
		is_user: 1
	};

	og.renderContactSelector({
		genid: genid,
		id: genid + 'user_permissions_report',
		name: 'report[user]',
		render_to: "user_permissions_report",
		listWidth: 250,
		filters: filters,
		custom_selected_class: 'permission_report_contact_seletor'
	
	});
});
</script>