<?php
Hook::register("custom_reports_subscribers_column");


/**
 * Add the 'Subscribers' column to the report view
 */
function custom_reports_subscribers_column_custom_reports_fixed_additional_columns_def($args, &$results) {
	$ot = array_var($args, 'object_type');
    $field = array_var($args, 'field');
   
	if ($ot instanceof ObjectType && $ot->getType() == 'content_object' && $field == 'subscribers_list_id') {
        // Set column header name
        $results['columns']['names'][$field] = lang('subscribers');
        // Set column order
		$results['columns']['order'][] = $field;


	}
}


/**
 * Add the 'Subscribers' column to the add/edit custom report form for tasks
 */
function custom_reports_subscribers_column_custom_reports_additional_columns($params, &$fields) {
	
    $ot = array_var($params, 'object_type');
    
	if ($ot->getType() == 'content_object') {
        $fields[] = array('id' => 'subscribers_list_id', 'name' => lang('subscribers'), 'type' => 'text');
    }

}


/**
 * Add the 'Subscribers' column values to the custom report result
 */
function custom_reports_subscribers_column_custom_reports_override_column_format($parameters, &$value) {
	
	$field = array_var($parameters, 'field');
    $object = array_var($parameters, 'object');
    
	if ($object instanceof ContentDataObject && $field == 'subscribers_list_id') {
        $subscriber_ids = $object->getSubscriberIds();
        $value = '<ul>';
        foreach($subscriber_ids as $s_id){
            $name = Contacts::findById($s_id)->getName();
            $value .= '<li>'.$name.'</li>'; 
        }
        $value .= '</ul>';
	}
}



