<?php


function advanced_reports_update_1_2() {
	Env::useHelper('default_member_reports', 'advanced_reports');
	create_default_member_report('workspace');
	create_default_member_report('customer');
	create_default_member_report('project');
	create_default_member_report('sample');
}

function advanced_reports_update_2_3() {
	if (!check_column_exists(TABLE_PREFIX."reports", "group_by")) {
		DB::execute("ALTER TABLE `".TABLE_PREFIX."reports` ADD `group_by` varchar(255) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '';");
	}

	if (!check_column_exists(TABLE_PREFIX."reports", "hide_group_details")) {
		DB::execute("ALTER TABLE `".TABLE_PREFIX."reports` ADD `hide_group_details` tinyint(1) NOT NULL DEFAULT 0;");
	}
}

function advanced_reports_update_3_4() {
	if (!check_column_exists(TABLE_PREFIX."reports", "group_by_options")) {
		DB::execute("ALTER TABLE `".TABLE_PREFIX."reports` ADD `group_by_options` text COLLATE 'utf8_unicode_ci' NOT NULL;");
	}
}

function advanced_reports_update_4_5() {
	if (!check_column_exists(TABLE_PREFIX."reports", "show_comments")) {
		DB::execute("ALTER TABLE `".TABLE_PREFIX."reports` ADD COLUMN `show_comments` tinyint(1) NOT NULL DEFAULT 0;");
	}
}

function advanced_reports_update_5_6() {
	if (!check_column_exists(TABLE_PREFIX."reports", "hide_group_total_counts")) {
		DB::execute("ALTER TABLE `".TABLE_PREFIX."reports` ADD `hide_group_total_counts` tinyint(1) NOT NULL DEFAULT 0;");
	}
}

function advanced_reports_update_6_7() {
	if (!check_column_exists(TABLE_PREFIX."reports", "show_last_group_as_column")) {
		DB::execute("ALTER TABLE `".TABLE_PREFIX."reports` ADD `show_last_group_as_column` tinyint(1) NOT NULL DEFAULT 0;");
	}
}

function advanced_reports_update_7_8() {
    if (!check_column_exists(TABLE_PREFIX."reports", "report_category_id")) {
        DB::execute("ALTER TABLE `".TABLE_PREFIX."reports` ADD `report_category_id` INT  NOT NULL DEFAULT 0;");
    }

    if (!checkTableExists(TABLE_PREFIX."report_category")) {
        DB::execute("

                    CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."report_category` (
                        `object_id` INT NOT NULL AUTO_INCREMENT ,
                        `description` VARCHAR(255) NOT NULL ,
                        `is_default` TINYINT NOT NULL ,
                        PRIMARY KEY (`object_id`)
                    );
            ");
    }
}

function advanced_reports_update_8_9() {
    if (!check_column_exists(TABLE_PREFIX."reports", "date_format")) {
	DB::execute("ALTER TABLE `".TABLE_PREFIX."reports` ADD `date_format` VARCHAR(15) NOT NULL;");
    }
    if (!check_column_exists(TABLE_PREFIX."reports", "show_currency")) {
	DB::execute("ALTER TABLE `".TABLE_PREFIX."reports` ADD `show_currency` TINYINT(1) NOT NULL DEFAULT 1;");
    }
    if (!check_column_exists(TABLE_PREFIX."reports", "show_negatives")) {
	DB::execute("ALTER TABLE `".TABLE_PREFIX."reports` ADD `show_negatives` TINYINT(1) NOT NULL DEFAULT 1;");
    }
}

function advanced_reports_update_9_10() {
    DB::execute("
        INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`) VALUES
('report_category', 'ReportCategories', 'report_category', 'located', 'reporting', 0)
ON DUPLICATE KEY UPDATE name=name;
            ");
}


function advanced_reports_update_10_11() {
    if (!check_column_exists(TABLE_PREFIX."reports", "report_category_id")) {
        DB::execute("ALTER TABLE `".TABLE_PREFIX."reports` CHANGE `report_category_id` `report_category_id` INT(10) NOT NULL DEFAULT 0;");
    }
}

function advanced_reports_update_11_12() {
    if (!check_column_exists(TABLE_PREFIX."reports", "is_system")) {
        DB::execute("ALTER TABLE `".TABLE_PREFIX."reports` ADD `is_system` TINYINT(1) NOT NULL DEFAULT '0' AFTER `is_default`;");
    }
}

function advanced_reports_update_12_13() {
	// fix report_category_id column
	DB::execute("
			ALTER TABLE `".TABLE_PREFIX."reports`
			CHANGE `report_category_id` `report_category_id` int(10) unsigned NOT NULL DEFAULT '0';
	");
	// remove wrong data
	DB::execute("
			UPDATE ".TABLE_PREFIX."reports
			SET report_category_id=0
			WHERE report_category_id<>0 AND NOT EXISTS(
				SELECT rc.object_id FROM ".TABLE_PREFIX."report_category rc WHERE rc.object_id=report_category_id
			)
	");
}
// upgrade version of plugin 
function advanced_reports_update_13_14() {
    DB::execute("
		INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`,`name`,`default_value`,`config_handler_class`,`is_system`) VALUES
                ('reporting', 'show_type_phone', '1', 'BoolConfigHandler', 0)
                ON DUPLICATE KEY UPDATE name=name;
    ");
}


function advanced_reports_update_14_15() {
	if (!check_column_exists(TABLE_PREFIX."reports", "dont_show_time")) {
		DB::execute("ALTER TABLE `".TABLE_PREFIX."reports` ADD `dont_show_time` TINYINT(1) NOT NULL DEFAULT '0';");
	}
}

function advanced_reports_update_15_16() {
	DB::execute("
	INSERT INTO `".TABLE_PREFIX."objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`) VALUES
	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report'), 'tasks report', NOW(), 0, NOW(), 0, 0, 0);
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."reports` (`object_id`, `description`, `report_object_type_id`, `is_order_by_asc`, `ignore_context`, `is_default`, `code`, `function_url`) VALUES
	((SELECT max(id) FROM ".TABLE_PREFIX."objects WHERE object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report')), 'tasks report description', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='task'), 1, 1, 1, 'tasks_report', '?c=advanced_reports&a=tasks_report_p');
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`) VALUES
	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report'), 'tasks by user', NOW(), 0, NOW(), 0, 0, 0);
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."reports` (`object_id`, `description`, `report_object_type_id`, `is_order_by_asc`, `ignore_context`, `is_default`, `code`, `function_url`) VALUES
	((SELECT max(id) FROM ".TABLE_PREFIX."objects WHERE object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report')), 'tasks by user report description', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='task'), 1, 1, 1, 'tasks_by_user_report', '?c=advanced_reports&a=tasks_report_p&by_user=1');
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`) VALUES
	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report'), 'file access report', NOW(), 0, NOW(), 0, 0, 0);
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."reports` (`object_id`, `description`, `report_object_type_id`, `is_order_by_asc`, `ignore_context`, `is_default`, `code`, `function_url`) VALUES
	((SELECT max(id) FROM ".TABLE_PREFIX."objects WHERE object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report')), 'file access report description', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='file'), 1, 1, 1, 'file_access_report', '?c=advanced_reports&a=file_access_report_p');
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`) VALUES
	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report'), 'grouped timeslots report', NOW(), 0, NOW(), 0, 0, 0);
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."reports` (`object_id`, `description`, `report_object_type_id`, `is_order_by_asc`, `ignore_context`, `is_default`, `code`, `function_url`) VALUES
	((SELECT max(id) FROM ".TABLE_PREFIX."objects WHERE object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report')), 'grouped timeslots report description', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='timeslot'), 1, 1, 1, 'grouped_timeslots_report', '?c=advanced_timeslot_reports&a=grouped_timeslots_p');
	");

}

function advanced_reports_update_16_17() {

	DB::execute("
		INSERT INTO `".TABLE_PREFIX."objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`, `trashed_on`, `archived_on`) VALUES
		((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report'), 'Permissions Report', NOW(), 0, NOW(), 0, 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00');
	");

	DB::execute("
		INSERT INTO `".TABLE_PREFIX."reports` (`object_id`, `description`, `report_object_type_id`, `is_order_by_asc`, `ignore_context`, `is_default`, `code`, `function_url`) VALUES
		((SELECT max(id) FROM ".TABLE_PREFIX."objects WHERE object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report')), '', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='timeslot'), 1, 1, 1, 'permissions_report', '?c=permissions_reports&a=permissions_report_p');
    ");

}

function advanced_reports_update_17_18() {
	if (!check_column_exists(TABLE_PREFIX."reports", "add_signature_and_date_field")) {
		DB::execute("ALTER TABLE `".TABLE_PREFIX."reports` ADD `add_signature_and_date_field` TINYINT(1) NOT NULL DEFAULT '0';");
	}
}

function advanced_reports_update_18_19() {
	if (!check_column_exists(TABLE_PREFIX."reports", "calculate_quantity_for_actual_expenses")) {
		DB::execute("ALTER TABLE `".TABLE_PREFIX."reports` ADD `calculate_quantity_for_actual_expenses` TINYINT(1) NOT NULL DEFAULT '0';");
	}
}
