<?php
	$genid = gen_id();
	
	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.submit_modal_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	
	$day_names = array(
		"0" => lang('sunday'), "1" => lang('monday'), "2" => lang('tuesday'),
		"3" => lang('wednesday'), "4" => lang('thursday'), "5" => lang('friday'), "6" => lang('saturday')
	);
	$day_ids = array_keys($day_names);
	
	$def_start_time_option = user_config_option("work_day_start_time");
	$def_end_time_option = user_config_option("work_day_end_time");
	
	$format = (user_config_option('time_format_use_24') ? 'G:i' : 'g:i A');
	$def_st = new DateTimeValue(strtotime($def_start_time_option));
	$def_et = new DateTimeValue(strtotime($def_end_time_option));
	
	$def_start_time = $def_st->format($format);
	$def_end_time = $def_et->format($format);
	
	// initialize using the working days, start time and end time config options
	if ($object->isNew()) {
		$working_days = explode(',', config_option("working_days"));
		
		$days_data = array();
		foreach ($working_days as $wd) {
			$days_data[$wd] = array('start' => $def_start_time, 'end' => $def_end_time);
		}
	}
	
?>

<form onsubmit="<?php echo $on_submit?>" class="add-work-shift" id="<?php echo $genid ?>submit-edit-form" action="<?php echo $object->isNew() ? get_url('work_shift', 'add') : get_url('work_shift', 'edit', array('id' => $object->getId())) ?>" method="post" enctype="multipart/form-data">
<div class="work-shift">

<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $object->isNew() ? lang('new work shift') : lang('edit work shift') ?>
	</div>
  </div>

  <div>
	<div class="coInputName">
		<?php echo text_field('work_shift[name]', $object->getName(), array('id' => $genid . 'work_shift_title', 'class' => 'title', 'placeholder' => lang('type name here'))); ?>
	</div>
	<div class="coInputButtons" style="float:right;">
		<?php echo submit_button($object->isNew() ? lang('add work shift') : lang('save changes'),'s',array('style'=>'margin-top:0px;margin-left:10px')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>

<div class="coInputMainBlock">
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_work_shift_details"><?php echo lang('details') ?></a></li>
			<li><a href="#<?php echo $genid?>add_work_shift_break_options"><?php echo lang('break options') ?></a></li>
			<li><a href="#<?php echo $genid?>add_work_shift_description"><?php echo lang('description') ?></a></li>
		<!-- 	<li><a href="#<?php echo $genid?>add_work_shift_persons"><?php echo ucfirst(lang('persons')); ?></a></li> -->
			
		</ul>

		
		<div id="<?php echo $genid ?>add_work_shift_details" class="editor-container form-tab">
			<?php 
			foreach ($day_ids as $d) { ?>
			<div class="dataBlock <?php echo $d%2 == 0 ? '' : 'alt'?>"><?php 
				?><label><?php echo $day_names[$d]?></label>
				
				<input type="hidden" name="work_shift[<?php echo $d?>][enabled]" id="<?php echo $genid?>_work_shift_<?php echo $d?>_enabled" 
					value="<?php echo isset($days_data[$d]) ? "1" : "0"?>" />
				
				<div id="<?php echo $genid?>_day_data_<?php echo $d?>" style="<?php echo !isset($days_data[$d]) ? 'display:none;' : ''?>">
					<div style="float:left;"><?php 
						echo pick_time_widget2("work_shift[$d][start_time]", isset($days_data[$d]) ? $days_data[$d]['start'] : $def_start_time, $genid);
					?></div>
					<div style="float:left;margin-left:10px;"> - </div>
					<div style="float:left;margin-left:10px;"><?php
						echo pick_time_widget2("work_shift[$d][end_time]", isset($days_data[$d]) ? $days_data[$d]['end'] : $def_end_time, $genid);
					?></div>
					<div style="float:left;margin-left:10px;"><?php
						echo checkbox_field("work_shift[$d][is_day_off]", isset($days_data[$d]) ? $days_data[$d]['is_day_off'] : false, array('id' => $genid."ws_".$d."_dayoff", 'style' => "margin-top:4px;"));
						echo label_tag(lang('day off'), $genid."ws_".$d."_dayoff", false, array('style' => "min-width:0; float:none; display:inline; margin-left:5px;margin-top:0px;vertical-align: text-bottom;"), '');
					?></div>
					<a class="link-ico ico-delete" style="float:left;margin-left:20px;" onclick="og.work_shifts.hide_day_data('<?php echo $genid?>', '<?php echo $d?>')">&nbsp;</a>
					<div class="clear;"></div>
				</div>
				
			<?php
				echo '<a class="link-ico ico-add" href="#" id="'.$genid.'_add_day_data_link_'.$d.'" style="'.(isset($days_data[$d]) ? 'display:none;' : '').'"
					onclick="og.work_shifts.show_day_data(\''.$genid.'\', '.$d.')">'.lang('add').'</a>';
			?>
			</div><?php
			}
			?>
		</div>
		
		<div id="<?php echo $genid ?>add_work_shift_break_options" class="form-tab">
			<div class="dataBlock">
				<?php $break_minutes = $object->isNew() ? config_option('default_break_minutes') : $object->getBreakMinutes() ?>
				<?php echo label_tag(lang('break minutes')) ?>
				<?php echo text_field('work_shift[break_minutes]', $break_minutes, array('class' => 'short')) ?>
			</div>
			<div class="dataBlock"><?php
				$exploded = explode(':', config_option('default_break_min_hours'));
				$def_break_min = array_var($exploded, 0, 0) * 60 + array_var($exploded, 1, 0);
				
				$break_min_minutes = $object->isNew() ? $def_break_min : $object->getBreakMinMinutes();
				echo label_tag(lang('min hours to generate break'));
				
				$hours = floor($break_min_minutes/60);
				$minutes = $break_min_minutes % 60;
				$input_attr = array("style" => "width:30px;", "onkeyup" => "event.target.value = event.target.value.replace(/[^0-9]/g, '')");
				echo text_field("work_shift[break_min_minutes][hours]", $hours, $input_attr);
				echo "&nbsp;" . lang('hours');
				echo "&nbsp;&nbsp;";
				echo text_field("work_shift[break_min_minutes][minutes]", $minutes, $input_attr);
				echo "&nbsp;" . lang('minutes');
			?>
			</div>
			<div class="dataBlock"><?php 
				$exploded = explode(':', config_option('default_break_every_x_hours'));
				$def_break_every_x_min = array_var($exploded, 0, 0) * 60 + array_var($exploded, 1, 0);
				
				$break_every_x_minutes = $object->isNew() ? $def_break_every_x_min : $object->getBreakEveryXMinutes();
				echo label_tag(lang('generate break every'));
			
				$hours = floor($break_every_x_minutes/60);
				$minutes = $break_every_x_minutes % 60;
				$input_attr = array("style" => "width:30px;", "onkeyup" => "event.target.value = event.target.value.replace(/[^0-9]/g, '')");
				echo text_field("work_shift[break_every_x_minutes][hours]", $hours, $input_attr);
				echo "&nbsp;" . lang('hours');
				echo "&nbsp;&nbsp;";
				echo text_field("work_shift[break_every_x_minutes][minutes]", $minutes, $input_attr);
				echo "&nbsp;" . lang('minutes');
			?>
				<div class="desc"><?php echo lang("break_every_x_minutes description") ?></div>
			</div>
		</div>
		
		<div id="<?php echo $genid ?>add_work_shift_description" class="editor-container form-tab">
			<textarea name="work_shift[description]" style="width:99%; height:200px;"><?php echo $object->getDescription();?></textarea>
		</div>
		
		<div id="<?php echo $genid ?>add_work_shift_persons" class="form-tab">
			
		</div>
		
	</div>

	
	<?php if (!array_var($_REQUEST, 'modal')) {
		echo submit_button($object->isNew() ? lang('add work shift') : lang('save changes'),'s', array('style'=>'margin-top:0px')); 
	}?>
</div>
</div>
</form>
<script>
$(function() {
	var genid = '<?php echo $genid?>';	
	$("#" + genid + "tabs").tabs();
	$("#" + genid + "work_shift_title").focus();
});
</script>