<?php

$genid = gen_id();

if ($contact instanceof Contact) {
	
	$shifts = WorkShifts::findAll();
	
	$shifts_data = array();
	
	$options = array(option_tag("--"), 0);
	foreach ($shifts as $shift) {
		$options[] = option_tag($shift->getName(), $shift->getId());
		$shifts_data[$shift->getId()] = array('name' => clean($shift->getName()));
	}
	
	$current_shifts_data = ContactShifts::getContactShiftsData($contact);
	
	?>
	<div class="dataBlock">
		<label><?php echo lang('work shift')?>:</label>
		<div style="float:left;">
			<div id="<?php echo $genid?>_shifts_container"></div><?php 
			echo select_box('work_shift_selector', $options, array('onchange' => 'og.work_shifts.select_contact_shift(this.value);', 'id' => $genid."_shifts_combo"));
		?></div>
		<div class="clear"></div>
	</div>
	<?php
	
}
?>
<script>
if (!og.work_shifts) og.work_shifts = {};
var sh_genid = '<?php echo $genid;?>';

og.work_shifts.all_shifts = Ext.util.JSON.decode('<?php echo json_encode($shifts_data) ?>');

og.work_shifts.select_contact_shift = function(value, takes_break) {
	if (!value) return;
	
	var exists = $("#" + sh_genid+"_work_shift_"+value).length;
	
	if (!exists) {
		
		var checked_str = 'checked="checked"';
		if (typeof(takes_break) != 'undefined') {
			if (!takes_break) checked_str = '';
		}
		
		var new_shift_html = '<div><input type="hidden" name="contact[work_shifts]['+value+'][id]" value="'+value+'" id="'+sh_genid+'_work_shift_'+value+'" />';
		new_shift_html += '<div class="work-shift-name">'+og.work_shifts.all_shifts[value].name;
		new_shift_html += '<input type="checkbox" id="'+sh_genid+'takes_break" name="contact[work_shifts]['+value+'][takes_break]" '+checked_str+'/>';
		new_shift_html += '<label for="'+sh_genid+'takes_break">'+ lang('takes break') +'</label>';
		new_shift_html += '&nbsp;&nbsp;<a href="#" onclick="$(this).parent().parent().remove();$(\'#'+ sh_genid+'_shifts_combo\').show();" class="link-ico ico-delete"></a></div></div>';
	
		$("#" + sh_genid + "_shifts_container").append(new_shift_html);
		$("#" + sh_genid + "_shifts_combo").val(0);
		$("#" + sh_genid + "_shifts_combo").hide();
	}
}

$(function() {
	<?php foreach ($current_shifts_data as $sh_id => $sh_data) { ?>
	og.work_shifts.select_contact_shift(<?php echo $sh_id?>, <?php echo $sh_data['takes_break'] ? '1' : '0' ?>);
	<?php } ?>
});
</script>