<?php
Hook::register("task_availability");

function task_availability_modify_allowed_users_to_assign($params, &$data) {
	$parameters = array_var($params, 'params');
	
	if (is_string($parameters)) {
		$parameters = json_decode($parameters, true);
	}
	
	// users ids to check
	$user_ids = array();
	foreach ($data['companies'] as $company) {
		foreach ($company['users'] as $user) {
			$user_ids[] = $user['id'];
		}
	}
	
	if (count($user_ids) > 0) {
		Env::useHelper('functions', 'advanced_services');
		$rows = get_unavailable_users_to_assign($parameters, $user_ids);
		
		// update result with the not available users
		if (is_array($rows)) {
			foreach ($rows as $row) {
				$not_available_user_id = $row['user_id'];
		
				foreach ($data['companies'] as &$company) {
					foreach ($company['users'] as &$user) {
						if ($user['id'] == $not_available_user_id) {
							$user['not_available'] = '1';
						}
					}
				}
			}
		}
	}
}


function task_availability_before_object_save($object, &$ret) {
	
	if ($object instanceof ProjectTask && config_option('dont allow unavailable users assign')) {

		$data = array_var($_REQUEST, 'task');
		if (is_array($data) && array_var($data, 'assigned_to_contact_id') > 0) {
			
			$assigned_user_id = array_var($data, 'assigned_to_contact_id');
			Env::useHelper('functions', 'advanced_services');
			
			$parameters = array(
				'task_id' => array_var($_REQUEST, 'task_id'),
				'start_date' => array_var($_REQUEST, 'task_start_date'),
				'start_time' => array_var($_REQUEST, 'task_start_time'),
				'due_date' => array_var($_REQUEST, 'task_due_date'),
				'due_time' => array_var($_REQUEST, 'task_due_time'),
				'estimated_mins' => array_var($data, 'time_estimate_minutes') + array_var($data, 'time_estimate_hours') * 60,
			);
			
			$unavailable_users = get_unavailable_users_to_assign($parameters, array($assigned_user_id));
			$unavailable_user_ids = array_flat($unavailable_users);
			
			if (in_array($assigned_user_id, $unavailable_user_ids)) {
				$contact = Contacts::findById($assigned_user_id);
				$contact_name = $contact instanceof Contact ? $contact->getObjectName() : '';
				throw new Exception(lang('this task cant be assigned to x in selected dates', $contact_name));
			}
		}
	}
}

