og.advanced_services = {
	init: function() {
		for (x in og.dimension_object_types) {
			if (!og.dimension_object_types[x] || typeof(og.dimension_object_types[x])=='function') continue;
			if (og.dimension_object_types[x] == 'hour_type') {
				og.additional_on_dimension_object_click[x] = 'og.advanced_services.onHourTypeClick(<parameters>);';
			} else if (og.dimension_object_types[x] == 'service_type') {
				og.additional_on_dimension_object_click[x] = 'og.advanced_services.onServiceTypeClick(<parameters>);';
			}
		}
		
		// add listeners to date components in task form to check availability
		if (!og.more_add_task_form_init_fn) og.more_add_task_form_init_fn = [];
		og.more_add_task_form_init_fn.push(function(genid) {
			
			var sd = Ext.getCmp(genid + "start_date");
			if (sd) {
				sd.addListener('change', function(picker, new_value, old_value) {
					og.on_task_datetime_change(genid);
				});
				sd.picker_select_listener = function(picker, new_value) {
					og.on_task_datetime_change(genid);
				}
			}
			var sdt = Ext.getCmp(genid + "start_date_time");
			if (sdt) {
				sdt.addListener('change', function(picker, new_value, old_value) {
					og.on_task_datetime_change(genid);
				});
				sdt.addListener('select', function(picker, new_value) {
					og.on_task_datetime_change(genid);
				});
			}
			
			var dd = Ext.getCmp(genid + "due_date");
			if (dd) {
				dd.addListener('change', function(picker, new_value, old_value) {
					og.on_task_datetime_change(genid);
				});
				dd.picker_select_listener = function(picker, new_value) {
					og.on_task_datetime_change(genid);
				}
			}
			var ddt = Ext.getCmp(genid + "due_date_time");
			if (ddt) {
				ddt.addListener('change', function(picker, new_value, old_value) {
					og.on_task_datetime_change(genid);
				});
				ddt.addListener('select', function(picker, new_value) {
					og.on_task_datetime_change(genid);
				});
			}

			$("#ogTasksPanelATHours").change(function() {
				og.on_task_datetime_change(genid);
			});
			$("#ogTasksPanelATMinutes").change(function() {
				og.on_task_datetime_change(genid);
			});

			og.on_task_datetime_change_build_params(genid);
		});
		
		if (!og.after_assigned_to_change_fn) og.after_assigned_to_change_fn = [];
		og.after_assigned_to_change_fn.push(function(genid, combo, selected) {
			if (selected && selected.data) {
				if (og.not_available_users && og.not_available_users.indexOf(selected.data.value) != -1) {
					$('#'+ genid +'taskFormAssignedToCombo').addClass("user not-available");
				} else {
					$('#'+ genid +'taskFormAssignedToCombo').removeClass("user not-available");
				}
			}
		});
		
		og.eventManager.addListener('after usersStore init', function(genid){
			var sel = Ext.getCmp(genid +'taskFormAssignedToCombo').getValue();
			if (sel) {
				if (og.not_available_users && og.not_available_users.indexOf(sel) != -1) {
					$('#'+ genid +'taskFormAssignedToCombo').addClass("user not-available");
				} else {
					$('#'+ genid +'taskFormAssignedToCombo').removeClass("user not-available");
				}
			}
		});
		
	},
	onServiceTypeClick: function (member_id) {
		og.memberTreeExternalClick('service_types', member_id);
	},
	onHourTypeClick: function (member_id) {
		og.memberTreeExternalClick('hour_types', member_id);
	}
}



// Task availability check functions ------

og.on_task_datetime_change_build_params = function(genid) {
	
	var start_date = Ext.getCmp(genid + "start_date").getValue();
	var el_st_time = Ext.getCmp(genid + "start_date_time");
	var start_time_str = el_st_time ? el_st_time.getValue() : '';
	
	var due_date = Ext.getCmp(genid + "due_date").getValue();
	var el_due_time = Ext.getCmp(genid + "due_date_time");
	var due_time_str = el_due_time ? el_due_time.getValue() : '';
	
	var task_id = $("#" + genid + "task_id").val();

	var start_date_str = '';
	if (start_date) {
		start_date_str = start_date.format(og.preferences.date_format);
	}
	
	var due_date_str = '';
	if (due_date) {
		due_date_str = due_date.format(og.preferences.date_format);
	}

	var estimated_mins = $("#ogTasksPanelATHours").val() * 60 + parseInt($("#ogTasksPanelATMinutes").val());
	
	var extra_params = {
			task_id: task_id,
			start_date: start_date_str,
			start_time: start_time_str,
			due_date: due_date_str,
			due_time: due_time_str,
			estimated_mins: estimated_mins
	}

	og.task_redraw_users_extra_params = Ext.util.JSON.encode(extra_params);
}

og.last_task_redraw_users_extra_params = null;

og.on_task_datetime_change = function(genid) {
	
	og.on_task_datetime_change_build_params(genid);

	// don't make the same request again
	if (og.task_redraw_users_extra_params != og.last_task_redraw_users_extra_params) {
		
		var dimension_members_json = Ext.util.JSON.encode(member_selector[genid].sel_context);
		og.redrawUserLists(dimension_members_json);
		
		og.last_task_redraw_users_extra_params = og.task_redraw_users_extra_params;
	}
}


og.replace_build_assigned_combo_store = function(companies, only_me, groups) {
	var usersStore = [];
	var comp_array = [];
	var preserveSelectedUser = false;
	var available_users = [];
	var not_available_users = [];
	
	var me_in_available = false;
	var me_present = false;
	
	if (!only_me) {
		usersStore.push(['0', lang('dont assign')]);
	}
	if (companies) {
		for (i=0; i<companies.length; i++) {
			comp = companies[i];
			if (!only_me && comp.id > 0) {
				comp_array.push([comp.id, og.clean(comp.name)]);
			}
			for (j=0; j<comp.users.length; j++) {
				usr = comp.users[j];
				if (usr.isCurrent) {
					me_present = true;
					var uname = lang('me') + " (" + usr.name + ")";
					if (usr.not_available) {
						not_available_users.unshift([usr.id, '<div class="user not-available">' + uname + '</div>']);
						//not_available_users.unshift([usr.id, uname]);
					} else {
						me_in_available = true;
						available_users.unshift([usr.id, '<div class="user available">' + uname + '</div>']);
						//available_users.unshift([usr.id, uname]);
					}
				} else if (!only_me) {
					if (usr.not_available) {
						not_available_users.push([usr.id, '<div class="user not-available">' + og.clean(usr.name) + '</div>']);
						//not_available_users.push([usr.id, og.clean(usr.name)]);
					} else {
						available_users.push([usr.id, '<div class="user available">' + og.clean(usr.name) + '</div>']);
						//available_users.push([usr.id, og.clean(usr.name)]);
					}
				}
				if(usr.id == ogTasks.assignedTo){
					preserveSelectedUser = true;
				}
			}
		}

		var me = null;
		// sort available users
		if (me_present && me_in_available) me = available_users.shift();
		if (available_users.length > 0) {
			available_users.sort(ogTasks.sortAssignedCombo);
		}
		if (me_present && me_in_available) available_users.unshift(me);
		
		// sort not available users
		if (me_present && !me_in_available) me = not_available_users.shift();
		if (not_available_users.length > 0) {
			not_available_users.sort(ogTasks.sortAssignedCombo);
		}
		if (me_present && !me_in_available) not_available_users.unshift(me);

		// add group titles
		if (available_users.length > 0) {
			if (!only_me) usersStore.push(['0', '<div class="task-group-name">'+ lang('available') +'</div>']);
			usersStore = usersStore.concat(available_users);
		}
		if (not_available_users.length > 0) {
			if (!only_me) usersStore.push(['0', '<div class="task-group-name">'+ lang('not available') +'</div>']);
			usersStore = usersStore.concat(not_available_users);
		}
		
		
		if (og.config['can_assign_tasks_to_companies'] && comp_array.length > 0) {
			usersStore.push(['0', '--']);
		}
	}
	if (og.config['can_assign_tasks_to_companies'] && comp_array.length > 0) {
		usersStore = usersStore.concat(comp_array);
	}
	
	if(!preserveSelectedUser){
		ogTasks.assignedTo = 0;
	}
	
	// remove undefined values
	var cleanStore = [];
	for (x in usersStore) {
		if (usersStore[x] && typeof(usersStore[x]) != 'function') cleanStore.push(usersStore[x]);
	}
	
	og.not_available_users = [];
	for (var i=0; i<not_available_users.length; i++) {
		var x = not_available_users[i];
		og.not_available_users.push(x[0]);
	}
	
	return cleanStore;
}
// Task availability check functions ------




if (!og.work_shifts) og.work_shifts = {};

og.work_shifts.show_day_data = function(genid, d) {
	$("#"+genid+"_day_data_"+d).show();
	$("#"+genid+"_work_shift_"+d+"_enabled").val("1");
	$("#"+genid+"_add_day_data_link_"+d).hide();
}

og.work_shifts.hide_day_data = function(genid, d) {
	$("#"+genid+"_day_data_"+d).hide();
	$("#"+genid+"_work_shift_"+d+"_enabled").val("0");
	$("#"+genid+"_add_day_data_link_"+d).show();
}