<?php 
	$genid = gen_id();
	$object = $absence;
	
	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.submit_modal_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	
	if ($absence->isNew()) {
	    $form_url = get_url('absence', 'add');
	} else {
	    $form_url = get_url('absence', 'edit', array('id' => $absence->getId()));
	}
	
	
	$categories = array();
	Hook::fire('object_edit_categories', $object, $categories);

	$main_cp_count = CustomProperties::countVisibleCustomPropertiesByObjectType($object->getObjectTypeId());
	$other_cp_count = CustomProperties::countHiddenCustomPropertiesByObjectType($object->getObjectTypeId());
?>
<form class="add-form" id="<?php echo $genid ?>submit-edit-form" onsubmit="<?php echo $on_submit?>" action="<?php echo $form_url ?>" method="post" enctype="multipart/form-data" >
<div class="form">
<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $object->getAddEditFormTitle(); ?>
	</div>
  </div>

  <div>
	<div class="coInputName">
		<?php echo text_field('absence[name]', $absence->getName(), array('id' => $genid . 'absenceName', 'class' => 'title', 'placeholder' => lang('type name here'))) ?>
	</div>
		
	<div class="coInputButtons">
		<?php echo submit_button($object->getSubmitButtonFormTitle(),'s', array('style'=>'margin-top:0px;margin-left:10px')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>


<div class="coInputMainBlock">
	
	<input id="<?php echo $genid?>genid" type="hidden" name="genid" value="<?php echo $genid ?>">
	<input id="<?php echo $genid?>updated-on-hidden" type="hidden" name="updatedon" value="<?php echo !$absence->isNew() ? $absence->getUpdatedOn()->getTimestamp() : '' ?>">
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_absence_details"><?php echo lang('details') ?></a></li>

			<li><a href="#<?php echo $genid?>add_absence_classification"><?php echo lang('context') ?></a></li>
			
			<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
			<li><a href="#<?php echo $genid?>add_linked_objects_div"><?php echo lang('linked objects') ?></a></li>
			<?php } ?>
			
			<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
			<li><a href="#<?php echo $genid?>add_custom_properties_div"><?php echo lang('custom properties') ?></a></li>
			<?php } ?>
			
			<li><a href="#<?php echo $genid?>add_subscribers_div"><?php echo lang('object subscribers') ?></a></li>
			
			<?php foreach ($categories as $category) {
					if (array_var($category, 'hidden')) continue;
				?>
			<li><a href="#<?php echo $genid . $category['name'] ?>"><?php echo $category['name'] ?></a></li>
			<?php } ?>
		</ul>
	
		<div id="<?php echo $genid ?>add_absence_details" class="editor-container form-tab">
		
			<?php $null = null; Hook::fire('before_render_main_custom_properties', array('object' => $object), $null);?>
			
			<div class="dataBlock main-custom-properties-div"><?php
				if ($main_cp_count) {
					echo render_object_custom_properties($object, false, null, 'visible_by_default');
				}
			?></div>
			<div class="clear"></div>
			
		</div>

		<div id="<?php echo $genid ?>add_absence_classification" class="editor-container form-tab">
		
			<div id="<?php echo $genid ?>add_absence_select_context_div">
				<?php
				$listeners = array('on_selection_change' => 'og.reload_subscribers("'.$genid.'",'.$object->manager()->getObjectTypeId().')');
				if ($absence->isNew()) {
				    render_member_selectors($absence->manager()->getObjectTypeId(), $genid, null, array('select_current_context' => true, 'listeners' => $listeners, 'object' => $object), null, null, false);
				} else {
				    render_member_selectors($absence->manager()->getObjectTypeId(), $genid, $absence->getMemberIds(), array('listeners' => $listeners, 'object' => $object), null, null, false);
				} 
				?>
			</div>
			<div class="clear"></div>
		</div>
		
		<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
		<div id="<?php echo $genid ?>add_custom_properties_div" class="form-tab other-custom-properties-div">
			<?php  echo render_object_custom_properties($object, false, null, 'other') ?>
			<?php  echo render_add_custom_properties($object); ?>
		</div>
		<?php } ?>
		
		<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
		<div id="<?php echo $genid ?>add_linked_objects_div" class="form-tab">
			<?php echo render_object_link_form($object) ?>
		</div>
		<?php } // if ?>
		
		<div id="<?php echo $genid ?>add_subscribers_div" class="form-tab">
			<div id="<?php echo $genid ?>add_subscribers_content">
				<?php echo render_add_subscribers($object, $genid); ?>
			</div>
		</div>		

	
		<?php foreach ($categories as $category) { ?>
		<div id="<?php echo $genid . $category['name'] ?>" class="form-tab">
			<?php echo $category['content'] ?>
		</div>
		<?php } ?>

	
	<div class="clear"></div>
</div>
	<?php if (!array_var($_REQUEST, 'modal')) {
	    echo submit_button($absence->isNew() ? lang('add absence') : lang('save changes'),'s', array('tabindex' => '20000')); 
	}?>
</div>
</form>

<script>
var genid = '<?php echo $genid?>';
$(function(){
	$("#<?php echo $genid?>tabs").tabs();
});


</script>