<?php
if (isset($absence) && $absence instanceof Absence) {
    if (!$absence->isTrashed()){
        if($absence->canEdit(logged_user())) {
            add_page_action(lang('edit'), "javascript:og.render_modal_form('', {c:'absence', a:'edit', params: {id:".$absence->getId()."}});", 'ico-edit', null, null, true);
			
			if (!$absence->isArchived()) {
			    add_page_action(lang('archive'), "javascript:if(confirm(lang('confirm archive object'))) og.openLink('" . $absence->getArchiveUrl() ."');", 'ico-archive-obj');
			} else {
			    add_page_action(lang('unarchive'), "javascript:if(confirm(lang('confirm unarchive object'))) og.openLink('" . $absence->getUnarchiveUrl() ."');", 'ico-unarchive-obj');
			}
		}
	}
	if ($absence->canDelete(logged_user())) {
	    if ($absence->isTrashed()) {
	        add_page_action(lang('restore from trash'), "javascript:if(confirm(lang('confirm restore objects'))) og.openLink('" . $absence->getUntrashUrl() ."');", 'ico-restore', null, null, true);
	        add_page_action(lang('delete permanently'), "javascript:if(confirm(lang('confirm delete permanently'))) og.openLink('" . $absence->getDeletePermanentlyUrl() ."');", 'ico-delete', null, null, true);
		} else {
		    add_page_action(lang('move to trash'), "javascript:if(confirm(lang('confirm move to trash'))) og.openLink('" . $absence->getTrashUrl() ."');", 'ico-trash', null, null, true);
		}
	}
?>

<div style="padding:7px">
<div class="form">
<?php

	tpl_assign("object", $absence);
	tpl_assign('iconclass', 'ico-large-form');
	
	$this->includeTemplate(get_template_path('view', 'co'));
?>
</div>
</div>
<?php } ?>
