-- add the absence type
INSERT INTO `<?php echo $table_prefix ?>object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
 ('absence', 'Absences', 'absences', 'content_object', 'absence', (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='attendance_absence_tracking'), 0)
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
	SELECT dot.dimension_id, dot.dimension_object_type_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='absence'), dot.is_required, dot.is_multiple
	FROM <?php echo $table_prefix ?>dimension_object_type_contents dot
	WHERE dot.content_object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='message')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>dimension_object_type_contents.dimension_id=<?php echo $table_prefix ?>dimension_object_type_contents.dimension_id;

INSERT INTO `<?php echo $table_prefix ?>tab_panels` (`id`,`title`,`icon_cls`,`refresh_on_context_change`,`default_controller`,`default_action`,`initial_controller`,`initial_action`,`enabled`,`type`,`ordering`,`plugin_id`,`object_type_id`) VALUES 
 ('absences-panel', 'absences', 'ico-absences', 1, 'absence', 'index', '', '', 1, 'system', 11, (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='attendance_absence_tracking'), (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='absence')) 
ON DUPLICATE KEY UPDATE id=id;

-- permissions for roles
INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('absence')
	 AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 0, 0
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('absence')
	 AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');

INSERT INTO <?php echo $table_prefix ?>role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('absence')
	AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');


-- add permissions to users where the users already have permissions (copy permissions from tasks)
INSERT INTO <?php echo $table_prefix ?>contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
 SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='absence'), cmp.can_delete, cmp.can_write 
 FROM <?php echo $table_prefix ?>contact_member_permissions cmp
 WHERE cmp.object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>contact_member_permissions.member_id=<?php echo $table_prefix ?>contact_member_permissions.member_id;

INSERT INTO <?php echo $table_prefix ?>tab_panel_permissions (permission_group_id, tab_panel_id)
 SELECT pg.id, 'absences-panel' FROM <?php echo $table_prefix ?>permission_groups pg WHERE pg.type='roles' AND pg.name IN ('Super Administrator','Administrator','Manager','Executive')
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;

INSERT INTO <?php echo $table_prefix ?>tab_panel_permissions (permission_group_id, tab_panel_id)
 SELECT c.permission_group_id, 'absences-panel' FROM <?php echo $table_prefix ?>contacts c 
 WHERE c.user_type IN (SELECT pg.id FROM <?php echo $table_prefix ?>permission_groups pg WHERE pg.type='roles' and pg.name IN ('Super Administrator','Administrator','Manager','Executive'))
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;

INSERT INTO `<?php echo $table_prefix ?>custom_properties` (`object_type_id`,`name`,`code`,`type`,`description`,`values`,`default_value`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`, `is_special`, `is_disabled`) VALUES 
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='absence'),'Total hours per day','total_hours_per_day','numeric','','','',1,0,0,1, 1,0),
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='absence'),'User','contact_id','user','','','',1,0,1,1,2,0),
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='absence'),'Start date','start_date','datetime','','','',1,0,2,1,1,0),
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='absence'),'Due Date','due_date','datetime','','','',1,0,3,1,1,0), 
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='absence'),'Description','description','memo','','','',0,0,4,1,1,0)
ON DUPLICATE KEY UPDATE object_type_id=object_type_id;