<?php
Hook::register('billing_rates_dimension');


function billing_rates_dimension_after_add_to_members($object, &$members) {
	if ($object instanceof Timeslot) {

		$dim = Dimensions::findByCode('billing_rates');
		
		foreach ($members as $member) {
			if ($member->getDimensionId() == $dim->getId()) return;
		}
		
		// if not classified in status dimension -> classify in default member if it is defined
		$default_value = DimensionOptions::instance()->getOptionValue($dim->getId(), 'default_value');
		if ($default_value > 0) {
			
			$default_member = Members::getMemberById($default_value);
			if ($default_member instanceof Member) {
				$object->addToMembers(array($default_member));
			}
		}

	}
}