<?php

function apply_rate_multiplier_to_field($object, $field, &$value) {
	$field_modified = false;
	
	$multiplier = 1;
	$member_ids = $object->getMemberIds();
		
	$regular_member_id = config_option('regular_rate_member_id');
	$overtime_member_id = config_option('overtime_rate_member_id');
	$double_overtime_member_id = config_option('double_overtime_rate_member_id');
	$non_billable_member_id = config_option('non_billable_rate_member_id');
		
	if (in_array($regular_member_id, $member_ids)) {
		$multiplier = config_option('regular_rate_multiplier');
	} else if (in_array($overtime_member_id, $member_ids)) {
		$multiplier = config_option('overtime_rate_multiplier');
	} else if (in_array($double_overtime_member_id, $member_ids)) {
		$multiplier = config_option('double_overtime_rate_multiplier');
	} else if (in_array($non_billable_member_id, $member_ids)) {
		$multiplier = config_option('non_billable_multiplier');
	}
		
	if ($multiplier != 1) {
		$value = $multiplier * $object->getColumnValue($field);
		$object->setColumnValue($field, $value);
		$field_modified = true;
	}
	
	return $field_modified;
}