<?php

  /**
  * BaseTaskActionCondition class
  *
  * @author Alvaro Torterola <alvaro.torterola@fengoffice.com>
  */
  abstract class BaseTaskActionCondition extends DataObject {
  
  	  
    // -------------------------------------------------------
    //  Access methods
    // -------------------------------------------------------
    
  	/**
  	 * Return value of 'task_id' field
  	 *
  	 * @access public
  	 * @param void
  	 * @return string
  	 */
  	function getTaskId() {
  		return $this->getColumnValue('task_id');
  	} // getId()
  	
  	/**
  	 * Set value of 'task_id' field
  	 *
  	 * @access public
  	 * @param string $value
  	 * @return boolean
  	 */
  	function setTaskId($value) {
  		return $this->setColumnValue('task_id', $value);
  	} // setId()
  
    /**
    * Return value of 'action' field
    *
    * @access public
    * @param void
    * @return string 
    */
    function getAction() {
      return $this->getColumnValue('action');
    } 
    
    /**
    * Set value of 'action' field
    *
    * @access public   
    * @param string $value
    * @return boolean
    */
    function setAction($value) {
      return $this->setColumnValue('action', $value);
    } 
    
    /**
    * Return value of 'property' field
    *
    * @access public
    * @param void
    * @return string 
    */
    function getProperty() {
      return $this->getColumnValue('property');
    } 
    
    /**
    * Set value of 'property' field
    *
    * @access public   
    * @param string $value
    * @return boolean
    */
    function setProperty($value) {
      return $this->setColumnValue('property', $value);
    } 
    

    
    /**
    * Return value of 'required_values' field
    *
    * @access public
    * @param void
    * @return string 
    */
    function getRequiredValues() {
      return $this->getColumnValue('required_values');
    }
    
    /**
    * Set value of 'required_values' field
    *
    * @access public   
    * @param string $value
    * @return boolean
    */
    function setRequiredValues($value) {
      return $this->setColumnValue('required_values', $value);
    }
    
    
    /**
     * Return value of 'defined_only_in_templates' field
     *
     * @access public
     * @param void
     * @return string
     */
    function getDefinedOnlyInTemplates() {
    	return $this->getColumnValue('defined_only_in_templates');
    }
    
    /**
     * Set value of 'defined_only_in_templates' field
     *
     * @access public
     * @param string $value
     * @return boolean
     */
    function setDefinedOnlyInTemplates($value) {
    	return $this->setColumnValue('defined_only_in_templates', $value);
    }

    
    /**
    * Return manager instance
    *
    * @access protected
    * @param void
    * @return TaskActionConditions 
    */
    function manager() {
      if(!($this->manager instanceof TaskActionConditions)) $this->manager = TaskActionConditions::instance();
      return $this->manager;
    } // manager
  
  } // BaseTaskActionCondition 

?>