<?php

include_once dirname(__FILE__)."/../../../application/helpers/plugin_installer_functions.php";

function __conditional_tasks_get_workflow_association_query($db_connection, $table_prefix, $dim, $ot, $assoc_dim, $assoc_ot) {
	$sql = "SELECT id FROM `".$table_prefix."dimension_member_associations`
			WHERE dimension_id=(SELECT id FROM ".$table_prefix."dimensions WHERE code='$dim')
			AND object_type_id=(SELECT id FROM ".$table_prefix."object_types WHERE name='$ot')
			AND associated_dimension_id=(SELECT id FROM ".$table_prefix."dimensions WHERE code='$assoc_dim')
			AND associated_object_type_id=(SELECT id FROM ".$table_prefix."object_types WHERE name='$assoc_ot')";
	$assoc_id = null;
	$mysql_res = mysqli_query($db_connection, $sql);
	if ($mysql_res) {
		$row = mysqli_fetch_assoc($mysql_res);
		if (is_array($row) && count($row) > 0) {
			$assoc_id = $row['id'] > 0 ? $row['id'] : null;
		}
	}
	
	if (!$assoc_id) {
		return null;
	}
	
	return "INSERT INTO ".$table_prefix."dimension_associations_config (association_id, config_name, value) VALUES
		($assoc_id, 'workflow_can_change_value', '1'),
		($assoc_id, 'keeps_old_value', '')
		ON DUPLICATE KEY UPDATE association_id=association_id;";
}

function conditional_tasks_get_additional_install_queries($db_connection, $table_prefix) {
	
	$queries = array();
	
	$is_installed_crpm = check_is_installed_plugin($db_connection, $table_prefix, 'crpm');
	$is_installed_crpm_types = check_is_installed_plugin($db_connection, $table_prefix, 'crpm_types');
	
	if ($is_installed_crpm && $is_installed_crpm_types) {
		$project_dim_code = 'customer_project';
		$customer_dim_code = 'customer_project';
		
		$queries[] = __conditional_tasks_get_workflow_association_query($db_connection, $table_prefix, $project_dim_code, 'project', 'project_statuses', 'project_status');
		$queries[] = __conditional_tasks_get_workflow_association_query($db_connection, $table_prefix, $project_dim_code, 'project', 'project_types', 'project_type');
		$queries[] = __conditional_tasks_get_workflow_association_query($db_connection, $table_prefix, $customer_dim_code, 'customer', 'customer_types', 'customer_type');
		$queries[] = __conditional_tasks_get_workflow_association_query($db_connection, $table_prefix, $customer_dim_code, 'customer', 'customer_stages', 'customer_stage');
		
	}
	
	return $queries;

}
?>