
og.eventManager.addListener('more template object actions', function(parameters){
	if (parameters.obj && parameters.actions_div) {
		og.task_workflow.mark_task_as_conditional(parameters.obj);
	}
});

og.eventManager.addListener('template object added', function(data) {
	
	og.task_workflow.draw_task_to_instantiate(data);
	
});

og.task_workflow = {};

og.task_workflow.mark_task_as_conditional = function (tobj) {
	var cond_tasks_input = $("#templateForm input[name='conditional_task_ids']").first();
	var cond_tasks_input_val = $(cond_tasks_input).val();
	if (!cond_tasks_input_val) {
		return;
	}
	var cond_task_ids = cond_tasks_input_val.split(',');
	if (cond_task_ids.indexOf(tobj.object_id.toString()) >= 0) {
		setTimeout(function(){
			$("#objectDiv"+tobj.object_id).addClass('conditional');
		}, 200);
	}
}

og.task_workflow.copy_cond_combos = function (params) {

	$("#"+params.genid+'_'+params.index+'_conditions_container').append("<div id='"+params.genid+'_'+params.index+'_'+params.cond_count+"_single_condition' class='single-condition'></div>");

	// copy all inputs
	var new_field_sel = $("#" + params.genid + "_" + params.index + "_t_conditions_combo").clone();
	$(new_field_sel).attr('id', params.genid + "_" + params.index + "_"+ params.cond_count +"_conditions_combo");
	$(new_field_sel).attr('name', "task_workflow[" + params.index + "]["+ params.cond_count +"][field]");
	$("#" + params.genid+'_'+params.index+'_'+params.cond_count+"_single_condition").append(new_field_sel);

	var new_num_comp = $("#" + params.genid + "_" + params.index + "_t_comp_numeric").clone();
	$(new_num_comp).attr('id', params.genid + "_" + params.index + "_"+ params.cond_count +"_comp_numeric");
	$(new_num_comp).attr('name', "task_workflow[" + params.index + "]["+ params.cond_count +"][comp_n]");
	$("#" + params.genid+'_'+params.index+'_'+params.cond_count+"_single_condition").append(new_num_comp);
	$(new_num_comp).hide();

	var new_text_comp = $("#" + params.genid + "_" + params.index + "_t_comp_text").clone();
	$(new_text_comp).attr('id', params.genid + "_" + params.index + "_"+ params.cond_count +"_comp_text");
	$(new_text_comp).attr('name', "task_workflow[" + params.index + "]["+ params.cond_count +"][comp_t]");
	$("#" + params.genid+'_'+params.index+'_'+params.cond_count+"_single_condition").append(new_text_comp);
	$(new_text_comp).hide();

	var new_nt_val = $("#" + params.genid + "_" + params.index + "_t_value_text_num").clone();
	$(new_nt_val).attr('id', params.genid + "_" + params.index + "_"+ params.cond_count +"_value_text_num");
	$(new_nt_val).attr('name', "task_workflow[" + params.index + "]["+ params.cond_count +"][value_nt]");
	$("#" + params.genid+'_'+params.index+'_'+params.cond_count+"_single_condition").append(new_nt_val);
	$(new_nt_val).hide();

	var new_b_val = $("#" + params.genid + "_" + params.index + "_t_value_bool").clone();
	$(new_b_val).attr('id', params.genid + "_" + params.index + "_"+ params.cond_count +"_value_bool");
	$(new_b_val).attr('name', "task_workflow[" + params.index + "]["+ params.cond_count +"][value_b]");
	$("#" + params.genid+'_'+params.index+'_'+params.cond_count+"_single_condition").append(new_b_val);
	$(new_b_val).hide();

	var delete_link = '<a class="link-ico ico-delete delete-link" onclick="$(this).parent().remove();" title="'+lang('delete this condition')+'">&nbsp;</a>';
	$("#" + params.genid+'_'+params.index+'_'+params.cond_count+"_single_condition").append(delete_link);

	// set selected values
	if (params.sel_field) {
		$(new_field_sel).val(params.sel_field);
		var type = og.task_workflow.field_types[params.sel_field];

		if (typeof(params.sel_comp) != 'undefined') {
			if (type == 'integer' || type == 'numeric') {
				$(new_num_comp).val(params.sel_comp);
			} else if (type == 'string' || type == 'text') {
				$(new_text_comp).val(params.sel_comp);
			}
		}
		
		if (typeof(params.cond_value) != 'undefined') {
			if (type == 'integer' || type == 'numeric' || type == 'string' || type == 'text') {
				$(new_nt_val).val(params.cond_value);
			} else if (type == 'boolean') {
				$(new_b_val).val(params.cond_value);
			}
		}
		
		og.task_workflow.enable_field_inputs(params.genid, params.index, params.cond_count, params.sel_field);
	}
}

og.task_workflow.add_new_condition = function(genid, index, sel_field, sel_comp, cond_value) {
	if (!og.task_workflow.cond_counts[genid]) {
		og.task_workflow.cond_counts[genid] = {};
		og.task_workflow.cond_counts[genid][index] = 0;
	}
	if (!og.task_workflow.cond_counts[genid][index]) {
		og.task_workflow.cond_counts[genid][index] = 0;
	}

	var cond_count = og.task_workflow.cond_counts[genid][index];
	og.task_workflow.cond_counts[genid][index] = og.task_workflow.cond_counts[genid][index] + 1;
	
	og.task_workflow.copy_cond_combos({genid:genid, index:index, cond_count:cond_count, sel_field:sel_field, sel_comp:sel_comp, cond_value:cond_value});
}

og.task_workflow.on_cond_field_change = function(combo) {
	var split = combo.id.split('_');
	var genid = split[0] + '_' + split[1] + '_' + split[2];
	var index = split[3];
	var cond_count = split[4];
	var field = combo.options[combo.selectedIndex].value;

	og.task_workflow.enable_field_inputs(genid, index, cond_count, field);
}

og.task_workflow.enable_field_inputs = function(genid, index, cond_count, field) {
	var type = og.task_workflow.field_types[field];
	var pre_id = genid + '_' + index + '_' + cond_count;
	
	if (type == 'integer' || type == 'numeric') {
		$("#" + pre_id + "_comp_numeric").show();
		$("#" + pre_id + "_value_text_num").show();
		
		$("#" + pre_id + "_comp_text").hide();
		$("#" + pre_id + "_value_bool").hide();
		
	} else if (type == 'string' || type == 'text') {
		$("#" + pre_id + "_comp_text").show();
		$("#" + pre_id + "_value_text_num").show();
		
		$("#" + pre_id + "_comp_numeric").hide();
		$("#" + pre_id + "_value_bool").hide();
		
	} else if (type == 'boolean') {
		$("#" + pre_id + "_value_bool").show();
		
		$("#" + pre_id + "_comp_text").hide();
		$("#" + pre_id + "_comp_numeric").hide();
		$("#" + pre_id + "_value_text_num").hide();
		
	} else {
		$("#" + pre_id + "_value_bool").hide();
		$("#" + pre_id + "_comp_text").hide();
		$("#" + pre_id + "_comp_numeric").hide();
		$("#" + pre_id + "_value_text_num").hide();
	}
}


og.task_workflow.copy_action_combos = function (params) {
	
	$("#"+params.genid+'_'+params.index+'_actions_container').append("<div id='"+params.genid+'_'+params.index+'_'+params.act_count+"_single_action' class='single-action'></div>");

	// copy all inputs
	var new_action_sel = $("#" + params.genid + "_" + params.index + "_t_actions_combo").clone();
	$(new_action_sel).attr('id', params.genid + "_" + params.index + "_"+ params.act_count +"_actions_combo");
	$(new_action_sel).attr('name', "task_workflow_actions[" + params.index + "]["+ params.act_count +"][action]");
	$(new_action_sel).attr('params', Ext.util.JSON.encode(params));
	$(new_action_sel).change(og.task_workflow.on_actions_select_change);
	$("#" + params.genid+'_'+params.index+'_'+params.act_count+"_single_action").append(new_action_sel);
	
	// clone instantiation data containers
	var inst_container_html = '<div class="clear" id="'+ params.genid +'_'+ params.index + '_instantiate">';
	$("#" + params.genid+'_'+params.index+'_'+params.act_count+"_single_action").append(inst_container_html);
	
	var task_container_html = '<div class="tasks-to-instantiate-container clear" id="'+ params.genid +'_'+ params.index + '_tasks_to_instantiate_container">';
	$("#" + params.genid +'_'+ params.index + "_instantiate").append(task_container_html);

	var new_add_task_link = $("#" + params.genid + "_" + params.index + "_t_add_task_link").clone();
	$(new_add_task_link).attr('id', params.genid + "_" + params.index + "_"+ params.act_count +"_add_task_link");
	$("#" + params.genid +'_'+ params.index + "_instantiate").append(new_add_task_link);
	
	// clone dimension selectors containers
	var association_divs =  $("." + params.genid +'_'+ params.index + "_change_assoc_dim");
	for (var i=0; i<association_divs.length; i++) {
		var new_adiv = $(association_divs[i]).clone();
		var id_suffix = $(new_adiv).attr('id').substring($(new_adiv).attr('id').indexOf('_change_assoc_dim'));
		$(new_adiv).attr('id', params.genid + "_" + params.index + id_suffix);
		$("#" + params.genid+'_'+params.index+'_'+params.act_count+"_single_action").append(new_adiv);
	}

	//	var delete_link = '<a class="link-ico ico-delete delete-link" onclick="$(this).parent().remove();" title="'+lang('delete this action')+'">&nbsp;</a>';
	//	$("#" + params.genid+'_'+params.index+'_'+params.act_count+"_single_action").append(delete_link);
	
	// set selected values
	if (params.sel_action) {
		$(new_action_sel).val(params.sel_action);
		
		if (params.act_data) {
			if (params.sel_action == 'instantiate') {
				// split  de act_data, para cada task_id pedir el objeto, poner ademas en data el genid, index y act_count
				og.openLink(og.getUrl('template', 'get_template_tasks_data', {ids:params.act_data}), {
					hideLoading: true,
					callback: function(success, data) {
						var tasks = data.tasks;
						for (var x=0; x<tasks.length; x++) {
							var task = tasks[x];
							if (!task) continue;
							var data = {
								genid: params.genid,
								index: params.index,
								act_count: params.act_count,
								object: task
							};
							og.task_workflow.draw_task_to_instantiate(data);
						}
					}
				});
				
			} else if (params.sel_action == 'change_assoc_dim') {
				// set selected value
				if (params.act_data) {
					var decoded_data = Ext.util.JSON.decode(params.act_data);
					var dim_assoc_id = null;
					for (x in decoded_data) {
						dim_assoc_id = x;
						break;
					}
					if (dim_assoc_id) {
						// set selected option in actions combo
						$(new_action_sel).val('change_assoc_dim_' + dim_assoc_id);
						// execute onchange event function to render the selector
						$(new_action_sel).change();
					}
				}
			}
		}
		
		//og.task_workflow.enable_action_inputs(params.genid, params.index, params.cond_count, params.sel_field);
	}

}

og.task_workflow.draw_task_to_instantiate = function(data) {
	var task_html = '<div class="link-ico '+ data.object.ico +'">' 
	+ data.object.name
	+ '<a class="link-ico ico-delete delete-link" onclick="$(this).parent().remove();" title="'+lang('delete this task')+'">&nbsp;</a>'
	+ '<input type="hidden" name="task_workflow_actions['+ data.index +']['+ data.act_count +'][tasks_to_instantiate]['+ data.object.id +']" value="'+ data.object.id +'"/>'
	+ '</div>';

	$("#" + data.genid +'_'+ data.index + "_tasks_to_instantiate_container").append(task_html);	
	
	var cond_tasks_input = $("#templateForm input[name='conditional_task_ids']").first();
	var tids = $(cond_tasks_input).val();
	tids = (tids == "" ? "" : ",") + data.object.id;
	$(cond_tasks_input).val(tids);
	
	og.task_workflow.mark_task_as_conditional({object_id: data.object.id});
}

og.task_workflow.create_task_to_instantiate = function(link_el, genid, index) {
	Ext.getCmp('tabs-panel').activate('task_to_inst');
	var form_genid = $("input[name='genid']").val();

	var split_id = $(link_el).parent().attr('id').split('_');
	var act_count = split_id[4];
	
	var params = {
		template_task:1,
		template_id: $("#"+form_genid+"template_id").val(),
		additional_tt_params: Ext.util.JSON.encode({genid: genid, index:index, act_count:act_count})
	}
	og.render_modal_form('', {c:'task', a:'add_task', params: params});
	/*
	og.openLink(og.getUrl('task', 'add_task', {
		template_task:1,
		template_id: $("#"+form_genid+"template_id").val(),
		additional_tt_params: Ext.util.JSON.encode({genid: genid, index:index, act_count:act_count})
	}), {caller:'task_to_inst'});*/ 
}



og.task_workflow.add_new_action = function(genid, index, sel_action, act_data) {
	if (!og.task_workflow.action_counts[genid]) {
		og.task_workflow.action_counts[genid] = {};
		og.task_workflow.action_counts[genid][index] = 0;
	}
	if (!og.task_workflow.action_counts[genid][index]) {
		og.task_workflow.action_counts[genid][index] = 0;
	}

	var act_count = og.task_workflow.action_counts[genid][index];
	og.task_workflow.action_counts[genid][index] = og.task_workflow.action_counts[genid][index] + 1;
	
	og.task_workflow.copy_action_combos({genid:genid, index:index, act_count:act_count, sel_action:sel_action, act_data:act_data});
}


og.task_workflow.hide_dialog_and_reload_grid = function() {
	og.ExtendedDialog.hide();
	setTimeout(function() {
		Ext.getCmp('object-picker').grid.store.reload();
	}, 500);

	return true;
}


// show object picker with add task button.
og.task_workflow.pick_task_to_instantiate = function(link_el, genid, index) {
	
	var form_genid = $("input[name='genid']").val();

	var split_id = $(link_el).parent().attr('id').split('_');
	var act_count = split_id[4];
	
	var extra_list_params = {
		template_id: $("#"+form_genid+"template_id").val(),
		id_no_select: $("#"+form_genid+"task_id").val()
	};
	og.ObjectPicker.show(function (objs) {
		if (objs && objs.length > 0) {
			var obj = objs[0].data;
			if (obj.type != 'template_task') {
				og.msg(lang("error"), lang("object type not supported"), 4, "err");
			} else {
				for (var x=0; x<objs.length; x++) {
					var o = objs[x];
					var obj = {id: o.data.object_id, name: o.data.name, ico: o.data.icon};
					og.task_workflow.draw_task_to_instantiate({object: obj, act_count:act_count, index:index, genid:genid});
				}
			}
		}
	}, link_el, {
		hideFilters: true,
		hideUploadButton: true,
		types: ['template_task'],
		selected_type: 'template_task',
		extra_list_params : extra_list_params/*,
		more_tbar_items: [{
			text: lang('add new task'),
            iconCls: 'ico-add',
            handler: function() {
				var quickId = Ext.id();
				var picker = this;
				og.openLink(og.getUrl('task', 'add_task', {genid: quickId, template_task:1, template_id:$("#"+form_genid+"template_id").val(), additional_onsubmit:'og.task_workflow.hide_dialog_and_reload_grid()'}), {
        			preventPanelLoad: true,
					onSuccess: function(data) {
	        			og.ExtendedDialog.show({
	                		html: data.current.data,
	                		height: 520,
	                		width: 1050,
	                		title: lang('new task'),
	                		noCancel: true,
	                		noOkBtn: true
	                	});
	                	return;
        			}
        		});
			},
			scope: this
		}]*/
	},'', null);
}