<?php 

function __conditional_tasks_add_association_to_tasks_workflow($dim, $ot, $assoc_dim, $assoc_ot) {
	$row = DB::executeOne("
		SELECT id FROM `".TABLE_PREFIX."dimension_member_associations`
		WHERE dimension_id=(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='$dim')
			AND object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='$ot')
			AND associated_dimension_id=(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='$assoc_dim')
			AND associated_object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='$assoc_ot');
	");
	if ($row && $row['id']) {
		$aid = $row['id'];
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."dimension_associations_config (association_id, config_name, value) VALUES
				($aid, 'workflow_can_change_value', '1'),
				($aid, 'keeps_old_value', '')
				ON DUPLICATE KEY UPDATE association_id=association_id;
		");
	}
}

function conditional_tasks_update_1_2() {
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."dimension_associations_config` (
			`association_id` int(10) unsigned NOT NULL,
			`config_name` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
			`value` text COLLATE utf8_unicode_ci NOT NULL,
			PRIMARY KEY (`association_id`,`config_name`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	

	if (Plugins::instance()->isActivePlugin('crpm') && Plugins::instance()->isActivePlugin('crpm_types')) {
		$project_dim_code = 'customer_project';
		Env::useHelper('functions', 'crpm');
		$customer_dim_code = get_customers_dimension()->getCode();
		
		__conditional_tasks_add_association_to_tasks_workflow($project_dim_code, 'project', 'project_statuses', 'project_status');
		__conditional_tasks_add_association_to_tasks_workflow($project_dim_code, 'project', 'project_types', 'project_type');
		__conditional_tasks_add_association_to_tasks_workflow($customer_dim_code, 'customer', 'customer_types', 'customer_type');
		__conditional_tasks_add_association_to_tasks_workflow($customer_dim_code, 'customer', 'customer_stages', 'customer_stage');
	}
}

function conditional_tasks_update_2_3() {
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."config_categories` (`name`, `is_system`, `category_order`) VALUES
		('task_workflow', 0, 10);
	");
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
		('task_workflow', 'workflow_dims_to_copy_next_task', (SELECT GROUP_CONCAT(d.id) FROM ".TABLE_PREFIX."dimensions d WHERE d.is_manageable=1), 'ManageableDimensionsConfigHandler', '0', '0', NULL);
	");
}

// fix the installer error that not added these configs
function conditional_tasks_update_3_4() {
	if (Plugins::instance()->isActivePlugin('crpm') && Plugins::instance()->isActivePlugin('crpm_types')) {
		$project_dim_code = 'customer_project';
		Env::useHelper('functions', 'crpm');
		$customer_dim_code = get_customers_dimension()->getCode();
		
		__conditional_tasks_add_association_to_tasks_workflow($project_dim_code, 'project', 'project_statuses', 'project_status');
		__conditional_tasks_add_association_to_tasks_workflow($project_dim_code, 'project', 'project_types', 'project_type');
		__conditional_tasks_add_association_to_tasks_workflow($customer_dim_code, 'customer', 'customer_types', 'customer_type');
		__conditional_tasks_add_association_to_tasks_workflow($customer_dim_code, 'customer', 'customer_stages', 'customer_stage');
	}
}
