<?php 
class CrpmController extends ApplicationController {
	
	var $plugin_name = "crpm";
	
	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'website');
		Env::useHelper("api", $this->plugin_name);
		Env::useHelper("functions", $this->plugin_name);
	}
	
	

	function generate_first_repetitions_for_task() {
	
		$task = ProjectTasks::findById(get_id());
		if (!($task instanceof ProjectTask)) {
			flash_error(lang('task dnx'));
			ajx_current("empty");
			return;
		}
	
		if(!$task->canEdit(logged_user())) {
			flash_error(lang('no access permissions'));
			ajx_current("empty");
			return;
		}
	
		if (!$task->isRepetitive()) {
			flash_error(lang('task not repetitive'));
			ajx_current("empty");
			return;
		}
	
		try {
			DB::beginWork();
				
			generate_first_repetitions_for_task($task);
				
			DB::commit();
				
			flash_success(lang("first task repetitions generated successfully"));
			ajx_current("reload");
				
		} catch (Exception $e) {
			DB::rollback();
			flash_error($e->getMessage());
			ajx_current("empty");
			return;
		}
	
	}
	
		
	public function add_contact() {
	
		$contact_id = array_var($_POST, 'new_contact')	;
		$target = array_var($_POST, 'target')	; // target = 'customer' or 'project'
		$target_id = array_var($_POST, 'target_id')	; // id of parent object (customerId o projectId)
		
		try {
			$crpmObject = Objects::findObject($target_id) ;
		
			if (!$crpmObject->canEdit(logged_user())){
				flash_error(lang('no access permissions'));
				return; 
			} 			
			if ( $contact_id && $target && $target_id ) {
				$targetMembers = Members::findByObjectId($target_id);
				
				$contactMembers = Members::findByObjectId($contact_id, Dimensions::findByCode('feng_persons')->getId());
				//CrpmAPI::addContact($contactMembers[0],$targetMembers[0]);
			}else{
				flash_error(lang("invalid parameters"));
			}
			//evt_add("reload dimension tree",$contactMembers[0]->getDimensionId());
			tpl_assign("contact", Contacts::instance()->findById($contact_id));
		} catch (Exception $e) {
			flash_error($e->getMessage());
		}
	}
	
	
	public function wizard() {
		$this->setLayout('empty');
	}
}