<?php

function get_tasks_for_statistics_widget($members){

    $SQL_BASE_JOIN = "SELECT e.completed_by_id as completed_by_id, e.due_date as due_date FROM ".TABLE_PREFIX."project_tasks e
    INNER JOIN ".TABLE_PREFIX."objects o ON e.object_id = o.id ";

    $extra_info = get_widget_context_condition($members);
    $SQL_BASE_JOIN .= $extra_info['SQL_BASE_JOIN'];
    $SQL_CONTEXT_CONDITION = $extra_info['SQL_CONTEXT_CONDITION']; 

    $SQL_MAIN_CONDITION = ($SQL_CONTEXT_CONDITION == '' ? '' : " AND ");
    $SQL_MAIN_CONDITION .= " `o`.`trashed_on` = 0 AND `o`.`archived_on` = 0  AND is_template = 0";

    
    $sql = "$SQL_BASE_JOIN
            WHERE $SQL_CONTEXT_CONDITION
            $SQL_MAIN_CONDITION";

    $tasks = DB::executeAll($sql);

    return $tasks;
}


function get_tasks_for_work_progress_widget($members){
    $SQL_BASE_JOIN = "SELECT e.object_id as 'object_id', e.due_date as 'due_date', 
                             e.start_date as 'start_date', e.time_estimate as 'time_estimate',
                             o.name as 'name',  e.completed_by_id as 'completed_by_id'
                             FROM ".TABLE_PREFIX."project_tasks e INNER JOIN ".TABLE_PREFIX."objects o ON e.object_id = o.id ";

    $extra_info = get_widget_context_condition($members);
    $SQL_BASE_JOIN .= $extra_info['SQL_BASE_JOIN'];
    $SQL_CONTEXT_CONDITION = $extra_info['SQL_CONTEXT_CONDITION']; 

    $SQL_MAIN_CONDITION = ($SQL_CONTEXT_CONDITION == '' ? '' : " AND ");
    $SQL_MAIN_CONDITION .= " `o`.`trashed_on` = 0 AND `o`.`archived_on` = 0  AND `e`.`is_template` = 0";

    $SQL_EXTRA_CONDITIONS = get_extra_conditions_for_work_progress_widget($members, 'task');

    $sql = "$SQL_BASE_JOIN
            WHERE $SQL_CONTEXT_CONDITION
            $SQL_MAIN_CONDITION
            $SQL_EXTRA_CONDITIONS";

    $tasks = DB::executeAll($sql);

    return $tasks;
}


function get_timeslots_for_work_progress_widget($members, $extra_conditions) {
    $SQL_BASE_JOIN = "SELECT e.rel_object_id as 'rel_object_id', e.end_time as 'end_time', 
                             e.start_time as 'start_time', e.subtract as 'subtract'
                             FROM ".TABLE_PREFIX."timeslots e INNER JOIN ".TABLE_PREFIX."objects o ON e.object_id = o.id ";

    $extra_info = get_widget_context_condition($members);
    $SQL_BASE_JOIN .= $extra_info['SQL_BASE_JOIN'];
    $SQL_CONTEXT_CONDITION = $extra_info['SQL_CONTEXT_CONDITION']; 

    $SQL_MAIN_CONDITION = ($SQL_CONTEXT_CONDITION == '' ? '' : " AND ");
    $SQL_MAIN_CONDITION .= " `o`.`trashed_on` = 0 AND `o`.`archived_on` = 0 ";

    $SQL_EXTRA_CONDITIONS = $extra_conditions;
    $SQL_EXTRA_CONDITIONS .= get_extra_conditions_for_work_progress_widget($members, 'time');

    $sql = "$SQL_BASE_JOIN
            WHERE $SQL_CONTEXT_CONDITION
            $SQL_MAIN_CONDITION
            $SQL_EXTRA_CONDITIONS";

    $timeslots = DB::executeAll($sql);

    return $timeslots;
}


function get_widget_context_condition($members){
    $SQL_CONTEXT_CONDITION = '';  
    $SQL_BASE_JOIN = '';
    $i = 0;
    foreach ($members as $mem_id) {
        $t_alias = 'om';
        if ($i > 0) $t_alias .= $i;
        $SQL_BASE_JOIN .= "
            LEFT JOIN ".TABLE_PREFIX."object_members $t_alias ON ${t_alias}.object_id=o.id AND ${t_alias}.member_id=$mem_id ";
        $i++;
        
        $SQL_CONTEXT_CONDITION .= ($SQL_CONTEXT_CONDITION == '' ? '' : " AND ");
        $SQL_CONTEXT_CONDITION .= "${t_alias}.member_id = $mem_id ";
    }

    return array('SQL_BASE_JOIN' => $SQL_BASE_JOIN, 'SQL_CONTEXT_CONDITION' => $SQL_CONTEXT_CONDITION);
}


function get_extra_conditions_for_work_progress_widget($members, $type){
    $SQL_EXTRA_CONDITIONS = "";
    if (count($members) == 0) {
        $beginning_of_year = DateTimeValueLib::now();
        if( $beginning_of_year->getMonth() < 6){
            $previous_year = $beginning_of_year->getYear() - 1;
            $beginning_of_year->setYear($previous_year);
        } 
        $beginning_of_year->setDay(1);
        $beginning_of_year->setMonth(1);
        $beginning_of_year->setHour(0);
        $beginning_of_year->setMinute(0);
        $beginning_of_year->setSecond(0);
        if($type == 'task'){
            $SQL_EXTRA_CONDITIONS .= " AND (e.start_date >= '".$beginning_of_year->toMySQL()."' OR e.due_date >= '".$beginning_of_year->toMySQL()."')";
        } elseif($type == 'time'){
            $SQL_EXTRA_CONDITIONS .= " AND (e.start_time >= '".$beginning_of_year->toMySQL()."' OR e.end_time >= '".$beginning_of_year->toMySQL()."')";
        }
    }

    if (!SystemPermissions::userHasSystemPermission(logged_user(), 'can_see_assigned_to_other_tasks') && $type == 'task') {
        $SQL_EXTRA_CONDITIONS .= " AND e.assigned_to_contact_id = ".logged_user()->getId();
    }

    return $SQL_EXTRA_CONDITIONS;
}


function get_project_member_ids_for_projects_widget(){
	$project_ot = ObjectTypes::findByName('project');
	$project_dimension = Dimensions::findByCode('customer_project');
	$associated_member_ids = get_associated_member_ids_from_active_context();
	$assoc_mem_ids_condition = '';
	if(count($associated_member_ids) > 0){
		$sql_array_assoc_mem_ids = '(' . join(',', $associated_member_ids) . ')';
		$assoc_mem_ids_condition = ' AND mpm.property_member_id IN '.$sql_array_assoc_mem_ids;
	}

	$SQL = "SELECT DISTINCT(m.id)
		FROM ".TABLE_PREFIX."members m INNER JOIN ".TABLE_PREFIX."member_property_members mpm ON m.id=mpm.member_id
		WHERE object_type_id=" . $project_ot->getId() . $assoc_mem_ids_condition . 
        " ORDER BY m.name ASC;";

	$p_rows = DB::executeAll($SQL);
	$project_member_ids = array_map(function ($row){
							return $row['id'];
						}, $p_rows);

	return $project_member_ids;
}

function get_associated_member_ids_from_active_context(){
	// get current selected members and its children that area associated to this dimension
	$associated_member_ids = array();
	$context = active_context();
	if (is_array($context)) {
		foreach ($context as $sel) {
            if ($sel instanceof Member) {
				$associated_member_ids[] = $sel->getId();
				$mem_ob_type_id = $sel->getObjectTypeId();
				$mem_children = $sel->getAllChildrenIdsByType($mem_ob_type_id);
				if(!empty($mem_children)){
					foreach($mem_children as $m_child){
						$associated_member_ids[] = $m_child;
					}
				}
			}
		}
	}
    
	return array_unique($associated_member_ids);
}
