<?php 
	class Formulas extends BaseFormulas {
		
		
		function calculateStatus($object) {
			
			if (config_option('automatic_crpm_status_calculation') && ($object instanceof ProjectTask || $object instanceof Timeslot)) {
				$members = $object->getMembers();
				$this->calculateMemberStatus($members);				
			}
		}
		
		function calculateMemberStatus($members) {
			
			if (config_option('automatic_crpm_status_calculation')) {
				$project_ot = ObjectTypes::findByName('project')->getId();
				$client_ot = ObjectTypes::findByName('customer')->getId();
				
				$status_dimension = Dimensions::findByCode("project_statuses");
				$use_project_status_dimension = $status_dimension instanceof Dimension && in_array($status_dimension->getId(), config_option('enabled_dimensions'));
				
				$status_ot = ObjectTypes::findByName("project_status");
				
				foreach ($members as $m) {
					if ($m->getObjectTypeId() == $project_ot) {						
						$formula = Formulas::findOne(array('conditions' => "object_type_id = $project_ot AND is_default = 1"));
						if ($formula instanceof Formula) {
							$project = Projects::findById($m->getObjectId());
							if($project->getAutomaticStatus()){
								$new_status = $formula->calculateStatus($m);
								if (!is_null($new_status)) {
									
									if ($use_project_status_dimension) {
										
										$project_member = Members::findOneByObjectId($project->getId(), Dimensions::findByCode('customer_project')->getId());
										$old_project_status = get_associated_status_member_id($project_member, $status_dimension, $status_ot, false, 'project_'.$status_ot->getName());
										
										associate_member_to_status_member($project_member, $old_project_status, $new_status, $status_dimension, $status_ot, true, 'project_'.$status_ot->getName());
										
									} else {
										$project->setStatus($new_status);
									}
									
									$project->save();
								}
							}
						}
					} else if ($m->getObjectTypeId() == $client_ot) {
		
						$formula = Formulas::findOne(array('conditions' => "object_type_id = $client_ot AND is_default = 1"));
						if ($formula instanceof Formula) {
							$client = Customers::findById($m->getObjectId());
							if($client->getAutomaticStatus()){
								$new_status = $formula->calculateStatus($m);
								if (!is_null($new_status)) {
									$client->setStatusId($new_status);
									$client->save();
								}
							}
						}
					}
				}
		
			}
		}
	}