<?php 
	class NonWorkingDays extends BaseNonWorkingDays {
		
		private $non_working_days = null;
		
		private function getNonWorkingDays() {
			if ($this->non_working_days == null) {
				// use this order to make that the all-years dates have more priority than sigle year dates.
				$temp = $this->findAll(array('order' => 'year, month, day'));
				
				// dont put repeated month-day dates, to prevent counting them twice (e.g. if there is defined 03/03 for all years and also 03/03/2016) 
				$distinct = array();
				foreach ($temp as $nwday) {
					$k = $nwday->getMonth()."-".$nwday->getDay();
					if (!isset($distinct[$k])) {
						$distinct[$k] = $nwday;
					}
				}
				
				$this->non_working_days = $distinct;
				
				if ($this->non_working_days == null) {
					$this->non_working_days = array();
				}
			}
			return $this->non_working_days;
		}
		
		
		function isNonWorkingDay($date, $check_working_days_of_week=true) {
			
			if (!$date instanceof DateTimeValue) return false;
			
			// check non-working days defined in settings panel
			$non_working_days = $this->getNonWorkingDays();
			foreach ($non_working_days as $nw_day) {
				if ($nw_day->getYear() > 0) {
					if ($date->getDay() == $nw_day->getDay() && $date->getMonth() == $nw_day->getMonth() && $date->getYear() == $nw_day->getYear()) {
						return true;
					}
				} else {
					if ($date->getDay() == $nw_day->getDay() && $date->getMonth() == $nw_day->getMonth()) {
						return true;
					}
				}
			}
			
			// check working days of week
			if ($check_working_days_of_week) {
				$working_days_of_week = explode(',', config_option('working_days'));
				$dow = $date->format('w');
				if (!in_array($dow, $working_days_of_week)) {
					return true;
				}
			}
			
			return false;
		}
	}
 