<?php 
	Env::useHelper('functions', 'crpm');
	require_javascript('CustomerForm.js', 'crpm');
	require_javascript("og/modules/addContactForm.js");
	
	$genid  = gen_id(); 
	$formId = "$genid-customer-form" ;
	$action = ( $customer->isNew() ) ? get_url('customer', 'add') : $customer->getEditUrl();
	$contact_type = ObjectTypes::findByName("contact")->getId();
	$company_type = ObjectTypes::findByName("company")->getId();
	
	Env::useHelper('functions', 'crpm');
	$crpm_dim = get_customers_dimension();
	$dimensionId = $crpm_dim->getId();
	
	$member_color = 0;
	if(!$customer->isNew() && $member instanceof Member) {
		$ot = ObjectTypes::findById($customer->getObjectTypeId());
  		$member_color = $member->getColor();
		$ot_name = lang($ot->getName());
		if ($member->getArchivedById() == 0) {
			add_page_action(lang('archive'), "javascript:if(confirm('".lang('confirm archive member',$ot_name)."')) og.openLink('".get_url('member', 'archive', array('id' => $member->getId()))."');", 'ico-archive-obj');
		} else {
			add_page_action(lang('unarchive'), "javascript:if(confirm('".lang('confirm unarchive member',$ot_name)."')) og.openLink('".get_url('member', 'unarchive', array('id' => $member->getId()))."');", 'ico-unarchive-obj');
		}
		$delete_url = get_url('member', 'delete', array('id' => $member->getId(),'start' => true));
		add_page_action(lang('delete'), "javascript:og.deleteMember('".$delete_url."','".$ot_name."');", 'ico-delete');
  	}
  	
  	if ($customer->isNew() && $parent_member > 0) {
		$p = Members::getMemberById($parent_member);
		if ($p instanceof Member) $member_color = $p->getColor();
	}
	$person_ot = ObjectTypes::findByName('person');
	$company_ot = ObjectTypes::findByName('company');
	
	if (!Plugins::instance()->isActivePlugin('advanced_core')) {
		if ($customer->isNew()){
			$has_custom_properties_contact = count(CustomProperties::getCustomPropertyIdsByObjectType($contact->getObjectTypeId())) > 0;
		}else{
			$contact = $customer->getContact();
			if ($contact instanceof Contact) {
				$has_custom_properties_contact = count(CustomProperties::getCustomPropertyIdsByObjectType($contact->getObjectTypeId())) > 0;
			}else{
				$has_custom_properties_contact = false;
			}		
		}
	} else {
		$has_custom_properties_contact = false;
	}
	
	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.submitCustomer(); og.submit_modal_form('".$formId."'); return false;";
	} else {
		$on_submit = "return og.submitCustomer();";
	}

	$main_properties = array();
    Hook::fire('render_member_properties', array('member' => $member, 'visible_by_default' => true, 'genid' => $genid), $main_properties);
    $has_custom_properties = count($main_properties) > 0;

    $more_properties = array();
    Hook::fire('render_member_properties', array('member' => $member, 'visible_by_default' => false, 'genid' => $genid), $more_properties);
    $has_more_custom_properties = count($more_properties) > 0 && $more_properties[0]['html'] != '';
    
	$categories = array();
	Hook::fire('member_edit_categories', array('member' => $member, 'genid' => $genid), $categories);
	
	
	$create_contact_info_options = config_option('create_contact_info_for_client');
	
?>
<div class = "form-container customer">
	<form onsubmit="<?php echo $on_submit ?>" method="post" enctype="multipart/form-data" id="<?php echo $formId ?>" action="<?php echo $action?>">
	
	<div class="coInputHeader">
	
	<?php if ($member instanceof Member && !$customer->isNew()) {
			$delete_url = get_url('member', 'delete', array('id' => $member->getId(),'start' => true));
			
			if ($member->getArchivedById() == 0) {
				$arch_action = "if(confirm('".lang('confirm archive member',$ot_name)."')) og.openLink('".get_url('member', 'archive', array('id' => $member->getId()))."', {callback:function(){\$('#_close_link').click();}});";
				$arch_icon = "ico-archive-obj";
			} else {
				$arch_action = "if(confirm('".lang('confirm unarchive member',$ot_name)."')) og.openLink('".get_url('member', 'unarchive', array('id' => $member->getId()))."', {callback:function(){\$('#_close_link').click();}});";
				$arch_icon = "ico-unarchive-obj";
			}
	?>
		<div class="headerToolbar">
			<div class="headerToolbarItem">
				<a onclick="<?php echo $arch_action ?>" 
					href="#" class="link-ico <?php echo $arch_icon ?>"><?php 
						echo lang("archive");
				?></a>
			</div>
			<div class="headerToolbarItem">
				<a onclick="og.deleteMember('<?php echo $delete_url ?>','<?php echo $ot_name ?>');" 
					href="#" class="link-ico ico-delete"><?php 
						echo lang("delete");
				?></a>
			</div>
		</div>
		<div class="clear"></div>
	<?php } ?>
	
	  <div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo $customer->isNew() ? lang('new') : lang('edit'); echo ' '. $member->getTypeNameToShow(); ?></div>
	  </div>
	
	  <div>
		<div class="coInputName">
			<input type="text" class="title" name="customer[name]" required id="<?php echo $genid."-name"?>" value="<?php echo  clean(array_var($customer_data, "name"))  ?>" placeholder="<?php echo lang('type name here')?>" />
		</div>
			
		<div class="coInputButtons">
			<?php echo submit_button($customer->isNew() ? lang('add') .' '.$member->getTypeNameToShow()  : lang('save changes'),'s',array('style'=>'margin-top:0px;margin-left:10px')) ?>
		</div>
		<div class="clear"></div>
	  </div>
	</div>
	
    <div class="form-body coInputMainBlock" id="<?php echo $genid ?>add_invoice_select_customer_div" style="display:none">
        <fieldset>
            <legend><?php echo lang('customer data') ?></legend>
            <table>
                <tr>
                    <td>
                        <div>
                            <?php echo label_tag(lang('customer name')) ?>
                            <?php echo text_field('customer[customer_name]', array_var($customer_data, 'customer_name'), array('style' => 'width:238px;')) ?>
                        </div>
                    </td>
                    <td style="padding-left:20px">
                        <div>
                            <?php echo label_tag(lang('customer address'))?>
                            <?php echo text_field('customer[customer_address]', array_var($customer_data, 'customer_address'), array('style' => 'width:238px;')) ?>
                        </div>
                    </td>
                </tr>
                <tr>
                    <td>
                        <div>
                            <?php echo label_tag(lang('customer number')) ?>
                            <?php echo text_field('customer[customer_number]', array_var($customer_data, 'customer_number'), array('style' => 'width:238px;')) ?>
                        </div>
                    </td>
                    <td style="padding-left:20px">
                        <div>
                            <?php echo label_tag(lang('customer rut'))?>
                            <?php echo text_field('customer[customer_rut]', array_var($customer_data, 'customer_rut'), array('style' => 'width:238px;')) ?>
                        </div>
                    </td>
                </tr>
            </table>
        </fieldset>
    </div>
            
		<div class="form-body coInputMainBlock">
			<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
			<ul id="<?php echo $genid?>tab_titles">
			
				<li><a href="#<?php echo $genid?>member_data"><?php echo lang('details') ?></a></li>
				
				<?php //if($customer->isNew()){?>
				
				<li style="display: none;" class="contact-data-container"><a id="<?php echo $genid?>contact_data_tab"  href="#<?php echo $genid?>contact_data"><?php echo lang('contact details') ?></a></li>
				<li style="display: none;" class="contact-data-container"><a id="<?php echo $genid?>contact_additional_data_tab"  href="#<?php echo $genid?>contact_additional_data"><?php echo lang('additional data') ?></a></li>
				
				<li style="display: none;" class="contact-data-container"><a id="<?php echo $genid?>company_data_tab"  href="#<?php echo $genid?>company_data"><?php echo lang('contact details') ?></a></li>
				<?php //}?>

				
				<?php if ($has_more_custom_properties || $has_custom_properties_contact) { ?>
				<li><a href="#<?php echo $genid?>add_custom_properties_div"><?php echo lang('more properties') ?></a></li>
				<?php } ?>			
				
				<?php foreach ($categories as $category) { ?>
				<li style="<?php echo array_var($category, 'style')?>" class="<?php echo array_var($category, 'class')?>">
					<a href="#<?php echo $category['id'] ?>" id="<?php echo array_var($category, 'link_id')?>"><?php echo $category['name'] ?></a>
				</li>
				<?php } ?>

                <?php if ($crpm_dim->getDefinesPermissions() && can_manage_security(logged_user())) { ?>
                    <li><a href="#<?php echo $genid?>member_permissions_div" id="<?php echo $genid?>permissions_tab"><?php echo lang('permissions') ?></a></li>
                <?php } ?>
			</ul>
			
				<div class="field child of left form-tab" id="<?php echo $genid?>member_data">
				
				<?php 
					if (count($create_contact_info_options) > 1) {
						
						$client_ot_id = $customer->isNew() ? user_config_option("new_client_contact_type") : $customer->getContactObjectTypeId();
				?>
					<div class="field" style="margin-left:15px;">
						<label for="<?php echo $genid."-contact-type"?>"><?php echo lang("this client is",$member->getTypeNameToShow()) ?>:</label>
						<table><tr><td>
							<?php echo simple_select_box("customer[contact_data_type]", $contact_types, $client_ot_id, array(/*'onchange' => "og.renderContactDataFields('$genid', this.value)",*/ 'id' => $genid."customer_ot_combo")) ?>						
						</td><td>
							<div style="display:none; margin-left:10px;" id="<?php echo $genid?>existing_contact_combo_container"></div>
						</td></tr></table>
					</div>
					
					<div class="x-clear"></div>
				
				<?php } else {
						$contact_type_name = array_var($create_contact_info_options, 0);
						if ($contact_type_name && $contact_type_name != 'unknown') {
							$contact_type = ObjectTypes::findByName($contact_type_name);
							$contact_type_id = $contact_type instanceof ObjectType ? $contact_type->getId() : 0;
						} else {
							$contact_type_id = 0;
						}
					?>
				
					<input type="hidden" name="customer[contact_data_type]" value="<?php echo $contact_type_id?>" id="<?php echo $genid ?>customer_ot_combo"">
				
					<div style="display:none; margin-left:10px;" id="<?php echo $genid?>existing_contact_combo_container"></div>
				<?php } ?>
				
					<?php
				
					$render_parent_selector = true;
					if (Plugins::instance()->isActivePlugin('member_custom_properties')) {
						if (Plugins::instance()->isActivePlugin('advanced_core')) $render_parent_selector = false;
					}
					if ($render_parent_selector && $member instanceof Member && $member->canHaveParents()) {
						$folder_id = ObjectTypes::instance()->findByName("folder")->getId();
					?><div class="field" style="margin-left:15px;margin-bottom:25px;"><?php
						render_single_member_selector($crpm_dim, $genid, array($parent_member), array('is_multiple' => false, 'label' => lang('located under'),
							"allowedMemberTypes" => array($folder_id), 'dont_filter_this_selector' => true,
							'select_function' => 'og.onParentMemberSelect', 'listeners' => array('on_remove_relation' => "og.onParentMemberRemove('".$genid."');")), false);
					?></div><?php
					}
					?>
					<input type="hidden" id="<?php echo $genid?>memberParent" value="<?php echo $parent_member;?>" name='customer[parent]' />
					
					<div class="x-clear"></div>
					
					<?php 
						$render = true;
						Hook::fire('member_form_render_associated_dimension_selectors', array('member' => $member, 'is_new' => $customer->isNew()), $render);
						if ($render) {
							render_associated_dimensions_selectors(array('member' => $member, 'is_new' => $customer->isNew()));
						}
					?>
					
					<?php 
					$null = null; Hook::fire('before_render_main_custom_properties', array('object' => $customer), $null);
					?>
					<div class="main-custom-properties-div">
					<?php 
					if ($has_custom_properties) {
                        foreach ($main_properties as $main_property){
                            echo $main_property['html'];
                        }
					}
					?>
					</div>
					
					<div class="x-clear" ></div>
				
					<?php if (!Plugins::instance()->isActivePlugin('member_custom_properties')) { ?>
					<div id="<?php echo $genid?>member_color_input" class="dataBlock"></div>
					<div class="x-clear"></div>
					
					<div class="field">
						<label for="<?php echo $genid."-status"?>"><?php echo lang("status")?>:</label>
						<?php echo simple_select_box("customer[status_id]", $status, array_var($customer_data, "status_id", config_option('default_customer_status_value')),array('onchange' => "og.defaultCustomerStatusChange('$genid')")) ?>
					</div>	
					
					<div class="field">
						<label for="customerAutomaticStatus"><?php echo lang("calculate the status automatically")?>:</label>
						<?php echo yes_no_widget('customer[automatic_status]', $genid.'customerAutomaticStatus', array_var($customer_data, "automatic_status"), lang('yes'), lang('no')) ?>		
					</div>	
					<?php } ?>
					
					<div class="x-clear"></div>
					
				</div>
				
				
				<?php if ($crpm_dim->getDefinesPermissions() && can_manage_security(logged_user())):?>
				<div class="field child of left form-tab" id="<?php echo $genid?>member_permissions_div">
				
					<label><?php  echo lang("users and groups with permissions here")?></label>
					<div class="clear"></div>
					<div><?php
						tpl_assign('genid', $genid);
						tpl_assign('parent_sel', $parent_member);
						$this->includeTemplate(get_template_path('member_permissions_control', 'member'));
					?></div>
	
				</div>
				<?php endif ;?>
				
				<div class="x-clear"></div>
				<?php if ($has_more_custom_properties || $has_custom_properties_contact) { ?>
				<div id="<?php echo $genid ?>add_custom_properties_div" class="form-tab"><?php
					if ($member instanceof Member) {
                        foreach ($more_properties as $more_property){
                            echo $more_property['html'];
                        }
					}
					?>
					
					<?php if($has_custom_properties_contact){?>
					<div id="<?php echo $genid ?>add_contact_custom_properties_div" class="contact-data-container">
					<?php echo render_object_custom_properties($contact, false, null, 'all', $customer->getId()) ?>
					</div>
					<?php }?>	
				</div>
				<div class="x-clear"></div>
				<?php } ?>
				
				<?php 
				/*
				if ($customer->isNew()) {
					$c_data = array();
					if (isset($customer_data['email'])) {
						$c_data['email'] = $customer_data['email'];
					}
					//Basic contact data tab
					render_contact_data_tab($genid, new Contact(), false, $c_data,null,null,false);
					
					//Company data tab
					render_company_data_tab($genid, new Contact(), false, $c_data);
				} else {
					$client_contact = $customer->getContact();
					if ($client_contact instanceof Contact) {
						$cdata = $client_contact->getArrayInfo();
						
						render_contact_data_tab($genid, $client_contact, false, $cdata, null, null, false);
						render_company_data_tab($genid, $client_contact, false, $cdata);
					}
				}
				*/
				?>
				
				<div class="contact_additional_data form-tab" id="<?php echo $genid?>contact_additional_data">
				<?php
			/*		if (!isset($assoc_contact_data)) $assoc_contact_data = array();
					tpl_assign('genid', $genid);
					tpl_assign('new_contact', $customer->isNew());
					tpl_assign('contact_data', $assoc_contact_data);
					tpl_assign('id_prefix', '_cdata');
					
					$this->includeTemplate(get_template_path("tabs/more_contact_data", "contact"));*/
				?>
				</div>
			
				<?php 
					foreach ($categories as $category) {
						echo $category['content'];
					} 
				?>
				
			<?php $additional_hidden_fields = array();
				Hook::fire('additional_member_hidden_fields', $member, $additional_hidden_fields);
				foreach ($additional_hidden_fields as $name => $value) { ?>
					<input name="customer[<?php echo $name?>]" id="<?php echo $genid.$name?>" value="<?php echo $value?>" type="hidden"/> 
			<?php } ?>
			
			</div>
			<?php 
			if (!array_var($_REQUEST, 'modal')) {
				echo submit_button($customer->isNew() ? lang('add') .' '.$member->getTypeNameToShow() : lang('save changes')); 
			}
			?>
		</div>
	</form>	
</div>

<script>
	og.member_is_new = <?php echo ($customer->isNew() ? "1" : "0")?>;

	og.prev_parent = null;
	var person_ot = '<?php echo $person_ot->getId() ?>';
	var company_ot = '<?php echo $company_ot->getId() ?>';

	og.submitCustomer = function () {
		
		<?php if ($crpm_dim->getDefinesPermissions() && can_manage_security(logged_user())):?>
			if (og.userPermissions) og.userPermissions.ogPermPrepareSendData('<?php echo $genid ?>', <?php echo $customer->isNew() ? 'true' : 'false';?>);
		<?php endif;?>
		
		return true;
	}

	og.defaultCustomerStatusChange = function(genid){
		$("#"+genid+"customerAutomaticStatusNo").attr('checked', true);		
	}

	var genid = '<?php echo $genid ?>';
	
	$(function(){

		<?php if (!Plugins::instance()->isActivePlugin('member_custom_properties')) { ?>
		document.getElementById(genid + 'member_color_input').innerHTML = og.getColorInputHtml('<?php echo $genid?>', 'customer', <?php echo "$member_color"?>, 'color', '<?php echo lang('color')?>');
		<?php } ?>
		
		$("fieldset.collapsible").collapse();
		H5F.setup(document.getElementById("<?php echo $formId ?>"));
		og.customers.customerForm.bindEvents() ;
		var name_input = Ext.get('<?php echo $genid."-name"?>');
		if (name_input) name_input.focus();

		$("#<?php echo $genid?>tabs").tabs().css('margin-bottom',0);
	<?php if (false) { ?>
		<?php if ($customer->isNew()) { ?>
			og.renderContactDataFields("<?php echo $genid?>",<?php echo user_config_option("new_client_contact_type")?>);
		<?php } else { ?>
			og.renderContactDataFields("<?php echo $genid?>", $("#<?php echo $genid?>customer_ot_combo").val());
		<?php } ?>
	<?php } ?>
		
		<?php 
		$exisiting_contact_id=0;
		$exisiting_contact_name='';
		if (!$customer->isNew()) {
			$exisiting_contact_id = $customer->getContactId();
			$exisiting_contact = Contacts::findById($customer->getContactId());
			if ($exisiting_contact instanceof Contact) {
				$exisiting_contact_name = escape_character($exisiting_contact->getObjectName(), "'", true);
			}
		}
		?>

		og.renderContactSelector({
			genid: '<?php echo $genid?>',
			id: 'existing_contact_id',
			name: 'customer[existing_contact_id]',
			render_to: "existing_contact_combo_container",
			listWidth: 300,
			selected: '<?php echo $exisiting_contact_id ?>',
			selected_name: '<?php echo $exisiting_contact_name ?>',
			empty_text: lang('select an existing contact or company'),
			filters: {
				'include_companies': 1,
				'is_user': 0
			}
		});

		$("#<?php echo $genid?>customer_ot_combo").change(function() {
			og.initCustomerFields();
		});
		og.initCustomerFields = function () {
			var company_ot = null;
			var contact_ot = null;
			for (x in og.objectTypes) {
				if (og.objectTypes[x].name == 'contact') contact_ot = x;
				else if (og.objectTypes[x].name == 'company') company_ot = x;
			}

			var contact_field_ids = ['input-address','input-picture_file','input-phone','input-webpage','input-company_id','input-department','input-birthday','input-email','input-comments'];
			
			if (parseInt($("#<?php echo $genid?>customer_ot_combo").val()) == 0) {
				for (x in contact_field_ids) {
					if (typeof(contact_field_ids[x]) == 'function') continue;
					$("#" + contact_field_ids[x]).hide();
				}
			} else {
				for (x in contact_field_ids) {
					if (typeof(contact_field_ids[x]) == 'function') continue;
					$("#" + contact_field_ids[x]).show();
				}
				
				if ($("#<?php echo $genid?>customer_ot_combo").val() == contact_ot) {
					$("#input-company_id").show();
					$("#input-department").show();
					$("#input-birthday").show();
				} else {
					$("#input-company_id").hide();
					$("#input-department").hide();
					$("#input-birthday").hide();
				}
			}
			
		}
		og.initCustomerFields();

		
	});

	
</script>
