<?php 
	$genid  = gen_id(); 
	$formId = "$genid-project-form" ;
	$action = ( $project->isNew() ) ? get_url('project', 'add') : $project->getEditUrl(); 
	$crpm_dim = Dimensions::findByCode('customer_project');
	$dimensionId = $crpm_dim->getId();
	$member_color = 0;
	if(!$project->isNew()) {
		$ot = ObjectTypes::findById($member->getObjectTypeId());
		$member_color = $member->getColor();
		$ot_name = lang($ot->getName());
		if ($member->getArchivedById() == 0) {
			add_page_action(lang('archive'), "javascript:if(confirm('".lang('confirm archive member',$ot_name)."')) og.openLink('".get_url('member', 'archive', array('id' => $member->getId()))."');", 'ico-archive-obj');
		} else {
			add_page_action(lang('unarchive'), "javascript:if(confirm('".lang('confirm unarchive member',$ot_name)."')) og.openLink('".get_url('member', 'unarchive', array('id' => $member->getId()))."');", 'ico-unarchive-obj');
		}
		$delete_url = get_url('member', 'delete', array('id' => $member->getId(),'start' => true));
		add_page_action(lang('delete'), "javascript:og.deleteMember('".$delete_url."','".$ot_name."');", 'ico-delete');
		
  	}
  	if ($project->isNew() && $parent_member > 0) {
		$p = Members::getMemberById($parent_member);
		if ($p instanceof Member) $member_color = $p->getColor();
	}
	$person_ot = ObjectTypes::findByName('person');

    $main_properties = array();
    Hook::fire('render_member_properties', array('member' => $member, 'visible_by_default' => true, 'genid' => $genid), $main_properties);
    $has_custom_properties = count($main_properties) > 0;

    $more_properties = array();
    Hook::fire('render_member_properties', array('member' => $member, 'visible_by_default' => false, 'genid' => $genid), $more_properties);
    
    $categories = array();
	Hook::fire('member_edit_categories', array('member' => $member, 'genid' => $genid), $categories);
	

	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.submitProject(); og.setDescription(); og.submit_modal_form('".$formId."'); return false;";
	} else {
		$on_submit = "return og.submitProject() && og.setDescription();";
	}
	
	$member_type_name = $member->getTypeNameToShow();
	Hook::fire('override_get_object_type_name', $project, $member_type_name);
	
	$new_button_text = null;
	Hook::fire('new_project_button_text', array('member' => $member, 'object' => $project), $new_button_text);
	if (!$new_button_text) $new_button_text = lang('new') .' '. $member_type_name;

?>

<div class = "form-container project">
	<form onsubmit="<?php echo $on_submit ?>" method="post" enctype="multipart/form-data" id="<?php echo $formId ?>" action="<?php echo $action?>">
		
		<div class="coInputHeader">
	
	<?php if ($member instanceof Member && !$project->isNew()) {
			$delete_url = get_url('member', 'delete', array('id' => $member->getId(),'start' => true));
			
			if ($member->getArchivedById() == 0) {
				$arch_action = "if(confirm('".lang('confirm archive member',$ot_name)."')) og.openLink('".get_url('member', 'archive', array('id' => $member->getId()))."', {callback:function(){\$('#_close_link').click();}});";
				$arch_icon = "ico-archive-obj";
			} else {
				$arch_action = "if(confirm('".lang('confirm unarchive member',$ot_name)."')) og.openLink('".get_url('member', 'unarchive', array('id' => $member->getId()))."', {callback:function(){\$('#_close_link').click();}});";
				$arch_icon = "ico-unarchive-obj";
			}
	?>
		<div class="headerToolbar">
			<div class="headerToolbarItem">
				<a onclick="<?php echo $arch_action ?>" 
					href="#" class="link-ico <?php echo $arch_icon ?>"><?php 
						echo lang("archive");
				?></a>
			</div>
			<div class="headerToolbarItem">
				<a onclick="og.deleteMember('<?php echo $delete_url ?>','<?php echo $member_type_name ?>');" 
					href="#" class="link-ico ico-delete"><?php 
						echo lang("delete");
				?></a>
			</div>
		</div>
		<div class="clear"></div>
	<?php } ?>
		  <div class="coInputHeaderUpperRow">
			<div class="coInputTitle"><?php echo $project->isNew() ? lang('new') : lang('edit'); echo ' '. $member_type_name ?></div>
		  </div>
		
		  <div>
			<div class="coInputName">
				<?php
				$project_name = !$project->isNew() ? clean($project->getObjectName()) : array_var($project_data, 'name');
				Hook::fire("render_object_name_prefix", array('object' => $project), $project_name);
				?>
				<input type="text" class="title" name="project[name]" required id="<?php echo $genid."-name"?>" value="<?php echo $project_name ?>" placeholder="<?php echo lang('type name here')?>" />
			</div>
				
			<div class="coInputButtons">
				<?php echo submit_button($project->isNew() ? $new_button_text : lang('save changes'),'s',array('style'=>'margin-top:0px;margin-left:10px')) ?>
			</div>
			<div class="clear"></div>
		  </div>
		</div>

		<div class="form-body coInputMainBlock">
			<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
			<ul id="<?php echo $genid?>tab_titles">
			
				<li><a href="#<?php echo $genid?>member_data"><?php echo lang('details') ?></a></li>
				
				<?php if ($crpm_dim->getDefinesPermissions() && can_manage_security(logged_user())) { ?>
				<li><a href="#<?php echo $genid?>member_permissions_div" id="<?php echo $genid?>permissions_tab"><?php echo lang('permissions') ?></a></li>
				<?php } ?>
				
				<?php if ($has_custom_properties) { ?>
				<li><a href="#<?php echo $genid?>add_custom_properties_div"><?php echo lang('more properties') ?></a></li>
				<?php } ?>
				
				<?php foreach ($categories as $category) { ?>
				<li style="<?php echo array_var($category, 'style')?>" class="<?php echo array_var($category, 'class')?>">
					<a href="#<?php echo $category['id'] ?>" id="<?php echo array_var($category, 'link_id')?>"><?php echo $category['name'] ?></a>
				</li>
				<?php } ?>
				
			</ul>
			
				<div class="field child of left form-tab" id="<?php echo $genid?>member_data"><?php
				
				$render_parent_selector = true;
				if (Plugins::instance()->isActivePlugin('member_custom_properties')) {
					if (Plugins::instance()->isActivePlugin('advanced_core')) $render_parent_selector = false;
				}
				if ($render_parent_selector && $member instanceof Member && $member->canHaveParents()) { 
					echo label_tag(lang('located under'));
					$allowedMemberTypes = array(
						ObjectTypes::instance()->findByName("customer")->getId(), 
						ObjectTypes::instance()->findByName("folder")->getId(), 
						ObjectTypes::instance()->findByName("customer_folder")->getId()
					);
					render_single_member_selector($crpm_dim, $genid, array($parent_member), array('is_multiple' => false, 'hide_label' => true,
						"allowedMemberTypes" => $allowedMemberTypes, 'dont_filter_this_selector' => true,
						'select_function' => 'og.onParentMemberSelect', 'listeners' => array('on_remove_relation' => "og.onParentMemberRemove('".$genid."');")), false);
				}
					?>
					<input type="hidden" id="<?php echo $genid?>memberParent" value="<?php echo $parent_member;?>" name='project[parent]' />
					
					<div class="clear"></div>
					
					<?php 
						$render = true;
						Hook::fire('member_form_render_associated_dimension_selectors', array('member' => $member, 'is_new' => $project->isNew()), $render);
						if ($render) {
							render_associated_dimensions_selectors(array('member' => $member, 'is_new' => $project->isNew()));
						}
					?>

                    <?php
                    $null = null; Hook::fire('before_render_main_custom_properties', array('object' => $project), $null);
                    
                    if ($has_custom_properties) {
                        foreach ($main_properties as $main_property){
                            echo $main_property['html'];
                        }
                    }
                    ?>
					<div class="x-clear"></div>
					
					<?php if (!Plugins::instance()->isActivePlugin('member_custom_properties')) { ?>
					<div id="<?php echo $genid?>member_color_input" class="dataBlock"></div>
					<div class="clear"></div>
					<?php } ?>
					
					<?php 
						$enabled_dimensions = config_option('enabled_dimensions');
						$status_dimension = Dimensions::findByCode('project_statuses');
						if (!$status_dimension instanceof Dimension || !in_array($status_dimension->getId(), $enabled_dimensions)) {

							if (!Plugins::instance()->isActivePlugin('member_custom_properties')) {
					?>
	
					<div class="field status" class="dataBlock">
						<label for="<?php echo $genid."-status"?>"><?php echo lang("status")?>:</label>
						<?php echo simple_select_box("project[status]", $status, array_var($project_data, "status",config_option('default_project_status_value')),array('onchange' => "og.defaultProjectStatusChange('$genid')")) ?>
					</div>
						<?php } ?>
					<?php } ?>
					
					<?php if (!Plugins::instance()->isActivePlugin('member_custom_properties')) { ?>
					<div class="field">
						<label for="projectAutomaticStatus"><?php echo lang("calculate the status automatically")?>:</label>
						<?php echo yes_no_widget('project[automatic_status]', $genid.'projectAutomaticStatus', array_var($project_data, "automatic_status"), lang('yes'), lang('no')) ?>		
					</div>
					<?php } ?>
					
					<div class="clear"></div>

					<?php if (Plugins::instance()->isActivePlugin('quickbooks') && logged_user()->getEmailAddress() == 'support@evxsoftware.com') { ?>
						<div class="dataBlock">
							<label>Quickbooks Id:</label>
							<?php echo text_field("project[quickbooks_online_id]", $member->getColumnValue("quickbooks_online_id")) ?>
						</div>
					<?php } ?>
					
					<div class="clear"></div>
					
					
					
					<?php
					if (!Plugins::instance()->isActivePlugin('member_custom_properties')) {

						if(config_option("wysiwyg_projects")){
							if(array_var($project_data, 'type_content') == "text"){
								$ckEditorContent = nl2br(htmlspecialchars(array_var($project_data, 'description')));
							}else{
								$ckEditorContent = purify_html(nl2br(array_var($project_data, 'description')));
							}
							$loc = user_config_option('localization');
							if (strlen($loc) > 2) $loc = substr($loc, 0, 2);
						?>
					<label for="<?php echo $genid."-description"?>"><?php echo lang("description")?>:</label>
					<div id="<?php echo $genid ?>ckcontainer" style="height: 100%; margin-left:200px;">
						<textarea cols="80" id="<?php echo $genid ?>ckeditor" name="project[description]" rows="10"><?php echo clean($ckEditorContent) ?></textarea>
					</div>
					<script>
					    var h = document.getElementById("<?php echo $genid ?>ckcontainer").offsetHeight;
					    var editor = CKEDITOR.replace('<?php echo $genid ?>ckeditor', {
							height: (h-60) + 'px',
							allowedContent: true,
							enterMode: CKEDITOR.ENTER_BR,
							shiftEnterMode: CKEDITOR.ENTER_BR,
							disableNativeSpellChecker: false,
							language: '<?php echo $loc ?>',
							customConfig: '',
							contentsCss: ['<?php echo get_javascript_url('ckeditor/contents.css').'?rev='.product_version_revision();?>', '<?php echo get_stylesheet_url('og/ckeditor_override.css').'?rev='.product_version_revision();?>'],
							toolbar: [
								['FontSize','-','Bold','Italic','Underline','-', 'SpellChecker', 'Scayt','-',
								//'NumberedList','BulletedList','-',
								'TextColor','BGColor','-',
								'JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock']
							],
							on: {
								instanceReady: function(ev) {
									og.adjustCkEditorArea('<?php echo $genid ?>');
									editor.resetDirty();
								}
							},
					        fillEmptyBlocks: false,
							removePlugins: 'scayt,liststyle,magicline',
							entities_additional : '#39,#336,#337,#368,#369'
					    });
	
					    og.setDescription = function() {
						    var form = Ext.getDom('<?php echo $formId ?>');
						    if (form.preventDoubleSubmit) return false;
	
						    setTimeout(function() {
							    form.preventDoubleSubmit = false;
						    }, 2000);
	
						    var editor = og.getCkEditorInstance('<?php echo $genid ?>ckeditor');
						    form['project[description]'].value = editor.getData();
	
						    return true;
					    };
					</script>
						<?php } else { ?>
					<div class="field description dataBlock">
							<?php
								if(array_var($project_data, 'type_content') == "text"){
									$content_text = array_var($project_data, 'description');
								}else{
									$content_text = html_to_text(html_entity_decode(nl2br(array_var($project_data, 'description')), null, "UTF-8"));
								}
							?>
						<label for="<?php echo $genid."-description"?>"><?php echo lang("description")?>:</label>
						<?php echo textarea_field("project[description]", $content_text, array('class' => 'long', 'id' => $genid."-description"))?>
					</div>
					<script>
						og.setDescription = function() {
							return true;
						};
					</script>
					<?php }?>
				<?php } ?>
					<div class="x-clear" ></div>
				
				
				</div>
				
				<?php if ($crpm_dim->getDefinesPermissions() && can_manage_security(logged_user())):?>
				<div class="field child of left form-tab" id="<?php echo $genid?>member_permissions_div">
					<label><?php  echo lang("users and groups with permissions here")?></label>
					<div class="clear"></div>
					<div><?php
						tpl_assign('genid', $genid); 
						tpl_assign('parent_sel', $parent_member);
						$this->includeTemplate(get_template_path('member_permissions_control', 'member'));
					?></div>
				</div>
				<?php endif ;?>
			
				
				<?php if ($has_custom_properties) { ?>
				<div id="<?php echo $genid ?>add_custom_properties_div" class="form-tab"><?php
                    if ($member instanceof Member) {
                        foreach ($more_properties as $more_property){
                            echo $more_property['html'];
                        }
                    }
                    ?>
				</div>
				<div class="x-clear" ></div>
				<?php } ?>
				
				
				<?php 
					foreach ($categories as $category) {
						echo $category['content'];
					} 
				?>
				
				<?php $additional_hidden_fields = array();
					Hook::fire('additional_member_hidden_fields', $member, $additional_hidden_fields);
					foreach ($additional_hidden_fields as $name => $value) { ?>
						<input name="project[<?php echo $name?>]" id="<?php echo $genid.$name?>" value="<?php echo $value?>" type="hidden"/> 
				<?php } ?>
				
				
			</div>
			<?php 
			if (array_var($_REQUEST, 'modal')) {
				echo submit_button($project->isNew() ? $new_button_text : lang('save changes')); 
			}
			?>
		</div>
	</form>	
</div>

<div class="quick-project-form overlay"></div>


<script>
	og.member_is_new = <?php echo ($project->isNew() ? "1" : "0")?>;
	var person_ot = '<?php echo $person_ot->getId() ?>';

	var genid = '<?php echo $genid ?>';

	var form_submitted = false;
	
	og.submitProject = function () {
		if (form_submitted) {
			return false;
		}
		<?php if ($crpm_dim->getDefinesPermissions() && can_manage_security(logged_user())):?>
			if (og.userPermissions) og.userPermissions.ogPermPrepareSendData('<?php echo $genid ?>', <?php echo $project->isNew() ? 'true' : 'false';?>);
		<?php endif;?>

		form_submitted = true;
		setTimeout(function() {
			form_submitted = false;
		}, 5000);
		
		return true;
	}

	og.defaultProjectStatusChange = function(genid){
		$("#"+genid+"projectAutomaticStatusNo").attr('checked', true);		
	}

	$(function(){
		var color_input = document.getElementById(genid + 'member_color_input');
		if (color_input) {
			color_input.innerHTML = og.getColorInputHtml('<?php echo $genid?>', 'project', <?php echo "$member_color"?>, 'color', '<?php echo lang('color')?>');
		}
		
		$("fieldset.collapsible").collapse();
		//H5F.setup(document.getElementById("<?php //echo $formId ?>"));
		var name_input = Ext.get('<?php echo $genid."-name"?>');
		if (name_input) name_input.focus();

		$("#<?php echo $genid?>tabs").tabs();


<?php if (Plugins::instance()->isActivePlugin('member_custom_properties')) {
		$mem_desc_cp = MemberCustomProperties::findOne(array('conditions' => "code='description_special' AND is_special=1 AND is_disabled=0 AND object_type_id=".$member->getObjectTypeId()));
		if (config_option("wysiwyg_projects") && $mem_desc_cp instanceof MemberCustomProperty) {

			if(array_var($project_data, 'type_content') == "text"){
				$ckEditorContent = nl2br(htmlspecialchars(array_var($project_data, 'description')));
			}else{
				$ckEditorContent = purify_html(nl2br(array_var($project_data, 'description')));
			}
			$loc = user_config_option('localization');
			if (strlen($loc) > 2) $loc = substr($loc, 0, 2);
		?>
			
			var editor_id = $("[name='member_custom_properties[<?php echo $mem_desc_cp->getId()?>]']").attr('id');


        var editor = CKEDITOR.replace(editor_id, {
            height: (200) + 'px',
            allowedContent: true,
            enterMode: CKEDITOR.ENTER_BR,
            shiftEnterMode: CKEDITOR.ENTER_BR,
            disableNativeSpellChecker: false,
            language: '<?php echo $loc ?>',
            customConfig: '',
            contentsCss: ['<?php echo get_javascript_url('ckeditor/contents.css').'?rev='.product_version_revision();?>', '<?php echo get_stylesheet_url('og/ckeditor_override.css').'?rev='.product_version_revision();?>'],
            toolbar: [
                ['Source','-','PasteText','PasteFromWord','-','Print', 'SpellChecker', 'Scayt','-',
                    'Undo','Redo','-','Find','Replace','-','SelectAll',
                    'Format','Font','FontSize'],
                '/',
                ['Bold','Italic','Underline','Strike','-','Subscript','Superscript','-',
                    'NumberedList','BulletedList','-','Outdent','Indent','Blockquote','-',
                    'JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock','-',
                    'Link','Unlink', 'Anchor', '-','Maximize','-',
                    'Image','Table','HorizontalRule','Smiley','SpecialChar','PageBreak','-',
                    'TextColor','BGColor','RemoveFormat']
            ],

            keystrokes: [
                [ CKEDITOR.ALT + 121 /*F10*/, 'toolbarFocus' ],
                [ CKEDITOR.ALT + 122 /*F11*/, 'elementsPathFocus' ],

                [ CKEDITOR.SHIFT + 121 /*F10*/, 'contextMenu' ],

                [ CKEDITOR.CTRL + 90 /*Z*/, 'undo' ],
                [ CKEDITOR.CTRL + 89 /*Y*/, 'redo' ],
                [ CKEDITOR.CTRL + CKEDITOR.SHIFT + 90 /*Z*/, 'redo' ],

                [ CKEDITOR.CTRL + 76 /*L*/, 'link' ],

                [ CKEDITOR.CTRL + 66 /*B*/, 'bold' ],
                [ CKEDITOR.CTRL + 73 /*I*/, 'italic' ],
                [ CKEDITOR.CTRL + 85 /*U*/, 'underline' ],

                //[ CKEDITOR.CTRL + 83 /*S*/, 'save' ],

                [ CKEDITOR.ALT + 109 /*-*/, 'toolbarCollapse' ]
            ],
            filebrowserImageUploadUrl : '<?php echo ROOT_URL ?>/ck_upload_handler.php',
            on: {
                instanceReady: function(ev) {
                    $("#cke_"+ev.editor.name)[0].style.marginLeft = '200px';
                    editor.resetDirty();
                },
                change: function(ev) {
                    /*var p = og.getParentContentPanel(Ext.get('<?php echo $genid ?>ckeditor'));
                    Ext.getCmp(p.id).setPreventClose(editor.checkDirty());*/
                }
            },
            fillEmptyBlocks: false,
            removePlugins: 'scayt,liststyle,magicline',
            entities_additional : '#336,#337,#368,#369'
        });

        og.setDescription = function() {
			    var form = Ext.getDom('<?php echo $formId ?>');
			    if (form.preventDoubleSubmit) return false;

			    setTimeout(function() {
				    form.preventDoubleSubmit = false;
			    }, 2000);

			    var editor = og.getCkEditorInstance(editor_id);
			    if (editor) form['member_custom_properties[<?php echo $mem_desc_cp->getId()?>]'].value = editor.getData();

			    return true;
		    };
		    
<?php 	} else { ?>
			og.setDescription = function() {
				return true;
			};
<?php 	}
?>
<?php } ?>
		
	});
</script>
