<?php /* @var $project Project  */
	$genid = gen_id();
?>

<div class="statistics-widget widget">

	<div style="overflow: hidden;" class="widget-header" onclick="og.dashExpand('<?php echo $genid?>');">
		<?php echo lang('project statistics') ; ?>
		<div class="dash-expander ico-dash-expanded" id="<?php echo $genid; ?>expander"></div>
	</div>
	
	<div class="widget-body" id="<?php echo $genid; ?>_widget_body">
	
	<?php if ($project->getStatus()): ?>	
        <div class="customer-status-face">
                <div class="customer-status-text">
                    <?php echo lang('project_field_status' . $project->getStatus()); ?>
                </div>
                <div class="customer-status-lastupdate">
	                <?php echo lang("last updated")?>: <?php echo format_date($project->getUpdatedOn()); ?> <br/>
	                <?php echo lang("by")?> <a href="#"><?php echo clean($project->getUpdatedByDisplayName()); ?></a>
                </div>
         </div>
         <div class="status-meter-graph project-status-<?php echo strtolower($project->getStatus())?>"></div>
         <div class="x-clear"> </div> 
    <?php endif ;?>        

	<?php if (isset($project_milestones_stats) && array_var($project_milestones_stats, 'total') > 0) :?>
		<h2><?php echo lang('milestones')?></h2>
			
		<div style="float:left">
			<table class="statistics">
			
			<?php if (array_var($project_milestones_stats, 'late') > 0) : ?>
				<tr><td><div class="ref late">&nbsp;</div></td><td><?php echo lang('overdue m')?></td><td class="right"><?php echo array_var($project_milestones_stats, 'late')?></td></tr>	
			<?php endif; ?>
			
			<?php if (array_var($project_milestones_stats, 'upcoming') > 0) : ?>
				<tr><td><div class="ref upcoming">&nbsp;</div></td><td><?php echo lang('upcoming')?></td><td class="right"><?php echo array_var($project_milestones_stats, 'upcoming')?></td></tr>	
			<?php endif; ?>
			
			<?php if (array_var($project_milestones_stats, 'today') > 0) : ?>
				<tr><td><div class="ref today">&nbsp;</div></td><td><?php echo lang('today')?></td><td class="right"><?php echo array_var($project_milestones_stats, 'today')?></td></tr>	
			<?php endif; ?>
			
			<?php if (array_var($project_milestones_stats, 'complete') > 0) : ?>
				<tr><td><div class="ref complete">&nbsp;</div></td><td><?php echo lang('completed m')?></td><td class="right"><?php echo array_var($project_milestones_stats, 'complete')?></td></tr>	
			<?php endif; ?>
			
			</table>
			
			</div>
			<div style="float:right; margin-right:-10px;">
		
		<?php 
			
			$chart_data = array();
			if (array_var($project_milestones_stats, 'late') > 0) {
				$chart_data[] = array( 'color'=>"#CC0000", 'value' => $project_milestones_stats['late'], 'text' => "" );
			}
			if (array_var($project_milestones_stats, 'upcoming') > 0) {
				$chart_data[] = array( 'color'=>"#CCCCCC", 'value' => array_var($project_milestones_stats, 'upcoming'), 'text' => "" );
			}
			if (array_var($project_milestones_stats, 'today') > 0) {
				$chart_data[] = array( 'color'=>"#CCCC00", 'value' => array_var($project_milestones_stats, 'today'), 'text' => "" );
			}
			if (array_var($project_milestones_stats, 'complete') > 0) {
				$chart_data[] = array( 'color'=>"#00AA00", 'value' => $project_milestones_stats['complete'], 'text' => "" );
			}
			
			render_pie_chart(array(
				'data' => $chart_data,
				'width' => '225px',
				'height' => '150px',
				'alpha' => 0.55,
				'tip' => '#val#/#total#<br>#percent#',
				'start_angle' => 40,
			));
			
		?>
		</div>
	<?php endif; ?>
		
		<div class="x-clear"></div>
		
	<?php if (isset($project_tasks_stats) && array_var($project_tasks_stats, 'total') > 0) :?>
		<h2><?php echo lang('tasks')?></h2>
		
		<div style="float:left">
			<table class="statistics">
			<?php if (array_var($project_tasks_stats, 'late') > 0) : ?>
				<tr><td><div class="ref late">&nbsp;</div></td><td><?php echo lang('overdue f')?></td><td class="right"><?php echo array_var($project_tasks_stats, 'late')?></td></tr>	
			<?php endif; ?>
			
			<?php if (array_var($project_tasks_stats, 'upcoming') > 0) : ?>
				<tr><td><div class="ref upcoming">&nbsp;</div></td><td><?php echo lang('upcoming')?></td><td class="right"><?php echo array_var($project_tasks_stats, 'upcoming') ?></td></tr>	
			<?php endif; ?>
			
			<?php if (array_var($project_tasks_stats, 'today') > 0) : ?>
				<tr><td><div class="ref today">&nbsp;</div></td><td><?php echo lang('today')?></td><td class="right"><?php echo array_var($project_tasks_stats, 'today')?></td></tr>	
			<?php endif; ?>
			
			<?php if (array_var($project_tasks_stats, 'complete') > 0) : ?>
				<tr><td><div class="ref complete">&nbsp;</div></td><td><?php echo lang('completed f')?></td><td class="right"><?php echo array_var($project_tasks_stats, 'complete')?></td></tr>	
			<?php endif; ?>
			
			</table>
		
		</div>
		<div style="float:right; margin-right: -10px; ">
		
		<?php 

			$chart_data = array();
			if (array_var($project_tasks_stats, 'late') > 0) {
				$chart_data[] = array( 'color'=>"#CC0000", 'value' => $project_tasks_stats['late'], 'text' => "" );
			}
			if (array_var($project_tasks_stats, 'upcoming') > 0) {
				$chart_data[] = array( 'color'=>"#6ba8e3", 'value' => $project_tasks_stats['upcoming'], 'text' => "" );
			}
			if (array_var($project_tasks_stats, 'today') > 0) {
				$chart_data[] = array( 'color'=>"#CCCC00", 'value' => $project_tasks_stats['today'], 'text' => "" );
			}
			if (array_var($project_tasks_stats, 'complete') > 0) {
				$chart_data[] = array( 'color'=>"#00AA00", 'value' => $project_tasks_stats['complete'], 'text' => "" );
			}
			
			render_pie_chart(array(
				'data' => $chart_data,
				'width' => '225px',
				'height' => '150px',
				'alpha' => 0.55,
				'tip' => '#val#/#total#<br>#percent#',
				'start_angle' => 40,
			));
		?>
		</div>
		
	<?php endif; ?>
		<div class="x-clear"></div>
	</div>
	<div class="x-clear"></div>
	
</div>
