<?php 
	$genid = gen_id();
	$formId = "$genid-edit-status-formula";
	$action = get_url('status_formulas', 'edit');
	$object_type = ObjectTypes::instance()->findById($formula->getObjectTypeId());
?>

<style>
div.factors-status {
	background-color: white;
	border: 1px solid #CCC;
	border-radius: 5px;
	margin: 10px;
	padding: 10px;
	box-shadow: 0 0 3px 0 #CCC inset;
}
div.factors-status h2 {
	margin-bottom: 10px;
	font-size: 125%;
}
div.factors-status-def .factor-name {
	font-weight: bold;
}

div.factors-status-def .factor-container {
	margin: 10px 0;
}

select.select-required-value {
	min-width: 50px;
}
</style>

<div class = "form-container status-formula">
	<form method="post" enctype="multipart/form-data" id="<?php echo $formId ?>" action="<?php echo $action?>">
		<div class="coInputHeader">
			<div class="coInputHeaderUpperRow">
				<div class="coInputTitle">
					<table style="width:535px">
						<tr>
							<td>
								<?php echo lang(($formula->getIsDefault() ? 'default ' : '') . 'status formula for ' . $object_type->getName()) ?>
							</td>
							<td style="text-align:right">
								<?php //echo submit_button(lang('save changes'),'s', array('style'=>'margin-top:0px;margin-left:10px', 'class' => 'blue', 'tabindex' => '5')) ?>
							</td>
						</tr>
					</table>
				</div>
			</div>
		</div>
            
		<div class="form-body coInputMainBlock">
			
			<input type="hidden" name="formula[id]" value="<?php echo $formula->getId()?>" />
			<input type="hidden" name="formula[is_default]" value="<?php echo $formula->getIsDefault()?>" />
			<input type="hidden" name="formula[object_type_id]" value="<?php echo $formula->getObjectTypeId()?>" />
			<input type="hidden" name="formula[name]" value="<?php echo $formula->getName()?>" />
			
			<div id="<?php echo $genid?>-formula-factors-container">
			</div>

			<div id="<?php echo $genid?>-add-factor-container" class="add-factor-container">
				<span class="add-factor-text"><?php echo lang('add formula factor for status')?></span>
				<?php echo simple_select_box("add-factor-select-status", $status, 0, array('id' => $genid.'-select-status')) ?>
				<button id="<?php echo $genid?>-add-factor-button" type="button"><?php echo lang('add')?></button>
			</div>
							
		</div>
		<?php echo submit_button(lang('save changes'),'s', array('style'=>'margin-top:30px;margin-left:10px', 'class' => 'blue', 'tabindex' => '1000')) ?>
	</form>	
</div>

<script>
var genid = '<?php echo $genid; ?>';

formulas = {};
formulas.new_group_id = 0;

formulas.add_container_for_status = function(status_id, status_name, group_factor_id) {
	var container_id = genid+'-factors-status-'+status_id;
	
	if($("#"+container_id).length == 0){
		var html = '<div class="factors-status" id="'+container_id+'">';
		html += '<div style="float:right;"><a href="#" onclick="formulas.remove_factor_for_status('+status_id+',\''+status_name+'\')" class="ico-delete" style="padding:3px 0 3px 18px;">'+ lang('delete conditions for status', status_name) +'</a></div>' +
		'<h2>'+lang('conditions to accomplish status')+' "'+ status_name +'"</h2>';
		html += '<div id="'+container_id+'-groups"></div>';
		html += '<button id="'+genid+'-add-factor-group-button" type="button" onclick="formulas.add_factor_for_status('+status_id+',\''+status_name+'\')" >Add</button>';
		html += '</div>';	
		
		$("#"+genid+'-formula-factors-container').append(html);		
	}	
}

formulas.add_factor_for_status = function(status_id, status_name, group_factor_id) {
	if(typeof group_factor_id == 'undefined'){
		formulas.new_group_id++;
		group_factor_id = "new_"+formulas.new_group_id;
	}
	
	var factor_names = ['completeness', 'dueness', 'estimation'];
	var comparisson_types = ['more_than', 'more_than_equal_to', 'equal_to', 'less_than_equal_to', 'less_than'];

	formulas.add_container_for_status(status_id, status_name, group_factor_id);

	var groups_container_id = genid+'-factors-status-'+status_id+'-groups';
	
	var html = '<div id="'+genid+'-factors-group-'+group_factor_id+'" class="factors-status-def">';

	html += '<div class="factors-group-header">';
	if($("#"+groups_container_id).children().length > 0){		
		html += '<h2>'+lang('or')+'</h2>';		
	}else{
			
	}
	html += '<div style="float:right;"><a href="#" onclick="formulas.remove_factor_group('+status_id+',\''+status_name+'\',\''+group_factor_id+'\')" class="ico-delete" style="padding:3px 0 3px 18px;">'+ lang('delete') +'</a></div>';
	html += '</div>';
	
	for (i=0; i<factor_names.length; i++) {
		var fname = factor_names[i];
		var pre = 'factor['+status_id+']['+group_factor_id+']['+fname+']';
		html += '<div class="factor-container" id="'+genid+'factor-container-'+status_id+'-'+fname+'">';

		html += '<div class="factor-name">' + lang(fname+' factor') + '&nbsp;&nbsp;&nbsp;<input type="checkbox" checked=checked name="'+pre+'[enabled]" id="'+genid+pre+'-enabled" onchange="formulas.enableChanged(this, true);" class="factor-enable-checkbox"/>' +
			'<span style="font-weight:normal;"> '+lang('enabled')+'</span></div>';
		
		html += '<div class="factor-condition">' + lang(fname+ ' factor condition desc') + '&nbsp;&nbsp;';
		html += '<select name="'+pre+'[comparisson_type]" id="'+genid+pre+'-comparisson_type">';
		for (j=0; j<comparisson_types.length; j++) {
			html += '<option value="'+comparisson_types[j]+'">'+lang(comparisson_types[j])+'</option>';
		}
		html += '</select>';
		html += '<select name="'+pre+'[required_value]" id="'+genid+pre+'-required_value" class="select-required-value">';
		for (p=0; p<=100; p+=5) {
			html += '<option value="'+p+'">'+p+'</option>';
		}
		html += '</select>&nbsp;' + lang('percent of the total');
		
		html += '</div></div>';
	}
	html += '</div>';
	
	
	
	$("#"+groups_container_id).append(html);
}

formulas.remove_factor_group = function(status_id, status_name, group_factor_id) {
	$('#' + genid + '-factors-group-' + group_factor_id).remove();

	var groups_container_id = genid+'-factors-status-'+status_id+'-groups';
	
	if($("#"+groups_container_id).children().length == 0){
		formulas.remove_factor_for_status(status_id, status_name);
	}		
}

formulas.remove_factor_for_status = function(status_id, status_name) {
	$('#' + genid + '-factors-status-' + status_id).remove();
	$('#'+genid+'-select-status').append(new Option(status_name, status_id, true, true));
}

formulas.enableChanged = function(checkbox, animate) {
	var element = $(checkbox).parent().next('.factor-condition');
	if (checkbox.checked) {
		if (animate) element.slideDown();
		else element.show();
	} else {
		if (animate) element.slideUp();
		else element.hide();
	}
}

$(function() {

	$('#'+genid+'-add-factor-button').click(function() {
		var val = $('#'+genid+'-select-status option:selected').val();
		if (val > 0) {
			// draw conditions for selected status
			formulas.add_factor_for_status(val, $('#'+genid+'-select-status option:selected').text());
			// remove selected status from selectbox
			$('#'+genid+'-select-status option[value="'+val+'"]').remove();
		}
	});

<?php 
foreach ($actual_statuses as $st_key => $factors_groups) : 
	foreach ($factors_groups as $factors_group) :
	?>
		formulas.add_factor_for_status('<?php echo $st_key; ?>', '<?php echo $factors_group['text']; ?>', '<?php echo $factors_group['groupid']; ?>');
		$('#'+genid+'-select-status option[value="<?php echo $st_key; ?>"]').remove();
	<?php 
		foreach ($factors_group['factors'] as $factor) : 
			$ct = $factor->getComparissonType();
			$ct_idx = ($ct == 'more_than' ? 0 : ($ct == 'more_than_equal_to' ? 1 : ($ct == 'equal_to' ? 2 : ($ct == 'less_than_equal_to' ? 3 : 4))));
			$comon_id = 'factor['.$st_key.']['.$factors_group['groupid'].']['.$factor->getName().']';			
		?>
				document.getElementById(genid+'<?php echo $comon_id;?>-enabled').checked = '<?php echo $factor->getEnabled() ? 'checked' : '';?>';
			
				document.getElementById(genid+'<?php echo $comon_id;?>-comparisson_type').selectedIndex = <?php echo $ct_idx;?>;
			
				document.getElementById(genid+'<?php echo $comon_id;?>-required_value').selectedIndex = <?php echo $factor->getRequiredValue()/5;?>;
			<?php			
		endforeach;
	endforeach;
endforeach;
?>

	$('.factor-enable-checkbox').each(function() {
		formulas.enableChanged(this, false);
	});

});

</script>