<?php 	
	$genid = gen_id();
	$currentDimension = current_dimension_id();
	$crpmDimension = Dimensions::instance()->findByCode('customer_project')->getId();
	$ws_dim = Dimensions::instance()->findByCode('workspaces');
	$workspacesDimension = $ws_dim instanceof Dimension ? $ws_dim->getId() : 0;
	$currentMember = current_member();
	$customerType = ObjectTypes::findByName('customer')->getId();
	$projectType = ObjectTypes::findByName('project')->getId();
	$workspaceType = ObjectTypes::findByName('workspace')->getId();
	$currentType = ($currentMember instanceof Member) ? $currentMember->getObjectTypeId() : 0;
	Env::useHelper('chart');
	
	// Show only in customer dash
	if ($currentMember instanceof Member && in_array($currentDimension, array($crpmDimension, $workspacesDimension)) && in_array($currentType, array($customerType, $workspaceType))) {
		$objectId = $currentMember->getObjectId();
		$object = Objects::findObject($objectId);
		
		$task_assignment_conditions = "";
		if (!SystemPermissions::userHasSystemPermission(logged_user(), 'can_see_assigned_to_other_tasks')) {
			$task_assignment_conditions = " AND assigned_to_contact_id = ".logged_user()->getId();
		}
		
		$tasks = ProjectTasks::instance()->listing(array(
			"raw_data" => true,
			"order" => "due_date",
			"order_dir" => "ASC",
			"fire_additional_data_hook" => false,
			"extra_conditions" => " AND is_template = 0 $task_assignment_conditions"
		))->objects;
		
		$completed_task_summary = array(
			"overdue" 	=> 0,
			"pending" 	=> 0,
			"today" 	=> 0,
			"completed" => 0,
		);
		
		$now = DateTimeValueLib::now();
		if (is_array($tasks)) {
			foreach ($tasks as $task){
				$dd = $task['due_date'] != EMPTY_DATETIME ? DateTimeValueLib::makeFromString($task['due_date']) : null;
				if ($task['completed_by_id'] > 0) {
					$completed_task_summary['completed']++;	
				} elseif ($task['completed_by_id'] == 0 && $dd !== null && $dd->getTimestamp() < $now->getTimestamp()) {
					$completed_task_summary['overdue']++;
				} else {
					if ($dd instanceof DateTimeValue && $dd->isToday()) $completed_task_summary['today']++;
					else $completed_task_summary['pending']++;	
				}
			}
		}
		
		$active_members = array();
		$context = active_context();
		foreach ($context as $selection) {
			if ($selection instanceof Member) $active_members[] = $selection;
		}
		if (count($active_members) > 0) {
			$mnames = array();
			$allowed_contact_ids = array();
			foreach ($active_members as $member) {
				$allowed_contact_ids[] = $member->getAllowedContactIds();
				$mnames[] = clean($member->getName());
			}
			$widget_title = lang('tasks');
		}
		
		include 'template.php';
	}