<?php
Env::useHelper('functions', 'crpm');
	
$dimension = Dimensions::findByCode('customer_project');
$project_ot = ObjectTypes::instance()->findByName('project');
$client_ot = ObjectTypes::instance()->findByName('customer');

$folder_ot = ObjectTypes::instance()->findByName('folder');
$cfolder_ot = ObjectTypes::instance()->findByName('customer_folder');

$draw = true;

$cdot = DimensionObjectTypes::findOne(array('conditions' => 'dimension_id='.get_customers_dimension()->getId().' AND object_type_id='.$client_ot->getId()));
if (!$cdot instanceof DimensionObjectType || !$cdot->getEnabled()) {
	$draw = false;
}

$parent = null;
$context = active_context();
if (is_array($context)) {
	foreach ($context as $selection) {
		if ($selection instanceof Member) {
			if ($selection->getDimensionId() != $dimension->getId()) {
				$draw = false;
				break;
			} else {
				if (!in_array($selection->getObjectTypeId(), array($folder_ot->getId(), $cfolder_ot->getId()))) {
					$draw = false;
				}
				$parent = $selection;
				break;
			}
		}
	}
}

if ($draw) {
	
	$limit = 5;
	$start = 0;
	$order = 'name';
	$total = 0;
	
	$customer_ot_id = ObjectTypes::findByName('customer')->getId();
	$pg_array = logged_user()->getPermissionGroupIds();
	
	$customer_ids = array();
	$current_member_cond = $parent instanceof Member ? "AND parent_member_id=".$parent->getId() : "";
	
	$members = Members::findAll(array(
		'limit' => $limit,
		'order' => "depth, name",
		'conditions' => "object_type_id=$customer_ot_id $current_member_cond AND archived_by_id=0 AND EXISTS (
			SELECT cmp.member_id FROM ".TABLE_PREFIX."contact_member_permissions cmp WHERE cmp.member_id=".TABLE_PREFIX."members.id AND cmp.permission_group_id IN (".implode(',',$pg_array)."))"
	));
	
	if ($parent instanceof Member && count($members) < $limit) {
		$tmp_ids = array();
		foreach ($members as $m) {
			$tmp_ids[] = $m->getId();
		}
		
		$extra_conds = "AND archived_by_id=0 AND EXISTS (
			SELECT cmp.member_id FROM ".TABLE_PREFIX."contact_member_permissions cmp WHERE cmp.member_id=".TABLE_PREFIX."members.id AND cmp.permission_group_id IN (".implode(',',$pg_array)."))";

		$childs = $parent->getAllChildren(true, 'name', $extra_conds);
		foreach ($childs as $ch) {
			if (in_array($ch->getId(), $tmp_ids)) continue;
			if ($ch->getObjectTypeId() == $customer_ot_id && count($members) <= $limit) {
				$members[] = $ch;
			}
			if (count($members) >= $limit) break;
		}
	}
	
	foreach ( $members as $member ){
		$customer_ids[] = $member->getObjectId();
	}
	
	if (count($customer_ids) > 0){
		$customers = Customers::findAll(array( 
			'conditions' => " trashed_on = '0000-00-00 00:00:00' AND  archived_on = '0000-00-00 00:00:00' AND `object_id` IN (".implode(",",$customer_ids).")",
			'limit' => $limit,
			//'order' => $order,
		));
	}else{
		$customers = array();
	}
	$total = count($customers);
	
	$genid = gen_id() ;
	$render_add = can_manage_dimension_members(logged_user());
	
	if ($total > 0 || $render_add) {
		include_once 'template.php';
	}

}