<?php
	$crpmDimension = Dimensions::instance()->findByCode('customer_project')->getId();
	$folderOtid = ObjectTypes::findByName('folder')->getId();
	$parent = null;
	$draw = true;
	
	$fdot = DimensionObjectTypes::findOne(array('conditions' => 'dimension_id='.$crpmDimension.' AND object_type_id='.$folderOtid));
	if (!$fdot instanceof DimensionObjectType || !$fdot->getEnabled()) {
		$draw = false;
	}
	
	$context = active_context();
	if (is_array($context)) {
		foreach ($context as $selection) {
			if ($selection instanceof Member) {
				if ($selection->getDimensionId() != $crpmDimension) {
					$draw = false;
					break;
				} else {
					$parent = $selection;
					break;
				}
			}
		}
	}
	
	if ($draw) {
		
		$projectOtid = ObjectTypes::findByName('project')->getId();
		$customerOtid = ObjectTypes::findByName('customer')->getId();
		$customerFolderOtid = ObjectTypes::findByName('customer_folder')->getId();
		$projectFolderOtid = ObjectTypes::findByName('project_folder')->getId();
		$type = null;
		
		if (!$parent) {
			$type = $folderOtid;
		}elseif($parent->getObjectTypeId() == $projectOtid ){
			$type = $projectFolderOtid;
		}elseif($parent->getObjectTypeId() == $customerOtid ){
			$type = $customerFolderOtid;
		}elseif($parent->getObjectTypeId() == $folderOtid ){
			$type = $folderOtid;
		}elseif($parent->getObjectTypeId() == $customerFolderOtid ){
			$type = $customerFolderOtid;	
		}elseif($parent->getObjectTypeId() == $projectFolderOtid ){
			$type = $projectFolderOtid;
		}
	
		$limit = 5;
		$start = 0;
		$dim_controller= new DimensionController();
		
		$pg_array = logged_user()->getPermissionGroupIds();
		$current_member_cond = $parent instanceof Member ? "AND parent_member_id=".$parent->getId() : "";
		
		$members = Members::findAll(array(
			'limit' => $limit,
			'order' => "depth, name",
			'conditions' => "object_type_id IN ($projectFolderOtid, $folderOtid, $customerFolderOtid) $current_member_cond AND archived_by_id=0 AND EXISTS (
				SELECT cmp.member_id FROM ".TABLE_PREFIX."contact_member_permissions cmp WHERE cmp.member_id=".TABLE_PREFIX."members.id AND cmp.permission_group_id IN (".implode(',',$pg_array)."))"
		));
		
		if ($parent instanceof Member && count($members) < $limit) {
			$tmp_ids = array();
			foreach ($members as $m) {
				$tmp_ids[] = $m->getId();
			}
			
			$extra_conds = "AND archived_by_id=0 AND EXISTS (
				SELECT cmp.member_id FROM ".TABLE_PREFIX."contact_member_permissions cmp WHERE cmp.member_id=".TABLE_PREFIX."members.id AND cmp.permission_group_id IN (".implode(',',$pg_array)."))";
		
			$childs = $parent->getAllChildren(true, 'name', $extra_conds);
		
			foreach ($childs as $ch) {
				if (in_array($ch->getId(), $tmp_ids)) continue;
				if (in_array($ch->getObjectTypeId(), array($projectFolderOtid, $folderOtid, $customerFolderOtid)) && count($members) <= $limit) {
					$members[] = $ch;
				}
				if (count($members) >= $limit) break;
			}
		}
		$folders = $members;	
		$total = count($folders);
		$render_add = can_manage_dimension_members(logged_user());
		
		$active_members = array();
		$context = active_context();
		if (is_array($context)) {
			foreach ($context as $selection) {
				if ($selection instanceof Member) $active_members[] = $selection;
			}
		}
		if (count($active_members) > 0) {
			$mnames = array();
			$allowed_contact_ids = array();
			foreach ($active_members as $member) {
				$allowed_contact_ids[] = $member->getAllowedContactIds();
				$mnames[] = clean($member->getName());
			}
			$widget_title = lang('folders');
		}
		
		if ($total > 0 || $render_add) {
			include_once 'template.php';
		}
	}