<?php /* @var Member $folder */
	$widget_title = lang('folders');
	$genid = gen_id();
	$row_cls = "";
	$no_objects_text = count($folders) > 0 ? '' : lang('you have no folders yet');
	$dim_id = Dimensions::findByCode('customer_project')->getId();
	
	$fot = ObjectTypes::findByName('folder');
	$c_name = Members::getTypeNameToShowByObjectType($dim_id, $fot->getId());
	$add_button_text = count($folders) > 0 ? lang('add new folder', $c_name) : lang('add your first folder', $c_name);
	
?>

<div class="widget-folders widget">

	<div style="overflow: hidden;" class="widget-header" onclick="og.dashExpand('<?php echo $genid?>');">
		<div class="widget-title"><?php echo $c_name; ?></div>
		<div class="dash-expander ico-dash-expanded" id="<?php echo $genid; ?>expander"></div>
	</div>
	
	<div class="widget-body" id="<?php echo $genid; ?>_widget_body">
	
		<div class="folder-list">
		<?php foreach ($folders as $folder): /* @var $folder Member */ ?>
			<div class="folder-row-container <?php echo $row_cls?>" id="folder-<?php echo $folder->getId()?>">
				
				<a class="internalLink" href="#" onclick="og.crpm.onFolderClick(<?php echo $folder->getId() ?>);">
					<img src= "<?php echo ROOT_URL?>/public/assets/themes/default/images/icons-feng-3/16x16/open_folder.png" style="vertical-align:top;" />
					<?php  echo html_entity_decode(clean($folder->getName())) ?>
				</a><?php
					$p = $folder->getParentMember();
					if ($p instanceof Member) {
						$crumb_members = array(
							$p->getId() => array('name' => $p->getName(), 'ot' => $p->getObjectTypeId(), 'c' => $p->getColor()),
						);
						$crumbOptions = json_encode(array($dim_id => $crumb_members));
						if($crumbOptions == ""){
							$crumbOptions = "{}";
						}
						$crumbJs = " og.getEmptyCrumbHtml($crumbOptions, '.folder-row-container ' ) ";
					?>
				<span class="breadcrumb"></span>
				<script>
					var crumbHtml = <?php echo $crumbJs?>;
					$("#folder-<?php echo $folder->getId()?> .breadcrumb").html(crumbHtml);
				</script>
				<?php } ?>
			</div>
			<div class="x-clear"></div>
		<?php endforeach;?>
		</div>
		
		<?php if ($render_add) :?>
			<?php if (count($folders) > 0) : ?>
			<div class="separator"></div>
			<?php endif; ?>
			<?php if ($no_objects_text != '') : ?><div class="no-obj-widget-msg"><?php echo $no_objects_text ?></div><?php endif; ?>
			<input type="text" class="add-folder-field" style="float:left; height:27px; border-radius:5px; margin:10px 6px 0 0; width:145px;" placeholder="<?php echo $c_name.' '.lang('name')."..."?>"/>			
			<button title="<?php echo $add_button_text ?>" class="add-folder-button add-first-btn" style="margin-top: 10px;">
				<img src="public/assets/themes/default/images/16x16/add.png"/>&nbsp;<?php echo $add_button_text ?>
			</button>
		<?php endif;?>
	</div>
</div>

<script>
	$(function(){
		$(".add-folder-field").keypress(function(e){
			if(e.keyCode == 13){
				$(".add-folder-button").click();
     		}
		});

		$(".add-folder-button").click(function(){
			var container = $(this).closest(".widget-body");
			var value = $(container).find("input.add-folder-field").val();
			if (value == '') {
				og.err(lang('folder name required'));
				return;
			}
			var folderType = '<?php echo ($type == $projectFolderOtid ? 'project' : ($type == $customerFolderOtid ? 'customer' : 'folder')); ?>';
			og.crpm.addFolder(value, <?php echo ($parent instanceof Member) ? $parent->getId() : 0 ?>, function(){}, folderType); 
		});
	//	og.eventManager.fireEvent('replace all empty breadcrumb', null);
	});
</script>