-- <?php echo $table_prefix ?> 
-- <?php echo $default_charset ?> DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci
-- <?php echo $default_collation ?> collate utf8_unicode_ci
-- <?php echo $engine ?> InnoDB
-- varchar cannot be larger than 256
-- blob/text cannot have default values
-- sql queries must finish with ;\n (line break inmediately after ;)


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>customers` (
  `object_id` int(10) unsigned NOT NULL auto_increment,
  `contact_id` int(10) unsigned NOT NULL,
  `status_id` int(10) unsigned  ,
  `system_usage` FLOAT,
  `installation_id` VARCHAR(128),
  `users_limit` int(10) unsigned ,
  `diskspace_limit` int(10) unsigned ,
  `collaborators_limit` int(10) unsigned ,
  `active_users` int(10) unsigned,
  `cmrr` FLOAT,
  `payment_cycle_id` int(10) unsigned,
  `service_type_id` int(10) unsigned,
  `feedback_id` int(10) unsigned,
  `code` int(10) unsigned,
  `start_date` datetime,
  `end_date` datetime,
  `industry` VARCHAR(128),
  `internal_users` int(10) unsigned,
  `external_users` int(10) unsigned,
  `subscription_channel_id` int(10) unsigned,
  `payment_method_id` int(10) unsigned,
  `customer_name` VARCHAR( 100 ) NULL COMMENT 'customer number for invoices' ,
  `customer_address` VARCHAR( 100 ) NULL COMMENT 'customer address for invoices' ,
  `customer_rut` VARCHAR( 50 ) NULL COMMENT 'customer rut for invoices',
  `customer_number` VARCHAR( 50 ) NULL COMMENT 'customer number for invoices',
  `automatic_status` BOOLEAN NOT NULL DEFAULT '1',
  `contact_object_type_id` INTEGER UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>customer_status` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(45) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>customer_feedback` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(45) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>customer_payment_cycles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(45) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>customer_service_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(45) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>customer_contacts` (
  `contact_id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `customer_id` INTEGER UNSIGNED NOT NULL,
  PRIMARY KEY (`contact_id`, `customer_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>projects` (
  `object_id` int(10) unsigned NOT NULL auto_increment,
  `status` int(10) unsigned,
  `description` text <?php echo $default_collation ?>,
  `customer_id` int(10) unsigned,
  `comments` text <?php echo $default_collation ?>,
  `type_content` ENUM( 'text', 'html' ) NOT NULL DEFAULT 'text',
  `automatic_status` BOOLEAN NOT NULL DEFAULT '1',
  `manager_id` INTEGER UNSIGNED NOT NULL,
  `start_date` datetime NOT NULL,
  `end_date` datetime NOT NULL,
  PRIMARY KEY (`object_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>formulas` (
  `id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `object_type_id` INTEGER UNSIGNED NOT NULL,
  `is_default` BOOLEAN NOT NULL,
  `name` VARCHAR(256) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>formula_factors_groups` (
  `group_id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `formula_id` INTEGER UNSIGNED NOT NULL,
  `status_id` INTEGER UNSIGNED NOT NULL,			  			 
  PRIMARY KEY (`group_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>formula_factors_by_group` (
  `group_id` INTEGER UNSIGNED NOT NULL,	  
  `name` VARCHAR(255) NOT NULL,
  `enabled` BOOLEAN NOT NULL,
  `comparisson_type` VARCHAR(45) NOT NULL,
  `required_value` INTEGER UNSIGNED NOT NULL,
  PRIMARY KEY (`group_id`, `name`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>object_formulas` (
  `object_id` INTEGER UNSIGNED NOT NULL,
  `formula_id` INTEGER UNSIGNED NOT NULL,
  PRIMARY KEY (`object_id`, `formula_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>object_prefix_settings` (
  `object_type_id` INTEGER UNSIGNED NOT NULL,
  `enabled` BOOLEAN NOT NULL,
  `max_digits` INTEGER UNSIGNED NOT NULL,
  `current_value` INTEGER UNSIGNED NOT NULL,
  PRIMARY KEY (`object_type_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>object_prefixes` (
  `object_id` INTEGER UNSIGNED NOT NULL,
  `prefix` VARCHAR(50) NOT NULL,
  `object_type_id` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`),
  UNIQUE KEY `object_type_id_prefix` (`object_type_id`,`prefix`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>project_additional_data` (
  `project_id` INTEGER UNSIGNED NOT NULL,
  `calc_customer_id` INTEGER UNSIGNED NOT NULL,
  `total_tasks` INTEGER UNSIGNED NOT NULL,
  `completed_tasks` INTEGER UNSIGNED NOT NULL,
  `task_completion_p` FLOAT NOT NULL,
  `total_estimated_time` INTEGER UNSIGNED NOT NULL,
  `total_worked_time` INTEGER UNSIGNED NOT NULL,
  `time_worked_p` FLOAT NOT NULL,
  PRIMARY KEY (`project_id`),
  INDEX `task_completion`(`task_completion_p`),
  INDEX `worked_time`(`time_worked_p`),
  INDEX `customer` (`calc_customer_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>customer_additional_data` (
  `customer_id` int(10) unsigned NOT NULL,
  `total_tasks` int(10) unsigned NOT NULL,
  `completed_tasks` int(10) unsigned NOT NULL,
  `task_completion_p` float NOT NULL,
  `total_estimated_time` int(10) unsigned NOT NULL,
  `total_worked_time` int(10) unsigned NOT NULL,
  `time_worked_p` float NOT NULL,
  PRIMARY KEY (`customer_id`) USING BTREE,
  KEY `task_completion` (`task_completion_p`),
  KEY `worked_time` (`time_worked_p`),
  KEY `total_tasks` (`total_tasks`),
  KEY `completed_tasks` (`completed_tasks`),
  KEY `total_estimated_time` (`total_estimated_time`),
  KEY `total_worked_time` (`total_worked_time`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>non_working_days` (
  `id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `day` INTEGER UNSIGNED NOT NULL,
  `month` INTEGER UNSIGNED NOT NULL,
  `year` INTEGER UNSIGNED NOT NULL,
  `name` VARCHAR(255) NOT NULL,
  PRIMARY KEY (`id`),
  INDEX `yearmonthday`(`year`, `month`, `day`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

ALTER TABLE `<?php echo $table_prefix ?>templates`
 ADD COLUMN `nw_days_todo_action` VARCHAR(50) NOT NULL,
 ADD COLUMN `nw_days_todo_amount` INTEGER UNSIGNED NOT NULL,
 ADD COLUMN `use_only_working_days` BOOLEAN NOT NULL DEFAULT 0;

ALTER TABLE `<?php echo $table_prefix ?>contacts`
 ADD COLUMN `is_confidential` BOOLEAN NOT NULL DEFAULT 0;

ALTER TABLE `<?php echo $table_prefix ?>project_tasks`
ADD `repeat_generate_instances` tinyint(1) NOT NULL AFTER `repeat_by`;

ALTER TABLE `<?php echo $table_prefix ?>project_tasks`
ADD `repeat_fixed_days` varchar(50) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '' AFTER `repeat_generate_instances`;

ALTER TABLE `<?php echo $table_prefix ?>template_tasks`
ADD `repeat_generate_instances` tinyint(1) NOT NULL AFTER `repeat_by`;

ALTER TABLE `<?php echo $table_prefix ?>template_tasks`
ADD `repeat_fixed_days` varchar(50) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '' AFTER `repeat_generate_instances`;
