<?php 
	/**
	 * Feng2 Plugin update engine 
	 */
	function crpm_update_1_2() {
		// MEMBER MAIN VIEW
		DB::execute("
			UPDATE ".TABLE_PREFIX."dimension_object_types 
			SET options = '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}' 
			WHERE dimension_id IN (
				SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'
			)"		
		);

		// NEW WIDGETS 
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."widgets (name, title, plugin_id, default_section, default_order ) 
			VALUES 
				('statics', 'statics', (SELECT id from ".TABLE_PREFIX."plugins WHERE name = 'crpm'), 'right', -100 ),
				('completed_tasks', 'completed_tasks', (SELECT id from ".TABLE_PREFIX."plugins WHERE name = 'crpm'), 'right', -50 ),
				('crpm_people', 'crpm_people', (SELECT id from ".TABLE_PREFIX."plugins WHERE name = 'crpm'), 'right', -30 ),
				('summary', 'summary', (SELECT id from ".TABLE_PREFIX."plugins WHERE name = 'crpm'), 'left', -1000 )
			ON DUPLICATE KEY UPDATE name = name 
		");
		
		
	}

	/**
	 * Make old customer / projects searchable: Add them to sharing table 
	 */
	function crpm_update_2_3() {
		foreach  ( Projects::findAll() as $obj ){
			/* @var $obj Project */
			$obj->addToSearchableObjects(1);
			$obj->addToSharingTable();
		}
		foreach  ( Customers::findAll() as $obj ){
			$obj->addToSearchableObjects(1);
			$obj->addToSharingTable();
		}
	}

	/**
	 * wysiwyg in projects
	 * 
	 */
	function crpm_update_3_4() {
		// WYSIWYG PROJECTS
		if (!check_column_exists(TABLE_PREFIX."projects", "type_content")) {
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."projects` ADD `type_content` ENUM( 'text', 'html' ) NOT NULL DEFAULT 'text';"                        
			);
		}
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			('general', 'wysiwyg_projects', '0', 'BoolConfigHandler', '0', '0', NULL)
			ON DUPLICATE KEY UPDATE category_name=category_name;"
		);
	}
        
        /**
	 * Customer data for invoices
	 * 
	 */
	function crpm_update_4_5() {
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."widgets (name, title, plugin_id, default_section, default_order)
			VALUES ('estimated_worked_time', 'estimated_worked_time', (SELECT id from ".TABLE_PREFIX."plugins WHERE name = 'crpm'), 'left', 50)
			ON DUPLICATE KEY UPDATE name=name;"
		);
		// CUSTOMER DATA
		if (!check_column_exists(TABLE_PREFIX."customers", 'customer_name')) {
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."customers` ADD `customer_name` VARCHAR( 100 ) NULL COMMENT 'customer number for invoices' ,
                        ADD `customer_address` VARCHAR( 100 ) NULL COMMENT 'customer address for invoices' ,
                        ADD `customer_rut` VARCHAR( 50 ) NULL COMMENT 'customer rut for invoices',
                        ADD `customer_number` VARCHAR( 50 ) NULL COMMENT 'customer number for invoices';"
			);
		}

		// MULTI ASSIGNMENT
		if (!check_column_exists(TABLE_PREFIX."project_tasks", 'multi_assignment')) {
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."project_tasks` ADD `multi_assignment` TINYINT( 1 ) NULL DEFAULT '0';"
			);
		}
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) 
			VALUES ('general', 'multi_assignment', '1', 'BoolConfigHandler', '0', '0', NULL)
			ON DUPLICATE KEY UPDATE category_name=category_name;"
		);
	}
	
	
	function crpm_update_5_6() {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
			 SELECT
			 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_project'),
			 	`id`,
			 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='contact'),
			 	0, 0
			 FROM `".TABLE_PREFIX."object_types`
			 WHERE `name` IN ('customer', 'project', 'folder', 'customer_folder', 'project_folder')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;"
		);
		
		DB::execute("
			UPDATE `".TABLE_PREFIX."dimension_object_type_contents` SET is_multiple = 1
			WHERE dimension_id = (SELECT id FROM `".TABLE_PREFIX."dimensions` WHERE code = 'customer_project' )
			 AND content_object_type_id in (
			 	SELECT DISTINCT id FROM `".TABLE_PREFIX."object_types` WHERE name IN ('message', 'file', 'file_revision', 'mail','event','contact', 'weblink')
			 );"
		);
	}
	
	function crpm_update_6_7(){
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
				('mobile panel', 'mobile_logs_amount_to_search', '1000', 'IntegerConfigHandler', '0', '400', NULL),
				('mobile panel', 'mobile_maximum_display_dimension_members', '7', 'IntegerConfigHandler', '0', '0', NULL),
				('mobile panel', 'mobile_minimum_display_dimension_members', '2', 'IntegerConfigHandler', '0', '0', NULL)
			ON DUPLICATE KEY UPDATE name=name;"
	 	);
	 	DB::execute("
	 		INSERT INTO `".TABLE_PREFIX."contact_config_categories` (`name` ,`is_system` ,`type` ,`category_order`)VALUES 
				('mobile panel', '0', '0', '5')
			ON DUPLICATE KEY UPDATE name=name;"
		);
	}
	
	
	function crpm_update_7_8(){
		DB::execute("
			CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."formulas` (
			  `id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
			  `object_type_id` INTEGER UNSIGNED NOT NULL,
			  `is_default` BOOLEAN NOT NULL,
			  `name` VARCHAR(256) NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=InnoDB;
		");
		DB::execute("
			CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."formula_factors` (
			  `formula_id` INTEGER UNSIGNED NOT NULL,
			  `status_id` INTEGER UNSIGNED NOT NULL,
			  `name` VARCHAR(256) NOT NULL,
			  `enabled` BOOLEAN NOT NULL,
			  `comparisson_type` VARCHAR(45) NOT NULL,
			  `required_value` INTEGER UNSIGNED NOT NULL,
			  PRIMARY KEY (`formula_id`, `status_id`, `name`)
			) ENGINE=InnoDB;
		");
		DB::execute("
			CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."object_formulas` (
			  `object_id` INTEGER UNSIGNED NOT NULL,
			  `formula_id` INTEGER UNSIGNED NOT NULL,
			  PRIMARY KEY (`object_id`, `formula_id`)
			) ENGINE=InnoDB;
		");
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			 ('general', 'automatic_crpm_status_calculation', '1', 'BoolConfigHandler', 0, 0, '')
			ON DUPLICATE KEY UPDATE name=name;
		");
	}
	
	function crpm_update_8_9() {
		// create associations
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_member_associations` (`dimension_id`,`object_type_id`,`associated_dimension_id`, `associated_object_type_id`, `is_required`,`is_multiple`, `keeps_record`) VALUES
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'folder'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'feng_persons'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'person'),0,1,0),
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'folder'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'feng_persons'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'company'),0,1,0),
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer_folder'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'feng_persons'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'person'),0,1,0),
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer_folder'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'feng_persons'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'company'),0,1,0),
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'project_folder'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'feng_persons'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'person'),0,1,0),
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'project_folder'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'feng_persons'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'company'),0,1,0)
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");
		
		// instantiate actual associations
		$dim = Dimensions::findByCode('customer_project');
		$folder_ot_ids = ObjectTypes::findAll(array('id' => true, 'conditions' => "name IN ('folder','customer_folder','project_folder')"));
		$folder_members = Members::findAll(array('conditions' => 'dimension_id = '.$dim->getId().' AND object_type_id IN ('.implode(',', $folder_ot_ids).')'));
		foreach($folder_members as $mem) {
			// after saving permissions the associations are instantiated by 'core_dimensions' plugin 
			save_member_permissions($mem);
		}
	}
	
	function crpm_update_9_10() {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`) VALUES
			 ('listing preferences', concat('lp_dim_customer_project_show_as_column'), '0', 'BoolConfigHandler', 0, 0)
			ON DUPLICATE KEY UPDATE name=name;
		");
	}
	
	/**
	 * template task and template mileston objects
	 *
	 */
	function crpm_update_10_11() {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`) VALUES
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'folder'),(SELECT id from ".TABLE_PREFIX."object_types WHERE `name` = 'template_task'),0,1),	
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer_folder'),(SELECT id from ".TABLE_PREFIX."object_types WHERE `name` = 'template_task'),0,1),
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'project_folder'),(SELECT id from ".TABLE_PREFIX."object_types WHERE `name` = 'template_task'),0,1),
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer'),(SELECT id from ".TABLE_PREFIX."object_types WHERE `name` = 'template_task'),0,1),
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'project'),(SELECT id from ".TABLE_PREFIX."object_types WHERE `name` = 'template_task'),0,1),
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'folder'),(SELECT id from ".TABLE_PREFIX."object_types WHERE `name` = 'template_milestone'),0,1),	
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer_folder'),(SELECT id from ".TABLE_PREFIX."object_types WHERE `name` = 'template_milestone'),0,1),
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'project_folder'),(SELECT id from ".TABLE_PREFIX."object_types WHERE `name` = 'template_milestone'),0,1),
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer'),(SELECT id from ".TABLE_PREFIX."object_types WHERE `name` = 'template_milestone'),0,1),
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'project'),(SELECT id from ".TABLE_PREFIX."object_types WHERE `name` = 'template_milestone'),0,1)
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
			");
	
	}
	
	function crpm_update_11_12() {
		DB::execute("
			UPDATE `".TABLE_PREFIX."dimension_object_type_contents` SET is_multiple = 1
				WHERE dimension_id = (SELECT id FROM `".TABLE_PREFIX."dimensions` WHERE code = 'customer_project' )
				 AND content_object_type_id in (
			 	SELECT DISTINCT id FROM `".TABLE_PREFIX."object_types` WHERE name IN ('task','timeslot')
			 );			
		");
	}
	
	function crpm_update_12_13() {
		DB::execute("
				UPDATE `".TABLE_PREFIX."contact_config_options`
					SET default_value = concat((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_project'),',',(default_value))
					WHERE name='quick_add_task_view_dimensions_combos';
				");
		
		DB::execute("
				UPDATE `".TABLE_PREFIX."contact_config_options`
					SET default_value = concat((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_project'),',',(default_value))
					WHERE name='add_timeslot_view_dimensions_combos';
				");
	}
	
	function crpm_update_13_14() {
		DB::execute("UPDATE ".TABLE_PREFIX."widgets SET default_section='left' WHERE name='folders';");
		DB::execute("UPDATE ".TABLE_PREFIX."contact_widgets SET section='left' WHERE widget_name='folders';");
	}
	
	function crpm_update_14_15() {
		DB::execute("UPDATE ".TABLE_PREFIX."contact_config_options SET default_value='1' WHERE name='lp_dim_customer_project_show_as_column';");		
	}
	
	function crpm_update_15_16() {
		DB::execute("UPDATE ".TABLE_PREFIX."config_options SET value='1' WHERE name='automatic_crpm_status_calculation';");
	}
	
	function crpm_update_16_17() {
		if (!checkTableExists(TABLE_PREFIX."object_prefix_settings")) {
			DB::execute("CREATE TABLE `".TABLE_PREFIX."object_prefix_settings` (
			  `object_type_id` INTEGER UNSIGNED NOT NULL,
			  `enabled` BOOLEAN NOT NULL,
			  `max_digits` INTEGER UNSIGNED NOT NULL,
			  `current_value` INTEGER UNSIGNED NOT NULL,
			  PRIMARY KEY (`object_type_id`)
			) ENGINE = InnoDB;");
		}
		
		if (!checkTableExists(TABLE_PREFIX."object_prefixes")) {
			DB::execute("CREATE TABLE `".TABLE_PREFIX."object_prefixes` (
			  `object_id` INTEGER UNSIGNED NOT NULL,
			  `prefix` VARCHAR(50) NOT NULL,
			  PRIMARY KEY (`object_id`)
			) ENGINE = InnoDB;");
		}
		
		DB::execute("INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			('general', 'use_autonumeric_prefixes', '', 'MultipleObjectTypePrefixConfigHandler', 0, 0, '')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;");
	}
	
	function crpm_update_17_18() {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`) VALUES
			 ('general', 'new_client_contact_type', (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='company'), 'NewClientContactTypeConfigHandler', 0, 0)
			ON DUPLICATE KEY UPDATE name=name;
		");
		
		DB::execute("INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			('general', 'default_customer_status_value', 6, 'StatusConfigHandler', 0, 0, '')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;");
		
		DB::execute("INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			('general', 'default_project_status_value', 6, 'StatusConfigHandler', 0, 0, '')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;");
		
		DB::execute("DELETE FROM `".TABLE_PREFIX."formula_factors` WHERE  `name` = 'pending'");
		
		if (!check_column_exists(TABLE_PREFIX."projects", 'automatic_status')) {
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."projects` ADD `automatic_status` BOOLEAN NOT NULL DEFAULT '1';"
								);
		}
		
		if (!check_column_exists(TABLE_PREFIX."customers", 'automatic_status')) {
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."customers` ADD `automatic_status` BOOLEAN NOT NULL DEFAULT '1';"
								);
		}
		
		if (!check_column_exists(TABLE_PREFIX."customers", 'contact_object_type_id')) {
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."customers` ADD `contact_object_type_id` INTEGER UNSIGNED NOT NULL DEFAULT '0';"
								);
		}
	}
	
	function crpm_update_18_19(){
		DB::execute("
			CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."formula_factors_groups` (
			  `group_id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
			  `formula_id` INTEGER UNSIGNED NOT NULL,
			  `status_id` INTEGER UNSIGNED NOT NULL,			  			 
			  PRIMARY KEY (`group_id`)
			) ENGINE=InnoDB;
		");
		
		DB::execute("
			CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."formula_factors_by_group` (
			  `group_id` INTEGER UNSIGNED NOT NULL,			  
			  `name` VARCHAR(255) NOT NULL,
			  `enabled` BOOLEAN NOT NULL,
			  `comparisson_type` VARCHAR(45) NOT NULL,
			  `required_value` INTEGER UNSIGNED NOT NULL,
			  PRIMARY KEY (`group_id`, `name`)
			) ENGINE=InnoDB;
		");
		
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."formula_factors_groups` (`formula_id`, `status_id`)
				SELECT `formula_id`,`status_id` FROM `".TABLE_PREFIX."formula_factors` GROUP BY `formula_id`,`status_id`
			ON DUPLICATE KEY UPDATE formula_id=formula_id;
		");
		
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."formula_factors_by_group` (`group_id`, `name`, `enabled`, `comparisson_type`, `required_value`)
				SELECT fsg.group_id, `name`, `enabled`, `comparisson_type`, `required_value` 
				FROM `".TABLE_PREFIX."formula_factors` AS ff 
				INNER JOIN `".TABLE_PREFIX."formula_factors_groups` AS fsg ON ff.formula_id = fsg.formula_id AND ff.status_id = fsg.status_id
			ON DUPLICATE KEY UPDATE group_id=fsg.group_id;
		");
				
		DB::execute("
				DROP TABLE IF EXISTS `".TABLE_PREFIX."formula_factors`;
		");
	}
	
	function crpm_update_19_20() {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`) VALUES
			 ('listing preferences', 'show_only_member_objects_filters', '1', 'BoolConfigHandler', 1, 0),
			 ('listing preferences', 'show_only_member_files', '0', 'BoolConfigHandler', 1, 0)
			ON DUPLICATE KEY UPDATE name=name;
		");
	}
	
	function crpm_update_20_21() {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			 ('general', 'use_time_in_task_dates', '1', 'BoolConfigHandler', 0, 0, '')
			ON DUPLICATE KEY UPDATE name=name;
		");
	}
	
	
	function crpm_update_21_22() {
		if (!check_column_exists(TABLE_PREFIX."projects", 'manager_id')) {
		  DB::execute("
			ALTER TABLE `".TABLE_PREFIX."projects`
			 ADD COLUMN `manager_id` integer unsigned NOT NULL default 0,
			 ADD COLUMN `start_date` DATETIME NOT NULL,
			 ADD COLUMN `end_date` DATETIME NOT NULL;
		  ");
		}
		
		DB::execute("
			CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."project_additional_data` (
			  `project_id` INTEGER UNSIGNED NOT NULL,
			  `calc_customer_id` INTEGER UNSIGNED NOT NULL,
			  `total_tasks` INTEGER UNSIGNED NOT NULL,
			  `completed_tasks` INTEGER UNSIGNED NOT NULL,
			  `task_completion_p` FLOAT NOT NULL,
			  `total_estimated_time` INTEGER UNSIGNED NOT NULL,
			  `total_worked_time` INTEGER UNSIGNED NOT NULL,
			  `time_worked_p` FLOAT NOT NULL,
			  PRIMARY KEY (`project_id`),
			  INDEX `task_completion`(`task_completion_p`),
			  INDEX `worked_time`(`time_worked_p`),
  			  INDEX `customer` (`calc_customer_id`)
			) ENGINE=InnoDB;
		");
		
		// fill additional projects data
		Env::useHelper('project_additional_data', 'crpm');
		$projects = Projects::findAll();
		foreach ($projects as $project) {
			calculate_single_project_additional_data($project);
		}
	}
	
	function crpm_update_22_23() {
		DB::execute("
			CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."non_working_days` (
			  `id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
			  `day` INTEGER UNSIGNED NOT NULL,
			  `month` INTEGER UNSIGNED NOT NULL,
			  `name` VARCHAR(255) NOT NULL,
			  PRIMARY KEY (`id`),
			  INDEX `monthday`(`month`, `day`)
			) ENGINE=InnoDB;
		");
		
		if (!check_column_exists(TABLE_PREFIX."templates", "nw_days_todo_action")) {
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."templates`
				 ADD COLUMN `nw_days_todo_action` VARCHAR(50) NOT NULL,
				 ADD COLUMN `nw_days_todo_amount` INTEGER UNSIGNED NOT NULL,
				 ADD COLUMN `use_only_working_days` BOOLEAN NOT NULL DEFAULT 1;
			");
		}
		
	}
	
	function crpm_update_23_24() {
		if (!check_column_exists(TABLE_PREFIX."templates", "can_instance_from_mail")) {
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."templates` ADD COLUMN `can_instance_from_mail` int(1) NOT NULL default '0';
			");
		}
	}
	
	
	function crpm_update_24_25() {
	  if (Plugins::instance()->isActivePlugin('member_custom_properties')) {
	  	if (!check_member_custom_prop_exists(TABLE_PREFIX, 'start_date', 'project')) {
			// define custom properties for projects and customers
			DB::execute("
				INSERT INTO ".TABLE_PREFIX."member_custom_properties (object_type_id, name, code, `type`) VALUES
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project'), 'Start date', 'start_date', 'date'),
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project'), 'End date', 'end_date', 'date'),
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project'), 'Fee', 'fee', 'numeric'),
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer'), 'Start date', 'start_date', 'date'),
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer'), 'End date', 'end_date', 'date'),
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer'), 'Fee', 'cmrr', 'numeric');
			");
			
			// set custom property values for every project 
			$st_id_rows = MemberCustomProperties::instance()->findAll(array('id' => true, 'conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project') AND code='start_date'"));
			$sd_cp = array_var($st_id_rows, 0);
			$et_id_rows = MemberCustomProperties::instance()->findAll(array('id' => true, 'conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project') AND code='end_date'"));
			$ed_cp = array_var($et_id_rows, 0);
			
			$all_projects = Members::findAll(array('conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project')"));
			foreach ($all_projects as $project_member) {
				$member_id = $project_member->getId();
				$project_id = $project_member->getObjectId();
				
				$sql = "INSERT INTO ".TABLE_PREFIX."member_custom_property_values (member_id, custom_property_id, `value`) VALUES
					('$member_id', '$sd_cp', (SELECT start_date FROM ".TABLE_PREFIX."projects WHERE object_id='$project_id')),
					('$member_id', '$ed_cp', (SELECT end_date FROM ".TABLE_PREFIX."projects WHERE object_id='$project_id'));";
				
				DB::execute($sql);
			}
			
			// set custom property values for every customer
			$st_id_rows = MemberCustomProperties::instance()->findAll(array('id' => true, 'conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer') AND code='start_date'"));
			$sd_cp = array_var($st_id_rows, 0);
			$et_id_rows = MemberCustomProperties::instance()->findAll(array('id' => true, 'conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer') AND code='end_date'"));
			$ed_cp = array_var($et_id_rows, 0);
			$fee_id_rows = MemberCustomProperties::instance()->findAll(array('id' => true, 'conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer') AND code='cmrr'"));
			$fee_cp = array_var($fee_id_rows, 0);
			
			$all_customers = Members::findAll(array('conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer')"));
			foreach ($all_customers as $customer_member) {
				$member_id = $customer_member->getId();
				$customer_id = $customer_member->getObjectId();
					
				$sql = "INSERT INTO ".TABLE_PREFIX."member_custom_property_values (member_id, custom_property_id, `value`) VALUES
				('$member_id', '$fee_cp', (SELECT cmrr FROM ".TABLE_PREFIX."customers WHERE object_id='$customer_id')),
				('$member_id', '$sd_cp', (SELECT start_date FROM ".TABLE_PREFIX."customers WHERE object_id='$customer_id')),
				('$member_id', '$ed_cp', (SELECT end_date FROM ".TABLE_PREFIX."customers WHERE object_id='$customer_id'));";
					
				DB::execute($sql);
			}
	  	}
	  }
	}
	
	
	function crpm_update_25_26() {
		DB::execute("
			CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."customer_additional_data` (
			  `customer_id` int(10) unsigned NOT NULL,
			  `total_tasks` int(10) unsigned NOT NULL,
			  `completed_tasks` int(10) unsigned NOT NULL,
			  `task_completion_p` float NOT NULL,
			  `total_estimated_time` int(10) unsigned NOT NULL,
			  `total_worked_time` int(10) unsigned NOT NULL,
			  `time_worked_p` float NOT NULL,
			  PRIMARY KEY (`customer_id`) USING BTREE,
			  KEY `task_completion` (`task_completion_p`),
			  KEY `worked_time` (`time_worked_p`),
			  KEY `total_tasks` (`total_tasks`),
			  KEY `completed_tasks` (`completed_tasks`),
			  KEY `total_estimated_time` (`total_estimated_time`),
			  KEY `total_worked_time` (`total_worked_time`)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
		");
	
		// fill additional projects data
		ini_set('memory_limit', '1024M');
		Env::useHelper('customer_additional_data', 'crpm');
		$customers = Customers::findAll();
		foreach ($customers as $customer) {
			calculate_single_customer_additional_data($customer);
		}
		
		if (check_column_exists(TABLE_PREFIX."templates", "use_only_working_days")) {
			DB::execute("ALTER TABLE `".TABLE_PREFIX."templates` MODIFY COLUMN `use_only_working_days` BOOLEAN NOT NULL DEFAULT 0;");
			DB::execute("UPDATE `".TABLE_PREFIX."templates` SET use_only_working_days= 0;");
		}
	}
	
	function crpm_update_26_27() {
	  DB::execute("
			UPDATE ".TABLE_PREFIX."members SET description=(SELECT p.description FROM ".TABLE_PREFIX."projects p WHERE p.object_id=".TABLE_PREFIX."members.object_id)
			WHERE object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project');
	  ");
	  DB::execute("
			INSERT INTO ".TABLE_PREFIX."dimension_object_type_options (`dimension_id`, `object_type_id`, `name`, `value`) VALUES 
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_project'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='customer'),'select_after_creation','1'),
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_project'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='project'),'select_after_creation','1'),
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_project'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='folder'),'select_after_creation','1'),
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_project'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='customer_folder'),'select_after_creation','1'),
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_project'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='project_folder'),'select_after_creation','1')
			ON DUPLICATE KEY UPDATE `value`=`value`;
	  ");
		
	  if (Plugins::instance()->isActivePlugin('member_custom_properties')) {
		// define custom properties for projects and customers
		
	  	if (!check_member_custom_prop_exists(TABLE_PREFIX, 'payment_cycle', 'customer')) {
			DB::execute("
				INSERT INTO ".TABLE_PREFIX."member_custom_properties (object_type_id, name, code, `type`, `values`, `visible_by_default`) VALUES
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project'), 'Project manager', 'project_manager', 'user', '', 1),
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer'), 'Payment cycle', 'payment_cycle', 'list', 'Monthly,Yearly,Single Payment,Per Project', 0);
			");
		  	
			
			$pm_id_rows = MemberCustomProperties::instance()->findAll(array('id' => true, 'conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project') AND code='project_manager'"));
			$pm_cp = array_var($pm_id_rows, 0);
			
			$all_projects = Members::findAll(array('conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project')"));
			foreach ($all_projects as $project_member) {
				$member_id = $project_member->getId();
				$project_id = $project_member->getObjectId();
				$project = Projects::findById($project_id);
				if ($project instanceof Project && $project->getManagerId()>0) {
					$sql = "INSERT INTO ".TABLE_PREFIX."member_custom_property_values (member_id, custom_property_id, `value`) VALUES
					('$member_id', '$pm_cp', '".$project->getManagerId()."')
					ON DUPLICATE KEY UPDATE member_id=member_id;";
						
					DB::execute($sql);
				}
			}
			
			$pc_id_rows = MemberCustomProperties::instance()->findAll(array('id' => true, 'conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer') AND code='payment_cycle'"));
			$pc_cp = array_var($pc_id_rows, 0);
			
			$all_customers = Members::findAll(array('conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer')"));
			foreach ($all_customers as $customer_member) {
				$member_id = $customer_member->getId();
				$customer_id = $customer_member->getObjectId();
				$c = Customers::findById($customer_id);
				if ($c instanceof Customer && $c->getPaymentCycleId() > 0) {
					$sql = "INSERT INTO ".TABLE_PREFIX."member_custom_property_values (member_id, custom_property_id, `value`) VALUES
					('$member_id', '$pc_cp', '".$c->getPaymentCycleId()."');";
				
					DB::execute($sql);
				}
			}
	  	}
	  }
		
	  DB::execute("
			DELETE FROM `".TABLE_PREFIX."contact_config_options` 
				WHERE  `name` IN ('mobile_minimum_display_dimension_members', 'mobile_logs_amount_to_search', 'mobile_maximum_display_dimension_members');
	  ");
	}
	
	
	function crpm_update_27_28() {
		// if template is configurated to move 0 days or to leave as they are then disable use_only_working_days
		DB::execute("
			UPDATE ".TABLE_PREFIX."templates SET use_only_working_days=0 WHERE nw_days_todo_action='' OR nw_days_todo_amount=0;
		");
		// if template has enabled use_only_working_days and amount of days=0 then set amount of days to 1
		DB::execute("
			UPDATE ".TABLE_PREFIX."templates SET nw_days_todo_amount=1 WHERE nw_days_todo_amount=0 AND use_only_working_days=1;
		");
		// if template has enabled use_only_working_days and action is empty then set action to 'advance'
		DB::execute("
			UPDATE ".TABLE_PREFIX."templates SET nw_days_todo_action='advance' WHERE nw_days_todo_action='' AND use_only_working_days=1;
		");
	}
	
	
	function crpm_update_28_29() {
		if (Plugins::instance()->isActivePlugin('member_custom_properties')) {
			
			$is_disabled = Plugins::instance()->isActivePlugin('crpm_types') ? "1" : "0";
			
			// define custom properties for projects and customers
			DB::execute("
				INSERT INTO ".TABLE_PREFIX."member_custom_properties (object_type_id, name, code, `type`, `values`, `visible_by_default`, `is_special`, `is_disabled`) VALUES
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project'), 'Status', 'status_special', 'list', '1@Inactive,2@Suspended,3@Bad,4@Regular,5@Neutral,6@Good,7@Excellent', 1, 1, $is_disabled),
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project'), 'Use automatic status', 'calculate the status automatically_special', 'boolean', '', 1, 1, $is_disabled),
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer'), 'Status', 'status_special', 'list', '1@Inactive,2@Suspended,3@Bad,4@Regular,5@Neutral,6@Good,7@Excellent', 1, 1, $is_disabled),
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer'), 'Use automatic status', 'calculate the status automatically_special', 'boolean', '', 1, 1, $is_disabled);
			");
			
			// update payment_cycle custom property
			DB::execute("UPDATE ".TABLE_PREFIX."member_custom_properties SET `values`='1@Monthly,2@Yearly,3@Single Payment,4@Per Project' WHERE code='payment_cycle';");
			DB::execute("UPDATE ".TABLE_PREFIX."member_custom_property_values mcp 
							SET mcp.value=(SELECT pc.id FROM ".TABLE_PREFIX."customer_payment_cycles pc WHERE pc.name=mcp.value) 
							WHERE mcp.custom_property_id IN (SELECT id FROM ".TABLE_PREFIX."member_custom_properties WHERE code='payment_cycle');");
			
			if (!$is_disabled) {
				$id_rows = MemberCustomProperties::instance()->findAll(array('id' => true, 'conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project') AND code='status_special'"));
				$cp = array_var($id_rows, 0);
				$id_rows = MemberCustomProperties::instance()->findAll(array('id' => true, 'conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project') AND code='calculate the status automatically_special'"));
				$cp2 = array_var($id_rows, 0);
		
				$all_projects = Members::findAll(array('conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project')"));
				foreach ($all_projects as $project_member) {
					$member_id = $project_member->getId();
					$project_id = $project_member->getObjectId();
					$project = Projects::findById($project_id);
					
					if ($project instanceof Project) {
						if ($project->getStatus() > 0) {
							$sql = "INSERT INTO ".TABLE_PREFIX."member_custom_property_values (member_id, custom_property_id, `value`) VALUES
									('$member_id', '$cp', '".$project->getStatus()."')
								ON DUPLICATE KEY UPDATE member_id=member_id;";
							DB::execute($sql);
						}
						
						if ($project->getAutomaticStatus() > 0) {
							$sql = "INSERT INTO ".TABLE_PREFIX."member_custom_property_values (member_id, custom_property_id, `value`) VALUES
									('$member_id', '$cp2', '1') ON DUPLICATE KEY UPDATE member_id=member_id;";
							DB::execute($sql);
						}
					}
				}
		
				$id_rows = MemberCustomProperties::instance()->findAll(array('id' => true, 'conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer') AND code='status_special'"));
				$cp = array_var($id_rows, 0);
				$id_rows = MemberCustomProperties::instance()->findAll(array('id' => true, 'conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer') AND code='calculate the status automatically_special'"));
				$cp2 = array_var($id_rows, 0);
		
				$all_customers = Members::findAll(array('conditions' => "object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer')"));
				foreach ($all_customers as $customer_member) {
					$member_id = $customer_member->getId();
					$customer_id = $customer_member->getObjectId();
					$c = Customers::findById($customer_id);
					if ($c instanceof Customer) {
						if ($c->getStatusId() > 0) {
							$sql = "INSERT INTO ".TABLE_PREFIX."member_custom_property_values (member_id, custom_property_id, `value`) VALUES
								('$member_id', '$cp', '".$c->getStatusId()."');";
							DB::execute($sql);
						}
						
						if ($c->getAutomaticStatus() > 0) {
							$sql = "INSERT INTO ".TABLE_PREFIX."member_custom_property_values (member_id, custom_property_id, `value`) VALUES
								('$member_id', '$cp2', '1');";
							DB::execute($sql);
						}
					}
				}
			}
		}
	}
	


	function crpm_update_29_30() {
		// delete project members that not have any project associated
		DB::execute("
			delete from ".TABLE_PREFIX."members
			where object_type_id=(select id from ".TABLE_PREFIX."object_types where name='project') and ".TABLE_PREFIX."members.object_id>0
			and not exists (select id from ".TABLE_PREFIX."objects o where o.id=".TABLE_PREFIX."members.object_id);
		");
	}
	
	
	function crpm_update_30_31() {
		// add column for confidential users
		if (!check_column_exists(TABLE_PREFIX."contacts", "is_confidential")) {
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."contacts` ADD COLUMN `is_confidential` BOOLEAN NOT NULL DEFAULT 0;
			");
		}
	}
	
	function crpm_update_31_32() {
		if (Plugins::instance()->isActivePlugin('member_custom_properties')) {
			// set start_date, end_date, fee, cmrr, payment_cycle, company_id custom properties as special
			DB::execute("
				UPDATE ".TABLE_PREFIX."member_custom_properties SET is_special=1 
				WHERE code IN ('start_date','end_date','fee','cmrr','payment_cycle','legal_name','company_id')
					AND object_type_id IN (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name IN ('customer','project'));
			");
			// set default value for status client/project custom property
			DB::execute("
				UPDATE ".TABLE_PREFIX."member_custom_properties SET default_value=6
				WHERE code IN ('status_special')
					AND object_type_id IN (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name IN ('customer','project'));
			");
		}
	}
	
	
	function crpm_update_32_33() {
		if (!check_column_exists(TABLE_PREFIX."non_working_days", "year")) {
			// add year column to non_working_days table
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."non_working_days` ADD `year` int(10) unsigned NOT NULL DEFAULT 0;
			");
			// add new index including the new year column
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."non_working_days` ADD INDEX `year_month_day` (`year`, `month`, `day`);
			");
		}
	}
	
	
	function crpm_update_33_34() {
		
		if (!check_column_exists(TABLE_PREFIX."object_prefixes", "object_type_id")) {
			// add year column object_type_id and unique index by <object_type_id,prefix>
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."object_prefixes` ADD COLUMN `object_type_id` int(10) unsigned NOT NULL DEFAULT 0;
			");
			
			// reassign repeated prefixes
			$repeated_object_ids = DB::executeAll("
				select op.object_id from ".TABLE_PREFIX."object_prefixes op where exists (
					select op2.object_id from ".TABLE_PREFIX."object_prefixes op2 where op2.prefix=op.prefix and op2.object_id<op.object_id
				);
			");
			$repeated_object_ids = array_filter(array_flat($repeated_object_ids));
			foreach ($repeated_object_ids as $rep_oid) {
				
				$object = Objects::findObject($rep_oid);
				DB::execute("UPDATE ".TABLE_PREFIX."object_prefix_settings SET current_value=current_value+1 WHERE object_type_id=".$object->getObjectTypeId());
				
				$op_settings = get_object_prefix_setting($object);
				$value = $op_settings->getCurrentValue();
				$prefix = str_pad($value, $op_settings->getMaxDigits(), '0', STR_PAD_LEFT);
				DB::execute("UPDATE ".TABLE_PREFIX."object_prefixes SET prefix='$prefix' WHERE object_id=$rep_oid");
			}
			
			// fill object_type_id for existing prefixes
			$sql = "UPDATE ".TABLE_PREFIX."object_prefixes SET object_type_id=(
						SELECT o.object_type_id FROM ".TABLE_PREFIX."objects o WHERE o.id=".TABLE_PREFIX."object_prefixes.object_id
					);";
			DB::execute($sql);
			
			// create unique index by object_type_id,prefix
			DB::execute("ALTER TABLE `".TABLE_PREFIX."object_prefixes` ADD UNIQUE `object_type_id_prefix` (`object_type_id`, `prefix`);");
		}
	}
	
	function crpm_update_34_35() {

		if (Plugins::instance()->isActivePlugin('advanced_reports')) {
			Env::useHelper('default_member_reports', 'advanced_reports');
		
			create_default_member_report('customer');
			create_default_member_report('project');
		}
	}
	
	
	function crpm_update_35_36() {
		
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."tab_panels` (`id`,`title`,`icon_cls`,`refresh_on_context_change`,`default_controller`,`default_action`,`initial_controller`,`initial_action`,`enabled`,`type`,`ordering`,`plugin_id`,`object_type_id`,`url_params`) VALUES 
			 ('projects-panel', 'projects', 'ico-projects', 1, 'member', 'init', '', '', 1, 'system', 20, (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='crpm'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project'), 
			 	CONCAT('{\"dim_id\":',(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_project'),', \"type_id\":',(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project'),'}') ),
			 ('customers-panel', 'customers', 'ico-customers', 1, 'member', 'init', '', '', 1, 'system', 20, (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='crpm'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer'), 
			 	CONCAT('{\"dim_id\":',(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_project'),', \"type_id\":',(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer'),'}') )
			ON DUPLICATE KEY UPDATE id=id;
		");
		
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."tab_panel_permissions (permission_group_id, tab_panel_id)
			 SELECT pg.id, 'projects-panel' FROM ".TABLE_PREFIX."permission_groups pg WHERE pg.type='roles' AND pg.name IN ('Super Administrator','Administrator','Manager','Executive')
			ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;
		");
		
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."tab_panel_permissions (permission_group_id, tab_panel_id)
			 SELECT pg.id, 'customers-panel' FROM ".TABLE_PREFIX."permission_groups pg WHERE pg.type='roles' AND pg.name IN ('Super Administrator','Administrator','Manager','Executive')
			ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;
		");
		
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."tab_panel_permissions (permission_group_id, tab_panel_id)
			 SELECT pg.id, 'projects-panel' FROM ".TABLE_PREFIX."permission_groups pg WHERE pg.type='permission_groups' AND pg.contact_id IN (
				SELECT c.object_id FROM ".TABLE_PREFIX."contacts c WHERE c.user_type IN (SELECT pg.id FROM ".TABLE_PREFIX."permission_groups pg WHERE pg.name IN ('Super Administrator','Administrator','Manager','Executive'))
			 )
			ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;
		");
		
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."tab_panel_permissions (permission_group_id, tab_panel_id)
			 SELECT pg.id, 'customers-panel' FROM ".TABLE_PREFIX."permission_groups pg WHERE pg.type='permission_groups' AND pg.contact_id IN (
				SELECT c.object_id FROM ".TABLE_PREFIX."contacts c WHERE c.user_type IN (SELECT pg.id FROM ".TABLE_PREFIX."permission_groups pg WHERE pg.name IN ('Super Administrator','Administrator','Manager','Executive'))
			 )
			ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;
		");
	}
	
	
	function crpm_update_36_37() {
		// allow search by object prefix
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."searchable_objects (rel_object_id, column_name, content)
			SELECT op.object_id, 'prefix', op.prefix FROM ".TABLE_PREFIX."object_prefixes op
			ON DUPLICATE KEY UPDATE content='op.prefix';
		");
	}

    function crpm_update_37_38() {

        $dim = Dimensions::findByCode('customer_stages');
        if ($dim instanceof Dimension) {
            $dim_id = $dim->getId();

            $config_option_exists = ConfigOptions::getByName("new_members_from_api_with");
            if (!$config_option_exists instanceof ConfigOption) {
                DB::execute("
                    INSERT INTO `" . TABLE_PREFIX . "config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `options`) VALUES
                        ('general', 'new_members_from_api_with', '0', 'MemberConfigHandler', '0', '0', '{\"dim_id\":$dim_id}');
					");
            }
        }



    }
	
	
	function crpm_update_38_39() {
		// update client status cp
		DB::execute("
			UPDATE " . TABLE_PREFIX . "custom_properties
			SET `values` = '0@Unknown,1@Inactive,2@Suspended,3@Bad,4@Regular,5@Neutral,6@Good,7@Excellent',
				`default_value` = 0
			WHERE `code` = 'status_special';	
		");
		
		// add default cp value for customers that dont have status cp value
		$customer_ot = ObjectTypes::findByName('customer');
		$status_cp = CustomProperties::instance()->getCustomPropertyByCode($customer_ot->getId(), 'status_special');
		if ($status_cp instanceof CustomProperty) {
			DB::execute("
				INSERT INTO ".TABLE_PREFIX."custom_property_values (`object_id`, `custom_property_id`, `value`)
					select c.object_id, 14, 0 from ".TABLE_PREFIX."customers c
					where not exists (
						select object_id from ".TABLE_PREFIX."custom_property_values cpv
						inner join ".TABLE_PREFIX."custom_properties cp on cp.id=cpv.custom_property_id
						where cp.code='status_special' and cp.object_type_id=(select id from ".TABLE_PREFIX."object_types where name='customer')
						and c.object_id=cpv.object_id
					);
			");
		}
	}
	
	function crpm_update_39_40() {
		$config_option_exists = ConfigOptions::getByName("allow_duplicated_contact_emails");
		if (!$config_option_exists instanceof ConfigOption) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`)
				VALUES ('clients_and_contacts', 'allow_duplicated_contact_emails', '', 'BoolConfigHandler', 0, 0, '')
				ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
	        ");
		}
		
		if (!check_column_exists(TABLE_PREFIX."project_tasks", 'repeat_generate_instances')) {
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."project_tasks`
				ADD `repeat_generate_instances` tinyint(1) NOT NULL AFTER `repeat_by`;
			");
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."project_tasks`
				ADD `repeat_fixed_days` varchar(50) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '' AFTER `repeat_generate_instances`;
			");
		}
		if (!check_column_exists(TABLE_PREFIX."template_tasks", 'repeat_generate_instances')) {
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."template_tasks`
				ADD `repeat_generate_instances` tinyint(1) NOT NULL AFTER `repeat_by`;
			");
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."template_tasks`
				ADD `repeat_fixed_days` varchar(50) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '' AFTER `repeat_generate_instances`;
			");
		}
		$config_option_exists = ConfigOptions::getByName("days range to replicate tasks");
		if (!$config_option_exists instanceof ConfigOption) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
				('general', 'days range to replicate tasks', 15, 'IntegerConfigHandler', '0', '0', NULL);
			");
		}
		
		$cron_event = CronEvents::instance()->getByName("generate_repetitive_tasks_instances");
		if (!$cron_event instanceof CronEvent) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."cron_events` (`name`, `recursive`, `delay`, `is_system`, `enabled`) VALUES
				('generate_repetitive_tasks_instances', 1, 120, 0, 0)
				ON DUPLICATE KEY UPDATE name=name;
			");
		}
	}
	
	function crpm_update_40_41() {
		$config_option_exists = ConfigOptions::getByName("generate repetitive instances");
		if (!$config_option_exists instanceof ConfigOption) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
				('general', 'generate repetitive instances', 1, 'BoolConfigHandler', '0', '0', NULL);
			");
		}
	}
	
	function crpm_update_41_42() {
		
		$config_cat_exists = ConfigCategories::findOne(array("conditions" => "name='clients_and_contacts'"));
		if (!$config_cat_exists instanceof ConfigCategory) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."config_categories` (`name`, `is_system`, `category_order`) VALUES
				('clients_and_contacts', 0, 70);
			");
		}
		
		$config_option_exists = ConfigOptions::getByName("create_contact_info_for_client");
		if (!$config_option_exists instanceof ConfigOption) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
				('clients_and_contacts', 'create_contact_info_for_client', 'company,contact,unknown', 'MultipleListConfigHandler', 0, 0, '', 'company,contact,unknown')
				ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
			");
		}
		
		DB::execute("
			UPDATE ".TABLE_PREFIX."config_options SET category_name='clients_and_contacts'
			WHERE name IN ('allow_duplicated_contact_emails', 'check_unique_mail_contact_comp');
		");
	}
	
	function crpm_update_42_43() {
		if (!Plugins::instance()->isInstalledPlugin('advanced_services')) {
			DB::execute("DELETE FROM ".TABLE_PREFIX."config_options WHERE `name`='dont allow unavailable users assign';");
		}
	}
	
	function crpm_update_43_44() {
		// fix clients depth if they were removed from a parent
		$client_ot = ObjectTypes::findByName('customer');
		DB::execute("
			UPDATE ".TABLE_PREFIX."members SET depth=1 
			WHERE parent_member_id=0 AND object_type_id=".$client_ot->getId()."
		");
	}
	
	function crpm_update_44_45() {
		DB::execute("
			UPDATE `".TABLE_PREFIX."cron_events` SET `enabled`=1
			WHERE `name`='generate_repetitive_tasks_instances' AND `enabled`=0;
		");
	}

	function crpm_update_45_46() {
		// set association between projects and clients as not multiple
		DB::execute("
			update `".TABLE_PREFIX."dimension_member_associations`
			set is_multiple=0
			where
			object_type_id = (select id from ".TABLE_PREFIX."object_types where name='project')
			and associated_object_type_id = (select id from ".TABLE_PREFIX."object_types where name='customer');
		");
	}
	
	
	
	function crpm_update_46_47() {
		$config_option_exists = ContactConfigOptions::getByName("show_only_member_files");
		if (!$config_option_exists instanceof ContactConfigOption) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`) VALUES
				 ('listing preferences', 'show_only_member_files', '0', 'BoolConfigHandler', 1, 0)
				ON DUPLICATE KEY UPDATE name=name;
			");
		}
	}
	
	function crpm_update_47_48() {
		$config_option_exists = ContactConfigOptions::getByName("collapse_dim_panel_when_only_one_member");
		if (!$config_option_exists instanceof ContactConfigOption) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`) VALUES
				 ('general', 'collapse_dim_panel_when_only_one_member', '0', 'BoolConfigHandler', 0, 0)
				ON DUPLICATE KEY UPDATE name=name;
			");
		}
	}
	
	function crpm_update_48_49() {
		$config_option_exists = ConfigOptions::getByName("multi_assignment_dim_ids");
		if (!$config_option_exists instanceof ContactConfigOption) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
				('general', 'multi_assignment_dim_ids', '0', 'ManageableDimensionsConfigHandler', '0', '0', NULL)
				ON DUPLICATE KEY UPDATE name=name;
			");
		}
	}