og.crpm_types = {
	init: function() {
		for (x in og.dimension_object_types) {
			if (!og.dimension_object_types[x] || typeof(og.dimension_object_types[x])=='function') continue;
			if (og.dimension_object_types[x] == 'customer_type') {
				og.additional_on_dimension_object_click[x] = 'og.crpm_types.onCustomerTypeClick(<parameters>);';
			} else if (og.dimension_object_types[x] == 'customer_sector') {
				og.additional_on_dimension_object_click[x] = 'og.crpm_types.onCustomerSectorClick(<parameters>);';
			} else if (og.dimension_object_types[x] == 'customer_stage') {
				og.additional_on_dimension_object_click[x] = 'og.crpm_types.onCustomerStageClick(<parameters>);';
			} else if (og.dimension_object_types[x] == 'project_types') {
				og.additional_on_dimension_object_click[x] = 'og.crpm_types.onProjectTypeClick(<parameters>);';
			} else if (og.dimension_object_types[x] == 'project_status') {
				og.additional_on_dimension_object_click[x] = 'og.crpm_types.onProjectStatusClick(<parameters>);';
			}
		}
	},
	onCustomerTypeClick: function (member_id) {
		og.memberTreeExternalClick('customer_types', member_id);
	},
	onCustomerSectorClick: function (member_id) {
		og.memberTreeExternalClick('customer_sectors', member_id);
	},
	onCustomerStageClick: function (member_id) {
		og.memberTreeExternalClick('customer_stages', member_id);
	},
	onProjectTypeClick: function (member_id) {
		og.memberTreeExternalClick('project_types', member_id);
	},
	onProjectStatusClick: function (member_id) {
		og.memberTreeExternalClick('project_statuses', member_id);
	}
}

og.onCustomerTypeRemove = function (genid){
	og.onAssociatedMemberTypeRemove(genid, "customer[customer_type]");
}

og.onCustomerTypeSelect = function (genid, dimension_id, member_id){
	og.onAssociatedMemberTypeSelect(genid, dimension_id, member_id, "customer[customer_type]");
}

og.onCustomerSectorRemove = function (genid, dimension_id){
	og.onAssociatedMemberTypeRemoveMultiple(genid, dimension_id, "customer[customer_sector]");
}

og.onCustomerSectorSelect = function (genid, dimension_id, member_id){
	og.onAssociatedMemberTypeSelectMultiple(genid, dimension_id, member_id, "customer[customer_sector]");
}

og.onCustomerStageRemove = function (genid){
	og.onAssociatedMemberTypeRemove(genid, "customer[customer_stage]");
}

og.onCustomerStageSelect = function (genid, dimension_id, member_id){
	og.onAssociatedMemberTypeSelect(genid, dimension_id, member_id, "customer[customer_stage]");
}


og.onProjectTypeRemove = function (genid){
	og.onAssociatedMemberTypeRemove(genid, "project[project_type]");
}

og.onProjectTypeSelect = function (genid, dimension_id, member_id){
	og.onAssociatedMemberTypeSelect(genid, dimension_id, member_id, "project[project_type]");
}


og.onProjectStatusRemove = function (genid){
	og.onAssociatedMemberTypeRemove(genid, "project[status_member_id]");
}

og.onProjectStatusSelect = function (genid, dimension_id, member_id){
	og.onAssociatedMemberTypeSelect(genid, dimension_id, member_id, "project[status_member_id]");
}


og.onProjectPMRemove = function (genid){
	og.onAssociatedMemberTypeRemove(genid, "project[project_manager_member_id]");
}

og.onProjectPMSelect = function (genid, dimension_id, member_id){
	og.onAssociatedMemberTypeSelect(genid, dimension_id, member_id, "project[project_manager_member_id]");
}


og.onProjectClientRemove = function (genid){
	og.onAssociatedMemberTypeRemove(genid, "project[client_id]");
}

og.onProjectClientSelect = function (genid, dimension_id, member_id){
	og.onAssociatedMemberTypeSelect(genid, dimension_id, member_id, "project[client_id]");
}


og.onCustomerCountryRemove = function (genid, dimension_id){
	og.onAssociatedMemberTypeRemoveMultiple(genid, dimension_id, "customer[countries]");
}

og.onCustomerCountrySelect = function (genid, dimension_id, member_id){
	og.onAssociatedMemberTypeSelectMultiple(genid, dimension_id, member_id, "customer[countries]");
}
