<?php 

function crpm_types_update_1_2() {
  $sectors_dim = Dimensions::findByCode('customer_sectors');
  if (!$sectors_dim instanceof Dimension) {
	// new dimension customer_sectors
	$options = '{"defaultAjax":{"controller":"dashboard","action":"main_dashboard"},"useLangs":true,"quickAdd":true,"showInPaths":true}';
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimensions` (`code`,`name`,`is_root`,`is_manageable`,`allows_multiple_selection`,`defines_permissions`,`default_order`, `is_default`, `options`, `permission_query_method`) VALUES 
		('customer_sectors','Client sector',1,0,0,0,13,0,'$options', 'not_mandatory' );
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
		 ('customer_sector', '', '', 'dimension_group', 'customer_sector', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='crpm_types'), 0)
		ON DUPLICATE KEY UPDATE id=id;
	");
	
	$options2 = '{"defaultAjax":{"controller":"dashboard", "action": "main_dashboard"}}';
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_types` (`dimension_id`,`object_type_id`,`is_root`,`options`) VALUES 
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_sectors'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer_sector'), 1, '$options2')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_sectors'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='customer_sector'),
		 	`id`, 0, 1
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `type` IN ('content_object', 'comment', 'located')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_member_associations` (`dimension_id`,`object_type_id`,`associated_dimension_id`, `associated_object_type_id`, `is_required`,`is_multiple`, `keeps_record`) VALUES
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_sectors'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer_sector'),0,1,0)
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		UPDATE `".TABLE_PREFIX."contact_config_options` 
		 SET default_value = concat(default_value,',', (SELECT GROUP_CONCAT(`id`) FROM `".TABLE_PREFIX."dimensions` WHERE `code` IN ('customer_sectors')) ) 
		 WHERE name='root_dimensions';
	");
	
	DB::execute("
		UPDATE `".TABLE_PREFIX."config_options` 
		 SET value = concat(`".TABLE_PREFIX."config_options`.`value`,',', (SELECT GROUP_CONCAT(`id`) FROM `".TABLE_PREFIX."dimensions` WHERE `code` IN ('customer_sectors')) )
		 WHERE name='enabled_dimensions';
 	");
  }
}

function crpm_types_update_2_3() {
  $stages_dim = Dimensions::findByCode('customer_stages');
  if (!$stages_dim instanceof Dimension) {
	// new dimension Client Stage
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimensions` (`code`,`name`,`is_root`,`is_manageable`,`allows_multiple_selection`,`defines_permissions`,`default_order`, `is_default`, `options`, `permission_query_method`) VALUES 
		('customer_stages','Client sector',1,0,0,0,13,0,'{\"defaultAjax\":{\"controller\":\"dashboard\",\"action\":\"main_dashboard\"},\"useLangs\":true,\"quickAdd\":true,\"showInPaths\":true}', 'not_mandatory' );
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."dimension_options (`dimension_id`, `name`, `value`) VALUES
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_stages'),'useLangs','1'),
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_stages'),'showInPaths','1')
		ON DUPLICATE KEY UPDATE `value`=`value`;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
		 ('customer_stage', '', '', 'dimension_group', 'customer_stage', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='crpm_types'), 0)
		ON DUPLICATE KEY UPDATE id=id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_types` (`dimension_id`,`object_type_id`,`is_root`,`options`) VALUES 
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_stages'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer_stage'), 1, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_stages'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='customer_stage'),
		 	`id`, 0, 1
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `type` IN ('content_object', 'comment', 'located')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_member_associations` (`dimension_id`,`object_type_id`,`associated_dimension_id`, `associated_object_type_id`, `is_required`,`is_multiple`, `keeps_record`) VALUES
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_stages'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer_stage'),0,0,0)
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
			SELECT mt.id, 'Color', 'color_special','color','','','',0,0,0,30,1, 1, 0
			FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('customer_stage')
		ON DUPLICATE KEY UPDATE `code`=`code`;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
		  SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,0,31,1, 1, 0
		  FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('customer_stage')
		ON DUPLICATE KEY UPDATE `code`=`code`;
	");
  }
	
	$c_dim = Dimensions::findByCode('customers');
	if ($c_dim instanceof Dimension) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_member_associations` (`dimension_id`,`object_type_id`,`associated_dimension_id`, `associated_object_type_id`, `is_required`,`is_multiple`, `keeps_record`) VALUES
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customers'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_stages'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer_stage'),0,0,0)
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");
	}
}


function crpm_types_update_3_4() {
	$pm_dim = Dimensions::findByCode('project_managers');
	if (!$pm_dim instanceof Dimension) {
		// new dimension Project managers
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimensions` (`code`,`name`,`is_root`,`is_manageable`,`allows_multiple_selection`,`defines_permissions`,`default_order`, `is_default`, `options`, `permission_query_method`) VALUES
			('project_managers','Project managers',1,0,0,0,13,0,'{\"defaultAjax\":{\"controller\":\"dashboard\",\"action\":\"main_dashboard\"},\"useLangs\":true,\"quickAdd\":true,\"showInPaths\":true}', 'not_mandatory' );
		");
	
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."dimension_options (`dimension_id`, `name`, `value`) VALUES
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='project_managers'),'useLangs','1'),
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='project_managers'),'showInPaths','1')
			ON DUPLICATE KEY UPDATE `value`=`value`;
		");
	
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
			 ('project_manager', '', '', 'dimension_group', 'project_manager', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='crpm_types'), 0)
			ON DUPLICATE KEY UPDATE id=id;
		");
	
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_types` (`dimension_id`,`object_type_id`,`is_root`,`options`) VALUES
			 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'project_managers'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'project_manager'), 1, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");
	
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
			 SELECT
			 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='project_managers'),
			 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='project_manager'),
			 	`id`, 0, 1
			 FROM `".TABLE_PREFIX."object_types`
			 WHERE  `type` IN ('content_object', 'comment', 'located')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");
	
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_member_associations` (`dimension_id`,`object_type_id`,`associated_dimension_id`, `associated_object_type_id`, `is_required`,`is_multiple`, `keeps_record`) VALUES
			 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'project'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'project_managers'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'project_manager'),0,0,0)
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");
	
		if (checkTableExists(TABLE_PREFIX.'member_custom_properties')) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
					SELECT mt.id, 'Color', 'color_special','color','','','',0,0,0,30,1, 1, 0
					FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('project_manager')
				ON DUPLICATE KEY UPDATE `code`=`code`;
			");
		
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				  SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,0,31,1, 1, 0
				  FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('project_manager')
				ON DUPLICATE KEY UPDATE `code`=`code`;
			");
		}
	}
}

function crpm_types_update_4_5() {
	DB::executeAll("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_hierarchies` (`dimension_id`, `parent_object_type_id`, `child_object_type_id`) VALUES
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_stages'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='customer_stage'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='customer_stage'))
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
}




function crpm_types_update_5_6() {
	$c_dim = Dimensions::findByCode('countries');
	if (!$c_dim instanceof Dimension) {
		// new dimension Countries
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimensions` (`code`,`name`,`is_root`,`is_manageable`,`allows_multiple_selection`,`defines_permissions`,`default_order`, `is_default`, `options`, `permission_query_method`) VALUES
			('countries','Countries',1,0,0,0,20,0,'{\"defaultAjax\":{\"controller\":\"dashboard\",\"action\":\"main_dashboard\"},\"useLangs\":true,\"quickAdd\":true,\"showInPaths\":true}', 'not_mandatory' );
		");
	
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."dimension_options (`dimension_id`, `name`, `value`) VALUES
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='countries'),'useLangs','1'),
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='countries'),'showInPaths','1')
			ON DUPLICATE KEY UPDATE `value`=`value`;
		");
	
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
			 ('country', '', '', 'dimension_group', 'country', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='crpm_types'), 0)
			ON DUPLICATE KEY UPDATE id=id;
		");
	
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_types` (`dimension_id`,`object_type_id`,`is_root`,`options`) VALUES
			 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'countries'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'country'), 1, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");
	
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
			 SELECT
			 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='countries'),
			 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='country'),
			 	`id`, 0, 1
			 FROM `".TABLE_PREFIX."object_types`
			 WHERE  `type` IN ('content_object', 'comment', 'located')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");
	
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_member_associations` (`dimension_id`,`object_type_id`,`associated_dimension_id`, `associated_object_type_id`, `is_required`,`is_multiple`, `keeps_record`) VALUES
			 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'countries'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'country'),0,1,0)
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");
	
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				SELECT mt.id, 'Color', 'color_special','color','','','',0,0,0,30,1, 1, 0
				FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('country')
			ON DUPLICATE KEY UPDATE `code`=`code`;
		");
	
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
			  SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,0,31,1, 1, 0
			  FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('country')
			ON DUPLICATE KEY UPDATE `code`=`code`;
		");
		
		DB::executeAll("
			INSERT INTO `".TABLE_PREFIX."dimension_object_type_hierarchies` (`dimension_id`, `parent_object_type_id`, `child_object_type_id`) VALUES
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='countries'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='country'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='country'))
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");
	}

	$c_dim = Dimensions::findByCode('customers');
	if ($c_dim instanceof Dimension) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_member_associations` (`dimension_id`,`object_type_id`,`associated_dimension_id`, `associated_object_type_id`, `is_required`,`is_multiple`, `keeps_record`) VALUES
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customers'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'countries'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'country'),0,1,0)
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");
	}
}

function crpm_types_update_6_7() {
	DB::executeAll("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_hierarchies` (`dimension_id`, `parent_object_type_id`, `child_object_type_id`) VALUES
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_sectors'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='customer_sector'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='customer_sector'))
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
}

function crpm_types_update_7_8() {
	DB::executeAll("
		UPDATE ".TABLE_PREFIX."dimensions SET is_manageable=1 WHERE code='customers';
	");
}

function crpm_types_update_8_9() {

	$pr_status_dim = Dimensions::findByCode('project_statuses');
	if ($pr_status_dim instanceof Dimension && in_array($pr_status_dim->getId(), config_option('enabled_dimensions'))) {
		DB::executeAll("
			UPDATE ".TABLE_PREFIX."member_custom_properties SET is_disabled=1 
			WHERE `code` IN ('status_special','calculate the status automatically_special') 
				AND object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project');
		");
	}
	
	DB::execute("
		UPDATE `".TABLE_PREFIX."dimension_member_associations` SET is_multiple=1 
		WHERE associated_object_type_id in (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name in ('customer_sector','country'));
	");
}




function crpm_types_update_9_10() {
	$pm_dim = Dimensions::findByCode('account_executives');
	if (!$pm_dim instanceof Dimension) {
		// new dimension Project managers
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimensions` (`code`,`name`,`is_root`,`is_manageable`,`allows_multiple_selection`,`defines_permissions`,`default_order`, `is_default`, `options`, `permission_query_method`) VALUES
			('account_executives','Account executives',1,1,0,0,15,0,'{\"defaultAjax\":{\"controller\":\"dashboard\",\"action\":\"main_dashboard\"},\"useLangs\":true,\"quickAdd\":true,\"showInPaths\":true}', 'not_mandatory' );
		");

		DB::execute("
			INSERT INTO ".TABLE_PREFIX."dimension_options (`dimension_id`, `name`, `value`) VALUES
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='account_executives'),'useLangs','1'),
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='account_executives'),'showInPaths','1')
			ON DUPLICATE KEY UPDATE `value`=`value`;
		");

		DB::execute("
			INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
			 ('account_executive', '', '', 'dimension_group', 'account_executive', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='crpm_types'), 0)
			ON DUPLICATE KEY UPDATE id=id;
		");

		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_types` (`dimension_id`,`object_type_id`,`is_root`,`options`) VALUES
			 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'account_executives'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'account_executive'), 1, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");

		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
			 SELECT
			 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='account_executives'),
			 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='account_executive'),
			 	`id`, 0, 1
			 FROM `".TABLE_PREFIX."object_types`
			 WHERE  `type` IN ('content_object', 'comment', 'located')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");

		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_member_associations` (`dimension_id`,`object_type_id`,`associated_dimension_id`, `associated_object_type_id`, `is_required`,`is_multiple`, `keeps_record`) VALUES
			 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'account_executives'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'account_executive'),0,0,0)
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");

		if (checkTableExists(TABLE_PREFIX.'member_custom_properties')) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
					SELECT mt.id, 'Color', 'color_special','color','','','',0,0,0,30,1, 1, 0
					FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('account_executive')
				ON DUPLICATE KEY UPDATE `code`=`code`;
			");

			DB::execute("
				INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				  SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,0,31,1, 1, 0
				  FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('account_executive')
				ON DUPLICATE KEY UPDATE `code`=`code`;
			");
		}
	}
}


function crpm_types_update_10_11() {
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`) VALUES
		 ('listing preferences', 'lp_dim_customer_types_show_as_column', '1', 'BoolConfigHandler', 0, 0),
		 ('listing preferences', 'lp_dim_project_types_show_as_column', '1', 'BoolConfigHandler', 0, 0),
		 ('listing preferences', 'lp_dim_project_managers_show_as_column', '1', 'BoolConfigHandler', 0, 0),
		 ('listing preferences', 'lp_dim_project_statuses_show_as_column', '1', 'BoolConfigHandler', 0, 0),
		 ('listing preferences', 'lp_dim_customer_sectors_show_as_column', '1', 'BoolConfigHandler', 0, 0),
		 ('listing preferences', 'lp_dim_customer_stages_show_as_column', '1', 'BoolConfigHandler', 0, 0),
		 ('listing preferences', 'lp_dim_account_executives_show_as_column', '1', 'BoolConfigHandler', 0, 0),
		 ('listing preferences', 'lp_dim_countries_show_as_column', '1', 'BoolConfigHandler', 0, 0)
		ON DUPLICATE KEY UPDATE name=name;
	");
}


function crpm_types_update_11_12() {
	DB::executeAll("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_hierarchies` (`dimension_id`, `parent_object_type_id`, `child_object_type_id`) VALUES
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='customer_types'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='customer_type'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='customer_type'))
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
}



function crpm_types_update_12_13() {
	$pm_dim = Dimensions::findByCode('marketing_channels');
	if (!$pm_dim instanceof Dimension) {
		// new dimension Project managers
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimensions` (`code`,`name`,`is_root`,`is_manageable`,`allows_multiple_selection`,`defines_permissions`,`default_order`, `is_default`, `options`, `permission_query_method`) VALUES
			('marketing_channels','Marketing channels',1,1,0,0,15,0,'{\"defaultAjax\":{\"controller\":\"dashboard\",\"action\":\"main_dashboard\"},\"useLangs\":true,\"quickAdd\":true,\"showInPaths\":true}', 'not_mandatory' );
		");

		DB::execute("
			INSERT INTO ".TABLE_PREFIX."dimension_options (`dimension_id`, `name`, `value`) VALUES
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='marketing_channels'),'useLangs','1'),
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='marketing_channels'),'showInPaths','1')
			ON DUPLICATE KEY UPDATE `value`=`value`;
		");

		DB::execute("
			INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
			 ('marketing_channel', '', '', 'dimension_group', 'marketing_channel', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='crpm_types'), 0)
			ON DUPLICATE KEY UPDATE id=id;
		");

		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_types` (`dimension_id`,`object_type_id`,`is_root`,`options`) VALUES
			 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'marketing_channels'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'marketing_channel'), 1, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");

		DB::executeAll("
			INSERT INTO `".TABLE_PREFIX."dimension_object_type_hierarchies` (`dimension_id`, `parent_object_type_id`, `child_object_type_id`) VALUES
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='marketing_channels'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='marketing_channel'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='marketing_channel'))
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");

		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
			 SELECT
			 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='marketing_channels'),
			 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='marketing_channel'),
			 	`id`, 0, 1
			 FROM `".TABLE_PREFIX."object_types`
			 WHERE  `type` IN ('content_object', 'comment', 'located')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");

		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_member_associations` (`dimension_id`,`object_type_id`,`associated_dimension_id`, `associated_object_type_id`, `is_required`,`is_multiple`, `keeps_record`) VALUES
			 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'marketing_channels'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'marketing_channel'),0,0,0)
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");
		
		DB::executeAll("
			INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`) VALUES
			 ('listing preferences', 'lp_dim_marketing_channels_show_as_column', '1', 'BoolConfigHandler', 0, 0)
			ON DUPLICATE KEY UPDATE name=name;
		");

		if (checkTableExists(TABLE_PREFIX.'member_custom_properties')) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
					SELECT mt.id, 'Color', 'color_special','color','','','',0,0,0,30,1, 1, 0
					FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('marketing_channel')
				ON DUPLICATE KEY UPDATE `code`=`code`;
			");

			DB::execute("
				INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				  SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,0,31,1, 1, 0
				  FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('marketing_channel')
				ON DUPLICATE KEY UPDATE `code`=`code`;
			");
		}
	}
}

function crpm_types_update_13_14() {
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_associations_config` (`association_id`, `config_name`, `value`)
			SELECT id, 'dont_filter_associated_selector', '1' FROM ".TABLE_PREFIX."dimension_member_associations WHERE 
				dimension_id=(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project') AND object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'customer') AND 
				associated_dimension_id=(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'marketing_channels') AND associated_object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'marketing_channel')
		ON DUPLICATE KEY UPDATE `value`=1;
	");
}



function crpm_types_update_14_15() {
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_hierarchies` (`dimension_id`, `parent_object_type_id`, `child_object_type_id`) VALUES
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='project_types'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='project_type'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='project_type')),
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='project_statuses'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='project_status'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='project_status')),
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='project_managers'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='project_manager'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='project_manager')),
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='account_executives'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='account_executive'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='account_executive'))
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
}


function crpm_types_update_15_16() {
	$pm_dim = Dimensions::findByCode('project_phases');
	if (!$pm_dim instanceof Dimension) {
		// new dimension Project managers
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimensions` (`code`,`name`,`is_root`,`is_manageable`,`allows_multiple_selection`,`defines_permissions`,`default_order`, `is_default`, `options`, `permission_query_method`) VALUES
			('project_phases','Project phases',1,1,0,0,15,0,'{\"defaultAjax\":{\"controller\":\"dashboard\",\"action\":\"main_dashboard\"},\"useLangs\":true,\"quickAdd\":true,\"showInPaths\":true}', 'not_mandatory' );
		");

		DB::execute("
			INSERT INTO ".TABLE_PREFIX."dimension_options (`dimension_id`, `name`, `value`) VALUES
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='project_phases'),'useLangs','1'),
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='project_phases'),'showInPaths','1')
			ON DUPLICATE KEY UPDATE `value`=`value`;
		");

		DB::execute("
			INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
			 ('project_phase', '', '', 'dimension_group', 'project_phase', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='crpm_types'), 0)
			ON DUPLICATE KEY UPDATE id=id;
		");

		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_types` (`dimension_id`,`object_type_id`,`is_root`,`options`) VALUES
			 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'project_phases'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'project_phase'), 1, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");

		DB::executeAll("
			INSERT INTO `".TABLE_PREFIX."dimension_object_type_hierarchies` (`dimension_id`, `parent_object_type_id`, `child_object_type_id`) VALUES
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='project_phases'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='project_phase'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='project_phase'))
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");

		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
			 SELECT
			 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='project_phases'),
			 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='project_phase'),
			 	`id`, 0, 1
			 FROM `".TABLE_PREFIX."object_types`
			 WHERE  `type` IN ('content_object', 'comment', 'located')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");

		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_member_associations` (`dimension_id`,`object_type_id`,`associated_dimension_id`, `associated_object_type_id`, `is_required`,`is_multiple`, `keeps_record`) VALUES
			 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'project'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'project_phases'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'project_phase'),0,0,0)
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");

		DB::executeAll("
			INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`) VALUES
			 ('listing preferences', 'lp_dim_project_phases_show_as_column', '1', 'BoolConfigHandler', 0, 0)
			ON DUPLICATE KEY UPDATE name=name;
		");

		if (checkTableExists(TABLE_PREFIX.'member_custom_properties')) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
					SELECT mt.id, 'Color', 'color_special','color','','','',0,0,0,30,1, 1, 0
					FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('project_phase')
				ON DUPLICATE KEY UPDATE `code`=`code`;
			");

			DB::execute("
				INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				  SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,0,31,1, 1, 0
				  FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('project_phase')
				ON DUPLICATE KEY UPDATE `code`=`code`;
			");
		}
		
		if (checkTableExists(TABLE_PREFIX.'dimension_content_object_options')) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."dimension_content_object_options` (`dimension_id`,`content_object_type_id`,`option`,`value`)
					SELECT d.id, ot.id, 'hide_member_selector_in_forms', '1'
					FROM ".TABLE_PREFIX."dimensions d LEFT JOIN ".TABLE_PREFIX."object_types ot ON true
					WHERE d.code='project_phases' AND ot.type IN ('content_object', 'located', 'comment')
				ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
			");
		}
	}
}



function crpm_types_update_16_17() {
	DB::execute("
		UPDATE `".TABLE_PREFIX."dimension_member_associations` SET allows_default_selection=1
		WHERE
			dimension_id = (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='customer_project')
			AND object_type_id in (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name in ('project'));
	");
}

function crpm_types_update_17_18() {
	$pm_dim = Dimensions::findByCode('job_phases');
	if (!$pm_dim instanceof Dimension) {
		// New dimension "Job phases"
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimensions` (`code`,`name`,`is_root`,`is_manageable`,`allows_multiple_selection`,`defines_permissions`,`default_order`, `is_default`, `options`, `permission_query_method`) VALUES
			('job_phases','Job phases',1,1,0,0,15,0,'{\"defaultAjax\":{\"controller\":\"dashboard\",\"action\":\"main_dashboard\"},\"useLangs\":true,\"quickAdd\":true,\"showInPaths\":true}', 'not_mandatory' );
		");

		DB::execute("
			INSERT INTO ".TABLE_PREFIX."dimension_options (`dimension_id`, `name`, `value`) VALUES
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='job_phases'),'useLangs','1'),
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='job_phases'),'showInPaths','1')
			ON DUPLICATE KEY UPDATE `value`=`value`;
		");

		DB::execute("
			INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
			 ('job_phase', '', '', 'dimension_group', 'job_phase', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='crpm_types'), 0)
			ON DUPLICATE KEY UPDATE id=id;
		");

		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_types` (`dimension_id`,`object_type_id`,`is_root`,`options`) VALUES
			 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'job_phases'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'job_phase'), 1, '{\"defaultAjax\":{\"controller\":\"dashboard\", \"action\": \"main_dashboard\"}}')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");

		DB::executeAll("
			INSERT INTO `".TABLE_PREFIX."dimension_object_type_hierarchies` (`dimension_id`, `parent_object_type_id`, `child_object_type_id`) VALUES
			 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='job_phases'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='job_phase'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='job_phase'))
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");

		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
			 SELECT
			 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='job_phases'),
			 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='job_phase'),
			 	`id`, 0, 0
			 FROM `".TABLE_PREFIX."object_types`
			 WHERE  `type` IN ('content_object', 'comment', 'located')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");


		DB::executeAll("
			INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`) VALUES
			 ('listing preferences', 'lp_dim_job_phases_show_as_column', '1', 'BoolConfigHandler', 0, 0)
			ON DUPLICATE KEY UPDATE name=name;
		");

		if (checkTableExists(TABLE_PREFIX.'member_custom_properties')) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
					SELECT mt.id, 'Color', 'color_special','color','','','',0,0,0,30,1, 1, 0
					FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('job_phase')
				ON DUPLICATE KEY UPDATE `code`=`code`;
			");

			DB::execute("
				INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				  SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,0,31,1, 1, 0
				  FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('job_phase')
				ON DUPLICATE KEY UPDATE `code`=`code`;
			");
		}
		
		if (checkTableExists(TABLE_PREFIX.'dimension_content_object_options')) {
			DB::execute("
				INSERT INTO `".TABLE_PREFIX."dimension_content_object_options` (`dimension_id`,`content_object_type_id`,`option`,`value`)
					SELECT d.id, ot.id, 'hide_member_selector_in_forms', '1'
					FROM ".TABLE_PREFIX."dimensions d LEFT JOIN ".TABLE_PREFIX."object_types ot ON true
					WHERE d.code='job_phases' AND ot.type IN ('content_object', 'located', 'comment')
				ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
			");
		}

		if (Plugins::instance()->isActivePlugin('advanced_core')) {
			Env::useHelper('functions', 'advanced_core');
			fill_property_groups_default_data();
		}
	}
	
}


function crpm_types_update_18_19() {
	
	// add the acronym cp for project managers
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."member_custom_properties (object_type_id, name, code, `type`,`is_special`) VALUES
		((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project_manager'), 'Acronym', 'acronym', 'text', 1)
		ON DUPLICATE KEY UPDATE `code`=`code`;
	");
		
	// set project managers name as acronym - name
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."dimension_object_type_options (dimension_id, object_type_id, `name`, `value`) VALUES
		(	(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='project_managers'),
			(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project_manager'),
			'text_to_show_in_trees',
			CONCAT('{\"properties\":[\"cp_',(SELECT id FROM ".TABLE_PREFIX."member_custom_properties WHERE `code`='acronym'),'\",\"name\"], \"separator\":\"-\"}')
		);
	");
	
	if (Plugins::instance()->isActivePlugin('advanced_core')) {
		Env::useHelper('functions', 'advanced_core');
		fill_property_groups_default_data();
	}
}