<?php
Hook::register('custom_login');

function custom_login_overwrite_login_css($ignored, &$css) {
	if (!is_array($css)) $css = array();
	if (file_exists(ROOT . "/custom_login.css")) {
		$css[] = ROOT_URL.'/custom_login.css';
	}
}

function custom_login_change_favicon($ignored, &$ico_name) {
	if (file_exists(ROOT . "/custom_favicon.ico")) {
		$ico_name = 'custom_favicon.ico';
	}
}

function custom_login_change_loading_img($ignored, &$url) {
	if (file_exists(ROOT . "/custom_loading.gif")) {
		$url = with_slash(ROOT_URL) . 'custom_loading.gif';
	}
}

function custom_login_render_userbox_crumbs($ignored, &$crumbs) {
	if (defined('REMOVE_HELP') && REMOVE_HELP) {
		$new_crumbs = array();
		foreach ($crumbs as $crumb) {
			$parsed = parse_url($crumb['url']);
			if (!str_starts_with($parsed['query'], 'c=help')) {
				$new_crumbs[] = $crumb;
			}
		}
		$crumbs = $new_crumbs;
	}
}

function custom_login_login_form_before_inputs() {
	if (file_exists(ROOT . "/before_login_inputs_html.php")) {
		include_once ROOT . "/before_login_inputs_html.php";
	}
}

function custom_login_login_form_after_inputs() {
	if (file_exists(ROOT . "/after_login_inputs_html.php")) {
		include_once ROOT . "/after_login_inputs_html.php";
	}
}

function custom_login_login_form_before_form() {
	if (file_exists(ROOT . "/before_login_form_html.php")) {
		include_once ROOT . "/before_login_form_html.php";
	}
}

function custom_login_login_form_after_form() {
	if (file_exists(ROOT . "/after_login_form_html.php")) {
		include_once ROOT . "/after_login_form_html.php";
	}
}

function custom_login_login_page_title($ignored, &$page_title) {
	$oc = owner_company();
	if ($oc instanceof Contact) {
		$page_title = $oc->getObjectName();
	}
}

function echo_custom_logo_url() {
	if (file_exists(ROOT . "/custom_logo.png")) {
		echo '<img alt="logo" src="custom_logo.png" class="custom-logo"/>';
	} else {
		echo '<a class="logo" href="'.clean(PRODUCT_URL).'"></a>';
	}
}

function get_custom_logo_url() {
	$logo_data = array();
	if (file_exists(ROOT . "/custom_logo.png")) {
		$logo_data['src'] = "custom_logo.png";
		$logo_data['class'] = "custom-logo";
	}
	return $logo_data;
}
