<?php
	class EventTicketType extends BaseEventTicketType {
		
		
		function getArrayInfo($raw_data = false) {
			$info = array();
			
			$columns = self::getColumns();
			foreach ($columns as $col) {
				$info[$col] = $this->getColumnValue($col);
				if ($info[$col] instanceof DateTimeValue) {
					if ($raw_data) {
						$info[$col] = format_date($info[$col], DATE_MYSQL, 0);
					} else {
						$info[$col] = format_date($info[$col], null, 0);
					}
				}
			}
			
			$info["description"] = str_replace("\n", " ", $info["description"]);
			
			if ($info["currency_id"] > 0) {
				$c = Currencies::getCurrency($info["currency_id"]);
				$info["currency_sym"] = $c instanceof Currency ? $c->getSymbol() : "";
			} else {
				$info["currency_sym"] = "";
			}

            $o_tt = ObjectTypes::findByName('event_ticket');
			if ($o_tt instanceof ObjectType){
                $info["ot_id"] = $o_tt->getId();
            }

            if (Plugins::instance()->isActivePlugin('object_subtypes')) {
			    $id = ObjectSubtypesController::get_object_subtype_dependence($info['event_id']);
                $info["object_subtype_id"] = $id;
            }
			
			return $info;
		}
		
		
	}