<?php
$genid = gen_id();


// the forms will be called using ajax
$tickets_on_submit = "return false;";
$attendees_on_submit = "return false;";

// form action urls
$tickets_form_action = get_url('event_ticket', 'submit_multiple_event_tickets');
$tickets_type_form_action = get_url('event_ticket', 'get_ticket_types');
$attendees_form_action = get_url('event_attendee', 'submit_multiple_attendees');


$dimension = Dimensions::findByCode('customer_project');
?>


<div class="coInputHeader"></div>

<div class="coInputMainBlock feng-bootstrap">


    <div class="row col-md-12">
        <form class="" id="<?php echo $genid ?>submit-tickets-form"
              onsubmit="<?php echo $tickets_on_submit ?>"
              onticketstypes="<?php echo $tickets_type_form_action ?>"
              action="<?php echo $tickets_form_action ?>" method="post" enctype="multipart/form-data">

            <input id="event_member_id" type="hidden" name="tickets[event_member_id]" value="<?php echo $event_member->getId() ?>">

            <div id="step1">

                <h2><?php echo lang('registration_request_information') ?></h2>
                <div class="col-md-12 ">
                    <div id="step2_error" class="alert alert-danger" style="display: none;">
                        <strong>Error!</strong> <span id="step2_error_message"></span>
                    </div>
                    <div class="row row-padding-bottom">
                        <div class="col-md-12">
                            <label for="inputTransactionId"><?php echo lang('members') ?></label>
                            <?php render_single_member_selector($dimension, $genid, null, array(
                                'hf_name' => 'event_company_selected', 'hide_label' => true, 'is_multiple' => false,'is_bootstrap'=>true,
                                'listeners' => array(
                                    'on_selection_change' => "og.event_tickets.reDrawContactSelector();",
                                    'on_remove_relation' => "og.event_tickets.reDrawContactSelector();",
                                )
                            )); ?>
                        </div>
                    </div>
                    <div class="row row-padding-bottom">
                        <div class="col-md-12">
                            <label for="inputTransactionId"><?php echo lang('requested_by') ?></label>
                            <div id="<?php echo $genid; ?>new_event_registration"></div>
                        </div>
                    </div>
                </div>
                <button type="button" class="btn btn-primary pull-right mt-3"
                        onclick="og.event_tickets.getStepClasses2('<?php echo $genid ?>');"><?php echo lang('next') ?></button>
            </div>

            <div id="step2" style="display: none;">
                <h2><?php echo lang('select_students_to_register') ?></h2>
                <div class="col-md-12 row">
                    <div class="add-event-ticket" id="<?php echo $genid ?>submit-attendees-form"
                          onsubmit="<?php echo $attendees_on_submit ?>" style="min-width: 0px;"
                          action="<?php echo $attendees_form_action ?>" method="post" enctype="multipart/form-data">

                        <input type="hidden" name="attendees[event_member_id]" value="<?php echo $event_member->getId() ?>">
                        <input type="hidden" name="attendees[customer_member_id]" id="attendees_customer_member_id" value="" >

                        <div id="attendee_form">

                        </div>
                        <div class="col-md-12 row clearfix">
                            <button id="more-tickets" type="button" class="btn btn-sm btn-primary"
                                    onclick="og.event_tickets.addMoreTicketType()"><?php echo lang('add_another_student') ?></button>
                        </div>
                    </div>
                </div>
                <button type="button" class="btn btn-primary mt-3"
                        onclick="og.event_tickets.goStep1()">
                    <?php echo lang('back') ?>
                </button>
                <button type="button" class="btn btn-primary pull-right mt-3"
                        onclick="og.event_tickets.goStepClasses3();">
                    <?php echo lang('next') ?>
                </button>
            </div>


            <div id="step3" style="display: none;">
                <h2><?php echo lang('billing_information_and_payment') ?></h2>
                <div class="col-md-12">

                    <div class="row row-padding-bottom">
                        <label for="total_event_payment"><?php echo lang('sold quantity') ?></label>
                        <input type="text" class="form-control" data-money-symbol="<?php echo $c_sym ?>"
                               id="total_event_payment" readonly value="<?php echo $c_sym ?>0">
                    </div>

                    <div class="row row-padding-bottom">

                        <?php
                        $customProp = CustomProperties::getCustomPropertyByCode(IncomeInvoices::instance()->getObjectTypeId(),'payment_method');
                        $config = array();
                        $config['name'] = 'tickets[payment_method]';
                        $config['label'] = $customProp->getName();
                        $config['is_bootstrap'] = true;
                        $html = render_custom_property_by_type($customProp, $config);
                        echo $html;
                        ?>
                    </div>

                    <div class="row row-padding-bottom" id="inputTransactionIdContainer">

                        <?php
                        $customProp = CustomProperties::getCustomPropertyByCode(IncomeInvoices::instance()->getObjectTypeId(),'external_transaction_id');
                        $config = array();
                        $config['name'] = 'tickets[external_transaction_id]';
                        $config['label'] = $customProp->getName();
                        $config['is_bootstrap'] = true;
                        $html = render_custom_property_by_type($customProp, $config);
                        echo $html;

                        ?>
                    </div>

                    <div class="row row-padding-bottom">

                        <?php
                        $customProp = CustomProperties::getCustomPropertyByCode(IncomeInvoices::instance()->getObjectTypeId(),'external_transaction_desc');
                        $config = array();
                        $config['name'] = 'tickets[external_transaction_desc]';
                        $config['label'] = $customProp->getName();
                        $config['is_bootstrap'] = true;
                        $html = render_custom_property_by_type($customProp, $config);
                        echo $html;
                        ?>

                    </div>


                </div>

                <button type="button" class="btn btn-primary pull-right mt-3"
                        onclick="og.event_tickets.getAvailableBillToForClasses();"><?php echo lang('finish_registration') ?></button>
            </div>

            <div id="step4" style="display: none;">
                <div class="col-md-12">
                    <div id="step3_error" class="alert alert-danger " style="display: none;">
                        <strong>Error!</strong> <span id="step3_error_message"></span>
                    </div>
                    <div class="row">
                        <h2 for="billto"><?php echo lang('review billing information') ?></h2>
                    </div>
                    <div id="list_of_bill_to" class="row">

                    </div>

                </div>

                <button type="button" class="btn btn-primary pull-right mt-3"
                        onclick="og.event_tickets.submit_multiple_event_tickets_for_classes('<?php echo $genid ?>',true)"><?php echo lang('invoice_and_email') ?></button>
                <button type="button" class="btn btn-primary pull-right mt-3" style="margin-right: 15px;"
                        onclick="og.event_tickets.submit_multiple_event_tickets_for_classes('<?php echo $genid ?>',false)"><?php echo lang('invoice_only') ?></button>
            </div>


        </form>
    </div>
</div>

<script type="text/javascript">
    og.event_tickets.customer_member_id = 0;
    og.event_tickets.member_id = '<?php echo $event_member->getId() ?>';
    og.event_tickets.event_ticket_available = '<?php echo $event_ticket_available ?>';

    var gen_new_event_ticket_registration = '<?php echo $genid; ?>';
    url_available_bill_to = '<?php echo get_url('invoice', 'get_available_bill_to_for_invoice');?>';
    contacts_billing_to_information = null;
    og.bootstrap_helper.renderContactCombo({
        genid: gen_new_event_ticket_registration,
        id: gen_new_event_ticket_registration + 'new_event_registration',
        name: 'tickets[requested_by][contact_id]',
        render_to: "new_event_registration",
        listWidth: 380,
        width: 380,
        selected: '',
        selected_name: '',
        cp_type:'contact',
        empty_text: lang('select contact'),
        filters: {is_user: 0,member_ids:og.event_tickets.member_id},
        memberId:og.event_tickets.member_id
    });
</script>

<script id="billto_row" type="text/x-handlebars-template">
    <div class="col-md-4">
        <h5>{{customer_name}}</h5>
        <div class="input-group input-group-sm mb-3">
            <div class="input-group-prepend">
                <span class="input-group-text" id="inputGroup-sizing-sm"><?php echo lang("address") ?></span>
            </div>
            <input type="text" class="form-control" aria-label="Small" id="customer_address_{{customer_id}}"
                   aria-describedby="inputGroup-sizing-sm" readonly value="{{customer_address}}">
        </div>

        <div class="input-group input-group-sm mb-3">
            <div class="input-group-prepend">
                <span class="input-group-text" id="inputGroup-sizing-sm"><?php echo lang("city") ?></span>
            </div>
            <input type="text" class="form-control" aria-label="Small" id="customer_city_{{customer_id}}"
                   aria-describedby="inputGroup-sizing-sm" readonly value="{{customer_city}}">
        </div>

        <div class="input-group input-group-sm mb-3">
            <div class="input-group-prepend">
                <span class="input-group-text" id="inputGroup-sizing-sm"><?php echo lang("state") ?></span>
            </div>
            <input type="text" class="form-control" aria-label="Small" id="customer_state_{{customer_id}}"
                   aria-describedby="inputGroup-sizing-sm" readonly value="{{customer_state}}">
        </div>

        <div class="input-group input-group-sm mb-3">
            <div class="input-group-prepend">
                <span class="input-group-text" id="inputGroup-sizing-sm"><?php echo lang("country") ?></span>
            </div>
            <input type="text" class="form-control" aria-label="Small" id="customer_country_{{customer_id}}"
                   aria-describedby="inputGroup-sizing-sm" readonly value="{{customer_country}}">
        </div>

        <div class="input-group input-group-sm mb-3">
            <div class="input-group-prepend">
                <span class="input-group-text" id="inputGroup-sizing-sm"><?php echo lang("zipcode") ?></span>
            </div>
            <input type="text" class="form-control" aria-label="Small" id="customer_zipcode_{{customer_id}}"
                   aria-describedby="inputGroup-sizing-sm" readonly value="{{customer_zipcode}}">
        </div>

        <div class="input-group input-group-sm mb-3">
            <div class="input-group-prepend">
                <span class="input-group-text" id="inputGroup-sizing-sm"><?php echo lang("email") ?></span>
            </div>
            <input type="text" class="form-control" aria-label="Small" id="customer_email_{{customer_id}}"
                   aria-describedby="inputGroup-sizing-sm" readonly value="{{customer_email}}">
        </div>

        <div class="input-group input-group-sm mb-3">
            <div class="input-group-prepend">
                <span class="input-group-text" id="inputGroup-sizing-sm"><?php echo lang("phone") ?></span>
            </div>
            <input type="text" class="form-control" aria-label="Small" id="customer_phone_{{customer_id}}"
                   aria-describedby="inputGroup-sizing-sm" readonly value="{{customer_phone}}">
        </div>

        <input type="radio" name="billto" value="{{customer_id}}">
    </div>
</script>

<script id="attendee_row" type="text/x-handlebars-template">
    {{#each ticket_type}}
    <div class="clearfix container-attendees" style="display: none;">
        <h3 class="">Ticket: {{ticket_name}}</h3>
        {{#each ticket}}
        <input type="hidden" class="ticket_type_id" name="tickets[types][{{ticket_type_id}}][quantity]" value="1">
        <div class="col-md-12 clearfix">
            <div class="row pb-3">
                {{!-- {{If this structure is changed you have to check the function submit_multiple_attendees}} --}}
                <input type="hidden" id="ticket_type_amount" value="{{amount}}">
                {{#each attendees}}
                <div class="row col-md-12 pt-3">

                    <div id="{{ticket_num}}_{{count}}_new_attendee_registration" class="col-md-12 row">
                    </div>
                    <input type="hidden" name="attendees[{{ticket_num}}][{{count}}][event_ticket_id]" value="{{ticket_id}}">

                </div>

                <div class="dropdown-divider"></div>
                {{/each}}
                <div id="cp_container_{{ticket_num}}" class="col-md-12 row">

                </div>
            </div>

        </div>
        {{/each}}
    </div>
    {{/each}}
</script>
