
INSERT INTO <?php echo $table_prefix ?>member_custom_properties (object_type_id, name, code, `type`, `is_special`, `property_order`, `visible_by_default`) VALUES
	((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='managed_event'), 'Max capacity', 'max_capacity', 'numeric', 1, 11, 1),
	((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='managed_event'), 'Available from', 'available_from', 'date', 1, 12, 1),
	((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='managed_event'), 'Available to', 'available_to', 'date', 1, 13, 1),
    ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='managed_event'), 'Tickets quantity', 'event_ticket_quantity', 'text', 1, 14, 1);

INSERT INTO <?php echo $table_prefix ?>widgets (name,title,plugin_id,path,default_options,default_section,default_order,icon_cls) VALUES
("event_ticket_types","ticket types",(SELECT id FROM <?php echo $table_prefix ?>plugins WHERE name='event_tickets'),"","","right",2,"ico-ticket"),
("event_tickets","event tickets",(SELECT id FROM <?php echo $table_prefix ?>plugins WHERE name='event_tickets'),"","","left",2,"ico-ticket");


-- add the event_ticket type
INSERT INTO `<?php echo $table_prefix ?>object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
 ('event_ticket', 'EventTickets', 'event_tickets', 'content_object', 'event_ticket', (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='event_tickets'), 0),
 ('event_attendee', 'EventAttendees', 'event_attendee', 'content_object', 'event_attendee', (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='event_tickets'), 0)
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
	SELECT dot.dimension_id, dot.dimension_object_type_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='event_ticket'), dot.is_required, dot.is_multiple
	FROM <?php echo $table_prefix ?>dimension_object_type_contents dot
	WHERE dot.content_object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>dimension_object_type_contents.dimension_id=<?php echo $table_prefix ?>dimension_object_type_contents.dimension_id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
	SELECT dot.dimension_id, dot.dimension_object_type_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='event_attendee'), dot.is_required, dot.is_multiple
	FROM <?php echo $table_prefix ?>dimension_object_type_contents dot
	WHERE dot.content_object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>dimension_object_type_contents.dimension_id=<?php echo $table_prefix ?>dimension_object_type_contents.dimension_id;

-- permissions for roles
INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('event_ticket', 'event_attendee')
	 AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 0, 0
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('event_ticket', 'event_attendee')
	 AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');

INSERT INTO <?php echo $table_prefix ?>role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('event_ticket', 'event_attendee')
	AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');


-- tab panel
INSERT INTO `<?php echo $table_prefix ?>tab_panels` (`id`,`title`,`icon_cls`,`refresh_on_context_change`,`default_controller`,`default_action`,`initial_controller`,`initial_action`,`enabled`,`type`,`ordering`,`plugin_id`,`object_type_id`) VALUES 
 ('event-tickets-panel', 'attendees', 'ico-event-tickets', 1, 'event_ticket', 'init', '', '', 1, 'system', 11, (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='event_tickets'), (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='event_ticket')) 
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO `<?php echo $table_prefix ?>tab_panel_permissions` (`permission_group_id`, `tab_panel_id`)
 SELECT `c`.`permission_group_id`, 'event-tickets-panel'
 FROM `<?php echo $table_prefix ?>contacts` `c` WHERE `c`.`user_type` IN (
 	SELECT `id` FROM `<?php echo $table_prefix ?>permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator','Manager','Executive')
 )
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;


-- add permissions to users where the users already have permissions (copy permissions from tasks)
INSERT INTO <?php echo $table_prefix ?>contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
 SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='event_ticket'), cmp.can_delete, cmp.can_write 
 FROM <?php echo $table_prefix ?>contact_member_permissions cmp
 WHERE cmp.object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>contact_member_permissions.member_id=<?php echo $table_prefix ?>contact_member_permissions.member_id;

-- add permissions to users where the users already have permissions (copy permissions from tasks)
INSERT INTO <?php echo $table_prefix ?>contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
 SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='event_attendee'), cmp.can_delete, cmp.can_write 
 FROM <?php echo $table_prefix ?>contact_member_permissions cmp
 WHERE cmp.object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>contact_member_permissions.member_id=<?php echo $table_prefix ?>contact_member_permissions.member_id;



INSERT INTO `<?php echo $table_prefix ?>config_categories` (`name`, `is_system`, `category_order`) VALUES
('event_tickets', 0, 6)
ON DUPLICATE KEY UPDATE `name`=`name`;

INSERT INTO <?php echo $table_prefix ?>config_options (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
 ('event_tickets', 'use_ticket_type_member_pricing', '0', 'BoolConfigHandler', 0, 1, '', ''),
 ('event_tickets', 'create_member_in_web_registration', '0', 'BoolConfigHandler', 0, 1, '', ''),
 ('event_tickets', 'use_classes_workflow', '0', 'BoolConfigHandler', '0', '0','',''),
 ('event_tickets', 'web_classes_stage_member', '0', 'MemberConfigHandler', '0', '0', '', CONCAT('{"dim_id":',(SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code='customer_stages'),'}')),
 ('event_tickets', 'compare_member_active_with', '0', 'MemberConfigHandler', '0', '0', '', CONCAT('{"dim_id":',(SELECT id FROM <?php echo $table_prefix ?>dimensions WHERE code='customer_stages'),'}')),
 ('event_tickets', 'group_invoice_lines_by_event', '0', 'BoolConfigHandler', '0', '0', '', '')
ON DUPLICATE KEY UPDATE `name`=`name`;


INSERT INTO <?php echo $table_prefix ?>custom_properties (object_type_id, name, code, `type`,`is_special`,`description`) VALUES
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='customer'), 'Member code', 'member_code', 'text', 1, 'This code will be used by the member to identify themselves on the Website, to get member pricing. Use the first 5 or 6 letters of the member name, a dash, a random number of 5 digits, a dash, and the month and day you are creating the code. Example: CMCPL-87412-0414');

INSERT INTO <?php echo $table_prefix ?>property_group_properties (group_id, property_id, `order`)
	SELECT pg.id, cp.id, cp.property_order
	FROM <?php echo $table_prefix ?>property_groups pg
	LEFT JOIN <?php echo $table_prefix ?>custom_properties cp ON cp.object_type_id=pg.object_type_id
	WHERE pg.name='Billing Information' AND pg.object_type_id=cp.object_type_id AND cp.code='member_code'
ON DUPLICATE KEY UPDATE group_id=group_id;


INSERT INTO <?php echo $table_prefix ?>custom_properties (object_type_id, name, code, `type`,`is_special`,`description`) VALUES
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='contact'), 'License type', 'license_type_code', 'text', 1, '');

INSERT INTO <?php echo $table_prefix ?>custom_properties (object_type_id, name, code, `type`,`is_special`,`description`) VALUES
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='contact'), 'License number', 'license_number_code', 'text', 1, '');

INSERT INTO <?php echo $table_prefix ?>custom_properties (object_type_id, name, code, `type`,`is_special`,`description`) VALUES
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='event_attendee'), 'Signature', 'signature_code', 'text', 1, '');

INSERT INTO <?php echo $table_prefix ?>custom_properties (object_type_id, name, code, `type`,`is_special`,`visible_by_default`,`description`) VALUES
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='event_attendee'), 'Attended', 'attended_code', 'text', 1,1, '');

-- asociate event tickets as a dependant type of managed events
INSERT INTO <?php echo $table_prefix ?>object_type_dependencies (object_type_id, dependant_object_type_id) VALUES
	((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE `name`='managed_event'),
	(SELECT id FROM <?php echo $table_prefix ?>object_types WHERE `name`='event_ticket'))
ON DUPLICATE KEY UPDATE object_type_id=object_type_id;

INSERT INTO `<?php echo $table_prefix ?>objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`) VALUES
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='report'), 'Event Roster', NOW(), 0, NOW(), 0, 0, 0);

INSERT INTO `<?php echo $table_prefix ?>reports` (`object_id`, `description`, `report_object_type_id`, `is_order_by_asc`, `ignore_context`, `is_default`, `code`, `function_url`) VALUES
((SELECT max(id) FROM <?php echo $table_prefix ?>objects WHERE object_type_id=(SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='report')), '', (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='event'), 1, 1, 1, 'events_report', '?c=event_ticket&a=tickets_attendee_report_params');
