<?php 

function event_tickets_update_1_2() {
	if (!check_column_exists(TABLE_PREFIX."event_ticket_types", "member_pricing")) {
		DB::executeAll("
			ALTER TABLE `".TABLE_PREFIX."event_ticket_types`
			ADD `member_pricing` tinyint(1) unsigned NOT NULL DEFAULT '0'
		");
	}
	
	$category_exists = ConfigCategories::instance()->findOne(array("conditions" => "name='event_ticket_types'"));
	if (!$category_exists instanceof ConfigCategory) {
		DB::executeAll("
			INSERT INTO `".TABLE_PREFIX."config_categories` (`name`, `is_system`, `category_order`) VALUES
			('event_tickets', 0, 6)
			ON DUPLICATE KEY UPDATE `name`=`name`;
		");
	}
	
	$config_option_exists = ConfigOptions::getByName("use_ticket_type_member_pricing");
	if (!$config_option_exists instanceof ConfigOption) {
		DB::executeAll("
			INSERT INTO ".TABLE_PREFIX."config_options (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			 ('event_tickets', 'use_ticket_type_member_pricing', '0', 'BoolConfigHandler', 0, 1, '')
			ON DUPLICATE KEY UPDATE `name`=`name`;
		");
	}
	
	// member code cp
	$ot = ObjectTypes::findByName('customer');
	$cp = CustomProperties::getCustomPropertyByCode($ot->getId(), "member_code");
	if (!$cp instanceof CustomProperty) {
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."custom_properties (object_type_id, name, code, `type`,`is_special`,`description`) VALUES
			((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer'), 'Member code', 'member_code', 'text', 1, 'This code will be used by the member to identify themselves on the Website, to get member pricing. Use the first 5 or 6 letters of the member name, a dash, a random number of 5 digits, a dash, and the month and day you are creating the code. Example: CMCPL-87412-0414');
		");
		
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."property_group_properties (group_id, property_id, `order`)
				SELECT pg.id, cp.id, cp.property_order
				FROM ".TABLE_PREFIX."property_groups pg
				LEFT JOIN ".TABLE_PREFIX."custom_properties cp ON cp.object_type_id=pg.object_type_id
				WHERE pg.name='Billing Information' AND pg.object_type_id=cp.object_type_id AND cp.code='member_code'
			ON DUPLICATE KEY UPDATE group_id=group_id;
		");
	}
}

function event_tickets_update_2_3() {

    $ot = ObjectTypes::findByName('contact');
    $cp = CustomProperties::getCustomPropertyByCode($ot->getId(), "license_type_code");
    if (!$cp instanceof CustomProperty) {
        DB::execute("
			INSERT INTO ".TABLE_PREFIX."custom_properties (object_type_id, name, code, `type`,`is_special`,`description`) VALUES
			((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='contact'), 'License type', 'license_type_code', 'text', 1, '');
		");
    }
    $cp = CustomProperties::getCustomPropertyByCode($ot->getId(), "license_number_code");
    if (!$cp instanceof CustomProperty) {
        DB::execute("
			INSERT INTO ".TABLE_PREFIX."custom_properties (object_type_id, name, code, `type`,`is_special`,`description`) VALUES
			((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='contact'), 'License number', 'license_number_code', 'text', 1, '');
		");

    }

    $ot2 = ObjectTypes::findByName('event_attendee');
    $cp = CustomProperties::getCustomPropertyByCode($ot2->getId(), "signature_code");
    if (!$cp instanceof CustomProperty) {
        DB::execute("
			INSERT INTO ".TABLE_PREFIX."custom_properties (object_type_id, name, code, `type`,`is_special`,`description`) VALUES
			((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='event_attendee'), 'Signature', 'signature_code', 'text', 1, '');
		");

    }
    $cp = CustomProperties::getCustomPropertyByCode($ot2->getId(), "attended_code");
    if (!$cp instanceof CustomProperty) {
        DB::execute("
			INSERT INTO ".TABLE_PREFIX."custom_properties (object_type_id, name, code, `type`,`is_special`,`description`) VALUES
			((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='event_attendee'), 'Attended', 'attended_code', 'text', 1, '');
		");

    }

}



function event_tickets_update_3_4() {
	$config_option_exists = ConfigOptions::getByName("web_classes_stage_member");
	if (!$config_option_exists instanceof ConfigOption) {
		DB::executeAll("
			INSERT INTO ".TABLE_PREFIX."config_options (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
 			('event_tickets', 'create_member_in_web_registration', '0', 'BoolConfigHandler', 0, 1, '', ''),
			('event_tickets', 'web_classes_stage_member', '0', 'MemberConfigHandler', '0', '0', '', CONCAT('{\"dim_id\":',(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='customer_stages'),'}'))
			ON DUPLICATE KEY UPDATE `name`=`name`;
		");
	}
}


function event_tickets_update_4_5() {

	if (Plugins::instance()->isActivePlugin('income') && Plugins::instance()->isActivePlugin('financial_accounts')) {
		$dim = Dimensions::findByCode('financial_accounts');
		if ($dim instanceof Dimension) {
			$dim_id = $dim->getId();
			DB::execute("
				INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
					('event_invoice_account_id', '', 'MemberConfigHandler', 1, '{\"dim_id\":$dim_id}');
					");
		}
	}
}

function event_tickets_update_5_6() {

    $ot = ObjectTypes::findByName('event_attendee');
    $cp = CustomProperties::getCustomPropertyByCode($ot->getId(), "attended_code");
    if ($cp instanceof CustomProperty) {
        DB::execute("
            UPDATE ".TABLE_PREFIX."custom_properties SET `visible_by_default`='1' WHERE `code`='attended_code';
		");
    }
}


function event_tickets_update_6_7() {
    // asociate event tickets as a dependant type of managed events
    DB::execute("
		INSERT INTO ".TABLE_PREFIX."object_type_dependencies (object_type_id, dependant_object_type_id) VALUES
			((SELECT id FROM ".TABLE_PREFIX."object_types WHERE `name`='managed_event'),
			(SELECT id FROM ".TABLE_PREFIX."object_types WHERE `name`='event_ticket'))
		ON DUPLICATE KEY UPDATE object_type_id=object_type_id;
	");
}

function event_tickets_update_7_8()
{
    $config_option_exists = ConfigOptions::getByName("use_classes_workflow");
    if (!$config_option_exists instanceof ConfigOption) {
        DB::execute("
                INSERT INTO `" . TABLE_PREFIX . "config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`) 
                VALUES ('event_tickets', 'use_classes_workflow', '0', 'BoolConfigHandler', '0', '0');
            ");
    }
    $dim = Dimensions::findByCode('customer_stages');
    if ($dim instanceof Dimension) {
        $dim_id = $dim->getId();

        $config_option_exists = ConfigOptions::getByName("compare_member_active_with");
        if (!$config_option_exists instanceof ConfigOption) {
            DB::execute("
                    INSERT INTO `" . TABLE_PREFIX . "config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `options`) VALUES
                        ('event_tickets', 'compare_member_active_with', '0', 'MemberConfigHandler', '0', '0', '{\"dim_id\":$dim_id}');
					");
        }
    }

}

function event_tickets_update_8_9(){

    // member code cp
    $ot = ObjectTypes::findByName('managed_event');
    $cp = CustomProperties::getCustomPropertyByCode($ot->getId(), "event_ticket_quantity");
    if (!$cp instanceof CustomProperty) {

        DB::execute("
			INSERT INTO " . TABLE_PREFIX . "custom_properties (object_type_id, name, code, `type`,`visible_by_default`,`is_special`,`description`) VALUES
			((SELECT id FROM " . TABLE_PREFIX . "object_types WHERE name='managed_event'), 'Tickets quantity', 'event_ticket_quantity', 'text',1, 1, '');
		");

    }


}

function event_tickets_update_9_10() {
	$config_option_exists = ConfigOptions::getByName("group_invoice_lines_by_event");
	if (!$config_option_exists instanceof ConfigOption) {
		DB::executeAll("
			INSERT INTO ".TABLE_PREFIX."config_options (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			 ('event_tickets', 'group_invoice_lines_by_event', '0', 'BoolConfigHandler', 0, 1, '')
			ON DUPLICATE KEY UPDATE `name`=`name`;
		");
	}
}

function event_tickets_update_10_11() {
	DB::execute("
	INSERT INTO `".TABLE_PREFIX."objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`) VALUES
	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report'), 'Event Roster', NOW(), 0, NOW(), 0, 0, 0);
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."reports` (`object_id`, `description`, `report_object_type_id`, `is_order_by_asc`, `ignore_context`, `is_default`, `code`, `function_url`) VALUES
	((SELECT max(id) FROM ".TABLE_PREFIX."objects WHERE object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report')), '', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='event'), 1, 1, 1, 'events_report', '?c=event_ticket&a=tickets_attendee_report_params');
	");
}


function event_tickets_update_11_12() {
	if (!check_column_exists(TABLE_PREFIX."event_ticket_types", "input_required")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."event_ticket_types` ADD `input_required` tinyint(1) unsigned NOT NULL DEFAULT '0';
		");
	}
	if (!check_column_exists(TABLE_PREFIX."event_ticket_types", "comment")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."event_tickets`ADD `comment` varchar(255) COLLATE 'utf8_unicode_ci' NOT NULL;
		");
	}
}

