<?php 
if (!isset($genid)) $genid = gen_id();
?>

<div class="widget-earned-value widget">

	<div class="widget-header" onclick="og.dashExpand('<?php echo $genid?>');">	
		<div class="widget-title">
			<div><?php echo (isset($widget_title)) ? $widget_title : lang("expenses"); ?></div>
			<?php if($include_subtitle){ ?>
				<div class="widget-subtitle"><?php echo $widget_subtitle; ?></div>
			<?php } ?>
		</div>
		<div class="dash-expander ico-dash-expanded" id="<?php echo $genid; ?>expander"></div>
	</div>
	
	<div class="widget-body" id="<?php echo $genid; ?>_widget_body">

		<?php 
		$chart_data_array = array();
		foreach($amounts_by_day as $key => $value){
			$chart_data_array[]=$value;
		}
		$date_format = convertPHPToMomentFormat(user_config_option('date_format'));
		$executedTitle = lang('executed labor');
		$estimatedTitle = lang('estimated labor');
		$currency_symbol = config_option('currency_code', '$');
		$decimals = user_config_option('decimal_digits');
		$decimals_separator = user_config_option('decimals_separator');
		$thousand_separator = user_config_option('thousand_separator');
		?>
		<div id="widget-earned-value__progress-chart"></div>
		<script>	
			/** convert $chart_data_array to json format */
			var chartData = <?php echo json_encode($chart_data_array); ?>;
			/** Prepare data to pass to showExpensesProgressWidget() */
			var dataForComponent = {
						currencySymbol: <?php echo json_encode($currency_symbol) ?>,
						dateFormat: <?php echo json_encode($date_format); ?>,
						executed: <?php echo $last_executed_amount ?>,
						estimated: <?php echo $last_estimated_amount; ?>,
						executedTitle: <?php echo json_encode($executedTitle) ?>,
						estimatedTitle: <?php echo json_encode($estimatedTitle) ?>,
						chartData,
						decimals: <?php echo $decimals; ?>,
						decimalsSeparator: '<?php echo $decimals_separator; ?>',
						thousandSeparator: '<?php echo $thousand_separator; ?>'
					}
			/**
			* Pass data to showExpensesProgressWidget.
			* Returns React component that builds widget with the passed data
			* to the element with id "expenses-progress-chart".
			* It can be found in public/assets/javascript/react_src/showExpensesProgressWidget.js
			* */ 
			showEarnedValueWidget(dataForComponent, document.getElementById('widget-earned-value__progress-chart'));
		</script>

	
		<?php if((count($tasks_without_due_date) > 0) || (count($tasks_without_estimated_time) > 0) || (count($tasks_without_billing_cat) > 0)): ?>
			<div class="widget-earned-value__warnings-container">

				<?php if(count($tasks_without_estimated_time) > 0){?>
					<div>
						<div><?php echo lang('there are tasks with no estimated time earned value widget message', 
											  count($tasks_without_estimated_time), 
											  format_money_amount( $total_amount_tasks_without_estimated_time, $currency_symbol)
											); ?>
						</div> 
						<ul>
							<?php 
							if(count($active_members) > 0 && count($tasks_without_estimated_time) < 5){
								foreach($tasks_without_estimated_time as $task){ ?>
									<li><a href="<?php echo get_url('task','view',array('id'=>$task['id']))?>"><?php echo $task['name'] ?></a></li>
								<?php }
							} ?>
						</ul>
					</div>
				<?php } ?>

				<?php if(count($tasks_without_due_date) > 0){ ?>
					<?php 
					?>
					<div>
						<div><?php echo lang('there are tasks without due date earned value widget message', 
											  count($tasks_without_due_date), 
											  format_money_amount($total_amount_tasks_without_due_date, $currency_symbol)
											); ?>
						</div>
						<ul>
							<?php 
							if(count($active_members) > 0 && count($tasks_without_due_date) < 5){
								foreach($tasks_without_due_date as $task){ ?>
									<li><a href="<?php echo get_url('task','view',array('id'=>$task['id']))?>"><?php echo $task['name'] ?></a></li>
								<?php }
							} ?>
						</ul>
						
					</div>
				<?php } ?>
				
				<?php if(count($tasks_without_billing_cat) > 0){ ?>
					<div>
						<div><?php echo lang('there are tasks without a billing category') ?></div>
						<ul>
							<?php 
							if(count($active_members) > 0 && count($tasks_without_billing_cat) < 5){
								foreach($tasks_without_billing_cat as $task){ ?>
									<li><a href="<?php echo get_url('task','view',array('id'=>$task['id']))?>"><?php echo $task['name'] ?></a></li>
								<?php }
							} ?>
						</ul>
					</div>
				<?php } ?>

			</div>

		<?php endif ?>
	</div>
</div>