<?php 
Env::useHelper('chart');

$crpmDimension = Dimensions::instance()->findByCode('customer_project')->getId();
$project_ot = ObjectTypes::instance()->findByName('project');

$draw = can_manage_dimension_members(logged_user());

$pdot = DimensionObjectTypes::findOne(array('conditions' => 'dimension_id='.$crpmDimension.' AND object_type_id='.$project_ot->getId()));
if (!$pdot instanceof DimensionObjectType || !$pdot->getEnabled()) {
	$draw = false;
}

$context = active_context();
if (is_array($context)) {
	foreach ($context as $selection) {
		if ($selection instanceof Member) {
			if ($selection->getDimensionId() != $crpmDimension) {
				$draw = false;
				break;
			} else {
				if ($selection->getObjectTypeId() == $project_ot->getId()) {
					$draw = false;
				}
				break;
			}
		}
	}
}

if ($draw) {
	
	$widget_title = lang('evx_application_requests widget title');
	
	$render_add = $draw;
	$render_add_templates = false;
	
	if ($render_add) {
		$member_templates = MemberTemplates::findAll(array("conditions" => "object_type_id=".$project_ot->getId(), "order" => "name"));
		if (count($member_templates) > 0) {
			$render_add = false;
			$render_add_templates = true;
		}
	}
	
	if ($total > 0 || $render_add || $render_add_templates) {
		include_once 'template.php';	
	}
}
