<?php /* @var Project $project */
	$genid = gen_id();
	$row_cls = "";
	$no_objects_text = count($projects) > 0 ? '' : lang('you have no projects yet');
	$dim_id = Dimensions::findByCode('customer_project')->getId();
	
	$status_dimension = Dimensions::findByCode("project_statuses");
	$status_ot = ObjectTypes::findByName("project_status");
	$use_project_status_dimension = $status_dimension instanceof Dimension && in_array($status_dimension->getId(), config_option('enabled_dimensions'));
	$pot = ObjectTypes::findByName('project');
	$c_name = Members::getTypeNameToShowByObjectType($dim_id, $pot->getId(), null, true);
	$add_button_text = count($projects) > 0 ? lang('add new project',$c_name) : lang('add your first project',$c_name);

	/* @var $this Widget */
	$widget_header_color = $this->getContactOptionValue('color');
?>

<div class="evx-projects-widget widget">

	<div style="overflow: hidden;" class="widget-header color-<?php echo $widget_header_color?>" onclick="og.dashExpand('<?php echo $genid?>');">
		<div class="widget-title"><?php echo isset($widget_title) ? $widget_title : $c_name; ?></div>
		<div class="dash-expander ico-dash-expanded" id="<?php echo $genid; ?>expander"></div>
	</div>
	
	<div class="widget-body" id="<?php echo $genid; ?>_widget_body" >
	
		<div class="widget-buttons-left" style="float: left;">
					
		<?php if ($render_add) :?>
			<button title="<?php echo $add_button_text ?>" class="add-project-button add-first-btn">
				<img src="public/assets/themes/default/images/16x16/add.png"/>&nbsp;<?php echo $add_button_text ?>
			</button>
			<div class="x-clear"></div>
			<?php if (count($projects) > 0) : ?>
			<div class="separator"></div>
			<?php endif; ?>
		<?php endif;?>
					
		<?php if ($render_add_templates) :?>
			<?php foreach ($member_templates as $member_template) :
					$add_button_text = lang('add new project', $member_template->getName());
					$add_template_click = "og.render_modal_form('', {c:'project', a:'add', params: {type:".$project_ot->getId().", dim_id:".$crpmDimension.", template_id:".$member_template->getId().", object_subtype_id:".$member_template->getObjectSubtypeId()."}});";
			?>
				<button title="<?php echo $add_button_text ?>" class="add-first-btn" onclick="<?php echo $add_template_click?>">
					<img src="public/assets/themes/default/images/16x16/add.png"/>&nbsp;<?php echo $add_button_text ?>
				</button>
				<div class="x-clear"></div>
			<?php endforeach; ?>
			
			<?php if (false && count($projects) > 0) : ?>
			<div class="separator"></div>
			<?php endif; ?>
		<?php endif;?>
	
		</div>
		
		<div class="x-clear"></div>

	</div>
</div>

<script>
	var parent_id = '<?php echo $parent instanceof Member ? $parent->getId() : 0?>';
	$(function(){
		$(".add-project-button").click(function(){
			var url = og.getUrl('project', 'add', {parent: parent_id});
			var container = $(this).closest(".widget-body") ;
			container.closest(".widget-body").addClass("loading");
			og.openLink(url); 
		});

	});
</script>