<?php

include_once dirname(__FILE__)."/../../../application/helpers/plugin_installer_functions.php";

function expense_categories_get_additional_install_queries($db_connection, $table_prefix) {
	
	$queries = array();
	
	$is_installed_mem_custom_props = check_is_installed_plugin($db_connection, $table_prefix, 'member_custom_properties');
	
	if ($is_installed_mem_custom_props) {
	
		$sql = "SELECT count(id) as total FROM ".$table_prefix."member_custom_properties WHERE code='color_special'
				AND object_type_id=(SELECT id FROM ".$table_prefix."object_types WHERE name='expense_category')";
		
		$mysql_res = mysqli_query($db_connection, $sql);
		if ($mysql_res) {
			$rows = mysqli_fetch_assoc($mysql_res);
		
			if (count($rows) > 0 && $rows['total'] == 0) {
				$queries[] = "INSERT INTO `".$table_prefix."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
					SELECT mt.id, 'Color', 'color_special','color','','','',0,0,0,30,1, 1, 0
					FROM ".$table_prefix."object_types mt WHERE mt.`type` IN ('dimension_group') AND name IN ('expense_category')
				ON DUPLICATE KEY UPDATE `code`=`code`;";
				
				$queries[] = "INSERT INTO `".$table_prefix."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				  SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,0,31,1, 1, 0
				  FROM ".$table_prefix."object_types mt WHERE mt.`type` IN ('dimension_group') AND name IN ('expense_category')
				ON DUPLICATE KEY UPDATE `code`=`code`;";
			}
		}
	}
	
	
	if (check_is_installed_plugin($db_connection, $table_prefix, 'advanced_core')) {
	
		include_once dirname(__FILE__)."/../../advanced_core/application/helpers/installer_functions.php";
	
		$prop_groups_queries = get_default_property_groups_queries($db_connection, $table_prefix);
		$queries = array_merge($queries, $prop_groups_queries);
		
		$queries[] = "
			INSERT INTO `".$table_prefix."dimension_content_object_options` (`dimension_id`,`content_object_type_id`,`option`,`value`)
				SELECT d.id, ot.id, 'hide_member_selector_in_forms', '1'
				FROM ".$table_prefix."dimensions d LEFT JOIN ".$table_prefix."object_types ot ON true
				WHERE d.code='expense_categories' AND ot.type IN ('content_object', 'located', 'comment')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		";


	}

	return $queries;

}
