<?php 

	class PaymentHistories extends BasePaymentHistories {
		
		
		function getFormattedHistory($payment_id, $offset=null, $limit=null) {
			
			$conditions = "payment_id='$payment_id' AND modification_log IN ('add', 'edit')";
			$find_params = array(
				'conditions' => $conditions,
				'order' => 'modification_date DESC',
			);
			if (!is_null($offset) && is_numeric($offset)) {
				$find_params['offset'] = $offset;
			}
			if (!is_null($limit) && is_numeric($limit)) {
				$find_params['limit'] = $limit;
			}
			
			$history = self::findAll($find_params);
			
			$data = array();
			foreach ($history as $h) {
				$data[] = $h->getArrayInfo();
			}
			
			$total = self::count($conditions);
			
			$result = array('data' => $data, 'total' => $total);
				
			return $result;
		}
		
		
		static function comparePaymentHistoryDates($a, $b) {
			return strcmp($a["date"], $b["date"]);
		}
                
                function getAllPaymentHistory($expense_ids = null, $currency_id = null, $extra_params = null) {
                    $phs = array();
                    $extra_cond = $currency_id ? "AND ph.currency=$currency_id " : "";

                    $perm_conds_sql = "";
                    if (!logged_user()->isAdministrator()) {
                        $logged_user_pg_ids = implode(',', logged_user()->getPermissionGroupIds());
                        $perm_conds_sql = "AND ph.payment_id IN (
                                                SELECT sh.object_id FROM " . TABLE_PREFIX . "sharing_table sh
                                                WHERE ph.payment_id = sh.object_id AND sh.group_id  IN ($logged_user_pg_ids)
                                            )";
                    }

                    $date_condition = "";

                    if (is_array($extra_params)) {

                        if (array_key_exists("from_date", $extra_params) && $extra_params["from_date"] != '') {
                            $date_condition .= DB::prepareString('AND ph.date >= ? ', array($extra_params['from_date']));
                        }
                        if (array_key_exists("to_date", $extra_params) && $extra_params["to_date"] != '') {
                            $date_condition .= DB::prepareString('AND ph.date <= ? ', array($extra_params['to_date']));
                        }
                    }

                    $expenses_filter = "";

                    if (isset($expense_ids) && !empty($expense_ids)) {
                        $expense_ids = array_filter($expense_ids);
                        if (count($expense_ids) > 0) {
                            $expenses_filter = "AND ph.expense_id IN (" . implode(",", $expense_ids) . ") ";
                        }
                    }

                    $all_rows = array();

                    $sql = "SELECT ph.* FROM " . TABLE_PREFIX . "payment_history ph
                            INNER JOIN " . TABLE_PREFIX . "payments pp ON pp.object_id = ph.payment_id
                            WHERE ph.status_id <= pp.status_id
                            AND ph.modification_log IN ('add', 'edit')
                            $expenses_filter
                            $date_condition
                            $extra_cond
                            $perm_conds_sql
                            AND ph.modification_date = (
                                SELECT MAX(x.modification_date) FROM " . TABLE_PREFIX . "payment_history x
                                WHERE x.payment_id = ph.payment_id
                                AND x.status_id = ph.status_id
                            )
                            ORDER BY ph.date;";
                    
                    $rows = DB::executeAll($sql);

                    if (is_array($rows))
                        $all_rows = array_merge($all_rows, $rows);

                    usort($all_rows, 'PaymentHistories::comparePaymentHistoryDates');
                    $phs = $all_rows;

                    return $phs;
                }
        }
