<?php
	require_javascript("og/ReportingFunctions.js");
	require_javascript('og/modules/doubleListSelCtrl.js');
	echo stylesheet_tag("og/reporting.css");
	$genid = gen_id();
	if (!isset($conditions)) $conditions = array();
	
	$report_data = array_var($_SESSION, 'payments_by_state_data');
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('expense_reports', 'payments_by_state') ?>" method="post" enctype="multipart/form-data">
<input type="hidden" id="<?php echo $genid?>report[report_object_type_id]" name="report[report_object_type_id]" value="<?php echo Expenses::instance()->getObjectTypeId()?>"/>

<div class="reportTotalTimeParams">
<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo lang('payments report') ?>
		<?php //echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;margin-left:10px')) ?></div>
	</div>
	<div style="padding:5px 0"><?php echo lang('payments report description') ?></div>
</div>
<div class="coInputSeparator"></div>
<div class="coInputMainBlock">
	
	<?php if (count(active_context_members(false)) > 0) : ?>
	<div style="margin-bottom: 15px; padding-bottom: 5px; border-bottom:1px dotted #aaa;">
		<h5><?php echo lang('showing information for')?>:</h5>
		<ul>
		<?php
			$context = active_context();
			foreach ($context as $selection) :
				if ($selection instanceof Member) : ?>
					<li><span class="coViewAction <?php echo $selection->getIconClass()?>"><?php echo $selection->getName()?></span></li>	
		<?php 	endif;
			endforeach;
		?>
		</ul>
	</div>
	<?php else: ?>
	<div style="padding:5px;"></div>
	<?php endif; ?>

	<table>
		
		<tr style='height:30px;'>
			<td><span class="bold"><?php echo lang("expense status") ?>:&nbsp;</span></td>
			<td align='left'><?php 
				$options = array(option_tag(lang('All'), 0, array_var($report_data, "status") == 0 ? array('selected' => 'selected') : null));
				$statuses = ExpensesStatuses::instance()->getAllStatusInfo();
				foreach ($statuses as $st) {
					$options[] = option_tag($st['name'], $st['id'], array_var($report_data, "status") == $st['id'] ? array('selected' => 'selected') : null);
				}
				echo select_box('report[status]', $options);
			?></td>
		</tr>
		
		<tr style='height:30px;'>
			<td><span class="bold"><?php echo lang("date") ?>:&nbsp;</span></td>
			<td align='left'><?php 
				echo select_box('report[date_type]', array(
					option_tag(lang('none'), -1, array_var($report_data, "date_type") == -1 ? array('selected' => 'selected'):null),
					option_tag(lang('today'), 1, array_var($report_data, "date_type") == 1 ? array('selected' => 'selected'):null),
					option_tag(lang('this week'), 2, array_var($report_data, "date_type") == 2 ? array('selected' => 'selected'):null),
					option_tag(lang('next week'), 3, array_var($report_data, "date_type") == 3 ? array('selected' => 'selected'):null),
					option_tag(lang('this month'), 4, array_var($report_data, "date_type") == 4 ? array('selected' => 'selected'):null),
					option_tag(lang('next month'), 5, array_var($report_data, "date_type") == 5 ? array('selected' => 'selected'):null),
					option_tag(lang('select dates...'), 6, array_var($report_data, "date_type") == 6 ? array('selected' => 'selected'):null)
				), array('onchange' => 'og.dateselectchange(this)'));
			?></td>
		</tr>
		<?php
			if (array_var($report_data, "date_type") == 6) {
				$style = "";
				$date_format = user_config_option('date_format');
		       	$st = DateTimeValueLib::dateFromFormatAndString($date_format, array_var($report_data, 'date_start_value'));
		       	$et = DateTimeValueLib::dateFromFormatAndString($date_format, array_var($report_data, 'date_end_value'));
			} else {
				$style = 'display:none;';
				$st = DateTimeValueLib::now();
				$et = $st;
			} 
		?>
		<tr class="dateTr"  style="<?php echo $style ?>">
			<td><span class="bold"><?php echo lang("start date") ?>:&nbsp;</span></td>
			<td align='left'><?php echo pick_date_widget2('report[date_start_value]', $st, $genid);?></td>
		</tr>
		<tr class="dateTr"  style="<?php echo $style ?>">
			<td style="padding-bottom:18px"><span class="bold"><?php echo lang("end date") ?>:&nbsp;</span></td>
			<td align='left'><?php echo pick_date_widget2('report[date_end_value]', $et, $genid);?></td>
		</tr>
		
		<tr style='height:30px;' id="<?php echo $genid ?>repGroupBy">
			<td><span class="bold"><?php echo lang("group by") ?>:&nbsp;</span></td>
			<td align='left'>
				<span id="<?php echo $genid ?>gbspan">
					<?php for ($i = 1; $i <= 3; $i++){ 
						$gbVal = array_var($report_data, "group_by_$i");
						?>
					<select id="<?php echo $genid ?>group_by_<?php echo $i ?>" name="report[group_by_<?php echo $i ?>]" )">
						<option value="0"<?php if ($gbVal == null) echo ' selected="selected"' ?>><?php echo lang('none') ?></option>
						<?php 
							$gbs = array();
							Hook::fire('total_task_timeslots_group_by_criterias', null, $gbs);
							foreach($gbs as $gb) { ?>
								<option value="<?php echo $gb['val']?>"<?php if ($gbVal == $gb['val']) echo ' selected="selected"' ?>><?php echo $gb['name']?></option>
						<?php } ?>
					</select>
					<?php } // for ?>
				</span>
			</td>
		</tr>
		
		<?php if (isset($has_custom_properties) && $has_custom_properties) {?>
		<tr>
			<td style="padding-right:10px;"><span class="bold"><?php echo lang('conditions') ?>:&nbsp;</span></td>
			<td><div style="border:1px dotted #aaa; border-radius:5px; padding:5px 5px 7px;">
				<div id="<?php echo $genid ?>" style="margin-bottom:5px;"></div>
				<a href="#" class="link-ico ico-add" onclick="og.addCondition('<?php echo $genid ?>', 0, 0, '', '', '', false, false, true, true)"><?php echo lang('add condition')?></a>
			</div></td>
		</tr>
		<?php } ?>
		
		<tr style="height:30px;">
			<td colspan="2">
				<span class="bold" onclick="$('#<?php echo $genid?>print_props_in_payments').click();" style="cursor:pointer;"><?php 
					echo lang('print expense props in each payment') ?></span>
				<?php echo checkbox_field("report[print_expense_props_in_each_payment]", array_var($report_data, 'print_expense_props_in_each_payment'), array('id' => $genid.'print_props_in_payments'))?>
			</td>
		</tr>
		
		<tr id="<?php echo $genid?>_column_selector_link">
			<td style="padding-top:10px;" colspan="2">
			  <a href="#" class="underline" onclick="$('#<?php echo $genid?>_column_selector_row').show(); $(this).closest('tr').hide();"><?php 
				echo lang('select columns to show');
			?></a></td>
		</tr>
		
		<tr id="<?php echo $genid?>_column_selector_row" style="display:none;">
			<td style="padding-top:10px;padding-right:10px;"><span class="bold"><?php echo lang('columns') ?>:&nbsp;</span></td>
			<td><?php
				$column_list = array_var($report_data, 'column_list');
				$size = count($column_list);
				if ($size < 8) $size = 8;
				if ($size > 20) $size = 20;
				echo doubleListSelect("report[show_columns]", $column_list, array('id' => $genid."columns", 'size' => $size));
			?></td>
		</tr>
	</table>
	
<br/>
<?php echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;')) ?>
</div>
</div>

</form>

<script>
	og.loadReportingFlags();	
	og.reportTask('<?php echo $genid?>', '<?php echo array_var($report_data, 'order_by') ?>', '<?php echo array_var($report_data, 'order_by_asc') ?>', '');	

	var first = document.getElementById('<?php echo $genid ?>reportFormName');
	if (first) first.focus();
	
</script>