
INSERT INTO `<?php echo $table_prefix ?>object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`) VALUES
 ('expense', 'Expenses', 'expenses', 'content_object', 'expense', (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='expenses')),
 ('payment', 'Payments', 'payments', 'content_object', 'payment', (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='expenses'))
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
 SELECT dimension_id, dimension_object_type_id, (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='expense'), 0, 1
 FROM `<?php echo $table_prefix ?>dimension_object_type_contents` x
 WHERE x.`content_object_type_id` = (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>dimension_object_type_contents.dimension_id=<?php echo $table_prefix ?>dimension_object_type_contents.dimension_id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
 SELECT dimension_id, dimension_object_type_id, (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='payment'), 0, 1
 FROM `<?php echo $table_prefix ?>dimension_object_type_contents` x
 WHERE x.`content_object_type_id` = (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>dimension_object_type_contents.dimension_id=<?php echo $table_prefix ?>dimension_object_type_contents.dimension_id;

DELETE FROM `<?php echo $table_prefix ?>dimension_object_type_contents` WHERE `dimension_id`=0 OR dimension_id IS NULL;

INSERT INTO `<?php echo $table_prefix ?>tab_panels` (`id`,`title`,`icon_cls`,`refresh_on_context_change`,`default_controller`,`default_action`,`initial_controller`,`initial_action`,`enabled`,`type`,`ordering`,`plugin_id`,`object_type_id`) VALUES 
 ('expenses-panel', 'expenses', 'ico-expenses', 1, 'expense', 'init', '', '', 1, 'system', 6, (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='expenses'), (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='expense')) 
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO `<?php echo $table_prefix ?>tab_panel_permissions` (`permission_group_id`, `tab_panel_id`)
 SELECT `c`.`permission_group_id`, 'expenses-panel'
 FROM `<?php echo $table_prefix ?>contacts` `c` WHERE `c`.`user_type` IN (
 	SELECT `id` FROM `<?php echo $table_prefix ?>permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator','Manager','Executive')
 )
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;


INSERT INTO `<?php echo $table_prefix ?>expenses_status` (`order`, `code`, `name`, `description`, `editable`, `created_on`, `created_by_id`, `enabled`, `is_final`, `only_for_expenses`) VALUES
(1, 'budgeted', '', '', 0, NOW(), (SELECT object_id FROM <?php echo $table_prefix ?>contacts WHERE user_type=(SELECT id FROM <?php echo $table_prefix ?>permission_groups WHERE `type`='roles' AND name='Super Administrator') limit 1), 1, 0, 0),
(10, 'part_approved', '', '', 0, NOW(), (SELECT object_id FROM <?php echo $table_prefix ?>contacts WHERE user_type=(SELECT id FROM <?php echo $table_prefix ?>permission_groups WHERE `type`='roles' AND name='Super Administrator') limit 1), 1, 0, 1),
(20, 'approved', '', '', 0, NOW(), (SELECT object_id FROM <?php echo $table_prefix ?>contacts WHERE user_type=(SELECT id FROM <?php echo $table_prefix ?>permission_groups WHERE `type`='roles' AND name='Super Administrator') limit 1), 1, 0, 0),
(30, 'part_executed', '', '', 0, NOW(), (SELECT object_id FROM <?php echo $table_prefix ?>contacts WHERE user_type=(SELECT id FROM <?php echo $table_prefix ?>permission_groups WHERE `type`='roles' AND name='Super Administrator') limit 1), 1, 0, 1),
(40, 'executed', '', '', 0, NOW(), (SELECT object_id FROM <?php echo $table_prefix ?>contacts WHERE user_type=(SELECT id FROM <?php echo $table_prefix ?>permission_groups WHERE `type`='roles' AND name='Super Administrator') limit 1), 1, 1, 0);

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('expense', 'payment')
			 AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 0, 0
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('expense', 'payment')
			 AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');

INSERT INTO <?php echo $table_prefix ?>role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('expense', 'payment')
			 AND p.`name` IN ('Super Administrator','Administrator','Manager');

INSERT INTO <?php echo $table_prefix ?>role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 0, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('expense', 'payment')
			 AND p.`name` IN ('Executive');


-- add permissions to users where the users already have permissions (copy permissions from tasks)

INSERT INTO <?php echo $table_prefix ?>contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
 SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='expense'), cmp.can_delete, cmp.can_write 
 FROM <?php echo $table_prefix ?>contact_member_permissions cmp
 WHERE cmp.object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>contact_member_permissions.member_id=<?php echo $table_prefix ?>contact_member_permissions.member_id;

INSERT INTO <?php echo $table_prefix ?>contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
 SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='payment'), cmp.can_delete, cmp.can_write 
 FROM <?php echo $table_prefix ?>contact_member_permissions cmp
 WHERE cmp.object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>contact_member_permissions.member_id=<?php echo $table_prefix ?>contact_member_permissions.member_id;

UPDATE `<?php echo $table_prefix ?>system_permissions` SET `can_edit_executed_payments`=1 WHERE `permission_group_id` IN (
	SELECT id FROM `<?php echo $table_prefix ?>permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator')
);
UPDATE `<?php echo $table_prefix ?>system_permissions` SET `can_edit_executed_payments`=1 WHERE `permission_group_id` IN (
	SELECT permission_group_id FROM `<?php echo $table_prefix ?>contacts` WHERE `user_type` IN (
		SELECT id FROM `<?php echo $table_prefix ?>permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator')
	)
);
ALTER TABLE `<?php echo $table_prefix ?>max_system_permissions` ADD COLUMN `can_edit_executed_payments` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0;
UPDATE `<?php echo $table_prefix ?>max_system_permissions` SET `can_edit_executed_payments`=1 WHERE `permission_group_id` IN (
	SELECT id FROM `<?php echo $table_prefix ?>permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator','Manager')
);

INSERT INTO <?php echo $table_prefix ?>widgets (name,title,plugin_id,path,default_options,default_section,default_order,icon_cls) VALUES
("expenses_graph","expenses graph",(SELECT id FROM <?php echo $table_prefix ?>plugins WHERE name='expenses'),"","","left",2,"ico-expense");

INSERT INTO <?php echo $table_prefix ?>tab_panel_permissions (permission_group_id, tab_panel_id)
 SELECT pg.id, 'expenses-panel' FROM <?php echo $table_prefix ?>permission_groups pg WHERE pg.type='roles' AND pg.name IN ('Super Administrator','Administrator','Manager','Executive')
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;


INSERT INTO `<?php echo $table_prefix ?>config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
 ('expenses', 'use_date_in_expense_level', '0', 'BoolConfigHandler', 0, 1, ''),
 ('expenses', 'default_payment_status', '1', 'PaymentStatusConfigHandler', 0, 10, ''),
 ('expenses', 'action_for_empty_amounts', 'ask_user', 'SavePromptConfigHandler', 0, 20, ''),
 ('expenses', 'allow_negative_amounts', '0', 'BoolConfigHandler', 0, 30, ''),
 ('expenses', 'copy_exp_classiffication_to_payments', '1', 'BoolConfigHandler', 0, 40, '')
ON DUPLICATE KEY UPDATE `category_name`=`category_name`;

INSERT INTO `<?php echo $table_prefix ?>contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
('widget expenses_graph', 'expenses_graph_unit', 'Default', 'ListConfigHandler', 0, 1, '', ' { "option": [{ "value": "1", "text": "Default" }, { "value": "2", "text": "Millions" }, { "value": "3", "text": "Billions" } ] }'),
 ('widget expenses_graph', 'expenses_graph_date_range', '', 'DateRangeConfigHandler', 0, 1, '', '')
ON DUPLICATE KEY UPDATE category_name = category_name;

INSERT INTO `<?php echo $table_prefix ?>objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`) VALUES
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='report_category'), 'expenses reports', NOW(), 0, NOW(), 0, 0, 0);

INSERT INTO `<?php echo $table_prefix ?>report_category` (`object_id`, `description`, `is_default`) VALUES
((SELECT max(id) FROM <?php echo $table_prefix ?>objects WHERE object_type_id=(SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='report_category')), '', 1);

INSERT INTO `<?php echo $table_prefix ?>objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`) VALUES
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='report'), 'payments report', NOW(), 0, NOW(), 0, 0, 0);

INSERT INTO `<?php echo $table_prefix ?>reports` (`object_id`, `description`, `report_object_type_id`, `is_order_by_asc`, `ignore_context`, `is_default`, `code`, `function_url`, `report_category_id`) VALUES
((SELECT max(id) FROM <?php echo $table_prefix ?>objects WHERE object_type_id=(SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='report')), 'payments report description', (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='billing'), 1, 1, 1, 'payments_report', '?c=expense_reports&a=payments_by_state_parameters', (SELECT max(object_id) FROM <?php echo $table_prefix ?>report_category));

