og.expenses = {
	
	init: function() {
		og.openLink(og.getUrl('expense', 'get_expense_status'), {callback: function(success, data){
			og.expenses.all_status = [];
			for (x=0; x<data.status.length; x++) {
				var st = data.status[x];
				if (st.only_for_expenses) continue;
				og.expenses.all_status.push(st);
			}
			og.expenses.next_status_config = data.next_status_config;
		}});
		
		
		og.openLink(og.getUrl('payment', 'get_payment_list_config'), {
			preventPanelLoad: true,
			callback: function(success, data){
				eval(data.html);
				return;
			}
		});
		
		og.eventManager.addListener('load input events', function(data){
			for (var i= 0; i < data.length; i++){
				switch( data[i] ) {

					case "expenses_graph_unit":
						$("#list_"+data[i]).change( function() {
							og.openLink(og.getUrl('object', 'set_user_config_option_value', {config_option_name: 'expenses_graph_unit', config_option_value: $(this).val()}), {preventPanelLoad: true, hideLoading: true});
							og.eventManager.fireEvent('reload current panel');
							$("#quick-form").fadeOut();
						});
						break;
					case "expenses_graph_date_range":
						var html = '<button id="btn_apply_date_range_expenses_graph">'+lang('apply date range button')+'</button>';
					    $('.expenses_graph_date_range.date-range-container').append(html);
					          
						$("#date_range_type_"+data[i]).change( function(){
	    					var data_values = { type: $(this).val(), range_start: '', range_end: ''};
	    					if ( $(this).val() != "range" ) {
	    						og.openLink(og.getUrl('object', 'set_user_config_option_value', {config_option_name: 'expenses_graph_date_range', config_option_value: Ext.util.JSON.encode(data_values) }), {preventPanelLoad: true, hideLoading: true});
	    						og.eventManager.fireEvent('reload current panel');
	    						$("#quick-form").fadeOut();
	    					}
						});
						break;
						
				}
		
			}
			
			$("#btn_apply_date_range_expenses_graph").click(function() {
				var data_values = { type: $("#date_range_type_expenses_graph_date_range").val(), range_start: $("#date_range_start_expenses_graph_date_range").val(), range_end: $("#date_range_end_expenses_graph_date_range").val()};

				og.openLink(og.getUrl('object', 'set_user_config_option_value', {config_option_name: 'expenses_graph_date_range', config_option_value: Ext.util.JSON.encode(data_values) }), {preventPanelLoad: true, hideLoading: true, callback: function(success){
					if (success) og.eventManager.fireEvent('reload current panel');
				}});
				
				$("#quick-form").fadeOut();
			});
			
		});
	},
	
	loadSubtab: function (t) {
		if (this.load_subtab_functions && this.load_subtab_functions.length > 0) {
			for (var i=0; i<this.load_subtab_functions.length; i++) {
				var fn = this.load_subtab_functions[i];
				if (typeof(fn) == 'function') {
					fn.call(null, t);
				}
			}
		}
	},
	
	buildPaymentsTableRowHtml: function(payment, alt, column_model) {
		var cell_class = ' expense-subtable';
		if (alt) cell_class += ' alt';
		
		var row_html = '<tr class="expense-subtable-row">';
		
		var extra_expense_amount_columns = [];
		if (og.extra_expense_list_columns && og.extra_expense_list_columns.length>0) {
			for (var i=0; i<og.extra_expense_list_columns.length; i++) {
				var tmp = og.extra_expense_list_columns[i];
				if (tmp && tmp.id) extra_expense_amount_columns.push(tmp.id);
			}
		}
		
		for (var i=0; i<column_model.config.length; i++) {
			var col = column_model.config[i];
			if (col.hidden) {
				continue;
			}
			if (col.id == 'checker' || col.id == 'draghandle' || col.id == 'expand' || col.id == 'icon') {
				if (col.id.indexOf('dim_') == 0) {
					row_html += '<td class="x-grid3-col x-grid3-cell'+ cell_class +'"></td>';
				} else {
					row_html += '<td></td>';
				}
			
			} else if (col.id == 'name') {
				
				var link = '<a href="javascript:og.render_modal_form(\'\', {c:\'payment\', a:\'edit\', params:{id:'+payment.id+'}});">'+ payment.desc +'</a>';
				
				row_html += '<td class="x-grid3-col x-grid3-cell'+ cell_class +'"><div class="x-grid3-cell-inner">'+ link +'</div></td>';
			
			} else if (col.id == 'status') {
				row_html += '<td class="x-grid3-col x-grid3-cell'+ cell_class +'"><div class="x-grid3-cell-inner"><span class="expense-row-status-'+payment.status_code+'">'+payment.status+'</span></div></td>'
			
			} else if (col.id == 'date') {
				row_html += '<td class="x-grid3-col x-grid3-cell'+ cell_class +'"><div class="x-grid3-cell-inner" style="text-align:center;">'+payment.date+'</div></td>'
			
			} else if (col.id.indexOf('total_') == 0 || extra_expense_amount_columns.indexOf(col.id) != -1) {
				var col_st_code = col.id.indexOf('total_') == 0 ? col.id.substring(6) : col.id;
				row_html += '<td class="x-grid3-col x-grid3-cell'+ cell_class +'"><div class="x-grid3-cell-inner">';
				
				if (payment[col_st_code]) {
					row_html += '<span style="float:right">' + payment[col_st_code].amount + '</span>'
				}
				
				row_html += '</div></td>';
				
			} else if (col.id.indexOf('dim_') == 0) {
				var dim_id = col.id.substring(4);
				
				row_html += "<td class='x-grid3-col x-grid3-cell"+ cell_class +"'>" + (typeof(payment[col.id])!='undefined' ? payment[col.id] : "") + '</td>';
				/*var mpath = Ext.util.JSON.decode(payment.memPath);
				
				if (mpath) {
					var mpath_aux = {};
					mpath_aux[dim_id] = {};
					for (t in mpath[dim_id]) {
						mpath_aux[dim_id][t] = mpath[dim_id][t];
					}
					
					var br_text = "<td class='x-grid3-col x-grid3-cell"+ cell_class +"'>";
					br_text += "<div class='breadcrumb-container' style='width: 100%;'>";
					br_text += og.getEmptyCrumbHtml(mpath_aux, '.breadcrumb-container');
					br_text += "</div></td>";
					
					row_html += br_text;
				}*/
			}
			
		}

		row_html += '</tr>';
		
		return row_html;
	},
	
	buildPaymentsTable: function(el, payments) {
		if (!payments) return;
		
		var column_model = Ext.getCmp('expense-manager').getColumnModel();
		for (var i=0; i<payments.length; i++) {
			var alt = i % 2 != 0;
			var html = og.expenses.buildPaymentsTableRowHtml(payments[i], alt, column_model);
			
			var other_pay_rows = $('#'+el.id).closest('tr').siblings(".expense-subtable-row");
			if (other_pay_rows.length > 0) {
				$(other_pay_rows).last().after(html);
			} else {
				$('#'+el.id).closest('tr').after(html);
			}
		}
		
	},
	
	requestPayments: function(el, object_id) {
		$('#'+el.id).removeClass('ico-expand-lens').addClass('ico-collapse-lens');
		el.setAttribute('onclick', 'og.expenses.collapseSubtable(this);');
		
		og.openLink(og.getUrl('expense','get_payments',{id:object_id}), {
			callback: function (success, data) {
				og.expenses.buildPaymentsTable(el, data.payments);
				og.eventManager.fireEvent('replace all empty breadcrumb', null);
			}
		});
	},
	
	collapseSubtable: function(el) {
		$('#'+el.id).parent('.x-grid3-row-table').children('.expense-subtable-row').hide();
		var table = $('#'+el.id).closest('.x-grid3-row-table').get(0);
		for (i=0; i<table.rows.length; i++) {
			if (table.rows[i].className == 'expense-subtable-row') table.rows[i].style.display = 'none';
		}

		$('#'+el.id).removeClass('ico-collapse-lens').addClass('ico-expand-lens');
		el.setAttribute('onclick', 'og.expenses.expandSubtable(this);');
	},
	
	expandSubtable: function(el) {
		$('#'+el.id).parent('.x-grid3-row-table').children('.expense-subtable-row').hide();
		var table = $('#'+el.id).closest('.x-grid3-row-table').get(0);
		for (i=0; i<table.rows.length; i++) {
			if (table.rows[i].className == 'expense-subtable-row') table.rows[i].style.display = '';
		}
		
		$('#'+el.id).removeClass('ico-expand-lens').addClass('ico-collapse-lens');
		el.setAttribute('onclick', 'og.expenses.collapseSubtable(this);');
	},
	
	addTotalsRow: function(store, filters, manager_id) {
		var params = {st: filters.status};
		if (filters.from_date) params['fromd'] = filters.from_date;
		if (filters.to_date) params['tod'] = filters.to_date;
		if (filters.expense_id) params['expense_id'] = filters.expense_id;
		
		og.openLink(og.getUrl('expense', 'get_totals_for_listing', params), {callback: function(success, data){
			
			var totals = data.totals;
			var obj = {id: totals.id, name: totals.name};
			
			for (x=0; x<og.expenses.all_status.length; x++) {
				var st = og.expenses.all_status[x];
				if (st.only_for_expenses) continue;
				
				if (store.fields.keys.indexOf('total_' + st['code']) >= 0) {
					obj['total_' + st['code']] = totals['total_' + st['code']];
				} else {
					obj[st['code']] = totals['total_' + st['code']];
				}
			}
			
			var record = new Ext.data.Record(obj, totals.id);
			var records = [];
			records.push(record);
			store.add(records);
			
			$("#"+manager_id+" #__total_row__").closest('tr').addClass('expenses-list-totals');
			
			// scroll list to top
			setTimeout(function(){
				$("#"+ manager_id +" .x-grid3-scroller").scrollTop(0);
			}, 10);
			
		}});
	},
	
	drawPaymentTypeCells: function(cell, values, pos, name_prefix) {
		
		for (var j=0; j < og.expenses.payment_types.length; j++) {
			var pt = og.expenses.payment_types[j];
			if (pt.attributes) {
				for (var k=0; k < pt.attributes.length; k++) {
					
					var attr = pt.attributes[k];
					var input_name = name_prefix + '['+pt.id+']['+attr.attribute_id+']';
					var common_tag_attr = 'class="pt-attr pt-attribute-input-'+pos+' pt-'+ pos +'-'+ pt.id +'-attr" style="display:none;"';
					var placeholder = attr.name + (attr.is_required > 0 ? ' *' : '');
					
					switch (attr.type) {
					case 'text':
					case 'numeric':
						var input_type = attr.type == 'numeric' ? 'type="number"' : '';
						var input_val = "";
						if (values && values.attributes && values.attributes[attr.attribute_id]) {
							input_val = values.attributes[attr.attribute_id];
						}
						
						cell.innerHTML += '<input name="'+input_name+'" '+input_type+' placeholder="'+placeholder+'" value="'+input_val+'" '+common_tag_attr+'/>';
						break;
						
					case 'list':
						var combo_id = Ext.id();
						var html = '<select name="'+input_name+'" '+common_tag_attr+' title="'+placeholder+'" onchange="og.payment_types.onListAttributeChange(this);" id="'+combo_id+'">';
						list_vals = attr.list_values.split(',');
						var selected = null;
						if (values && values.attributes && values.attributes[attr.attribute_id]) {
							selected = values.attributes[attr.attribute_id];
						}
						html += '<option value="">'+ placeholder +'</option>';
						for (var x=0; x<list_vals.length; x++) {
							var sel_html = (selected == list_vals[x] ? 'selected="selected"' : '');
							html += '<option value="'+ list_vals[x] +'" '+sel_html+' >' + list_vals[x] + '</option>';
						}
						html += '</select>';
						cell.innerHTML += html;
						setTimeout(function() {
							var c = document.getElementById(combo_id);
							og.payment_types.onListAttributeChange(c);
						}, 100);
						break;

					case 'boolean':
						var ch_id = Ext.id();
						var label_html = '<label style="float:none; display:inline;" for="'+ch_id+'">'+placeholder+'&nbsp;</label>';
						var sel_html = "";
						if (values && values.attributes && values.attributes[attr.attribute_id]) {
							sel_html = 'checked="checked"';
						}
						cell.innerHTML += '<span '+common_tag_attr+'>'+ label_html +'<input id="'+ch_id+'" name="'+ input_name +'" type="checkbox" '+sel_html+'/></span>';
						break;

					case 'date':
						var dp_id = Ext.id();
						cell.innerHTML += '<span '+ common_tag_attr +' id="'+ dp_id +'" style="margin-left:4px;"></span>';
						var input_val = "";
						if (values && values.attributes && values.attributes[attr.attribute_id]) {
							input_val = values.attributes[attr.attribute_id];
						}

						og.expenses.drawAttributeDateField({
							render_to: dp_id,
							name: input_name,
							id: dp_id + '-pt-'+ pos +'-'+ pt.id,
							val: input_val,
							empty_text: og.preferences.date_format_tip + (attr.is_required > 0 ? ' *' : '')
						});
						break;
						
					case 'contact':
					case 'user':
						var c_id = Ext.id();
						cell.innerHTML += '<div style="display:inline;margin-left:4px;" class="clear"><span '+ common_tag_attr +' id="'+ c_id +'"></span></div>';
						var sel_contact = "";
						var sel_name = "";
						
						if (values && values.attributes && values.attributes[attr.attribute_id]) {
							var sel = values.attributes[attr.attribute_id];
							if (sel != '') {
								var splitted = sel.split('|');
								sel_contact = splitted[0];
								sel_name = splitted[1];
							}
						}
						
						var parameters = {
							genid: '',
							id: c_id + '-pt-'+ pos +'-'+ pt.id,
							name: input_name,
							render_to: c_id,
							selected: sel_contact,
							selected_name: sel_name,
							empty_text: placeholder,
							width: 130,
							inline_selector: true
						}
						if (attr.type == 'user') {
							parameters.filters = {is_user: 1};
						}

						og.expenses.drawAttributeContactField(parameters);
						
						break;
					}
					
				}
			}
		}
		
	},
	
	drawAttributeContactField: function(params) {
		setTimeout(function() {
			og.renderContactSelector({
				genid: params.genid,
				id: params.id,
				name: params.name,
				render_to: params.render_to,
				selected: params.selected,
				selected_name: params.selected_name,
				empty_text: params.empty_text,
				width: params.width,
				listClass: "payment-attr",
				listAlign: "tr-br",
				inline_selector: params.inline_selector,
				filters: params.filters
			});
		}, 100);
	},
	
	drawAttributeDateField: function(params) {
		setTimeout(function() {
			if (!params.empty_text) params.empty_text = og.preferences.date_format_tip;
			
			var dtp = new og.DateField({
				renderTo: params.render_to,
				name: params.name,
				width: 90,
				emptyText: params.empty_text,
				id: params.id,
				value: params.val
			});
		}, 100);
	},

	onPaymentTypeChange: function(typeselector, pos) {
		var pt_id = $(typeselector).val();
		
		if (pt_id > 0) {
			$(".pt-attributes-row-"+pos).show();
		} else {
			$(".pt-attributes-row-"+pos).hide();
		}
		
		$(".pt-attribute-input-"+pos).hide();
		$(".pt-"+ pos +'-'+ pt_id +"-attr").show();
		
		// scroll the form if necessary
		og.expenses.scrollExpenseFormDown(genid);
	},

	addPaymentTableRow: function(table_id, values, genid) {
		var table = document.getElementById(table_id);
		var table_type = 'payments';
		var len = table.rows.length;
		var pos = len - 1;
		var row = table.insertRow(len);
		var row_id = Math.floor((Math.random()*10000)+1);

		if (table.max_num) {
			num = parseInt(table.max_num) + 1;
		} else if (values && values.num) {
			num = parseInt(values.num);
			if (!table.max_num) table.max_num = num;
		} else {
			table.max_num = 0;
			num = 1;
		}
		if (parseInt(table.max_num) < num) table.max_num = num;
		
		row.id = row_id;
		row.className = (Math.floor(pos/2) % 2 == 0) ? '' : 'alt';

		// type selector
		if (og.expenses.payment_types.length > 0) {
			var cellt = row.insertCell(row.cells.length);
			var options = '<option value="0"></option>';
			for (var i=0; i < og.expenses.payment_types.length; i++) {
				var type = og.expenses.payment_types[i];
				var sel = values && values.type_id == type.id ? 'selected="selected"' : '';
				options += '<option '+sel+' value="'+ type.id +'">'+ type.name +'</option>';
			}
			cellt.innerHTML = '<select name="expense['+table_type+']['+pos+'][type_id]" onchange="og.expenses.onPaymentTypeChange(this, '+pos+');" id="type-sel-'+pos+'">' + options + '</select>';
			
			var row2 = table.insertRow(len+1);
			row2.style.display = 'none';
			row2.className += 'pt-attributes-row-'+pos + ((Math.floor(pos/2) % 2 == 0) ? '' : ' alt');
			row2.id = row_id + '-' + pos;
			var dummy_cell = row2.insertCell(row2.cells.length);
			var cellattrs = row2.insertCell(row2.cells.length);
			cellattrs.setAttribute("colspan", "5");
			og.expenses.drawPaymentTypeCells(cellattrs, values, pos, 'expense['+table_type+']['+pos+']');

			if (values && values.type_id > 0) {
				setTimeout(function() {
					$('#type-sel-'+pos).change();
				}, 100);
			}
		}

		
		// description
		var desc = values && values.desc ? values.desc : '';
		var celld = row.insertCell(row.cells.length);
		var desc_style = og.expenses.use_date_in_expense_level ? "width: 98%;" : "";
		celld.innerHTML = '<input type="text" name="expense['+table_type+']['+pos+'][description]" value="'+desc+'" style="'+desc_style+'"/>';
		celld.innerHTML += '<input type="hidden" name="expense['+table_type+']['+pos+'][num]" value="'+num+'"/>';

		// date
		if (!og.expenses.use_date_in_expense_level) {
			var celldate = row.insertCell(row.cells.length);
			celldate.className += 'date';
			var dateInput = new og.DateField({
				renderTo: celldate,
				width: 80,
				name: 'expense['+table_type+']['+pos+'][date]'
			});
			if (values && values.date) dateInput.setValue(values.date);
		}

		// currency selector and amount
		var cellc = row.insertCell(row.cells.length);
		var options = [];
		for (i=0; i<og.expenses.currencies.length; i++) {
			var c = og.expenses.currencies[i];
			var sel = values && values.currency == c.id ? 'selected="selected"' : '';
			options += '<option '+sel+' value="'+ c.id +'">'+ c.symbol +'</option>';
		}
		cellc.className += 'right';
		cellc.innerHTML = '<select type="text" name="expense['+table_type+']['+pos+'][currency]">' + options + '</select>';
		var amount = values && values.amount ? values.amount : '';
		cellc.innerHTML += '<input type="text" class="amount" name="expense['+table_type+']['+pos+'][amount]" value="'+amount+'"/>';

		// status selector
		var cellst = row.insertCell(row.cells.length);
		var options = [];
		for (i=0; i<og.expenses.statuses.length; i++) {
			var c = og.expenses.statuses[i];
			if (c.only_for_expenses) continue;
			if (values && typeof(values.status) != 'undefined') {
				var sel = values && values.status == c.id ? 'selected="selected"' : '';
			} else {
				var sel = parseInt(og.expenses.default_payment_status) == c.id ? 'selected="selected"' : '';
			}
			options += '<option '+sel+' value="'+ c.id +'">'+ c.name +'</option>';
		}
		cellst.className += 'right';
		cellst.innerHTML = '<select type="text" name="expense['+table_type+']['+pos+'][status_id]">' + options + '</select>';		

		// delete link
		cellremove = row.insertCell(row.cells.length);
		cellremove.innerHTML = '<a href="#" class="link-ico ico-delete" onclick="og.expenses.removePaymentTableRow(\''+table_id+'\', '+row_id+', '+pos+')"></a>';
		cellremove.style.width = '23px';

		// focus in first input
		celld.getElementsByTagName('input')[0].focus();
		
		// scroll the form if necessary
		og.expenses.scrollExpenseFormDown(genid);
	},
	
	scrollExpenseFormDown: function(genid) {
		var offset = $("#"+ genid +"add-payment-button").offset();
		if (offset) {
		//	$('#modal-forms-container').animate({scrollTop: offset.top});
		}
	},

	removePaymentTableRow: function(table_id, row_id, suffix) {
		var table = document.getElementById(table_id);
		var row = document.getElementById(row_id);
		if (table && row) {
			table.deleteRow(row.rowIndex);
			var row2 = document.getElementById(row_id + '-' + suffix);
			if (row2) {
				table.deleteRow(row2.rowIndex);
			}
		}
	},
	
	
	submit_expense_form: function(form_id) {
		var has_empty_amounts = false;
		var amounts = $("#"+form_id+" .payments-table-container input.amount");
		for (var i=0; i<amounts.length; i++) {
			var amount = amounts[i];
			
			if ($(amount).val() == '' || parseFloat($(amount).val()) == 0) {
				has_empty_amounts = true;
				break;
			}
		}

		if (has_empty_amounts) {
			switch (og.expenses.action_for_empty_amount_payments) {
				case 'dont_save':
					og.err(lang('cannot save expense it has payments with empty amount'));
					break;
				case 'ask_user':
					if (confirm(lang('save expense with empty amounts prompt'))) {
						og.submit_modal_form(form_id);
					}
					break;
				case 'allow_save':
				default:
					og.submit_modal_form(form_id); 
					return false;
			}
		} else {
			og.submit_modal_form(form_id); 
			return false;
		}
	},
	
	
	submit_payment_form: function(form_id) {
		var has_empty_amounts = false;
		var amounts = $("#"+form_id+" .payments-table-container input.amount");
		for (var i=0; i<amounts.length; i++) {
			var amount = amounts[i];
			
			if ($(amount).val() == '' || parseFloat($(amount).val()) == 0) {
				has_empty_amounts = true;
				break;
			}
		}

		if (has_empty_amounts) {
			switch (og.expenses.action_for_empty_amount_payments) {
				case 'dont_save':
					og.err(lang('cannot save expense it has payments with empty amount'));
					break;
				case 'ask_user':
					if (confirm(lang('save expense with empty amounts prompt'))) {
						og.submit_modal_form(form_id);
					}
					break;
				case 'allow_save':
				default:
					og.submit_modal_form(form_id); 
					return false;
			}
		} else {
			og.submit_modal_form(form_id); 
			return false;
		}
	},
	
	
	showPaymentHistory: function(expense_id, payment_num) {
		
		og.openLink(og.getUrl('payment', 'show_payment_history', {expense_id:expense_id, payment_num:payment_num}), {
			callback: function(success, data) {
	
				var modal_params = {
					'closeHTML': '<a id="'+genid+'_close_link" class="modal-close" title="'+lang('close')+'"></a>',
					'onShow': function (dialog) {
						$("#"+genid+"_close_link").addClass("modal-close-img");
				    }
				};
				var html = '<div class="modal-container" style="background-color: white;padding: 10px;">'+data.html+'</div>';
				setTimeout(function() {
					$.modal(html, modal_params);
				}, 100);
			}
		});
	},
	
	reorderPaymentsTable: function(exp_id, order, odir) {
		if (odir != 'ASC' && odir != 'DESC') odir = 'ASC';
		
		og.openLink(og.getUrl('expense', 'get_payments_table_html', {id:exp_id, order:order, order_dir:odir}), {
			callback: function(success, data) {
				$("#payments-table-container").html(data.html);
			}
		});
	},
	
	
	renderPaymentGridActions: function(value, p, r) {
		var actions = '';
		if (r.data.id == '__total_row__' || r.data.id <= 0) return actions;
		
		var actionStyle= ' style="font-size:105%;padding-top:2px;padding-bottom:3px;padding-left:16px;background-repeat:no-repeat;" '; 
		
		actions += String.format(
			'<a class="list-action ico-edit" href="#" onclick="og.render_modal_form(\'\', {c:\'payment\', a:\'edit\', params:{id:'+r.data.object_id+'}});" title="{1}" ' + actionStyle + '>&nbsp;</a>',
			r.data.object_id, lang('edit'));
		
		var current_status = null;
		for (x in og.expenses.all_status) {
			var st = og.expenses.all_status[x];
			if (st.code == r.data.status_code) {
				current_status = st;
				break;
			}
		}
		if (current_status && !current_status.is_final) {
			var next_status = og.expenses.next_status_config[current_status.code];
			if (next_status) {
				actions += String.format( 
					'<a class="list-action ico-change-pstatus ico-change-pstatus-'+next_status.code+'" href="#" onclick="og.openLink(og.getUrl(\'expense\', \'change_payment_status\', {'+
					'payment_id:'+r.data.object_id+', st:'+next_status.id+'}));" title="'+ lang('change status to', next_status.name) +'" ' + actionStyle + '>&nbsp;</a>');
			}
		}
		
		if (actions != '')
			actions = '<span>' + actions + '</span>';
			
		return actions;
	},
	
	renderPaymentGridStatus: function(value, p, r) {
		if (r.data.status_code) {
			return '<span class="expense-row-status-'+r.data.status_code+'">' + value + '</span>';
		} else {
			return '';
		}
	}
}




og.checkCanHaveExpense = function(genid) {
	if (og.after_selecting_payment_expense) return;
	
	var expense_id = $("#"+genid+"paymentExpenseId").val();
	if (expense_id) {
		var members = $("#"+genid+"members").val();
		og.openLink(og.getUrl('expense', 'check_expense_members', {id: expense_id, member_ids: members}), {
			callback: function(success, data) {
				if (!data.ok) {
					og.removePaymentExpense(genid, false);
				}
			}
		});
	}
}

og.removePaymentExpense = function(genid, remove_classification) {

	$("#"+genid+"paymentExpenseId").val("");
	$("#"+genid+"paymentExpenseName").html("");
	$("#"+genid+"exp_change_link").html(lang('select expense'));
	$("#"+genid+"exp_remove_link").hide();

	if (remove_classification) {
		$("#"+genid+"members").val("[]");
		member_selector.remove_all_selections(genid);
		$(".single_current_selected .empty-text").show();
	}
}

og.resetPaymentMembersByExpense = function(genid, expense_id) {
	og.openLink(og.getUrl('expense', 'get_expense_data', {id: expense_id}), {
		callback: function(success, data) {
			if (data && data.expense && data.expense.memPath) {

				// remove previous classification
				//member_selector.remove_all_selections(genid);
				//$("#"+genid+"members").val("[]");

				var all_member_ids = Ext.util.JSON.decode($("#"+genid+"members").val());
				
				for (dim_id in data.expense.memPath) {
					var member_ids_by_ot = data.expense.memPath[dim_id];
					if (typeof(member_ids_by_ot) == 'function') continue;
					
					for (ot in member_ids_by_ot) {
						var member_ids = member_ids_by_ot[ot];
						if (typeof(member_ids) == 'function') continue;

						if (member_selector[genid].properties[dim_id]) {
							for (var j=0; j<member_ids.length; j++) {
								var mem_id = member_ids[j];
								var d = dim_id;
								// add member to payment classification
								if ((!member_selector[genid].sel_context[dim_id] || member_selector[genid].sel_context[dim_id].length == 0) 
										&& member_selector[genid].properties[dim_id]) {

									member_selector.add_relation(d, genid, mem_id);
									
									all_member_ids.push(parseInt(mem_id));
									$("#"+genid+"members").val(Ext.util.JSON.encode(all_member_ids));

									$("#"+genid+"-member-chooser-panel-"+d+"-tree-current-selected .empty-text").hide();
								}
								
								if (!member_selector[genid].properties[d].isMultiple) break;
							}
						}
					}
				}
			}
			og.after_selecting_payment_expense = false;
		}
	});
}




og.payment_types = {
	
	onListAttributeChange: function(combo) {
		var val = $(combo).val();
		if (val == '') {
			$(combo).addClass('desc');
		} else {
			$(combo).removeClass('desc');
		}
	},
		
	deletePaymentType: function(pt_id, link) {
		var container = $(link).closest(".payment-type");
		if (container.length > 0) {
			var name = $("#"+ container[0].id +" #name").html();
			if (confirm(lang('delete payment type confirmation'), name)) {
				og.openLink(og.getUrl('payment_types', 'delete', {id: pt_id}));
			}
		}
	},
	
	onAttributeTypeChange: function(combo) {
		var selection = $(combo).val();
		var container = $(combo).closest(".pt-attr-container");
		
		if (container.length > 0 && container[0].id) {
			if (selection == 'list') {
				$("#"+ container[0].id +" #list_values_row").show();
			} else {
				$("#"+ container[0].id +" #list_values_row").hide();
			}
		}
	},

	addPaymentAttributeRow: function(genid, property) {

		var template = $('<tbody></tbody>');

		// get html and replace {number} with new cp index
		var template_html = $("#"+genid+"_template_attr_row").html();
		template_html = template_html.replace(/{i}/g, og.pt_attribute_count);
		template.html(template_html);

		$(template).attr('id', "pt-attr-container-" + og.pt_attribute_count);
		$(template).addClass("pt-attr-container").addClass(genid);
		if (og.pt_attribute_count % 2 != 0) {
			$(template).addClass("alt");
		}

		
		$("#"+genid+"pt-attributes-table").append(template);
		
		$(pre_id + " #deleted_message").html(lang('payment type attribute deleted'));
		
		var pre_id = "#pt-attr-container-" + og.pt_attribute_count;
		
		if (property) {

			$(pre_id + " #attribute_id").attr('value', property.attribute_id);
			$(pre_id + " #name").attr('value', property.name);
			$(pre_id + ' #type option[value="' + property.type + '"]').prop('selected', true);
			$(pre_id + " #list_values").attr('value', property.list_values);
			if (property.is_required > 0) {
				$(pre_id + " #is_required").attr('checked', 'checked');
			}
			
			og.payment_types.onAttributeTypeChange($(pre_id + ' #type'));
			
		} else {
			// default values
			$(pre_id + " #attribute_id").attr('value', 0);
			$(pre_id + " #name").attr('value', '');
			$(pre_id + ' #type option[value="text"]').prop('selected', true);
		}
		
		og.pt_attribute_count = og.pt_attribute_count + 1;
	},
	
	deletePaymentTypeAttribute: function(link){
	  	if(confirm(lang('delete payment type attribute confirmation'))){
	
	  		var container = $(link).closest(".pt-attr-container");
	
			$("#"+$(container).attr('id')+" #deleted").val(1);
			
			$("#"+$(container).attr('id')+" #undo_delete_action").show();
			$("#"+$(container).attr('id')+" #delete_action").hide();
	
			$("#"+$(container).attr('id')+" #deleted_message").show();
			$(container).addClass('disabled');
			
	  	}
	},
	
	undoDeletePaymentTypeAttribute: function(link){
		
		var container = $(link).closest(".pt-attr-container");
	
		$("#"+$(container).attr('id')+" #deleted").val(0);
		
		$("#"+$(container).attr('id')+" #undo_delete_action").hide();
		$("#"+$(container).attr('id')+" #delete_action").show();
	
		$("#"+$(container).attr('id')+" #deleted_message").hide();
		$(container).removeClass('disabled');
	}
}