<?php 

function expenses_update_1_2() {
	DB::executeAll("INSERT INTO ".TABLE_PREFIX."tab_panel_permissions (permission_group_id, tab_panel_id)
		 SELECT pg.id, 'expenses-panel' FROM ".TABLE_PREFIX."permission_groups pg WHERE pg.type='roles' AND pg.name IN ('Super Administrator','Administrator','Manager','Executive')
		ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;");
}

function expenses_update_2_3() {
	if (!check_column_exists(TABLE_PREFIX."max_system_permissions", 'can_edit_executed_payments')) {
		DB::executeAll("ALTER TABLE `".TABLE_PREFIX."max_system_permissions` ADD COLUMN `can_edit_executed_payments` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0;");
	}
	DB::executeAll("UPDATE `".TABLE_PREFIX."max_system_permissions` SET `can_edit_executed_payments`=1 WHERE `permission_group_id` IN (
		SELECT id FROM `".TABLE_PREFIX."permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator','Manager','Executive')
	);");
}

function expenses_update_3_4() {
	DB::executeAll("INSERT INTO ".TABLE_PREFIX."role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		 SELECT rtp.role_id, (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='expense'), can_delete, can_write
		 FROM ".TABLE_PREFIX."role_object_type_permissions rtp WHERE rtp.object_type_id=(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='task')
		ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."role_object_type_permissions.role_id=".TABLE_PREFIX."role_object_type_permissions.role_id;");
}

function expenses_update_4_5() {
	DB::executeAll("INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		 SELECT rtp.role_id, (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='expense'), can_delete, can_write
		 FROM ".TABLE_PREFIX."max_role_object_type_permissions rtp WHERE rtp.object_type_id=(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='task')
		ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."max_role_object_type_permissions.role_id=".TABLE_PREFIX."max_role_object_type_permissions.role_id;");
}

function expenses_update_5_6() {
	DB::executeAll("
		DELETE FROM ".TABLE_PREFIX."max_role_object_type_permissions 
		WHERE object_type_id IN (
					 SELECT o.id
					 FROM `".TABLE_PREFIX."object_types` o 
					 WHERE o.`name` IN ('expense')				
		);
	");
	DB::executeAll("
		INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 1, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('expense')
				 AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');
	");
	DB::executeAll("
		INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 0, 0
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('expense')
				 AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');
	");
	DB::executeAll("
		DELETE FROM ".TABLE_PREFIX."role_object_type_permissions
		WHERE object_type_id IN (
					SELECT o.id
					FROM `".TABLE_PREFIX."object_types` o
					WHERE o.`name` IN ('expense')
		);
	");
	DB::executeAll("
		INSERT INTO ".TABLE_PREFIX."role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 1, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('expense')
				 AND p.`name` IN ('Super Administrator','Administrator','Manager');
	");
	DB::executeAll("
		INSERT INTO ".TABLE_PREFIX."role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 0, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('expense')
				 AND p.`name` IN ('Executive');
	");
	
	DB::executeAll("
		UPDATE `".TABLE_PREFIX."max_system_permissions` SET `can_edit_executed_payments`=0 WHERE `permission_group_id` IN (
			SELECT id FROM `".TABLE_PREFIX."permission_groups` WHERE `type`='roles' AND `name` IN ('Executive')
		);	
	");
}


function expenses_update_6_7() {
	// payment types definition
	DB::execute("
		CREATE TABLE `".TABLE_PREFIX."payment_types` (
		  `id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
		  `name` VARCHAR(255) NOT NULL,
		  `created_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
		  `created_on` datetime NOT NULL default '0000-00-00 00:00:00',
		  `updated_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
		  `updated_on` datetime NOT NULL default '0000-00-00 00:00:00',
		  PRIMARY KEY (`id`)
		) ENGINE = InnoDB;
	");
	// payment types attributes definition
	DB::execute("
		CREATE TABLE `".TABLE_PREFIX."payment_type_attributes` (
		  `payment_type_id` INTEGER UNSIGNED NOT NULL,
		  `attribute_id` INTEGER UNSIGNED NOT NULL,
		  `name` VARCHAR(255) NOT NULL,
		  `type` VARCHAR(50) NOT NULL,
		  `order` INTEGER UNSIGNED NOT NULL DEFAULT 0,
		  PRIMARY KEY (`payment_type_id`, `attribute_id`)
		) ENGINE = InnoDB;
	");
	// payment attributes values
	DB::execute("
		CREATE TABLE `".TABLE_PREFIX."payment_attribute_values` (
		  `expense_id` INTEGER UNSIGNED NOT NULL,
		  `payment_num` INTEGER UNSIGNED NOT NULL,
		  `type_id` int(10) unsigned NOT NULL,
		  `attribute_id` INTEGER UNSIGNED NOT NULL,
		  `value` TEXT NOT NULL,
		  PRIMARY KEY (`expense_id`, `payment_num`, `type_id`, `attribute_id`)
		) ENGINE = InnoDB;
	");
	// type field in payments and payments history
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."payments` ADD COLUMN `type_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;
	");
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."payment_history` ADD COLUMN `type_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;
	");
	// allow to define required attributes and list type values
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."payment_type_attributes`
		 ADD COLUMN `list_values` TEXT NOT NULL,
		 ADD COLUMN `is_required` BOOLEAN NOT NULL;
	");
	// config option to use the date in expense level or in payments level
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
		 ('expenses', 'use_date_in_expense_level', '0', 'BoolConfigHandler', 0, 0, ''),
		 ('expenses', 'default_payment_status', '1', 'PaymentStatusConfigHandler', 0, 0, '')
		ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
	");
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."expenses` ADD COLUMN `date` DATETIME NOT NULL DEFAULT '0000-00-00';
	");
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."expenses_history` ADD COLUMN `date` DATETIME NOT NULL DEFAULT '0000-00-00';
	");
}

function expenses_update_7_8() {
	DB::execute("UPDATE `".TABLE_PREFIX."config_options` SET category_name='expenses' WHERE name IN ('use_date_in_expense_level', 'default_payment_status');");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
		 ('expenses', 'action_for_empty_amounts', 'ask_user', 'SavePromptConfigHandler', 0, 20, '')
		ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
	");
	
}

function expenses_update_8_9() {
	// fix amount db columns
	DB::execute("ALTER TABLE `".TABLE_PREFIX."payments` MODIFY COLUMN `amount` FLOAT(20,3) NOT NULL DEFAULT 0;");
	DB::execute("ALTER TABLE `".TABLE_PREFIX."payment_history` MODIFY COLUMN `amount` FLOAT(20,3) NOT NULL DEFAULT 0;");
}

function expenses_update_9_10() {
	// allow to define negative amounts
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
		 ('expenses', 'allow_negative_amounts', '0', 'BoolConfigHandler', 0, 30, '')
		ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
	");
}


// set payments as content objects
function expenses_update_10_11() {
	// object type
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`) VALUES
		 ('payment', 'Payments', 'payments', 'content_object', 'payment', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='expenses'))
		ON DUPLICATE KEY UPDATE id=id;
	");
	
	// dimension config
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT dotc.dimension_id, dotc.dimension_object_type_id, (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='payment'), 0, 1
		 FROM `".TABLE_PREFIX."dimension_object_type_contents` dotc
		 WHERE dotc.content_object_type_id = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='expense')
		ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."dimension_object_type_contents.dimension_id=".TABLE_PREFIX."dimension_object_type_contents.dimension_id;
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 1, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('payment') AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');
	");
	
	// role permissions
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 0, 0
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('payment') AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 1, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('payment') AND p.`name` IN ('Super Administrator','Administrator','Manager');
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 0, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('payment') AND p.`name` IN ('Executive');
	");
	
	// migration to objects
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."payments` ADD COLUMN `object_id` int(10) unsigned NOT NULL DEFAULT 0 FIRST;
	");
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."payments` ADD INDEX `object_id` (`object_id`);
	");
	
	
	$pot = ObjectTypes::findByName('payment');
	$all_payments = DB::executeAll("SELECT * FROM ".TABLE_PREFIX."payments WHERE object_id=0");
	
	foreach ($all_payments as $p) {
		$exp = Expenses::instance()->getExpense($p['expense_id']);
		
		$object = new Object();
		$object->setObjectTypeId($pot->getId());
		$object->setName($p['description']);
		$object->save();
		
		DB::execute("UPDATE ".TABLE_PREFIX."payments SET object_id=".$object->getId()." WHERE expense_id=".$p['expense_id']." AND payment_num=".$p['payment_num']);
		
		ObjectMembers::addObjectToMembers($object->getId(), $exp->getMembers());
		
		$subscribers = $exp->getSubscribers();
		foreach ($subscribers as $sub) {
			$os = new ObjectSubscription();
			$os->setContactId($sub->getId());
			$os->setObjectId($object->getId());
			$os->save();
		}
	}
	
	// @TODO: migrar payment types a subtipos de objetos con custom properties, si hay payment_types asegurar la instalación de object_subtypes antes de proceder
	
}


function expenses_update_11_12() {
	// change payment amount column to decimal, float is not exact.
	
	// first change to 2 decimals to round the aproximated values.
	DB::execute("ALTER TABLE `".TABLE_PREFIX."payments` CHANGE `amount` `amount` decimal(20,2) NOT NULL DEFAULT '0.000';");
	DB::execute("ALTER TABLE `".TABLE_PREFIX."payment_history` CHANGE `amount` `amount` decimal(20,2) NOT NULL DEFAULT '0.000';");
	
	// now set to 3 decimals again
	DB::execute("ALTER TABLE `".TABLE_PREFIX."payments` CHANGE `amount` `amount` decimal(20,3) NOT NULL DEFAULT '0.000';");
	DB::execute("ALTER TABLE `".TABLE_PREFIX."payment_history` CHANGE `amount` `amount` decimal(20,3) NOT NULL DEFAULT '0.000';");
}

function expenses_update_12_13() {

	DB::execute("ALTER TABLE `".TABLE_PREFIX."payments` ADD INDEX `amount` (`amount`);");
	DB::execute("ALTER TABLE `".TABLE_PREFIX."payment_history` ADD INDEX `amount` (`amount`);");

	if (!check_column_exists(TABLE_PREFIX."payment_history", "payment_id")) {
		
		DB::execute("ALTER TABLE `".TABLE_PREFIX."payment_history` ADD `payment_id` int(10) unsigned NOT NULL;");
		DB::execute("ALTER TABLE `".TABLE_PREFIX."payment_history` ADD INDEX `payment_id` (`payment_id`);");
		
		DB::execute("UPDATE ".TABLE_PREFIX."payment_history SET payment_id=(
			SELECT object_id FROM ".TABLE_PREFIX."payments p 
			WHERE p.expense_id=".TABLE_PREFIX."payment_history.expense_id AND p.payment_num=".TABLE_PREFIX."payment_history.payment_num
		)");
	}
	
}


function expenses_update_13_14() {
	
	// index by date in payments tables
	DB::execute("ALTER TABLE `".TABLE_PREFIX."payments` ADD INDEX `date` (`date`)");
	DB::execute("ALTER TABLE `".TABLE_PREFIX."payment_history` ADD INDEX `date` (`date`)");
	
	// cache table for reduntant expense totals by state and currency
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."expense_totals` (
		  `expense_id` int(11) NOT NULL DEFAULT '0',
		  `status_id` int(11) NOT NULL DEFAULT '0',
		  `currency_id` int(11) NOT NULL DEFAULT '0',
		  `amount` decimal(20,3) NOT NULL DEFAULT '0.000',
		  PRIMARY KEY (`expense_id`,`status_id`,`currency_id`),
		  KEY `currency_id_amount` (`currency_id`,`amount`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	
	// cache table for reduntant payment totals by state and currency
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."payment_totals` (
		  `payment_id` int(11) NOT NULL DEFAULT '0',
		  `status_id` int(11) NOT NULL DEFAULT '0',
		  `currency_id` int(11) NOT NULL DEFAULT '0',
		  `amount` decimal(20,3) NOT NULL DEFAULT '0.000',
		  PRIMARY KEY (`payment_id`,`status_id`,`currency_id`),
		  KEY `currency_id_amount` (`currency_id`,`amount`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	
	ini_set('memory_limit', '1G');
	
	// calculate the payment totals
	$payment_ids = Payments::findAll(array('id' => true));
	foreach ($payment_ids as $id) {
		$e = Payments::findById($id);
		if ($e instanceof Payment && $e->getTrashedById()==0) {
			
			$e->updateCalculatedTotals(false);
		}
	}

	// calculate the expense totals
	$expenses_ids = Expenses::findAll(array('id' => true));
	foreach ($expenses_ids as $id) {
		$e = Expenses::findById($id);
		if ($e instanceof Expense && $e->getTrashedById()==0) {
			
			$e->updateCalculatedTotals();
		}
	}
	
}

// migrate payment type definitions to object subtypes and payment custom properties
function expenses_update_14_15() {
	
	$ptypes_info = PaymentTypes::getAllPaymentTypesInfo();
	if (count($ptypes_info) > 0) {
		
		// ensure that object subtypes is installed and activated
		$controller = new PluginController();
		$controller->ensure_installed_and_activated('object_subtypes');
		
		$ot = ObjectTypes::findByName('payment');
		$ot_id = $ot->getId();
		
		$types_array = array();
		$cps_array = array();
		
		// create object subtypes for each payment type
		foreach ($ptypes_info as $ptype) {
			$subtype = new ObjectSubtype();
			$subtype->setName($ptype['name']);
			$subtype->setObjectTypeId($ot_id);
			$subtype->save();
			$types_array[$ptype['id']] = $subtype->getId();
			
			// create a custom property for each payment type attribute
			foreach ($ptype['attributes'] as $attr) {
				
				$cp = new CustomProperty();
				$cp->setName($attr['name']);
				$cp->setObjectTypeId($ot_id);
				$cp->setType($attr['type']);
				$cp->setIsRequired($attr['is_required']);
				$cp->setValues($attr['list_values']);
				$cp->setOrder($attr['order']);
				$cp->setColumnValue('object_subtype_id', $subtype->getId());
				$cp->save();
				
				$cps_array[$attr['payment_type_id']."_".$attr['attribute_id']] = $cp->getId();
			}
		}
		
		// foreach payment that has any particular type, set its object_subtype_id with the matching subtype
		$payments = Payments::findAll(array('conditions' => "type_id>0"));
		foreach ($payments as $p) {/* @var $p Payment */
			$subtype_id = array_var($types_array, $p->getTypeId());
			if (!$subtype_id) continue;
			
			$p->setColumnValue('object_subtype_id', $subtype_id);
			$p->save();
			
			// foreach payment attribute, create the custom property value that matches
			$type_attributes = $p->getTypeAttributes();
			foreach ($type_attributes as $tattr) { /* @var $tattr PaymentAttributeValue */
				
				$cp_id = array_var($cps_array, $tattr->getTypeId()."_".$tattr->getAttributeId());
				if (!$cp_id) continue;
				
				$cp_val = new CustomPropertyValue();
				$cp_val->setCustomPropertyId($cp_id);
				$cp_val->setObjectId($p->getId());
				$cp_val->setValue($tattr->getValue());
				$cp_val->save();
			}
		}
		
	}
	
}

function expenses_update_15_16() {
	if (!defined('PLUGIN_MANAGER_CONSOLE')) define('PLUGIN_MANAGER_CONSOLE', true);
	$p_controller = new PluginController();
	$p_controller->ensure_installed_and_activated('advanced_core');
}

function expenses_update_16_17() {
	DB::executeAll("
		INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
		 ('expenses', 'copy_exp_classiffication_to_payments', '1', 'BoolConfigHandler', 0, 40, '')
		ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
	");
}

function expenses_update_17_18() {
    if (!check_column_exists(TABLE_PREFIX."expenses_status", "is_temporal")) {
        DB::executeAll("
			ALTER TABLE `".TABLE_PREFIX."expenses_status`
			ADD `is_temporal` tinyint(1) NOT NULL DEFAULT 0;
		");
        
    }
    DB::executeAll("
        INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
            ('widget expenses_graph', 'expenses_graph_unit', 'Default', 'ListConfigHandler', 0, 1, '', 'Default, Millions, Billions'),
            ('widget expenses_graph', 'expenses_graph_date_range', '', 'DateRangeConfigHandler', 0, 1, '', '')
		ON DUPLICATE KEY UPDATE category_name= category_name;
	");
    
}

function expenses_update_18_19() {
	DB::executeAll("
		ALTER TABLE `".TABLE_PREFIX."payments`
		ADD INDEX (`expense_id`, `payment_num`),
		ADD PRIMARY KEY (`object_id`),
		DROP INDEX `PRIMARY`;
	");
}

function expenses_update_19_20() {
    $dataOptions = '
        { "option": [{ "value": "1", "text": "Default" }, { "value": "2", "text": "Millions" }, { "value": "3", "text": "Billions" } ] }
            ';
	DB::executeAll("
		UPDATE `".TABLE_PREFIX."contact_config_options` SET `options` = '".$dataOptions."' WHERE `".TABLE_PREFIX."contact_config_options`.`name` = 'expenses_graph_unit';
	");
        
}

function expenses_update_20_21() {
	DB::execute("
	INSERT INTO `".TABLE_PREFIX."objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`) VALUES
	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report_category'), 'expenses reports', NOW(), 0, NOW(), 0, 0, 0);
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."report_category` (`object_id`,  `description`, `is_default`) VALUES
	((SELECT max(id) FROM ".TABLE_PREFIX."objects WHERE object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report_category')), '', 1);
    ");

    DB::execute("
	INSERT INTO `".TABLE_PREFIX."objects` (`object_type_id`, `name`, `created_on`, `created_by_id`, `updated_on`, `updated_by_id`, `trashed_by_id`, `archived_by_id`) VALUES
	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report'), 'payments report', NOW(), 0, NOW(), 0, 0, 0);
	");

	DB::execute("
	INSERT INTO `".TABLE_PREFIX."reports` (`object_id`, `description`, `report_object_type_id`, `is_order_by_asc`, `ignore_context`, `is_default`, `code`, `function_url`, `report_category_id`) VALUES
	((SELECT max(id) FROM ".TABLE_PREFIX."objects WHERE object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='report')), 'payments report description', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='billing'), 1, 1, 1, 'payments_report', '?c=expense_reports&a=payments_by_state_parameters',(SELECT max(object_id) FROM ".TABLE_PREFIX."report_category));
	");
}

