<?php
Env::useHelper('format');
$info_to_skip = array();
Hook::fire('exclude_budgeted_expense_info', array(), $info_to_skip);
if (isset($expense) && $expense instanceof Expense) {
	$genid = gen_id();
	if (!$expense->isTrashed()){
		if($expense->canEdit(logged_user())) {
			add_page_action(lang('edit'), "javascript:og.render_modal_form('', {c:'expense', a:'edit', params: {id:".$expense->getId()."}});", 'ico-edit', null, null, true);
			if (!$expense->isArchived())
				add_page_action(lang('archive'), "javascript:if(confirm(lang('confirm archive object'))) og.openLink('" . $expense->getArchiveUrl() ."');", 'ico-archive-obj');
			else
				add_page_action(lang('unarchive'), "javascript:if(confirm(lang('confirm unarchive object'))) og.openLink('" . $expense->getUnarchiveUrl() ."');", 'ico-unarchive-obj');
			
			//add_page_action(lang('create copy of this expense'), "javascript:og.render_modal_form('', {c:'expense', a:'copy_expense', params: {id:".$expense->getId()."}});", 'ico-copy', null, null, true);
				
		} // if
		
		if (can_add(logged_user(), $expense->getMembers(), PaymentReceipts::instance()->getObjectTypeId())) {
			add_page_action(lang('add payment receipt'), "javascript:og.render_modal_form('', {c:'payment_receipt', a:'add', params: {expense_id:".$expense->getId()."}});", 'ico-add', null, null, true);
		}
	}
	if ($expense->canDelete(logged_user())) {
		if ($expense->isTrashed()) {
			add_page_action(lang('restore from trash'), "javascript:if(confirm(lang('confirm restore objects'))) og.openLink('" . $expense->getUntrashUrl() ."');", 'ico-restore', null, null, true);
			add_page_action(lang('delete permanently'), "javascript:if(confirm(lang('confirm delete permanently'))) og.openLink('" . $expense->getDeletePermanentlyUrl() ."');", 'ico-delete', null, null, true);
		} else {
			add_page_action(lang('move to trash'), "javascript:if(confirm(lang('confirm move to trash'))) og.openLink('" . $expense->getTrashUrl() ."');", 'ico-trash', null, null, true);
		}
	}
?>

<div style="padding:7px">
<div class="expense">
<?php
	$use_date_in_expense_level = config_option("use_date_in_expense_level");
	
	//$status = ExpensesStatuses::instance()->getStatus($expense->getStatusId());

	
	//This is to retrieve the dimensions that relate to expense items
	//It will be used to list the right columns and checkboxes when rendering the  
	$object_type = ObjectTypes::findByName('expense_item');

	//this worked delete.
	//Logger::log_r("Object Type id = ".$object_type->getId()."\n");
	

	//The following is not working correctly
	$expense_items_dimensions = Dimensions::getAllowedDimensions($object_type->getId());

	//which in turn should use a hook of the advanced_core -> dimension_options_hooks
	//Which in turn should use the BaseDimensionContentObjectOptions to filter out the 'hidden' dimensions for this ObjectType
	//In this case: 'expense_item'.
	
 	//Logger::log_r("Dimensions found: ".count($expense_items_dimensions)."\n");
	
//  	if ( is_array($expense_items_dimensions) && count($expense_items_dimensions) > 0 ) {
//  	    Logger::log_r("Yes! Found the dimensions for expense items. Total dimensions: ".count($expense_items_dimensions)."\n");
//  	    foreach ($expense_items_dimensions as $dimension) {
//  	        Logger::log_r(" Dimension id: ".$dimension['dimension_id']." Dimension name: ".$dimension['dimension_name']."\n");
//  	    }
 	    
//  	}
	
	
	$content = '';
	
	//Not using status property
	//$st_html = '<span class="expense-row-status-'.($status instanceof ExpensesStatus ? $status->getCode() : '').'">'.($status instanceof ExpensesStatus ? lang($status->getCode()) : '').'</span>';
	//$content .= '<div class="expense-property"><span class="bold ">'.lang('status').': </span>'.$st_html.'</div>';
	
	if ($use_date_in_expense_level) {
		$content .= '<div class="expense-property"><span class="bold ">'.lang('date').': </span>'.format_date($expense->getDate(), null, 0).'</div>';
	}
	if(!in_array('billable', $info_to_skip)){
		$content .= '<div class="expense-property"><span class="bold ">'.lang('billable').': </span>'.($expense->getIsBillable() ? lang('yes') : lang('no')).'</div>';
	}
	
	if (trim($expense->getDescription()) != "") {
		$content .= '<div class="expense-property"><span class="bold">'.lang('description').': </span>'.$expense->getDescription().'</div>';
	}
	
	$content .= '<div class="expense-property"><span class="bold">'.lang('items').': </span></div>';
	$content .= '<div id="'.$genid.'_items_grid_container" class="expense-items-grid-container"></div>';

	
	
	
	$content .= '<div class="clear"></div>';
	
	tpl_assign("content", $content);
	tpl_assign("object", $expense);
	tpl_assign('iconclass', $expense->isTrashed()? 'ico-large-expense-trashed' : ($expense->isArchived() ? 'ico-large-expense-archived' : 'ico-large-expense'));
	
	$this->includeTemplate(get_template_path('view', 'co'));

	
	// include payment grid columns and toolbar configuration
	tpl_assign("genid", $genid);
	tpl_assign("expense", $expense);
	$this->includeTemplate(get_template_path('expense_items_grid/columns', 'expense', 'expenses2'));
	$this->includeTemplate(get_template_path('expense_items_grid/toolbar', 'expense', 'expenses2'));
	
?>
</div>
</div>
<style>
.expense-items-grid-container .list-totals-row-container {
	position: relative;
	bottom: inherit;
}

.expense-items-grid-container .x-grid3-cell-inner {
	padding-right: 16px;
}

</style>
<script>

var grid_id = '<?php echo $genid?>_items_grid';


//Removed: dimension_columns: php echo json_encode($expense_items_dimensions); ?>,

//This displays the grid with all the payment items for the expense
var itemsgrid = new og.ObjectGrid({
	renderTo: '<?php echo $genid?>_items_grid_container',
	url: og.getUrl('expense_item', 'list_all'),

	//type_name: 'item',
	//this should be 'expense_item'. Will delete this comment in future edits.
	type_name: 'expense_item',

	name_column_text: lang('product type'),

	response_objects_root: 'expense_items',
	grid_id: grid_id,

	//had to comment this. It was allowing to click the line item in the view, but the system would then throw an error.
	//nameRenderer: og.gridObjectNameRenderer,
	store_params: {
		url_controller: 'expense_item',
		url_action: 'list_all',
		expense_id: <?php echo $expense->getId()?>
	},
	
	//checkbox_sel_model: true,
	//Why would we want to select expense items?
	checkbox_sel_model: false,
	columns: item_columns,
	//dimension_columns: '<?php // echo $expense_items_dimensions['dimension_id'] ?>,
	add_default_actions_column: false,
	tbar_items: tbar_items,
	no_totals_row: true,
	stateId: 'expense-items-list', // to remember the gui state independent of the panel
});

var active_tab = Ext.getCmp('tabs-panel').activeTab;
if (active_tab.events.resize.listeners.length < 2) {
	active_tab.on('resize', function() {
		var g = Ext.getCmp(grid_id)
		if (g) g.fireEvent('resize');
	});
}


itemsgrid.load({
	load_callback: function() {
		og.expenses2.addTotalsRow(Ext.getCmp(grid_id).store, {expense_id:'<?php echo $expense->getId()?>'}, grid_id);
	}
});

</script>

<?php } //if isset ?>
