<?php
	$genid = gen_id();
	$object = $product_type;
	/* @var $object ProductType */
	
	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.submit_modal_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	
	$rate_enabled = $object->isNew() || $object->getEnableRate();
	$cost_enabled = $object->isNew() || $object->getEnableCost();
	
	$amount_decimals = config_option('product_type_decimals');
?>

<form onsubmit="<?php echo $on_submit?>" class="add-product_type" id="<?php echo $genid ?>submit-edit-form" action="<?php echo $product_type->isNew() ? get_url('product_type', 'add') : get_url('product_type', 'edit', array('id' => $product_type->getId())) ?>" method="post" enctype="multipart/form-data">
<div class="product_type">

<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $product_type->isNew() ? lang('new product type') : lang('edit product type') ?>
	</div>
  </div>

  <div>
	<div class="coInputButtons" style="float:right;">
		<?php echo submit_button($product_type->isNew() ? lang('add product type') : lang('save changes'),'s',array('style'=>'margin-top:0px;margin-left:10px')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>

<div class="coInputMainBlock">
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_product_type_details"><?php echo lang('details') ?></a></li>
			<li><a href="#<?php echo $genid?>add_product_type_description"><?php echo lang('description') ?></a></li>
			
		</ul>

		
		<div id="<?php echo $genid ?>add_product_type_details" class="editor-container form-tab">
			
			<div class="dataBlock"><?php 
				echo label_tag(lang('name'), $genid . 'product_type_title');
				echo text_field('product_type[name]', $object->getName(),
					array('id' => $genid . 'product_type_title', 'class' => 'title', 'placeholder' => lang('type name here')));
			?></div>
			
			<div class="dataBlock <?php echo ($cost_enabled ? "" : "block-disabled")?>" id="<?php echo $genid?>cost_def"><?php 
				echo currency_selector('product_type[cost_currency_id]', $object->getCostCurrencyId(), array('id' => $genid.'costCurrencyId'));
				echo label_tag(lang('cost'), $genid . 'product_type_cost');
				?>
				<input class="money" id="<?php echo $genid?>product_type_cost" name="product_type[hourly_cost]" value="<?php echo number_format($object->getHourlyCost(), $amount_decimals)?>"/>
				
				<input type="checkbox" name="product_type[enable_cost]" <?php echo ($cost_enabled ? 'checked="checked"' : '') ?> id="<?php echo $genid?>cost_enabled"
					onchange="og.product_types.def_ratecost_toggle('<?php echo $genid?>','cost',this);" /> 
					<?php echo label_tag(lang('enabled'), $genid."cost_enabled", false, array('style' => 'display:inline;float:none;'))?>
			</div>
			
			<div class="dataBlock"><?php 
				echo label_tag(lang('use price multiplier'), $genid . 'uses_price_multiplier');
				?>
				<input type="checkbox" name="product_type[uses_price_multiplier]" <?php echo ($object->getUsesPriceMultiplier() ? 'checked="checked"' : '') ?> id="<?php echo $genid?>uses_price_multiplier"
						onchange="og.product_types.price_multiplier_toggle('<?php echo $genid?>', this);" />
			</div>
			
			<div class="dataBlock <?php echo ($rate_enabled ? "" : "block-disabled")?>" id="<?php echo $genid?>rate_def" style="<?php echo ($object->getUsesPriceMultiplier() ? "display:none;" : "")?>"><?php 
				echo currency_selector('product_type[rate_currency_id]', $object->getRateCurrencyId(), array('id' => $genid.'rateCurrencyId'));
				echo label_tag(lang('price'), $genid . 'product_type_rate');
				?>
				<input class="money" id="<?php echo $genid?>product_type_rate" name="product_type[hourly_rate]" value="<?php echo number_format($object->getHourlyRate(), $amount_decimals)?>"/>
				
				<input type="checkbox" name="product_type[enable_rate]" <?php echo ($rate_enabled ? 'checked="checked"' : '') ?> id="<?php echo $genid?>rate_enabled"
					onchange="og.product_types.def_ratecost_toggle('<?php echo $genid?>','rate',this);" /> 
					<?php echo label_tag(lang('enabled'), $genid."rate_enabled", false, array('style' => 'display:inline;float:none;'))?>
			</div>
			
			<div class="dataBlock" id="<?php echo $genid?>price_multiplier" style="<?php echo ($object->getUsesPriceMultiplier() ? "" : "display:none;")?>"><?php 
				echo label_tag(lang('price multiplier'), $genid . 'product_type_rate');
				?>
				<input class="amount" id="<?php echo $genid?>product_type_rate" name="product_type[price_multiplier]" value="<?php echo number_format($object->getPriceMultiplier(), $amount_decimals)?>"/>
			</div>
		
			
		<?php
			$allowed_dimension_ids = config_option('product_type_dimensions');
			$allowed_dimension_ids = array_filter($allowed_dimension_ids, 'is_numeric');
			if (is_array($allowed_dimension_ids) && count($allowed_dimension_ids) > 0) {
				$dimensions = Dimensions::findAll(array('conditions' => "id IN (".implode(',', $allowed_dimension_ids).")"));
			} else {
				$dimensions = array();
			}
			
			if (!isset($selected_members)) $selected_members = array();
			
			foreach ($dimensions as $dimension) {
				$gid = $genid."-".$dimension->getId();
				
				render_single_member_selector($dimension, $gid, $selected_members, array(
					'allow_non_manageable' => true,
					'is_multiple' => false,
					'root_lang' => lang('All'),
					'width' => 400,
					'hidden_field_name' => "product_type[dim_".$dimension->getId()."][member_id]",
				), false);

				echo '<div class="clear"></div>';
			}
		?>

			<div class="dataBlock"><?php 
				echo label_tag(lang('reimbursable'));
				?>
				<input type="checkbox" name="product_type[is_reimbursable]" <?php echo ($object->getIsReimbursable() ? 'checked="checked"' : '') ?> id="<?php echo $genid?>is_reimbursable" />
			</div>

		<?php
			$null = null;
			Hook::fire('product_type_form_more_inputs', array('product_type' => $object, 'genid' => $genid), $null);
		?>

		</div>
		
		<div id="<?php echo $genid ?>add_product_type_description" class="editor-container form-tab">
			<textarea name="product_type[description]" style="width:99%; height:200px;"><?php echo $object->getDescription();?></textarea>
		</div>
		
	</div>

	
	<?php if (!array_var($_REQUEST, 'modal')) {
		echo submit_button($product_type->isNew() ? lang('add product_type') : lang('save changes'),'s', array('style'=>'margin-top:0px')); 
	}?>
</div>
</div>
</form>
<script>
$(function() {
	var genid = '<?php echo $genid?>';

	$(".product_type input.money").change(function(){
		var money = $(this).val();
		if (isNaN(money)) {
			$(this).val("0.00");
		}
	});
	
	$("#"+ genid +"tabs").tabs();

	
});
</script>