<?php 
if (!isset($genid)) $genid = gen_id();
?>

<div class="widget-expenses widget">

	<div class="widget-header" onclick="og.dashExpand('<?php echo $genid?>');">
		<div class="widget-title"><?php echo (isset($widget_title)) ? $widget_title : lang("expenses");?></div>
		<div class="dash-expander ico-dash-expanded" id="<?php echo $genid; ?>expander"></div>
    </div>
	
	<div class="widget-body" id="<?php echo $genid; ?>_widget_body">
		<?php 
		$chart_data_array = array();
		foreach($amounts_by_day as $key => $value){
			$chart_data_array[]=$value;
		}
		$actual_title = lang('actual expenses');
		$budgeted_title = lang('budgeted expenses');
		$date_format = convertPHPToMomentFormat(user_config_option('date_format'));
		$currency_symbol = config_option('currency_code', '$');
		$decimals = user_config_option('decimal_digits');
		$decimals_separator = user_config_option('decimals_separator');
		$thousand_separator = user_config_option('thousand_separator');
		?>
		<div id="expenses-progress-chart"></div>
		<script>	
			/** convert $chart_data_array to json format */
			var chartData = <?php echo json_encode($chart_data_array); ?>;
			/** Prepare data to pass to showExpensesProgressWidget() */
			var dataForComponent = {
						currencySymbol: <?php echo json_encode($currency_symbol) ?>,
						dateFormat: <?php echo json_encode($date_format); ?>,
						actual: <?php echo $last_actual_amount ?>,
						budgeted: <?php echo $last_budgeted_amount; ?>,
						actualTitle: <?php echo json_encode($actual_title) ?>,
						budgetedTitle: <?php echo json_encode($budgeted_title) ?>,
						chartData: chartData,
						decimals: <?php echo $decimals; ?>,
						decimalsSeparator: '<?php echo $decimals_separator; ?>',
						thousandSeparator: '<?php echo $thousand_separator; ?>'
					}
			/**
			* Pass data to showExpensesProgressWidget.
			* Returns React component that builds widget with the passed data
			* to the element with id "expenses-progress-chart".
			* It can be found in public/assets/javascript/react_src/showExpensesProgressWidget.js
			* */ 
			showExpensesProgressWidget(dataForComponent, document.getElementById('expenses-progress-chart'));
		</script>
	</div>
	
</div>