-- <?php echo $table_prefix ?> fo_
-- <?php echo $default_charset ?> DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci
-- <?php echo $default_collation ?> collate utf8_unicode_ci
-- <?php echo $engine ?> InnoDB
-- varchar cannot be larger than 256
-- blob/text cannot have default values
-- sql queries must finish with ;\n (line break inmediately after ;)

-- ***************** UNINSTALL OLD EXPENSES PLUGIN *****************

-- DELETE RECORDS
DELETE FROM <?php echo $table_prefix ?>objects WHERE object_type_id IN (
	SELECT id FROM <?php echo $table_prefix ?>object_types WHERE `name` IN ('expense','payment')
);
DELETE FROM <?php echo $table_prefix ?>dimension_object_type_contents WHERE content_object_type_id IN (
	SELECT id FROM <?php echo $table_prefix ?>object_types WHERE `name` IN ('expense','payment')
);
DELETE FROM <?php echo $table_prefix ?>max_role_object_type_permissions WHERE object_type_id IN (
	SELECT id FROM <?php echo $table_prefix ?>object_types WHERE `name` IN ('expense','payment')
);
DELETE FROM <?php echo $table_prefix ?>role_object_type_permissions WHERE object_type_id IN (
	SELECT id FROM <?php echo $table_prefix ?>object_types WHERE `name` IN ('expense','payment')
);
DELETE FROM <?php echo $table_prefix ?>contact_member_permissions WHERE object_type_id IN (
	SELECT id FROM <?php echo $table_prefix ?>object_types WHERE `name` IN ('expense','payment')
);
DELETE FROM <?php echo $table_prefix ?>object_types WHERE `name` IN ('expense','payment');
DELETE FROM <?php echo $table_prefix ?>config_options WHERE `category_name`='expenses';
DELETE FROM <?php echo $table_prefix ?>contact_config_options WHERE `category_name`='widget expenses_graph';
DELETE FROM <?php echo $table_prefix ?>widgets WHERE `name`='expenses_graph';
DELETE FROM <?php echo $table_prefix ?>tab_panels WHERE `id`='expenses-panel';

DELETE FROM `<?php echo $table_prefix ?>reports` WHERE `code`='payments_report' AND function_url='?c=expense_reports&a=payments_by_state_parameters';

-- DELETE TABLES
DROP TABLE IF EXISTS <?php echo $table_prefix ?>expenses;
DROP TABLE IF EXISTS <?php echo $table_prefix ?>payments;
DROP TABLE IF EXISTS <?php echo $table_prefix ?>expenses_history;
DROP TABLE IF EXISTS <?php echo $table_prefix ?>payment_history;
DROP TABLE IF EXISTS <?php echo $table_prefix ?>payment_types;
DROP TABLE IF EXISTS <?php echo $table_prefix ?>payment_type_attributes;
DROP TABLE IF EXISTS <?php echo $table_prefix ?>payment_attribute_values;
DROP TABLE IF EXISTS <?php echo $table_prefix ?>expenses_status;
DROP TABLE IF EXISTS <?php echo $table_prefix ?>expense_totals;
DROP TABLE IF EXISTS <?php echo $table_prefix ?>payment_totals;

-- UNINSTALL PLUGIN
UPDATE <?php echo $table_prefix ?>plugins SET is_installed=0, is_activated=0 WHERE `name`='expenses';

-- ****************************************************************

-- CREATE TABLES

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>expenses` (
  `object_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `description` text NOT NULL,
  `status_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `currency_id` int(10) UNSIGNED NOT NULL DEFAULT 0,
  `invoicing_status_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `date` datetime NOT NULL,
  `is_billable` tinyint(1) NOT NULL,
  PRIMARY KEY (`object_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;



CREATE TABLE  `<?php echo $table_prefix ?>expense_items` (
  `object_id` int(10) unsigned NOT NULL,
  `expense_id` int(10) unsigned NOT NULL DEFAULT 0,
  `date` datetime NOT NULL,
  `description` text <?php echo $default_collation ?> NOT NULL,
  `quantity` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `product_type_id` int(10) unsigned NOT NULL DEFAULT 0, -- id in product_types table
  `currency_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `unit_cost` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `total_cost` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `price_multiplier` decimal(20,3) unsigned NOT NULL DEFAULT 1,
  `unit_price` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `total_price` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`object_id`),
  KEY `expense_id` (`expense_id`),
  KEY `product_type_id` (`product_type_id`,`expense_id`),
  KEY `date` (`date`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE  `<?php echo $table_prefix ?>expenses_history` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `object_id` int(10) unsigned NOT NULL,
  `name` text <?php echo $default_collation ?> NOT NULL,
  `description` text <?php echo $default_collation ?> NOT NULL,
  `user_id` int(10) unsigned NOT NULL,
  `modification_date` datetime NOT NULL,
  `status_id` int(10) unsigned NOT NULL,
  `date` datetime NOT NULL,
  `status_name` varchar(128) <?php echo $default_collation ?> NOT NULL,
  `modification_log` text <?php echo $default_collation ?> NOT NULL,
  PRIMARY KEY (`id`),
  KEY `expense` (`object_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE  `<?php echo $table_prefix ?>expense_items_history` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `object_id` int(10) unsigned NOT NULL,
  `expense_id` int(10) unsigned NOT NULL,
  `date` datetime NOT NULL,
  `name` text <?php echo $default_collation ?> NOT NULL,
  `description` text <?php echo $default_collation ?> NOT NULL,
  `quantity` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `product_type_id` int(10) unsigned NOT NULL DEFAULT 0,
  `currency_id` int(10) unsigned NOT NULL,
  `unit_cost` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `total_cost` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `price_multiplier` decimal(20,3) unsigned NOT NULL DEFAULT 1,
  `unit_price` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `total_price` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `user_id` int(10) unsigned NOT NULL,
  `modification_date` datetime NOT NULL,
  `modification_log` text <?php echo $default_collation ?> NOT NULL,
  PRIMARY KEY (`id`),
  KEY `object_id` (`object_id`),
  KEY `expense_id` (`expense_id`),
  KEY `date` (`date`),
  KEY `user_id` (`user_id`),
  KEY `modification_date` (`modification_date`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>expenses_status` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `order` int(10) unsigned NOT NULL,
  `code` varchar(128) NOT NULL,
  `name` varchar(128) NOT NULL,
  `description` text NOT NULL,
  `editable` tinyint(1) NOT NULL,
  `created_on` datetime NOT NULL,
  `created_by_id` int(10) unsigned NOT NULL,
  `enabled` tinyint(1) NOT NULL,
  `is_final` tinyint(1) NOT NULL,
  `is_temporal` tinyint(1) NOT NULL,
  `only_for_expenses` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `order` (`order`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;



CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>expense_totals` (
  `expense_id` int(11) NOT NULL DEFAULT '0',
  `status_id` int(11) NOT NULL DEFAULT '0',
  `currency_id` int(11) NOT NULL DEFAULT '0',
  `unit_cost` decimal(20,3) unsigned NOT NULL DEFAULT 0.00,
  `total_cost` decimal(20,3) unsigned NOT NULL DEFAULT 0.00,
  `unit_price` decimal(20,3) unsigned NOT NULL DEFAULT 0.00,
  `total_price` decimal(20,3) unsigned NOT NULL DEFAULT 0.00,
  PRIMARY KEY (`expense_id`,`status_id`,`currency_id`)
) ENGINE = <?php echo $engine ?> <?php echo $default_charset ?>;




CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>product_types` (
  `id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(255) <?php echo $default_collation ?> NOT NULL,
  `description` text <?php echo $default_collation ?> NOT NULL,
  `user_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `rate_currency_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `hourly_rate` DECIMAL(20,3) NOT NULL DEFAULT 0,
  `cost_currency_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `hourly_cost` DECIMAL(20,3) NOT NULL DEFAULT 0,
  `enable_rate` tinyint(1) NOT NULL DEFAULT '1',
  `enable_cost` tinyint(1) NOT NULL DEFAULT '1',
  `price_multiplier` decimal(20,3) unsigned NOT NULL DEFAULT 1,
  `uses_price_multiplier` tinyint(1) NOT NULL DEFAULT 0,
  `created_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `created_on` datetime NOT NULL default '0000-00-00 00:00:00',
  `updated_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `updated_on` datetime NOT NULL default '0000-00-00 00:00:00',
  `is_reimbursable` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  INDEX `name`(`name`),
  INDEX `cost`(`cost_currency_id`, `hourly_cost`),
  INDEX `rate`(`rate_currency_id`, `hourly_rate`),
  INDEX `user_id`(`user_id`)
) ENGINE = <?php echo $engine ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>product_type_members` (
  `product_type_id` int(10) unsigned NOT NULL,
  `dimension_id` int(10) NOT NULL DEFAULT '0',
  `member_id` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`product_type_id`,`dimension_id`,`member_id`)
) ENGINE = <?php echo $engine ?>;


CREATE TABLE  `<?php echo $table_prefix ?>payment_receipts` (
  `object_id` int(10) unsigned NOT NULL,
  `expense_id` int(10) unsigned NOT NULL DEFAULT 0,
  `status_id` int(10) unsigned NOT NULL DEFAULT 0,
  `date` datetime NOT NULL,
  `description` text <?php echo $default_collation ?> NOT NULL,
  `product_type_id` int(10) unsigned NOT NULL DEFAULT 0, -- id in product_types table
  `currency_id` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `amount` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `document_id` varchar(255) NOT NULL DEFAULT '',
  `is_billable` tinyint(1) NOT NULL,
  `paid_by_id` int(10) unsigned NOT NULL DEFAULT 0,
  `quantity` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `unit_cost` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `unit_price` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `total_price` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `price_multiplier` decimal(20,3) unsigned NOT NULL DEFAULT 1,
  `total_cost_without_taxes` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `expense_type` varchar(100) NOT NULL DEFAULT 'reimbursable',
  `due_date` datetime NOT NULL,
  `payment_term_id` int(10) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`object_id`),
  KEY `expense_id` (`expense_id`),
  KEY `product_type_id` (`product_type_id`,`expense_id`),
  KEY `date` (`date`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;



CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>actual_expense_taxes` (
  `id` int NOT NULL AUTO_INCREMENT PRIMARY KEY,
  `name` varchar(255) <?php echo $default_collation ?> NOT NULL,
  `value` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `is_percentage` tinyint(1) NOT NULL,
  `valid_from` datetime NOT NULL,
  `valid_to` datetime NOT NULL,
  `currency_id` int(10) NOT NULL DEFAULT 0,
  `select_by_default` tinyint(1) NOT NULL
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>actual_expense_tax_values` (
  `tax_id` int(10) NOT NULL,
  `object_id` int(10) NOT NULL,
  `applied_value` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  `value` decimal(20,3) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`tax_id`,`object_id`),
  KEY `object_id` (`object_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;
