og.expenses2 = {
	
	init: function() {
		og.openLink(og.getUrl('expense', 'get_expense_status'), {callback: function(success, data){
			og.expenses2.all_status = [];
			for (x=0; x<data.status.length; x++) {
				var st = data.status[x];
				if (st.only_for_expenses) continue;
				og.expenses2.all_status.push(st);
			}
			og.expenses2.next_status_config = data.next_status_config;
		}});
		
		og.openLink(og.getUrl('expense', 'get_disabled_subtabs'), {callback: function(success, data){
			if (success) {
				og.expenses2.disabled_subtabs = data.disabled_subtabs;
			}
		}});
		
		og.openLink(og.getUrl('payment_receipt', 'get_list_config'), {
			preventPanelLoad: true,
			callback: function(success, data){
				eval(data.html);
				return;
			}
		});
		
		/*
		og.openLink(og.getUrl('expense_item', 'get_expense_item_list_config'), {
			preventPanelLoad: true,
			callback: function(success, data){
				eval(data.html);
				return;
			}
		});*/
		
		og.product_types.reload_allowed_dimensions();
		
		og.eventManager.addListener('load input events', function(data){
			for (var i= 0; i < data.length; i++){
				switch( data[i] ) {

					case "expenses_graph_unit":
						$("#list_"+data[i]).change( function() {
							og.openLink(og.getUrl('object', 'set_user_config_option_value', {config_option_name: 'expenses_graph_unit', config_option_value: $(this).val()}), {preventPanelLoad: true, hideLoading: true});
							og.eventManager.fireEvent('reload current panel');
							$("#quick-form").fadeOut();
						});
						break;
					case "expenses_graph_date_range":
						var html = '<button id="btn_apply_date_range_expenses_graph">'+lang('apply date range button')+'</button>';
					    $('.expenses_graph_date_range.date-range-container').append(html);
					          
						$("#date_range_type_"+data[i]).change( function(){
	    					var data_values = { type: $(this).val(), range_start: '', range_end: ''};
	    					if ( $(this).val() != "range" ) {
	    						og.openLink(og.getUrl('object', 'set_user_config_option_value', {config_option_name: 'expenses_graph_date_range', config_option_value: Ext.util.JSON.encode(data_values) }), {preventPanelLoad: true, hideLoading: true});
	    						og.eventManager.fireEvent('reload current panel');
	    						$("#quick-form").fadeOut();
	    					}
						});
						break;
						
				}
		
			}
			
			$("#btn_apply_date_range_expenses_graph").click(function() {
				var data_values = { type: $("#date_range_type_expenses_graph_date_range").val(), range_start: $("#date_range_start_expenses_graph_date_range").val(), range_end: $("#date_range_end_expenses_graph_date_range").val()};

				og.openLink(og.getUrl('object', 'set_user_config_option_value', {config_option_name: 'expenses_graph_date_range', config_option_value: Ext.util.JSON.encode(data_values) }), {preventPanelLoad: true, hideLoading: true, callback: function(success){
					if (success) og.eventManager.fireEvent('reload current panel');
				}});
				
				$("#quick-form").fadeOut();
			});
			
		});

		// Add 'budgeted revenue' and 'budgeted cost' columns to the project list
		og.openLink(og.getUrl('project', 'get_dimension_info'), {
			callback: function(success, data) {
				if (!data || !data.dim_info) return;
				og.projects.dimension_id = data.dim_info.dimension_id;
				og.projects.object_type_id = data.dim_info.object_type_id;

				og.eventManager.fireEvent('after get projects dimension info', data.dim_info);

				var dim = data.dim_info; 
				if (!og.listing_member_type_cols) og.listing_member_type_cols = [];
				if (!og.listing_member_type_cols[dim.dimension_id]) og.listing_member_type_cols[dim.dimension_id] = [];
				if (!og.listing_member_type_cols[dim.dimension_id][dim.object_type_id]) og.listing_member_type_cols[dim.dimension_id][dim.object_type_id] = [];

				// Estimated values
				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_expense_billable_price',
					name: lang('estimated expense billable price'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_expense_non_billable_price',
					name: lang('estimated expense non-billable price'),
					renderer: og.clean,
					hidden: true
				});


				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_expense_total_price',
					name: lang('estimated expense total price'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_expense_billable_cost',
					name: lang('estimated expense billable cost'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_expense_non_billable_cost',
					name: lang('estimated expense non-billable cost'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'estimated_expense_total_cost',
					name: lang('estimated expense total cost'),
					renderer: og.clean,
					hidden: true
				});

				// Executed values
				/*og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_expense_billable_price',
					name: lang('executed expense billable price'),
					renderer: og.clean,
					hidden: true
				});*/

				/*og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_expense_non_billable_price',
					name: lang('executed expense non-billable price'),
					renderer: og.clean,
				});*/


				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_expense_total_price',
					name: lang('executed expense total price'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_expense_billable_cost',
					name: lang('executed expense billable cost'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_expense_non_billable_cost',
					name: lang('executed expense non-billable cost'),
					renderer: og.clean,
					hidden: true
				});

				og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
					id: 'executed_expense_total_cost',
					name: lang('executed expense total cost'),
					renderer: og.clean,
					hidden: true
				});
			}
		});
	},
	
	loadSubtab: function (t) {
		if (this.load_subtab_functions && this.load_subtab_functions.length > 0) {
			for (var i=0; i<this.load_subtab_functions.length; i++) {
				var fn = this.load_subtab_functions[i];
				if (typeof(fn) == 'function') {
					fn.call(null, t);
				}
			}
		}
	},
	
	buildExpenseItemsTableRowHtml: function(expense_item, alt, column_model) {
		
		var cell_class = ' expense-subtable';
		if (alt) cell_class += ' alt';
		
		var row_html = '<tr class="expense-subtable-row">';
		
		var extra_expense_amount_columns = [];
		if (og.extra_expense_list_columns && og.extra_expense_list_columns.length>0) {
			for (var i=0; i<og.extra_expense_list_columns.length; i++) {
				var tmp = og.extra_expense_list_columns[i];
				if (tmp && tmp.id && tmp.id != 'invoicing_status') extra_expense_amount_columns.push(tmp.id);
			}
		}
		
		for (var i=0; i<column_model.config.length; i++) {
			var col = column_model.config[i];
			if (col.hidden) {
				continue;
			}

			if (col.id == 'checker' || col.id == 'draghandle' || col.id == 'expand' || col.id == 'icon' || col.id == 'is_billable') {
				if (col.id.indexOf('dim_') == 0) {
					row_html += '<td class="x-grid3-col x-grid3-cell'+ cell_class +'"></td>';
				} else {
					row_html += '<td></td>';
				}
			
			} else if (col.id == 'name') {
				
				var item_name_to_show = expense_item.name;
				/*var product_type = null;
				if (expense_item.product_type_id) {
					product_type = og.product_types.get_by_id(expense_item.product_type_id);
				}
				if (product_type) {
					item_name_to_show += ' (' + product_type.name + ')';
				}*/
				//var link = '<a href="javascript:og.render_modal_form(\'\', {c:\'expense_item\', a:\'edit\', params:{id:'+expense_item.id+'}});">'+ expense_item.name +'</a>';
				var link = '<a href="javascript:og.openLink(og.getUrl(\'expense\', \'view\', {id:'+expense_item.expense_id+'}));">'+ item_name_to_show +'</a>';
				
				row_html += '<td class="x-grid3-col x-grid3-cell'+ cell_class +'"><div class="x-grid3-cell-inner">'+ link +'</div></td>';
			
			} else if (col.id == 'status_id' || col.id == 'invoicing_status') {
				row_html += '<td class="x-grid3-col x-grid3-cell'+ cell_class +'"><div class="x-grid3-cell-inner"></div></td>'
			
			} else if (col.id == 'date') {
				row_html += '<td class="x-grid3-col x-grid3-cell'+ cell_class +'"><div class="x-grid3-cell-inner" style="text-align:center;">'+expense_item.date+'</div></td>'
			
			} else if (col.id.indexOf('total_') == 0 || extra_expense_amount_columns.indexOf(col.id) != -1) {
				
				row_html += '<td class="x-grid3-col x-grid3-cell'+ cell_class +'"><div class="x-grid3-cell-inner">';
				
				var detail_col = col.id.replace('total', 'unit');
				
				var total_str = expense_item['currency_sym'] + " " + expense_item[col.id].toFixed(expense_item.amount_decimals);
				
				var detail_str = expense_item['quantity'] +  ' x ';
				detail_str += expense_item['currency_sym'] + " " + expense_item[detail_col].toFixed(expense_item.amount_decimals);
				
				row_html += '<span style="float:right">' + detail_str + " = " + total_str + '</span>';
				
				row_html += '</div></td>';
				
			} else if (col.id.indexOf('dim_') == 0) {
				var dim_id = col.id.substring(4);
				row_html += "<td class='x-grid3-col x-grid3-cell"+ cell_class +"'>" + (typeof(expense_item[col.id])!='undefined' ? expense_item[col.id] : "") + '</td>';
			}
			
		}

		row_html += '</tr>';
		
		return row_html;
	},
	
	buildExpenseItemsTable: function(el, expense_items) {
		if (!expense_items) return;
		
		var column_model = Ext.getCmp('expense-manager').getColumnModel();
		for (var i=0; i<expense_items.length; i++) {
			var alt = i % 2 != 0;
			var html = og.expenses2.buildExpenseItemsTableRowHtml(expense_items[i], alt, column_model);
			
			var other_pay_rows = $('#'+el.id).closest('tr').siblings(".expense-subtable-row");
			if (other_pay_rows.length > 0) {
				$(other_pay_rows).last().after(html);
			} else {
				$('#'+el.id).closest('tr').after(html);
			}
		}
		
	},
	
	requestExpenseItems: function(el, object_id) {
		$('#'+el.id).removeClass('ico-expand-lens').addClass('ico-collapse-lens');
		el.setAttribute('onclick', 'og.expenses2.collapseSubtable(this);');
		
		og.openLink(og.getUrl('expense','get_expense_items',{id:object_id}), {
			callback: function (success, data) {
				og.expenses2.buildExpenseItemsTable(el, data.expense_items);
				og.eventManager.fireEvent('replace all empty breadcrumb', null);
			}
		});
	},
	
	collapseSubtable: function(el) {
		$('#'+el.id).parent('.x-grid3-row-table').children('.expense-subtable-row').hide();
		var table = $('#'+el.id).closest('.x-grid3-row-table').get(0);
		for (i=0; i<table.rows.length; i++) {
			if (table.rows[i].className == 'expense-subtable-row') table.rows[i].style.display = 'none';
		}

		$('#'+el.id).removeClass('ico-collapse-lens').addClass('ico-expand-lens');
		el.setAttribute('onclick', 'og.expenses2.expandSubtable(this);');
	},
	
	expandSubtable: function(el) {
		$('#'+el.id).parent('.x-grid3-row-table').children('.expense-subtable-row').hide();
		var table = $('#'+el.id).closest('.x-grid3-row-table').get(0);
		for (i=0; i<table.rows.length; i++) {
			if (table.rows[i].className == 'expense-subtable-row') table.rows[i].style.display = '';
		}
		
		$('#'+el.id).removeClass('ico-expand-lens').addClass('ico-collapse-lens');
		el.setAttribute('onclick', 'og.expenses2.collapseSubtable(this);');
	},

	addExpenseItemTableRow: function(table_id, values, genid) {
		var table = document.getElementById(table_id);
		var table_type = 'expense_items';
		var len = table.rows.length;
		var pos = len - 1;
		var row = table.insertRow(len);
		var row_id = Math.floor((Math.random()*10000)+1);

		if (table.max_num) {
			num = parseInt(table.max_num) + 1;
		} else if (values && values.num) {
			num = parseInt(values.num);
			if (!table.max_num) table.max_num = num;
		} else {
			table.max_num = 0;
			num = 1;
		}
		if (parseInt(table.max_num) < num) table.max_num = num;
		
		row.id = row_id;
		row.className = (len % 2 == 0) ? 'alt' : '';
		
		var columnsToSkip = og.columns_to_hide_in_expenses ? og.columns_to_hide_in_expenses : [];

		// item id
		var id = values && values.id ? values.id : '';
		// price multiplier
		var pm = values && values.price_multiplier ? values.price_multiplier : '1';
		

		
		// product_type_id
		var cellpt = row.insertCell(row.cells.length);
		var product_type_id = values && values.product_type_id ? values.product_type_id : '';
		var pt_options = ['<option value=""></option>'];
		
		var product_types = og.expenses2.product_types;

		
		
		if (og.expenses2.filtered_product_types) {
			product_types = og.expenses2.filtered_product_types;
		}
		
		
		for (i=0; i<product_types.length; i++) {
			var c = product_types[i];
			var sel = product_type_id == c.id ? 'selected="selected"' : '';
			pt_options += '<option '+sel+' value="'+ c.id +'">'+ c.name +'</option>';
		}
		var cell_id = genid + '_' + pos + '_product_type_id';
		cellpt.innerHTML = '<select id="'+cell_id+'" class="product_type_selector" type="text" name="expense['+table_type+']['+pos+'][product_type_id]" onchange="og.expenses2.onItemProductTypeChange(\''+genid+'\', '+pos+')" style="width:100%;max-width:200px;">' + pt_options + '</select>';
		

		// quantity
		var celluc = row.insertCell(row.cells.length);
		var quantity = values && values.quantity ? values.quantity : '';
		var cell_id = genid + '_' + pos + '_quantity';
		celluc.innerHTML += '<input type="text" id="'+cell_id+'" class="short" name="expense['+table_type+']['+pos+'][quantity]" value="'+quantity+'" onchange="og.expenses2.updateItemTotals(\''+genid+'\', '+pos+')"/>';
		
		// description
		var description = values && values.desc ? values.desc : '';
		var celld = row.insertCell(row.cells.length);
		var desc_style = og.expenses2.use_date_in_expense_level ? "width: 98%;" : "";
		celld.innerHTML = '<input type="text" name="expense['+table_type+']['+pos+'][description]" value="'+description+'" style="'+desc_style+'"/>';

		celld.innerHTML += '<input type="hidden" name="expense['+table_type+']['+pos+'][num]" value="'+num+'"/>';
		celld.innerHTML += '<input type="hidden" name="expense['+table_type+']['+pos+'][id]" value="'+id+'" class="exp-item-id"/>';

		var pm_id = genid + '_' + pos + '_price_multiplier';
		celld.innerHTML += '<input id="'+pm_id+'" type="hidden" name="expense['+table_type+']['+pos+'][price_multiplier]" value="'+pm+'"/>';
		
		// date
		if (!og.expenses2.use_date_in_expense_level) {
			var celldate = row.insertCell(row.cells.length);
			celldate.className += 'date';
			var dateInput = new og.DateField({
				renderTo: celldate,
				width: 80,
				name: 'expense['+table_type+']['+pos+'][date]'
			});
			if (values && values.date) dateInput.setValue(values.date);
		}
		
		// unit cost
		var celluc = row.insertCell(row.cells.length);
		var amount = values && values.unit_cost ? values.unit_cost : '';
		var cell_id = genid + '_' + pos + '_unit_cost';
		var hiddenCost = values && values.show_cost_info ? '' : 'hidden';
		celluc.innerHTML += '<input type="text" '+hiddenCost+' id="'+cell_id+'" class="amount" name="expense['+table_type+']['+pos+'][unit_cost]" value="'+amount+'" onchange="og.expenses2.updateItemTotalCost(\''+genid+'\', '+pos+')"/>';
		
		// total cost
		var celltc = row.insertCell(row.cells.length);
		var amount = values && values.total_cost ? values.total_cost : '';
		var cell_id = genid + '_' + pos + '_total_cost';
		var hiddenCost = values && values.show_cost_info ? '' : 'hidden';
		celltc.innerHTML += '<input type="text" '+hiddenCost+' id="'+cell_id+'" class="amount" name="expense['+table_type+']['+pos+'][total_cost]" value="'+amount+'"/>';
		
		if(!columnsToSkip.includes('unit_price')){
			// unit price
			var cellup = row.insertCell(row.cells.length);
			var amount = values && values.unit_price ? values.unit_price : '';
			var cell_id = genid + '_' + pos + '_unit_price';
			var hiddenPrice = values && values.show_billing_info ? '' : 'hidden';
			cellup.innerHTML += '<input type="text" '+hiddenPrice+' id="'+cell_id+'" class="amount" name="expense['+table_type+']['+pos+'][unit_price]" value="'+amount+'" onchange="og.expenses2.updateItemTotalPrice(\''+genid+'\', '+pos+')"/>';
		}
		
		if(!columnsToSkip.includes('total_price')){
			// total price
			var celltp = row.insertCell(row.cells.length);
			var amount = values && values.total_price ? values.total_price : '';
			var cell_id = genid + '_' + pos + '_total_price';
			var hiddenPrice = values && values.show_billing_info ? '' : 'hidden';
			celltp.innerHTML += '<input type="text" '+hiddenPrice+' id="'+cell_id+'" class="amount" name="expense['+table_type+']['+pos+'][total_price]" value="'+amount+'"/>';
		}
/*
		// status selector
		var cellst = row.insertCell(row.cells.length);
		var options = [];
		for (i=0; i<og.expenses2.statuses.length; i++) {
			var c = og.expenses2.statuses[i];
			if (c.only_for_expenses) continue;
			if (values && typeof(values.status) != 'undefined') {
				var sel = values && values.status == c.id ? 'selected="selected"' : '';
			}
			options += '<option '+sel+' value="'+ c.id +'">'+ c.name +'</option>';
		}
		cellst.className += 'right';
		cellst.innerHTML = '<select type="text" name="expense['+table_type+']['+pos+'][status_id]">' + options + '</select>';		
*/
		// delete link
		cellremove = row.insertCell(row.cells.length);
		cellremove.innerHTML = '<a href="#" class="link-ico ico-delete" onclick="og.expenses2.removeExpenseItemTableRow(\''+table_id+'\', '+row_id+', '+pos+')"></a>';
		cellremove.style.width = '23px';
		cellremove.style.minWidth = '23px';

		// focus in first input
		celld.getElementsByTagName('input')[0].focus();
		
		// scroll the form if necessary
		og.expenses2.scrollExpenseFormDown(genid);
	},
	
	updateItemTotals: function(genid, pos) {
		var valuesToSkip = og.columns_to_hide_in_expenses ? og.columns_to_hide_in_expenses : [];
		og.expenses2.updateItemTotalCost(genid, pos);
		if(!valuesToSkip.includes('total_price')){
			og.expenses2.updateItemTotalPrice(genid, pos);
		}
		og.expenses2.update_payment_receipt_name(genid, '1');
	},
	
	updateItemTotalCost: function(genid, pos) {
		var quantity = $("#" + genid + '_' + pos + '_quantity').val();
		var unit_cost = $("#" + genid + '_' + pos + '_unit_cost').val();

		quantity = og.clean_thousand_separator(quantity);
		unit_cost = og.clean_thousand_separator(unit_cost);
		
		if (quantity == '') quantity = 0;
		if (isNaN(quantity)) quantity = parseFloat(quantity);
		if (isNaN(unit_cost)) unit_cost = parseFloat(unit_cost);
		
		var all_taxes_amount = 0;
		if (og.expenses2.taxes) {
			for (tax_id in og.expenses2.taxes) {
				og.expenses2.on_tax_change(tax_id, genid, true);
				var tax_val = $("#" + genid + '_' + pos + '_tax_' + tax_id).val();
				tax_val = og.clean_thousand_separator(tax_val);
				if (!isNaN(tax_val)) all_taxes_amount += parseFloat(tax_val);
			}
		}
		
		var total_cost = quantity * unit_cost + all_taxes_amount;
		$("#" + genid + '_' + pos + '_total_cost').val(og.format_money_amount(total_cost, og.expenses2.amount_decimals));

		$("#" + genid + '_' + pos + '_unit_cost').val(og.format_money_amount(unit_cost, og.expenses2.amount_decimals));
		
		var product_type_id = $("#" + genid + '_' + pos + '_product_type_id').val();
		var product_type = og.product_types.get_by_id(product_type_id);
		if (product_type && product_type.uses_price_multiplier) {
			var unit_price = unit_cost * product_type.price_multiplier;
			$("#" + genid + '_' + pos + '_unit_price').val(og.format_money_amount(unit_price, og.expenses2.amount_decimals));
			og.expenses2.updateItemTotalPrice(genid, pos);
		}
	},
	
	updateItemTotalPrice: function(genid, pos) {
		if ($("#" + genid + '_' + pos + '_unit_price').hasClass('nonbillable')) {
			$("#" + genid + '_' + pos + '_unit_price').val(0);
		}
		var quantity = $("#" + genid + '_' + pos + '_quantity').val();
		var unit_price = $("#" + genid + '_' + pos + '_unit_price').val();

		quantity = og.clean_thousand_separator(quantity);
		unit_price = og.clean_thousand_separator(unit_price);
		
		if (quantity == '') quantity = 0;
		if (isNaN(quantity)) quantity = parseFloat(quantity);
		if (isNaN(unit_price)) unit_price = parseFloat(unit_price);
		
		var total_price = quantity * unit_price;
		$("#" + genid + '_' + pos + '_total_price').val(og.format_money_amount(total_price, og.expenses2.amount_decimals));

		$("#" + genid + '_' + pos + '_unit_price').val(og.format_money_amount(unit_price, og.expenses2.amount_decimals));
	},
	
	onItemProductTypeChange: function(genid, pos, dontFillMemberSelectors) {
		var product_type_id = $("#" + genid + '_' + pos + '_product_type_id').val();
		var product_type = og.product_types.get_by_id(product_type_id);
		var valuesToSkip = og.columns_to_hide_in_expenses ? og.columns_to_hide_in_expenses : [];

		if (product_type) {
			$("#" + genid + '_' + pos + '_unit_cost').val(product_type.hourly_cost.toFixed(og.expenses2.amount_decimals));
			$("#" + genid + '_' + pos + '_price_multiplier').val(product_type.price_multiplier.toFixed(3));
			if(!valuesToSkip.includes('unit_price')){
				if (product_type.uses_price_multiplier) {
					var unitprice = product_type.hourly_cost * product_type.price_multiplier;
				} else {
					var unitprice = product_type.hourly_rate;
				}
				$("#" + genid + '_' + pos + '_unit_price').val(og.format_money_amount(unitprice, og.expenses2.amount_decimals));
			}
		}
		og.expenses2.updateItemTotals(genid, pos);
		if(!dontFillMemberSelectors){
			og.expenses2.fillEmptyMemberSelectors(genid, product_type);
		}
		og.expenses2.update_payment_receipt_name(genid, '1');
	},
	
	fillEmptyMemberSelectors: function(genid, product_type) {
		
		if (product_type && product_type.members && member_selector[genid]) {
			
			for (var dim_id in product_type.members) {
				if ((!member_selector[genid].sel_context[dim_id] || member_selector[genid].sel_context[dim_id].length == 0) 
					&& member_selector[genid].properties[dim_id]) {
					
					var mem_id = product_type.members[dim_id];
					if (mem_id) {
						member_selector.add_relation(dim_id, genid, mem_id);
						$("#"+genid+"-member-chooser-panel-"+dim_id+"-tree-current-selected .empty-text").hide();
					}
				}
			}
			
		}
	},
	
	scrollExpenseFormDown: function(genid) {
		var offset = $("#"+ genid +"add-expense-item-button").offset();
		if (offset) {
		//	$('#modal-forms-container').animate({scrollTop: offset.top});
		}
	},

	removeExpenseItemTableRow: function(table_id, row_id, suffix) {
		var table = document.getElementById(table_id);
		var row = document.getElementById(row_id);
		if (table && row) {
			var exp_item_id = $(row).find('.exp-item-id').val();
			var del_ids_json = $(table).find('#deleted_item_ids').val();
			var del_ids = Ext.util.JSON.decode(del_ids_json);
			del_ids.push(exp_item_id);
			del_ids_json = Ext.util.JSON.encode(del_ids);
			$(table).find('#deleted_item_ids').val(del_ids_json);
			
			table.deleteRow(row.rowIndex);
			var row2 = document.getElementById(row_id + '-' + suffix);
			if (row2) {
				table.deleteRow(row2.rowIndex);
			}
		}
	},
	
	
	submit_expense_form: function(form_id) {
		var has_empty_amounts = false;
		var amounts = $("#"+form_id+" .expense-items-table-container input.amount");
		for (var i=0; i<amounts.length; i++) {
			var amount = amounts[i];
			
			if ($(amount).val() == '' || parseFloat($(amount).val()) == 0) {
				has_empty_amounts = true;
				break;
			}
		}

		if (has_empty_amounts) {
			switch (og.expenses2.action_for_empty_amount_expense_items) {
				case 'dont_save':
					og.err(lang('cannot save expense it has expense_items with empty amount'));
					break;
				case 'ask_user':
					if (confirm(lang('save expense with empty amounts prompt'))) {
						og.submit_modal_form(form_id);
					}
					break;
				case 'allow_save':
				default:
					og.submit_modal_form(form_id); 
					return false;
			}
		} else {
			og.submit_modal_form(form_id); 
			return false;
		}
	},
	
	
	submit_expense_item_form: function(form_id) {
		var has_empty_amounts = false;
		var amounts = $("#"+form_id+" .expense-items-table-container input.amount");
		for (var i=0; i<amounts.length; i++) {
			var amount = amounts[i];
			
			if ($(amount).val() == '' || parseFloat($(amount).val()) == 0) {
				has_empty_amounts = true;
				break;
			}
		}

		if (has_empty_amounts) {
			switch (og.expenses2.action_for_empty_amount_expense_items) {
				case 'dont_save':
					og.err(lang('cannot save expense it has expense_items with empty amount'));
					break;
				case 'ask_user':
					if (confirm(lang('save expense with empty amounts prompt'))) {
						og.submit_modal_form(form_id);
					}
					break;
				case 'allow_save':
				default:
					og.submit_modal_form(form_id); 
					return false;
			}
		} else {
			og.submit_modal_form(form_id); 
			return false;
		}
	},
	
	
	showExpenseItemHistory: function(expense_id, expense_item_num) {
		
		og.openLink(og.getUrl('expense_item', 'show_expense_item_history', {expense_id:expense_id, expense_item_num:expense_item_num}), {
			callback: function(success, data) {
	
				var modal_params = {
					'closeHTML': '<a id="'+genid+'_close_link" class="modal-close" title="'+lang('close')+'"></a>',
					'onShow': function (dialog) {
						$("#"+genid+"_close_link").addClass("modal-close-img");
				    }
				};
				var html = '<div class="modal-container" style="background-color: white;padding: 10px;">'+data.html+'</div>';
				setTimeout(function() {
					$.modal(html, modal_params);
				}, 100);
			}
		});
	},
	
	reorderExpenseItemsTable: function(exp_id, order, odir) {
		if (odir != 'ASC' && odir != 'DESC') odir = 'ASC';
		
		og.openLink(og.getUrl('expense', 'get_expense_items_table_html', {id:exp_id, order:order, order_dir:odir}), {
			callback: function(success, data) {
				$("#expense-items-table-container").html(data.html);
			}
		});
	},
	
	
	renderExpenseItemGridActions: function(value, p, r) {
		var actions = '';
		if (r.data.id == '__total_row__' || r.data.id <= 0) return actions;
		
		var actionStyle= ' style="font-size:105%;padding-top:2px;padding-bottom:3px;padding-left:16px;background-repeat:no-repeat;" '; 
		
		actions += String.format(
			'<a class="list-action ico-edit" href="#" onclick="og.render_modal_form(\'\', {c:\'expense_item\', a:\'edit\', params:{id:'+r.data.object_id+'}});" title="{1}" ' + actionStyle + '>&nbsp;</a>',
			r.data.object_id, lang('edit'));
		
		var current_status = null;
		for (x in og.expenses2.all_status) {
			var st = og.expenses2.all_status[x];
			if (st.code == r.data.status_code) {
				current_status = st;
				break;
			}
		}
		if (current_status && !current_status.is_final) {
			var next_status = og.expenses2.next_status_config[current_status.code];
			if (next_status) {
				actions += String.format( 
					'<a class="list-action ico-change-pstatus ico-change-pstatus-'+next_status.code+'" href="#" onclick="og.openLink(og.getUrl(\'expense\', \'change_expense_item_status\', {'+
					'expense_item_id:'+r.data.object_id+', st:'+next_status.id+'}));" title="'+ lang('change status to', next_status.name) +'" ' + actionStyle + '>&nbsp;</a>');
			}
		}
		
		if (actions != '')
			actions = '<span>' + actions + '</span>';
			
		return actions;
	},
	
	renderExpenseItemGridStatus: function(value, p, r) {
		if (r.data.status_code) {
			return '<span class="expense-row-status-'+r.data.status_code+'">' + r.data.status + '</span>';
		} else {
			return '';
		}
	},
	
	renderInvoiceLink: function(value, p, r) {
		if (r.data.invoice_id && r.data.invoicing_status=='invoiced') {
			return '<a class="underline" href="#" onclick="og.openLink(og.getUrl(\'invoice\', \'view\', {id: '+r.data.invoice_id+'})); return false;" >' + lang('view invoice') + '</span>';
		} else {
			return '';
		}
	},
	
	renderInvoicingStatus: function(value, p, r) {
		if (r.data.invoicing_status) {
			return '<span class="invoicing-status-'+r.data.invoicing_status+'">' + lang('invoicing_status '+r.data.invoicing_status) + '</span>';
		} else {
			return '';
		}
	},
	
	renderPaymentTerm: function(value, p, r) {
		if (r.data.payment_term_name) {
			return r.data.payment_term_name;
		} else {
			return '';
		}
	},
	
	
	addTotalsRow: function(store, filters, manager_id) {
		var params = {st: filters.status};
		if (filters.from_date) params['fromd'] = filters.from_date;
		if (filters.to_date) params['tod'] = filters.to_date;
		if (filters.expense_id) params['expense_id'] = filters.expense_id;
		
		og.openLink(og.getUrl('expense', 'get_totals_for_listing', params), {callback: function(success, data){
			
			var obj = data.totals;
			
			var record = new Ext.data.Record(obj, obj.id);
			var records = [];
			records.push(record);
			store.add(records);
			
			$("#"+manager_id+" #__total_row__").closest('tr').addClass('expenses-list-totals');
			
			// scroll list to top
			setTimeout(function(){
				$("#"+ manager_id +" .x-grid3-scroller").scrollTop(0);
				$("#expenses-panel .x-panel-body").scrollTop(0);
			}, 10);
			
		}});
	},
	renderContactName: function(value, p, r) {
		return r.data.paid_by_name;
	},

	renderExpenseNameColumn: function(value, p, r) {		
		return r.data.expense_name;
	},
	
	renderProductTypeColumn: function (value, p, r) {							
		return r.data.product_type_name
	},

	update_payment_receipt_name: function(genid, is_new_pr) {

		if (is_new_pr && !og.expenses2.user_has_changed_object_name) {
			var pr_name = '';

			var include_date = og.expenses2.actual_expense_name_generation == 'date_quantity_product' || og.expenses2.actual_expense_name_generation == 'date_product';
			var include_quantity = og.expenses2.actual_expense_name_generation == 'date_quantity_product';

			if (include_date) {
				var date_cmp = Ext.getCmp(genid + "payment_receipt_date");
				if (date_cmp) {
					var date_obj = date_cmp.getValue();
					if (date_obj) {
						pr_name = date_obj.format(og.preferences.date_format);
					}
				}
			}

			if (include_quantity) {
				var quantity =$("#" + genid + '_0_quantity').val();
				if(quantity){
					pr_name += ' ' + quantity;
				}
			}

			var product_type_id = $("#" + genid + '_0_product_type_id').val();
			var product_type = og.product_types.get_by_id(product_type_id);
			
			if(product_type && product_type.name){
				pr_name += ' ' + product_type.name;
			}

			pr_name = pr_name.trim();

			/* COMMENTED OUT: Add expense category to the name of the actual expense

			var exp_cat_dim_id = null;
			for (var i=0; i<og.dimensionPanels.length; i++) {
				if (og.dimensionPanels[i].dimensionCode == 'expense_categories') {
					exp_cat_dim_id = og.dimensionPanels[i].dimensionId;
					break;
				}
			}
			var exp_cat_name = '';
			if (exp_cat_dim_id && member_selector[genid].sel_context[exp_cat_dim_id] && member_selector[genid].sel_context[exp_cat_dim_id].length > 0) {
				var exp_cat_member_id = member_selector[genid].sel_context[exp_cat_dim_id][0];
				if (exp_cat_member_id > 0) {
					exp_cat_name = og.contextManager.getMemberName(exp_cat_dim_id, exp_cat_member_id);
				}
			}
			
			if (exp_cat_name != '') {
				pr_name += (pr_name == '' ? '' : ' - ') + exp_cat_name;
			}*/

			if (pr_name != '') {
				$("#" + genid + "payment_receipt_name").val(pr_name);
			}
		}
	},
	
	actual_expenses_bulk_actions: {
		pending: function(panel_id) {
			var params = og.expenses2.get_actual_expenses_grid_params(panel_id);
	        og.openLink(og.getUrl('expenses_approval', 'put_pending_actual_expenses', params), {preventPanelLoad: true});
		},
		lock: function(panel_id) {
			var params = og.expenses2.get_actual_expenses_grid_params(panel_id);
	        og.openLink(og.getUrl('expenses_approval', 'lock_actual_expenses', params), {preventPanelLoad: true});
		},
		approve: function(panel_id) {
			var params = og.expenses2.get_actual_expenses_grid_params(panel_id);
	        og.openLink(og.getUrl('expenses_approval', 'approve_actual_expenses', params), {preventPanelLoad: true});
		},
		invoice: function(panel_id) {
			var params = og.expenses2.get_actual_expenses_grid_params(panel_id);
	        og.openLink(og.getUrl('expenses_approval', 'invoice_actual_expenses', params), {preventPanelLoad: true});
		},
		process: function(panel_id) {
			var params = og.expenses2.get_actual_expenses_grid_params(panel_id);
	        og.openLink(og.getUrl('expenses_approval', 'process_actual_expenses', params), {preventPanelLoad: true});
		},
		review: function(panel_id) {
			var params = og.expenses2.get_actual_expenses_grid_params(panel_id);
	        og.openLink(og.getUrl('expenses_approval', 'put_under_review_actual_expenses', params), {preventPanelLoad: true});
		}
	},
	
	get_actual_expenses_grid_params: function(panel_id) {
		var ids = [];

        var grid = Ext.getCmp(panel_id);
        if (grid) {
            ids = grid.getSelectedIds();
        }
        
        var params = {};
        
        if (ids.length > 0) {
        	params.expense_ids = ids;
        } else {
        	params.all_expenses = true;
        	if (grid) {
        		Ext.apply(params, grid.store_params);
        	}
        }
        
        return params;
	},

	on_expense_type_change: function(genid) {
		var sel_value = $("#" + genid + 'expense_type').val();
		var display_deposit_date =  $("#" + genid + 'display_deposit_date').val() == '1';
		if(display_deposit_date) {
			var deposit_day_cp = $("#" + genid + 'deposit_day_cp').val();
		}
		var suppliers_dim_id = og.suppliers_dimension_id;
	
		if (sel_value == 'reimbursable') {
	
			$("#" + genid + 'paid_by_container').show();
			$("#" + genid + 'submit-edit-form .due-date-col').hide();
			$("#" + genid + 'terms_container').show();
			$("#" + genid + 'actual_expense_payments').parent().show();
			if (suppliers_dim_id > 0) {
				$("#" + genid + '-member-chooser-panel-'+suppliers_dim_id+'-container').closest(".dimension-selector-container").show();
			}
			if(display_deposit_date) {
				$("#" + genid + '-container-cp' + deposit_day_cp).show();
			}
	
		} else if (sel_value == 'direct_to_vendor') {
	
			$("#" + genid + 'paid_by_container').hide();
			$("#" + genid + 'submit-edit-form .due-date-col').show();
			$("#" + genid + 'terms_container').show();
			$("#" + genid + 'actual_expense_payments').parent().show();
			if (suppliers_dim_id > 0) {
				$("#" + genid + '-member-chooser-panel-'+suppliers_dim_id+'-container').closest(".dimension-selector-container").show();
			}
			if(display_deposit_date) {
				$("#" + genid + '-container-cp' + deposit_day_cp).hide();
			}
	
		} else if (sel_value == 'rental_consumable') {

			$("#" + genid + 'paid_by_container').hide();
			$("#" + genid + 'submit-edit-form .due-date-col').hide();
			$("#" + genid + 'terms_container').hide();
			$("#" + genid + 'actual_expense_payments').parent().hide();
			if (suppliers_dim_id > 0) {
				$("#" + genid + '-member-chooser-panel-'+suppliers_dim_id+'-container').closest(".dimension-selector-container").hide();
			}
			if(display_deposit_date) {
				$("#" + genid + '-container-cp' + deposit_day_cp).hide();
			}
			
		} else if (sel_value == 'field_lab_testing') {

			$("#" + genid + 'paid_by_container').show();
			$("#" + genid + 'submit-edit-form .due-date-col').hide();
			$("#" + genid + 'terms_container').hide();
			$("#" + genid + 'actual_expense_payments').parent().hide();
			if (suppliers_dim_id > 0) {
				$("#" + genid + '-member-chooser-panel-'+suppliers_dim_id+'-container').closest(".dimension-selector-container").hide();
			}
			if(display_deposit_date) {
				$("#" + genid + '-container-cp' + deposit_day_cp).hide();
			}
			
		} else if (sel_value == 'credit_card_purchase') {
			$("#" + genid + '-member-chooser-panel-'+suppliers_dim_id+'-container').closest(".dimension-selector-container").hide();
			if(display_deposit_date) {
				$("#" + genid + '-container-cp' + deposit_day_cp).hide();
			}
		}
	}
}





og.product_types = {
	get_by_id: function (product_type_id) {
		var product_type = null;
		
		for (var x in og.expenses2.product_types) {
			var pt = og.expenses2.product_types[x];
			if (pt.id == product_type_id) {
				product_type = pt;
				break;
			}
		}
		
		return product_type;
	},
	
	def_ratecost_toggle: function(genid, type, checkbox) {
		var id = genid + (type == 'cost' ? 'cost_def' : 'rate_def');

		if ($(checkbox).attr('checked') == 'checked') {
			$("#"+id).removeClass('block-disabled');
		} else {
			$("#"+id).addClass('block-disabled');
		}
	},
	
	price_multiplier_toggle: function(genid, checkbox) {
		
		if ($(checkbox).attr('checked') == 'checked') {
			$("#" + genid + 'rate_def').hide();
			$("#" + genid + 'price_multiplier').show();
		} else {
			$("#" + genid + 'rate_def').show();
			$("#" + genid + 'price_multiplier').hide();
		}
	},


	product_type_dimension_changed: function(checkbox, dim_id) {
		var enable = $(checkbox).attr('checked') == 'checked' ? '1' : '0';
		og.openLink(og.getUrl('product_type', 'enable_disable_dimension', {dim_id:dim_id, enable:enable}), {
			silent:true,
			callback: function(success, data) {

				og.product_types.reload_allowed_dimensions(parseInt(dim_id));
				
			}
		});
		
	},


	product_type_filter_up_dimension_changed: function(checkbox, dim_id) {
		var enable = $(checkbox).attr('checked') == 'checked' ? '1' : '0';
		og.openLink(og.getUrl('product_type', 'enable_disable_filter_up_dimension', {dim_id:dim_id, enable:enable}), {
			silent:true
		});
		
	},
	
	reload_product_type_selectors: function(genid) {

		og.openLink(og.getUrl('product_type', 'get_filtered_product_types', {member_ids: $("#"+genid+"members").val()}), {
			callback: function(success, data) {
				
				if (!data || !data.product_types) return;
				og.expenses2.filtered_product_types = data.product_types;

				$("#" + genid + "submit-edit-form .product_type_selector").each(function(index, obj) {
					var selected_value = $(obj).val();

					// remove old options
					$(obj).find("option").remove();

					// add new options
					$(obj).append($('<option>', {value: 0, text : ""}));
					$.each(og.expenses2.filtered_product_types, function (i, item) {
						$(obj).append($('<option>', { 
							value: item.id,
							text : item.name.replaceAll('\\"', '"')
						}));
					});

					$(obj).val(selected_value);
				});
			}
		});
	},

	reload_product_type_selectors_for_payment_receipt: function(genid, expense_id) {
	
	  // use a timeout to prevent multiple requests when this fn is called many times by the member selector
	  if (og.expenses2.timeout_reload_pt) clearTimeout(og.expenses2.timeout_reload_pt);
	  
	  og.expenses2.timeout_reload_pt = setTimeout(function(){
	  
		// Comment out selecting product types from budgeted expense
		og.openLink(og.getUrl('product_type', 'get_filtered_product_types_for_payment_receipt', {member_ids: $("#"+genid+"members").val()/*, expense_id: $("#"+genid+"paymentExpenseId").val()*/}), {
			callback: function(success, data) {
				
				if (!data || !data.product_types) return;
				og.expenses2.filtered_product_types = data.product_types;

				$("#" + genid + "submit-edit-form .product_type_selector").each(function(index, obj) {
					var selected_value = $(obj).val();

					// remove old options
					$(obj).find("option").remove();

					// add new options
					$(obj).append($('<option>', {value: 0, text : ""}));
					$.each(og.expenses2.filtered_product_types, function (i, item) {
						$(obj).append($('<option>', { 
							value: item.id,
							text : item.name.replaceAll('\\"', '"')
						}));
					});
					$(obj).val(selected_value);
				});
			}
		});
	  }, 100);
	},

	reload_allowed_dimensions: function(changed_dim) {
		og.openLink(og.getUrl('product_type', 'get_allowed_dimensions'), {
			silent: true,
			callback: function(success, data) {
				if (success) {
					og.product_types_allowed_dimensions = [];
					for (i=0; i<data.allowed_dimensions.length; i++) {
						og.product_types_allowed_dimensions.push(parseInt(data.allowed_dimensions[i]));
					}
					
					var man = Ext.getCmp('product-types-manager');
					if (man) {
						var cm = man.getColumnModel();
						if (cm) {
						  for (var i=0; i<og.product_types_allowed_dimensions.length; i++) {
							var dim_id = og.product_types_allowed_dimensions[i];
							
							var col = cm.getColumnById('dim_' + dim_id);
							if (!col && og.product_types_allowed_dimensions.indexOf(parseInt(dim_id)) >= 0) {
								cm.config.push({
									id: 'dim_' + dim_id,
									header: og.dimensions_info[dim_id].name,
									dataIndex: 'dim_' + dim_id,
									sortable: true,
									renderer: og.renderDimCol
								});
								cm.fireEvent('configchange', cm);
								man.reset();
							}
						  }
						}
						
						if (changed_dim) {
							if (og.product_types_allowed_dimensions.indexOf(parseInt(changed_dim)) > -1) {
								$("#advanced-billing-manager .x-grid3-col.x-grid3-cell.x-grid3-td-dim_"+changed_dim).show();
								$("#advanced-billing-manager .x-grid3-hd.x-grid3-cell.x-grid3-td-dim_"+changed_dim).show();
							} else {
						//		$("#advanced-billing-manager .x-grid3-col.x-grid3-cell.x-grid3-td-dim_"+changed_dim).hide();
						//		$("#advanced-billing-manager .x-grid3-hd.x-grid3-cell.x-grid3-td-dim_"+changed_dim).hide();
							}
						}
					}
				}
			}
		});
	}
}

