<?php
Env::useHelper('einvoice_provider', 'einvoice');
/*
 *  DO NOT DELETE. this is needed for  plugins to work
 */
class FacturalistaController extends EinvoiceProvider {
	
	var $plugin_name = "facturalista";
	
	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'website');
		Env::useHelper('facturalista_wrapper', 'facturalista');
	}


	public function send_invoice(IncomeInvoice $invoice) {
		$facturalista = new FacturalistaWrapper();

		try {
			$transaction_started = false;
			
			$facturalista->send_invoice($invoice);

			DB::beginWork();
			$transaction_started = true;
			$einvoice_data = get_facturalista_factura($invoice->getId());

			$invoice->setSeries($einvoice_data['serie']);
			$invoice->setInvoiceNumber($einvoice_data['numero']);

			$invoice->save();
			DB::commit();
		}catch(Exception $e){
			if ($transaction_started) {
				DB::rollback();
			}
			Logger::log($e->getMessage() . " - Incvoice ID: " . $invoice->getId());
			throw $e;
		}
	}

	public function get_invoice_document(IncomeInvoice $invoice) {
		$facturalista = new FacturalistaWrapper();
		$file = $facturalista->get_invoice($invoice);
		return $file;
	}

	/**
	 * Show configuration index page
	 *
	 * @param void
	 * @return null
	 */
	function administration() {
		if (!can_manage_invoicing_configuration(logged_user())) {
			flash_error(lang('no access permissions'));
			ajx_current("empty");
			return;
		} // if
		$this->addHelper('textile');
	}

	function update_config() {
		if (!can_manage_invoicing_configuration(logged_user())) {
			flash_error(lang('no access permissions'));
			ajx_current("empty");
			return;
		}

		$options = ConfigOptions::findAll(array("condition" => array("category_name='facturalista'")));
		tpl_assign('options', $options);

		$submited_values = array_var($_POST, 'options');
		if (is_array($submited_values)) {
			foreach ($options as $option) {
				$new_value = array_var($submited_values, $option->getName());
				if (is_null($new_value) || ($new_value == $option->getValue()))
					continue;

				$option->setValue($new_value);
				$option->save();
			}
			flash_success(lang('success update config'));
			ajx_current("back");
		} // if
	}


}