<?php
	echo stylesheet_tag("og/reporting.css");
	require_javascript("og/ReportingFunctions.js");
	$genid = gen_id();
	if (!isset($conditions)) $conditions = array();
	
	$report_data = array_var($_SESSION, 'contable_report_data');
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('fidelis_reports', 'contable_report') ?>" method="post" enctype="multipart/form-data">
<input type="hidden" id="<?php echo $genid?>report[report_object_type_id]" name="report[report_object_type_id]" value="<?php echo Timeslots::instance()->getObjectTypeId()?>"/>

<div class="reportTotalTimeParams">
<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo lang('contable report') ?>
		<?php //echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;margin-left:10px')) ?></div>
	</div>
	<div style="padding:5px 0"><?php echo lang('contable report description') ?></div>
</div>
<div class="coInputSeparator"></div>
<div class="coInputMainBlock">
	
	<?php if (count(active_context_members(false)) > 0) : ?>
	<div style="margin-bottom: 15px; padding-bottom: 5px; border-bottom:1px dotted #aaa;">
		<h5><?php echo lang('showing information for')?>:</h5>
		<ul>
		<?php
			$context = active_context();
			foreach ($context as $selection) :
				if ($selection instanceof Member) : ?>
					<li><span class="coViewAction <?php echo $selection->getIconClass()?>"><?php echo $selection->getName()?></span></li>	
		<?php 	endif;
			endforeach;
		?>
		</ul>
	</div>
	<?php else: ?>
	<div style="padding:5px;"></div>
	<?php endif; ?>

	<table>
		<tr style='height:30px;'>
			<td><span class="bold">Funcionarios:&nbsp;</span></td>
			<td align='left'><?php 
			$selected_user_activity = array_var($report_data, "user_activity", 'active');
				echo select_box('report[user_activity]', array(
						option_tag('Todos', 'all', $selected_user_activity == 'all' ? array('selected' => 'selected'):null),
						option_tag('Activos', 'active', $selected_user_activity == 'active' ? array('selected' => 'selected'):null),
						option_tag('Inactivos', 'inactive', $selected_user_activity == 'inactive' ? array('selected' => 'selected'):null)
				));
			?></td>
		</tr>
	
		<tr style='height:30px;'>
			<td><span class="bold"><?php echo lang("date") ?>:&nbsp;</span></td>
			<td align='left'><?php 
				echo select_box('report[date_type]', array(
					option_tag(lang('none'), -1, array_var($report_data, "date_type") == -1 ? array('selected' => 'selected'):null),
					option_tag(lang('today'), 1, array_var($report_data, "date_type") == 1 ? array('selected' => 'selected'):null),
					option_tag(lang('this week'), 2, array_var($report_data, "date_type") == 2 ? array('selected' => 'selected'):null),
					option_tag(lang('last week'), 3, array_var($report_data, "date_type") == 3 ? array('selected' => 'selected'):null),
					option_tag(lang('this month'), 4, array_var($report_data, "date_type") == 4 ? array('selected' => 'selected'):null),
					option_tag(lang('last month'), 5, array_var($report_data, "date_type") == 5 ? array('selected' => 'selected'):null),
					option_tag(lang('select dates...'), 6, array_var($report_data, "date_type") == 6 ? array('selected' => 'selected'):null)
				), array('onchange' => 'og.dateselectchange(this)'));
			?></td>
		</tr>
		<?php
			if (array_var($report_data, "date_type") == 6) {
				$style = "";
				$dateFormat = user_config_option('date_format');
		       	$st = DateTimeValueLib::dateFromFormatAndString($dateFormat, array_var($report_data, 'date_start_value'));
		       	$et = DateTimeValueLib::dateFromFormatAndString($dateFormat, array_var($report_data, 'date_end_value'));
			} else {
				$style = 'display:none;';
				$st = DateTimeValueLib::now();
				$et = $st;
			} 
		?>
		<tr class="dateTr"  style="<?php echo $style ?>">
			<td><span class="bold"><?php echo lang("start date") ?>:&nbsp;</span></td>
			<td align='left'><?php echo pick_date_widget2('report[date_start_value]', $st, $genid);?></td>
		</tr>
		<tr class="dateTr"  style="<?php echo $style ?>">
			<td style="padding-bottom:18px"><span class="bold"><?php echo lang("end date") ?>:&nbsp;</span></td>
			<td align='left'><?php echo pick_date_widget2('report[date_end_value]', $et, $genid);?></td>
		</tr>
	
		
	</table>
	
<br/>
<?php echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;')) ?>
</div>
</div>

</form>
