-- remove old form object type
UPDATE `<?php echo $table_prefix ?>object_types` SET `name` = 'project_form' WHERE `handler_class` = 'ProjectForms';

-- add the form type
INSERT INTO `<?php echo $table_prefix ?>object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
 ('form', 'Forms', 'forms', 'content_object', 'form', (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='forms'), 0)
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
	SELECT dot.dimension_id, dot.dimension_object_type_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='form'), dot.is_required, dot.is_multiple
	FROM <?php echo $table_prefix ?>dimension_object_type_contents dot
	WHERE dot.content_object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='message')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>dimension_object_type_contents.dimension_id=<?php echo $table_prefix ?>dimension_object_type_contents.dimension_id;

INSERT INTO `<?php echo $table_prefix ?>tab_panels` (`id`,`title`,`icon_cls`,`refresh_on_context_change`,`default_controller`,`default_action`,`initial_controller`,`initial_action`,`enabled`,`type`,`ordering`,`plugin_id`,`object_type_id`) VALUES 
 ('forms-panel', 'forms', 'ico-forms', 1, 'form', 'index', '', '', 1, 'system', 11, (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='forms'), (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='form')) 
ON DUPLICATE KEY UPDATE id=id;

-- permissions for roles
INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('form')
	 AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 0, 0
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('form')
	 AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');

INSERT INTO <?php echo $table_prefix ?>role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('form')
	AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');


-- add permissions to users where the users already have permissions (copy permissions from tasks)
INSERT INTO <?php echo $table_prefix ?>contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
 SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='form'), cmp.can_delete, cmp.can_write 
 FROM <?php echo $table_prefix ?>contact_member_permissions cmp
 WHERE cmp.object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>contact_member_permissions.member_id=<?php echo $table_prefix ?>contact_member_permissions.member_id;

INSERT INTO <?php echo $table_prefix ?>tab_panel_permissions (permission_group_id, tab_panel_id)
 SELECT pg.id, 'forms-panel' FROM <?php echo $table_prefix ?>permission_groups pg WHERE pg.type='roles' AND pg.name IN ('Super Administrator','Administrator','Manager','Executive')
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;

INSERT INTO <?php echo $table_prefix ?>tab_panel_permissions (permission_group_id, tab_panel_id)
 SELECT c.permission_group_id, 'forms-panel' FROM <?php echo $table_prefix ?>contacts c 
 WHERE c.user_type IN (SELECT pg.id FROM <?php echo $table_prefix ?>permission_groups pg WHERE pg.type='roles' and pg.name IN ('Super Administrator','Administrator','Manager','Executive'))
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;
