<?php 
	if (!isset($genid)) $genid = gen_id();

	// custom properties gantt options, check if there is a config option to show each cp, if not then create it
	$cps = CustomProperties::getAllCustomPropertiesByObjectType(ProjectTasks::instance()->getObjectTypeId());
	$cps_by_id = array();
	foreach ($cps as $cp) {/* @var $cp CustomProperty */
		$cps_by_id[$cp->getId()] = $cp;
		$config_option_name = 'ganttShowCP_'.$cp->getId();
		$conf_opt = ContactConfigOptions::getByName($config_option_name);
		if (is_null($conf_opt)) {
			$conf_opt = new ContactConfigOption();
			$conf_opt->setName($config_option_name);
			$conf_opt->setCategoryName('gantt options');
			$conf_opt->setIsSystem(true);
			$conf_opt->setDefaultValue('0');
			$conf_opt->setConfigHandlerClass('BoolConfigHandler');
			$conf_opt->save();
		}
	}
	
	// gantt preferences
	$ganttPreferences = array();
	$options = ContactConfigOptions::getOptionsByCategoryName('gantt options', true);
	foreach ($options as $option) {
		if (str_starts_with($option->getName(), "ganttShowCP_")) {
			$cp_id = str_replace("ganttShowCP_", "", $option->getName());
			$cp = array_var($cps_by_id, $cp_id);
			if (!$cp instanceof CustomProperty || $cp->getIsDisabled()) continue;
		}
		$ganttPreferences[$option->getName()] = user_config_option($option->getName());
	}
	
?>

<input type="hidden" id="hfGanttPreferences" value="<?php echo clean(str_replace('"',"'", escape_character(json_encode($ganttPreferences)))) ?>"/>

<a id="<?php echo $genid?>show_gantt_link" rel="#gantt_overlay_<?php echo $genid ?>" style="display:none;"></a>

<div id="gantt_overlay_<?php echo $genid ?>" class="gantt-overlay" data-url="<?php echo get_url('task', 'view'); ?>" style="display:block;">
    <div class="tasksPanelWarning gantt_alert ico-warning32" style="font-size:10px;color:#666;background-repeat:no-repeat;padding-left:40px;max-width:920px; margin:20px;border:1px solid #E3AD00;background-color:#FFF690;background-position:4px 4px;display:none;">
		<div style="font-weight:bold;min-height:30px;width:99%;text-align:center;padding:4px;color:#AF8300;"><?php echo lang('tasks that do not appear in gantt') ?></div>
	</div>
	
	<div id="<?php echo $genid?>ganttChartContainer" style='width:100%; height:100%;'></div>
</div>

<script>

if (!ogTasks) ogTasks = {};
ogTasks.ganttPreferences = Ext.util.JSON.decode(document.getElementById('hfGanttPreferences').value);

if (ogTasks.ganttPreferences && typeof(ogTasks.ganttPreferences.ganttShowDimensionCols) == 'string') {
	ogTasks.ganttPreferences.ganttShowDimensionCols = ogTasks.ganttPreferences.ganttShowDimensionCols.split(',');
}

$(document).ready(function(){
try {
	if (ganttWrapper) {
		ganttWrapper.genid = "<?php echo $genid?>";
		if (ganttWrapper) ganttWrapper.setupToolBar();
	}
} catch (e) {
	console.log(e);
}
});
</script>
