<?php
Hook::register('gantt');

if (strtoupper(substr(PHP_OS, 0, 5)) == 'LINUX') {
	if (!function_exists('pdf_to_text_pro')) {
		function pdf_to_text_pro($file_path) {
			$tmp_name = "tmp/".gen_id().".text";
			exec("pdftotext $file_path $tmp_name");
			return file_get_contents($tmp_name);
		}
	}
}

function gantt_autoload_javascripts($args, &$js) {
	$js[] = ROOT_URL . "/" . get_javascript_url('dhtmlxGantt/codebase/dhtmlxgantt.js', 'gantt');
	$js[] = ROOT_URL . "/" . get_javascript_url('dhtmlxGantt/codebase/ext/dhtmlxgantt_tooltip.js', 'gantt');
	
	//localization
	$gantt_langs = array("en","es", "fr");
	$lang = substr(localization::instance()->getLocale(), 0, 2);
		
	if (in_array($lang, $gantt_langs))
	{
		if($lang == "en"){
			$lang_file = 'locale';//default English
		}else{
			$lang_file = 'locale_'.$lang;
		}		
		$js[] = ROOT_URL . "/" . get_javascript_url('dhtmlxGantt/codebase/sources/locale/'.$lang_file.'.js', 'gantt');
	}	
	//END localization
}

function gantt_include_tasks_template($ignored, &$templates) {
	$templates[] = array(
	    'template' => 'tasks_list_overlay',
	    'controller' => 'gantt',
	    'plugin' => 'gantt',
	);
}


function gantt_tasks_user_preferences($ignored, &$array){
	$array['showTasksListAsGantt'] = (bool) user_config_option('show_tasks_list_as_gantt');
	$array['show_tasks_names_on_gantt'] = (bool) user_config_option('show_tasks_names_on_gantt');
	$array['zoom_in_gantt'] = user_config_option('zoom_in_gantt');
	$array['show_left_grid_on_gantt'] = (bool) user_config_option('show_left_grid_on_gantt');
	$array['collapse_gantt_groups'] = (bool) user_config_option('collapse_gantt_groups');
	require_javascript('gantt_override.js', 'gantt');
	require_javascript('gantt_tasks_section.js', 'gantt');
	require_javascript('gantt_manager.js', 'gantt');
	require_javascript('gantt_wrapper.js', 'gantt');
}

