var ganttWrapper = {
	genid : '',
	defaultZoom : '3',
	defaultLeftGridWidth : 350,
	drawList : function() {
		//Switch to List
		var change_view_button = $('#tasksPanelTopToolbarObject').find('button.ico-task');
		change_view_button.removeClass('ico-task').addClass('ico-gantt').html(lang('view as gantt'));
		ganttWrapper.showGanttOrList(false);
		
		ogTasks.draw();
		
		//remove gantt options from the top bar				
		Ext.getCmp('gantt_opt').destroy();			
	},	
	setupToolBar : function() {
		if (!ogTasks.extraTopToolbarItems) {
			ogTasks.extraTopToolbarItems = [];
		}
		if (typeof (Ext.getCmp('gantt_button')) == "undefined") {
			ogTasks.extraTopToolbarItems.push('-');
			ogTasks.extraTopToolbarItems.push(new Ext.Action( {
				id : 'gantt_button',
				text : lang('view as gantt'),
				iconCls : 'ico-gantt',
				handler : function() {
					if (ogTasks.userPreferences.showTasksListAsGantt) {
						ogTasks.userPreferences.showTasksListAsGantt = false;
						ganttWrapper.drawList();
						
						//updating server value for ogTasks.userPreferences.showTasksListAsGantt
						var url = og.getUrl('account', 'update_user_preference', {
							name : 'show_tasks_list_as_gantt',
							value : ((ogTasks.userPreferences.showTasksListAsGantt) ? 1 : 0)
						});
						og.openLink(url, {
							hideLoading : true
						});
						
						
					} else {		
						ogTasks.userPreferences.showTasksListAsGantt = true;
						//updating server value for ogTasks.userPreferences.showTasksListAsGantt
						var url = og.getUrl('account', 'update_user_preference', {
							name : 'show_tasks_list_as_gantt',
							value : ((ogTasks.userPreferences.showTasksListAsGantt) ? 1 : 0)
						});
						og.openLink(url, {
							hideLoading : true
						});						
						
						ogTasks.draw();
					}
				},
				scope : this
			}));
			ogTasks.extraTopToolbarItems.push('-');			
		}			
	},
	showGanttOrList : function(show_gantt) {
		$('div.gantt-overlay').css('display', show_gantt ? 'block' : 'none');
		$('table#tasksPanelContainer').css('display', show_gantt ? 'none' : 'block');
		if(show_gantt){
			gantt.render();		
		}
	},
	
	//add selectors for gantt. (zoom for example)
	setupGanttToolBar : function() {
		var topToolbar = Ext.getCmp('tasksPanelTopToolbarObject');
			
		var zoomMenuItems = [
		         		{text: lang('day'), handler: function() {
							// Save user preference 'zoom_in_gantt'
							var url = og.getUrl('account', 'update_user_preference', {
								name : 'zoom_in_gantt',
								value : 1
							});
							og.openLink(url, {
								hideLoading : true
							});

							// Set gantt zoom scale and render gantt
							ganttManager.setScaleConfig('1');
							gantt.render();        			
		         		}},
		         		{text: lang('week'), handler: function() {
							// Save user preference 'zoom_in_gantt'
							var url = og.getUrl('account', 'update_user_preference', {
								name : 'zoom_in_gantt',
								value : 2
							});
							og.openLink(url, {
								hideLoading : true
							});

							// Set gantt zoom scale and render gantt
							ganttManager.setScaleConfig('2');
			        		gantt.render();
		         		}},
		         		{text: lang('month'), handler: function() {
							// Save user preference 'zoom_in_gantt'
							var url = og.getUrl('account', 'update_user_preference', {
								name : 'zoom_in_gantt',
								value : 3
							});
							og.openLink(url, {
								hideLoading : true
							});

							// Set gantt zoom scale and render gantt
							ganttManager.setScaleConfig('3');
			        		gantt.render();
		         		}},
		         		{text: lang('year'), handler: function() {
							// Save user preference 'zoom_in_gantt'
							var url = og.getUrl('account', 'update_user_preference', {
								name : 'zoom_in_gantt',
								value : 4
							});
							og.openLink(url, {
								hideLoading : true
							});

							// Set gantt zoom scale and render gantt
							ganttManager.setScaleConfig('4');
			        		gantt.render();
		         		}}
					 ];
		// Set collapse groups text and icon
		var collapseGroupsText = lang('collapse groups');
		var collapseGroupsIco = 'ico-minus';
		if (!ogTasks.userPreferences.collapse_gantt_groups){
			collapseGroupsText = lang('expand groups');
			collapseGroupsIco = 'ico-plus';
		}
				
		var expandMenuItems = [
				         		{iconCls: collapseGroupsIco,
				         			text: collapseGroupsText,
				         			handler: function(item) {
										if(item.iconCls == 'ico-plus'){
											item.setIconClass('ico-minus');
											item.setText(lang('collapse groups'));
											ogTasks.userPreferences.collapse_gantt_groups = true;
											ganttManager.toggleAllGroups(true);
										}else{
											item.setIconClass('ico-plus');
											item.setText(lang('expand groups'));
											ogTasks.userPreferences.collapse_gantt_groups = false;
											ganttManager.toggleAllGroups(false);
										}

										// Update value for ogTasks.userPreferences.collapse_gantt_groups
										var url = og.getUrl('account', 'update_user_preference', {
											name : 'collapse_gantt_groups',
											value : ((ogTasks.userPreferences.collapse_gantt_groups) ? 1 : 0)
										});
										og.openLink(url, {
											hideLoading : true
										});
       			
				         			}				         			
				         		}				         		
				         	];
		
		var exportMenuItems = [
				         		{text: lang('export to png'),
				         			iconCls: 'ico-picture',
				         			handler: function() {
				         				ganttWrapper.print('gantt','img');			        			
				         			}
				         		},
				         		{text: lang('export to pdf'), 
				         			iconCls: 'ico-application-pdf',
				         			handler: function() {
				         				ganttWrapper.print('gantt','pdf');
				         			}
				         		}
				         	];
		//Gantt options btn
		if (typeof (Ext.getCmp('gantt_opt')) != "undefined") {
			Ext.getCmp('gantt_opt').destroy();			
		}
		
		//Show tasks names on gantt
		var showTasksNamesText = lang('hide task name');
		var showTasksNamesIco = 'ico-task-low-priority';
		if (!ogTasks.userPreferences.show_tasks_names_on_gantt){
			showTasksNamesText = lang('show task name');
			showTasksNamesIco = 'ico-task';
		}
		var showTasksNames = {text: showTasksNamesText, 
				     			iconCls: showTasksNamesIco,
				     			handler: function(item) {
				     													
				     				if(item.iconCls == 'ico-task'){
					        			item.setIconClass('ico-task-low-priority');
					        			item.setText(lang('hide task name'));
					        			ogTasks.userPreferences.show_tasks_names_on_gantt = true;
					        		}else{
					        			item.setIconClass('ico-task');
					        			item.setText(lang('show task name'));
					        			ogTasks.userPreferences.show_tasks_names_on_gantt = false;
					        		}  
				     				
				     				//updating server value for ogTasks.userPreferences.show_tasks_names_on_gantt
									var url = og.getUrl('account', 'update_user_preference', {
										name : 'show_tasks_names_on_gantt',
										value : ((ogTasks.userPreferences.show_tasks_names_on_gantt) ? 1 : 0)
									});
									og.openLink(url, {
										hideLoading : true
									});
				     				
				     				ganttManager.toggleTasksNames();
				     			}		
     						};
		
		//Show left grid on gantt
		var showLeftGridText = lang('hide left grid');
		var showLeftGridIco = 'op-ico-details';
		if (!ogTasks.userPreferences.show_left_grid_on_gantt){
			showLeftGridText = lang('show left grid');			
		}
		var showLeftGrid = {text: showLeftGridText, 
				     			iconCls: showLeftGridIco,
				     			handler: function(item) {				     													
				     				if(!ogTasks.userPreferences.show_left_grid_on_gantt){
					        			item.setText(lang('hide left grid'));
					        			ogTasks.userPreferences.show_left_grid_on_gantt = true;
					        		}else{
					        			item.setText(lang('show left grid'));
					        			ogTasks.userPreferences.show_left_grid_on_gantt = false;
					        		}  
				     				
				     				//updating server value for ogTasks.userPreferences.show_left_grid_on_gantt
									var url = og.getUrl('account', 'update_user_preference', {
										name : 'show_left_grid_on_gantt',
										value : ((ogTasks.userPreferences.show_left_grid_on_gantt) ? 1 : 0)
									});
									og.openLink(url, {
										hideLoading : true
									});
				     				
				     				ganttManager.toggleLeftGrid();
				     			}		
     						};
		
		var fullScreen = {
				text: "Full Screen", 
     			iconCls: 'ico-expand',
     			handler: function(item) {
     				ganttManager.fullScreenMode();
     			}
		};
		
		
		var leftGridColumnNames = {
			'ganttShowAssignedTo': lang('assigned to'),
			'ganttShowStartDates': lang('start date'),
			'ganttShowEndDates': lang('due date'),
			'ganttShowTimeEstimates': lang('estimated time'),
			'ganttShowTimePending': lang('pending time'),
			'ganttShowTimeWorked': lang('worked time'),
			'ganttShowPercentCompletedBar': lang('percent completed')
		}
		
		var leftGridColumnItems = [];
		for (var pref in ogTasks.ganttPreferences) {
			if (pref == 'ganttShowDimensionCols') continue;
			
			var label = leftGridColumnNames[pref];
			
			if (pref.indexOf('ganttShowCP_') == 0) {
				for (var cp_order=0; cp_order < ogTasks.custom_properties.length; cp_order++) {
					var cp = ogTasks.custom_properties[cp_order];
					if (pref == 'ganttShowCP_'+cp.id) {
						label = cp.name;
						break;
					}
				}
			}
			
			leftGridColumnItems.push({
				pref_name: pref,
				text: label,
				checked: (ogTasks.ganttPreferences[pref] == 1),
				checkHandler: function() {
					ogTasks.ganttPreferences[this.pref_name] = (this.checked?1:0);
					ogTasks.redrawGroups = false;
					ogTasks.draw();
					ogTasks.redrawGroups = true;
					var url = og.getUrl('account', 'update_user_preference', {name: this.pref_name, value:(this.checked?1:0)});
					og.openLink(url,{hideLoading:true});
				}
			});
		}
		for (did in og.dimensions) {
			if (isNaN(did)) continue;
			
			tmp_menu_items = ogTasks.createDimensionColumnMenuItems(did, 'ganttShowDimensionCols', true);
			
			if (tmp_menu_items && tmp_menu_items.length > 0) {
				leftGridColumnItems = leftGridColumnItems.concat(tmp_menu_items);
			}
		}
		
		var leftGridColumns = { 
			text: "Left grid columns",
     		iconCls: 'ico-expand',
     		menu: {
     			items: leftGridColumnItems
     		}
		}
		
		var menuItems = [
		         		{text: lang('expand'),
		         			iconCls: 'ico-plus',
		         			menu: {
		         				items: expandMenuItems
		         			}
		         		},
		         		{text: lang('zoom'), 
		         			iconCls: 'ico-expand',
		         			menu: {
		         				items: zoomMenuItems
		         			}
		         		},
		         		{text: lang('export'), 
		         			iconCls: 'ico-picture',
		         			menu: {
		         				items: exportMenuItems
		         			}
		         		},
		         		showTasksNames,
		         		showLeftGrid,
		         		leftGridColumns,
		         		fullScreen
		         	];
		
		var btn = new Ext.Button({
			id: 'gantt_opt',
			iconCls: 'ico-administration-small',
			text: lang('gantt options'),
			menu: {
				cls:'scrollable-menu',
				items: menuItems
			}
		});
		topToolbar.add(btn);
	},
	//Draw Gantt
	drawGantt : function() {
		ganttWrapper.setupGanttToolBar();
		
		var change_view_button = $('#tasksPanelTopToolbarObject').find('button.ico-gantt');
		change_view_button.removeClass('ico-gantt').addClass('ico-task').html(lang('view as list'));
		
		var container_container = $('div#tasksPanelContent');
		var container = $('div#tasksPanelContainer');
		var taskPanelViews = container.find('.ogTasksGroup');

		//switch to Gantt
		if (!$('div.gantt-overlay').parent().is(container)) {
			container_container.append($('div.gantt-overlay'));
		}
		
		//Gantt initialisation
		ganttManager.initGantt();
			
		//END Gantt initialisation
		
		//showTasksList preferences
		ogTasks.userPreferences.showTasksListAsGantt = true;
		
		ganttWrapper.showGanttOrList(true);
		//END showTasksList preferences	
				
	},
	
	//print to pdf or png (type)
	print : function(title,type) {
		var printWindow = "";
		printWindow += '<html><head><title>' + title + '</title>';
		printWindow += '<link href="' + og.hostName + '/public/assets/themes/default/stylesheets/website.css" rel="stylesheet" type="text/css">';
		printWindow += '<link href="' + og.hostName + '/plugins/gantt/public/assets/css/gantt.css" rel="stylesheet" type="text/css">';
		printWindow += '<link href="' + og.hostName + '/plugins/gantt/public/assets/css/gantt_pdf.css" rel="stylesheet" type="text/css">';
		printWindow += '<link href="' + og.hostName + '/public/assets/themes/default/stylesheets/general/rewrites.css" rel="stylesheet" type="text/css">';
				
		printWindow += '</head><body id="body">'; 
		
		//Get gantt html
		printWindow += '<div style="float: left; width: '+$('.gantt_grid').first().width()+'px;">'+$('.gantt_grid').first().html()+'</div>';
		printWindow += '<div style="float: left;width:10px;">'+$('.gantt_task').first().html()+'</div>';
					
		printWindow += '</body></html>';
				
		var parameters = [];
		parameters["html_to_convert"] = printWindow;
		printWindow = null;		
		var url = og.getUrl('gantt', 'to_'+type);
		og.openLink(url, {
			method: 'POST',
			post: parameters,
			hideLoading : false,
			onSuccess: function(data) {
				var $form = $("<form></form>");
				$form.attr("action", og.getUrl('gantt', 'download_file'));
				$form.attr("method", "post");
				$form.append('<input type="text" name="file_name" value="'+data.file_data_name+'" />');
				$form.append('<input type="text" name="file_type" value="'+data.file_data_type+'" />');
				
				$form.appendTo('body').submit().remove();				
			}
		});			
	}
	
};

//Always listen if ogTasks.Groups change and if showTasksListAsGantt is true redraw gantt
og.eventManager.addListener('after ogTasks.Groups list completely loaded',function(){
	//Important remove loadMoreTasks interval if the task list is reloaded
	if(ganttManager.intervalId != null){
		window.clearInterval(ganttManager.intervalId);
		ganttManager.intervalId = null;
		og.hideLoading();
	}	
	
	if(ogTasks.userPreferences.showTasksListAsGantt){
		ganttWrapper.drawGantt();						
	}else{
		ganttWrapper.showGanttOrList(false);
	}		
});
