<?php


function create_project_folder_in_sharepoint($folder_name) {
	
	set_time_limit(0);
	ini_set('memory_limit', '1G');
	
	Env::useLibrary('phpSPO', 'sharepoint_library');
	/*
	$settings = array(
			'BaseUrl' => 'https://dfodor.sharepoint.com',
			'SitePath' => '/sites/Projects',
			'UserName' => 'damian@dfodor.onmicrosoft.com',
			'Password' => 'f6@8BmD(',
	);
	*/
	$settings = array(
			'BaseUrl' => config_option('sp_base_url'),
			'SitePath' => config_option('sp_site_path'),
			'UserName' => config_option('sp_user'),
			'Password' => config_option('sp_password'),
	);
	
	// authenticate with the general url, only the domain, without path
	$authCtx = new Office365\Runtime\Auth\AuthenticationContext($settings['BaseUrl']);
	$authCtx->acquireTokenForUser($settings['UserName'], $settings['Password']);
	// set the context using the url containing the site path
	$context = new Office365\SharePoint\ClientContext($settings['BaseUrl'] . $settings['SitePath'], $authCtx);
	
	$site = $context->getSite();
	$context->load($site); //load site settings
	$context->executeQuery();
	
	$list = $context->getWeb()->getLists()->getByTitle("Documents");
	
	return do_create_project_folder_in_sharepoint($context, $list, $folder_name);
}



function do_create_project_folder_in_sharepoint(Office365\SharePoint\ClientContext $context, Office365\SharePoint\SPList $targetList, $folderName) {
	$root_parent_folder = config_option('sp_projects_dir'); //'Projects18000';
	
	$child_folders = array(
			'Client Instruction',
			'Correspondence and Emails',
			'Desk Study',
			'Drawings & Figures',
			'Field Notes and Drillers Logs',
			'HS & MS Documents',
			'Invoicing',
			'Lab Results',
			'Lab Schedules',
			'Landgas & Groundwater Monitoring',
			'Photos',
			'Proposal',
			'Remediation - RMS',
			'Report Drafts',
			'Report Final',
			'Site Instruction',
			'Tender Information',
			'Validation',
	);
	
	/*
	 $folder = $targetList->getRootFolder()->getFolders()->add($folderName);
	 //$context->load($targetList->getRootFolder());
	 $context->executeQuery();
	 */
	
	// add the folder for the project
	$projects_root_folder = $targetList->getRootFolder()->getFolders()->getByUrl(config_option('sp_site_path').'/Shared%20Documents/'.$root_parent_folder);
	$folder = $projects_root_folder->getFolders()->add($folderName);
	$context->executeQuery();
	
	// add the project folder childs
	foreach ($child_folders as $child_folder) {
		$folder->getFolders()->add($child_folder);
		$context->executeQuery();
	}
	
	return $folder;
}