<?php

/**
 * InvoiceTemplateController
 * Generado el 20/8/2012
 * 
 */
class InvoiceTemplateController extends ApplicationController {

    var $plugin_name = "income";

    /**
     * Construct the InvoiceTemplateController
     *
     * @access public
     * @param void
     * @return InvoiceTemplateController
     */
    function __construct() {
        parent::__construct();
        prepare_company_website_controller($this, 'website');
        Env::useHelper('functions', 'income');
    }

    /**
     * Show invoice_templates
     *
     * @param void
     * @return null
     */
    function index() {
        if (!can_manage_invoicing_configuration(logged_user())) {
            flash_error(lang('no access permissions'));
            ajx_current("empty");
            return;
        } // if
        $this->addHelper('textile');

        $invoice_templates = IncomeInvoiceTemplates::findAll();
        tpl_assign('invoice_templates', $invoice_templates);
    }

    function add() {
    	if (!can_manage_invoicing_configuration(logged_user())) {
    		flash_error(lang('no access permissions'));
    		ajx_current("empty");
    		return;
    	}
    
    	$invoice_template_post = array_var($_POST, 'invoice_template');
    	if (!is_array($invoice_template_post)) {
    		// set layout for modal form
    		if (array_var($_REQUEST, 'modal')) {
    			$this->setLayout("json");
    			tpl_assign('modal', true);
    		}
    		
    		tpl_assign('invoice_template', new IncomeInvoiceTemplate());
    	} else {
    		try {
    			DB::beginWork();
    			$invoice_template = new IncomeInvoiceTemplate();                
                $this->save_invoice_template($invoice_template_post, $invoice_template, true);
    			
                flash_success(lang('success add invoice template'));
    
    			if (array_var($_REQUEST, 'modal')) {
    				evt_add("reload current panel");
    				ajx_current("empty");
    			} else {
    				ajx_current("reload");
    			}
    
    			DB::commit();
    		} catch (Exception $e) {
    			DB::rollback();
    			flash_error($e->getMessage());
    			ajx_current("empty");
    		}
    	}
    }

    function edit() {
        $this->setTemplate("add");
    	if (!can_manage_invoicing_configuration(logged_user())) {
    		flash_error(lang('no access permissions'));
    		ajx_current("empty");
    		return;
        }
        
        $id = get_id();
    	$invoice_template = IncomeInvoiceTemplates::findById($id);
    
    	$invoice_template_post = array_var($_POST, 'invoice_template');             
    	if (!is_array($invoice_template_post)) {
    		// set layout for modal form
    		if (array_var($_REQUEST, 'modal')) {
    			$this->setLayout("json");
    			tpl_assign('modal', true);
    		}
    		
            tpl_assign('invoice_template', $invoice_template);
            tpl_assign('invoice_template_edit', $invoice_template->getArrayInfo());
    	} else {
    		try {
                DB::beginWork();
                $this->save_invoice_template($invoice_template_post, $invoice_template, false);
    			
                flash_success(lang('success edit invoice template'));
    
    			if (array_var($_REQUEST, 'modal')) {
    				evt_add("reload current panel");
    				ajx_current("empty");
    			} else {
    				ajx_current("reload");
    			}
    
    			DB::commit();
    		} catch (Exception $e) {
    			DB::rollback();
    			flash_error($e->getMessage());
    			ajx_current("empty");
    		}
    	}
    }

    function delete() {
        ajx_current("empty");
        $invoice_template = IncomeInvoiceTemplates::findById(get_id("template_id"));
        if ($invoice_template instanceof IncomeInvoiceTemplate) {
            $invoice_template->delete();
            flash_success(lang('success delete invoice template'));
        }

    }

    function save_invoice_template($invoice_template_post, IncomeInvoiceTemplate $invoice_template_data, $is_new=true) {                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
        $labor_category_dimension = Dimensions::findByCode('hour_types');
        if($invoice_template_post['is_default']){
            $default_template = IncomeInvoiceTemplates::findOne(array('conditions' => ' is_default=1 '));
            if($default_template instanceof IncomeInvoiceTemplate && $default_template->getId() != $invoice_template_data->getId()){
                $default_template->setIsDefault(0);
                $default_template->save();
            }  
        }
        
        $invoice_template_data->setTemplateType($invoice_template_post['template_type']);
        
        $invoice_template_data->setName($invoice_template_post['name']);
        $invoice_template_data->setIsDefault($invoice_template_post['is_default']);
        $invoice_template_data->setGroupBy($invoice_template_post['group_by']);

        $invoice_template_data->setBreakDownBySubprojects($invoice_template_post['break_down_by_subprojects']);
		$invoice_template_data->setBreakDownExpensesByCategory($invoice_template_post['break_down_expenses_by_category']);
		$invoice_template_data->setShowExpensesMarkupSeparated($invoice_template_post['show_expenses_markup_separated']);
		$invoice_template_data->setAccumulateDiscounts($invoice_template_post['accumulate_discounts']);
		
        //FOR TIMESLOTS
        //columns
        $invoice_template_data->setIncludeDate($invoice_template_post['include_date']);
        $invoice_template_data->setincludeTimeLineDate($invoice_template_post['include_time_line_date']);
        $invoice_template_data->setCategoryForTimeslotCol($invoice_template_post['category_for_timeslot_col']);
        $invoice_template_data->setProductTypeForTimeslotCol($invoice_template_post['product_type_for_timeslot_col']);
        $invoice_template_data->setCategoryForTimeslot($invoice_template_post['category_for_timeslot']);
        $invoice_template_data->setProductTypeForTimeslot($invoice_template_post['product_type_for_timeslot']);
        $invoice_template_data->setIncludeDescription($invoice_template_post['include_description']);
        $invoice_template_data->setIncludeUserNameCol($invoice_template_post['include_user_name_col']);
        
        
        //for descripction
        $invoice_template_data->setIncludeUserName($invoice_template_post['include_user_name']);
        $invoice_template_data->setIncludeLaborCategory($invoice_template_post['include_labor_category']);
        $invoice_template_data->setIncludeTaskName($invoice_template_post['include_task_name']);
        $invoice_template_data->setincludeTimeEntryDescription($invoice_template_post['include_time_entry_description']);
        $invoice_template_data->setIncludeProjectName($invoice_template_post['include_project_name']);
        //totals
        $invoice_template_data->setIncludeHours($invoice_template_post['include_hours']);
        $invoice_template_data->setIncludeRate($invoice_template_post['include_rate']);
        $invoice_template_data->setIncludeTotal($invoice_template_post['include_total']);

        //lump sum
        $invoice_template_data->setIncludeLumpSumProjectNumber($invoice_template_post['include_lump_sum_project_number']);
        $invoice_template_data->setIncludeLumpSumProjectName($invoice_template_post['include_lump_sum_project_name']);
        $invoice_template_data->setIncludeLumpSumFromTo($invoice_template_post['include_lump_sum_from_to']);
        $invoice_template_data->setincludeLumpSumBudgetCompletion($invoice_template_post['include_lump_sum_budget_completion']);
        $invoice_template_data->setIncludeLumpQuantity($invoice_template_post['include_lump_sum_quantity']);
        $invoice_template_data->setIncludeLumpSumDateCol($invoice_template_post['include_lump_sum_date_col']);
        $invoice_template_data->setIncludeLumpSumUnitPrice($invoice_template_post['include_lump_sum_unit_price']);
        $invoice_template_data->SetIncludeLumpDate($invoice_template_post['include_lump_sum_date']);
        $invoice_template_data->setIncludeLumpSumProjectType($invoice_template_post['include_lump_sum_project_type']);
        $invoice_template_data->setCategoryForLumpSum($invoice_template_post['category_for_lump_sum']);
        $invoice_template_data->setCategoryForLumpSumCol($invoice_template_post['category_for_lump_sum_col']);
        $invoice_template_data->setProductTypeForLumpSumcol($invoice_template_post['product_type_for_lump_sum_col']);
        $invoice_template_data->setProductTypeForLumpSum($invoice_template_post['product_type_for_lump_sum']);
        $invoice_template_data->setIncludeLumpSumDeetailCol($invoice_template_post['include_lump_sum_deetail_col']);
        
        //expenses
        //columns
        $invoice_template_data->setExpGroupBy(array_var($invoice_template_post, 'exp_group_by'));
        $invoice_template_data->setIncludeExpQuantity(array_var($invoice_template_post, 'include_exp_quantity'));
        $invoice_template_data->setIncludeExpAmount(array_var($invoice_template_post, 'include_exp_amount'));
        $invoice_template_data->setIncludeExpFee(array_var($invoice_template_post, 'include_exp_fee'));
        $invoice_template_data->setIncludeExpTotal(array_var($invoice_template_post, 'include_exp_total'));
        $invoice_template_data->setDisplayCostOrPrice(array_var($invoice_template_post, 'display_cost_or_price'));
        $invoice_template_data->setIncludeExpDate(array_var($invoice_template_post, 'include_exp_date'));
        $invoice_template_data->setIncludeExpTypeDate(array_var($invoice_template_post, 'include_exp_type_date'));
        $invoice_template_data->setIncludePaidBy(array_var($invoice_template_post, 'include_paid_by'));
        $invoice_template_data->setIncludeProductType(array_var($invoice_template_post, 'include_product_type'));
        $invoice_template_data->setIncludeExpenseCategory(array_var($invoice_template_post, 'include_expense_category'));
        $invoice_template_data->setIncludeExpenseName(array_var($invoice_template_post, 'include_expense_name'));
		$invoice_template_data->setIncludeExpenseDescription(array_var($invoice_template_post, 'include_expense_description'));
        $invoice_template_data->setIncludeExpenseProjectNumber(array_var($invoice_template_post, 'include_expense_project_number'));
		$invoice_template_data->setIncludeExpenseProjectName(array_var($invoice_template_post, 'include_expense_project_name'));

        $invoice_template_data->setIncludeExpUserNameCol($invoice_template_post['include_exp_user_name_col']);
        $invoice_template_data->setCategoryForExpenseCol($invoice_template_post['category_for_expenses_col']);
        $invoice_template_data->setCategoryForExpense($invoice_template_post['category_for_expenses']);
        $invoice_template_data->setProductTypeForExpenseCol($invoice_template_post['product_type_for_expenses_col']);
        $invoice_template_data->setProductTypeForExpense($invoice_template_post['product_type_for_expenses']);
        $invoice_template_data->setIncludeExpDescription($invoice_template_post['include_exp_description']);

        

        $invoice_template_data->setShowTaxesForEachLine(array_var($invoice_template_post, 'show_taxes_for_each_line'));
        $invoice_template_data->setShowHeadersBeforeDetails(array_var($invoice_template_post, 'show_headers_before_details'));
        $invoice_template_data->setIncludeAccountSummary(array_var($invoice_template_post, 'include_account_summary'));
        $invoice_template_data->setIncludeFooterText(array_var($invoice_template_post, 'invoice_footer_disclaimer'));
        
		// when not grouping, for the include exp description and include exp name => use the value of the combobox "expense_use_name_or_desc"
		if (array_var($invoice_template_post, 'exp_group_by') == 'payment_receipts') {
			
			$field_to_show = array_var($invoice_template_post, 'expense_use_name_or_desc');

			if ($field_to_show == 'use_exp_name') {

				$invoice_template_data->setIncludeExpenseName(true);
				$invoice_template_data->setIncludeExpenseDescription(false);

			} else if ($field_to_show == 'use_exp_desc') {

				$invoice_template_data->setIncludeExpenseName(false);
				$invoice_template_data->setIncludeExpenseDescription(true);

			} else if ($field_to_show == 'none') {

				$invoice_template_data->setIncludeExpenseName(false);
				$invoice_template_data->setIncludeExpenseDescription(false);
			}
		}

        // INVOICE TEMPLATES ::
        $invoice_template_data->setInvoiceTemplateColumnAssigned(array_var($invoice_template_post, 'invoice_template_assigned'));

        $invoice_template_data->save();
    
    	return $invoice_template_data;
    }
    

    
    
    function get_invoice_templates_data() {
    	ajx_current("empty");
    	
    	$data = array();
    	$templates = IncomeInvoiceTemplates::findAll();
    	foreach ($templates as $t) { /* @var $t IncomeInvoiceTemplate */
    		$data[] = $t->getArrayInfo();
    	}
    	
    	ajx_extra_data(array("invoice_templates" => $data));
    }
}
