<?php

class IncomeInvoiceLineTaxes extends BaseIncomeInvoiceLineTaxes {

    function __construct() {
        parent::__construct();
    }
    
    
    static function getAllLineTaxes($line_id) {
    	return self::findAll(array("conditions" => array("invoice_line_id = ?", $line_id)));
    }
    
    static function getAllLineTaxesInfo($line_id) {
    	$all_info = array();
    	
    	$line_taxes = self::getAllLineTaxes($line_id);
    	foreach ($line_taxes as $line_tax) {
    		$all_info[$line_tax->getTaxId()] = $line_tax->getArrayInfo();
    	}
    	
    	return $all_info;
    }
    
    static function getTaxValue($line_id, $tax_id) {
    	
    	$value = 0;
    	
    	$tax_val_obj = self::findOne(array("conditions" => array("invoice_line_id = ? AND tax_id = ?", $line_id, $tax_id)));
    	if ($tax_val_obj instanceof IncomeInvoiceLineTax) {
    		$value = $tax_val_obj->getValue();
    	}
    	
    	return $value;
    }

}

