<?php

/**
 * IncomeInvoiceTemlate
 * Created: 06/15/20
 * Author: Alex Zonis
 * 
 */
class IncomeInvoiceTemplate extends BaseIncomeInvoiceTemplate {
    // ---------------------------------------------------
    //  System
    // ---------------------------------------------------

    function getArrayInfo($include_html_fields = true) {
        
        $result = array();
        foreach ($this->getColumns() as $col) {
        	$result[$col] = $this->getColumnValue($col);
        }

		if (!$include_html_fields) {
			unset($result['footer_text']);
		}
        
        return $result;
    }
    
	function orderMultiDimensionalArray ($toOrderArray, $field, $inverse) {  
		$position = array();  
		$newRow = array();  
		foreach ($toOrderArray as $key => $row) {  
				$position[$key]  = $row[$field];  
				$newRow[$key] = $row;  
		}  
		if ($inverse) {  
			arsort($position);  
		}  
		else {  
			asort($position);  
		}  
		$returnArray = array();  
		foreach ($position as $key => $pos) {       
			$returnArray[] = $newRow[$key];  
		}  
		return $returnArray;  
	}  

    function getHtmlDetailsTableForInvoice(IncomeInvoice $invoice, $print_options = array()) {
		Env::useHelper('functions', 'income');
    	$use_taxes_in_lines = income_config_option("use_line_taxes");
		$print_labels = array_var($print_options, 'labels', array());
    	
    	/***********lump sum and timeslots */
		$column_order = array();
    	$columns = array();

		/***************EXPENSES LINES **********************/
		$act_exp_column_order = array();
		$act_exp_columns = array();

		///////////////////////$columns['amount'] = lang('hours');
		/**deprecated */
    	
    	
    	/*$include_cat_in_description = false;
    	if ($this->getIncludeLaborCategory() && $this->getIncludeDescription()) {
    		//$include_cat_in_description = true;
    		//$column_order[] = 'description';
    		//$columns['description'] = lang('description');
    	} else {
	    	//if ($this->getIncludeLaborCategory()) {
	    	//	$column_order[] = 'category';
	    	//	$columns['category'] = array_var($print_labels, 'labor', lang('labor category'));
	    	//}
			if($this->getTemplateType() == 'lumpsum')
			{
				//$column_order[] = 'amount';
	    		//$columns['amount'] = lang('quantity');
			}
    	}*/

		if ($use_taxes_in_lines && $this->getShowTaxesForEachLine()) {
			$inv_taxes = $invoice->getTaxes();
			$taxes_by_id = array();
			foreach ($inv_taxes as $inv_tax) {
				$column_order[] = 'tax_' . $inv_tax->getTaxId();
				$taxes_by_id[$inv_tax->getTaxId()] = IncomeTaxes::findById($inv_tax->getTaxId());
			}
		}

		if ($use_taxes_in_lines && $this->getShowTaxesForEachLine()) {
			foreach ($inv_taxes as $inv_tax) {
				$columns['tax_' . $inv_tax->getTaxId()] = $taxes_by_id[$inv_tax->getTaxId()]->getName();
			}
		}
		
		/*******detailed template*************/
    	if ($this->getTemplateType() == 'detailed') {
    		
			/******************TIMES LINES*****************/
			if ($this->getIncludeDate()) {
				$column_order[] = 'date';
				$columns['date'] = lang('date');
			}

			if (strtolower($this->getIncludeUserNameCol()) != strtolower('Do not Display')) {
				$column_order[] = 'user';
				$columns['user'] = lang('employee');
				$initials = $this->getIncludeUserNameCol() == 'Initials';
    		}

			if ($this->getCategoryForTimeslotCol()) {
				$column_order[] = 'category';
				$columns['category'] = lang('labor category');
			}
			if ($this->getProductTypeForTimeslotCol()) {
				$column_order[] = 'product type';
				$columns['product type'] = lang('product type');
			}

			if($this->getIncludeDescription() ||$this->getIncludeCustomDescription())
			{
			$column_order[] = 'description';
			$columns['description'] = lang('description');
			}
	
			if($this->getIncludeHours())
			{
				$column_order[]='amount';
				$columns['amount'] = lang('hours');
			}
			if ($this->getIncludeRate()) {
				$column_order[] = 'unit_value';
				$columns['unit_value'] = lang('rate');
			}
			if($this->getIncludeTotal())
			{
				$column_order[] = 'total';
				$columns['total'] = lang('amount'); // previously called "Amount"
			}

			///////////////////Expenses///////////////////////////////
			////date
			if($this->getIncludeExpDate())
			{
				$act_exp_column_order[] = 'date';
		    	$act_exp_columns['date'] = lang('date');
			}

			if (strtolower($this->getIncludeExpUserNameCol()) != strtolower('Do not Display')) {
				$act_exp_column_order[] = 'user';
				$act_exp_columns['user'] = lang('employee');
				$initials_exp = $this->getIncludeExpUserNameCol() == 'Initials';
    		}

			if ($this->getProductTypeForExpenseCol()) {
				$act_exp_column_order[] = 'product type';
				$act_exp_columns['product type'] = lang('expense_line');
			}

			if ($this->getCategoryForExpenseCol()) {
				$act_exp_column_order[] = 'category';
				$act_exp_columns['category'] = lang('expense_line');
			}
			
			///detail
			if ($this->getIncludeExpDescription()) {
				$act_exp_column_order[] = 'description';
				$act_exp_columns['description'] = lang('description');
			}

			///quantity
			if($this->getIncludeExpQuantity())
			{
				$act_exp_column_order[] = 'amount';
				$act_exp_columns['amount'] = lang('quantity');
			}

			///amount
			if($this->getIncludeExpAmount())
			{
				$act_exp_column_order[] = 'unit_value';
		    	$act_exp_columns['unit_value'] = lang('unit_value');
			}

			///fee
			if ($this->getIncludeExpFee() ) {
	    		
	    		$act_exp_column_order[] = 'unit_cost';
	    		$act_exp_columns['unit_cost'] = lang('unit cost');
	    		
	    		$act_exp_column_order[] = 'fee';
	    		$act_exp_columns['fee'] = lang('fee');
	    	}

			///total
			if($this->getIncludeExpTotal())
			{
    	   		$act_exp_column_order[] = 'total';
	    		$act_exp_columns['total'] = lang('amount');
			}

	    		    	
	    	// set the same amount of columns for each table
	    	$exp_col_count = count($act_exp_column_order);
	    	while ($exp_col_count < count($column_order)) {
	    		$last_cols_count = $this->getDisplayCostOrPrice() == 'cost_and_fee' ? -4 : -3;//getIncludeExpFee getDisplayCostOrPrice
	    		$last_cols = array_splice($act_exp_column_order, $last_cols_count);
	    		$act_exp_column_order[] = '';
	    		$act_exp_column_order = array_merge($act_exp_column_order, $last_cols);
	    		$exp_col_count++;
	    	}
	    	
	    	$col_count = count($column_order);
	    	while ($col_count < count($act_exp_column_order)) {
	    		$last_3_cols = array_splice($column_order, -3);
	    		$column_order[] = '';
	    		$column_order = array_merge($column_order, $last_3_cols);
	    		$col_count++;
	    	}
			
    	}
		else if ($this->getTemplateType() == 'lumpsum'){
			
			if($this->getIncludeLumpSumDateCol())
			{
				$column_order[] = 'date';
		    	$columns['date'] = lang('date');
			}

			if($this->getCategoryForLumpSumCol())
			{
				$column_order[] = 'category';
		    	$columns['category'] = lang('category');
			}
			if($this->getProductTypeForLumpSumCol())
			{
				$column_order[] = 'product type';
		    	$columns['product type'] = lang('product type');
			}

			
			$column_order[] = 'description';
    		$columns['description'] = lang('description');
			
			if($this->getIncludeLumpQuantity()){
				$column_order[] = 'amount';
	    		$columns['amount'] = lang('quantity');
			}
			if($this->getIncludeLumpSumUnitPrice()){
				$column_order[] = 'unit_value';
				$columns['unit_value'] = lang('price');
			}
			
			if ($this->getTemplateType() == 'lumpsum' && $use_taxes_in_lines && $this->getShowTaxesForEachLine()) {
		
				$column_order[] = 'subtotal';
				$columns['subtotal'] = lang('subtotal');
			}
			$column_order[] = 'total';
			$columns['total'] = lang('total');
		}
		else if ($this->getTemplateType() == 'lumpsum_view'){
			$column_order = array('description', 'amount', 'total');
			$columns = array(
				'description' => lang('description'),
				'amount' => lang('quantity'),
				'total' => lang('amount'),
			);

		}

		if($this->getBreakDownBySubprojects()=='MULTI')
		{
			//1 get all the invoices related
			$invoice_ids=[];
			
			$resInvoices=IncomeInvoiceChilds::getInvoiceChild($invoice->getObjectId());
			
			//search by childs invoices
			if(!$resInvoices)
			{
				$resInvoicesParents=IncomeInvoiceChilds::getInvoiceParent($invoice->getObjectId());
				foreach($resInvoicesParents as $resInvoicesParent)
				{
					$resInvoices=IncomeInvoiceChilds::getInvoiceChild($resInvoicesParent->getInvoiceParent());
				}
			}

			foreach($resInvoices as $resInvoice)
			{
				$invoice_ids[]=$resInvoice->getInvoiceChild();
			}
			
			//2 find all timeslot and expenses for all the invoices related
			$timeslots=Timeslots::findAll(array("conditions" => "invoice_id IN (".implode(',', $invoice_ids).")" ));
			$PaymentReceipts=PaymentReceipts::findAll(array("conditions" => "invoice_id IN (".implode(',', $invoice_ids).")" ));
			
			//3 group by subproject
			$this->setBreakDownBySubprojects('SINGLE');
			$grouped_timeslots=IncomeInvoiceTemplates::groupTimeslotsUsingTemplate($this, $timeslots);
			$grouped_payment_receipts=IncomeInvoiceTemplates::groupTimeslotsUsingTemplate($this, $PaymentReceipts);
			$this->setBreakDownBySubprojects('MULTI');

			//3 build the lines
			$lines = IncomeInvoiceTemplates::buildInvoiceLinesFromGroups($this, $grouped_timeslots, $grouped_payment_receipts);
		}else{
			$lines = $invoice->getInvoiceLines();
		};

    	$discount = 0;
    	$subtotal = 0;
    	$act_exp_subtotal = 0;
    	$lines_data = array();
    	$act_exp_lines_data = array();
    	$line_groups = array();

		if ($this->getTemplateType() == 'lumpsum_view') {
			// generate one line accumulating all non-discount lines

			// build lump sum description {Project name}, {from date} To {until date}
			// project name
			$project_ot = ObjectTypes::findByName('project');
			$project_name = '';
			$invoice_members = $invoice->getMembers();
			foreach ($invoice_members as $invoice_member) {
				if ($invoice_member->getObjectTypeId() == $project_ot->getId()) {
					$project_name = $invoice_member->getName();
					break;
				}
			}

			// from date and to date
			$billing_from_cp = CustomProperties::getCustomPropertyByCode($invoice->getObjectTypeId(), 'billing_period_from');
			$billing_to_cp = CustomProperties::getCustomPropertyByCode($invoice->getObjectTypeId(), 'billing_period_to');
			$billing_from_date = '';
			$billing_to_date = '';
			$cp_val = CustomPropertyValues::getCustomPropertyValue($invoice->getId(), $billing_from_cp->getId());
			if ($cp_val && $cp_val->getValue() != '') {
				try {
					$dt = DateTimeValueLib::dateFromFormatAndString('Y-m-d', $cp_val->getValue());
					$billing_from_date = format_date($dt, null, 0);
				} catch (Exception $e) {
				}
			}
			$cp_val = CustomPropertyValues::getCustomPropertyValue($invoice->getId(), $billing_to_cp->getId());
			if ($cp_val && $cp_val->getValue() != '') {
				try {
					$dt = DateTimeValueLib::dateFromFormatAndString('Y-m-d', $cp_val->getValue());
					$billing_to_date = format_date($dt, null, 0);
				} catch (Exception $e) {
				}
			}

			// concat description parts
			$ls_description = $project_name . ", $billing_from_date " . lang('to') . " $billing_to_date";
			
			// accumulate lump sum total
			$ls_total_raw = 0;
			foreach ($lines as $line) {
				$ls_total_raw += $line->getTotal();
			}

			// total to show in line
			$c_sym = '$';
			$currency = Currencies::instance()->getCurrency($line->getCurrencyId());
			
			if ($currency)
			{
			 $c_sym = $currency->getSymbol();
			}

			$ls_total = format_money_amount($ls_total_raw, $c_sym);
			$lineShowTotal=$ls_total_raw;

			// build lines data object to send to the view
			$ls_lines_data = array(
				array(
					'description' => $ls_description,
					'amount' => 1,
					'total' => $ls_total,
				)
			);

			$line_group_id = 0;
			$line_group_name = '';
			$line_group_code = '';

			// build lines group to send to the view
			$line_groups[$line_group_id] = array(
				'name' => $line_group_name,
				'code' => $line_group_code,
				'lines_data' => $ls_lines_data,
				'discount' => 0,
				'subtotal' => $ls_total_raw,
				'act_exp_lines_data' => array(),
				'act_exp_subtotal' => 0,
			);

		} else {
			$key=0;
			$lineShowTotal=0;
			foreach ($lines as $line) { /* @var $line IncomeInvoiceLine */

				if($this->getBreakDownBySubprojects()=='MULTI'){
					$key++;
					$lineCategoryId=$line['category_id'];	
					$lineTotal=$line['total'];
					$lineMemberId=$line['member_id'];
					$lineGetFormObjectType=$line['from_object_type_id'];;
					$lineGetCurrencyId=$line['currency_id'];;
					$lineGetDetail=$line['detail'];
					$lineGetDate=$line['date'];
					$lineGetUnitValue=$line['unit_value'];
					$lineGetId=$key;
					$lineGetProductType=$line['product_type_id'];
					$lineGetAnount=$line['amount'];
					$lineItemTypeId= 0;
					$lineGetUnitCost=$line['unit_cost'];
					$lineGetPriceMultiplier=$line['price_multiplier'];
					$lineShowTotal=$lineShowTotal+$line['total'];
				}else{
					$lineCategoryId=$line->getCategoryId();
					$lineTotal=$line->getTotal();	
					$lineMemberId=$line->getMemberId();
					$lineGetFormObjectType=$line->getFromObjectTypeId();
					$lineGetCurrencyId=$line->getCurrencyId();
					$lineGetDetail=$line->getDetail();
					$lineGetDate=$line->getDate();
					$lineGetUnitValue=$line->getUnitValue();
					$lineGetId=$line->getId();
					$lineGetProductType=$line->getProductTypeId();
					$lineGetAnount = $line->getAmount();
					$lineItemTypeId= $line->getItemTypeId();
					$lineGetUnitCost=$line->getUnitCost();
					$lineGetPriceMultiplier=$line->getPriceMultiplier();
					$lineShowTotal=$invoice->getTotal();
				}

				// first level grouping: projects
				if ($this->getBreakDownBySubprojects() || $this->getGroupBy() == 'project_labor_category' || $this->getExpGroupBy() == 'project_expense_category') {
					$line_group_id = $lineMemberId;
					if ($line_group_id > 0) {
						$line_member = Members::getMemberById($line_group_id);
						if ($line_member) {
							$raw_name = $line_member->getName();
							$tmp_mem = array($line_member);
							build_member_list_text_to_show_in_trees($tmp_mem);
							$line_group_name = $line_member ? $line_member->getName() : '';
							$line_group_code = str_replace($raw_name, '', $line_group_name);
						}
					} else {
						$line_group_name = '';
						$line_group_code = '';
					}
				} else {
					$line_group_id = 0;
					$line_group_name = '';
					$line_group_code = '';
				}
				$accumulate_discounts = $this->getAccumulateDiscounts();
				
				if ($lineGetFormObjectType == 0 || $lineGetFormObjectType == Timeslots::instance()->getObjectTypeId()) {
					$c_sym = '$';
					$currency = Currencies::instance()->getCurrency($invoice->getCurrencyId());
					if ($currency) $c_sym = $currency->getSymbol();
					if ($lineTotal < 0) {//is discount
						//////// discounts
						if ($accumulate_discounts=='consolidated') {
	
							if (!isset($line_groups[$line_group_id])) {
								$line_groups[$line_group_id] = array(
										'name' => $line_group_name,
										'code' => $line_group_code,
										'lines_data' => array(),
										'discount' => 0,
										'subtotal' => 0,
										'act_exp_lines_data' => array(),
										'act_exp_subtotal' => 0,
								);
							}
							$line_groups[$line_group_id]['discount'] += abs($lineTotal);
							continue;
	
						} else if ($accumulate_discounts=='separated_section'){
	
							$line_group_id = 'discounts_table';
							if (!isset($line_groups[$line_group_id])) {
							
								$line_group_code = 'discounts_table';
	
								$line_groups[$line_group_id] = array(
										'name' => $line_group_name,
										'code' => $line_group_code,
										'lines_data' => array(),
										'discount' => 0,
										'subtotal' => 0,
										'act_exp_lines_data' => array(),
										'act_exp_subtotal' => 0,
								);
							}
							$row = array(
								'description' => nl2br($lineGetDetail),
								'total' => format_money_amount($lineTotal, $c_sym),
							);
	
							$line_groups[$line_group_id]['lines_data'][] = $row;
							continue;
	
						} else if($accumulate_discounts=='between_line_items'){
	
							$line_group_id = '0';
							if (!isset($line_groups[$line_group_id])) {
							
								$line_group_code = '0';
	
								$line_groups[$line_group_id] = array(
										'name' => $line_group_name,
										'code' => $line_group_code,
										'lines_data' => array(),
										'discount' => 0,
										'subtotal' => 0,
										'act_exp_lines_data' => array(),
										'act_exp_subtotal' => 0,
								);
							}
	
							$valueDateDisscount	='';
							if ($lineGetDate instanceof DateTimeValue)
							{
								$valueDateDisscount = format_date($lineGetDate, null, 0);
							}
							$row = array(
								'date' => $valueDateDisscount,//format_date($line->getDate(), null, 0),
								'detail' => nl2br($lineGetDetail),
								'description' => nl2br($lineGetDetail),
								'category' => nl2br($lineGetDetail),
								'amount' => $lineGetAnount,
								'unit_value' => format_money_amount($lineGetUnitValue, $c_sym),
								'total' => format_money_amount($lineTotal, $c_sym),
							);
	
	
							/*$first_col = $column_order[0];
							$first_col_val = strtolower($row[$first_col]);*/
							$row_sort_key = /*$first_col_val .'-'.*/ $lineGetId; // add the line id to the key to avoid overlapping of rows with the same key
	
							$line_groups[$line_group_id]['subtotal'] += $lineTotal;
							$line_groups[$line_group_id]['lines_data'][$row_sort_key] = $row;
	
							continue;
	
						}
						////////end discounts
					}
					/* @var $line IncomeInvoiceLine */
					$row = array();
					
					foreach ($column_order as $col) {
						$value = '';
						switch ($col) {
							case 'date':
								if ($lineGetDate instanceof DateTimeValue) $value = format_date($lineGetDate, null, 0);
								break;
							case 'user':
								$value = $initials ? $line->getUserInitials() : $line->getUserName() ;
								break;
							case 'category':
								$cat_member = Members::getMemberById($lineCategoryId);
								if ($cat_member) $value = $cat_member->getName();
								else 
								$value = nl2br($lineGetDetail);
								break;
							case 'product type':
									$product_type_aux = ProductTypes::getById($lineGetProductType);
									$value = $product_type_aux instanceof ProductType ? $product_type_aux->getName() : '';
									break;
							case 'description':
								/*if ($include_cat_in_description) {
									$cat_member = Members::getMemberById($line->getCategoryId());
									if ($cat_member) $value .= '<span class="cat-name">'. $cat_member->getName() . '</span><br />';
								}*/
								$value .= nl2br($lineGetDetail);
								break;
							case 'amount':
								if($lineItemTypeId>4)
								{
									$value = '';
								}else{
									$value = number_format($lineGetAnount, 2);
								}
								
								break;
							case 'unit_value':
								if($lineItemTypeId>4)
								{
									$value = '';
								}else{
									$value = format_money_amount($lineGetUnitValue, $c_sym);
								}
								break;
							case 'total':
								if($lineItemTypeId>4)
								{
									$value = '';
								}else{
									$value = format_money_amount($lineTotal, $c_sym);
								}
								break;
							case 'subtotal':
								$value = format_money_amount($line->getSubTotal(), $c_sym);
								break;
							default:
								if (str_starts_with($col, "tax_")) {
									$tax_id = str_replace("tax_","",$col);
									$tax_line_amount = IncomeInvoiceLineTaxes::getTaxValue($lineGetId, $tax_id);
									$value = format_money_amount($tax_line_amount, $c_sym);
								}
								break;
						}
						$row[$col] = $value;
					}
					
					if (!isset($line_groups[$line_group_id])) {
						$line_groups[$line_group_id] = array(
								'name' => $line_group_name,
								'code' => $line_group_code,
								'lines_data' => array(),
								'discount' => 0,
								'subtotal' => 0,
								'act_exp_lines_data' => array(),
								'act_exp_subtotal' => 0,
						);
					}
	
					// build a key sort the rows by the first column (description, date, etc.)
					$first_col = $column_order[0];
					$first_col_val = strtolower($row[$first_col]);
					$row_sort_key = /*$first_col_val .'-'.*/ $lineGetId; // add the line id to the key to avoid overlapping of rows with the same key
					$line_groups[$line_group_id]['lines_data'][$row_sort_key] = $row;
					
					$line_groups[$line_group_id]['subtotal'] += $lineTotal;
					
				} else if (Plugins::instance()->isActivePlugin('expenses2') && $lineGetFormObjectType == PaymentReceipts::instance()->getObjectTypeId()) {//if line is expense (product/service) type
					if ($lineTotal < 0) {
						$discount += abs($lineTotal);
					if ($accumulate_discounts=='consolidated') {
	
						if (!isset($line_groups[$line_group_id])) {
							$line_groups[$line_group_id] = array(
									'name' => $line_group_name,
									'code' => $line_group_code,
									'lines_data' => array(),
									'discount' => 0,
									'subtotal' => 0,
									'act_exp_lines_data' => array(),
									'act_exp_subtotal' => 0,
							);
						}
						$line_groups[$line_group_id]['discount'] += abs($lineTotal);
						continue;
	
					} else if ($accumulate_discounts=='separated_section'){
	
						$line_group_id = 'discounts_table';
						if (!isset($line_groups[$line_group_id])) {
						
							$line_group_code = 'discounts_table';
	
							$line_groups[$line_group_id] = array(
									'name' => $line_group_name,
									'code' => $line_group_code,
									'lines_data' => array(),
									'discount' => 0,
									'subtotal' => 0,
									'act_exp_lines_data' => array(),
									'act_exp_subtotal' => 0,
							);
							}
							$row = array(
								'description' => nl2br($lineGetDetail),
								'total' => format_money_amount($lineTotal, $c_sym),
							);
	
							$line_groups[$line_group_id]['lines_data'][] = $row;
							continue;
	
						} 
					}
					$sub_group_id = 0;
					if ($this->getBreakDownExpensesByCategory()) {
						$sub_group_id = $lineCategoryId;
					}
					
					/* @var $line IncomeInvoiceLine */
					$c_sym = '$';
					$currency = Currencies::instance()->getCurrency($lineGetCurrencyId);
					if ($currency) $c_sym = $currency->getSymbol();
					$row = array();
	
					$line_has_markup = $lineGetUnitCost > 0 && $lineGetUnitCost != $lineGetUnitValue;
					
					foreach ($act_exp_column_order as $col) {
						$value = '';
						
						switch ($col) {
							case 'date':
								$value=$lineGetDate ? format_date($lineGetDate, null, 0):'';
								break;
							case 'user':
									$value = $initials_exp ? $line->getUserInitials() : $line->getUserName() ;
									break;
							case 'category'://outdated
								$cat_member = Members::getMemberById($lineCategoryId);
								if ($cat_member) $value = $cat_member->getName();
								break;
							case 'product type':
										$product_type_aux = ProductTypes::getById($line->getProductTypeId());
										$value = $product_type_aux instanceof ProductType ? $product_type_aux->getName() : '';
										break;
							case 'description':
								/*if ($include_exp_cat_in_description && $this->getExpGroupBy() != 'expense_category') {
									$cat_member = Members::getMemberById($line->getCategoryId());
									if ($cat_member) $value .= '<span class="cat-name">'. $cat_member->getName() . '</span><br />';
								}*/
								$value .= nl2br($lineGetDetail);
								break;
							case 'amount':
								$value=number_format($lineGetAnount, 2);
								if($lineItemTypeId>4)
								{
									$value = '';
								}
								
								break;
							case 'unit_value':
								
								if($lineItemTypeId>4)
								{
									$value = '';
								}else{
									if ($this->getShowExpensesMarkupSeparated() && $line_has_markup) {
										// if displaying markup in a separate line show the unit value without markup
										$value = format_money_amount($lineGetUnitCost, $c_sym);
									} else {
										$value = format_money_amount($lineGetUnitValue, $c_sym);
									}
								}


								break;
							case 'total':
								if($lineItemTypeId>4)
								{
									$value = '';
								}else{
									if ($this->getShowExpensesMarkupSeparated() && $line_has_markup) {
										// if displaying markup in a separate line show the total without markup
										$value = format_money_amount($lineGetUnitCost * $lineGetAnount, $c_sym);
									} else {
										$value = format_money_amount($lineTotal, $c_sym);
									}
								}
								break;
							case 'unit_cost':
								if ($lineGetPriceMultiplier > 1 ) {
									$value = format_money_amount($lineGetUnitCost, $c_sym);
								} else {
									$value = format_money_amount($lineGetUnitValue, $c_sym);
								}
								break;
							case 'fee':
								if ($lineGetPriceMultiplier > 0 ) {
									$value = (($lineGetPriceMultiplier - 1) * 100) . '%';
								} else {
									$value = '0%';
									//$multiplier = $line->getUnitValue() / $lineGetUnitCost;
									//$value = round((($multiplier - 1) * 100), 2) . '%';
								}
								break;
							/*case 'product_type'://outdated
								if($line->getItemTypeId()>4)
								{
									$value = nl2br($line->getDetail());
								}else{
									$pt = ProductTypes::getById($line->getProductTypeId());
									$value = $pt instanceof ProductType ? $pt->getName() : '';
								}
								break;*/
							/*case 'expense_name'://outdated
								$act_exp = PaymentReceipts::findById($line->getRelObjectId());
								if ($act_exp instanceof PaymentReceipt) {
									$value = $act_exp->getName();
								}
								if ($this->getIncludeProductType()) {
									$pt = ProductTypes::getById($line->getProductTypeId());
									$pt_name = $pt instanceof ProductType ? $pt->getName() : '';
									if ($pt_name != '') {
										$value = $pt_name . ($value == '' ? '' : ' - ') . $value;
									}
								}*/
								if ($value == "") {
									$value = nl2br($lineGetDetail);
								}
								break;
						}
						$row[$col] = $value;
					}
					
					
					if (!isset($line_groups[$line_group_id])) {
						$line_groups[$line_group_id] = array(
								'name' => $line_group_name,
								'code' => $line_group_code,
								'lines_data' => array(),
								'discount' => 0,
								'subtotal' => 0,
								'actual_expense_groups' => array(),
								'act_exp_subtotal' => 0,
						);
					}

					// build a key sort the rows by the first column (description, date, etc.)
					$first_col = $act_exp_column_order[0];
					$first_col_val = strtolower($row[$first_col]);
					$row_sort_key = /*$first_col_val .'-'.*/ $lineGetId; // add the line id to the key to avoid overlapping of rows with the same key
	
					if (!isset($line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id])) {
						$sub_group_name = '';
						if ($this->getBreakDownExpensesByCategory() && $sub_group_id > 0) {
							$cat = Members::getMemberById($sub_group_id);
							if ($cat instanceof Member) $sub_group_name = $cat->getName();
						}
	
						$line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id] = array(
							'name' => $sub_group_name,
							'data' => array(),
							'subtotal' => 0,
							'discount' => 0,
							'more_expense_table_rows' => array(),
						);
					}
	
					$line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id]['data'][$row_sort_key] = $row;
					$line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id]['subtotal'] += $lineTotal;
					$line_groups[$line_group_id]['act_exp_subtotal'] += $lineTotal;
	
					// accumulate this line's markup amounts, to be shown at the end of the expenses table
					if ($this->getShowExpensesMarkupSeparated() && $line_has_markup) {
	
						$markup = ($lineTotal * 100 / ($lineGetUnitCost * $lineGetAnount)) - 100;
						$markup = round($markup, 2);
						
						$amount_to_apply_markup = $lineGetUnitCost * $lineGetAnount;
						$markup_amount = $lineTotal - $amount_to_apply_markup;
	
						$mark_up_row_key = 'markup-row-' . $markup;
						if (!isset($line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id]['more_expense_table_rows'][$mark_up_row_key])) {
							
							$markup_label = $line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id]['name']  == '' ? 'Markup' : 'Markup on '.$line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id]['name'];
							
							$markup_text_key = 'description';
							if (!in_array('description', $act_exp_column_order)) {
								if (in_array('expense_name', $act_exp_column_order)) $markup_text_key = 'expense_name';
								else if (in_array('product_type', $act_exp_column_order)) $markup_text_key = 'product_type';
								else if (in_array('category', $act_exp_column_order)) $markup_text_key = 'category';
							}
	
							$line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id]['more_expense_table_rows'][$mark_up_row_key] = array(
								$markup_text_key => $markup_label,
								'amount' => $markup . '%',
								'unit_value' => 0,
								'total' => 0,
							);
						}
	
						$line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id]['more_expense_table_rows'][$mark_up_row_key]['total'] += $markup_amount;
						$line_groups[$line_group_id]['actual_expense_groups'][$sub_group_id]['more_expense_table_rows'][$mark_up_row_key]['unit_value'] += $amount_to_apply_markup;
					}
				}
			}
		}
    	
    	$currency_symbol = '$';
    	$currency = Currencies::instance()->getCurrency($invoice->getCurrencyId());
    	if ($currency) $currency_symbol = $currency->getSymbol();

    	$html = '';

    	tpl_assign('invoice', $invoice);
    	tpl_assign('invoice_template', $this);
    	tpl_assign('print_options', $print_options);
    	tpl_assign('currency_symbol', $currency_symbol);
    	tpl_assign('column_order', $column_order);
    	tpl_assign('columns', $columns);
    	tpl_assign('act_exp_column_order', $act_exp_column_order);
    	tpl_assign('act_exp_columns', $act_exp_columns);
    	
    	$line_count = 0;

		$line_groups=$this->orderMultiDimensionalArray ($line_groups, 'name', false);

    	foreach ($line_groups as $line_group_id => $line_group) {

			// sort each table's lines using their keys
			ksort($line_group['lines_data']);
			foreach ($line_groups[$line_group_id]['actual_expense_groups'] as $sub_group_id => $sub_group) {
				ksort($sub_group['data']);
			}
    		
    		$line_count++;
    		// only show invoice total after the last group
			$show_grand_total = count($line_groups) == $line_count;
    		tpl_assign('show_grand_total', $show_grand_total);
			if ($show_grand_total) {
				$taxes = $invoice->getTaxes();
				foreach ($taxes as $inv_tax) {
					$tax = IncomeTaxes::instance()->findById($inv_tax->getTaxId());
					$tax_name = $tax->getName();
					if ($inv_tax->getType() == 'percentage') {
						$tax_name .= " (".$inv_tax->getValue()."%)";
					}
					$taxes_data[] = array(
						'name' => $tax_name,
						'amount' => $inv_tax->getFixedValue(),
						'type' => $inv_tax->getType(),
						'value' => $inv_tax->getValue(),
					);
				}

				tpl_assign('taxes_data', $taxes_data);
			}

			$invoice_total_to_show = $lineShowTotal;//$invoice->getTotal();
			
			$discount_to_show = $line_group['discount'];
			
			if (array_var($print_options, 'ignore_discount') && $discount_to_show > 0) {
				$invoice_total_to_show += $discount_to_show;
				$discount_to_show = 0;
			}
    		tpl_assign('group_name', $line_group['name']);
    		tpl_assign('group_code', $line_group['code']);
    		
    		tpl_assign('lines_data', $line_group['lines_data']);
    		tpl_assign('discount', $discount_to_show);
    		tpl_assign('subtotal', $line_group['subtotal']);
			tpl_assign('invoice_total', $invoice_total_to_show);
    		
    		tpl_assign('actual_expense_groups', $line_group['actual_expense_groups']);
    		tpl_assign('act_exp_subtotal', $line_group['act_exp_subtotal']);
    		
    		$html .= tpl_fetch(get_template_path('invoice_lines_table','invoice_template','income'));
			
    	}
    	
    	return $html;
    }
}