<?php

/**
 * BaseIncomeInvoices class
 * Generado el 13/2/2012
 *
 */
abstract class BaseIncomeInvoices extends ContentDataObjects {

    /**
     * Column name => Column type map
     *
     * @var array
     * @static
     */
    static private $columns = array(
        'object_id' => DATA_TYPE_INTEGER,
        'invoice_notebook_id' => DATA_TYPE_INTEGER,
        'invoice_number' => DATA_TYPE_STRING,
        'series' => DATA_TYPE_STRING,
        'date' => DATA_TYPE_DATE,
        'expiration_date' => DATA_TYPE_DATE,
        'final_consumer' => DATA_TYPE_BOOLEAN,
    	'currency_id' => DATA_TYPE_INTEGER,
        'subtotal' => DATA_TYPE_FLOAT,
        'total' => DATA_TYPE_FLOAT,
        'customer_id' => DATA_TYPE_INTEGER,
        'customer_name' => DATA_TYPE_STRING,
        'customer_address' => DATA_TYPE_STRING,
        'customer_city' => DATA_TYPE_STRING,
        'customer_rut' => DATA_TYPE_STRING,
        'customer_number' => DATA_TYPE_STRING,
        'status' => DATA_TYPE_STRING,
    	'repeat_forever' => DATA_TYPE_BOOLEAN,
    	'repeat_end' => DATA_TYPE_DATE,
    	'repeat_num' => DATA_TYPE_INTEGER,
    	'repeat_d' => DATA_TYPE_INTEGER,
    	'repeat_m' => DATA_TYPE_INTEGER,
    	'repeat_y' => DATA_TYPE_INTEGER,
    	'repeat_h' => DATA_TYPE_INTEGER,
     	'repeat_dow' => DATA_TYPE_INTEGER,
    	'repeat_wnum' => DATA_TYPE_INTEGER,
    	'repeat_mjump' => DATA_TYPE_INTEGER,
    	'from_invoice_id' => DATA_TYPE_INTEGER,
    	'additional_information' => DATA_TYPE_STRING,
    	'invoice_preview_file_id' => DATA_TYPE_INTEGER,
    	'sent_invoice_mail_id' => DATA_TYPE_INTEGER,
    	'ordered_by_id' => DATA_TYPE_INTEGER,
        'customer_state' => DATA_TYPE_STRING,
        'customer_country' => DATA_TYPE_STRING,
        'customer_zipcode' => DATA_TYPE_STRING,
        'customer_email' => DATA_TYPE_STRING,
        'customer_phone' => DATA_TYPE_STRING,
        'sent' => DATA_TYPE_STRING,
        'attn' => DATA_TYPE_STRING,
    );

    /**
     * Construct
     *
     * @return BaseIncomeInvoices
     */
    function __construct() {
        Hook::fire('object_definition', 'IncomeInvoice', self::$columns);
        parent::__construct('IncomeInvoice', 'income_invoices', true);
    }

    // -------------------------------------------------------
    //  Description methods
    // -------------------------------------------------------

    /**
     * Return array of object columns
     *
     * @access public
     * @param void
     * @return array
     */
    function getColumns() {
        return array_keys(self::$columns);
    }

    /**
     * Return column type
     *
     * @access public
     * @param string $column_name
     * @return string
     */
    function getColumnType($column_name) {
    	return parent::getCOColumnType($column_name, self::$columns);
    }

    /**
     * Return array of PK columns. If only one column is PK returns its name as string
     *
     * @access public
     * @param void
     * @return array or string
     */
    function getPkColumns() {
        return 'object_id';
    }

    /**
     * Return name of first auto_incremenent column if it exists
     *
     * @access public
     * @param void
     * @return string
     */
    function getAutoIncrementColumn() {
        return 'object_id';
    }

    /**
     * Return system columns
     *
     * @access public
     * @param void
     * @return array
     */
    function getSystemColumns() {
        return array_merge(parent::getSystemColumns(), array(
                    'final_consumer','from_invoice_id','invoice_preview_file_id','sent_invoice_mail_id')
        );
    }

// getSystemColumns
    // -------------------------------------------------------
    //  Finders
    // -------------------------------------------------------

    /**
     * Do a SELECT query over database with specified arguments
     *
     * @access public
     * @param array $arguments Array of query arguments. Fields:
     *
     *  - one - select first row
     *  - conditions - additional conditions
     *  - order - order by string
     *  - offset - limit offset, valid only if limit is present
     *  - limit
     *
     * @return array objects
     * @throws DBQueryError
     */
    function find($arguments = null) {
        if (isset($this) && instance_of($this, 'IncomeInvoices')) {
            return parent::find($arguments);
        } else {
            return IncomeInvoices::instance()->find($arguments);
        } // if
    }

    /**
     * Find all records
     *
     * @access public
     * @param array $arguments
     * @return array objects
     */
    function findAll($arguments = null) {
        if (isset($this) && instance_of($this, 'IncomeInvoices')) {
            return parent::findAll($arguments);
        } else {
            return IncomeInvoices::instance()->findAll($arguments);
        } // if
    }

    /**
     * Find one specific record
     *
     * @access public
     * @param array $arguments
     * @return IncomeInvoice
     */
    function findOne($arguments = null) {
        if (isset($this) && instance_of($this, 'IncomeInvoices')) {
            return parent::findOne($arguments);
        } else {
            return IncomeInvoices::instance()->findOne($arguments);
        } // if
    }

    /**
     * Return object by its PK value
     *
     * @access public
     * @param mixed $id
     * @param boolean $force_reload If true cache will be skipped and data will be loaded from database
     * @return IncomeInvoice
     */
    function findById($id, $force_reload = false) {
        if (isset($this) && instance_of($this, 'IncomeInvoices')) {
            return parent::findById($id, $force_reload);
        } else {
            return IncomeInvoices::instance()->findById($id, $force_reload);
        } // if
    }

    /**
     * Return number of rows in this table
     *
     * @access public
     * @param string $conditions Query conditions
     * @return integer
     */
    function count($condition = null) {
        if (isset($this) && instance_of($this, 'IncomeInvoices')) {
            return parent::count($condition);
        } else {
            return IncomeInvoices::instance()->count($condition);
        } // if
    }

    /**
     * Delete rows that match specific conditions. If $conditions is NULL all rows from table will be deleted
     *
     * @access public
     * @param string $conditions Query conditions
     * @return boolean
     */
    function delete($condition = null) {
        if (isset($this) && instance_of($this, 'IncomeInvoices')) {
            return parent::delete($condition);
        } else {
            return IncomeInvoices::instance()->delete($condition);
        } // if
    }

    /**
     * This function will return paginated result. Result is an array where first element is
     * array of returned object and second populated pagination object that can be used for
     * obtaining and rendering pagination data using various helpers.
     *
     * Items and pagination array vars are indexed with 0 for items and 1 for pagination
     * because you can't use associative indexing with list() construct
     *
     * @access public
     * @param array $arguments Query argumens (@see find()) Limit and offset are ignored!
     * @param integer $items_per_page Number of items per page
     * @param integer $current_page Current page number
     * @return array
     */
    function paginate($arguments = null, $items_per_page = 10, $current_page = 1, $count = null) {
        if (isset($this) && instance_of($this, 'IncomeInvoices')) {
            return parent::paginate($arguments, $items_per_page, $current_page);
        } else {
            return IncomeInvoices::instance()->paginate($arguments, $items_per_page, $current_page);
        } // if
    }

    /**
     * Return manager instance
     *
     * @return IncomeInvoices
     */
    function instance() {
        static $instance;
        if (!instance_of($instance, 'IncomeInvoices')) {
            $instance = new IncomeInvoices();
        }
        return $instance;
    }

}

?>
