<?php
set_page_title(lang('invoice copies'));
$genid = gen_id();
?>

<div id="<?php echo $genid ?>Copies" class="adminMailAccounts" style="height: 100%; background-color: white">
    <div class="coInputHeader">
        <div class="coInputTitle"><?php echo lang('invoice copies') ?></div>
    </div>
    <div class="adminMainBlock">
        <?php if(isset($copies) && is_array($copies) && count($copies)) { ?>
        <table class="adminListing" style="min-width: 400px; margin-top: 10px;">
                <tr>
                    <th><?php echo lang('name') ?></th>
                    <th><?php echo lang('description') ?></th>
                    <th><?php echo lang('color') ?></th>
                    <th><?php echo lang('options') ?></th>
                </tr>
                <?php
                $isAlt = true;
                foreach($copies as $copy) {
                        $isAlt = !$isAlt;
                ?>
                <tr class="<?php echo $isAlt? 'altRow' : ''?>" id="<?php echo $genid ?>tr_<?php echo $copy->getId()?>">
                    <td><?php echo $copy->getName() ?></td>
                    <td><?php echo $copy->getDescription() ?></td>
                    <td><?php echo $copy->getColor() ?></td>
                    <?php
                    $options = array();
                    $options[] = '<a class="internalLink" href="#" onclick="og.render_modal_form(\'\',{c:\'copy\', a:\'edit\', params:{id:'.$copy->getId().'}});">' . lang('edit') . '</a>';
                    $options[] = '<a class="internalLink" href="javascript:og.DeleteCopy(' . $copy->getId() . ')">' . lang('delete') . '</a>';
                    ?>
                    <td><?php echo implode(' | ', $options) ?></td>
                </tr>
                <?php } // foreach ?>
        </table>
        <?php } else { ?><div><?php echo lang('no copies') ?></div><?php } // if ?>
        
        </br><a href="#" onclick="og.render_modal_form('',{c:'copy', a:'add'});" class="link-ico ico-add"><?php echo lang('add copy')?></a>
    </div>
</div>

<script>
	var div = document.getElementById('<?php echo $genid ?>Copies');
	div.parentNode.style.backgroundColor = '#FFFFFF';
	og.DeleteCopy = function(copyId) {
		if (confirm(lang('delete copy'))) {
			og.openLink(og.getUrl('copy', 'delete', {cop_id : copyId}), {
	            callback: function(success, data) {
	            	$('#<?php echo $genid ?>tr_'+copyId).remove();
	        	}
	        });
			
		}
	};
</script>
