<?php 
$genid = gen_id();

$expense_cat_dim = Dimensions::findByCode('expense_categories');
if (Plugins::instance()->isActivePlugin('expenses2')) {
	$filtered_product_types_lump_sum = null;
	$exp_cat_ls = Members::findById(array_var($invoice_template_edit, 'category_for_lump_sum'));
	if ($exp_cat_ls instanceof Member) {
		$filtered_product_types_lump_sum = ProductTypes::getFilteredProductTypesData(array($exp_cat_ls));
	}
	$exp_cat_exp = Members::findById(array_var($invoice_template_edit, 'category_for_expenses'));
	if ($exp_cat_exp instanceof Member) {
		$filtered_product_types_expenses = ProductTypes::getFilteredProductTypesData(array($exp_cat_exp));
	}
}

$labor_cat_dim = Dimensions::findByCode('hour_types');
if (Plugins::instance()->isActivePlugin('expenses2')) {
	$filtered_product_types_timeslot = null;
	$exp_cat_ls = Members::findById(array_var($invoice_template_edit, 'category_for_timeslot'));
	if ($exp_cat_ls instanceof Member) {
		$filtered_product_types_timeslot = ProductTypes::getFilteredProductTypesData(array($exp_cat_ls));
	}
}

$form_url = get_url('invoice_template', 'add');
if (!$invoice_template->isNew()) {
	$form_url = get_url('invoice_template', 'edit', array('id' => $invoice_template->getId()));
}

$on_submit = "og.submit_modal_form('".$genid."submit-edit-form'); return false;";
?>
<style>
.invoice-template .coInputMainBlock label {
    float: left;
    min-width: 300px;
	max-width: 300px;
	clear: both;
}
.invoice-template input.title {
    width: 450px;
}
</style>

<form id="<?php echo $genid ?>submit-edit-form" class="internalForm" action="<?php echo $form_url ?>" method="post" onsubmit="<?php echo $on_submit ?>">
<div class="invoice-template">
	<div class="coInputHeader">
	
	  <div class="coInputHeaderUpperRow">
		<div class="coInputTitle">
			<?php echo $invoice_template->isNew() ? lang('add invoice template') : lang('edit invoice template') ?>
		</div>
	  </div>
	
	  <div>
		<div class="coInputButtons" style="float:right;">
			<?php echo submit_button(array_var($invoice_template_edit, 'id') ? lang('save changes') : lang('add invoice template')); ?>
		</div>
		<div class="clear"></div>
	  </div>
	</div>
	
	<div class="coInputMainBlock">
	
		<div class="property-group">
           
            <div class="dataBlock">
            <?php
            	echo label_tag(lang('template name'), $genid . 'name');
            	echo text_field('invoice_template[name]', array_var($invoice_template_edit, 'name'), array('class' => 'title'));
            ?>
            </div>

            <div class="dataBlock">
            <?php
            	echo label_tag(lang('is this the default template'), $genid . 'is_default');
            	echo checkbox_field('invoice_template[is_default]', array_var($invoice_template_edit, 'is_default'));
            ?>
            </div>

            <div class="dataBlock">
            <?php
            	echo label_tag(lang('type'), $genid . 'template_type');
            	$type_options = array('detailed', 'lumpsum', 'lumpsum_view');
            	$type_options_html = array();
            	foreach ($type_options as $type_option) {
            		$attr = $type_option == array_var($invoice_template_edit, 'template_type') ? array('selected' => 'selected') : null;
            		$type_options_html[] = option_tag(lang($type_option), $type_option, $attr);
            	}
            	echo select_box("invoice_template[template_type]", $type_options_html, array("id" => $genid."template_type"));
            ?>
            </div>
			
			

			<?php if (income_config_option("use_line_taxes")) { ?>
            <div class="dataBlock">
            <?php
            	echo label_tag(lang('show taxes in invoice lines'), $genid . 'show_taxes_for_each_line');
            	echo checkbox_field('invoice_template[show_taxes_for_each_line]', array_var($invoice_template_edit, 'show_taxes_for_each_line'));
            ?>
            </div>
            <?php } ?>
			<div class="dataBlock">
            <?php
				echo label_tag(lang('break_down_by_subprojects'), $genid . 'break_down_by_subprojects');
            	$type_options = array('no', 'SINGLE', 'MULTI');
            	$type_options_html = array();
            	foreach ($type_options as $type_option) {
            		$attr = $type_option == array_var($invoice_template_edit, 'break_down_by_subprojects') ? array('selected' => 'selected') : null;
            		$type_options_html[] = option_tag(lang($type_option), $type_option, $attr);
            	}
            	echo select_box("invoice_template[break_down_by_subprojects]", $type_options_html, array("id" => $genid."break_down_by_subprojects"));
            ?>
            </div>
			
            <!-- <div class="dataBlock">
            <?php
            	// echo label_tag(lang('break_down_by_subprojects'), $genid . 'break_down_by_subprojects');
            	// echo checkbox_field('invoice_template[break_down_by_subprojects]', array_var($invoice_template_edit, 'break_down_by_subprojects'));
            ?>
            </div> -->
            
            <div class="dataBlock" id="<?php echo $genid . 'show_headers_before_details'?>">
            <?php
            	echo label_tag(lang('show headers before labor and expenses details'), $genid . 'show_headers_before_details');
            	echo checkbox_field('invoice_template[show_headers_before_details]', array_var($invoice_template_edit, 'show_headers_before_details'));
            ?>
            </div>
            
            <div class="dataBlock">
            <?php
			$select_discounts_options=[];
			$select_discounts_options[] = ['between_line_items',lang('in between line items')];
			$select_discounts_options[] = ['separated_section',lang('in a separate section')];
			$select_discounts_options[] = ['consolidated',lang('consolidated as a single line')];
            	echo label_tag(lang('accumulate discounts'), $genid . 'accumulate_discounts');
				echo simple_select_box("invoice_template[accumulate_discounts]", $select_discounts_options , array_var($invoice_template_edit, 'accumulate_discounts'));
            ?>
            </div>
			<!-- :: INVOICE TEMPLATES SELECTOR :: (START)-->
			<div class="dataBlock">
				<?php

				/*
				* => Check directory name in customer installation to locate your invoice template
				*/
					$root_exploded = @explode(DIRECTORY_SEPARATOR, ROOT);
					$current_folder_name = end($root_exploded);
					$template_file = "invoice_print_custom_template.php";
					$base_folder = "/plugins/income/invoice_print_templates/" . $current_folder_name;

				/*
				* => Validating active template in invoice template configuration
				*/
					//$activeTemplate = ($current_folder_name == $invoice_template->getInvoiceTemplateColumnAssigned()) ?: false;
					$selected = $invoice_template->getInvoiceTemplateColumnAssigned();

				/*
				* => Render of the label and selector of invoice templates
				*/
					echo label_tag(lang('invoice template'), $genid . 'invoice_template_assigned');
					$display_options_html = array(
						//=> ORIGINAL TEMPLATE ::
						option_tag(lang('original'), 'original', $selected == 'original' ? array('selected' => 'selected') : null),
					);

					if (is_dir(ROOT . $base_folder) && file_exists(ROOT . $base_folder . "/$template_file")) {
						//=> CLIENT INSTALLATION TEMPLATE ::
						$display_options_html[] = option_tag(lang($current_folder_name), $current_folder_name, $selected == $current_folder_name ? array('selected' => 'selected') : null);
					}
					
					echo select_box("invoice_template[invoice_template_assigned]", $display_options_html, array_var($invoice_template_edit, 'invoice_template_assigned'));
				?>
			</div>
			<!-- :: INVOICE TEMPLATES SELECTOR :: (END)-->
        </div>
            
		<div class="property-group" id="<?php echo $genid?>lump_sum_properties">
			<div class="property-group-header"><?php echo lang('columns to display') ?></div>

			<!--<div class="dataBlock" >
			<strong><?php echo  lang("select the objects that will be used to crate invoice detail")?></strong>
			</div>-->
			
			<div class="dataBlock" >
					<?php
						echo label_tag(lang('date'), $genid . 'include_lump_sum_date_col');
						echo checkbox_field('invoice_template[include_lump_sum_date_col]', array_var($invoice_template_edit, 'include_lump_sum_date_col'), array("id" => $genid . "include_lump_sum_date_col"));
					?>
			</div>
			<div class="dataBlock" >
					<?php
						echo label_tag(lang('category'), $genid . 'category_for_lump_sum_col');
						echo checkbox_field('invoice_template[category_for_lump_sum_col]', array_var($invoice_template_edit, 'category_for_lump_sum_col'), array("id" => $genid . "include_lump_sum_date_col"));
					?>
			</div>
			<div class="dataBlock" >
					<?php
						echo label_tag(lang('product type'), $genid . 'product_type_for_lump_sum_col');
						echo checkbox_field('invoice_template[product_type_for_lump_sum_col]', array_var($invoice_template_edit, 'product_type_for_lump_sum_col'), array("id" => $genid . "product_type_for_lump_sum_col"));
					?>
			</div>

			

			<div class="dataBlock">
				<?php
					echo label_tag(lang('detail'), $genid . 'include_lump_sum_deetail_col');
					echo checkbox_field('invoice_template[include_lump_sum_deetail_col]', array_var($invoice_template_edit, 'include_lump_sum_deetail_col'), array("id" => $genid . "include_lump_sum_deetail_col"));
				?>
				</div>	

			<!-- include_lump_sum_quantity -->
            <div class="dataBlock" >
				<?php
					echo label_tag(lang('quantity'), $genid . 'include_lump_sum_quantity');
					echo checkbox_field('invoice_template[include_lump_sum_quantity]', array_var($invoice_template_edit, 'include_lump_sum_quantity'), array("id" => $genid."include_lump_sum_quantity"));
					//echo lang('if selected, it will shown as 1');
				?>
			</div>

			<!-- include_lump_sum_unit_price -->
			<div class="dataBlock" >
					<?php
						echo label_tag(lang('unit price'), $genid . 'include_lump_sum_unit_price');
						echo checkbox_field('invoice_template[include_lump_sum_unit_price]', array_var($invoice_template_edit, 'include_lump_sum_unit_price'), array("id" => $genid . "include_lump_sum_unit_price"));
					?>
			</div>

			<div class="property-group-header"><?php echo lang('automatic generation of invoice lines') ?></div>
			
			<!-- include_lump_sum_date -->
			<div class="dataBlock">
				<?php
				
					$include_lump_sum_date_options = array('Invoice date', 'Date of the earliest item', 'Date of the most recent item', 'Billing from date', 'Billing to date');
					$include_lump_sum_date_html = array();
					
					foreach ($include_lump_sum_date_options as $include_lump_sum_date_option) {
						$attr = $include_lump_sum_date_option == array_var($invoice_template_edit, 'include_lump_sum_date') ? array('selected' => 'selected') : null;
						$include_lump_sum_date_html[] = option_tag($include_lump_sum_date_option, $include_lump_sum_date_option, $attr);
					}
					echo label_tag(lang('date'), $genid . 'include_lump_sum_date');
					echo select_box("invoice_template[include_lump_sum_date]", $include_lump_sum_date_html, array("id" => $genid."include_lump_sum_date"));
					
				?>
			</div>

			<!---category and product type for lump sum-->
			<?php if (Plugins::instance()->isActivePlugin('expenses2')) { ?>
			
				<div class="dataBlock" style="display:none;" id="<?php echo $genid . 'category_for_lump_sum_block'?>">
					<?php echo label_tag(lang('category'), $genid . 'category_for_lump_sum');?>
					<div id="<?php echo $genid; ?>category_for_lump_sum_container"></div>
				</div>

			<div class="datablock">
				<?php echo label_tag(lang('product type'), $genid . 'product_type_for_lump_sum');?>
				<div id="<?php echo $genid; ?>product_type_for_lump_sum_container">
						<?php
							Env::useHelper('functions', 'expenses2');
							echo product_types_select_box(
								"invoice_template[product_type_for_lump_sum]", 
								array_var($invoice_template_edit, 'product_type_for_lump_sum'), 
								$filtered_product_types_lump_sum, 
								array('id' => $genid . 'product_type_for_lump_sum', 'style'=>'max-width:300px;')
							);
						?>
				</div>
			</div>
			<?php } ?>

			<!-- Detail -->
			<div class="dataBlock"><strong>
				<?php
					echo label_tag(lang('detail'), $genid . 'include_detail');
					//echo checkbox_field('invoice_template[include_detail]', array_var($invoice_template_edit, 'include_detail'), array("id" => $genid . "include_detail"));
				?>
				</strong>
            </div>			
			
			<!-- include_lump_sum_project_number -->
            <div class="dataBlock" style="margin-left: 50px;">
				<?php
					echo label_tag(lang('project number'), $genid . 'include_lump_sum_project_number');
					echo checkbox_field('invoice_template[include_lump_sum_project_number]', array_var($invoice_template_edit, 'include_lump_sum_project_number'), array("id" => $genid . "include_lump_sum_project_number"));
				?>
			</div>

			<!-- include_lump_sum_project_name -->
            <div class="dataBlock" style="margin-left: 50px;">
				<?php
					echo label_tag(lang('project name'), $genid . 'include_lump_sum_project_name');
					echo checkbox_field('invoice_template[include_lump_sum_project_name]', array_var($invoice_template_edit, 'include_lump_sum_project_name'), array("id" => $genid . "include_lump_sum_project_name"));
				?>
			</div>

			<!-- include_lump_sum_project_type -->
            <div class="dataBlock" style="margin-left: 50px;">
				<?php
					echo label_tag(lang('project type'), $genid . 'include_lump_sum_project_type');
					echo checkbox_field('invoice_template[include_lump_sum_project_type]', array_var($invoice_template_edit, 'include_lump_sum_project_type'), array("id" => $genid . "include_lump_sum_project_type"));
				?>
			</div>


			<!-- include_lump_sum_budget_completion -->
			<div class="dataBlock" style="margin-left: 50px;">
				<?php
					echo label_tag(lang('% completion'), $genid . 'include_lump_sum_budget_completion');
					echo checkbox_field('invoice_template[include_lump_sum_budget_completion]', array_var($invoice_template_edit, 'include_lump_sum_budget_completion'), array("id" => $genid . "include_lump_sum_budget_completion"));
				?>
			</div>
			<!-- include_lump_sum_from_to -->
            <div class="dataBlock" style="margin-left: 50px;">
				<?php
					echo label_tag(lang('from - to'), $genid . 'include_lump_sum_from_to');
					echo checkbox_field('invoice_template[include_lump_sum_from_to]', array_var($invoice_template_edit, 'include_lump_sum_from_to'), array("id" => $genid . "include_lump_sum_from_to"));
				?>
			</div>
		</div>

        <div class="property-group" id="<?php echo $genid?>time_properties">
        	<div class="property-group-header"><?php echo lang('labor (time) lines') ?></div>

			<div class="dataBlock" >
				<strong><?php echo lang('when automatically generating the invoice lines for labor (using time entries), use the following criteria') ?></strong>
			</div>

            <div class="dataBlock">
            <?php
                $group_by_options = array('timeslots', 'tasks', 'users', 'date-users', 'project');
                $group_by_options_html = array();
                $labor_category_dimension = Dimensions::findByCode('hour_types');
                $labor_cat_dim_enabled = $labor_category_dimension instanceof Dimension && in_array($labor_category_dimension->getId(), config_option('enabled_dimensions'));
                if ($labor_cat_dim_enabled){
					$group_by_options[] = 'date_users_labor_category';
                    $group_by_options[] = 'labor_category';
                    $group_by_options[] = 'project_labor_category';
                }
				$group_by_options[] = 'project';

                foreach($group_by_options as $opt){
                    $attr = $opt == array_var($invoice_template_edit, 'group_by') ? array('selected' => 'selected') : null;
                    if ($labor_cat_dim_enabled && $opt == 'labor_category'){
                        $group_by_options_html[] = option_tag($labor_category_dimension->getName(), $opt, $attr);
                    } else {
                        $group_by_options_html[] = option_tag(lang($opt), $opt, $attr);
                    }
                }
                $html = select_box("invoice_template[group_by]", $group_by_options_html, array("id" => "group_by"));
            	echo label_tag(lang('group by'), $genid . 'group_by');
            	echo select_box("invoice_template[group_by]", $group_by_options_html, array("id" => $genid."group_by"));
            ?>
            </div>
			
			<!-- <div class="dataBlock" >
				<div class="property-group-header"><?php echo lang('automatic generation of invoice lines') ?></div>
			</div> -->
			<!-- include_time_line_date -->
			<div class="dataBlock" >
				<?php
					$include_time_line_date_options = array('Item date', 'Invoice date', 'Date of the earliest item', 'Date of the most recent item', 'Billing from date', 'Billing to date');
					$include_time_line_date_html = array();
					foreach ($include_time_line_date_options as $include_time_line_date_option) {
						$attr = $include_time_line_date_option == array_var($invoice_template_edit, 'include_time_line_date') ? array('selected' => 'selected') : null;
						$include_time_line_date_html[] = option_tag($include_time_line_date_option, $include_time_line_date_option, $attr);
					}
					echo label_tag(lang('assign date based on'), $genid . 'include_time_line_date');
					echo select_box("invoice_template[include_time_line_date]", $include_time_line_date_html, array("id" => $genid."include_time_line_date"));
				?>
			</div>

			<!---category and product type for timeslot-->
			<?php if (Plugins::instance()->isActivePlugin('expenses2')) { ?>
			
			<div class="dataBlock" style="display:;" id="<?php echo $genid . 'category_for_timeslot_block'?>">
				<?php echo label_tag(lang('labor category'), $genid . 'category_for_timeslot');?>
				<div id="<?php echo $genid; ?>category_for_timeslot_container"></div>
			</div>

			<!-- <div class="datablock">
				<?php //echo label_tag(lang('product type'), $genid . 'product_type_for_timeslot');?>
				<div id="<?php //echo $genid; ?>product_type_for_timeslot_container">
						<?php
							// Env::useHelper('functions', 'expenses2');
							// echo product_types_select_box(
							// 	"invoice_template['product_type_for_timeslot']", 
							// 	array_var($invoice_template_edit, 'product_type_for_timeslot'), 
							// 	$filtered_product_types_timeslot, 
							// 	array('id' => $genid . 'product_type_for_timeslot', 'style'=>'max-width:300px;')
							// );
						?>
				</div>
			</div> -->
			<?php } ?>

			<!-- Detail -->
			<div class="dataBlock" >
					<?php
						echo lang('detail');
					?>
			</div>
			
			
			<div class="dataBlock" style="margin-left: 50px;">
				<!-- Person name -->
				<div class="dataBlock">
				<?php
					$user_name_options = array('No name', 'Full name', 'Initials');
					$user_name_options_html = array();
					
					foreach ($user_name_options as $user_name_option) {
						$attr = $user_name_option == array_var($invoice_template_edit, 'include_user_name') ? array('selected' => 'selected') : null;
						$user_name_options_html[] = option_tag($user_name_option, $user_name_option, $attr);
					}
					echo label_tag(lang('include person name'), $genid . 'include_user_name');
					echo select_box("invoice_template[include_user_name]", $user_name_options_html, array("id" => $genid."include_user_name"));							
				?>
				</div>
				<!-- Labor categories -->
				<div class="dataBlock">
				<?php
						echo label_tag(lang('include labor category'), $genid . 'include_labor_category');
						echo checkbox_field('invoice_template[include_labor_category]', array_var($invoice_template_edit, 'include_labor_category'), array("id" => $genid . "include_labor_category"));
				?>
				</div>
			
				<!-- Task name -->
				<div class="dataBlock">
				<?php
					echo label_tag(lang('include task name'), $genid . 'include_task_name');
					echo checkbox_field('invoice_template[include_task_name]', array_var($invoice_template_edit, 'include_task_name'), array("id" => $genid . "include_task_name"));
				?>
				</div>
				<!-- time entry CREAR UNO NUEVO time_entry -->
				<div class="dataBlock">
				<?php
					echo label_tag(lang('include time entry description'), $genid . 'include_time_entry_description');
					echo checkbox_field('invoice_template[include_time_entry_description]', array_var($invoice_template_edit, 'include_time_entry_description'), array("id" => $genid . "include_time_entry_description"));
				?>
				</div>
				<!-- include_project_description -->
				<!--<div class="dataBlock">
				<?php
					//echo label_tag(lang('custom project number'), $genid . 'include_project_description');
					//echo checkbox_field('invoice_template[include_project_description]', array_var($invoice_template_edit, 'include_project_description'), array("id" => $genid . "include_project_description"));
				?>
				</div>-->
				<!-- include_project_name -->
				
				<div class="dataBlock" >
				<?php
					echo label_tag(lang('include project name'), $genid . 'include_project_name');
					echo checkbox_field('invoice_template[include_project_name]', array_var($invoice_template_edit, 'include_project_name'), array("id" => $genid . "include_project_name"));
				?>
				</div>
			</div>
            
			<div class="dataBlock">
				<strong>
						<div class="property-group-header"><?php echo lang('columns to display') ?></div>
				</strong>
			</div> 
			<div class="dataBlock">
				<?php
					echo label_tag(lang('date'), $genid . 'include_date');
					echo checkbox_field('invoice_template[include_date]', array_var($invoice_template_edit, 'include_date'), array("id" => $genid . "include_date"));
				?>
			</div>
			<!-- Person name -->
			<div class="dataBlock">
				<?php
					$user_name_options_time_cols = array('Do not Display', 'Full name', 'Initials');
					$user_name_options_html_time_cols = array();
					
					foreach ($user_name_options_time_cols as $user_name_option_time_col) {
						$attr = $user_name_option_time_col == array_var($invoice_template_edit, 'include_user_name_col') ? array('selected' => 'selected') : null;
						$user_name_options_html_time_cols[] = option_tag($user_name_option_time_col, $user_name_option_time_col, $attr);
					}
					echo label_tag(lang('person name'), $genid . 'include_user_name_col');
					echo select_box("invoice_template[include_user_name_col]", $user_name_options_html_time_cols, array("id" => $genid."include_user_name_col"));							
				?>
			</div>
			<!--category-->
			<div class="dataBlock" >
					<?php
						echo label_tag(lang('labor category'), $genid . 'category_for_timeslot_col');
						echo checkbox_field('invoice_template[category_for_timeslot_col]', array_var($invoice_template_edit, 'category_for_timeslot_col'), array("id" => $genid . "include_lump_sum_date_col"));
					?>
			</div>
			<!-- product type for timeslot-->
			<!-- <div class="dataBlock" >
					<?php
						// echo label_tag(lang('product type'), $genid . 'product_type_for_timeslot_col');
						// echo checkbox_field('invoice_template[product_type_for_timeslot_col]', array_var($invoice_template_edit, 'product_type_for_timeslot_col'), array("id" => $genid . "product_type_for_lump_sum_col"));
					?>
			</div> -->
			<!--detail-->
			<div class="dataBlock">
				<?php
					echo label_tag(lang('detail'), $genid . 'include_description');
					echo checkbox_field('invoice_template[include_description]', array_var($invoice_template_edit, 'include_description'), array("id" => $genid . "include_description"));
				?>
				</div>	
			<!-- Hour  -->
			<div class="dataBlock" >
					<?php 
					echo label_tag(lang('hours'), $genid . 'include_hours');
					echo checkbox_field('invoice_template[include_hours]', array_var($invoice_template_edit, 'include_hours'), array("id" => $genid . "include_hours"));
					?>
			</div>
			<!-- Rate  -->
			<div class="dataBlock" >
					<?php 
					echo label_tag(lang('rate'), $genid . 'include_rate');
					echo checkbox_field('invoice_template[include_rate]', array_var($invoice_template_edit, 'include_rate'), array("id" => $genid . "include_rate"));
					?>
			</div>
			<!-- total  -->
			<div class="dataBlock" >
					<?php 
					echo label_tag(lang('total'), $genid . 'include_total');
					echo checkbox_field('invoice_template[include_total]', array_var($invoice_template_edit, 'include_total'), array("id" => $genid . "include_total"));
					?>
			</div>
           
        </div>
        
        <div class="property-group" id="<?php echo $genid?>expense_properties">
        	<div class="property-group-header"><?php echo lang('expenses, products and other services') ?></div>
			<div class="dataBlock" >
				<strong><?php echo lang('when automatically generating the invoice lines for expenses, products and other services (not from time entries), use the following criteria') ?></strong>
			</div>

        	
        	<div class="dataBlock">
            <?php
                $group_by_options = array('payment_receipts', 'expense_name', 'expense_description', 'product_type', 'paid_by', 'project','project_product');
                $group_by_options_html = array();
                $expense_category_dimension = Dimensions::findByCode('expense_categories');
                $exp_cat_dim_enabled = $expense_category_dimension instanceof Dimension && in_array($expense_category_dimension->getId(), config_option('enabled_dimensions'));
                if ($exp_cat_dim_enabled){
                    $group_by_options[] = 'expense_category';
                    $group_by_options[] = 'project_expense_category';
                }
                foreach($group_by_options as $opt){
                    $attr = $opt == array_var($invoice_template_edit, 'exp_group_by') ? array('selected' => 'selected') : null;
                    if ($exp_cat_dim_enabled && $opt == 'expense_category'){
                    	$group_by_options_html[] = option_tag($expense_category_dimension->getName(), $opt, $attr);
                    } else {
                        $group_by_options_html[] = option_tag(lang($opt), $opt, $attr);
                    }
                }
                //$html = select_box("invoice_template[group_by]", $group_by_options_html, array("id" => "group_by"));
            	echo label_tag(lang('group by'), $genid . 'exp_group_by');
            	echo select_box("invoice_template[exp_group_by]", $group_by_options_html, array("id" => $genid."exp_group_by"));
            ?>
            </div>

			<?php if ($exp_cat_dim_enabled) { ?>
			<div class="dataBlock">
            <?php
            	echo label_tag(lang('break_down_expenses_by_category'), $genid . 'break_down_expenses_by_category');
            	echo checkbox_field('invoice_template[break_down_expenses_by_category]', array_var($invoice_template_edit, 'break_down_expenses_by_category'), array("id" => $genid."break_down_expenses_by_category"));
            ?>
            </div>
			<?php } ?>

			<div class="dataBlock">
            <?php
            	echo label_tag(lang('show_expenses_markup_separated'), $genid . 'show_expenses_markup_separated');
            	echo checkbox_field('invoice_template[show_expenses_markup_separated]', array_var($invoice_template_edit, 'show_expenses_markup_separated'), array("id" => $genid."show_expenses_markup_separated"));
            ?>
            </div>
			<!-- unit value -->
			<div class="dataBlock">
				<?php
					echo label_tag(lang('at invoice line unit value display'), $genid . 'display_cost_or_price');
					$display_options_html = array(
						option_tag(lang('none'), 'none', 'none' == array_var($invoice_template_edit, 'display_cost_or_price') ? array('selected' => 'selected') : null),	
						option_tag(lang('price'), 'price', 'price' == array_var($invoice_template_edit, 'display_cost_or_price') ? array('selected' => 'selected') : null),
						option_tag(lang('unit cost and management fee'), 'cost_and_fee', 'cost_and_fee' == array_var($invoice_template_edit, 'display_cost_or_price') ? array('selected' => 'selected') : null),
					);
					echo select_box("invoice_template[display_cost_or_price]", $display_options_html, array("id" => $genid."display_cost_or_price"));
				?>
            </div>

			<!-- <div class="dataBlock" >
				<div class="property-group-header"><?php //echo lang('automatic generation of invoice lines') ?></div>
			</div> -->

			<div class="dataBlock" >
				<?php
				
					$include_exp_type_date_options = array('Item date', 'Invoice date', 'Date of the earliest item', 'Date of the most recent item', 'Billing from date', 'Billing to date');
					$include_exp_type_date_html = array();
					
					foreach ($include_exp_type_date_options as $include_exp_type_date_option) {
						$attr = $include_exp_type_date_option == array_var($invoice_template_edit, 'include_exp_type_date') ? array('selected' => 'selected') : null;
						$include_exp_type_date_html[] = option_tag($include_exp_type_date_option, $include_exp_type_date_option, $attr);
					}
					echo label_tag(lang('assign date based on'), $genid . 'include_exp_type_date');
					echo select_box("invoice_template[include_exp_type_date]", $include_exp_type_date_html, array("id" => $genid."include_exp_type_date"));
					
				?>
			</div>

			<!---category and product type for expenses-->
			<?php if (Plugins::instance()->isActivePlugin('expenses2')) { ?>
			
			<div class="dataBlock" style="display:;" id="<?php echo $genid . 'category_for_expenses_block'?>">
				<?php echo label_tag(lang('expense category'), $genid . 'category_for_expenses');?>
				<div id="<?php echo $genid; ?>category_for_expenses_container"></div>
			</div>

			<div class="datablock">
				<?php echo label_tag(lang('product type'), $genid . 'product_type_for_expenses');?>
				<div id="<?php echo $genid; ?>product_type_for_expenses_container">
						<?php
							Env::useHelper('functions', 'expenses2');
							echo product_types_select_box(
								"invoice_template[product_type_for_expenses]", 
								array_var($invoice_template_edit, 'product_type_for_expenses'), 
								$filtered_product_types_expenses, 
								array('id' => $genid . 'product_type_for_expenses', 'style'=>'max-width:300px;')
							);
						?>
				</div>
			</div>
			<?php } ?>

			<!-- detail -->
			<div class="dataBlock" >
					<?php
						echo label_tag(lang('detail'), $genid . 'include_detail');
					?>
			</div>
			
			<!-- paid by -->
			<div class="dataBlock" style="margin-left: 50px;">
				<?php
					echo label_tag(lang('include paid by'), $genid . 'include_paid_by');
					echo checkbox_field('invoice_template[include_paid_by]', array_var($invoice_template_edit, 'include_paid_by'), array("id" => $genid."include_paid_by"));
				?>
			</div>
			<!-- expense category -->
			<div class="dataBlock" style="margin-left: 50px;">
				<?php
					echo label_tag(lang('include expense category'), $genid . 'include_expense_category');
					echo checkbox_field('invoice_template[include_expense_category]', array_var($invoice_template_edit, 'include_expense_category'), array("id" => $genid."include_expense_category"));
				?>
			</div>
			<!-- product type -->
			<div class="dataBlock" style="margin-left: 50px;">
				<?php
					echo label_tag(lang('include product type'), $genid . 'include_product_type');
					echo checkbox_field('invoice_template[include_product_type]', array_var($invoice_template_edit, 'include_product_type'), array("id" => $genid."include_product_type"));
				?>
			</div>
		
			<!-- include_expense_name-->
			<div class="dataBlock"  style="margin-left: 50px;">
				<?php
					 echo label_tag(lang('include expense name'), $genid . 'include_expense_name');
					 echo checkbox_field('invoice_template[include_expense_name]', array_var($invoice_template_edit, 'include_expense_name'), array("id" => $genid."include_expense_name"));
				?>
            </div> 

			<!-- include_expense_description-->
			<div class="dataBlock" id="<?php echo $genid . 'include_expense_description_container'?>"  style="margin-left: 50px;">
				<?php
					echo label_tag(lang('include expense description'), $genid . 'include_expense_description');
					echo checkbox_field('invoice_template[include_expense_description]', array_var($invoice_template_edit, 'include_expense_description'), array("id" => $genid."include_expense_description"));
				?>
            </div>

			<!-- include_lump_sum_project_number -->
            <div class="dataBlock" style="margin-left: 50px;">
				<?php
					echo label_tag(lang('project number'), $genid . 'include_expense_project_number');
					echo checkbox_field('invoice_template[include_expense_project_number]', array_var($invoice_template_edit, 'include_expense_project_number'), array("id" => $genid . "include_expense_project_number"));
				?>
			</div>

			<!-- include_lump_sum_project_name -->
            <div class="dataBlock" style="margin-left: 50px;">
				<?php
					echo label_tag(lang('project name'), $genid . 'include_expense_project_name');
					echo checkbox_field('invoice_template[include_expense_project_name]', array_var($invoice_template_edit, 'include_expense_project_name'), array("id" => $genid . "include_expense_project_name"));
				?>
			</div>
			<div class="dataBlock">
				<strong>
						<div class="property-group-header"><?php echo lang('columns to display') ?></div>
				</strong>
			</div> 
			<!-- include_exp_date -->
			<div class="dataBlock">
            <?php
            	echo label_tag(lang('date'), $genid . 'include_exp_date');
				echo checkbox_field('invoice_template[include_exp_date]', array_var($invoice_template_edit, 'include_exp_date'), array("id" => $genid."include_exp_date"));
            ?>
            </div>

			<!-- paid by -->
			<div class="dataBlock">
				<?php
					echo label_tag(lang('paid by'), $genid . 'include_paid_by_col');
					echo checkbox_field('invoice_template[include_paid_by_col]', array_var($invoice_template_edit, 'include_paid_by_col'), array("id" => $genid."include_paid_by_col"));
				?>
			</div>
			<!-- Person name -->
			<div class="dataBlock">
				<?php
					$user_name_options_time_cols = array('Do not Display', 'Full name', 'Initials');
					$user_name_options_html_time_cols = array();
					
					foreach ($user_name_options_time_cols as $user_name_option_time_col) {
						$attr = $user_name_option_time_col == array_var($invoice_template_edit, 'include_exp_user_name_col') ? array('selected' => 'selected') : null;
						$user_name_options_html_time_cols[] = option_tag($user_name_option_time_col, $user_name_option_time_col, $attr);
					}
					echo label_tag(lang('person name'), $genid . 'include_exp_user_name_col');
					echo select_box("invoice_template[include_exp_user_name_col]", $user_name_options_html_time_cols, array("id" => $genid."include_exp_user_name_col"));							
				?>
			</div>
			<!--category-->
			<div class="dataBlock" >
					<?php
						echo label_tag(lang('expense category'), $genid . 'category_for_expenses_col');
						echo checkbox_field('invoice_template[category_for_expenses_col]', array_var($invoice_template_edit, 'category_for_expenses_col'), array("id" => $genid . "category_for_expenses_col"));
					?>
			</div>
			<!-- product type-->
			<div class="dataBlock" >
					<?php
						echo label_tag(lang('product type'), $genid . 'product_type_for_expenses_col');
						echo checkbox_field('invoice_template[product_type_for_expenses_col]', array_var($invoice_template_edit, 'product_type_for_expenses_col'), array("id" => $genid . "product_type_for_expenses_col"));
					?>
			</div>
			<!-- detail -->
			<div class="dataBlock" >
					<?php
						echo label_tag(lang('detail'), $genid . 'include_exp_description');
						echo checkbox_field('invoice_template[include_exp_description]', array_var($invoice_template_edit, 'include_exp_description'), array("id" => $genid."include_exp_description"));
					?>
			</div>
			
			<!-- include_exp_quantity -->
			<div class="dataBlock" >
					<?php
						echo label_tag(lang('quantity'), $genid . 'include_exp_quantity');
						echo checkbox_field('invoice_template[include_exp_quantity]', array_var($invoice_template_edit, 'include_exp_quantity'), array("id" => $genid."include_exp_quantity"));
					?>
			</div>

			<!-- include_exp_amount -->
            <div class="dataBlock" >
            <?php
            	echo label_tag(lang('unit value'), $genid . 'include_exp_amount');
				echo checkbox_field('invoice_template[include_exp_amount]', array_var($invoice_template_edit, 'include_exp_amount'), array("id" => $genid."include_exp_amount"));
            ?>
            </div>
			
			<!-- include_exp_fee -->
            <div class="dataBlock" >
				<?php
					echo label_tag(lang('fee'), $genid . 'include_exp_fee');
					echo checkbox_field('invoice_template[include_exp_fee]', array_var($invoice_template_edit, 'include_exp_fee'), array("id" => $genid."include_exp_fee"));
				?>
            </div>
			
			<!-- include_exp_total -->
            <div class="dataBlock" >
            <?php
            	echo label_tag(lang('total'), $genid . 'include_exp_total');
				echo checkbox_field('invoice_template[include_exp_total]', array_var($invoice_template_edit, 'include_exp_total'), array("id" => $genid."include_exp_fee"));
            ?>
            </div>
		</div>

		<div class="property-group" id="<?php echo $genid?>invoice_template_footer">
        	<div class="property-group-header"><?php echo lang('invoice_template_footer_title') ?></div>
        	
        	
           
            <div class="dataBlock">
            <?php
            	echo label_tag(lang('invoice_template_footer_account_summary'), $genid . 'include_account_summary');
            	echo checkbox_field('invoice_template[include_account_summary]', array_var($invoice_template_edit, 'include_account_summary'), array("id" => $genid."include_account_summary"));
            ?>
            </div>

			<div class="dataBlock">

			<?php
            	echo label_tag(lang('invoice_template_footer_text'), $genid . 'invoice_footer_disclaimer');
            	echo text_field('invoice_template[invoice_footer_disclaimer]', array_var($invoice_template_edit, 'footer_text'), array("id" => "invoice_footer_disclaimer",'class' => 'title', 'style' => 'display:none'));
            ?>
			</div>
            <div class="dataBlock">
		
	        <div>
	            <div id="<?php echo $genid ?>ckcontainer" style="height: 160px">
	                <textarea cols="80" id="<?php echo $genid ?>ckeditor" name="invoice_template['invoice_footer_disclaimer']" rows="10"><?php echo $invoice_template->getIncludeFooterText(); ?></textarea>
	            </div>
	        </div>


           
            </div>
        </div>
        
    </div>
</div>
</form>



	        
<script>
	var h = document.getElementById("<?php echo $genid ?>ckcontainer").offsetHeight;
	var editor = CKEDITOR.replace('<?php echo $genid ?>ckeditor', {		
		height: '120px',
		allowedContent: true,
		resize_enabled: false,
		enterMode: CKEDITOR.ENTER_BR,
		shiftEnterMode: CKEDITOR.ENTER_BR,
		disableNativeSpellChecker: false,
		language: '<?php echo $loc ?>',
		customConfig: '',
		contentsCss: ['<?php echo get_javascript_url('ckeditor/contents.css').'?rev='.product_version_revision();?>', '<?php echo get_stylesheet_url('og/ckeditor_override.css').'?rev='.product_version_revision();?>'],
		toolbar: [
					['Bold','Italic','Underline','Strike','-',
						'Font','FontSize','-', 'Blockquote','-',
						'SpellChecker', 'Scayt','-', 
						'NumberedList','BulletedList','-',
						'TextColor','BGColor','RemoveFormat','-',
						'Link','Unlink','-',
						'JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock']
				],
		on: {
				instanceReady: function(ev) {
						og.adjustCkEditorArea('<?php echo $genid ?>');
						editor.resetDirty();						
				}
			},
		fillEmptyBlocks: false,
		removePlugins: 'scayt,liststyle,magicline,contextmenu,tabletools,elementspath',
		entities_additional : '#336,#337,#368,#369,#124'
	});

	
	var el = document.getElementById("invoice_footer_disclaimer");

	editor.on("change", function() {
		el.value = editor.getData();
	})
	

	og.setDescription = function() {
			var form = Ext.getDom('<?php echo $genid ?>submit-edit-form');
			
	

			if (form.preventDoubleSubmit) return false;

			setTimeout(function() {
					form.preventDoubleSubmit = false;
			}, 2000);

			var editor = og.getCkEditorInstance('<?php echo $genid ?>ckeditor');
			form['invoice_template[invoice_footer_disclaimer]'].value = editor.getData();

			return true;
	};    
</script>

<script>

var genid = '<?php echo $genid ?>';

<?php if (Plugins::instance()->isActivePlugin('expenses2') && $expense_cat_dim instanceof Dimension) { ?>
og.render_plain_member_selector({
	dim_id: <?php echo $expense_cat_dim->getId() ?>,
	hf_name: 'invoice_template[category_for_lump_sum]',
	container: genid+ 'category_for_lump_sum_container',
	genid: genid,
	sel_id: <?php echo array_var($invoice_template_edit, 'category_for_lump_sum', '0') ?>,
});

$("#" + genid + 'member_selector_' + '<?php echo $expense_cat_dim->getId() ?>').change(function() {
	var members = Ext.util.JSON.encode([$(this).val()]);
	og.openLink(og.getUrl('product_type', 'get_filtered_product_types', {member_ids: members}), {
		callback: function(success, data) {
			if (!data || !data.product_types) return;

			$("#" + genid + "product_type_for_lump_sum").each(function(index, obj) {
				var selected_value = $(obj).val();

				// remove old options
				$(obj).find("option").remove();

				// add new options
				$(obj).append($('<option>', {value: 0, text : ""}));
				$.each(data.product_types, function (i, item) {
					$(obj).append($('<option>', { 
						value: item.id,
						text : item.name.replaceAll('\\"', '"')
					}));
				});

				$(obj).val(selected_value);
			});
		}
	});
});
<?php } ?>

<?php if (Plugins::instance()->isActivePlugin('expenses2') && $labor_cat_dim instanceof Dimension) { ?>
og.render_plain_member_selector({
	dim_id: <?php echo $labor_cat_dim->getId() ?>,
	hf_name: 'invoice_template[category_for_timeslot]',
	container: genid+ 'category_for_timeslot_container',
	genid: genid,
	sel_id: <?php echo array_var($invoice_template_edit, 'category_for_timeslot', '0') ?>,
});

// $("#" + genid + 'member_selector_' + '<?php echo $labor_cat_dim->getId() ?>').change(function() {
// 	var members = Ext.util.JSON.encode([$(this).val()]);
// 	og.openLink(og.getUrl('product_type', 'get_filtered_product_types', {member_ids: members}), {
// 		callback: function(success, data) {
// 			if (!data || !data.product_types) return;

// 			$("#" + genid + "product_type_for_timeslot").each(function(index, obj) {
// 				var selected_value = $(obj).val();

// 				// remove old options
// 				$(obj).find("option").remove();

// 				// add new options
// 				$(obj).append($('<option>', {value: 0, text : ""}));
// 				$.each(data.product_types, function (i, item) {
// 					$(obj).append($('<option>', { 
// 						value: item.id,
// 						text : item.name.replaceAll('\\"', '"')
// 					}));
// 				});

// 				$(obj).val(selected_value);
// 			});
// 		}
// 	});
// });
<?php } ?>

<?php if (Plugins::instance()->isActivePlugin('expenses2') && $expense_cat_dim instanceof Dimension) { ?>
og.render_plain_member_selector({
	dim_id: <?php echo $expense_cat_dim->getId() ?>,
	hf_name: 'invoice_template[category_for_expenses]',
	container: genid+ 'category_for_expenses_container',
	genid: genid,
	sel_id: <?php echo array_var($invoice_template_edit, 'category_for_expenses', '0') ?>,
});

	$('select[name="invoice_template[category_for_expenses]"]').change(function() {
	var members = Ext.util.JSON.encode([$(this).val()]);
	og.openLink(og.getUrl('product_type', 'get_filtered_product_types', {member_ids: members}), {
		callback: function(success, data) {
			if (!data || !data.product_types) return;

			$("#" + genid + "product_type_for_expenses").each(function(index, obj) {
				var selected_value = $(obj).val();

				// remove old options
				$(obj).find("option").remove();

				// add new options
				$(obj).append($('<option>', {value: 0, text : ""}));
				$.each(data.product_types, function (i, item) {
					$(obj).append($('<option>', { 
						value: item.id,
						text : item.name.replaceAll('\\"', '"')
					}));
				});

				$(obj).val(selected_value);
			});
		}
	});
});

// $("#" + genid + 'product_type_for_expenses').change(function() {
// 	alert($(this).val());        
// 	$("#" + genid + "product_type_for_expenses option[value="+$(this).val()+"]").attr('selected', 'selected');
// });

<?php } ?>

og.invoice_templates_on_template_type_change = function(genid) {

	if ($('#'+genid+'template_type').val() == 'lumpsum'){
		$('#'+genid+'lump_sum_properties').show();
		$('#'+genid+'time_properties').hide();
		$('#'+genid+'expense_properties').hide();
		$('#'+genid+'category_for_lump_sum_block').show();
	} else {
		$('#'+genid+'time_properties').show();
		$('#'+genid+'expense_properties').show();
		$('#'+genid+'category_for_lump_sum_block').hide();
		$('#'+genid+'lump_sum_properties').hide();

	}

	if ($('#'+genid+'template_type').val() == 'detailed'){
		$('#'+genid+'show_headers_before_details').show();
//		$('#'+genid+'lump_sum_properties').hide();
	} else {
		$('#'+genid+'show_headers_before_details').hide();
	}
}

og.invoice_templates_on_time_group_by_change = function(genid) {

	if($('#'+genid+'group_by').val() == 'timeslots'){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	} else if ($('#'+genid+'group_by').val() == 'tasks'){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	} else if ($('#'+genid+'group_by').val() == 'users'){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	} else if ($('#'+genid+'group_by').val() == 'date-users'){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	} else if ($('#'+genid+'group_by').val() == 'date_users_labor_category'){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	} else if ($('#'+genid+'group_by').val() == 'labor_category'){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	}  else if ($('#'+genid+'group_by').val() == 'project' ){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	} else if ( $('#'+genid+'group_by').val() == 'project_labor_category'){
		$('#'+genid+'include_date').attr("disabled", false);
	    $('#'+genid+'include_user_name').attr("disabled", false);
	    $('#'+genid+'include_labor_category').attr("disabled", false);
		$('#'+genid+'include_task_name').attr("disabled", false);
		$('#'+genid+'include_time_entry_description').attr("disabled", false);
		$('#'+genid+'include_project_name').attr("disabled", false);
		$('#'+genid+'include_hours').attr("disabled", false);
		$('#'+genid+'include_rate').attr("disabled", false);
		$('#'+genid+'include_total').attr("disabled", false);
	}
}


og.invoice_templates_on_expense_group_by_change = function(genid) {
	if($('#'+genid+'exp_group_by').val() == 'payment_receipts'){//actual expenses
		$('#'+genid+'include_exp_date').attr("disabled", false);
		$('#'+genid+'include_paid_by').attr("disabled", false);
	    $('#'+genid+'include_product_type').attr("disabled", false);
	    $('#'+genid+'include_expense_category').attr("disabled", false);
	    $('#'+genid+'include_expense_name').attr("disabled", false);
	    $('#'+genid+'include_expense_description').attr("disabled", false);
		$('#'+genid+'include_expense_project_number').attr("disabled", false);
		//$('#'+genid+'include_expense_project_number').prop('checked', false);
		$('#'+genid+'include_expense_project_name').attr("disabled", false);
		//$('#'+genid+'include_expense_project_name').prop('checked', false);
		$('#'+genid+'include_exp_quantity').attr("disabled", false);
		$('#'+genid+'include_exp_amount').attr("disabled", false);
		$('#'+genid+'include_exp_fee').attr("disabled", false);
		$('#'+genid+'include_exp_total').attr("disabled", false);
		$('#'+genid+'include_detail').prop('checked', true);

	} else if ($('#'+genid+'exp_group_by').val() == 'expense_name'){
		$('#'+genid+'include_exp_date').attr("disabled", false);
		$('#'+genid+'include_paid_by').attr("disabled", false);
	    $('#'+genid+'include_product_type').attr("disabled", false);
	    $('#'+genid+'include_expense_category').attr("disabled", false);
	    $('#'+genid+'include_expense_name').attr("disabled", false);
	    $('#'+genid+'include_expense_description').attr("disabled", false);
		$('#'+genid+'include_expense_project_number').attr("disabled", false);
		//$('#'+genid+'include_expense_project_number').prop('checked', false);
		$('#'+genid+'include_expense_project_name').attr("disabled", false);
		//$('#'+genid+'include_expense_project_name').prop('checked', false);
		$('#'+genid+'include_exp_quantity').attr("disabled", false);
		$('#'+genid+'include_exp_amount').attr("disabled", false);
		$('#'+genid+'include_exp_fee').attr("disabled", false);
		$('#'+genid+'include_exp_total').attr("disabled", false);
		$('#'+genid+'include_detail').prop('checked', true);

	} else if ($('#'+genid+'exp_group_by').val() == 'expense_description'){
		$('#'+genid+'include_exp_date').attr("disabled", false);
		$('#'+genid+'include_paid_by').attr("disabled", false);
	    $('#'+genid+'include_product_type').attr("disabled", false);
	    $('#'+genid+'include_expense_category').attr("disabled", false);
	    $('#'+genid+'include_expense_name').attr("disabled", false);
	    $('#'+genid+'include_expense_description').attr("disabled", false);
		$('#'+genid+'include_expense_project_number').attr("disabled", false);
		//$('#'+genid+'include_expense_project_number').prop('checked', false);
		$('#'+genid+'include_expense_project_name').attr("disabled", false);
		//$('#'+genid+'include_expense_project_name').prop('checked', false);
		$('#'+genid+'include_exp_quantity').attr("disabled", false);
		$('#'+genid+'include_exp_amount').attr("disabled", false);
		$('#'+genid+'include_exp_fee').attr("disabled", false);
		$('#'+genid+'include_exp_total').attr("disabled", false);
		$('#'+genid+'include_detail').prop('checked', true);
		
	} else if ($('#'+genid+'exp_group_by').val() == 'product_type'){
		$('#'+genid+'include_exp_date').attr("disabled", false);
		$('#'+genid+'include_paid_by').attr("disabled", false);
	    $('#'+genid+'include_product_type').attr("disabled", false);
	    $('#'+genid+'include_expense_category').attr("disabled", false);
	    $('#'+genid+'include_expense_name').attr("disabled", false);
	    $('#'+genid+'include_expense_description').attr("disabled", false);
		$('#'+genid+'include_expense_project_number').attr("disabled", false);
		//$('#'+genid+'include_expense_project_number').prop('checked', false);
		$('#'+genid+'include_expense_project_name').attr("disabled", false);
		//$('#'+genid+'include_expense_project_name').prop('checked', false);
		$('#'+genid+'include_exp_quantity').attr("disabled", false);
		$('#'+genid+'include_exp_amount').attr("disabled", false);
		$('#'+genid+'include_exp_fee').attr("disabled", false);
		$('#'+genid+'include_exp_total').attr("disabled", false);
		$('#'+genid+'include_detail').prop('checked', true);

	} else if ($('#'+genid+'exp_group_by').val() == 'paid_by'){
		$('#'+genid+'include_exp_date').attr("disabled", false);
		$('#'+genid+'include_paid_by').attr("disabled", false);
	    $('#'+genid+'include_product_type').attr("disabled", false);
	    $('#'+genid+'include_expense_category').attr("disabled", false);
	    $('#'+genid+'include_expense_name').attr("disabled", false);
	    $('#'+genid+'include_expense_description').attr("disabled", false);
		$('#'+genid+'include_expense_project_number').attr("disabled", false);
		//$('#'+genid+'include_expense_project_number').prop('checked', false);
		$('#'+genid+'include_expense_project_name').attr("disabled", false);
		//$('#'+genid+'include_expense_project_name').prop('checked', false);
		$('#'+genid+'include_exp_quantity').attr("disabled", false);
		$('#'+genid+'include_exp_amount').attr("disabled", false);
		$('#'+genid+'include_exp_fee').attr("disabled", false);
		$('#'+genid+'include_exp_total').attr("disabled", false);
		$('#'+genid+'include_detail').prop('checked', true);

	} else if ($('#'+genid+'exp_group_by').val() == 'expense_category'){
		$('#'+genid+'include_exp_date').attr("disabled", false);
		$('#'+genid+'include_paid_by').attr("disabled", false);
	    $('#'+genid+'include_product_type').attr("disabled", false);
	    $('#'+genid+'include_expense_category').attr("disabled", false);
	    $('#'+genid+'include_expense_name').attr("disabled", false);
	    $('#'+genid+'include_expense_description').attr("disabled", false);
		$('#'+genid+'include_expense_project_number').attr("disabled", false);
		//$('#'+genid+'include_expense_project_number').prop('checked', false);
		$('#'+genid+'include_expense_project_name').attr("disabled", false);
		//$('#'+genid+'include_expense_project_name').prop('checked', false);
		$('#'+genid+'include_exp_quantity').attr("disabled", false);
		$('#'+genid+'include_exp_amount').attr("disabled", false);
		$('#'+genid+'include_exp_fee').attr("disabled", false);
		$('#'+genid+'include_exp_total').attr("disabled", false);
		$('#'+genid+'include_detail').prop('checked', true);

	} else if ($('#'+genid+'exp_group_by').val() == 'project' ){
		$('#'+genid+'include_exp_date').attr("disabled", false);
		$('#'+genid+'include_paid_by').attr("disabled", false);
	    $('#'+genid+'include_product_type').attr("disabled", false);
	    $('#'+genid+'include_expense_category').attr("disabled", false);
	    $('#'+genid+'include_expense_name').attr("disabled", false);
	    $('#'+genid+'include_expense_description').attr("disabled", false);
		$('#'+genid+'include_expense_project_number').attr("disabled", false);
		//$('#'+genid+'include_expense_project_number').prop('checked', false);
		$('#'+genid+'include_expense_project_name').attr("disabled", false);
		//$('#'+genid+'include_expense_project_name').prop('checked', false);
		$('#'+genid+'include_exp_quantity').attr("disabled", false);
		$('#'+genid+'include_exp_amount').attr("disabled", false);
		$('#'+genid+'include_exp_fee').attr("disabled", false);
		$('#'+genid+'include_exp_total').attr("disabled", false);
		$('#'+genid+'include_detail').prop('checked', true);
		
	}else if( $('#'+genid+'exp_group_by').val() == 'project_expense_category'){
		$('#'+genid+'include_exp_date').attr("disabled", false);
		$('#'+genid+'include_paid_by').attr("disabled", false);
	    $('#'+genid+'include_product_type').attr("disabled", false);
	    $('#'+genid+'include_expense_category').attr("disabled", false);
	    $('#'+genid+'include_expense_name').attr("disabled", false);
	    $('#'+genid+'include_expense_description').attr("disabled", false);
		$('#'+genid+'include_expense_project_number').attr("disabled", false);
		//$('#'+genid+'include_expense_project_number').prop('checked', false);
		$('#'+genid+'include_expense_project_name').attr("disabled", false);
		//$('#'+genid+'include_expense_project_name').prop('checked', false);
		$('#'+genid+'include_exp_quantity').attr("disabled", false);
		$('#'+genid+'include_exp_amount').attr("disabled", false);
		$('#'+genid+'include_exp_fee').attr("disabled", false);
		$('#'+genid+'include_exp_total').attr("disabled", false);
		$('#'+genid+'include_detail').prop('checked', true);
	}
}

og.invoice_templates_on_template_type_change(genid);
og.invoice_templates_on_time_group_by_change(genid);
og.invoice_templates_on_expense_group_by_change(genid);

$('#'+genid+'template_type').on('change', function(){
	var genid = '<?php echo $genid ?>';
	og.invoice_templates_on_template_type_change(genid);
});

$('#'+genid+'group_by').on('change', function(){
	var genid = '<?php echo $genid ?>';
	og.invoice_templates_on_time_group_by_change(genid);
});

// $('#'+genid+'include_detail').on('click', function(){
// 	$('#'+genid+'include_detail').prop('checked', true);
// });
// $('#'+genid+'include_description').on('click', function(){
// 	$('#'+genid+'include_description').prop('checked', true);
// });

// });

$('#'+genid+'exp_group_by').on('change', function(){
	var genid = '<?php echo $genid ?>';
	og.invoice_templates_on_expense_group_by_change(genid);
});

</script>
