<?php
$print_labels = array_var($print_options, 'labels', array());
if ($group_code == 'discounts_table') {
	$columns = array('description' => 'Discounts', 'total' => 'Amount');
	$column_order = array('description', 'total');
}

if (count($taxes_data) > 0) {
	$sumTaxes = 0;
	foreach ($taxes_data as $tax_data) {
		$sumTaxes += $tax_data['amount'];
	}
}

foreach ($column_order as $key => $value) {
	if (str_starts_with($value, "tax_")) {
		moveElement($column_order, 0, count($column_order) - 1);
	}
}

moveElement($column_order, array_keys($column_order, "total")[0], count($column_order) - 1);
?>
<?php if ($group_name != '') { ?>
	<div class="items-group-name"><?php echo $group_name ?></div>
<?php } ?>

<?php if (count($lines_data) > 0) { ?>
	<table id="items">
		<?php if ($invoice_template->getShowHeadersBeforeDetails() && !in_array($invoice_template->getTemplateType(), array('lumpsum', 'lumpsum_view'))) { ?>
			<thead class="main-header object-type-header ">
				<tr>
					<th colspan="<?php echo count($column_order) ?>"><?php echo array_var($print_labels, 'labor', 'Labor') ?></th>
				</tr>
			</thead>
		<?php } ?>
		<thead class="hide_extra_columns">
			<tr>
				<?php
				foreach ($column_order as $col) {
					if ($col == '') continue;
					$cls = '';
					if (in_array($col, array('amount', 'unit_value', 'total', 'subtotal'))) $cls = 'right ';
					else if (in_array($col, array('description', 'user', 'category'))) $cls = 'left';
					else if (in_array($col, array('date'))) $cls = 'center';
					else $cls = 'right';
				?>

					<th class="<?php echo $cls ?>"><?php echo $columns[$col] ?></th>
				<?php } ?>
			</tr>
		</thead>
		<tbody>
			<?php
			foreach ($lines_data as $line_data) :
			?>
				<tr class="item-row">
					<?php
					//moveElement($column_order, 1, 5);
					foreach ($column_order as $k => $col) {

						// don't render empty column
						if ($col == '') continue;

						// select cell class
						$cls = '';
						switch ($col) {
							case 'amount':
								$cls = 'right TotalWidht';
								break;
							case 'date':
								$cls = 'center dateWidht';
								break;
							case 'description':
								$cls = 'description';
								break;
							case 'unit_value':
							case 'total':
							case 'subtotal':
								$cls = 'right TotalWidht';
								break;
							case 'user':
								$cls = 'user';
								break;
							case 'category':
								break;
							default:
								if (str_starts_with($col, "tax_")) {
									$cls = 'right short';
								}
								break;
						}

						// if next columns are empty, expand current column for better use of space
						/*$colspan = 1;
						$j = 1;
						while (($k + $j) < count($column_order) && $column_order[$k + $j] == '') {
							$colspan++;
							$j++;
						}*/
					?>
						<td class="<?php echo $cls ?>"><?php echo $line_data[$col] ?></td>
						<!--colspan="<?php echo $colspan22 ?>"-->
					<?php } ?>
				</tr>
			<?php endforeach; ?>
			<?php if ($group_code != 'discounts_table' && $subtotal != 0) { ?>
				<tr>
					<table style="width: 100%;">
						<tbody>
							<tr>
								<td class="totalLine" style="padding: 5px;">
									<div style="display: flex; width: 100%; justify-content: flex-end;">
										<span colspan="1" class="global-subtotal-line" style="margin-right: 30px;">
											<?=
											array_var(
												$print_labels,
												'subtotal_labor',
												(in_array($invoice_template->getTemplateType(), array('lumpsum', 'lumpsum_view'))) ? 'Subtotal' : 'Labor subtotal'
											);
											?>:
										</span>
										<span colspan="1" class="global-subtotal-value">
											<?=
											format_money_amount(
												(in_array($invoice_template->getTemplateType(), array('lumpsum', 'lumpsum_view'))) ? $subtotal - $sumTaxes : $subtotal,
												$currency_symbol
											);
											?>
										</span>
									</div>
								</td>
							</tr>
						</tbody>
					</table>
					<!-- <td class="total-line subtotal" colspan="<?php echo (count($column_order)); ?>">
						<?=
						array_var(
							$print_labels,
							'subtotal_labor',
							(in_array($invoice_template->getTemplateType(), array('lumpsum', 'lumpsum_view'))) ? 'Subtotal' : 'Labor subtotal'
						);
						?>:
					</td>
					<td class="total-value subtotal short">
						<div id="subtotal">
							<?=
							format_money_amount(
								(in_array($invoice_template->getTemplateType(), array('lumpsum', 'lumpsum_view'))) ? $subtotal - $sumTaxes : $subtotal,
								$currency_symbol
							);
							?>
						</div>
					</td> -->
				</tr>
		</tbody>
	<?php } ?>
	</table>
<?php } ?>

<?php
$subgroup_count = 0;
foreach ($actual_expense_groups as $actual_expense_group) {
	$subgroup_count++;

	$act_exp_lines_data = $actual_expense_group['data'];

	if ($invoice_template->getShowExpensesMarkupSeparated() && count($actual_expense_group['more_expense_table_rows']) > 0) {

		// format the markup line amounts
		foreach ($actual_expense_group['more_expense_table_rows'] as $row_key => &$row_val) {
			$row_val['total'] = format_money_amount($row_val['total'], $currency_symbol);
			$row_val['unit_value'] = format_money_amount($row_val['unit_value'], $currency_symbol);
		}

		// append the markup lines
		$act_exp_lines_data = array_merge($actual_expense_group['data'], $actual_expense_group['more_expense_table_rows']);
	}

	if (count($act_exp_lines_data) > 0) { ?>

		<table id="items">

			<?php if ($invoice_template->getShowHeadersBeforeDetails() && $subgroup_count == 1) { ?>
				<thead class="main-header object-type-header">
					<tr>
						<th colspan="<?php echo count($act_exp_column_order) ?>"><?php echo array_var($print_labels, 'expenses', 'Expenses') ?></th>
					</tr>
				</thead>
			<?php } ?>

			<?php if ($actual_expense_group['name'] != '') { ?>
				<thead class="main-header group-name-header">
					<tr>
						<th colspan="<?php echo count($act_exp_column_order) ?>"><?php echo $actual_expense_group['name'] ?></th>
					</tr>
				</thead>
			<?php } ?>

			<thead>
				<tr>
					<?php foreach ($act_exp_column_order as $col) {
						if ($col == '') continue;
						$cls = '';
						if (in_array($col, array('amount', 'unit_value', 'total', 'unit_cost'))) $cls = 'right';
						else if (in_array($col, array('description', 'user', 'category', 'product_type', 'expense_name'))) $cls = 'left';
						else if (in_array($col, array('date'))) $cls = 'center';
						else $cls = 'center';
					?>
						<th class="<?php echo $cls ?>"><?php echo $act_exp_columns[$col] ?></th>
					<?php } ?>
				</tr>
			</thead>

			<tbody>
				<?php foreach ($act_exp_lines_data as $line_data) : ?>
					<tr class="item-row">
						<?php foreach ($act_exp_column_order as $k => $col) {
							// don't render empty column
							if ($col == '') continue;

							// select cell class
							$cls = '';
							switch ($col) {
								case 'fee':
								case 'amount':
									$cls = 'right TotalWidht';
									break;
								case 'date':
									$cls = 'center dateWidht';
									break;
								case 'description':
									$cls = 'description';
									break;
								case 'unit_value':
									$cls = 'right TotalWidht';
								case 'unit_cost':
									$cls = 'right TotalWidht';
								case 'total':
									$cls = 'right TotalWidht';
									break;
								case 'user':
									$cls = 'user';
									break;
								case 'category':
									break;
							}

							// if next columns are empty, expand current column for better use of space
							$colspan = 1;
							$j = 1;
							while (($k + $j) < count($act_exp_column_order) && $act_exp_column_order[$k + $j] == '') {
								$colspan++;
								$j++;
							}
						?>
							<td class="<?php echo $cls ?>"><?php echo $line_data[$col] ?></td>
							<!--colspan="<?php echo $colspan ?>"-->
						<?php } ?>
					</tr>
				<?php endforeach; ?>

				<?php
				// if there are more than 1 expense subgroups then put the subtotal for each one
				if (count($actual_expense_groups) > 1) { ?>
					<!-- <tr>
				<td class="total-line subtotal" colspan="<?php echo (count($act_exp_column_order) - 1); ?>"><?php echo $actual_expense_group['name'] . ' ' . lang('subtotal') ?>: </td>
				<td class="total-value subtotal short">
					<div id="subtotal"><?php echo format_money_amount($actual_expense_group['subtotal'], $currency_symbol); ?></div>
				</td>
			</tr> -->
					<tr>
						<table style="width: 100%;">
							<tbody>
								<tr>
									<td class="totalLine" style="padding: 5px;">
										<div style="display: flex; width: 100%; justify-content: flex-end;">
											<span class="global-subtotal-line" colspan="1" style="margin-right: 30px;">
												<?php echo $actual_expense_group['name'] . ' ' . lang('subtotal') ?>:
											</span>
											<span class="global-subtotal-value" colspan="1">
												<?php echo format_money_amount($actual_expense_group['subtotal'], $currency_symbol); ?>
											</span>
										</div>
									</td>
								</tr>
							</tbody>
						</table>
					</tr>
				<?php } ?>

				<?php
				// general expense subtotal, only print it after the last group
				if ($subgroup_count == count($actual_expense_groups)) { ?>
					<!-- <tr>
				<td class="total-line subtotal" colspan="<?php echo (count($act_exp_column_order) - 1); ?>"><?php echo array_var($print_labels, 'subtotal_expenses', 'Expenses subtotal') ?>: </td>
				<td class="total-value subtotal short">
					<div id="subtotal"><?php echo format_money_amount($act_exp_subtotal, $currency_symbol); ?></div>
				</td>
			</tr> -->
					<tr>
						<table style="width: 100%;">
							<tbody>
								<tr>
									<td class="totalLine" style="padding: 5px;">
										<div style="display: flex; width: 100%; justify-content: flex-end;">
											<span class="global-subtotal-line" colspan="1" style="margin-right: 30px;">
												<?php echo array_var($print_labels, 'subtotal_expenses', 'Expenses subtotal ') ?>:
											</span>
											<span class="global-subtotal-value" colspan="1">
												<?php echo format_money_amount($act_exp_subtotal, $currency_symbol); ?>
											</span>
										</div>
									</td>
								</tr>
							</tbody>
						</table>
					</tr>
				<?php } ?>

			</tbody>
	<?php
	}
}
	?>

	<tbody class="total-tbody">

		<?php if ($group_code != '' && $group_code != 'discounts_table') { ?>
			<!-- <tr>
			<td class="total-line subtotal" colspan="<?php echo (count($act_exp_column_order) - 1); ?>"><?php echo $group_code ?> <?php echo array_var($print_labels, 'amount_due', 'Amount due') ?>: </td>
			<td class="total-value subtotal short">
				<div id="subtotal"><?php echo format_money_amount($subtotal + $act_exp_subtotal, $currency_symbol); ?></div>
			</td>
		</tr> -->
			<tr>
				<table style="width: 100%;">
					<tbody>
						<tr>
							<td class="totalLine" style="padding: 5px;">
								<div style="display: flex; width: 100%; justify-content: flex-end;">
									<span class="global-subtotal-line" colspan="1" style="margin-right: 30px;">
										<?php echo $group_code ?> <?php echo array_var($print_labels, 'amount_due', 'Amount due') ?>:
									</span>
									<span class="global-subtotal-value" colspan="1">
										<?php echo format_money_amount($subtotal + $act_exp_subtotal, $currency_symbol); ?>
									</span>
								</div>
							</td>
						</tr>
					</tbody>
				</table>
			</tr>
		<?php } ?>

		<?php if ($discount > 0) { ?>
			<!-- <tr>
			<td class="total-line subtotal" colspan="<?php echo (count($column_order) - 1); ?>"><?php echo array_var($print_labels, 'discount', 'Discount') ?>: </td>
			<td class="total-value subtotal short">
				<div id="subtotal"><?php echo "(" . format_money_amount(abs($discount), $currency_symbol) . ")" ?></div>
			</td>
		</tr> -->
			<tr>
				<table style="width: 100%;">
					<tbody>
						<tr>
							<td class="totalLine" style="padding: 5px;">
								<div style="display: flex; width: 100%; justify-content: flex-end;">
									<span colspan="1" style="margin-right: 30px;">
										<?= array_var($print_labels, 'discount', 'Discount') ?>:
									</span>
									<span colspan="1">
										<?= "(" . format_money_amount(abs($discount), $currency_symbol) . ")" ?>
									</span>
								</div>
							</td>
						</tr>
					</tbody>
				</table>
			</tr>
		<?php } ?>
		<?php if ($show_grand_total) { ?>
			<?php if (count($taxes_data) > 0) {
				foreach ($taxes_data as $tax_data) {
			?>
					<!-- <tr>
					<td class="total-line subtotal" colspan="<?php echo (count($column_order) - 1); ?>"><?php echo $tax_data['name'] ?>: </td>
					<td class="total-value subtotal short">
						<div id="subtotal"><?php echo format_money_amount($tax_data['amount'], $currency_symbol); ?></div>
					</td>
				</tr> -->
					<tr>
						<table style="width: 100%;">
							<tbody>
								<tr>
									<td class="totalLine" style="padding: 5px;">
										<div style="display: flex; width: 100%; justify-content: flex-end;">
											<span colspan="1" style="margin-right: 30px;">
												<?= $tax_data['name'] ?>:
											</span>
											<span colspan="1">
												<?= format_money_amount($tax_data['amount'], $currency_symbol); ?>
											</span>
										</div>
									</td>
								</tr>
							</tbody>
						</table>
					</tr>
				<?php } ?>
			<?php } ?>
			<!-- <tr>
			<td class="total-line" colspan="<?php echo (count($column_order) - 1); ?>"><?php echo array_var($print_labels, 'total', 'Total due for this invoice') ?>: </td>
			<td class="total-value short">
				<div id="total"><?php echo format_money_amount($invoice_total, $currency_symbol); ?></div>
			</td>
		</tr> -->
			<tr>
				<table style="width: 100%;">
					<tbody>
						<tr>
							<td class="totalLine" style="padding: 5px;">
								<div style="display: flex; width: 100%; justify-content: flex-end;">
									<span class="global-total-line" colspan="1" style="margin-right: 30px;">
										<?= array_var($print_labels, 'total', 'Total due for this invoice') ?>:
									</span>
									<span class="global-total-value" colspan="1">
										<?= format_money_amount($invoice_total, $currency_symbol); ?>
									</span>
								</div>
							</td>
						</tr>
					</tbody>
				</table>
			</tr>
		<?php } ?>
	</tbody>
		</table>

		<style>
			thead.hide_extra_columns tr th:empty {
				display: none !important;
			}

			#items .item-row:nth-child(33) td {
				background-color: rgba(0, 0, 0, .08);
				/* border-bottom: .1px solid #1a4567 !important;
		background-color: red; */
			}
		</style>

		<!-- <?php if (count($lines_data) > 33) { ?>
	<style>
		#items .item-row:nth-child(33) td {
			border-bottom: .1px solid #1a4567 !important;
			background-color: red;
		}
	</style>
<?php } ?> -->