<?php
set_page_title(lang('tax record',$tax_name));
$genid = gen_id();
?>

<div id="<?php echo $genid ?>Taxes" class="adminMailAccounts" style="height: 100%; background-color: white">
    <div class="adminHeader">
        <div class="adminTitle"><?php echo lang('tax record',$tax_name) ?></div>
    </div>
    <div class="adminMainBlock">
        <?php if(isset($tax_records) && is_array($tax_records) && count($tax_records)) { ?>
        <table class="adminListing" style="min-width: 400px; margin-top: 10px;">
                <tr>
                    <th><?php echo lang('date') ?></th>
                    <th><?php echo lang('type') ?></th>
                    <th><?php echo lang('value') ?></th>
                    <th><?php echo lang('options') ?></th>
                </tr>
                <?php
                $isAlt = true;
                foreach($tax_records as $tax) {
                        $isAlt = !$isAlt;
                ?>
                <tr class="<?php echo $isAlt? 'altRow' : ''?>" id="<?php echo $genid ?>tr_<?php echo $tax->getId()?>">
                    <td><?php echo format_date($tax->getDate()->getTimestamp()); ?></td>
                    <td><?php echo lang($tax->getType()) ?></td>
                    <td><?php echo $tax->getValue() ?></td>
                    <?php
                    $options = array();
                    $options[] = '<a class="internalLink" href="'.get_url('tax', 'record', array('tax_id' => $tax->getTaxId(),'tax_record_id' => $tax->getId())).'">' . lang('edit') . '</a>';
                    $options[] = '<a class="internalLink" href="javascript:og.DeleteTax(' . $tax->getId() . ')">' . lang('delete') . '</a>';
                    ?>
                    <td style="font-size: 80%;"><?php echo implode(' | ', $options) ?></td>
                </tr>
                <?php } // foreach ?>
        </table>
        <?php } else { ?> <?php echo lang('no taxes') ?> <?php } // if ?>
    </div>
    <br/>
    <div style="padding: 10px 15px 5px;" class="formBlock">   
        <div class="adminTitle"><?php echo array_var($tax_edit, 'id') ? lang('edit tax record') : lang('add tax record') ?></div>
        <form style="height:100%;background-color:white" class="internalForm" action="<?php echo get_url('tax', 'record', array('tax_id' => $tax_id,'tax_record_id' => array_var($tax_edit, 'id'))); ?>" method="post">
            <?php 
                echo label_tag(lang('type'), $genid . 'type', true);
                echo simple_select_box('tax_record[type]', $type_tax, array_var($tax_edit, 'type'),array('tabindex' => "1"));
                
                echo label_tag(lang('value'), $genid . 'value', true);
                echo text_field('tax_record[value]', array_var($tax_edit, 'value'),array('tabindex' => '2'));
            ?>
            <br/>
            <?php
              echo submit_button(array_var($tax_edit, 'id') ? lang('save changes') : lang('add tax'), 's', array('tabindex' => '1500')); 
            ?>
        </form>
    </div>
</div>

<script>
	var div = document.getElementById('<?php echo $genid ?>Taxes');
	div.parentNode.style.backgroundColor = '#FFFFFF'; 
        
        og.DeleteTax = function(taxId) {        
            if (confirm(lang('delete tax'))) {
                og.openLink(og.getUrl('tax', 'delete_record', {
                        tax_record_id : taxId
                }));
                $('#<?php echo $genid ?>tr_'+taxId).remove();
            }
        };
</script>
