-- <?php echo $table_prefix ?>
-- DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci
-- collate utf8_unicode_ci
-- <?php echo $engine ?> InnoDB
-- varchar cannot be larger than 256
-- blob/text cannot have default values
-- sql queries must finish with ;\n (line break inmediately after ;)

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_config_options` (
`id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
`name` varchar(50) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
`value` text COLLATE utf8_unicode_ci,
`config_handler_class` varchar(50) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
`is_system` tinyint(1) NOT NULL,
`options` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
PRIMARY KEY (`id`),
UNIQUE KEY `name` (`name`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoices` (
`object_id` int(10) unsigned NOT NULL,
`invoice_notebook_id` INT( 10 ) UNSIGNED NOT NULL,
`invoice_number` varchar(50) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
`series` varchar(5) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
`date` date NOT NULL,
`expiration_date` date NOT NULL,
`final_consumer` tinyint(1) NOT NULL,
`currency_id` int(10) NOT NULL DEFAULT '0',
`subtotal` DECIMAL(20,3) NOT NULL,
`total` DECIMAL(20,3) NOT NULL,
`customer_id` int(10) unsigned NOT NULL,
`customer_name` text COLLATE utf8_unicode_ci NOT NULL,
`customer_address` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`customer_city` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`customer_state` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`customer_country` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`customer_zipcode` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`customer_email` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`customer_phone` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`customer_rut` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`customer_number` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`status` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
`repeat_end` date NOT NULL,
`repeat_forever` tinyint(1) NOT NULL,
`repeat_num` int(10) unsigned NOT NULL,
`repeat_d` int(10) unsigned NOT NULL,
`repeat_m` int(10) unsigned NOT NULL,
`repeat_y` int(10) unsigned NOT NULL,
`repeat_h` int(10) unsigned NOT NULL,
`repeat_dow` int(10) unsigned NOT NULL,
`repeat_wnum` int(10) unsigned NOT NULL,
`repeat_mjump` int(10) unsigned NOT NULL,
`from_invoice_id` int(10) unsigned NOT NULL,
`additional_information` text COLLATE utf8_unicode_ci NOT NULL,
`invoice_preview_file_id` int(10) unsigned NOT NULL DEFAULT 0,
`sent_invoice_mail_id` int(10) unsigned NOT NULL DEFAULT 0,
`ordered_by_id` int(10) unsigned NOT NULL DEFAULT 0,
`sent` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
`attn` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT '',
PRIMARY KEY (`object_id`),
KEY `date` (`date`),
KEY `series_invoice_number` (`series`,`invoice_number`),
KEY `invoice_number` (`invoice_number`),
KEY `total` (`total`),
KEY `status` (`status`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_lines` (
`id` int(10) unsigned NOT NULL AUTO_INCREMENT,
`object_id` int(10) unsigned NOT NULL,
`amount` DECIMAL(20,3) unsigned NOT NULL,
`currency_id` int(10) NOT NULL DEFAULT '0',
`unit_value` DECIMAL(20,3) NOT NULL,
`total` DECIMAL(20,3) NOT NULL,
`subtotal` DECIMAL(20,3) NOT NULL,
`taxes` DECIMAL(20,3) NOT NULL,
`detail` text COLLATE utf8_unicode_ci NOT NULL,
`exchange_rate` DECIMAL(20,10) NOT NULL DEFAULT '1',
`rel_object_id` int(10) NOT NULL DEFAULT '0',
`user_id` int(10) NOT NULL DEFAULT '0',
`category_id` int(10) NOT NULL DEFAULT '0',
`date` DATE NOT NULL,
`from_object_type_id` int(10) NOT NULL DEFAULT '0',
`product_type_id` int(10) NOT NULL DEFAULT '0',
`member_id` int(10) NOT NULL DEFAULT '0',
`group_by_category_id` int(10) NOT NULL DEFAULT '0',
`unit_cost` DECIMAL(20,3) unsigned NOT NULL DEFAULT '0',
`price_multiplier` DECIMAL(20,3) unsigned NOT NULL DEFAULT '0',
`order` int(10),
`item_type_id` int(10) NOT NULL DEFAULT '0',
`discount_percent_value` decimal(20,3) DEFAULT '0',
`discount_percent_type` int(1) DEFAULT '0',
PRIMARY KEY (`id`),
KEY `object_id` (`object_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_references` (
`id` int(10) unsigned NOT NULL AUTO_INCREMENT,
`object_id` int(10) unsigned NOT NULL,
`serie` VARCHAR(100) NOT NULL,
`invoice_number` int(10) unsigned NOT NULL,
`referenced_object_id` int(10) unsigned NOT NULL,
`detail` text COLLATE utf8_unicode_ci NOT NULL,
PRIMARY KEY (`id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_taxes` (
`invoice_id` int(10) NOT NULL,
`tax_id` int(10) NOT NULL,
`type` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
`value` float NOT NULL,
`fixed_value` float NOT NULL,
PRIMARY KEY (`invoice_id`,`tax_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_taxes` (
`id` int(10) unsigned NOT NULL AUTO_INCREMENT,
`name` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
`select_default` tinyint(1) NOT NULL,
`code` varchar(255) <?php echo $default_collation ?> NOT NULL,
`is_special` BOOLEAN NOT NULL default '0',
`removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
`removed_by_id` INT( 10 ) UNSIGNED NOT NULL DEFAULT '0',
PRIMARY KEY (`id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_tax_records` (
`id` int(10) unsigned NOT NULL AUTO_INCREMENT,
`tax_id` int(10) unsigned NOT NULL,
`type` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
`value` float NOT NULL,
`date` date NOT NULL,
`removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
`removed_by_id` INT( 10 ) UNSIGNED NOT NULL DEFAULT '0',
PRIMARY KEY (`id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?> ;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_types` (
`id` INT( 10 ) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`name` VARCHAR( 100 ) NOT NULL ,
`select_default` TINYINT( 1 ) NULL,
`removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
`removed_by_id` INT( 10 ) UNSIGNED NOT NULL DEFAULT '0'
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_copies` (
`id` INT( 10 ) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`name` VARCHAR( 100 ) NOT NULL ,
`description` TEXT NULL ,
`color` VARCHAR( 100 ) NULL ,
`select_default` TINYINT( 1 ) NULL,
`removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
`removed_by_id` INT( 10 ) UNSIGNED NOT NULL DEFAULT '0'
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_notebooks` (
`id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
`invoice_type_id` INT(10) UNSIGNED NOT NULL,
`rut` VARCHAR(100) NULL,
`expiration_date` DATE NOT NULL,
`series` VARCHAR(100) NOT NULL,
`initial_number` INT(10) NOT NULL,
`final_number` INT(10) NOT NULL,
`address` VARCHAR(255) NULL,
`extra_information` TEXT NULL,
`press_information` TEXT NULL,
`exhausted` TINYINT( 1 ) NULL DEFAULT '0',
`removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
`removed_by_id` INT( 10 ) UNSIGNED NOT NULL DEFAULT '0'
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_copies` (
`invoice_id` int(10) NOT NULL,
`copy_id` int(10) NOT NULL,
PRIMARY KEY (`invoice_id`,`copy_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;

CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_templates` (
`id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
`name` VARCHAR(255) NOT NULL DEFAULT '',
`is_default` TINYINT( 1 ) NOT NULL DEFAULT '0',
`template_type` VARCHAR(100) NOT NULL DEFAULT 'detailed',
`group_by` VARCHAR(100) NOT NULL DEFAULT '',
`include_date` TINYINT( 1 ) NOT NULL DEFAULT '0',
`include_user_name` varchar(100) NOT NULL DEFAULT '',
`include_labor_category` TINYINT( 1 ) NOT NULL DEFAULT '0',
`include_description` TINYINT( 1 ) NOT NULL DEFAULT '0',
`exp_group_by` VARCHAR(100) NOT NULL DEFAULT '',
`display_cost_or_price` VARCHAR(100) NOT NULL DEFAULT 'price',
`include_exp_date` TINYINT( 1 ) NOT NULL DEFAULT '0',
`include_paid_by` TINYINT( 1 ) NOT NULL DEFAULT '0',
`include_product_type` TINYINT( 1 ) NOT NULL DEFAULT '0',
`include_expense_category` TINYINT( 1 ) NOT NULL DEFAULT '0',
`include_expense_description` TINYINT( 1 ) NOT NULL DEFAULT '0',
`include_expense_name` TINYINT( 1 ) NOT NULL DEFAULT '0',
`include_account_summary` TINYINT( 1 ) NOT NULL DEFAULT '0',
`break_down_by_subprojects` TINYINT( 1 ) NOT NULL DEFAULT '0',
`break_down_expenses_by_category` TINYINT( 1 ) NOT NULL DEFAULT '0',
`show_expenses_markup_separated` TINYINT( 1 ) NOT NULL DEFAULT '0',
`accumulate_discounts` TINYINT( 1 ) NOT NULL DEFAULT '1',
`footer_text` VARCHAR(511) NOT NULL DEFAULT '',
`category_for_lump_sum` int(10) NOT NULL DEFAULT '0',
`product_type_for_lump_sum` int(10) NOT NULL DEFAULT '0',
`invoice_template_assigned` VARCHAR(100) NOT NULL DEFAULT ''
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;


CREATE TABLE IF NOT EXISTS `<?php echo $table_prefix ?>income_invoice_line_taxes` (
`invoice_line_id` int(10) NOT NULL,
`tax_id` int(10) NOT NULL,
`value` DECIMAL(20,3) NOT NULL,
`applied_value` DECIMAL(20,3) NOT NULL,
PRIMARY KEY (`invoice_line_id`,`tax_id`),
KEY `tax_id` (`tax_id`)
) ENGINE=<?php echo $engine ?> <?php echo $default_charset ?>;