//const { lang } = require("moment");

//const { lang } = require("moment");

og.income = {
    props:{
        temporal_data:0
    },

    init: function () {

        // listener to enabled/disable action buttons on task selection in tasks list
        og.eventManager.addListener('task list updateCheckedStatus', function (params) {
            var btn = Ext.getCmp('generate_invoice_from_tasks');
            if (btn) {
                if (!params.checked) {
                    btn.disable();
                } else {
                    btn.enable();
                }
            }
        });
		
		og.openLink(og.getUrl('income', 'get_disabled_subtabs'), {callback: function(success, data){
			if (success) {
				og.income.disabled_subtabs = data.disabled_subtabs;
			}
		}});
		
        // load the dimension members for categories to use in the invoice form category selectors
		this.load_categories_dimensions();

		og.openLink(og.getUrl('invoice_template', 'get_invoice_templates_data'), {callback: function(success, data){
			if (success) {
				og.income.invoice_templates = data.invoice_templates;
			}
		}});

		// add billing address column to members list of type 'project'
		og.eventManager.addListener('after get projects dimension info', function (dim) {
			if (dim && dim.dimension_id && dim.object_type_id) {

				if (!og.listing_member_type_cols) og.listing_member_type_cols = [];
				if (!og.listing_member_type_cols[dim.dimension_id]) og.listing_member_type_cols[dim.dimension_id] = [];
				if (!og.listing_member_type_cols[dim.dimension_id][dim.object_type_id]) og.listing_member_type_cols[dim.dimension_id][dim.object_type_id] = [];
				
                var hasBillingAddress = og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].filter(el => el.id == 'billing_address');
                var hasBillingEmail = og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].filter(el => el.id == 'billing_email');
                if (hasBillingAddress.length == 0) {
                    og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
                        id: 'billing_address',
                        name: lang('billing address'),
                        renderer: og.clean,
                    });
                }
                if (hasBillingEmail.length == 0) {
                    og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
                        id: 'billing_email',
                        name: lang('billing email'),
                        renderer: og.clean,
                    });
                }
			}
		});

        if (og.advanced_billing) {

            og.invoicing_status_combo = og.income.build_invoicing_status_combo();

            var has_col = false;
            if (ogTasks.additional_task_list_columns) {
                for (var i = 0; i < ogTasks.additional_task_list_columns.length; i++) {
                    if (ogTasks.additional_task_list_columns[i].id == 'tasksShowInvoicingStatus') has_col = true;
                }
            } else {
                ogTasks.additional_task_list_columns = [];
            }
            if (!has_col) {
                ogTasks.additional_task_list_columns.push({
                    id: 'tasksShowInvoicingStatus',
                    width: 200,
                    name: lang('invoicing status')
                });
            }
            
            var invoicing_status_options = [
                ['', lang('All')],
                ['pending', lang('invoicing_status pending')],
                ['non_billable', lang('invoicing_status non_billable')],
                ['invoiced', lang('invoicing_status invoiced')]
            ];

            var invoicing_status_filter = {
            	type: 'list',
            	label: '&nbsp;' + lang('invoicing_status') + ': ',
            	options: invoicing_status_options,
            	width: 100,
            	value: '',
            	initial_val: '',
            	secondToolbar: true
            };
            var expense_invoicing_status_filter = {
            	type: 'list',
            	label: '&nbsp;' + lang('invoicing_status') + ': ',
            	options: invoicing_status_options,
            	width: 100,
            	value: '',
            	initial_val: '',
            	secondToolbar: true
            };
            
            if (!og.additional_timeslots_tab_filters) og.additional_timeslots_tab_filters = {};
            og.additional_timeslots_tab_filters['invoicing_status_filter'] = invoicing_status_filter;

            if (!og.additional_expenses_tab_filters) og.additional_expenses_tab_filters = {};
            og.additional_expenses_tab_filters['expense_invoicing_status_filter'] = expense_invoicing_status_filter;
            
            // add invoicing status to budgeted expenses list
            /*
            if (!og.extra_expense_list_columns) og.extra_expense_list_columns = [];
            og.extra_expense_list_columns.push({
    			id: 'invoicing_status',
    			header: lang("invoicing_status"),
    			dataIndex: 'invoicing_status',
    			width: 100,
    			renderer: function(value, p, r) {
    				if (r.data.invoicing_status) {
    					return '<span class="invoicing-status-'+r.data.invoicing_status+'">' + lang('invoicing_status '+r.data.invoicing_status) + '</span>';
    				}
    				return '';
    			},
            });
            */

            // Add invoice totals columns to the project list
            og.openLink(og.getUrl('project', 'get_dimension_info'), {
                callback: function(success, data) {
                    if (!data || !data.dim_info) return;
                    og.projects.dimension_id = data.dim_info.dimension_id;
                    og.projects.object_type_id = data.dim_info.object_type_id;

                    og.eventManager.fireEvent('after get projects dimension info', data.dim_info);

                    var dim = data.dim_info; 
                    if (!og.listing_member_type_cols) og.listing_member_type_cols = [];
                    if (!og.listing_member_type_cols[dim.dimension_id]) og.listing_member_type_cols[dim.dimension_id] = [];
                    if (!og.listing_member_type_cols[dim.dimension_id][dim.object_type_id]) og.listing_member_type_cols[dim.dimension_id][dim.object_type_id] = [];

                    // Invoice totals
                    og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
                        id: 'invoiced_total',
                        name: lang('invoiced total'),
                        renderer: og.clean,
                        hidden: true
                    });

                    og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
                        id: 'invoiced_subtotal',
                        name: lang('invoiced subtotal'),
                        renderer: og.clean,
                        hidden: true
                    });


                    og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
                        id: 'invoiced_paid_amount',
                        name: lang('invoiced paid amount'),
                        renderer: og.clean,
                        hidden: true
                    });

                    og.listing_member_type_cols[dim.dimension_id][dim.object_type_id].push({
                        id: 'invoiced_due_amount',
                        name: lang('invoiced due amount'),
                        renderer: og.clean,
                        hidden: true
                    });
                }
            });
        }
        $(document)
            .on("click", '#save_send_invoice', function (ev) {
                
                ev.preventDefault();
                var gen_id = $("#invoice_form_genid").val();
                var is_mail_active = $("#"+gen_id+"is_mail_active").val();
                if (is_mail_active) {
	                og.submit_modal_form(gen_id + 'submit-edit-form', function (data) {
	                	if (data && data.invoice) {
	                		og.invoices.sendInvoiceNow(data.invoice.object_id, data.invoice.customer_email);
	                	}
	                });
            	}
                return false;
            })
            .on("click", '#save_invoice', function (ev) {
                ev.preventDefault();
                var gen_id = $("#invoice_form_genid").val();
                og.submit_modal_form(gen_id + 'submit-edit-form');
                return false;
            })
            .on('change', '.verfDateString', (ev) => {

                if (ev !== '') {
                    let getValue = ev.target.value;
                    let cleanString = getValue.replace(/\\|\//g, '');
                    let newDate = cleanString.slice(0, 2) + '/' + cleanString.slice(2, 4) + '/' + cleanString.slice(4);
                    ev.target.value = newDate;
                } else {
                    ev.target.value = '';
                }
            });
		},

		on_payment_method_change: function(genid, selectbox) {
			if ($(selectbox).val() != '' && $(selectbox).val() != 'cash' && $(selectbox).val() != 'credit_card') {
				$("#" + genid + "payment-transaction-block").show();
			} else {
				$("#" + genid + "payment-transaction-block").hide();
			}
		},

    generate_invoice_from_timeslots: function (panel_id) {
        var ids = [];

        var grid = Ext.getCmp(panel_id);
        if (grid) {
            ids = grid.getSelectedIds();
        }
        
        var params = {};
        
        if (ids.length > 0) {
        	params.timeslot_ids = ids;
        } else {
        	params.all_timeslots = true;
        	if (grid) {
        		Ext.apply(params, grid.store_params);
        	}
            //og.err(lang('you must select at least one timeslot to generate the invoice'));
        }
        og.openLink(og.getUrl('invoice', 'generate_invoice_from_timeslots', params));
    },
    
    get_billing_address_from_project_inputs: function (genid, billing_contact_cp_id, client_assoc_id, billing_client_assoc_id) {
    		
    	var bc_cp_id = genid + 'cp' + billing_contact_cp_id;
    	var bc = 0;
    	if (billing_contact_cp_id > 0) {
    		bc = $("#"+bc_cp_id).val();
    	}
    	
    	var client = 0;
    	if (client_assoc_id > 0) {
    		var client_str = null;
    		var c_inputs = document.getElementsByName("associated_members["+client_assoc_id+"]");
    		if (c_inputs && c_inputs.length > 0) {
    			client_str = c_inputs[0].value;
    		}
    		
    		if (client_str) {
	    		var client_array = Ext.util.JSON.decode(client_str);
	    		if (client_array && client_array.length > 0) {
	    			client = client_array[0];
	    		}
    		}
    	}
    	
    	var billing_client = 0;
    	if (billing_client_assoc_id > 0) {
    		var billing_client_str = null;
    		var bc_inputs = document.getElementsByName("associated_members["+billing_client_assoc_id+"]");
    		if (bc_inputs && bc_inputs.length > 0) {
    			billing_client_str = bc_inputs[0].value;
    		}
    		
    		if (billing_client_str) {
	    		var billing_client_array = Ext.util.JSON.decode(billing_client_str);
	    		if (billing_client_array && billing_client_array.length > 0) {
	    			billing_client = billing_client_array[0];
	    		}
    		}
    	}
    	
    	var client_to_send = billing_client > 0 ? billing_client : client;
    	
    	$("#"+genid+"billing_address_container").addClass('selector-body loading');
    	
    	og.openLink(og.getUrl('income', 'get_project_billing_address', {
    		genid: genid,
    		bc_id: bc,
    		client_id: client_to_send
    	}),{
    		hideLoading: true,
    		callback: function(success, data) {
    			if (success) {
    				
    				var html = '<span class="desc">'+lang('address not found for the selected billing information')+'</span>';
    				
    				if (data && data.billing_address && data.billing_address.street) {
    					var line1 = data.billing_address.street + "<br />";
    					var line2 = '';
    					if (data.billing_address.city) line2 += data.billing_address.city;
    					if (data.billing_address.state) line2 += (line2==''?'':' ') + data.billing_address.state;
    					if (data.billing_address.zipcode) line2 += (line2==''?'':' ') + data.billing_address.zipcode;
    					if (data.billing_address.country_name) line2 += (line2==''?'':' ') + data.billing_address.country_name;
    					
    					html = line1 + line2;
    				}
    				
    				$("#"+data.genid+"billing_address_container").html(html);
    				
    				$("#"+data.genid+"billing_address_container").removeClass('selector-body loading');
    			}
    		}
    	});
    	
    },
    
    build_invoicing_status_combo: function () {
        invoicing_status_combo = new Ext.form.ComboBox({
            id: 'invoicing_status_combo',
            store: new Ext.data.SimpleStore({
                fields: ['value', 'text'],
                data: [['no_filter', '--' + lang('no filter') + '--'],
                    ['pending', lang('invoicing_status pending')],
                    ['partially_invoiced', lang('invoicing_status partially_invoiced')],
                    ['invoiced', lang('invoicing_status invoiced')],
                    ['non_billable', lang('invoicing_status non_billable')]
                ]
            }),
            hidden: (ogTasks && ogTasks.userPreferences ? ogTasks.userPreferences.filter != 'invoicing_status' : true),
            displayField: 'text',
            mode: 'local',
            triggerAction: 'all',
            selectOnFocus: true,
            width: 145,
            valueField: 'value',
            listeners: {
                'select': function (combo, record) {
                    var toolbar = Ext.getCmp('tasksPanelBottomToolbarObject');
                    if (toolbar) {
                        toolbar.load();
                    }
                }
            }
        });

        var has_combo = false;
        if (ogTasks.additional_filtercombo_types) {
            for (var i = 0; i < ogTasks.additional_filtercombo_types.length; i++) {
                if (ogTasks.additional_filtercombo_types[i].id == 'invoicing_status') has_combo = true;
            }
        } else {
            ogTasks.additional_filtercombo_types = [];
        }
        if (!has_combo) {
            ogTasks.additional_filtercombo_types.push({
                id: 'invoicing_status',
                name: lang('invoicing status'),
                onselect: og.income.on_tasks_list_invoicing_status_filter_selected,
                component_id: 'invoicing_status_combo'
            });
        }

        if (ogTasks && ogTasks.userPreferences) {
            invoicing_status_combo.setValue(ogTasks.userPreferences.filterValue);
        }

        return invoicing_status_combo;
    },

    on_tasks_list_invoicing_status_filter_selected: function (sel_value) {

        if (sel_value == 'invoicing_status') {

            Ext.getCmp('ogTasksFilterNamesCombo').hide();
            Ext.getCmp('ogTasksFilterNamesCompaniesCombo').hide();
            Ext.getCmp('ogTasksFilterMilestonesCombo').hide();
            Ext.getCmp('ogTasksFilterPriorityCombo').hide();
            Ext.getCmp('ogTasksFilterSubtypeCombo').hide();

            var combo = Ext.getCmp('invoicing_status_combo');
            if (combo) combo.show();
            og.invoicing_status_combo.show();

        } else {

            var combo = Ext.getCmp('invoicing_status_combo');
            if (combo) combo.hide();
            og.invoicing_status_combo.hide();

        }
    },

    on_timeslot_status_change: function (status_combo) {
        if ($(status_combo).val() == 'invoiced') {
            $("#addTimeslotFixedCost").attr('readonly', 'readonly');
            $("#addTimeslotHourlyCost").attr('readonly', 'readonly');
            $("#addTimeslotFixedBilling").attr('readonly', 'readonly');
            $("#addTimeslotHourlyBilling").attr('readonly', 'readonly');
            $("#addTimeslotRateCurrencyId").attr('disabled', 'disabled');
            $("#addTimeslotCostCurrencyId").attr('disabled', 'disabled');
            $("#addTimeslotFixedRateCurrencyId").attr('disabled', 'disabled');
            $("#addTimeslotFixedCostCurrencyId").attr('disabled', 'disabled');

            // if original status was 'invoiced' => dont let user change it to 'unbilled', then change amounts and then change status to 'invoiced' again
            if (og.income.ts_original_status == 'invoiced') {
                $("#addTimeslotFixedCost").val(og.income.ts_original_fixed_cost);
                $("#addTimeslotHourlyCost").val(og.income.ts_original_hourly_cost);
                $("#addTimeslotFixedBilling").val(og.income.ts_original_fixed_billing);
                $("#addTimeslotHourlyBilling").val(og.income.ts_original_hourly_billing);
                $("#addTimeslotRateCurrencyId").val(og.income.ts_original_rate_currency_id);
                $("#addTimeslotCostCurrencyId").val(og.income.ts_original_cost_currency_id);
                $("#addTimeslotFixedRateCurrencyId").val(og.income.ts_original_rate_currency_id);
                $("#addTimeslotFixedCostCurrencyId").val(og.income.ts_original_cost_currency_id);
            }

        } else {
            $("#addTimeslotFixedCost").removeAttr('readonly');
            $("#addTimeslotHourlyCost").removeAttr('readonly');
            $("#addTimeslotFixedBilling").removeAttr('readonly');
            $("#addTimeslotHourlyBilling").removeAttr('readonly');
            $("#addTimeslotRateCurrencyId").removeAttr('disabled');
            $("#addTimeslotCostCurrencyId").removeAttr('disabled');
            $("#addTimeslotFixedRateCurrencyId").removeAttr('disabled');
            $("#addTimeslotFixedCostCurrencyId").removeAttr('disabled');
        }

        if ($(status_combo).val() == 'non_billable') {
            $(status_combo).closest('.billing-inputs').children('.billing-inputs-container').hide();
            $('.billing-inputs').children('.billing-inputs-container').hide();
            $('#billing_info_li').hide();
        } else {
            $(status_combo).closest('.billing-inputs').children('.billing-inputs-container').show();
            $('.billing-inputs').children('.billing-inputs-container').show();
            $('#billing_info_li').show();
        }
    },
    
    
    get_context_selected_project_id: function() {
    	var project_member_id = null;
    	var sel_projects = og.contextManager.getDimensionMembers(og.projects.dimension_id);
    	for (i=0; i<sel_projects.length; i++) {
    		var mem_id = sel_projects[i];
    		var node = og.contextManager.getTreeNode(og.projects.dimension_id, mem_id);
    		if (node && node.object_type_id == og.projects.object_type_id){
    			project_member_id = mem_id;
    		}
    	}
    	return project_member_id;
    },

    trash_invoice: function(id, skip_confirmation) {
        og.openLink(og.getUrl('invoice', 'check_invoices_integration_status', {ids: id}), {
            hideLoading: true,
            callback: function(success, data) {
                if(data.result){
					var call_trash_action = false;
					if (skip_confirmation) {
						call_trash_action = true;
					} else {
						call_trash_action = confirm(lang('confirm move to trash'));
					}
                    if (call_trash_action) {
                        og.openLink(og.getUrl('object', 'trash', {object_id: id}));
                    }
                }
            }
        });
    },
    
    load_categories_dimensions: function() {
		og.openLink(og.getUrl('dimension', 'reload_dimensions_js', {
			dim_codes: ['hour_types','expense_categories'],
			check_perm: 0
		}), {
			callback: function(success, data) {

				for (dim_id in data.dims) {
					let dim_members = data.dims[dim_id];
					if (typeof dim_members == 'function') continue;

					if (dim_members.length > 0) {
						if (!og.dimensions) {
							og.dimensions = {};
						}
						if (!og.dimensions[dim_id]) {
							og.dimensions[dim_id] = {};
						}
						for (var i=0; i < dim_members.length; i++) {
							let member = dim_members[i];
							og.dimensions[dim_id][member.id] = member;
						}
					}
				}
			}
		});
	},
	// START functions to change time/expenses invoicing status
	// time
	mark_time_as_invoiced: function (panel_id) {
		var params = og.income.get_grid_params(panel_id);
		og.openLink(og.getUrl('income', 'mark_time_as_invoiced', params), {});
	},
    
	mark_time_as_unbilled: function (panel_id) {
		var params = og.income.get_grid_params(panel_id);
		og.openLink(og.getUrl('income', 'mark_time_as_unbilled', params), {});
	},
    
	mark_time_as_non_billable: function (panel_id) {
		var params = og.income.get_grid_params(panel_id);
		og.openLink(og.getUrl('income', 'mark_time_as_non_billable', params), {});
	},
    
	// expenses
	mark_expense_as_invoiced: function (panel_id) {
		var params = og.income.get_grid_params(panel_id);
		og.openLink(og.getUrl('income', 'mark_expense_as_invoiced', params), {});
	},
    
	mark_expense_as_unbilled: function (panel_id) {
		var params = og.income.get_grid_params(panel_id);
		og.openLink(og.getUrl('income', 'mark_expense_as_unbilled', params), {});
	},
    
	mark_expense_as_non_billable: function (panel_id) {
		var params = og.income.get_grid_params(panel_id);
		og.openLink(og.getUrl('income', 'mark_expense_as_non_billable', params), {});
	},
	
	// auxiliar
	get_grid_params: function(panel_id) {
		var ids = [];
		var grid = Ext.getCmp(panel_id);
		if (grid) {
			ids = grid.getSelectedIds();
		}
		var params = {
			ids: ids
		};

		return params;
	},
    // END functions to change time/expenses invoicing status

    
    batch_project_invoices_generation_tab: function() {
    	
    	og.openLink(og.getUrl('invoice', 'list_project_invoices_to_generate_tab'), {caller:"batch-invoicing"});
    	
    },

    sync_qb: function(ids_sel) {
    	og.openLink(og.getUrl('quickbooks', 'sync_invoices_whit_quickbooks', {ids_sel: ids_sel}), {
            ids_sel:ids_sel,
            callback:function(){
                og.income.reload_not_sync();
            }
        });
    },

    reload_not_sync:function(){
        og.openLink(og.getUrl('quickbooks', 'get_total_not_sync'), {
            callback:function(success, data){
                var text_rendered = $('#label-qb .x-btn-text:first').text().replace(og.income.props.temporal_data, data.total);
                $('#label-qb .x-btn-text:first').text(text_rendered);
                og.income.props.temporal_data = data.total;
            }
        });
    },
    
	edit_pre_invoice_properties: function(member_id) {
		// render modal form to modify some of the invoice's properties
		var man = Ext.getCmp('batch-invoicing-manager');
		var row = man.store.data.map[member_id];
		if (row) {

			var fee = isNaN(row.data.additional_fee) ? '0' : row.data.additional_fee;
			var discount = isNaN(row.data.discount) ? '0' : row.data.discount;
			var add_info = row.data.additional_information ? row.data.additional_information : '';
			
			var question = lang("here you can edit the invoice properties");
			var div = document.createElement('div');
			var genid = Ext.id();
			div.innerHTML = '<div style="border-radius: 5px; background-color: #fff; padding: 10px; width: 600px;">'+ 
				'<div><label class="coInputTitle">'+ row.data.name +'</label></div>'+
				'<div id="'+genid+'_question">'+ question +'</div>'+
				'<div id="'+genid+'_inputs" class="coInputMainBlock">'+ 
					'<div class="dataBlock"><label style="min-width: 160px;">'+lang('administration fee')+' ('+row.data.currency_sym+')</label>'+
					'<div id="'+genid+'_fee_container"><input type="text" value="'+fee+'" id="'+genid+'_fee" style="text-align:right;"/></div></div>'+
					'<div class="dataBlock"><label style="min-width: 160px;">'+lang('discount')+' ('+row.data.currency_sym+')</label>'+
					'<div id="'+genid+'_discount_container"><input type="text" value="'+discount+'" id="'+genid+'_discount" style="text-align:right;"/></div></div>'+
					'<div class="dataBlock"><label style="min-width: 160px;">'+lang('additional information')+'</label>'+
					'<div id="'+genid+'_additional_information_container"><textarea id="'+genid+'_additional_information" style="width:380px;height:60px;">'+add_info+'</textarea></div></div>'+
				'</div>'+
				'<div id="'+genid+'_buttons">'+
				'<button class="yes submit blue">'+lang('save changes')+'</button>'+
				'</div><div class="clear"></div></div>';

			var modal_params = {
				'escClose': false,
				'overlayClose': false,
				'closeHTML': '<a id="'+genid+'_close_link" class="modal-close" title="'+lang('close')+'"></a>',
				'onShow': function (dialog) {
					$("#"+genid+"_close_link").addClass("modal-close-img");
					$("#"+genid+"_buttons").css('text-align', 'right').css('margin', '0px 17px 10px');
					$("#"+genid+"_question").css('margin', '10px 0');
					
					$("#"+genid+"_buttons button.yes").click(function(){

						var f = $("#"+genid+"_fee").val();
						var d = $("#"+genid+"_discount").val();
						var ai = $("#"+genid+"_additional_information").val();
						
						og.income.set_pre_invoice_properties(member_id, d, f, ai);
						
						$('.modal-close').click();
					});
			    }
			};
			setTimeout(function() {
				$.modal(div, modal_params);
			}, 100);
			
			
		}	
	},
	

	set_pre_invoice_properties: function(member_id, discount, fee, add_info) {
		// set data in the grid store row
		discount = parseFloat(discount);
		fee = parseFloat(fee);
		
		var man = Ext.getCmp('batch-invoicing-manager');
		var row = man.store.data.map[member_id];
		if (row) {
			if (!row.data.original_total) row.data.original_total = row.data.total_raw;
			row.data.total_raw = row.data.original_total;
			
			if (!isNaN(discount)) {
				row.data.discount = discount;
			} else {
				row.data.discount = 0;
			}
			row.data.total_raw -= row.data.discount;
			
			if (!isNaN(fee)) {
				row.data.additional_fee = fee;
			} else {
				row.data.additional_fee = 0;
			}
			row.data.total_raw = row.data.total_raw + row.data.additional_fee;

			row.data.total = og.format_money_amount(row.data.total_raw);
			
			if (add_info) {
				row.data.additional_information = add_info;
			} else {
				row.data.additional_information = '';
			}
			
			// update row data in the view
			//man.view.refresh();
			man.view.refreshRow(row);
		}
		
	},
    
    generate_project_invoice_modal_form: function(member_id) {
    	
    	var project_name = '';
    	var node = og.contextManager.getTreeNode(og.projects.dimension_id, member_id);
		if (node && node.object_type_id == og.projects.object_type_id){
			project_name = node.text;
		}
		
		var invoice_template_options_html = '<option value="0">'+lang('inherit from project')+'</option>';
		for (var i=0; i<og.income.invoice_templates.length; i++) {
			var t = og.income.invoice_templates[i];
			invoice_template_options_html += '<option value="'+t.id+'">'+t.name+'</option>';
		}
    	
    	var question = lang('please select the billing period to invoice the project', project_name);
		var div = document.createElement('div');
		var genid = Ext.id();
		div.innerHTML = '<div style="border-radius: 5px; background-color: #fff; padding: 10px; width: 400px;">'+ 
			'<div><label class="coInputTitle">'+lang('generate invoice for project')+'</label></div>'+
			'<div id="'+genid+'_question">'+ question +'</div>'+
			'<div id="'+genid+'_inputs" class="coInputMainBlock">'+ 
				'<div class="dataBlock"><label style="min-width: 100px;">'+lang('from')+'</label>'+
				'<div id="'+genid+'_billing_from_container"></div></div>'+
				'<div class="dataBlock"><label style="min-width: 100px;">'+lang('to')+'</label>'+
				'<div id="'+genid+'_billing_to_container"></div></div>'+
				'<div class="dataBlock"><label style="min-width: 100px;">'+lang('invoice template')+'</label>'+
				'<div id="'+genid+'_invoice_template_container">'+
					'<select name="invoice_template_id" id="'+genid+'invoice_template_id">'+
					invoice_template_options_html +
					'</select>'+
				'</div></div>'+
			'</div>'+
			'<div id="'+genid+'_buttons">'+
			'<button class="yes submit blue">'+lang('generate invoice')+'</button>'+
			'</div><div class="clear"></div></div>';

		var modal_params = {
			'escClose': false,
			'overlayClose': false,
			'closeHTML': '<a id="'+genid+'_close_link" class="modal-close" title="'+lang('close')+'"></a>',
			'onShow': function (dialog) {
				$("#"+genid+"_close_link").addClass("modal-close-img");
				$("#"+genid+"_buttons").css('text-align', 'right').css('margin', '10px 0');
				$("#"+genid+"_question").css('margin', '10px 0');
				
                if (!sessionStorage.getItem('start_date_project_invoice')) {
                    var date_from = new Date();                        
                } else {
                    var date_from = new Date(sessionStorage.getItem('start_date_project_invoice'));    
                }                
                				
				var from_input = new og.DateField({
					renderTo: genid+'_billing_from_container',
					id: genid+'billing_period_from',
					value: date_from, 
                    listeners: {
                        'change': function (combo, record) {
                            sessionStorage.setItem('start_date_project_invoice', record)
                        }
                    }
				});

                if (!sessionStorage.getItem('end_date_project_invoice')) {
                    var date_to = new Date();                        
                } else {
                    var date_to = new Date(sessionStorage.getItem('end_date_project_invoice'));                        
                }                
                
				var to_input = new og.DateField({
					renderTo: genid+'_billing_to_container',
					id: genid+'billing_period_to',
					value: date_to,
                    listeners: {
                        'change': function (combo, record) {
                            sessionStorage.setItem('end_date_project_invoice', record)
                        }
                    }
				});                                       
                 
				$("#"+genid+"_buttons button.yes").css('margin-right', '10px').click(function(){

					og.openLink(og.getUrl('invoice', 'generate_member_invoice', {
						member_id: member_id,
						invoice_template_id: $("#"+genid+"invoice_template_id").val(),
						billing_period_from: Ext.util.Format.date(Ext.getCmp(genid+'billing_period_from').getValue(), og.preferences['date_format']),
						billing_period_to: Ext.util.Format.date(Ext.getCmp(genid+'billing_period_to').getValue(), og.preferences['date_format']),
					}));
					
					$('.modal-close').click();
				});
				$("#"+genid+"_buttons button.no").css('margin-right', '10px').click(function(){
					$('.modal-close').click();
				});
		    }
		};
		setTimeout(function() {
			$.modal(div, modal_params);
		}, 100);        
    	
    },
    onAppendDefaultBilling: (id, name, container_id, type, sel_data, mainContainer) => {

        let textCapitalize = type.charAt(0).toUpperCase() + type.slice(1),
            billingValue = (sel_data !== undefined) 
                ? (sel_data.hasOwnProperty('default_billing_address')) ? sel_data.default_billing_address : sel_data
                : false,
            defaultBillingContainer = $("#" + container_id),
            default_radio_button = $(`<div class="radioDefault radioDefaultButtonContainer">
                <div class="radioItem">	
                    <label>
                        <input
                            onchange="og.income.switchRadioActive(event, '${textCapitalize}')" 
                            id="${id}_default_billing_${type}"
                            type="radio"
                            class="checkbox radio${textCapitalize}Default"
                            name="${name}[default_billing_${type}]"
                            ${(billingValue && billingValue == 1) && 'checked'}
                        />
                        <span class="billingTitle">Billing ${type}</span>
                    </label>
                </div>
            </div>
        `);

        if(mainContainer){
            $('#'+container_id).append(default_radio_button);
        }else{
            defaultBillingContainer.each(function (i) {
                let childRemoveUndo = $(this).find('.removeUndo');
                $(default_radio_button).insertBefore(childRemoveUndo)
            });
        }


    },
    // onAppendMainEmailRadio: (id, name, container_id, type, sel_data) => {

    //     let textCapitalize = type.charAt(0).toUpperCase() + type.slice(1),
    //         // billingValue = (sel_data !== undefined)
    //         //     ? (sel_data.hasOwnProperty('default_billing_address')) ? sel_data.default_billing_address : sel_data
    //         //     : false,
    //         defaultBillingContainer = $("#" + container_id),
    //         default_radio_button = $(`<td class="radioDefault" style="vertical-align: middle;text-align: center;">
    //             <input 
    //                 id="${id}_is_main_${type}"
    //                 type="radio"
    //                 class="checkbox radio${textCapitalize}Default"
    //                 name="${name}[is_main_${type}]"
    //             />
    //         </td>`);

    //     defaultBillingContainer.each(function (i) {
    //         let childRemoveUndo = $(this).find('.removeUndo');
    //         $(default_radio_button).insertBefore(childRemoveUndo)
    //     });

    // },
    switchRadioActive: (e, type) => {
        $('.radio' + type +'Default').prop('checked', false);
        e.target.checked = true;
    },
    activeDefaultRadioButton: () => {
        $('.radioEmailDefault, .radioAddressDefault').prop('checked', true);
    },
};

function do_refresh_project_billing_address() {
	if (typeof(og.income.refresh_project_billing_address) == 'function') {
		og.income.refresh_project_billing_address();
	}
}

og.invoices = {

    drawAddReference: function (genid, ref_data) {
        var line_number = $("#" + genid + "invoice_reference_list_div").children('.invoice_reference_line').length;
        //get template for the row
        var source = $("#invoice-new-reference-template").html();
        //compile the template
        var template = Handlebars.compile(source);

        var serie = '';
        var invoice_number = '';
        var detail = '';
        var referenced_object_id = '';
        if (ref_data != null) {
            serie = ref_data.serie;
            invoice_number = ref_data.invoice_number;
            detail = ref_data.detail;
            referenced_object_id = ref_data.referenced_object_id;
        }

        //template data
        var data = {
            line_number: line_number,
            serie: serie,
            invoice_number: invoice_number,
            detail: detail,
            referenced_object_id: referenced_object_id,
            genid: genid
        }

        //instantiate the template
        var html = template(data);

        //invoice_reference_list_div
        $("#" + genid + "invoice_reference_list_div").append(html);
    },
    removeReference: function (genid, line_number) {
        $("#" + genid + "_" + line_number + "_invoice_reference_line").hide();
        $("#" + genid + "_" + line_number + "_invoice_reference_deleted").val(1);
    },
    requestInvoiceDetails: function (el, object_id) {
        $('#' + el.id).removeClass('ico-expand').addClass('ico-collapse');
        el.setAttribute('onclick', 'og.invoices.collapseSubtable(this);');

        og.openLink(og.getUrl('invoice', 'get_details', {id: object_id}), {
            callback: function (success, data) {
                og.invoices.buildDetailsTable(el, data.details);
            }
        });
    },

    collapseSubtable: function (el) {
        $('#' + el.id).parent('.x-grid3-row-table').children('.invoices-subtable-row').hide();
        var table = $('#' + el.id).closest('.x-grid3-row-table').get(0);
        for (i = 0; i < table.rows.length; i++) {
            if (table.rows[i].className == 'invoices-subtable-row') table.rows[i].style.display = 'none';
        }

        $('#' + el.id).removeClass('ico-collapse').addClass('ico-expand');
        el.setAttribute('onclick', 'og.invoices.expandSubtable(this);');
    },

    expandSubtable: function (el) {
        $('#' + el.id).parent('.x-grid3-row-table').children('.invoices-subtable-row').hide();
        var table = $('#' + el.id).closest('.x-grid3-row-table').get(0);
        for (i = 0; i < table.rows.length; i++) {
            if (table.rows[i].className == 'invoices-subtable-row') table.rows[i].style.display = '';
        }

        $('#' + el.id).removeClass('ico-expand').addClass('ico-collapse');
        el.setAttribute('onclick', 'og.invoices.collapseSubtable(this);');
    },

    buildDetailsTable: function (el, details) {
        var column_model = Ext.getCmp('invoice-manager').getColumnModel();
        details = details.reverse();
        for (i = 0; i < details.length; i++) {
            var alt = i % 2 != 0;
            var html = og.invoices.buildDetailsTableRowHtml(details[i], alt, column_model);
            $('#' + el.id).closest('tr').after(html);
        }
    },

    buildDetailsTableRowHtml: function (line, alt, column_model) {
        var cell_class = ' invoices-subtable';
        if (alt) cell_class += ' alt';

        var row_html = '<tr class="invoices-subtable-row">';

        for (var i = 0; i < column_model.config.length; i++) {
            var col = column_model.config[i];
            if (col.hidden) {
                continue;
            }

            if (col.id == 'name') {
                row_html += '<td class="x-grid3-col x-grid3-cell' + cell_class + '"><div class="x-grid3-cell-inner">' + line.desc + '</div></td>';

            } else if (col.id == 'total') {
                row_html += '<td class="x-grid3-col x-grid3-cell' + cell_class + '"><div class="x-grid3-cell-inner" style="text-align:right;">' + line.total + '</div></td>';
            } else if (col.id == 'subtotal') {
                if (line.detail_type == 'line') {
                    row_html += '<td class="x-grid3-col x-grid3-cell' + cell_class + '"><div class="x-grid3-cell-inner" style="text-align:right;">' + (line.amount > 1 ? line.amount + ' x ' : '') + line.unit_value + '</div></td>';
                } else {
                    row_html += '<td class="x-grid3-col x-grid3-cell' + cell_class + '"></td>';
                }
            } else {
                if (col.id == 'checker' || col.id == 'draghandle' || col.id == 'expand' || col.id == 'icon' || col.id == 'isRead') {
                    row_html += '<td></td>';
                } else {
                    row_html += '<td class="x-grid3-col x-grid3-cell' + cell_class + '"></td>';
                }
            }

        }

        row_html += '</tr>';

        return row_html;
    },

    /**
     * Function to send the invoice via email recently created.
     * Is called by the form of add new invoice as a callback and received the data parameter
     * Or can be called by any place passed the invoice_id and leave the data as null
     * This gonna generate a modal with a prompt that can decide if you want to send the invoice via email
     * @param data
     * @param invoice_id
     */
    sendInvoiceNow: function (invoice_id,bill_to_email) {
        var url = null;
        if (invoice_id) {
            url = og.getUrl('invoice', 'send_invoice', {id: invoice_id});
        }
        if (url == null) {
            return false;
        }
        $.modal.close();
        var template = Handlebars.compile($("#send-invoice-right-now").html());
        var url_contacts = og.makeAjaxUrl(og.getUrl("invoice", "get_contacts_of_member_from_invoice", {invoice_id: invoice_id,company_data:true}));
        $.getJSON(url_contacts, function (data) {
            if(data.response.contacts && data.response.contacts.length==0){
                og.hideLoading();
                og.openLink(url);
                return false;
            }
            var template_data = {
                invoice_paid_link: url,
                contacts: []
            };
            var emails =[]; //to avoid repeated emails
            
            // only process the response if it is defined
            if (data.response.contacts) {
	            Object.keys(data.response.contacts).forEach(function(key) {
	                var current_data = data.response.contacts[key][0];
	                var current_email = "";
	                if(typeof current_data.email == 'string'){
	                    current_email = current_data.email;
	                }else{
	                    if (current_data.email != null){
	                        if(current_data.email.length>0){
	                            current_email = current_data.email[0].email;
	                        }
	                    }
	                }
	                if (current_email != "") {
	                    if ($.inArray(current_email, emails) == -1) {
	                        emails.push(current_email);
	                        template_data.contacts.push(
	                            {
	                                id: current_data.id,
	                                name: current_data.name,
	                                email_address: current_email,
	                                to_selected: ((current_email == bill_to_email) ? true : false)
	                            }
	                        );
	                    }
	                }
	            });
            }
            var html = template(template_data);
            var modal_params = {
                'escClose': false,
                'overlayClose': false,
                'minWidth': 600,
                'minHeight': 500,
                'closeHTML': '<a id="ogTasksPanelAT_close_link" class="modal-close modal-close-img"></a>'
            };
            setTimeout(function () {
                $.modal(html, modal_params);
                $("#print_new_invoice").unbind('click');
                $("#print_new_invoice").off('click');
                $("#print_new_invoice").on('click', function (ev) {
                    ev.preventDefault();
                    var params_to_mail = {
                        to: [],
                        cc: [],
                        bcc: []
                    }
                    $("[data-name=send_as]").each(function (index, value) {
                        var $this = $(value);
                        switch ($this.val()) {
                            case "to":
                                params_to_mail.to.push($("#email_address_" + $this.attr('data-value')).html());
                                break;
                            case "cc":
                                params_to_mail.cc.push($("#email_address_" + $this.attr('data-value')).html());
                                break;
                            case "bcc":
                                params_to_mail.bcc.push($("#email_address_" + $this.attr('data-value')).html());
                                break;
                        }
                    });
                    og.openLink($(this).attr("data-url") + "&" + $.param(params_to_mail));
                    ogTasks.closeModal();
                });


                $("#close_print_new_invoice").unbind('click');
                $("#close_print_new_invoice").off('click');
                $("#close_print_new_invoice").on('click', function (ev) {
                    $.modal.close();
                });
            }, 50);
        });
        
    }

};


App.modules.addInvoiceForm = {
    /*
   * Returned all checked user ids as a CSV string.
   * @param integer company_id Company ID
   */
    getCheckedUsers: function (genid) {
        var ids = '', ret = '';
        var orig_subs_input = document.getElementById(genid + "original_subscribers");
        if (orig_subs_input) {
            ids = orig_subs_input.value;
        }
        var notcomp = Ext.getDom(genid + 'notify_companies');
        if (notcomp) {
            var companies_divs = new Array();
            for (var i = 0; i < notcomp.childNodes.length; i++) {
                if (notcomp.childNodes[i].id) {
                    companies_divs.push(notcomp.childNodes[i]);
                }
            }
            for (var x = 0; x < companies_divs.length; x++) {
                var users_div = companies_divs[x];
                if (!users_div) {
                    return null;
                }
                var p = '';
                var usrs_div;
                for (var n = 0; n < users_div.childNodes.length; n++) {
                    if (users_div.childNodes[n].id) {
                        var pos = users_div.childNodes[n].id.length;
                        var t = users_div.childNodes[n].id.substring(pos - 13);
                        if (t == 'company_users') {
                            usrs_div = (users_div.childNodes[n]);
                        }
                    }
                }
                for (var d = 0; d < usrs_div.childNodes.length; d++) {
                    if (usrs_div.childNodes[d].id) {
                        var div_user = document.getElementById(usrs_div.childNodes[d].id);
                        var user = document.getElementById(usrs_div.childNodes[d].id.substr(3));
                        if (div_user.className == 'container-div checked-user') {
                            ret += (user.name.substring(17, user.name.length - 1)) + ', ';
                        }

                    }
                }
            }
            return ret;
        }
        return ids;
    },


    addLine: function (config, position=null, indexItem=null) {

        var genid = config.genid;

        var last_order=0;

        $( "#"+genid+"invoice_line tbody" ).children().each(function(index) {
            if($(this).find('input').first().val()>last_order){
                last_order=$(this).find('input').first().val();
            }
        })
        last_order++;

        var current_money = $("#" + genid + "invoiceCurrencyId").val();
        var id = config.id ? config.id : 0;
        var order = config.order ? config.order : last_order;
        var amount = config.amount ? config.amount : 1;
        var detail = config.detail ? config.detail : '';
        var user_id = config.user_id ? config.user_id : '';
        var user_name = config.user_name ? config.user_name : '';
        var line_date = config.date ? config.date : '';
        var unit_value = config.unit_value ? config.unit_value : 0;
        var cat_dim_id = config.cat_dim_id ? config.cat_dim_id : 0;
        var cat_mem_id = config.cat_mem_id ? config.cat_mem_id : 0;
        var main_dim_id = config.main_dim_id ? config.main_dim_id : 0;
        var main_mem_id = config.main_mem_id ? config.main_mem_id : 0;
        var main_mem_name = config.main_mem_name ? config.main_mem_name : 0;
        var from_object_type_id = config.from_object_type_id ? config.from_object_type_id : 0;
        var product_type_id = config.product_type_id ? config.product_type_id : 0;
        var unit_cost = config.unit_cost ? config.unit_cost : 0;
        var price_multiplier = config.price_multiplier ? config.price_multiplier : 0;
        var total = config.total ? config.total : 0;
        var subtotal = config.subtotal ? config.subtotal : 0;
        var taxes = config.taxes ? config.taxes : 0;
        var taxes_info = config.taxes_info ? config.taxes_info : {};
        var currency = config.currency ? config.currency : current_money;
        var exchange_rate = config.exchange_rate ? config.exchange_rate : 1;
        var show_ex_rate_column = true;
        var labor_dimension_id_default = config.labor_dimension_id ? config.labor_dimension_id : 0;
        var productService_dim_id_default = config.productService_dim_id ? config.productService_dim_id : 0;
        var discount_percent_value = config.discount_percent_value ? config.discount_percent_value : 0;
        var discount_percent_type = config.discount_percent_type ? config.discount_percent_type : 0;
        
        var html = '';
        if (typeof(detail) == 'string') {
            var detail_lines = detail.split('%|%');
            var detail_str = "";
            for (var i = 0; i < detail_lines.length; i++) {
                detail_str += (detail_str == "" ? "" : "\n") + detail_lines[i];
            }
        } else {
            detail_str = '';
        }

        var currency_sel_html = $("#" + genid + "_currency_selector_template").html();
        currency_sel_html = currency_sel_html.replace(/{i}/g, COUNT_LINE);

        var ex_rate_input_html = '';
        if (show_ex_rate_column) {
            var line_style = '';
            if (exchange_rate == 1) line_style = "display:none;";
            ex_rate_input_html = '<div id="exchange_rate" style="text-align:right;' + line_style + '">' + lang('e. rate') + '&nbsp;';
            ex_rate_input_html += '<input type="text" value="' + exchange_rate + '" name="invoice_lines[' + COUNT_LINE + '][exchange_rate]" class="price" id="rate">';
            ex_rate_input_html += '</div>';
        }

        var allow_multiline_line_desc = $("#" + genid + "allow_multiline_line_desc").val();

        html += '<tr id="' + genid + 'invoice_line' + COUNT_LINE + '" class="invoice-line-tr td_line'+order+'" data-count="'+COUNT_LINE+'">';
        html += `<td class="order handle" id="order_${order}">
            <div class="img-grid-drag" style="height:26px!important;background-repeat: repeat-x; margin-right: 44px;" title="${lang('click to drag')}" ></div>
            <div class="btnContainer">
                <button class="btnBFLine row-line-tab-before" data-count="${COUNT_LINE}" type="button" onclick="App.modules.addInvoiceForm.insertRow(event, \'${genid}\', \'before\')">+</button>
                <button class="btnBFLine row-line-tab-after" data-count="${COUNT_LINE}" type="button" onclick="App.modules.addInvoiceForm.insertRow(event, \'${genid}\', \'after\')">+</button>
            </div>
        </td>`;
        html += '<input type="hidden" step="any" value="' + order + '" name="invoice_lines[' + COUNT_LINE + '][order]" class="amount orderColumn"  >';//onchange="App.modules.addInvoiceForm.updateTotalLine(\'' + genid + '\', ' + COUNT_LINE + ', true);" html += '<td class="invoice-line-td"><input type="number" step="any" value="' + order + '" name="invoice_lines[' + COUNT_LINE + '][order]" class="amount orderColumn"  ></td>';//onchange="App.modules.addInvoiceForm.updateTotalLine(\'' + genid + '\', ' + COUNT_LINE + ', true);"
        /*Type of line*/
        html += '<td class="invoice-line-td">';
        html +='<select style="width:auto!important" name="invoice_lines[' + COUNT_LINE + '][item_type_id]" id="'+genid+'line-type-id'+COUNT_LINE+'" onchange="App.modules.addInvoiceForm.onChangeLineType('+"'"+genid+"','"+COUNT_LINE+"','"+productService_dim_id_default+"','"+labor_dimension_id_default+"'"+')">';//expense_dimension_id_default, labor_dimension_id_default
        html +='<option value="1">'+lang('product/service')+'</option>';
        html +='<option value="2">'+lang('labor')+'</option>';
        html +='<option value="3">'+lang('discount - fixed amount')+'</option>';
        html +='<option value="4">'+lang('discount - % of other lines')+'</option>';
        html +='<option value="5">'+lang('information labor')+'</option>';
        html +='<option value="6">'+lang('information product')+'</option>';
		html +='</select>';
        html +='</td>'
        
        /*category*/
        html += '<td class="invoice-line-td line-category"><div id="'+ genid +"-"+ COUNT_LINE + "_category_selector"+'" class="ext-container  line-category_value'+COUNT_LINE+'"></div></td>';
        /*Product service*/
        let pt_options='';
        html += '<td class="invoice-line-td">';
        html += '<select name="invoice_lines[' + COUNT_LINE + '][product_type_id]" class="product_type_selector add_invoice_product_type_selector productService_value'+COUNT_LINE+'" type="text" onchange="App.modules.addInvoiceForm.setOnchangeProductService('+"'"+genid+"'"+','+COUNT_LINE+',this.value)">' + pt_options + '</select>';
        html += '</td>';
        /*Quantity*/
        html += '<td class="invoice-line-td"><input type="number" step="any" value="' + amount + '" name="invoice_lines[' + COUNT_LINE + '][amount]" class="amount line-quantity_value'+COUNT_LINE+'" onkeyup="App.modules.addInvoiceForm.updateTotalLine(\'' + genid + '\', ' + COUNT_LINE + ', true);" onblurr="App.modules.addInvoiceForm.updateTotalLine(\'' + genid + '\', ' + COUNT_LINE + ', true, event);" onchange="App.modules.addInvoiceForm.updateTotalLine(\'' + genid + '\', ' + COUNT_LINE + ', true, event);"></td>';
        /*user*/
        html += '<td class="invoice-line-td line-user"><div id="'+ genid + "user_id_combo_container_" + COUNT_LINE +'" class="ext-container line-user_value'+COUNT_LINE+'"></div></td>';
        /*Date*/
        html += '<td class="invoice-line-td line-date"><div id="'+ genid + "line_date_container_" + COUNT_LINE +'" class="ext-container line-date_value'+COUNT_LINE+'"></div></td>';
        /*detail*/
        html += '<td class="invoice-line-td line-detail'+COUNT_LINE+'"  style="display:;">';
        if (allow_multiline_line_desc == "1") {
            html += '<textarea name="invoice_lines[' + COUNT_LINE + '][detail]" class="detail detailLargeText detailValueInvoice line-detail_value'+COUNT_LINE+'" onkeyup="App.modules.addInvoiceForm.onChangeTextAreaDetailInvoices(event)">' + detail_str + '</textarea>';
        } else {
            html += '<input type="text" name="invoice_lines[' + COUNT_LINE + '][detail]" class="detail line-detail_value'+COUNT_LINE+'" value="' + detail_str + '"/>';
        }
        html += '</td>';
        /*unit value*/
        html += '<td class="invoice-line-td invoice_unit_v">' + currency_sel_html + ' <input type="number" value="' + unit_value + '" name="invoice_lines[' + COUNT_LINE + '][unit_value]" class="price total unitValueTabkey line-unit-value_value'+COUNT_LINE+'" onkeyup="App.modules.addInvoiceForm.updateTotalLine(\'' + genid + '\', ' + COUNT_LINE + ', true,event)" onblur="App.modules.addInvoiceForm.updateTotalLine(\'' + genid + '\', ' + COUNT_LINE + ', true,event)">' + ex_rate_input_html + '</td>';

        
        
        //html += '<div id="'+ genid + "line_discount_type_container_" + COUNT_LINE +'" class="ext-container line-discount-type_value'+COUNT_LINE+'">disc </div></td>';

        /*amount type (fixed amount, % of other lines)*/
        //html += '<td class="invoice-line-td line-amount-type'+COUNT_LINE+'" style="display:"><div id="'+ genid + "line_amount_type" + COUNT_LINE +'" class="ext-container line-amount-type_value'+COUNT_LINE+'">am </div></td>';
        
        /*applies to (All lines, Line above)*/
        html += '<td class="invoice-line-td line-applies-to'+COUNT_LINE+'" style="display:">';
        html +='<select name="invoice_lines[' + COUNT_LINE + '][discount_percent_type]"  id="'+genid+'line_applies_to'+COUNT_LINE+'" class="ext-container line-applies-to_value'+COUNT_LINE+'" onblur="App.modules.addInvoiceForm.updatePercentageDiscount(\'' + genid + '\', ' + COUNT_LINE + ')" onkeyup="App.modules.addInvoiceForm.updatePercentageDiscount(\'' + genid + '\', ' + COUNT_LINE + ')" onchange="App.modules.addInvoiceForm.updatePercentageDiscount(\'' + genid + '\', ' + COUNT_LINE + ')">';
        html +='<option value="2">'+lang('line above')+'</option>';
        html +='<option value="1">'+lang('all lines')+'</option>';
		html +='</select>';
        /*Discount type*/
        html += '<td class="invoice-line-td line-amount-type'+COUNT_LINE+'" style="display:">';
        html += '<input type="text" value="' + discount_percent_value + '" name="invoice_lines[' + COUNT_LINE + '][discount_percent_value]" class="price line-amount-type_value'+COUNT_LINE+'" onchange="App.modules.addInvoiceForm.updatePercentageDiscount(\'' + genid + '\', ' + COUNT_LINE + ')"></td>'; //onkeydown="App.modules.addInvoiceForm.onTabkeypress(event)" onchange="App.modules.addInvoiceForm.updateTotalLine(\'' + genid + '\', ' + COUNT_LINE + ', true);">' + ex_rate_input_html +
                       
        //related object id input (time or expense)
        html += '<input type="hidden" value="' + config.rel_object_id + '" name="invoice_lines[' + COUNT_LINE + '][rel_object_id]">';
        html += '<input type="hidden" value="' + config.from_object_type_id + '" name="invoice_lines[' + COUNT_LINE + '][from_object_type_id]" id="invoice_lines' + COUNT_LINE + 'from_object_type_id">';
        html += '<input type="hidden" value="' + config.product_type_id + '" name="invoice_lines[' + COUNT_LINE + '][product_type_id]">';
        html += '<input type="hidden" value="' + config.unit_cost + '" name="invoice_lines[' + COUNT_LINE + '][unit_cost]">';
        html += '<input type="hidden" value="' + config.price_multiplier + '" name="invoice_lines[' + COUNT_LINE + '][price_multiplier]">';
        html += '<input type="hidden" value="' + config.main_mem_id + '" name="invoice_lines[' + COUNT_LINE + '][member_id]">';
        
        
        
        
        /*subtotal*/var subtotal_style = og.income.use_line_taxes ? '' : 'display:none;';
        html += '<td class="invoice-line-td" style="'+subtotal_style+'"><input type="text" value="' + subtotal + '" name="invoice_lines[' + COUNT_LINE + '][subtotal]" class="price subtotal" disabled="disabled"></td>';

        if (og.income.use_line_taxes) {
        	
        	for (var x = 0; x < og.income.taxes.length; x++) {
        		var tax = og.income.taxes[x];
        		var line_tax = taxes_info[tax.id];
        		
        		var tax_checked = config.unit_value ? false : tax.is_default > 0;
        		if (typeof(line_tax) == 'undefined') {
        			line_tax = {applied_value: tax.value, value: 0};
        		} else {
        			tax_checked = line_tax.value > 0;
        		}
        		
        		html += '<td class="invoice-line-td tax">' +
        			'<input type="hidden" value="' + tax.id + '" name="invoice_lines[' + COUNT_LINE + '][taxes]['+x+'][id]">' +
        			'<input type="hidden" value="' + line_tax.applied_value + '" name="invoice_lines[' + COUNT_LINE + '][taxes]['+x+'][applied_value]">' +
        			'<input type="text" value="' + line_tax.value + '" name="invoice_lines[' + COUNT_LINE + '][taxes]['+x+'][value]" class="price tax-'+tax.id+'" disabled="disabled">' +
        			'<input type="checkbox" '+(tax_checked ? 'checked="checked"' : '')+' name="invoice_lines[' + COUNT_LINE + '][taxes]['+x+'][applied]" '+
        				'style="margin: 7px 3px;" onclick="App.modules.addInvoiceForm.recalculateInvoiceLineTax(\'' + genid + '\','+COUNT_LINE+','+x+')">' +
        			'</td>';
        	}
        	
        }
        /*total*/
        html += '<td class="invoice-line-td"><input type="text" value="' + total + '" name="invoice_lines[' + COUNT_LINE + '][total]" class="price total line-total_value'+COUNT_LINE+'" disabled="disabled" onkeydown="App.modules.addInvoiceForm.onTabkeypress(event,'+COUNT_LINE+')"></td>';
        /*delete*/
        html += '<td class="invoice-line-td"><div class="clico ico-delete" onclick="App.modules.addInvoiceForm.deleteLine(\'' + genid + '\', ' + COUNT_LINE + ')"></td>';
        html += '</tr>';

        if(position != null && indexItem != null){

            let element = document.querySelector("#" + genid + "invoice_line"+indexItem)
            let parentDiv = element.parentNode;
            let el = document.createElement('tr');
            el.setAttribute("id", genid + 'invoice_line' + COUNT_LINE);
            el.setAttribute("class", 'invoice-line-tr td_line'+order);
            el.setAttribute("data-count", COUNT_LINE);
            el.innerHTML = html;
            
            parentDiv.insertBefore(el, position == 'before' ? element : element.nextSibling);

        }else{
            $("#" + genid + "invoice_line").append(html);
        }

        var options = $("#" + genid + "_currency_selector_" + COUNT_LINE)[0].options;
        if (currency && parseInt(currency) > 0) {
            for (var x = 0; x < options.length; x++) {
                if (options[x].value == parseInt(currency)) {
                    options[x].setAttribute('selected', 'selected');
                    break;
                }
            }
        }
        if (options.length == 1) {
            $("#" + genid + "_currency_selector_" + COUNT_LINE).attr("disabled", "disabled");
        }

        //render the user selector
        og.renderContactSelector({
    		genid: genid,
    		id: genid + '_contact_selector_' + COUNT_LINE,
    		name: 'invoice_lines[' + COUNT_LINE + '][user_id]',
    		render_to: "user_id_combo_container_" + COUNT_LINE,
    		listWidth: 150,
    		width: 150,
    		filters: { is_user: 1 },
            cp_type:'user',
    		selected: user_id,
    		selected_name: user_name,
    		is_multiple: false,
    		empty_text: lang('select user'),
    		remove_text: ' '
    	});
        $("#" + genid + "user_id_combo_container_" + COUNT_LINE +" input.assigned-to-combo").first().css('width','141px');
        
        //render the date selector
        var dateInput = new og.DateField({
			renderTo: genid + "line_date_container_" + COUNT_LINE,
			id: genid + "line_date_" + COUNT_LINE,
			width: 85,
			emptyText: og.preferences.date_format_tip,
			name: 'invoice_lines[' + COUNT_LINE + '][date]',
		});
		if (line_date) dateInput.setValue(line_date);
		$("#" + genid + "line_date_" + COUNT_LINE).css('width','76px');
       //$("#" + genid + "line_date_" + COUNT_LINE).addClass('verfDateString');

		
		//render category selector
		/*if (cat_dim_id && cat_dim_id > 0) 
        {
			var sel_mem_ids = [];
			if (cat_mem_id)
            {
             sel_mem_ids.push(cat_mem_id);
            }
            
			var selector_genid = genid +'-'+ COUNT_LINE.toString();
           // id="'+ genid +"-"+ COUNT_LINE + "_category_selector"+'"
			var cat_selector_config = {
					genid: selector_genid,
					context: og.contextManager.plainContext(),
					dim_id: cat_dim_id,
					//is_multiple: false,
					hide_label: true,
					hf_name: 'invoice_lines[' + COUNT_LINE + '][category_id]',
					selected_member_ids: sel_mem_ids,
					select_current_context: false,
					container_id: selector_genid + '_category_selector'
			};
			
			og.openLink(og.getUrl('dimension', 'render_member_selector', cat_selector_config), {
				preventPanelLoad: true,
				hideLoading: true,
				callback: function(success, data) {
					if (success) {
						$("#" + data.container_id).html(data.current.data);
						
						Ext.getCmp(data.genid+"-member-chooser-panel-"+data.dim_id+"-tree").setWidth(200);
						$("#" + data.genid +'-member-selectors-panel--container').css('width', '200px');
						$("#" + data.genid +'-member-selectors-panel--container .dimension-selector-container div').first().css('width', '200px');
						$("#" + data.genid +'-member-selectors-panel--container .dimension-selector-container .x-column-inner').first().css('width', '200px');
						
						var lines_width = $(".add-invoice-lines").outerWidth();
					    $(".add-invoice-totals").width(lines_width);
					}
				}
			});
        }*/

        let objectTypeProduct_ot = og.get_object_type_by_name('payment_receipt')?og.get_object_type_by_name('payment_receipt'):'';////product
        let objectTypeLabor_ot =og.get_object_type_by_name('timeslot')?og.get_object_type_by_name('timeslot'):'';////labor 
        
        if(config.item_type_id==1)
        {
            App.modules.addInvoiceForm.settype1( genid, COUNT_LINE, config.product_type_id, productService_dim_id_default, cat_mem_id,objectTypeProduct_ot['id']);   
        }else if(config.item_type_id==2)
        {
            App.modules.addInvoiceForm.settype2( genid, COUNT_LINE,  labor_dimension_id_default, cat_mem_id, objectTypeLabor_ot['id'] );
        }else if(config.item_type_id==3)
        {
            App.modules.addInvoiceForm.settype3( genid, COUNT_LINE );
        }else if(config.item_type_id==4)
        {
            App.modules.addInvoiceForm.settype4( genid, COUNT_LINE);
            $("#"+genid+"line_applies_to"+COUNT_LINE+" option[value='"+discount_percent_type+"']").attr('selected', 'selected');
            
        }else if(config.item_type_id==5)
        {
            App.modules.addInvoiceForm.settype5( genid, COUNT_LINE );
        }else if(config.item_type_id==6)
        {
            App.modules.addInvoiceForm.settype6( genid, COUNT_LINE );
        }else
        {    //////////////////para compatibilidad anteriores
            
            
            if(from_object_type_id==objectTypeProduct_ot['id']) //is product/service 
            {
                App.modules.addInvoiceForm.settype1( genid, COUNT_LINE, config.product_type_id, cat_dim_id, cat_mem_id,objectTypeProduct_ot['id'] );
            }
            else if(from_object_type_id==objectTypeLabor_ot['id'])// is labor
            {
                App.modules.addInvoiceForm.settype2( genid, COUNT_LINE, cat_dim_id, cat_mem_id);
            }
            else{//is new line
                App.modules.addInvoiceForm.settype1( genid, COUNT_LINE, config.product_type_id, cat_dim_id, cat_mem_id, objectTypeLabor_ot['id'] );
            }
        }


        COUNT_LINE++;

        var table_rows = $("#" + genid + "invoice_line tr.invoice-line-tr");
        for (var i = 0; i < table_rows.length; i++) {
            if (i % 2 == 0) $(table_rows[i]).addClass('alt');
            else $(table_rows[i]).removeClass('alt');
        }
        App.modules.addInvoiceForm.showHideLineTableColumns();
        App.modules.addInvoiceForm.onSetAutoHeightTextArea();

        //=> AUTOFOCUS ::
        // if (COUNT_LINE > 2) {
        //     const inputForFocus = document.querySelectorAll(".autofocus, .invoice-line-tr");
        //     const timeSleep = () => {
        //         inputForFocus[inputForFocus.length - 1].focus();
        //     }
        //     setTimeout(timeSleep, 300);
        // }
    },
    
    recalculateInvoiceLineTax: function(genid, line, tax_pos) {
    	var el_id_prefix = "#" + genid + "invoice_line" + line + " input[name='invoice_lines[" + line + "]";
    
    	var line_tax_value = 0;
    
    	var applied = $(el_id_prefix + "[taxes]["+tax_pos+"][applied]']").attr('checked') == 'checked';
        if (applied) {
        	var subtotal = $(el_id_prefix + "[subtotal]']").val();
        	var tax_id = $(el_id_prefix + "[taxes]["+tax_pos+"][id]']").val();
        	var val_to_apply = $(el_id_prefix + "[taxes]["+tax_pos+"][applied_value]']").val();
        	
        	var tax_def = null;
        	for (var x = 0; x < og.income.taxes.length; x++) {
        		if (og.income.taxes[x].id == tax_id) {
        			tax_def = og.income.taxes[x];
        			break;
        		}
        	}
        	
        	if (tax_def != null) {
        		if (tax_def.type == 'percentage') {
        			line_tax_value = subtotal * (val_to_apply / 100);
        		} else {
        			line_tax_value = val_to_apply;
        		}
        	}
        	line_tax_value = parseFloat(line_tax_value).toFixed(2);
        }
        
    	$(el_id_prefix + "[taxes]["+tax_pos+"][value]']").val(line_tax_value);
        
        App.modules.addInvoiceForm.updateTotalLine(genid, line, false);
        
    },
    
    showHideLineTableColumns: function() {

        /*setTimeout(function() {
	        var lines_width = $(".add-invoice-lines").outerWidth();
	        $(".add-invoice-totals").width(lines_width);
        }, 50);*/
        
    },

    onChangeLineType: function(genid, count_line ,productService_dim_id_default,labor_dimension_id_default)
    {
        let lineTypeId=$( "#"+genid+"line-type-id"+count_line+" option:selected" ).val();
        let objectTypeProduct_ot = og.get_object_type_by_name('payment_receipt')?og.get_object_type_by_name('payment_receipt'):'';////product
        let objectTypeLabor_ot =og.get_object_type_by_name('timeslot')?og.get_object_type_by_name('timeslot'):'';////labor 
        
        if(lineTypeId==1)
        {
           App.modules.addInvoiceForm.settype1(genid, count_line,'', productService_dim_id_default,'',objectTypeProduct_ot['id']);
        }
        else if(lineTypeId==2)
        {
            App.modules.addInvoiceForm.settype2(genid, count_line,labor_dimension_id_default,'',objectTypeLabor_ot['id'] );
        }
        else if(lineTypeId==3)
        {
            App.modules.addInvoiceForm.settype3(genid, count_line);
        }
        else if(lineTypeId==4)
        {
            App.modules.addInvoiceForm.settype4(genid, count_line);
        }
        else if(lineTypeId==5)
        {
            App.modules.addInvoiceForm.settype5(genid, count_line);
        }
        else if(lineTypeId==6)
        {
            App.modules.addInvoiceForm.settype6(genid, count_line);
        }

        $(".line-unit-value_value"+count_line).val(0);
        App.modules.addInvoiceForm.updateTotalLine(genid , count_line, true);
    },

    setcategoryRender: function(genid, count_line, dim_id,cat_mem_id=0, enableLabor=false, enabledProduct=false) 
    {
        var sel_mem_ids = [];
           
        if(cat_mem_id>0)
        {
             sel_mem_ids.push(cat_mem_id);
        }
        let typeSelected=$("#"+genid+"line-type-id"+count_line+" option:selected" ).val();

        if(typeSelected==1)//product
        {
            dim_id=og.income.productService_dim_id;
        }else if(typeSelected==2)//labor
        {
            dim_id=og.income.labor_dimension_id;
        }

        var selector_genid = genid +'-'+ count_line.toString();

        // use simple member selector for categories
		og.render_plain_member_selector({
			dim_id: dim_id,
			hf_name: 'invoice_lines[' + count_line + '][category_id]',
			container: selector_genid+ '_category_selector',
			genid: selector_genid,
			sel_id: cat_mem_id,
            class_add: 'category_width',
		});

        if(enableLabor)
	    {
            $('#'+selector_genid+"member_selector_"+dim_id).on('change',function(){
            var billingDefinitions = og.income.billingDefinitionsHourlyRates;
            var res=billingDefinitions.find(({member_id})=>member_id==this.value);
            App.modules.addInvoiceForm.setHourlyRate(genid,count_line,res['hourly_rate']);
            });
	    }

        if(enabledProduct)
        {
            $('#'+selector_genid+"member_selector_"+dim_id).on('change',function(){
                App.modules.addInvoiceForm.setProductType(genid, count_line, '',this.value);
            });
        }

       
      //  var lines_width = $(".add-invoice-lines").outerWidth();
       //      $(".add-invoice-totals").width(lines_width);

         /* var cat_selector_config = {
                   genid: selector_genid,
                   context: og.contextManager.plainContext(),
                   dim_id: dim_id,
                  // is_multiple: false,
                   hide_label: true,
                   hf_name: 'invoice_lines[' + count_line + '][category_id]',
                   selected_member_ids: sel_mem_ids,
                   select_current_context: false,
                   container_id: selector_genid+ '_category_selector'
           };

           og.openLink(og.getUrl('dimension', 'render_member_selector', cat_selector_config), {
               preventPanelLoad: true,
               hideLoading: true,
               callback: function(success, data) {
                   
                   if (success) {
                       $("#" + data.container_id).html(data.current.data);
                       Ext.getCmp(data.genid+"-member-chooser-panel-"+data.dim_id+"-tree").setWidth(200);
                       $("#" + data.genid +'-member-selectors-panel--container').css('width', '200px');
                       $("#" + data.genid +'-member-selectors-panel--container .dimension-selector-container div').first().css('width', '200px');
                       $("#" + data.genid +'-member-selectors-panel--container .dimension-selector-container .x-column-inner').first().css('width', '200px');
                       
                       var lines_width = $(".add-invoice-lines").outerWidth();
                       $(".add-invoice-totals").width(lines_width);
                   }
               }
           });*/
    },

    settype1:function( genid, count_line, product_type_id_selected='',cat_dim_id, cat_mem_id,objectTypeProduct_id)
    {
        $(".line-date_value"+count_line).show();
        $(".productService_value"+count_line).show();
        $(".line-quantity_value"+count_line).show();
        $(".line-category_value"+count_line).show();
        $(".line-detail_value"+count_line).show();
        $(".line-unit-value_value"+count_line).show();
        $(".line-total_value"+count_line).show();
        $(".line-user_value"+count_line).hide();
        $(".line-amount-type_value"+count_line).hide();
        $(".line-applies-to_value"+count_line).hide();
        $("#" + genid + "_currency_selector_" + count_line).show();
        
        App.modules.addInvoiceForm.setTypeDefault(genid, count_line, 1);
        App.modules.addInvoiceForm.setProductType(genid, count_line, product_type_id_selected);
        App.modules.addInvoiceForm.setcategoryRender(genid, count_line, cat_dim_id, cat_mem_id, false, true);
        App.modules.addInvoiceForm.setfrom_object_type_id(genid, count_line, objectTypeProduct_id);
        var lines_width = $(".add-invoice-lines").outerWidth();
        if(lines_width>2)
        {
         $(".add-invoice-totals").width(lines_width);
        }
    },

    settype2:function( genid, count_line,cat_dim_id, cat_mem_id, objectTypeLabor_id)
    {
        $(".line-date_value"+count_line).show();
        $(".productService_value"+count_line).hide();
        $(".line-quantity_value"+count_line).show();
        $(".line-user_value"+count_line).show();
        $(".line-category_value"+count_line).show();
        $(".line-detail_value"+count_line).show();
        $(".line-unit-value_value"+count_line).show();
        $(".line-total_value"+count_line).show();
        $(".line-amount-type_value"+count_line).hide();
        $(".line-applies-to_value"+count_line).hide();
        $("#" + genid + "_currency_selector_" + count_line).show();

        App.modules.addInvoiceForm.setTypeDefault(genid, count_line, 2);
        App.modules.addInvoiceForm.setcategoryRender(genid, count_line, cat_dim_id, cat_mem_id);
        App.modules.addInvoiceForm.setfrom_object_type_id(genid, count_line, objectTypeLabor_id);
        var lines_width = $(".add-invoice-lines").outerWidth();
        if(lines_width>2)
        {
         $(".add-invoice-totals").width(lines_width);
        }
    },

    settype3:function( genid, count_line)
    {

        $(".line-amount-type_value"+count_line).hide();
        $(".line-applies-to_value"+count_line).hide();
        $(".line-detail_value"+count_line).show();
        $(".line-unit-value_value"+count_line).show();
        $(".line-total_value"+count_line).show();
        $('.productService_value'+count_line).html('');
        $(".productService_value"+count_line).hide();
        $(".line-date_value"+count_line).hide();
        $(".line-quantity_value"+count_line).hide();
        $(".line-category_value"+count_line).hide();
        $(".line-user_value"+count_line).hide();
        $("#" + genid + "_currency_selector_" + count_line).show();

        App.modules.addInvoiceForm.setTypeDefault(genid, count_line, 3);

        //try to get above type line
        let prev_count_line= count_line-1;
        let objectTypeid = $('#invoice_lines' +prev_count_line + 'from_object_type_id').val();
        
        objectTypeid = objectTypeid ? objectTypeid : 0;
        App.modules.addInvoiceForm.setfrom_object_type_id(genid, count_line, objectTypeid);

        var lines_width = $(".add-invoice-lines").outerWidth();
        if(lines_width>2)
        {
         $(".add-invoice-totals").width(lines_width);
        }
    },

    settype4:function( genid, count_line)
    {
        $(".line-amount-type_value"+count_line).show();
        $(".line-applies-to_value"+count_line).show();
        $(".line-detail_value"+count_line).show();
        $(".line-unit-value_value"+count_line).hide();
        $(".line-total_value"+count_line).show();
        $('.productService_value'+count_line).html('');
        $(".productService_value"+count_line).hide();
        $(".line-date_value"+count_line).hide();
        $(".line-quantity_value"+count_line).hide();
        $(".line-category_value"+count_line).hide();
        $(".line-user_value"+count_line).hide();
        $("#" + genid + "_currency_selector_" + count_line).hide();

        App.modules.addInvoiceForm.setTypeDefault(genid, count_line, 4);
        
        let prev_count_line= count_line-1;
        let objectTypeid = $('#invoice_lines' +prev_count_line + 'from_object_type_id').val();
        
        objectTypeid = objectTypeid ? objectTypeid : 0;
        App.modules.addInvoiceForm.setfrom_object_type_id(genid, count_line, objectTypeid);

        var lines_width = $(".add-invoice-lines").outerWidth();
        if(lines_width>2)
        {
         $(".add-invoice-totals").width(lines_width);
        }
    },

    //set type to information labor 
    settype5:function( genid, count_line) //information labor
    {
        $(".line-detail_value"+count_line).show();
        $(".line-date_value"+count_line).hide();
        $(".line-quantity_value"+count_line).hide();
        $(".line-category_value"+count_line).hide();
        $(".line-unit-value_value"+count_line).hide();
        $(".line-total_value"+count_line).hide();
        $(".line-user_value"+count_line).hide();
        $(".line-amount-type_value"+count_line).hide();
        $(".line-applies-to_value"+count_line).hide();
        $('.productService_value'+count_line).html('');
        $(".productService_value"+count_line).hide();
        $("#" + genid + "_currency_selector_" + count_line).hide();

        App.modules.addInvoiceForm.setTypeDefault(genid, count_line, 5);

        //set object type to labor
        let objectTypeid =og.get_object_type_by_name('timeslot')?og.get_object_type_by_name('timeslot'):'';
        App.modules.addInvoiceForm.setfrom_object_type_id(genid, count_line, objectTypeid['id']);

        var lines_width = $(".add-invoice-lines").outerWidth();
        if(lines_width>2)
        {
         $(".add-invoice-totals").width(lines_width);
        }
    },

    //set type to information product
    settype6:function( genid, count_line) 
    {
        $(".line-detail_value"+count_line).show();
        $(".line-date_value"+count_line).hide();
        $(".line-quantity_value"+count_line).hide();
        $(".line-category_value"+count_line).hide();
        $(".line-unit-value_value"+count_line).hide();
        $(".line-total_value"+count_line).hide();
        $(".line-user_value"+count_line).hide();
        $(".line-amount-type_value"+count_line).hide();
        $(".line-applies-to_value"+count_line).hide();
        $('.productService_value'+count_line).html('');
        $(".productService_value"+count_line).hide();
        $("#" + genid + "_currency_selector_" + count_line).hide();

        App.modules.addInvoiceForm.setTypeDefault(genid, count_line, 6);

        //set object type to product/type
        let objectTypeid = og.get_object_type_by_name('payment_receipt')?og.get_object_type_by_name('payment_receipt'):'';
        App.modules.addInvoiceForm.setfrom_object_type_id(genid, count_line, objectTypeid['id']);

        var lines_width = $(".add-invoice-lines").outerWidth();
        if(lines_width>2)
        {
         $(".add-invoice-totals").width(lines_width);
        }
    },

    setfrom_object_type_id(genid, count_line, object_type_id)
    {
        $('#invoice_lines' + count_line + 'from_object_type_id').val(object_type_id);
    },
    
    setTypeDefault:function(genid,count_line,lineTypeId)
    {
        $("#"+genid+"line-type-id"+count_line+" option[value="+lineTypeId+"]").attr('selected', 'selected');
    },
    
    setOnchangeProductService: function(genid, count_line, productId)
    {
        var product_types = og.expenses2.product_types;
        var res=product_types.find(({id})=>id==productId);
        
        App.modules.addInvoiceForm.setHourlyRate(genid,count_line,res['hourly_rate']);
        App.modules.addInvoiceForm.setCategoryRenderFromProductType( genid, count_line);
    },

    setProductType:function( genid, count_line, product_type_id_selected='', cat_mem_id='')
    {
        var pt_options = '<option value=""></option>';
        var product_types = og.expenses2.product_types;
        
        members_aux=Ext.util.JSON.decode($("#"+genid+"members").val());
        members_aux.push(cat_mem_id);
        member_aux_d=Ext.util.JSON.encode(members_aux);

        if(cat_mem_id!='')
        {
            og.openLink(og.getUrl('product_type', 'get_filtered_product_types', {member_ids: member_aux_d}), {//$("#"+genid+"members").val()
                callback: function(success, data) {
                    
                    $('.productService_value'+count_line).find("option").remove();

                    if (data.product_types)
                    {
                        product_types=data.product_types;
                    }
                
                    for (i=0; i<product_types.length; i++) {
                        var c = product_types[i];
                        var sel = product_type_id_selected == c.id ? 'selected="selected"' : '';
                        pt_options += '<option '+sel+' hourly_rate="'+c.hourly_rate+'" value="'+ c.id +'">'+ c.name +'</option>';
                    }
                    $('.productService_value'+count_line).append(pt_options);
                }
            });
        }else{
            for (i=0; i<product_types.length; i++) {
                var c = product_types[i];
                var sel = product_type_id_selected == c.id ? 'selected="selected"' : '';
                pt_options += '<option '+sel+' hourly_rate="'+c.hourly_rate+'" value="'+ c.id +'">'+ c.name +'</option>';
            }
            $('.productService_value'+count_line).append(pt_options);
        }
    },

    setCategoryRenderFromProductType:function( genid, count_line)
    {
        let product_type_id=$( ".productService_value"+count_line+" option:selected" ).val();
        var product_types = og.expenses2.product_types;
        var res=product_types.find(({id})=>id==product_type_id);
        var cat_mem_id = res['members'][og.income.productService_dim_id];
        if(cat_mem_id!=undefined)
        {
            App.modules.addInvoiceForm.setcategoryRender(genid, count_line, og.income.productService_dim_id, cat_mem_id, false, true);
        }
    },

    setHourlyRate:function( genid, count_line, value)
    {
        $(".line-unit-value_value"+count_line).val(value);
        $(".line-unit-value_value"+count_line).prop( "disabled", false);
        App.modules.addInvoiceForm.updateTotalLine(genid, count_line, false);
    },

    deleteLine: function (genid, line) {
        $("#" + genid + "invoice_line" + line).remove();

        var table_rows = $("#" + genid + "invoice_line tr.invoice-line-tr");
        for (var i = 0; i < table_rows.length; i++) {
            if (i % 2 == 0) $(table_rows[i]).addClass('alt');
            else $(table_rows[i]).removeClass('alt');
        }
        
        App.modules.addInvoiceForm.recalculateTotalsBox(genid);
    },
    updatePercentageDiscount: function (genid, line) {


        // Change associated with invoice lines before and after ::
        let itemChild = $( "#"+genid+"line_applies_to"+line);
        let prevVerification = itemChild.parent().parent().prev().attr('data-count');
        var newLine = prevVerification !== undefined ? prevVerification : 0;

        //---->>> Old functionality ::
        var percentageValue = parseFloat($(".line-amount-type_value" + line).val());
        let lineTypeDiscount=$( "#"+genid+"line_applies_to"+line+" option:selected" ).val();

        if(lineTypeDiscount==2)
        {
            let prev_count_line = newLine;
            let objectTypeid = $('#invoice_lines' +prev_count_line + 'from_object_type_id').val();
            objectTypeid = objectTypeid ? objectTypeid : 0;
            App.modules.addInvoiceForm.setfrom_object_type_id(genid, line, objectTypeid);
        }else{
            App.modules.addInvoiceForm.setfrom_object_type_id(genid, line, 0);
        }

        var unit_val=0;
        let total=0;
        let preline=0;

        if(lineTypeDiscount=='2'){
            preline = newLine;
            unit_val = $("#" + genid + "invoice_line" + preline + " input[name='invoice_lines[" + preline + "][total]']").val();
            total = (unit_val*percentageValue/100)*-1;
            $("#" + genid + "invoice_line" + line + " input[name='invoice_lines[" + line + "][unit_value]']").val(total)
            App.modules.addInvoiceForm.updateTotalLine(genid, line, false);
        }else{
            $("#" + genid + "invoice_line" + line + " input[name='invoice_lines[" + line + "][unit_value]']").val(0)
            App.modules.addInvoiceForm.updateTotalLine(genid, line, false);
            unit_val=$('.invoice-total').html();
            total = (unit_val*percentageValue/100)*-1;
            $("#" + genid + "invoice_line" + line + " input[name='invoice_lines[" + line + "][unit_value]']").val(total)
            App.modules.addInvoiceForm.updateTotalLine(genid, line, false);
        }
    },
    updateTotalLine: function (genid, line, recalculate_taxes, event=undefined) {
        if(event!=undefined)
        {
            var charCode = (event.which) ? event.which : event.keyCode;
        }else{
            charCode=undefined;
        }
        //alert('charCode'+charCode)
        if ((charCode >= 48 && charCode <= 57) || (charCode >= 96 && charCode <= 105) || (charCode== undefined)) {

            let lineTypeId=$( "#"+genid+"line-type-id"+line+" option:selected" ).val();
            var amount = $("#" + genid + "invoice_line" + line + " input[name='invoice_lines[" + line + "][amount]']").val();
            var unit_val = $("#" + genid + "invoice_line" + line + " input[name='invoice_lines[" + line + "][unit_value]']").val();
            var ex_rate = $('input[name="invoice_lines['+line+'][exchange_rate]"]').val();


            if(lineTypeId==3 || lineTypeId==4)
            {
                ////amount=Math.abs(amount)*-1;
                //unit_val=Math.abs(unit_val)*-1;
                ////$("#" + genid + "invoice_line" + line + " input[name='invoice_lines[" + line + "][amount]']").val(amount);
                
                if(!unit_val.includes("-")){
                    unit_val = '-'+unit_val;
                }
                
                $("#" + genid + "invoice_line" + line + " input[name='invoice_lines[" + line + "][unit_value]']").val(unit_val);
            }
            
            if(lineTypeId==3 || lineTypeId==4)
            {
                subtotal=Math.abs(subtotal)*-1;
            }

            var subtotal = ex_rate * (unit_val * amount);
            var total = subtotal;

            $("#" + genid + "invoice_line" + line + " input[name='invoice_lines[" + line + "][subtotal]']").val(subtotal.toFixed(2));
            
            if (og.income.use_line_taxes && recalculate_taxes) {
                for (var x = 0; x < og.income.taxes.length; x++) {
                    App.modules.addInvoiceForm.recalculateInvoiceLineTax(genid, line, x);
                }
            }
            
            if (og.income.use_line_taxes) {
                for (var x = 0; x < og.income.taxes.length; x++) {
                    var tax_amount = $("#" + genid + "invoice_line" + line + " input[name='invoice_lines[" + line + "][taxes]["+x+"][value]").val();
                    total += parseFloat(tax_amount);
                }
            }
            $("#" + genid + "invoice_line" + line + " input[name='invoice_lines[" + line + "][total]']").val(total.toFixed(2));
            
            App.modules.addInvoiceForm.recalculateTotalsBox(genid);
        }
    },
    
    recalculateTotalsBox: function(genid) {
    	var grand_subtotal = 0;
    	$("#" + genid + "invoice_line .price.subtotal").each(function() {
    		grand_subtotal += Number($(this).val());
    	});
    	$("#" + genid + "invoice_totals .invoice-subtotal").html(grand_subtotal.toFixed(2));
    	
    	var total_in_taxes = 0;
    	for (var x = 0; x < og.income.taxes.length; x++) {
    		var tax_total = 0;
    		var taxid = og.income.taxes[x].id;
    		if (og.income.use_line_taxes) {
				$("#" + genid + "invoice_line .price.tax-"+taxid).each(function() {
	    			tax_total += Number($(this).val());
	    		});
	    		if (tax_total > 0) {
	    			$("#" + genid + "invoice_totals .invoice-tax-"+taxid).closest('tr').show();
	    		} else {
	    			$("#" + genid + "invoice_totals .invoice-tax-"+taxid).closest('tr').hide();
	    		}
	    	} else {
	    		if ($("#" + genid + "_tax_"+taxid).val() > 0) {
	    			tax_total = og.income.taxes[x].type == 'percentage' ? grand_subtotal * (og.income.taxes[x].value / 100) : og.income.taxes[x].value;
	    			$("#" + genid + "invoice_totals .invoice-tax-"+taxid).closest('tr').show();
	    		} else {
	    			$("#" + genid + "invoice_totals .invoice-tax-"+taxid).closest('tr').hide();
	    		}
	    	}
    		$("#" + genid + "invoice_totals .invoice-tax-"+taxid).html(tax_total.toFixed(2));
    		total_in_taxes += tax_total;
    	}
    	
    	var grand_total = 0;
    	
        grand_total = grand_subtotal + total_in_taxes;
        
    	$("#" + genid + "invoice_totals .invoice-total").html(grand_total.toFixed(2));
    	
    	if (grand_total == grand_subtotal) {
    		$("#" + genid + "invoice_totals .invoice-subtotal").closest('tr').hide();
    	} else {
    		$("#" + genid + "invoice_totals .invoice-subtotal").closest('tr').show();
    	}
    },

    contacts_bill_to:null,

	updateClientData: function (genid, update_current_data) {

		if (this.timeout) clearTimeout(this.timeout);

		this.update_cli_data_genid = genid;
		this.update_cli_data_update_current_data = update_current_data;

		this.timeout = setTimeout(function() {
			App.modules.addInvoiceForm.doUpdateClientData(App.modules.addInvoiceForm.update_cli_data_genid, App.modules.addInvoiceForm.update_cli_data_update_current_data);
		}, 2000);
	},

    doUpdateClientData: function (genid, update_current_data) {
        var members = "";
        
        // check if there are clients selected before processing the variables
        var clients_selected = member_selector[genid].sel_context[og.customers.dimension_id];
        if (clients_selected && clients_selected.length > 0) {
        	clients_selected.sort(function(a, b){return b-a});
        	members += clients_selected.join(',');
    	}
    	var projects_selected = member_selector[genid].sel_context[og.projects.dimension_id];
        if (projects_selected && projects_selected.length > 0) {
        	projects_selected.sort(function(a, b){return b-a});
        	members += (members == "" ? "" : ",") + projects_selected.join(',');
    	}
        
        $("#bill_to_list").html("");
        if (update_current_data) {
        	$("[data-clean-bill-to]").val("");
        }
        if (members != "") {

            var invoice_id = $("#" + genid + "invoice_id").val();
            
            var url = og.makeAjaxUrl(og.getUrl("member", "get_contacts_of_member", {customer_id: members, company_data:true, invoice_id:invoice_id}));
            og.loading();
            $.getJSON(url, function (data) {
                if(!data.response.contacts || data.response.contacts.length == 0){
                    og.hideLoading();
                    $("#bill_to_list").hide();
                    return false;
                }

				var company_key = data.response.contacts['Billing Company'] && data.response.contacts['Billing Company'].length > 0 ? 'Billing Company' : 'Company';

				var customer = data.response.contacts[company_key] ? data.response.contacts[company_key][0] : null;
                if (customer && update_current_data && customer.status) {
                	if (customer.name) $('#' + genid + 'invoiceFormCustomerName').val(customer.name);
                	if (customer.number) $('#' + genid + 'invoiceFormCustomerNumber').val(customer.number);
                	if (customer.rut) $('#' + genid + 'invoiceFormCustomerRut').val(customer.rut);
					if (customer.phone && customer.phone.length > 0) $('#' + genid + 'invoiceFormCustomerPhone').val(customer.phone[0].number);
                }

                var radio_selected = false;
                App.modules.addInvoiceForm.contacts_bill_to = data.response.contacts;
                var template = Handlebars.compile($("#bill_to_option").html());
                Object.keys(data.response.contacts).forEach(function(key) {
                
                  for (var j=0; j<data.response.contacts[key].length; j++) {
                    var current_data = data.response.contacts[key][j];
                    var data_template = {
                        'type': j==0 ? key : '',
                        'code':current_data.code,
                        'name':current_data.name,
                        'address':((current_data.address.length>0)?current_data.address[0].parsed:""),
                        'json_data': JSON.stringify(current_data)
                    }
                    $("#bill_to_list").show();
                    if (key == 'Billing Company') {
                    	//$("#bill_to_list").prepend(template(data_template));
                    } else if (key == 'Company') {
                        current_data.code='company';
                        data_template = {
                            'type': j==0 ? key : '',
                            'code':current_data.code,
                            'name':current_data.name,
                            'address':((current_data.address.length>0)?current_data.address[0].parsed:""),
                            'json_data': JSON.stringify(current_data)
                        }
                    	$("#bill_to_list").prepend(template(data_template));
                    } else {
                    	$("#bill_to_list").append(template(data_template));
                            let boxContact='<div class="billingContactItem">'
                            boxContact+='<div class="attnAndCheck">'
                            boxContact+='<div>'
                            //boxContact+='<span class="labelData">Attn:</span>'
                            boxContact+='<h5 class="fs-13">'+data_template.name+'</h5>'
                            boxContact+='</div>'
                            boxContact+='<input type="checkbox" name="billing_contact_selected" id="billing_contact_selected'+data_template.code+'" />'
                            boxContact+='</div>'
                            boxContact+='<div>'
                            boxContact+='<p class="billingContactItemAddress">'+data_template.street+'</p>'
                            boxContact+='<p class="billingContactItemAddress">'+data_template.city+'</p>'
                            boxContact+='<p class="billingContactItemAddress">'+data_template.zipcode+' '+data_template.country+'</p>'
    //                                boxContact+='</p>'
                            boxContact+='</div>'
                            boxContact+='<div>'
                            boxContact+='<p class="fs-12">'+data_template.email+'</p>'
                            //boxContact+='testing@correo.com'
                            //boxContact+='</p>'
                            boxContact+='</div>'
                            boxContact+='</div>'

                        $('#billingContactsContainer').append(boxContact);
                    }

                    
                    if (!update_current_data && !radio_selected) {
                    	if (current_data.id == $('#' + genid + 'ordered_by_id').val()) {
                    		$("#bill_to_list #bill_to_" + current_data.code).attr('checked', 'checked');
                    		radio_selected = true;
                            //document.getElementById("billing_contact_selected"+data_template.code).checked = true;
                    	}
                        if (!radio_selected 
                             && (current_data.email && current_data.email.length>0 && current_data.email[0].email == $('#' + genid + 'invoiceFormCustomerEmail').val() || current_data.email  && current_data.email == $('#' + genid + 'invoiceFormCustomerEmail').val())
                             && current_data.name && current_data.name == $('#' + genid + 'invoiceFormAttn').val()) 
                        {
                    		$("#bill_to_list #bill_to_" + current_data.code).attr('checked', 'checked');
                    		radio_selected = true;
                            //document.getElementById("billing_contact_selected"+data_template.code).checked = true;
                    	}
                    }
                  }
                });
                var data_template_custom = {
                    'type': 'Other',
                    'code':'custom',
                    'name':'custom',
                    'address':'',
                    'json_data': ''
                }
                $("#bill_to_list").append(template(data_template_custom));
               
                $("#bill_to_custom").attr('disabled',true);
                if(!radio_selected)
                {
                    $("#bill_to_list #bill_to_" + 'custom').attr('checked', 'checked');
                }
                   

                $("#bill_to_list").append('<div id="'+genid+'member_billing_render_to" class=""></div>');

                $("[data-contact-bill-to]").off('click');
                $("[data-contact-bill-to]").unbind('click');
                $(".billing_contact_selected").click(function() {
                })

                $("[data-contact-bill-to]").on('click',function(){

                    var data = JSON.parse($(this).attr("data-json"));

                    //If it's clicked the same contact, don't update the information inputs
                    if(data.id!=$('#'+genid+'ordered_by_id').val())
                    {
                        $("[data-clean-bill-to]").val("");
                        
                        if(data.id>0 && data.id!=null)
                        {
                            $('#' + genid + 'ordered_by_id').val(data.id);
                        }
                        
                        if(data.name.length>0 &&data.name !=null)
                        {
                            $('#' + genid + 'invoiceFormAttn').val(data.name);
                            if(data.code=='company')
                            {
                                $('#' + genid + 'invoiceFormCustomerName').val(data.name);
                            }
                        }
                        
                        if(data.address.length>0){
                            $('#' + genid + 'invoiceFormCustomerAddress').val(data.address[0].street);
                            $('#' + genid + 'invoiceFormCustomerCity').val(data.address[0].city);
                            $('#' + genid + 'invoiceFormCustomerState').val(data.address[0].state);
                            $('#' + genid + 'invoiceFormCustomerCountry').val(data.address[0].country);
                            $('#' + genid + 'invoiceFormCustomerZipcode').val(data.address[0].zipcode);
                            
                        }
                        if(data.email!=null){
                            if(typeof data.email == 'string'){
                                $('#' + genid + 'invoiceFormCustomerEmail').val(data.email);
                            }else{
                                if(data.email.length>0) {
                                    $('#' + genid + 'invoiceFormCustomerEmail').val(data.email[0].email);
                                }
                            }
                        }
                        if(data.phone != null && data.phone.length>0){
                            $('#' + genid + 'invoiceFormCustomerPhone').val(data.phone[0].number);
                        }


                        $('#'+genid+'members_render_to').find('.ico-delete').parent().remove();
                        og.showContactCombo(genid+genid+'members_render_tocombo');

                        $('#'+genid+'members_render_to_contact_billing').find('.ico-delete').parent().remove();
                        og.showContactCombo(genid+genid+'members_render_tocombo');
                    }
                });

                if (update_current_data) {
                	if ($("#bill_to_list #bill_to_billing_contact").length > 0) {
                		$("#bill_to_list #bill_to_billing_contact").click();
                	} else {
                		$("[data-contact-bill-to]:first").click();
                	}
                }
                

                ////billing contact
               /* $("#billing_contact_compl").append('<div id="'+genid+'members_render_to_contact_billing" class=""></div>');
                og.bootstrap_helper.renderContactCombo({
                    genid: genid,
                    id: genid+'members_render_to_contact_billing',
                    name: 'member_billing_info',
                    render_to: "members_render_to_contact_billing",
                    listWidth: 480,
                    selected: '',
                    selected_name: '',
                    cp_type:'contact',
                    empty_text: lang('select contact'),
                    memberId:members,
                    filters: {is_user: 1,member_ids:members},
                    onchange_fn: function(person_id) {
                        $('#contact_billing_preview').html('Elizabeth Hill');
                        App.modules.addInvoiceForm.onChangeMemberFromSelector(genid,person_id,members);//onChangeMemberFromSelector
                    },
                });*/

               /* $("#bill_to_list").append('<div style="margin-bottom:1rem;"><h4>'+lang('other_contacts')+'</h4><div id="'+genid+'members_render_to" class=""></div></div>');
                og.bootstrap_helper.renderContactCombo({
                    genid: genid,
                    id: genid+'members_render_to',
                    name: 'member_billing_info',
                    render_to: "members_render_to",
                    listWidth: 480,
                    selected: '',
                    selected_name: '',
                    cp_type:'contact',
                    empty_text: lang('select contact'),
                    memberId:members,
                    filters: {is_user: 0,member_ids:members},
                    onchange_fn: function(person_id) {
                        App.modules.addInvoiceForm.onChangeMemberFromSelector(genid,person_id,members);//onChangeMemberFromSelector
                    },
                });*/

                og.hideLoading();
            });
        }
    },


    onInvoiceCurrencyChange: function (genid) {
        var selectors = $("#" + genid + "add_invoice_data_div .invline_currency_selector");
        for (var i = 0; i < selectors.length; i++) {
            var selid = $(selectors[i]).attr('id');
            var line = selid.substring(selid.lastIndexOf("_") + 1);

            App.modules.addInvoiceForm.onLineCurrencyChange(genid, line, selectors[i])
        }

        if (og.on_invoice_currency_change_additional_fn && og.on_invoice_currency_change_additional_fn.length > 0) {
            for (var j = 0; j < og.on_invoice_currency_change_additional_fn.length; j++) {
                var fn = og.on_invoice_currency_change_additional_fn[j];
                if (typeof(fn) == 'function') {
                    fn.call(null, genid);
                }
            }
        }
    },

    onLineCurrencyChange: function (genid, line, select) {
        var from = $(select).val();
        var to = $("#" + genid + "invoiceCurrencyId").val();

        if (to != from) {

            $("#" + genid + "invoice_line" + line + " #exchange_rate").show();

            // set new rate
            var new_ex_rate = 1;
            for (var i = 0; i < og.exchange_rates_info.length; i++) {
                var er = og.exchange_rates_info[i];
                if (parseInt(er.source_currency_id) == from && parseInt(er.destiny_currency_id) == to) {
                    new_ex_rate = parseFloat(er.rate);
                    break;
                } else if (parseInt(er.source_currency_id) == to && parseInt(er.destiny_currency_id) == from) {
                    new_ex_rate = 1 / parseFloat(er.rate);
                    break;
                }
            }
            $("#" + genid + "invoice_line" + line + " #exchange_rate #rate").attr('value', new_ex_rate);
            var el_id_prefix = "#" + genid + "invoice_line" + line + " input[name='invoice_lines[" + line + "]";
            unitValue = $('.line-unit-value_value'+line).val();
            updateSubtotal = parseFloat(unitValue * new_ex_rate);
        	$(el_id_prefix + "[subtotal]']").val(updateSubtotal.toFixed(2));

        } else {

            $("#" + genid + "invoice_line" + line + " #exchange_rate").hide();
            $("#" + genid + "invoice_line" + line + " #exchange_rate #rate").attr('value', 1);
        }

        App.modules.addInvoiceForm.updateTotalLine(genid, line, true);
    },

    onFinalConsumerChange: function (genid) {

        var is_final_consumer = $("#" + genid + "c_f").attr("checked") == "checked";

        var rut_label = is_final_consumer ? lang("customer document") : lang("customer rut");
        var req = $("#" + genid + "customer_rut_label span.label_required");

        $("#" + genid + "customer_rut_label").html(rut_label);

        if (req && req.length > 0) $("#" + genid + "customer_rut_label").append(":&nbsp;").append(req[0]);

    },

    
    onChangeMemberFromSelector: function (genid,contact_id,customer_id) {
        $('#bill_to_list input').prop('checked', false);

        // ajax request to set responsible
        og.openLink(og.getUrl('invoice', 'get_contact_billing_info'), {
            post: {
                contact_id: contact_id,
                member_id: customer_id,
            },
            callback:function(success,data){
                if (success){
                    $("[data-clean-bill-to]").val("");
                    var contact = data.contact;
                    if(contact.address != ""){
                        $('#' + genid + 'invoiceFormCustomerAddress').val(contact.address[0].street);
                        $('#' + genid + 'invoiceFormCustomerCity').val(contact.address[0].city);
                        $('#' + genid + 'invoiceFormCustomerState').val(contact.address[0].state);
                        $('#' + genid + 'invoiceFormCustomerCountry').val(contact.address[0].country);
                        $('#' + genid + 'invoiceFormCustomerZipcode').val(contact.address[0].zipcode);
                    }
                    if(contact.email!=null){
                        if(typeof contact.email == 'string'){
                            $('#' + genid + 'invoiceFormCustomerEmail').val(contact.email);
                        }else{
                            if(contact.email.length>0) {
                                $('#' + genid + 'invoiceFormCustomerEmail').val(contact.email[0].email);
                            }
                        }
                    }
                    if(contact.phone != null && contact.phone.length>0){
                        $('#' + genid + 'invoiceFormCustomerPhone').val(contact.phone[0].number);
                    }
                }
            }
        });


    },
    onSetAutoHeightTextArea: () => {

        $('textarea.detail').each(function (element) {
            setTimeout(() => {
                $(this).css('boxSizing', 'border-box')
                var offset = $(this)[0].offsetHeight - $(this)[0].clientHeight;
                $(this).css('minHeight', '24px')
                $(this).css('minHeight', $(this)[0].scrollHeight + offset + 'px')
            }, 300);
        });
    },
    onCalcHeight: (value) => {
        let numberOfLineBreaks = (value.match(/\n/g) || []).length;
        let newHeight = 10 + numberOfLineBreaks * 20 + 12 + 2;
        return newHeight;
    },
    onChangeTextAreaDetailInvoices: (event) => {
        event.target.style.boxSizing = 'border-box';
        var offset = event.target.offsetHeight - event.target.clientHeight;
        event.target.style.minHeight = '24px';
        event.target.style.minHeight = event.target.scrollHeight + offset + 'px';
    },
    onTabkeypress: (ev) => {
        if (ev.key == "Tab" || ev.key === "Enter") {
            let attrInput = document.querySelector('.genid-button'),
                uniValueElement = document.querySelectorAll(".unitValueTabkey"),
                detailValueelement = document.querySelectorAll(".detailValueInvoice"),
                unitValue = uniValueElement[uniValueElement.length - 1].value,
                detailValueInvoice = detailValueelement[detailValueelement.length - 1].value,
                genid = attrInput.getAttribute('data-genid'),
                containerTR = document.querySelector('.add-invoice-lines tbody'),
                parentContainer = containerTR,
                numIterator = containerTR.children.length - 1;

            if (detailValueInvoice == '' && unitValue == '0') {
                function timeSleep() {
                    for (let i = numIterator; i > 1; i--) {
                        let item = parentContainer.children[i];
                        item.getElementsByClassName("unitValueTabkey")
                        if (
                            item.getElementsByClassName("detailValueInvoice")[0].value == '' &&
                            item.getElementsByClassName("unitValueTabkey")[0].value == '0'
                        ) {
                            item.remove();
                        } else {
                            break;
                        }
                    }
                }

                setTimeout(timeSleep, 500);

                return;
            }

            App.modules.addInvoiceForm.addLine({ genid: genid, amount: '1',labor_dimension_id: og.income.labor_dimension_id, productService_dim_id: og.income.productService_dim_id, item_type_id:1, });///falta dimension
        }
    },
    resizeIframe: (obj) => {
        obj.style.height = obj.contentWindow.document.documentElement.scrollHeight + 'px'
        //obj.style.height = obj.contentWindow.document.body.scrollHeight + "px";
		obj.setAttribute("sandbox", "allow-scripts");
        App.modules.addInvoiceForm.atviveTabInvoiceView();
    },
    atviveTabInvoiceView: () => {
        const opacityDisable = document.querySelector(".opacityTemp");
        opacityDisable.style.display = 'none';
        opacityDisable.style.opacity = '1';
        // Tabs
        const tabBtns = document.querySelectorAll(".tabs__btn");
        const tabPanes = document.getElementsByClassName("tabs__pane");

        let fadeTime = 200;

        function fadeOut(target) {
            target.style.opacity = 1;
            target.style.transition = `opacity ${fadeTime}ms`;
            target.style.opacity = 0;
            setTimeout(() => {
                target.style.display = "none";
            }, fadeTime);
        }

        function fadeIn(target) {
            target.style.opacity = 0;
            target.style.transition = `opacity ${fadeTime}ms`;
            target.style.opacity = 1;
            setTimeout(() => {
                target.style.display = "block";
            }, fadeTime);
        }

        function triggerTab(elt) {
            elt.preventDefault();

            tabBtns.forEach((btn) => {
                btn.classList.remove("is-active");
                btn.setAttribute("aria-selected", false);
            });

            [].forEach.call(tabPanes, (pane) => {
                fadeOut(pane);
            });

            elt.target.classList.add("is-active");
            elt.target.setAttribute("aria-selected", true);
            let clickedTab = elt.target.dataset.tabTarget;
            fadeIn(document.querySelector(`#${clickedTab}`));
        }

        tabBtns.forEach((tab) => {
            tab.addEventListener("click", triggerTab);
        });

    },
    insertRow: (ev, id, position) => {
        let itemNumber = ev.target;
        let itemIndex = itemNumber.getAttribute('data-count');
        App.modules.addInvoiceForm.addLine({ genid: id, amount: '1',labor_dimension_id: og.income.labor_dimension_id, productService_dim_id: og.income.productService_dim_id, item_type_id:1, }, position, itemIndex);
    }
};



og.eventManager.addListener('get_all_associated_members_finish', function(data){
    if(typeof data.project_number != 'undefined' && data.project_number){
        var current_value = $('[name="object_custom_properties['+data.invoice_po_number_id+']"]').val();
        if(!current_value){
            $('[name="object_custom_properties['+data.invoice_po_number_id+']"]').val(data.project_number);
        }
    }
});
