<?php

function income_update_1_2()
{
    DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_taxes`
				 MODIFY COLUMN `removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
				 MODIFY COLUMN `removed_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;
		");
    DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_tax_records`
				 MODIFY COLUMN `removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
				 MODIFY COLUMN `removed_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;
		");
    DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoice_types`
				 MODIFY COLUMN `removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
				 MODIFY COLUMN `removed_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;
		");
    DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_copies`
				 MODIFY COLUMN `removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
				 MODIFY COLUMN `removed_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;
		");
    DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoice_notebooks`
				 MODIFY COLUMN `removed_on` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
				 MODIFY COLUMN `removed_by_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;
		");
}


function income_update_2_3()
{
    DB::executeAll("INSERT INTO " . TABLE_PREFIX . "max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
			 SELECT rtp.role_id, (SELECT `id` FROM `" . TABLE_PREFIX . "object_types` WHERE `name`='invoice'), can_delete, can_write
			 FROM " . TABLE_PREFIX . "max_role_object_type_permissions rtp WHERE rtp.object_type_id=(SELECT `id` FROM `" . TABLE_PREFIX . "object_types` WHERE `name`='task')
			ON DUPLICATE KEY UPDATE " . TABLE_PREFIX . "max_role_object_type_permissions.role_id=" . TABLE_PREFIX . "max_role_object_type_permissions.role_id;");
}

function income_update_3_4()
{
    DB::executeAll("
				DELETE FROM " . TABLE_PREFIX . "max_role_object_type_permissions 
				WHERE object_type_id IN (
					 SELECT o.id
					 FROM `" . TABLE_PREFIX . "object_types` o 
					 WHERE o.`name` IN ('invoice')				
				 );
		");
    DB::executeAll("
				 INSERT INTO " . TABLE_PREFIX . "max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
				 SELECT p.id, o.id, 1, 1
				 FROM `" . TABLE_PREFIX . "object_types` o JOIN `" . TABLE_PREFIX . "permission_groups` p
				 WHERE o.`name` IN ('invoice')
				 AND p.`name` IN ('Super Administrator','Administrator','Manager');
		");
    DB::executeAll("
				INSERT INTO " . TABLE_PREFIX . "max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
				 SELECT p.id, o.id, 0, 1
				 FROM `" . TABLE_PREFIX . "object_types` o JOIN `" . TABLE_PREFIX . "permission_groups` p
				 WHERE o.`name` IN ('invoice')
				 AND p.`name` IN ('Executive');
		");
    DB::executeAll("
				INSERT INTO " . TABLE_PREFIX . "max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
				 SELECT p.id, o.id, 0, 0
				 FROM `" . TABLE_PREFIX . "object_types` o JOIN `" . TABLE_PREFIX . "permission_groups` p
				 WHERE o.`name` IN ('invoice')
				 AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');
		");
    DB::executeAll("
				DELETE FROM " . TABLE_PREFIX . "role_object_type_permissions
				WHERE object_type_id IN (
					SELECT o.id
					FROM `" . TABLE_PREFIX . "object_types` o
					WHERE o.`name` IN ('invoice')
				);
		");
    DB::executeAll("
				INSERT INTO " . TABLE_PREFIX . "role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
				 SELECT p.id, o.id, 1, 1
				 FROM `" . TABLE_PREFIX . "object_types` o JOIN `" . TABLE_PREFIX . "permission_groups` p
				 WHERE o.`name` IN ('invoice')
				 AND p.`name` IN ('Super Administrator','Administrator');
		");
    DB::executeAll("
				INSERT INTO " . TABLE_PREFIX . "role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
				 SELECT p.id, o.id, 0, 1
				 FROM `" . TABLE_PREFIX . "object_types` o JOIN `" . TABLE_PREFIX . "permission_groups` p
				 WHERE o.`name` IN ('invoice')
				 AND p.`name` IN ('Manager','Executive');
		");

    DB::executeAll("
				UPDATE `" . TABLE_PREFIX . "max_system_permissions` SET `can_edit_confirmed_invoices`=0, `can_manage_invoicing_configuration`=0 WHERE `permission_group_id` IN (
					SELECT id FROM `" . TABLE_PREFIX . "permission_groups` WHERE `type`='roles' AND `name` IN ('Executive')
				);
		");


}


function income_update_4_5()
{

    if (Plugins::instance()->isActivePlugin('member_custom_properties')) {
        Env::useHelper('functions', 'crpm');

        // define custom properties for customers
        if (!check_member_custom_prop_exists(TABLE_PREFIX, 'company_id', 'customer')) {
            DB::execute("
					INSERT INTO " . TABLE_PREFIX . "member_custom_properties (object_type_id, name, code, `type`, `values`, `visible_by_default`) VALUES
					((SELECT id FROM " . TABLE_PREFIX . "object_types WHERE name='customer'), 'Company ID', 'company_id', 'text', '', 1),
					((SELECT id FROM " . TABLE_PREFIX . "object_types WHERE name='customer'), 'Legal name', 'legal_name', 'text', '', 1);
				");

            $id_rows = MemberCustomProperties::instance()->findAll(array('id' => true, 'conditions' => "object_type_id=(SELECT id FROM " . TABLE_PREFIX . "object_types WHERE name='customer') AND code='company_id'"));
            $ci_cp = array_var($id_rows, 0);
            $id_rows = MemberCustomProperties::instance()->findAll(array('id' => true, 'conditions' => "object_type_id=(SELECT id FROM " . TABLE_PREFIX . "object_types WHERE name='customer') AND code='legal_name'"));
            $ln_cp = array_var($id_rows, 0);

            $all_customers = Members::findAll(array('conditions' => "object_type_id=(SELECT id FROM " . TABLE_PREFIX . "object_types WHERE name='customer')"));
            foreach ($all_customers as $customer_member) {
                $member_id = $customer_member->getId();
                $customer_id = $customer_member->getObjectId();
                $c = Customers::findById($customer_id);
                if ($c instanceof Customer) {

                    if (trim($c->getCustomerRut()) != '') {
                        $sql = "INSERT INTO " . TABLE_PREFIX . "member_custom_property_values (member_id, custom_property_id, `value`) VALUES
							('$member_id', '$ci_cp', '" . trim($c->getCustomerRut()) . "');";

                        DB::execute($sql);
                    }

                    if (trim($c->getCustomerName()) != '') {
                        $sql = "INSERT INTO " . TABLE_PREFIX . "member_custom_property_values (member_id, custom_property_id, `value`) VALUES
							('$member_id', '$ln_cp', '" . trim($c->getCustomerName()) . "');";

                        DB::execute($sql);
                    }
                }
            }
        }
    }
}


function income_update_5_6()
{

    if (!check_column_exists(TABLE_PREFIX . "timeslots", "invoicing_status")) {
        DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "timeslots`
				 ADD COLUMN `invoicing_status` VARCHAR(50) NOT NULL DEFAULT 'pending',
 				 ADD COLUMN `invoice_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;
			");

        DB::execute("
				INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`) VALUES
					('generate_one_inv_line_per_timeslot', '0', 'BoolConfigHandler', 1)
				ON DUPLICATE KEY UPDATE name=name;
			");

        DB::execute("
				INSERT INTO `" . TABLE_PREFIX . "contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES 
				('task panel', 'tasksShowInvoicingStatus', '1', 'BoolConfigHandler', 1, 0, '');
			");
    }
}

function income_update_6_7()
{

    $p_controller = new PluginController();
    $p_controller->ensure_installed_and_activated('multiple_currencies');
    $p_controller->ensure_installed_and_activated('object_subtypes');

    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "currency_id")) {
        DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoices` ADD `currency_id` int(10) NOT NULL DEFAULT 0 AFTER `final_consumer`;
			");
        DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoice_lines` ADD `currency_id` int(10) NOT NULL DEFAULT 0 AFTER `object_id`;
			");
        DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoice_lines` ADD `exchange_rate` int(10) NOT NULL DEFAULT 1;
			");
        DB::execute("
				UPDATE `" . TABLE_PREFIX . "income_invoices` SET `currency_id`=(SELECT id FROM " . TABLE_PREFIX . "currencies LIMIT 1);
			");
        DB::execute("
				UPDATE `" . TABLE_PREFIX . "income_invoice_lines` SET `currency_id`=(SELECT id FROM " . TABLE_PREFIX . "currencies LIMIT 1);
			");
        DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoice_lines`
					CHANGE `unit_value` `unit_value` decimal(20,3) NOT NULL,
					CHANGE `total` `total` decimal(20,3) NOT NULL;
			");
        DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
					CHANGE `subtotal` `subtotal` decimal(20,3) NOT NULL,
					CHANGE `total` `total` decimal(20,3) NOT NULL;
			");
    }


    if (!check_column_exists(TABLE_PREFIX . "income_taxes", "code")) {
        DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_taxes`
				 ADD COLUMN `code` VARCHAR(255) COLLATE 'utf8_unicode_ci' NOT NULL;
			");
    }

    if (!check_column_exists(TABLE_PREFIX . "income_taxes", "is_special")) {
        DB::execute("
						ALTER TABLE `" . TABLE_PREFIX . "income_taxes`
						 ADD COLUMN `is_special` BOOLEAN NOT NULL DEFAULT 0;
					");
    }

    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "expiration_date")) {
        DB::execute("
						ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
						 ADD COLUMN `expiration_date` date NOT NULL;
					");
    }

    DB::execute("
				INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`) VALUES
				('owner_company_id', '', 'StringConfigHandler', 0)
				ON DUPLICATE KEY UPDATE name = name;
			");

    DB::execute("
				INSERT INTO `" . TABLE_PREFIX . "object_subtypes` (`object_type_id`, `name`, `sum_in_total`, `code`, `is_special`) VALUES
				((SELECT id FROM `" . TABLE_PREFIX . "object_types` WHERE name = 'invoice'),'invoice', 1, 'invoice', 1),
				((SELECT id FROM `" . TABLE_PREFIX . "object_types` WHERE name = 'invoice'),'credit note', 0, 'credit_note', 1)
				ON DUPLICATE KEY UPDATE name = name;
			");

    if (check_column_exists(TABLE_PREFIX . "income_invoices", "invoice_type_id")) {
        DB::execute("
						ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
						 DROP `invoice_type_id`;
					");
    }
    if (check_column_exists(TABLE_PREFIX . "income_invoices", "invoice_type")) {
        DB::execute("
						ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
						 DROP `invoice_type`;
					");
    }

    DB::execute("
			UPDATE " . TABLE_PREFIX . "objects 
			SET object_subtype_id=(SELECT id FROM " . TABLE_PREFIX . "object_subtypes WHERE code='invoice')
			WHERE object_type_id=(SELECT id FROM " . TABLE_PREFIX . "object_types WHERE name='invoice');
		");

    DB::execute("
			UPDATE " . TABLE_PREFIX . "income_invoice_notebooks
			SET invoice_type_id=(SELECT id FROM " . TABLE_PREFIX . "object_subtypes WHERE code='invoice');
		");

    DB::execute("
				CREATE TABLE IF NOT EXISTS `" . TABLE_PREFIX . "income_invoice_references` (
				`id` int(10) unsigned NOT NULL AUTO_INCREMENT,
				`object_id` int(10) unsigned NOT NULL,
				`serie` VARCHAR(100) NOT NULL,
				`invoice_number` int(10) unsigned NOT NULL,
				`referenced_object_id` int(10) unsigned NOT NULL,
				`detail` text COLLATE utf8_unicode_ci NOT NULL,
				PRIMARY KEY (`id`)
				) ENGINE=InnoDB;
		");
}


function income_update_7_8()
{
    DB::execute("
				INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`) VALUES
				('allow_multiline_line_desc', '0', 'BoolConfigHandler', 1);
		");
}


function income_update_8_9()
{

    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "customer_city")) {
        DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoices` 
				ADD COLUMN `customer_city` VARCHAR(100) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '' AFTER `customer_address`;
			");
    }

    DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`) VALUES
				('mandatory_customer_address', '0', 'BoolConfigHandler', 1),
				('mandatory_customer_city', '0', 'BoolConfigHandler', 1);
		");

    $pending_invoices = IncomeInvoices::findAll(array('conditions' => "`status`='pending'"));
    $cli_ot = ObjectTypes::findByName('customer')->getId();

    foreach ($pending_invoices as $inv) {
        if ($inv->getCustomerCity() == "") {
            $customer_member = null;
            $members = $inv->getMembers();
            foreach ($members as $m) {
                if ($m instanceof Member && $m->getObjectTypeId() == $cli_ot) {
                    $customer_member = $m;
                    break;
                }
            }
            if ($customer_member instanceof Member) {
                $customer = Customers::findById($customer_member->getObjectId());
                if ($customer instanceof Customer) {
                    $customer_city = "";
                    $contact = $customer->getContact();
                    if ($contact instanceof Contact) {
                        $address_obj = $contact->getAddress('work');
                        if ($address_obj instanceof ContactAddress) {
                            $customer_city = $address_obj->getCity();
                        }
                    }
                }
                if ($customer_city != "") {
                    $inv->setCustomerCity($customer_city);
                    $inv->save();
                }
            }
        }
    }
}


function income_update_9_10()
{
    DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`) VALUES
				('mandatory_customer_rut', '0', 'BoolConfigHandler', 1);
		");
}

function income_update_10_11()
{
    DB::execute("
                    INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`) VALUES
                    ('generate_next_invoice_repetition_on_print', '0', 'BoolConfigHandler', 1);
            ");

    DB::execute("
                    INSERT INTO `" . TABLE_PREFIX . "custom_properties` (`object_type_id`,`name`,`code`,`type`,`description`,`values`,`default_value`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`, `is_special`, `is_disabled`, `object_subtype_id`) VALUES
                    ((SELECT object_type_id FROM " . TABLE_PREFIX . "object_subtypes WHERE code='invoice'),'Payment Period','invoice_payment_period','list','','Due on receipt,Net D','',1,0,1,1, 1,0,(SELECT id FROM " . TABLE_PREFIX . "object_subtypes WHERE code='invoice'))
                    ON DUPLICATE KEY UPDATE object_type_id=object_type_id;
            ");
}

function income_update_11_12()
{
    DB::execute("
    		INSERT INTO `" . TABLE_PREFIX . "dimension_content_object_options` (`dimension_id`,`content_object_type_id`,`option`,`value`) 
				SELECT d.id, ot.id, 'hide_member_selector_in_forms', '0'
				FROM " . TABLE_PREFIX . "dimensions d LEFT JOIN " . TABLE_PREFIX . "object_types ot ON true
				WHERE ot.name IN ('invoice')
			ON DUPLICATE KEY UPDATE `value`=`value`;
    	");
}

function income_update_12_13()
{
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "invoice_preview_file_id")) {
        DB::execute("
	    		ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
				ADD `invoice_preview_file_id` int(10) unsigned NOT NULL DEFAULT 0;
	    	");
    }
    if (!check_column_exists(TABLE_PREFIX . "income_config_options", "options")) {
        DB::execute("
	    		ALTER TABLE `" . TABLE_PREFIX . "income_config_options`
				ADD `options` varchar(255) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '';
	    	");
    }
    DB::execute("
    		INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('enabled_invoices_status', 'printed', 'MultipleListConfigHandler', 1, 'printed');
    	");
    DB::execute("
    		INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('allow_invoice_flexible_status_change', '0', 'BoolConfigHandler', 1, '');
    	");
}

function income_update_13_14()
{
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "sent_invoice_mail_id")) {
        DB::execute("
	    		ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
				ADD `sent_invoice_mail_id` int(10) unsigned NOT NULL DEFAULT 0;
	    	");
    }
}

function income_update_14_15()
{

    DB::execute("
    		INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('mandatory_customer', '1', 'BoolConfigHandler', 1, '');
    	");
}

function income_update_15_16()
{
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "ordered_by_id")) {
        DB::execute("
	    		ALTER TABLE `" . TABLE_PREFIX . "income_invoices` 
	    		ADD `ordered_by_id` int(10) unsigned NOT NULL DEFAULT 0;
	    	");
    }
}

function income_update_16_17()
{
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "external_transaction_id")) {
        DB::execute("
	    		ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
			    ADD `payment_method` varchar(255) COLLATE 'utf8_unicode_ci' NOT NULL,
			    ADD `external_transaction_id` varchar(255) COLLATE 'utf8_unicode_ci' NOT NULL AFTER `payment_method`;
	    	");
    }
}

function income_update_17_18()
{
    DB::execute("INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
                ('invoice_payment_url', '', 'StringConfigHandler', 1, '')");
}

function income_update_18_19()
{
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "customer_state")) {
        DB::execute(
            "ALTER TABLE `" . TABLE_PREFIX . "income_invoices` 
	    		ADD `customer_state` varchar(100) COLLATE utf8_unicode_ci NOT NULL
	    		;"
        );
    }
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "customer_country")) {
        DB::execute(
            "ALTER TABLE `" . TABLE_PREFIX . "income_invoices` 
	    		ADD `customer_country` varchar(100) COLLATE utf8_unicode_ci NOT NULL
	    		;"
        );
    }
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "customer_zipcode")) {
        DB::execute(
            "ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
            ADD `customer_zipcode` varchar(100) COLLATE utf8_unicode_ci NOT NULL
	    		;"
        );
    }
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "customer_email")) {
        DB::execute(
            "ALTER TABLE `" . TABLE_PREFIX . "income_invoices` 
	    		ADD `customer_email` varchar(100) COLLATE utf8_unicode_ci NOT NULL
	    		;"
        );
    }
    if (!check_column_exists(TABLE_PREFIX . "income_invoices", "customer_phone")) {
        DB::execute(
            "ALTER TABLE `" . TABLE_PREFIX . "income_invoices` 
	    		ADD `customer_phone` varchar(100) COLLATE utf8_unicode_ci NOT NULL
	    		;"
        );
    }
    $result = DB::executeOne("
    	SELECT * FROM `" . TABLE_PREFIX . "custom_properties` 
    	WHERE name like 'Representative'
    	AND object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer')
    ");
    if(!is_null($result)){
        DB::execute("
        	UPDATE `" . TABLE_PREFIX . "custom_properties` set code = 'representative' WHERE id = '{$result['id']}';
        ");
    } else {
	    DB::execute("
	    	INSERT INTO `" . TABLE_PREFIX . "custom_properties` (`object_type_id`,`name`,`type`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`,`code`) VALUES 
	    	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer'),'Representative','contact',0,0,10,0,'representative');
	    ");
    }
}

function income_update_19_20()
{
	if (!check_column_exists(TABLE_PREFIX . "income_invoices", "external_transaction_desc")) {
		DB::execute("
	    		ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
			    ADD `external_transaction_desc` TEXT COLLATE 'utf8_unicode_ci' NOT NULL;
	    	");
	}
}


function income_update_20_21()
{
	Env::useHelper('functions', 'income');
	$printed_enabled = is_invoice_status_available("printed");
	$val = $printed_enabled ? "1" : "0";
	
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='assign_number_when_printing'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('assign_number_when_printing', '$val', 'BoolConfigHandler', 1, '');
	    ");
	}
}


function income_update_21_22()
{
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='send_invoice_default_mail_account'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('send_invoice_default_mail_account', '0', 'MailAccountConfigHandler', 1, '');
	    ");
	}
	
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='send_invoice_bcc'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('send_invoice_bcc', '', 'StringConfigHandler', 1, '');
	    ");
	}
}

function income_update_22_23() {
	// add column to indicate if invoice has been sent
	if (!check_column_exists(TABLE_PREFIX . "income_invoices", "sent")) {
		DB::execute("
    		ALTER TABLE `" . TABLE_PREFIX . "income_invoices`
			ADD `sent` tinyint(1) unsigned NOT NULL DEFAULT 0;
    	");
	}
	// remove sent status from invoices
	DB::execute("UPDATE " . TABLE_PREFIX . "income_invoices SET sent='1' WHERE status IN ('sent') OR sent_invoice_mail_id>0;");
	// remove sent status from invoices
	DB::execute("UPDATE " . TABLE_PREFIX . "income_invoices SET status='pending' WHERE status='sent';");
	
	// update config option
	DB::execute("
		UPDATE `" . TABLE_PREFIX . "income_config_options` SET `options`='printed'
		WHERE `name`='enabled_invoices_status';
	");
}

/**
 * Migrate payment_method, external_transaction_id and external_transaction_desc to custom properties
 */
function income_update_23_24() {
	// create custom properties
	DB::execute("
    	INSERT INTO `" . TABLE_PREFIX . "custom_properties` (`object_type_id`,`name`,`code`,`type`,`values`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`,`is_special`) VALUES
    	((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='invoice'), 'Payment type', 'payment_method', 'list', ',check,money_order,cash,credit_card,other', 0,0,10,1,1),
		((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='invoice'), 'Check/Mo/Other #', 'external_transaction_id', 'text', '',0,0,10,1,1),
		((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='invoice'), 'Comments on Payment type', 'external_transaction_desc', 'memo', '',0,0,10,1,1);
    ");
	
	// migrate payment_method
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."custom_property_values (`object_id`, `custom_property_id`, `value`)
		SELECT i.object_id,
			(SELECT id FROM ".TABLE_PREFIX."custom_properties WHERE code='payment_method' AND object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='invoice')),
			i.payment_method
		FROM ".TABLE_PREFIX."income_invoices i
		WHERE i.payment_method != '';
	");
	
	// migrate external_transaction_id
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."custom_property_values (`object_id`, `custom_property_id`, `value`)
		SELECT i.object_id,
			(SELECT id FROM ".TABLE_PREFIX."custom_properties WHERE code='external_transaction_id' AND object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='invoice')),
			i.external_transaction_id
		FROM ".TABLE_PREFIX."income_invoices i
		WHERE i.external_transaction_id != '';
	");
	
	// migrate external_transaction_desc
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."custom_property_values (`object_id`, `custom_property_id`, `value`)
		SELECT i.object_id,
			(SELECT id FROM ".TABLE_PREFIX."custom_properties WHERE code='external_transaction_desc' AND object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='invoice')),
			i.external_transaction_desc
		FROM ".TABLE_PREFIX."income_invoices i
		WHERE i.external_transaction_desc != '';
	");
	
	if (Plugins::instance()->isActivePlugin('advanced_core')) {
		Env::useHelper('functions', 'advanced_core');
		fill_property_groups_default_data();
	}
}


function income_update_24_25() {
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."income_invoices`
		CHANGE `sent` `sent` varchar(255) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '';
	");

	DB::execute("
		UPDATE `".TABLE_PREFIX."income_invoices` SET `sent`='invoice_sent' WHERE `sent`='1' AND status='pending';
	");
	
	DB::execute("
		UPDATE `".TABLE_PREFIX."income_invoices` SET `sent`='invoice_sent' WHERE `sent`='1' AND status='confirmed';
	");
	
	DB::execute("
		UPDATE `".TABLE_PREFIX."income_invoices` SET `sent`='void_sent' WHERE `sent`='1' AND status='canceled';
	");
	
	DB::execute("
		UPDATE `".TABLE_PREFIX."income_invoices` SET `sent`='no' WHERE `sent`='0' OR `sent`='';
	");
}

function income_update_25_26() {
	// refresh searchable objects for all invoices
	$invoices = IncomeInvoices::findAll();
	foreach ($invoices as $invoice) {
		/* $var $invoice IncomeInvoice */
		$invoice->addToSearchableObjects(true);
	}
}

function income_update_26_27() {
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='default_invoice_template_for_preview'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('default_invoice_template_for_preview', '1', 'BoolConfigHandler', 1, '');
	    ");
		// disable this option for affinity editions
		if (Plugins::instance()->isActivePlugin('event_tickets')) {
			DB::execute("
				UPDATE `" . TABLE_PREFIX . "income_config_options` SET `value`='0'
				WHERE `name`='default_invoice_template_for_preview';
			");
		}
	}
}


function income_update_27_28() {
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='generate_inv_line_detailed'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`) VALUES
				('generate_inv_line_detailed', '1', 'BoolConfigHandler', 1)
			ON DUPLICATE KEY UPDATE name=name;
		");
	}
}

function income_update_28_29() {
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='group_invoice_timeslots_by'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
				('group_invoice_timeslots_by', 'Task', 'ListConfigHandler', 1, ' { \"option\": [{ \"value\": \"Task\", \"text\": \"Task\" }, { \"value\": \"Timeslot\", \"text\": \"Timeslot\" }, { \"value\": \"Person\", \"text\": \"Person\" } ] }')
			ON DUPLICATE KEY UPDATE name=name;
		");
	}
	
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='generated_invoice_line_prefix_text'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
				('generated_invoice_line_prefix_text', '', 'StringConfigHandler', 1, '')
			ON DUPLICATE KEY UPDATE name=name;
		");
	}
}


function income_update_29_30() {
	// Add debit note subtype
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."object_subtypes` (`object_type_id`, `name`, `sum_in_total`, `code`, `is_special`) VALUES
			((SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'invoice'),'debit note', 0, 'debit_note', 1)
		ON DUPLICATE KEY UPDATE name = name;
	");
}

function income_update_30_31() {
	// Add income_invoice_templates table
	DB::execute("
		CREATE TABLE IF NOT EXISTS `" . TABLE_PREFIX . "income_invoice_templates` (
		`id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
		`name` VARCHAR(255) NULL,
		`is_default` TINYINT( 1 ) NOT NULL DEFAULT '0',
		`group_by` VARCHAR(100) NOT NULL DEFAULT '',
		`include_date` TINYINT( 1 ) NOT NULL DEFAULT '0',
		`include_user_name` TINYINT( 1 ) NOT NULL DEFAULT '0',
		`include_labor_category` TINYINT( 1 ) NOT NULL DEFAULT '0',
		`include_description` TINYINT( 1 ) NOT NULL DEFAULT '0'
		) ENGINE=InnoDB CHARSET=utf8;
	");

	// Add "invoice template" custom property to project
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."custom_properties` (`object_type_id`, `name`, `type`, `description`, `values`, `default_value`, `code`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `show_in_lists`, `is_special`) VALUES
			((SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'project'),'Invoice template', 'list', '', '', '', 'invoice_template', 0, 0, 10, 1, 1, 1),
			((SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'customer'),'Invoice template', 'list', '', '', '', 'invoice_template', 0, 0, 10, 1, 1, 1),
			((SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'invoice'),'Invoice template', 'list', '', '', '', 'invoice_template', 0, 0, 10, 1, 1, 1),
			((SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'invoice'),'Billing from', 'date', '', '', '', 'billing_period_from', 0, 0, 20, 1, 1, 1),
			((SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'invoice'),'Billing to', 'date', '', '', '', 'billing_period_to', 0, 0, 20, 1, 1, 1)
		ON DUPLICATE KEY UPDATE name = name;
	");
	
	// add more columns to invoice lines table
	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "rel_object_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `rel_object_id` int(10) NOT NULL DEFAULT '0'
			");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "category_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `category_id` int(10) NOT NULL DEFAULT '0'
			");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "user_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `user_id` int(10) NOT NULL DEFAULT '0'
			");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "date")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `date` DATE NOT NULL
			");
	}
}

function income_update_31_32() {
	DB::execute("
		UPDATE ".TABLE_PREFIX."custom_properties SET `name`='Payment terms' WHERE `code`='invoice_payment_period';
	");
	
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "exp_group_by")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `exp_group_by` VARCHAR(100) NOT NULL DEFAULT '',
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "display_cost_or_price")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `display_cost_or_price` VARCHAR(100) NOT NULL DEFAULT 'price';
		");
	}
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "include_paid_by")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `include_paid_by` TINYINT( 1 ) NOT NULL DEFAULT '0';
		");
	}
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "include_product_type")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `include_product_type` TINYINT( 1 ) NOT NULL DEFAULT '0';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "include_expense_category")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `include_expense_category` TINYINT( 1 ) NOT NULL DEFAULT '0';
		");
	}
	
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
		ADD INDEX IF NOT EXISTS `object_id` (`object_id`);
	");

	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "from_object_type_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `from_object_type_id` int(10) NOT NULL DEFAULT '0',
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "product_type_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `product_type_id` int(10) NOT NULL DEFAULT '0',
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "unit_cost")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `unit_cost` DECIMAL(20,3) unsigned NOT NULL DEFAULT '0',
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "price_multiplier")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `price_multiplier` DECIMAL(20,3) unsigned NOT NULL DEFAULT '0';
		");
	}
	
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
		ADD INDEX IF NOT EXISTS `object_id` (`object_id`);
	");
	
	if (Plugins::instance()->isActivePlugin('expenses2') && !check_column_exists(TABLE_PREFIX."payment_receipts", "invoice_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."payment_receipts`
			ADD `invoice_id` int(10) NOT NULL DEFAULT '0',
		");
		
	}
	if (Plugins::instance()->isActivePlugin('expenses2') && !check_column_exists(TABLE_PREFIX."payment_receipts", "invoicing_status")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."payment_receipts`
			ADD `invoicing_status` VARCHAR(100) NOT NULL DEFAULT 'pending';
		");
	}

	if (Plugins::instance()->isActivePlugin('expenses2') && !check_column_exists(TABLE_PREFIX."expenses", "invoicing_status")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."expenses`
			ADD `invoicing_status` VARCHAR(100) NOT NULL DEFAULT 'pending';
		");
	}
}


function income_update_32_33() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "template_type")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `template_type` VARCHAR(100) NOT NULL DEFAULT 'detailed';
		");
	}
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "show_taxes_for_each_line")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `show_taxes_for_each_line` tinyint(1) NOT NULL default 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "show_headers_before_details")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `show_headers_before_details` tinyint(1) NOT NULL default 0;
		");
	}

	// adds a default invoice template if no one is present
	$def_row = DB::executeOne("SELECT * FROM ".TABLE_PREFIX."income_invoice_templates WHERE is_default=1");
	if (!$def_row) {
		
		Env::useHelper('functions', 'income');
		$group_invoice_timeslots_by = income_config_option('group_invoice_timeslots_by');
		$gb = 'timeslots';
		if ($group_invoice_timeslots_by == 'Task') $gb = 'tasks';
		else if ($group_invoice_timeslots_by == 'Person') $gb = 'users';

		DB::execute("
			INSERT INTO ".TABLE_PREFIX."income_invoice_templates (`name`,`group_by`,`include_description`,`exp_group_by`,`is_default`) VALUES
			('Default', '$gb', 1, 'payment_receipts', 1)
			ON DUPLICATE KEY UPDATE `name`=`name`;
		");
		
	}
}


function income_update_33_34() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "template_type")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `template_type` VARCHAR(100) NOT NULL DEFAULT 'detailed';
		");
	}
}

function income_update_34_35() {
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='automatic_adm_fee_line_text'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
				('automatic_adm_fee_line_text', 'Administrative fee', 'StringConfigHandler', 1, '')
			ON DUPLICATE KEY UPDATE name=name;
		");
	}
}


function income_update_35_36() {
	$config_option_exists = ContactConfigOptions::getByName("timeReportInvoicingStatus");
	if (!$config_option_exists instanceof ContactConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
			('general', 'timeReportInvoicingStatus', '', 'StringConfigHandler', 1, 0, '')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}
}


function income_update_36_37() {
	
	// Add "po number" custom property to invoices
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."custom_properties` (`object_type_id`, `name`, `type`, `description`, `values`, `default_value`, `code`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `show_in_lists`, `is_special`) VALUES
			((SELECT id FROM `".TABLE_PREFIX."object_types` WHERE name = 'invoice'),'PO Number', 'text', '', '', '', 'po_number', 0, 0, 25, 1, 1, 1)
		ON DUPLICATE KEY UPDATE name = name;
	");
	
	if (Plugins::instance()->isActivePlugin('advanced_core')) {
		Env::useHelper('functions', 'advanced_core');
		fill_property_groups_default_data();
	}
}


function income_update_37_38() {
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='invoice_footer_disclaimer'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
				('invoice_footer_disclaimer', '', 'StringConfigHandler', 1, '')
			ON DUPLICATE KEY UPDATE name=name;
		");
	}
}



function income_update_38_39() {
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='disable_general_invoices_tab'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
				('disable_general_invoices_tab', '0', 'BoolConfigHandler', 1, '')
			ON DUPLICATE KEY UPDATE name=name;
		");
	}
}


function income_update_39_40() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "subtotal")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `subtotal` decimal(20,3) NOT NULL AFTER `total`,
			ADD `taxes` decimal(20,3) NOT NULL AFTER `subtotal`;
		");
		DB::execute("
			UPDATE `".TABLE_PREFIX."income_invoice_lines` SET subtotal=total;
		");
	}
	
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."income_invoice_line_taxes` (
		  `invoice_line_id` int(10) NOT NULL,
		  `tax_id` int(10) NOT NULL,
		  `value` decimal(20,3) NOT NULL,
		  `applied_value` decimal(20,3) NOT NULL,
		  PRIMARY KEY (`invoice_line_id`,`tax_id`),
		  KEY `tax_id` (`tax_id`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='use_line_taxes'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`)
			VALUES ('use_line_taxes', '0', 'BoolConfigHandler', '1', '');
		");
	}
	
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "show_taxes_for_each_line")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `show_taxes_for_each_line` tinyint(1) NOT NULL default 0;
		");
	}
}

function income_update_40_41() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "show_headers_before_details")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `show_headers_before_details` tinyint(1) NOT NULL default 0;
		");
	}
}

function income_update_41_42() {

	Env::useHelper('functions', 'crpm');
	$projects_dim = Dimensions::findByCode('customer_project');
	$clients_dim = get_customers_dimension();
	
	if ($clients_dim->getId() != $projects_dim->getId()) {
		
		$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='billing_client_dim_assoc'"));
		if (!$option instanceof IncomeConfigOption) {
		  DB::execute("
			INSERT INTO ".TABLE_PREFIX."income_config_options (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES 
			(
				'billing_client_dim_assoc',
				(SELECT id FROM ".TABLE_PREFIX."dimension_member_associations WHERE `code`='project_customer'),
				'DimAssociationsConfigHandler', 1, 
				COALESCE(CONCAT (
					'{\"no_empty_value\":1, \"dim_id\":', (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='customer_project'), ',',
					'\"ot_id\":', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project'), ',',
					'\"assoc_dim_id\":', (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='customers'), ',',
					'\"assoc_ot_id\":', (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer'), '}'
					),'')
			);
		  ");
		}
	}
	
}

function income_update_42_43() {
	
	DB::execute("
		UPDATE `".TABLE_PREFIX."custom_properties` 
		SET `name` = 'Billing contact', `code` = 'billing_contact', is_special=1
		WHERE (`name` LIKE 'Billing client' OR `name` LIKE 'Billing contact') AND `type`='contact'
			AND `object_type_id` = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project');
	");
	
	$project_ot = ObjectTypes::findByName('project');
	$billing_contact_cp = CustomProperties::getCustomPropertyByCode($project_ot->getId(), 'billing_contact');
	if (!$billing_contact_cp instanceof CustomProperty) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."custom_properties` (`object_type_id`, `name`, `type`, `description`, `values`, `default_value`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `code`, `is_special`) VALUES
			((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project'), 'Billing contact', 'contact', '', '', '', '0', '0', '30', '1', 'billing_contact', '1')
		");
	}
	
	if (Plugins::instance()->isActivePlugin('advanced_core')) {
		Env::useHelper('functions', 'advanced_core');
		fill_property_groups_default_data();
	}
	
}

function income_update_43_44() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "member_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `member_id` int(10) NOT NULL DEFAULT 0;
		");
	}
}

function income_update_44_45() {
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."income_invoices`
		CHANGE `customer_name` `customer_name` text COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '';
	");

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "include_exp_date")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `include_exp_date` tinyint(1) NOT NULL default 0;
		");
	}
}

function income_update_45_46() {
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."income_invoices`
		ADD INDEX IF NOT EXISTS `date` (`date`),
		ADD INDEX IF NOT EXISTS `series_invoice_number` (`series`, `invoice_number`),
		ADD INDEX IF NOT EXISTS `invoice_number` (`invoice_number`),
		ADD INDEX IF NOT EXISTS `total` (`total`),
		ADD INDEX IF NOT EXISTS `status` (`status`);
	");
}

function income_update_46_47() {
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."income_invoices`
		CHANGE `invoice_number` `invoice_number` varchar(50) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '',
		CHANGE `series` `series` varchar(5) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '';
	");

	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='use_serie_for_invoice_number'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`)
			VALUES ('use_serie_for_invoice_number', '1', 'BoolConfigHandler', '1', '');
		");
	}
}

function income_update_47_48() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "include_expense_name")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `include_expense_name` tinyint(1) NOT NULL default 0;
		");
	}
}

function income_update_48_49() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", "include_expense_description")) {
		// add new column for expense description in invoice templates
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `include_expense_description` tinyint(1) NOT NULL default 0;
		");
		// initialize it with the same value as the include description column
		DB::execute("
			UPDATE `".TABLE_PREFIX."income_invoice_templates`
			SET `include_expense_description` = `include_description`;
		");
	}
}

function income_update_49_50() {
	if (!check_custom_prop_exists(TABLE_PREFIX, 'invoice_memo', 'project')) {
		DB::execute("
				INSERT INTO " . TABLE_PREFIX . "custom_properties (`object_type_id`, `name`, `code`, `type`, `values`, `visible_by_default`, `is_special`, `description`) VALUES
				((SELECT id FROM " . TABLE_PREFIX . "object_types WHERE name='project'), 'Invoice memo', 'invoice_memo', 'memo', '', 1, 1, 'This is the default memo for all invoices for this project')
			");
	}
}


function income_update_50_51() {


	if(!check_column_exists(TABLE_PREFIX . "income_invoice_templates", 'include_account_summary')){

		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates`
			ADD COLUMN `include_account_summary` BOOLEAN DEFAULT 0;
		");

	}

	if(checkTableExists(TABLE_PREFIX . "custom_properties")){

		$contact_obect_type_id = ObjectTypes::findByName('contact')->getId();
		
		DB::execute("
			INSERT INTO " . TABLE_PREFIX . "custom_properties (`object_type_id`, `name`, `type`, `description`, `values`, `default_value`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `code`, `is_special`, `is_disabled`, `show_in_lists`, `total_operation`, `object_subtype_id`, `default_currency_id`, `contact_type`) 
			VALUES ('$contact_obect_type_id', 'Initials', 'text', 'User Initials', '', '', '0', '0', '10', '1', 'initials', '0', '0', '1', '', '0', '1', 'user');
		");
		
	}
}

function income_update_51_52() {
	if(checkTableExists(TABLE_PREFIX . "income_invoice_templates")){

		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates`
			CHANGE `include_user_name` `include_user_name` varchar(100) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '';
		");

		
		if (check_column_exists(TABLE_PREFIX."income_invoice_templates", 'include_user_name')) {
			DB::execute("	
				UPDATE `" . TABLE_PREFIX . "income_invoice_templates` 
				SET `include_user_name` = IF (include_user_name = '1', 'Full name', 'No name');
			");
		}
	}
}

function income_update_52_53() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", 'break_down_by_subprojects')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `break_down_by_subprojects` tinyint(1) NOT NULL default 0;
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", 'footer_text')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `footer_text` VARCHAR(511) NOT NULL DEFAULT '';
		");
	}
}

function income_update_53_54() {

	if (!check_column_exists(TABLE_PREFIX."income_invoice_lines", "group_by_category_id")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_lines`
			ADD `group_by_category_id` int(10) NOT NULL DEFAULT '0';
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", 'break_down_expenses_by_category')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `break_down_expenses_by_category` tinyint(1) NOT NULL default 0;
		");
	}

	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", 'show_expenses_markup_separated')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `show_expenses_markup_separated` tinyint(1) NOT NULL default 0;
		");
	}
}

function income_update_54_55() {
	if (!check_column_exists(TABLE_PREFIX."income_invoice_templates", 'accumulate_discounts')) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."income_invoice_templates`
			ADD `accumulate_discounts` tinyint(1) NOT NULL default 1;
		");
	}
}

function income_update_55_56() {

	// add new config option to use invoice notebooks or not
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='use_invoice_notebooks'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."income_config_options` (`name`, `value`, `config_handler_class`, `is_system`) VALUES
			('use_invoice_notebooks', '0', 'BoolConfigHandler', 1);
		");
	}

	// modify custom properties
	DB::execute("	
				UPDATE `" . TABLE_PREFIX . "custom_properties` 
					SET `values` = ',check,money_order,transfer,cash,credit_card,other'
				WHERE object_type_id in (select id
										from " . TABLE_PREFIX . "object_types
										where name='invoice' or name='invoice_payment_receipt')
				and code ='payment_method';
			");
}

function income_update_56_57() 
{
	if (check_column_exists(TABLE_PREFIX . "income_invoice_lines", "amount")) {
        DB::execute("
						ALTER TABLE `" . TABLE_PREFIX . "income_invoice_lines`
						modify amount decimal(20,3) not null;
					");
    }

	if (check_column_exists(TABLE_PREFIX . "income_invoice_templates", "accumulate_discounts")) {
        DB::execute("
						ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates`
						modify accumulate_discounts varchar(100) not null default 'between_line_items';
					");
    }
}

function income_update_57_58(){
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_lines", "order")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_lines` ADD `order` int(10);
		");
	}
}
function income_update_58_59() {

	// if clients already have a billing contact custom property, then ensure that it has the correct code
	DB::execute("
		UPDATE ".TABLE_PREFIX."custom_properties SET code='billing_contact'
		WHERE name LIKE 'Billing Contact' 
		AND object_type_id = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer');
	");

	// if clients already have a billing address custom property, then ensure that it has the correct code
	DB::execute("
		UPDATE ".TABLE_PREFIX."custom_properties SET code='billing_address'
		WHERE name LIKE 'Billing Address' 
		AND object_type_id = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='customer');
	");
}

function income_update_59_60(){
	if (!check_column_exists(TABLE_PREFIX . "income_invoices", "attn")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoices` ADD `attn` varchar(255) COLLATE utf8_unicode_ci NULL DEFAULT '';
		");
	}

	$project_ot_id = ObjectTypes::findByName('project')->getId();
	$contract_amount_cp = CustomProperties::getCustomPropertyByCode($project_ot_id, 'contract_amount');

	if($contract_amount_cp instanceof CustomProperty){
		$contract_amount_cp->setCode('budget_total');
		$contract_amount_cp->save();
	}
}

function income_update_60_61()
{
	if (!check_column_exists(TABLE_PREFIX . "contact_emails", "default_billing_email")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "contact_emails` ADD `default_billing_email` tinyint(1) unsigned NOT NULL DEFAULT 0;
		");
	}

	if (!check_column_exists(TABLE_PREFIX . "contact_addresses", "default_billing_address")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "contact_addresses` ADD `default_billing_address` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
}

function income_update_61_62()
{
		if (!check_column_exists(TABLE_PREFIX . "income_invoice_lines", "item_type_id")) {
			DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoice_lines` ADD `item_type_id` int(10);
			");
		}
		if (!check_column_exists(TABLE_PREFIX . "income_invoice_lines", "discount_percent_type")) {
			DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoice_lines` ADD `discount_percent_type` int(1) DEFAULT 0;
			");
		}
		if (!check_column_exists(TABLE_PREFIX . "income_invoice_lines", "discount_percent_value")) {
			DB::execute("
				ALTER TABLE `" . TABLE_PREFIX . "income_invoice_lines` ADD `discount_percent_value` decimal(20,3) DEFAULT 0;
			");
		}
}

function income_update_62_63() {
	DB::execute("
		UPDATE ".TABLE_PREFIX."custom_properties SET code='po_number'
		WHERE (name LIKE 'P.O. Number' OR name LIKE 'PO Number')
		AND object_type_id = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='project');
	");
}

function income_update_63_64()
{
	$option = IncomeConfigOptions::instance()->findOne(array('conditions' => "name='allow_duplicated_invoice_numbers'"));
	if (!$option instanceof IncomeConfigOption) {
		DB::execute("
			INSERT INTO `" . TABLE_PREFIX . "income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`) VALUES
			('allow_duplicated_invoice_numbers', '0', 'BoolConfigHandler', 1, '');
	    ");
	}
	
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_detail")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_detail` tinyint(1) unsigned NOT NULL DEFAULT 0;
		");
	}

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_task_name")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_task_name` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_hours")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_hours` tinyint(1) unsigned NOT NULL DEFAULT 1;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_rate")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_rate` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_custom_description")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_custom_description` varchar(100) NOT NULL DEFAULT '';
    ");
	}

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_time_entry_description")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_time_entry_description` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_total")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_total` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_quantity")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_quantity` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_amount")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_amount` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_fee")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_fee` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_total")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_total` tinyint(1) unsigned NOT NULL DEFAULT 1;
    ");
	}
	
}

function income_update_64_65()
{
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_project_name")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_project_name` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_project_description")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_project_description` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
}
function income_update_65_66()
{
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_project_number")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_project_number` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_project_name")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_project_name` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_from_to")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_from_to` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_date")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_date` varchar(100) NOT NULL DEFAULT '';
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_quantity")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_quantity` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_budget_completion")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_budget_completion` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
}
function income_update_66_67()
{
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_expense_project_number")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_expense_project_number` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_expense_project_name")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_expense_project_name` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_time_line_date")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_time_line_date` varchar(100) NOT NULL DEFAULT 'Item date';
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_type_date")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_type_date` varchar(100) NOT NULL DEFAULT 'Item date';
	");
	}
}
function income_update_67_68()
{
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_date_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_date_col` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_unit_price")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_unit_price` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
}
function income_update_68_69()
{
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_project_type")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_lump_sum_project_type` tinyint(1) unsigned NOT NULL DEFAULT 0;
	");
	}
}


function income_update_69_70(){
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "category_for_lump_sum")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `category_for_lump_sum` int(10) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "product_type_for_lump_sum")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `product_type_for_lump_sum` int(10) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "category_for_lump_sum_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `category_for_lump_sum_col` tinyint(1) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "product_type_for_lump_sum_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `product_type_for_lump_sum_col` tinyint(1) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "category_for_timeslot")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `category_for_timeslot` int(10) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "product_type_for_timeslot")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `product_type_for_timeslot` int(10) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "category_for_timeslot_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `category_for_timeslot_col` tinyint(1) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "product_type_for_timeslot_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `product_type_for_timeslot_col` tinyint(1) NOT NULL DEFAULT 0;
		");
	}

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "category_for_expenses")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `category_for_expenses` int(10) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "product_type_for_expenses")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `product_type_for_expenses` int(10) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "category_for_expenses_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `category_for_expenses_col` tinyint(1) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "product_type_for_expenses_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `product_type_for_expenses_col` tinyint(1) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_paid_by_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `include_paid_by_col` tinyint(1) NOT NULL DEFAULT 0;
		");
	}
	
	
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_lump_sum_deetail_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `include_lump_sum_deetail_col` tinyint(1) NOT NULL DEFAULT 0;
		");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_description")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `include_exp_description` tinyint(1) NOT NULL DEFAULT 0;
		");
	}

	/***for compatibility */
	/*get all templates*/
	/*$templates=IncomeInvoiceTemplates::getInvoiceTemplatesInfo();

	foreach($templates as $template)
	{

		//get the template
		$invoice_template = IncomeInvoiceTemplates::findById($template['id']);
		//set the template
		if($invoice_template->getIncludeUserName()!='No name')
		{
			$invoice_template->setIncludeUserNameCol(1);
		}

		$invoice_template->setCategoryForTimeslotCol($invoice_template->getIncludeLaborCategory());
		$invoice_template->setIncludePaidByCol($invoice_template->getIncludePaidBy());
		$invoice_template->setProductTypeForTimeslotCol($invoice_template->getIncludeProductType());

		//save the template
		$invoice_template->save();

		//destroy the object
		unset($invoice_template);
	}*/
}
function income_update_70_71(){
	
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_user_name_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` 
			ADD `include_exp_user_name_col`  varchar(100) NOT NULL DEFAULT 'Do not display'
		");
	}
}

function income_update_71_72(){

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_detail")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_detail` tinyint(1) unsigned NOT NULL DEFAULT 0;
		");
	}
}

function income_update_72_73(){
	if (check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_user_name_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates`
			DROP COLUMN `include_user_name_col`;
		");
	}

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_user_name_col")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates`
			ADD COLUMN `include_user_name_col` varchar(100) NOT NULL DEFAULT 'Do not display';
		");
	}
}

function income_update_73_74(){
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_task_name")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_task_name` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_hours")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_hours` tinyint(1) unsigned NOT NULL DEFAULT 1;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_rate")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_rate` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_custom_description")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_custom_description` varchar(100) NOT NULL DEFAULT '';
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_time_entry_description")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_time_entry_description` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_total")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_total` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_quantity")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_quantity` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_amount")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_amount` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_fee")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_fee` tinyint(1) unsigned NOT NULL DEFAULT 0;
    ");
	}
	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "include_exp_total")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `include_exp_total` tinyint(1) unsigned NOT NULL DEFAULT 1;
    ");
	}
}

function income_update_74_75()
{
	$pathInvoiceTemplate = 'original';
	$root_exploded = @explode(DIRECTORY_SEPARATOR, ROOT);
	$current_folder_name = end($root_exploded);
	$template_file = "invoice_print_custom_template.php";
	$base_folder = "/plugins/income/invoice_print_templates/" . $current_folder_name;

	if (!check_column_exists(TABLE_PREFIX . "income_invoice_templates", "invoice_template_assigned")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates` ADD `invoice_template_assigned` varchar(100) NOT NULL DEFAULT '$pathInvoiceTemplate';
    	");

		if (is_dir(ROOT . $base_folder) && file_exists(ROOT . $base_folder . "/$template_file")) {
			$pathInvoiceTemplate = $current_folder_name;
			DB::execute("
				UPDATE " . TABLE_PREFIX . "income_invoice_templates SET invoice_template_assigned='$pathInvoiceTemplate'
				WHERE invoice_template_assigned LIKE 'original';
			");
		}
	}
	
}

function income_update_75_76()
{
	DB::execute("
		CREATE TABLE IF NOT EXISTS `" . TABLE_PREFIX . "income_invoice_childs` (
		`object_id_parent` int(10) unsigned NOT NULL,
		`object_id_child` int(10) unsigned NOT NULL,
		PRIMARY KEY (`object_id_parent`,`object_id_child`)
		)ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");

	if (check_column_exists(TABLE_PREFIX . "income_invoice_templates", "break_down_by_subprojects")) {
		DB::execute("
			ALTER TABLE `" . TABLE_PREFIX . "income_invoice_templates`
			MODIFY COLUMN `break_down_by_subprojects` varchar(100) NOT NULL DEFAULT 'NO';
    ");
	}
}