<?php
if (isset($indicator) && $indicator instanceof Indicator) {
	if (!$indicator->isTrashed()){
		if($indicator->canEdit(logged_user())) {
			add_page_action(lang('edit'), "javascript:og.render_modal_form('', {c:'indicator', a:'edit', params: {id:".$indicator->getId()."}});", 'ico-edit', null, null, true);
			
			if (!$indicator->isArchived()) {
				add_page_action(lang('archive'), "javascript:if(confirm(lang('confirm archive object'))) og.openLink('" . $indicator->getArchiveUrl() ."');", 'ico-archive-obj');
			} else {
				add_page_action(lang('unarchive'), "javascript:if(confirm(lang('confirm unarchive object'))) og.openLink('" . $indicator->getUnarchiveUrl() ."');", 'ico-unarchive-obj');
			}
		}
	}
	if ($indicator->canDelete(logged_user())) {
		if ($indicator->isTrashed()) {
			add_page_action(lang('restore from trash'), "javascript:if(confirm(lang('confirm restore objects'))) og.openLink('" . $indicator->getUntrashUrl() ."');", 'ico-restore', null, null, true);
			add_page_action(lang('delete permanently'), "javascript:if(confirm(lang('confirm delete permanently'))) og.openLink('" . $indicator->getDeletePermanentlyUrl() ."');", 'ico-delete', null, null, true);
		} else {
			add_page_action(lang('move to trash'), "javascript:if(confirm(lang('confirm move to trash'))) og.openLink('" . $indicator->getTrashUrl() ."');", 'ico-trash', null, null, true);
		}
	}
?>

<div style="padding:7px">
<div class="indicator">
<?php
	$content = '';
	
	tpl_assign('indicator', $indicator);
	$table_html = tpl_fetch(get_template_path('view_values_table', 'indicator', 'indicators'));
	
	$content .= $table_html;
	
	$subtypes = ObjectSubtypes::instance()->findAll(array(
			"conditions" => "object_type_id = ".IndicatorValues::instance()->getObjectTypeId(). " AND id IN (
				SELECT dependant_object_subtype_id FROM ".TABLE_PREFIX."object_subtype_dependencies 
				WHERE object_subtype_id='".$indicator->getColumnValue('object_subtype_id')."'
			)",
	));
	
	foreach ($subtypes as $subtype) {
		$content .= '<a href="#" onclick="og.render_modal_form(\'\', {c:\'indicator_value\', a:\'add\', params: {indicator_id:'.$indicator->getId().', object_subtype_id:'.$subtype->getId().'}});" class="link-ico ico-add">'. lang('add value') .'</a>';
		$content .= '&nbsp;&nbsp;&nbsp;';
	}
	$content .= '<br /><br />';
	
	tpl_assign("content", $content);
	tpl_assign("object", $indicator);
	tpl_assign('iconclass', 'ico-large-indicator');
	
	$this->includeTemplate(get_template_path('view', 'co'));
?>
</div>
</div>
<?php } ?>
