<?php 

class InvoicePaymentReceiptInvoices extends BaseInvoicePaymentReceiptInvoices {
	
	function getByInvoiceAndPaymentReceiptId($invoice_id, $payment_receipt_id) {
		return self::findOne(array("conditions" => array("invoice_id=? AND payment_receipt_id=?", $invoice_id, $payment_receipt_id)));
	}
	
	function getByInvoiceId($invoice_id) {
		return self::findAll(array("conditions" => array("invoice_id=? AND 0=(SELECT o.trashed_by_id FROM ".TABLE_PREFIX."objects o WHERE o.id=payment_receipt_id)", $invoice_id)));
	}
	
	function getByPaymentReceiptId($payment_receipt_id) {
		return self::findAll(array("conditions" => array("payment_receipt_id=?", $payment_receipt_id)));
	}
	
	function getAffectedInvoices($payment_receipt_id) {
		return IncomeInvoices::findAll(array(
			"conditions" => array("id IN (SELECT invoice_id FROM ".$this->getTableName()." WHERE payment_receipt_id=?) AND o.trashed_by_id=0", $payment_receipt_id)
		));
	}
	
	
	function recalculateInvoicePaidAmount($invoice_id) {
		$sql = "
			UPDATE ".TABLE_PREFIX."income_invoices i SET i.paid_amount = (
				SELECT SUM(pri.amount) as paid_amount
				FROM ".TABLE_PREFIX."invoice_payment_receipt_invoices pri
				INNER JOIN ".TABLE_PREFIX."invoice_payment_receipts pr ON pri.payment_receipt_id = pr.object_id
				INNER JOIN ".TABLE_PREFIX."objects o ON o.id = pr.object_id
				WHERE pri.invoice_id = $invoice_id
					AND o.trashed_by_id=0
			),
			i.due_amount = (i.total - i.paid_amount),
			i.status = IF(i.paid_amount=0, 'pending', IF(i.due_amount<=0, 'confirmed', 'part_confirmed'))
			WHERE i.object_id=$invoice_id
		";
		
		DB::execute($sql);
	}
}
