
-- insert billing client association for projects if it doesn't exist
INSERT INTO `<?php echo $table_prefix ?>dimension_member_associations` (`dimension_id`, `object_type_id`, `associated_dimension_id`, `associated_object_type_id`, `is_required`, `is_multiple`, `keeps_record`, `allows_default_selection`, `code`)
SELECT 
  (SELECT `id` FROM <?php echo $table_prefix ?>dimensions WHERE `code` = 'customer_project'),
  (SELECT `id` FROM <?php echo $table_prefix ?>object_types WHERE `name` = 'project'),
  (SELECT `id` FROM <?php echo $table_prefix ?>dimensions WHERE `code` = 'customers'),
  (SELECT `id` FROM <?php echo $table_prefix ?>object_types WHERE `name` = 'customer'),
  '0', '1', '0', '1', 'project_billing_client'
WHERE (SELECT count(`id`) FROM `<?php echo $table_prefix ?>dimension_member_associations` WHERE `code` = 'project_billing_client') = 0;

-- insert config options for the association between projects and billing client
INSERT INTO `<?php echo $table_prefix ?>dimension_associations_config` (`association_id`, `config_name`, `type`, `value`) VALUES
  ((SELECT `id` FROM `<?php echo $table_prefix ?>dimension_member_associations` WHERE `code`='project_billing_client'), 'allow_remove_from_property_member', 'boolean', '1'),
  ((SELECT `id` FROM `<?php echo $table_prefix ?>dimension_member_associations` WHERE `code`='project_billing_client'), 'autoclassify_in_property_member', 'boolean', '1'),
  ((SELECT `id` FROM `<?php echo $table_prefix ?>dimension_member_associations` WHERE `code`='project_billing_client'), 'custom_association_name', 'text', 'Billing client')
ON DUPLICATE KEY UPDATE `association_id`=`association_id`;

-- insert allocation percentage attribute to the relation between project and billing clients
INSERT INTO `<?php echo $table_prefix ?>member_association_attributes` (`association_id`, `name`, `type`, `code`, `order`, `is_required`) VALUES
(COALESCE((SELECT id FROM `<?php echo $table_prefix ?>dimension_member_associations` WHERE `code`='project_billing_client'), 0), 'Invoice allocation', 'numeric', 'invoice_allocation', '1', '0');

-- config option to decide if we have to generate splitted invoices for different billing clients
INSERT INTO `<?php echo $table_prefix ?>income_config_options` (`name`, `value`, `config_handler_class`, `is_system`, `options`)
VALUES ('split_invoice_for_billing_clients', '1', 'BoolConfigHandler', '1', '');
