<?php
if (isset($analysis) && $analysis instanceof Analysis) {
	if (!$analysis->isTrashed()){
		if($analysis->canEdit(logged_user())) {
			add_page_action(lang('edit'), "javascript:og.render_modal_form('', {c:'analysis', a:'edit', params: {id:".$analysis->getId()."}});", 'ico-edit', null, null, true);
			if (!$analysis->isArchived())
				add_page_action(lang('archive'), "javascript:if(confirm(lang('confirm archive object'))) og.openLink('" . $analysis->getArchiveUrl() ."');", 'ico-archive-obj');
			else
				add_page_action(lang('unarchive'), "javascript:if(confirm(lang('confirm unarchive object'))) og.openLink('" . $analysis->getUnarchiveUrl() ."');", 'ico-unarchive-obj');
		} // if
	}
	if ($analysis->canDelete(logged_user())) {
		if ($analysis->isTrashed()) {
			add_page_action(lang('restore from trash'), "javascript:if(confirm(lang('confirm restore objects'))) og.openLink('" . $analysis->getUntrashUrl() ."');", 'ico-restore', null, null, true);
			add_page_action(lang('delete permanently'), "javascript:if(confirm(lang('confirm delete permanently'))) og.openLink('" . $analysis->getDeletePermanentlyUrl() ."');", 'ico-delete', null, null, true);
		} else {
			add_page_action(lang('move to trash'), "javascript:if(confirm(lang('confirm move to trash'))) og.openLink('" . $analysis->getTrashUrl() ."');", 'ico-trash', null, null, true);
		}
	}
?>

<div style="padding:7px">
<div class="analysis">
<?php
	
	tpl_assign("content", $content);
	tpl_assign("object", $analysis);
	//tpl_assign('iconclass', 'ico-large-analysis');
	
	$this->includeTemplate(get_template_path('view', 'co'));
?>
</div>
</div>
<?php } //if isset ?>
