<?php


function lab_samples_get_additional_install_queries($db_connection, $table_prefix) {
	
	$queries = array();
	$is_installed_mem_custom_props = false;
	$is_installed_mem_templates = false;
	
	$is_installed_mem_custom_props = check_is_installed_plugin($db_connection, $table_prefix, 'member_custom_properties');
	
	if ($is_installed_mem_custom_props) {
	
		
		$sql = "SELECT count(id) as total FROM ".$table_prefix."member_custom_properties WHERE code='color_special'
				AND object_type_id=(SELECT id FROM ".$table_prefix."object_types WHERE name='analysis_type')";
		
		$mysql_res = mysqli_query($db_connection, $sql);
		if ($mysql_res) {
			$rows = mysqli_fetch_assoc($mysql_res);

			if (count($rows[0]) == 0 || $rows[0]['total'] == 0) {
				$queries[] = "INSERT INTO `".$table_prefix."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				  SELECT mt.id, 'Color', 'color_special','color','','','',0,0,0,30,1, 1, 0
				  FROM ".$table_prefix."object_types mt WHERE mt.`type` IN ('dimension_group') AND name IN ('analysis_type','sample_status','sample_type')
				ON DUPLICATE KEY UPDATE `code`=`code`;";
				
				$queries[] = "INSERT INTO `".$table_prefix."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
				  SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,0,31,1, 1, 0
				  FROM ".$table_prefix."object_types mt WHERE mt.`type` IN ('dimension_group') AND name IN ('analysis_type','sample_status','sample_type')
				ON DUPLICATE KEY UPDATE `code`=`code`;";
			}
		}
		
	}
	
	$is_installed_advanced_reports = check_is_installed_plugin($db_connection, $table_prefix, 'advanced_reports');
	if ($is_installed_advanced_reports) {
		include_once dirname(__FILE__)."/../../advanced_reports/application/helpers/default_member_reports.php";
		$s_rep_q = get_default_member_report_queries($db_connection, $table_prefix, 'sample');
		$queries = array_merge($queries, $s_rep_q);
	}
	
	
	$is_installed_mem_templates = check_is_installed_plugin($db_connection, $table_prefix, 'member_templates');
	
	if ($is_installed_mem_templates) {
		$queries[] = "INSERT INTO `".$table_prefix."member_templates_available_types` (dimension_id, object_type_id) VALUES
		  ((SELECT id from ".$table_prefix."dimensions WHERE code = 'customer_project'), (SELECT id FROM ".$table_prefix."object_types WHERE name = 'sample'))
		ON DUPLICATE KEY UPDATE ".$table_prefix."member_templates_available_types.dimension_id=".$table_prefix."member_templates_available_types.dimension_id;";
	}
	
	return $queries;

}
?>