og.lab_samples = {
	init: function() {
		for (x in og.dimension_object_types) {
			if (!og.dimension_object_types[x] || typeof(og.dimension_object_types[x])=='function') continue;
			if (og.dimension_object_types[x] == 'sample') {
				og.additional_on_dimension_object_click[x] = 'og.folders.onFolderClick(<parameters>);';
			} else if (og.dimension_object_types[x] == 'sample_type') {
				og.additional_on_dimension_object_click[x] = 'og.lab_samples.onSampleTypeClick(<parameters>);';
			} else if (og.dimension_object_types[x] == 'sample_status') {
				og.additional_on_dimension_object_click[x] = 'og.lab_samples.onSampleStatusClick(<parameters>);';
			} else if (og.dimension_object_types[x] == 'analysis_type') {
				og.additional_on_dimension_object_click[x] = 'og.lab_samples.onAnalysisTypeClick(<parameters>);';
			}
		}
		
		if (!og.additional_list_actions) og.additional_list_actions = {};
		og.additional_list_actions.analysis = [];
		og.additional_list_actions.analysis.push(new Ext.Action({
			text: lang('generate document'),
            tooltip: lang('generate document for selected objects'),
            iconCls: 'ico-text',
			handler: function() {
				var genid = Ext.id();
				
				var ids = Ext.getCmp('analysis-manager').getSelectedIds().split(',');
				
				var div = document.createElement('div');
				div.innerHTML = '<div style="border-radius: 5px; background-color: #fff; padding: 10px; width: 400px;">'+
					'<div><label class="coInputTitle">'+lang('document name')+'</label></div>'+
					'<div id="'+genid+'_name"><input type="text" class="long" id="name_input" placeholder="'+ lang('name') +'"/></div>'+
					'<div id="'+genid+'_buttons">'+
					'<button class="yes submit blue">'+lang('generate document')+'</button><button class="no submit blue">'+lang('cancel')+'</button>'+
					'</div><div class="clear"></div></div>';

				var modal_params = {
					'escClose': false,
					'overlayClose': false,
					'closeHTML': '<a id="'+genid+'_close_link" class="modal-close" title="'+lang('close')+'"></a>',
					'onShow': function (dialog) {
						$("#"+genid+"_close_link").addClass("modal-close-img");
						$("#"+genid+"_buttons").css('text-align', 'right').css('margin', '10px 0');
						$("#"+genid+"_name").css('margin', '10px 0');
						
						$("#"+genid+"_buttons button.yes").css('margin-right', '10px').click(function(){
							var docname = $("#"+genid+"_name #name_input").val();
							og.openLink(og.getUrl('object_print', 'generate_document', {ids: ids, file_name:docname}));
							$('.modal-close').click();
						});
						$("#"+genid+"_buttons button.no").css('margin-right', '10px').click(function(){
							$('.modal-close').click();
						});
				    }
				};
				setTimeout(function() {
					$.modal(div, modal_params);
				}, 100);
			},
			scope: this
		}));
		
	},
	onSampleTypeClick: function (member_id) {
		og.memberTreeExternalClick('sample_types', member_id);
	},
	onSampleStatusClick: function (member_id) {
		og.memberTreeExternalClick('sample_statuses', member_id);
	},
	onAnalysisTypeClick: function (member_id) {
		og.memberTreeExternalClick('analysis_types', member_id);
	}
}

og.onAnalysisTypeRemove = function (genid, dimension_id){
	og.onAssociatedMemberTypeRemoveMultiple(genid, dimension_id, "member[analysis_type]");
}

og.onAnalisysTypeSelect = function (genid, dimension_id, member_id){
	og.onAssociatedMemberTypeSelectMultiple(genid, dimension_id, member_id, "member[analysis_type]");
}

og.onSampleCountryRemove = function (genid, dimension_id){
	og.onAssociatedMemberTypeRemoveMultiple(genid, dimension_id, "member[countries]");
}

og.onSampleCountrySelect = function (genid, dimension_id, member_id){
	og.onAssociatedMemberTypeSelectMultiple(genid, dimension_id, member_id, "member[countries]");
}

og.onSampleTypeRemoveMultiple = function (genid, dimension_id){
	og.onAssociatedMemberTypeRemoveMultiple(genid, dimension_id, "member[sample_type]");
}

og.onSampleTypeSelectMultiple = function (genid, dimension_id, member_id){
	og.onAssociatedMemberTypeSelectMultiple(genid, dimension_id, member_id, "member[sample_type]");
}


og.onSampleTypeRemove = function (genid, dimension_id){
	og.onAssociatedMemberTypeRemove(genid, "member[sample_type]");
}

og.onSampleTypeSelect = function (genid, dimension_id, member_id){
	og.onAssociatedMemberTypeSelect(genid, dimension_id, member_id, "member[sample_type]");
	og.selectDefaultAssociatedMembers(genid, dimension_id, member_id);
}

og.onSampleStatusRemove = function (genid, dimension_id){
	og.onAssociatedMemberTypeRemove(genid, "member[sample_status]");
}

og.onSampleStatusSelect = function (genid, dimension_id, member_id){
	og.onAssociatedMemberTypeSelect(genid, dimension_id, member_id, "member[sample_status]");
}


og.eventManager.addListener('lab sample member added', function(data){
	if (data.id) {
		
		var genid = Ext.id();
		
		var modal_params = {
			'escClose': false,
			'overlayClose': false,
			'minWidth' : 400,
			'minHeight' : 200,
			'closeHTML': '<a id="'+ genid +'print_label_close_link" class="modal-close modal-close-img"></a>'
		};
		
		var link_html = '<a id="sample_print_link" href="'+ og.getUrl('sample', 'print_sample_label', {id:data.id}) +'" target="_blank" style="display:none;">&nbsp;</a>';
		
		html = '<div id="'+ genid +'print-label-modal" class="modal-container print-label">' +
			'<div class="print-label-title">' + lang('print sample label') + '</div>' + 
			'<div class="question">' + lang('do you want to print label for sample', data.name) + '</div>' +
			'<div class="button-container">' +
				'<button class="cancel submit blue">' + lang('cancel') + '</button>' +
			'</div><div class="button-container">' +
				'<button class="print submit blue">' + lang('print') + '</button>' +
			'</div><div class="clear"></div>'+ link_html +'</div>';
		
		$.modal(html, modal_params);
		
		$('#'+ genid +'print-label-modal button.print').click(function(){
			
			$('#'+ genid +'print-label-modal #sample_print_link')[0].click();
			$('#'+ genid +'print_label_close_link').click();
			
		});
		
		$('#'+ genid +'print-label-modal button.cancel').click(function(){
			$('#'+ genid +'print_label_close_link').click();
		});
	}
});