<?php 


function lab_samples_update_1_2() {
	
	// dont allow samples under projects or project folders
	DB::execute("
		DELETE FROM `".TABLE_PREFIX."dimension_object_type_hierarchies` 
		WHERE dimension_id=(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='customer_project')
			AND parent_object_type_id IN (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name IN ('project_folder', 'project'))
			AND child_object_type_id = (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'sample');
	");
	// allow folders under samples
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_hierarchies` (dimension_id, parent_object_type_id, child_object_type_id) VALUES
		((SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='customer_project'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'sample'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'project_folder'))
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	// create sample status and sample types dimensions
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimensions` (`code`,`name`,`is_root`,`is_manageable`,`allows_multiple_selection`,`defines_permissions`,`default_order`, `is_default`, `options`, `permission_query_method`) VALUES
		('sample_statuses', 'Sample status', 1, 0, 0, 0, 15, 0, '', 'not_mandatory'),
		('sample_types','Sample types',1,0,0,0,16,0,'', 'not_mandatory' );
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."dimension_options (`dimension_id`, `name`, `value`) VALUES
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='sample_statuses'),'useLangs','1'),
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='sample_statuses'),'showInPaths','1'),
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='sample_types'),'useLangs','1'),
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='sample_types'),'showInPaths','1')
		ON DUPLICATE KEY UPDATE `value`=`value`;");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
		 ('sample_status', '', '', 'dimension_group', 'customer_type', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='lab_samples'), 0),
		 ('sample_type', '', '', 'dimension_group', 'sample_type', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='lab_samples'), 0)
		ON DUPLICATE KEY UPDATE id=id;");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_types` (`dimension_id`,`object_type_id`,`is_root`,`options`) VALUES 
		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'sample_statuses'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'sample_status'), 1, ''),
 		 ((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'sample_types'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'sample_type'), 1, '')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;");

	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='sample_statuses'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='sample_status'),
		 	`id`, 0, 1
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `type` IN ('content_object', 'comment', 'located')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='sample_types'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='sample_type'),
		 	`id`, 0, 1
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `type` IN ('content_object', 'comment', 'located')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_member_associations` (`dimension_id`,`object_type_id`,`associated_dimension_id`, `associated_object_type_id`, `is_required`,`is_multiple`, `keeps_record`) VALUES
		((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'sample'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'sample_statuses'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'sample_status'),0,0,0),
		((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'sample'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'sample_types'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'sample_type'),0,0,0),
		((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'sample_types'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'sample_type'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'analysis_types'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'analysis_type'),0,1,0)
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_hierarchies` (dimension_id, parent_object_type_id, child_object_type_id) VALUES
		((SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='analysis_types'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'analysis_type'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'analysis_type')),
		((SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='sample_types'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'sample_type'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'sample_type'))
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	if (!check_member_custom_prop_exists(TABLE_PREFIX, 'color_special', 'sample_status')) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
			SELECT mt.id, 'Color', 'color_special','color','','','',0,0,0,30,1, 1, 0
			FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('sample_status','sample_type')
			ON DUPLICATE KEY UPDATE `code`=`code`;
		");
	}
	
	if (!check_member_custom_prop_exists(TABLE_PREFIX, 'description_special', 'sample_status')) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."member_custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_system`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`)
			SELECT mt.id, 'Description', 'description_special', 'memo','','','',0,0,0,31,1, 1, 0
			FROM ".TABLE_PREFIX."object_types mt WHERE mt.`type` IN ('dimension_object','dimension_group') AND name IN ('sample_status','sample_type')
			ON DUPLICATE KEY UPDATE `code`=`code`;
		");
	}
	
}

function lab_samples_update_2_3() {
	// analysis module
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."analysis` (
		  `object_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
		  PRIMARY KEY (`object_id`)
		) ENGINE=InnoDB;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`) VALUES
		 ('analysis', 'Analysiss', 'analysis', 'content_object', 'analysis', (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='lab_samples'))
		ON DUPLICATE KEY UPDATE id=id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
			SELECT x.dimension_id, x.dimension_object_type_id, (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='analysis'), 0, 1
			FROM `".TABLE_PREFIX."dimension_object_type_contents` x WHERE content_object_type_id=(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='task')
		ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."dimension_object_type_contents.dimension_id=".TABLE_PREFIX."dimension_object_type_contents.dimension_id;
	");
	
	DB::execute("	
		DELETE FROM `".TABLE_PREFIX."dimension_object_type_contents` WHERE `dimension_id`=0 OR dimension_id IS NULL;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."tab_panels` (`id`,`title`,`icon_cls`,`refresh_on_context_change`,`default_controller`,`default_action`,`initial_controller`,`initial_action`,`enabled`,`type`,`ordering`,`plugin_id`,`object_type_id`) VALUES 
		 ('analysis-panel', 'analysis', 'ico-analysis', 1, 'analysis', 'init', '', '', 1, 'system', 11, (SELECT `id` FROM `".TABLE_PREFIX."plugins` WHERE `name`='lab_samples'), (SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='analysis')) 
		ON DUPLICATE KEY UPDATE id=id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."tab_panel_permissions` (`permission_group_id`, `tab_panel_id`)
		 SELECT `c`.`permission_group_id`, 'analysis-panel'
		 FROM `".TABLE_PREFIX."contacts` `c` WHERE `c`.`user_type` IN (
		 	SELECT `id` FROM `".TABLE_PREFIX."permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator','Manager','Executive')
		 )
		ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 1, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('analysis')
			 AND p.`name` IN ('Super Administrator','Administrator','Manager');
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 0, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('analysis')
			 AND p.`name` IN ('Executive');
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 0, 0
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('analysis')
			 AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 1, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('analysis')
			AND p.`name` IN ('Super Administrator','Administrator','Manager');
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		SELECT p.id, o.id, 0, 1
		FROM `".TABLE_PREFIX."object_types` o JOIN `".TABLE_PREFIX."permission_groups` p
		WHERE o.`name` IN ('analysis')
			AND p.`name` IN ('Executive');
	");
	
	// add permissions to users where the users already have permissions (copy permissions from tasks)
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
		 SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='analysis'), cmp.can_delete, cmp.can_write 
		 FROM ".TABLE_PREFIX."contact_member_permissions cmp
		 WHERE cmp.object_type_id = (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='task')
		ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."contact_member_permissions.member_id=".TABLE_PREFIX."contact_member_permissions.member_id;
	");
	
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."tab_panel_permissions (permission_group_id, tab_panel_id)
		 SELECT pg.id, 'analysis-panel' FROM ".TABLE_PREFIX."permission_groups pg WHERE pg.type='roles' AND pg.name IN ('Super Administrator','Administrator','Manager','Executive')
		ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`) VALUES
		 ('listing preferences', 'lp_dim_analysis_types_show_as_column', '1', 'BoolConfigHandler', 0, 0)
		ON DUPLICATE KEY UPDATE name=name;
	");
}

function lab_samples_update_3_4() {
	// enable checkbox default selecion in sample_types add/edit
	DB::execute("
		UPDATE ".TABLE_PREFIX."dimension_member_associations SET allows_default_selection=1 WHERE
			dimension_id=(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='sample_types') AND
			object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='sample_type') AND
			associated_dimension_id=(SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='analysis_types') AND
			associated_object_type_id=(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='analysis_type');
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
		('general', 'print_label_after_add_sample', '0', 'BoolConfigHandler', '0', '0', NULL)
		ON DUPLICATE KEY UPDATE category_name=category_name;
	");
	
	if (Plugins::instance()->isActivePlugin('advanced_reports')) {
		Env::useHelper('default_member_reports', 'advanced_reports');
	
		create_default_member_report('sample');
	}
}


function lab_samples_update_4_5() {
	// add relation between samples and countries
	$cdim = Dimensions::findByCode('countries');
	if ($cdim instanceof Dimension) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."dimension_member_associations` (`dimension_id`,`object_type_id`,`associated_dimension_id`, `associated_object_type_id`, `is_required`,`is_multiple`, `keeps_record`) VALUES
			((SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'customer_project'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'sample'),(SELECT id from ".TABLE_PREFIX."dimensions WHERE code = 'countries'),(SELECT id FROM ".TABLE_PREFIX."object_types WHERE name = 'country'),0,1,0)
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		");
	}
}
