<?php
/**
 * MailRulesController
 * Generado el 14/2/2012
 * 
 */
class MailRulesController extends ApplicationController {

	var $plugin_name = "mail_rules";

	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'website');
	}

	/**
	 * List email rules
	 *
	 */
	function list_rules() {
		$accounts = MailAccounts::getMailAccountsByUser(logged_user());
		if (!$accounts) {
			flash_error(lang('you need to have entered an account'));
			ajx_current("empty");
			return;
		}

		$sql = "SELECT mr.*,ma.email
			FROM `".TABLE_PREFIX."mail_rules` mr,
				`".TABLE_PREFIX."mail_accounts` ma,
				`".TABLE_PREFIX."mail_account_rules` ar,
				`".TABLE_PREFIX."mail_account_contacts` mc
			WHERE
				mr.id = ar.rule_id
				AND ar.account_id = ma.id
				AND mc.contact_id = ".logged_user()->getId()."
				AND mc.account_id=ma.id
			ORDER BY name ASC";
		
        $rules = DB::executeAll($sql);
		tpl_assign('rules', $rules);
	}
        
        /**
	 * add and edit email rules
	 *
	 */
	function add_rule() {
        if($_POST){
            
            if (!array_var($_POST, 'name')) {
                    flash_error(lang('must enter a name for the rule'));
                    ajx_current("empty");
                    return;
            }
            if (!array_var($_POST, 'account')) {
                    flash_error(lang('must enter an account'));
                    ajx_current("empty");
                    return;
            }
            if (!array_var($_POST, 'action_in_name')) {
                    flash_error(lang('must enter an action'));
                    ajx_current("empty");
                    return;
            } 
            if (array_var($_POST, 'action_in_name') == "classify") {
                if(array_var($_POST, 'members') == "[]"){                            
                    flash_error(lang('must enter an action value'));
                    ajx_current("empty");
                    return;
                }else{
                    $member_ids = json_decode(array_var($_POST, 'members'));
                    $action_value = "";
                    foreach($member_ids as $member_id){
                        $action_value .= $member_id.",";
                    }
                    $action_value = rtrim($action_value, ",");
                }                            
            }    
            if (array_var($_POST, 'action_in_name') == "forward") {
                if(!array_var($_POST, 'action_value_forward')){
                    flash_error(lang('must enter an action value'));
                    ajx_current("empty");
                    return;
                }else{
                    $action_value = array_var($_POST, 'action_value_forward');
                }                          
            } 
            if (array_var($_POST, 'action_in_name') == "autoreply") {
                if(!array_var($_POST, 'action_value_autoreply')){
                    flash_error(lang('must enter an action value'));
                    ajx_current("empty");
                    return;
                }else{
                    $action_value = array_var($_POST, 'action_value_autoreply');
                }                          
            }
          
            $rule = MailRules::findById(get_id('rule_id'));
            if($rule){
                $rule->setName(array_var($_POST, 'name'));
                $rule->save();
            }else{
                $rule = new MailRule();
                $rule->setName(array_var($_POST, 'name'));
                $rule->save();
            }
    
            $account_rule = MailAccountRules::getByRuleId($rule->getId());
            if($account_rule){
                $account_rule->setAccountId(array_var($_POST, 'account'));
                $account_rule->save();
            }else{
                $account_rule = new MailAccountRule();
                $account_rule->setAccountId(array_var($_POST, 'account'));
                $account_rule->setRuleId($rule->getId());
                $account_rule->save();
            }
    
            //from condition
            $rule_condition_from = MailRuleConditions::getByRuleId($rule->getId(),"from");
            if(array_var($_POST, 'from')){                    
                if($rule_condition_from){
                    $rule_condition_from->setValue(array_var($_POST, 'from'));
                    $rule_condition_from->save();
                }else{
                    $rule_condition_from = new MailRuleCondition();
                    $rule_condition_from->setRuleId($rule->getId());
                    $rule_condition_from->setField("from");
                    $rule_condition_from->setOperator('LIKE');
                    $rule_condition_from->setValue(array_var($_POST, 'from'));
                    $rule_condition_from->save();
                }                    
            }else{
                if($rule_condition_from){
                    $rule_condition_from->delete();
                }
            }  
    
            //to condition
            $rule_condition_to = MailRuleConditions::getByRuleId($rule->getId(),"to");    
            if(array_var($_POST, 'to')){                    
                if($rule_condition_to){
                    $rule_condition_to->setValue(array_var($_POST, 'to'));
                    $rule_condition_to->save();
                }else{
                    $rule_condition_to = new MailRuleCondition();
                    $rule_condition_to->setRuleId($rule->getId());
                    $rule_condition_to->setField("to");
                    $rule_condition_to->setOperator('LIKE');
                    $rule_condition_to->setValue(array_var($_POST, 'to'));
                    $rule_condition_to->save();
                }                    
            }else{
                if($rule_condition_to){
                    $rule_condition_to->delete();
                }
            }
    
            //subject condition
            $rule_condition_subject = MailRuleConditions::getByRuleId($rule->getId(),"subject");
            if(array_var($_POST, 'subject')){                    
                if($rule_condition_subject){
                    $rule_condition_subject->setValue(array_var($_POST, 'subject'));
                    $rule_condition_subject->save();
                }else{                        
                    $rule_condition_subject = new MailRuleCondition();
                    $rule_condition_subject->setRuleId($rule->getId());
                    $rule_condition_subject->setField("subject");
                    $rule_condition_subject->setOperator('LIKE');
                    $rule_condition_subject->setValue(array_var($_POST, 'subject'));
                    $rule_condition_subject->save();
                }
            }else{
                if($rule_condition_subject){
                    $rule_condition_subject->delete();
                }
            }
    
            //has_attachments condition
            $rule_condition_has_attachments = MailRuleConditions::getByRuleId($rule->getId(),"has_attachments");
            if(array_var($_POST, 'has_attachments')){
                if(!$rule_condition_has_attachments){
                    $rule_condition_has_attachments = new MailRuleCondition();
                    $rule_condition_has_attachments->setRuleId($rule->getId());
                    $rule_condition_has_attachments->setField("has_attachments");
                    $rule_condition_has_attachments->setOperator('=');
                    $rule_condition_has_attachments->setValue('1');
                    $rule_condition_has_attachments->save();
                }
            }else{
                if($rule_condition_has_attachments){
                    $rule_condition_has_attachments->delete();
                }
            }
    
            $rule_action = MailRuleActions::getByRule($rule->getId());
            if($rule_action){
                $rule_action->setAction(array_var($_POST, 'action_in_name'));
                $rule_action->setOrder('');
                $rule_action->setActionValue($action_value);
                $rule_action->save();
            }else{
                $rule_action = new MailRuleAction();
                $rule_action->setRuleId($rule->getId());
                $rule_action->setAction(array_var($_POST, 'action_in_name'));
                $rule_action->setOrder('');
                $rule_action->setActionValue($action_value);
                $rule_action->save();
            }               
    
            flash_success(lang('success add rule'));
            ajx_add("mails-panel", "start");
            
            $accounts = MailAccounts::getMailAccountsByUser(logged_user());
            tpl_assign('accounts', $accounts);
            $new_rule = true;
            tpl_assign('new_rule', $new_rule);
            
            
        }else{
            Logger::log($_GET);
            $new_rule = true;
            $style_classify = 'style="display: none;"';
            $style_forward = 'style="display: none;"';     
            $style_autoreply = 'style="display:none;"';
            
            if(array_var($_GET, 'from_classify')){
                $members_array = explode(', ', $_GET['members']);
                tpl_assign('members', $members_array);
                //tpl_assign('name_rule', $_GET['name_rule']);
                tpl_assign('rule_data', $_GET);
                $style_classify = 'style="list-style: none outside none;"';
                
            }elseif(get_id('rule_id')){
                
                $sql_edit = "SELECT mr.id, mr.name, ar.account_id, ra.action, ra.order, ra.action_value FROM `".TABLE_PREFIX."mail_rules` mr,`".TABLE_PREFIX."mail_account_rules` ar,`".TABLE_PREFIX."mail_rule_actions` ra
                             WHERE mr.id = ".get_id('rule_id')." AND ar.rule_id = mr.id AND ra.rule_id = mr.id";
                $rule = DB::executeAll($sql_edit);
    
                if($rule){
                    $rule_conditions = MailRuleConditions::getByRule($rule[0]['id']);
                    foreach ($rule_conditions as $condition){
                        $rule[0][$condition->getField()] = $condition->getValue();
                    }
                    
                    tpl_assign('rule_data', $rule[0]);
                    
                    $new_rule = false;                        
                    if($rule[0]['action'] == "classify"){
                        $style_classify = 'style="list-style: none outside none;"';
                    }elseif($rule[0]['action'] == "forward"){
                        $style_forward = '';
                    }elseif($rule[0]['action'] == "autoreply"){
                        $style_autoreply = 'style="display:block;"';
                    }
                }
            }
            
            if (array_var($_REQUEST, 'modal')) {
                tpl_assign('modal', true);
                tpl_assign('form_description',array_var($_GET, 'form_description'));
            }
    
            $accounts = MailAccounts::getMailAccountsByUser(logged_user());
            tpl_assign('accounts', $accounts);
            
            $actions_array[] = array("archive",lang('archive'));
            $actions_array[] = array("autoreply",lang('autoreply'));
            $actions_array[] = array("classify",lang('classify'));
            $actions_array[] = array("forward",lang('forward'));
            $actions_array[] = array("mark_read",lang('mark read'));
            $actions_array[] = array("mark_spam",lang('mark spam'));
            $actions_array[] = array("mark_not_spam",lang('mark not spam'));
            $actions_array[] = array("trash",lang('send to trash'));
            tpl_assign('actions', $actions_array);                    
            tpl_assign('new_rule', $new_rule);
            tpl_assign('style_c', $style_classify);
            tpl_assign('style_f', $style_forward);
            tpl_assign('style_autoreply', $style_autoreply);
        }
	}

        
        /**
	 * delete email rules
	 *
	 */
	function delete_rule() {
                ajx_current("empty");
                $rule = MailRules::findById(get_id('rule_id'));              
                $rule->delete();         
                
                flash_success(lang('success delete rule'));
	}

} // MailRulesController
