<?php
/**
 * MailTrackController
 *
 * 
 */
class MailTrackController extends ApplicationController {

	var $plugin_name = "mail_rules";

	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'website');
	}

	function read() {
		//do not track is is the user how read the mail
		if (logged_user() instanceof Contact && logged_user()->isUser()) {
			return false;
		}

		$email = MailContents::findById(get_id());
		
		if (!$email instanceof MailContent) {
			flash_error(lang('email dnx'));
			ajx_current("empty");
			return;
		}
		
		try {
			DB::beginWork();
			$email_track = MailTracks::findById($email->getObjectId());
			if (!$email_track instanceof MailTrack) {
				$email_track = new MailTrack(); 
				$email_track->setObjectId($email->getObjectId());
			}
			
			$email_track->setIp(get_ip_address());
			$email_track->setReadedOn(DateTimeValueLib::now());
			
			$email_track->save();
			DB::commit();			
			return;
		} catch(Exception $e) {
			DB::rollback();
			flash_error($e->getMessage());
			ajx_current("empty");
			return;
		}		
	}

}