<?php
set_page_title(lang('mail rules'));
$genid = gen_id();
$loc = user_config_option('localization');
if (strlen($loc) > 2) $loc = substr($loc, 0, 2);

$modal_input = '';
if (array_var($_REQUEST, 'modal')) {
    $modal_input = "<input type ='hidden' name='modal' value=1>";    
    $on_submit = "og.setDescription(); og.submit_modal_form('".$genid."submit-edit-form'); return false;";
    
}else{
    $on_submit = "og.setDescription();";
}
?>
<input type="hidden" id="<?php echo $genid ?>signatures" />
<script>
var sig = Ext.getDom('<?php echo $genid ?>signatures');
sig.accountSignatures = [];
sig.actualTextSignature = '';
sig.actualHtmlSignature = '';

</script>


<div id="<?php echo $genid ?>mailRules" class="adminMailAccounts modal-mail-rule-container" style="height: 100%; background-color: white">

    <div style="padding: 10px 15px 5px;" class="formBlock">

    <form style="height:100%;background-color:white" class="internalForm add-rule-form" action="<?php echo get_url('mail_rules', 'add_rule', array('rule_id' => array_var($rule_data, 'id'))); ?>" onsubmit="<?php echo $on_submit;?>" id="<?php echo $genid ?>submit-edit-form" method="post">
         <div class="editor-container form-tab ui-tabs-panel ui-corner-bottom">
            <?php
            	tpl_display(get_template_path('form_errors'));				
                $accounts_array = array();
                $orig_textsignature = $orig_htmlsignature = "";
                if ($modal_input != '')
                    echo $modal_input;
                ?><script type="text/javascript">
			    		sig.actualTextSignature = sig.actualHtmlSignature = "";
			    </script> <?php                  
                	$account_number = 0;
                    foreach($accounts as $account){
                    		$account_number+=1; //to count the order of the email accounts
                            $accounts_array[] = array($account->getId(),$account->getEmail());                            						
							$user_settings = MailAccountContacts::getByAccountAndContact($account, logged_user());
							$default_acc_id = 0;
					    	if ($user_settings instanceof MailAccountContact) {
					    		$sig = $user_settings->getSignature();
					    		if($user_settings->getIsDefault() || $account_number == 1) {
					    			$default_acc_id = $user_settings->getAccountId();
					    			$default_acc_number = $account_number;
					    		}
					    	} else {
					    		$sig = "";
					    	}
					    	$sig = nl2br($sig);
					    	
					    	$htmlsig = str_replace(array("\r", "\n"), "", "<div class=\"fengoffice_signature\">$sig</div>");
					    	$textsig = html_to_text($sig);					    	
					    	if ($default_acc_id) {
						    	if ($account->getId() == $default_acc_id) {
						    		$orig_textsignature = $textsig;
						    		$orig_htmlsignature = $htmlsig;						    								    		
						    ?><script type="text/javascript">
						    		sig.actualTextSignature = <?php echo json_encode($textsig) ?>;
						    		sig.actualHtmlSignature = <?php echo json_encode($htmlsig) ?>;
						    </script> <?php
						    	}
					    	}
							?>
							<script type="text/javascript">
									sig.accountSignatures[sig.accountSignatures.length] = {acc:'<?php echo $account->getId() ?>', htmlsig:<?php echo json_encode($htmlsig) ?>, textsig:<?php echo json_encode($textsig) ?>};
							</script> <?php 								
                    }         

	            
	            
	            ?>
	            
	<div class="coInputHeader modal-rule-header">

            <div class="coInputHeaderUpperRow">
                <div class="coInputTitle">
                	<?php echo $new_rule ? lang('new rule') : lang('edit rule') ?>
                </div>
            </div>
            
            <div>
                <div class="coInputName">
            		<?php 
            		echo text_field('name', array_var($rule_data, 'name'),array('id' => $genid . 'name', 'class' => 'title', 'placeholder' => lang('type name here'), 'tabindex' => '2'));
            		?>
        		</div>
        		<div class="coInputButtons">
        			<?php echo submit_button(array_var($rule_data, 'id') ? lang('save changes') : lang('add rule'), 's', array('tabindex' => '1500', 'class' => 'blue', 'style'=>'margin-top:0px;margin-left:10px')); ?>
        		</div>
        		<div class="clear"></div>
			</div>

	</div>
  	<div class="coInputMainBlock rule-main-block">
            <?php if (isset($form_description)){ ?>
                <div class="input-container">            
                    <div class="coInputDescription">            
                		<div class="coInputDescription"><?php echo $form_description; ?></div>
                	</div>
            	</div>
            <?php } ?>        
        <?php 
        
        echo '<div class="input-container">';
        if(count($accounts) > 1 ){
            echo label_tag(lang('account'), $genid . 'account', true);
            echo simple_select_box('account', $accounts_array, $default_acc_number, array('id' => $genid . 'account','tabindex' => "1", 'onchange' => "og.changeSignature('$genid'+'autoreply', this.value, true);"));
        }else{
            echo text_field('account', $accounts[0]->getId(),array('id' => $genid . 'account','type' => 'hidden', 'tabindex' => '2'));
        }
        echo '</div>';
        echo '<div class="input-container">';
        echo label_tag(lang('from'), $genid . 'from');
        echo text_field('from', array_var($rule_data, 'from'),array('id' => $genid . 'from', 'class' => 'title', 'tabindex' => '3'));
        echo '</div>';
        echo '<div class="input-container">';
        echo label_tag(lang('to'), $genid . 'to');
        echo text_field('to', array_var($rule_data, 'to'),array('id' => $genid . 'to', 'class' => 'title', 'tabindex' => '4'));
        echo '</div>';

        echo '<div class="input-container">';
        echo label_tag(lang('subject'), $genid . 'subject');
        echo text_field('subject', array_var($rule_data, 'subject'),array('id' => $genid . 'subject', 'class' => 'title', 'tabindex' => '5'));
        echo '</div>';
        echo '<div class="clear"></div>';
        echo '<div>';
        echo label_tag(lang('has attachments'), $genid . 'has_attachments');
        echo checkbox_field('has_attachments', array_var($rule_data, 'has_attachments'), array('id' => $genid.'attachments', 'tabindex'=>'6'));
        echo '</div>';
    ?>
        <table style="margin:10px 0; width: 100%;">
            <tr>
                <td style="width:150px; padding-right: 10px;">
                    <?php
                        echo '<div class="input-container">';                    
                        echo label_tag(lang('action'), $genid . 'action', true);                
                        echo simple_select_box('action_in_name', $actions,array_var($rule_data, 'action'),array('id' => $genid . 'action','tabindex' => "7"));
                        echo '</div>';                        
                    ?>
                </td>
           </tr>
           <tr>
                <div class="clear"></div>
                <td id="<?php echo $genid;?>action_value_forward" <?php echo $style_f;?> width="229px">
                    <?php       
                        echo '<div class="input-container">';                    
                        echo label_tag(lang('action value'), $genid . 'action', true);
                        echo text_field('action_value_forward', array_var($rule_data, 'action_value'),array('id' => $genid . 'action_value_forward', 'tabindex' => '10','style'=>'width:229px; '.$style_f));
                        echo '</div>';
                        
                    ?>
                </td>                  
                <td id="<?php echo $genid;?>action_value_classify" <?php echo $style_c;?> width="600px">
                    <?php       
                        echo label_tag(lang('action value'), $genid . 'action', true);
                        if ($new_rule || (!$new_rule && array_var($rule_data, 'action') != "classify")) {
                                if (array_var($_GET, 'from_classify')){
                                    echo '<input type="hidden" name="from_classify" />';
                                    render_member_selectors(MailContents::instance()->getObjectTypeId(), $genid, $members, array('select_current_context' => false));
                                }else{
                                    render_member_selectors(MailContents::instance()->getObjectTypeId(), $genid, null, array('select_current_context' => true));
                                }
                                 
                        } else {
                                $action_v = explode(",",array_var($rule_data, 'action_value'));
                                render_member_selectors(MailContents::instance()->getObjectTypeId(), $genid, $action_v); 
                        } 
                    ?>
                </td>
            </tr>               
        </table>  
                
        <div id="<?php echo $genid;?>action_value_autoreply" <?php echo $style_autoreply;?> colspan="4">
                    <?php                
                         if($new_rule) {	                         	
    	                        $ckEditorContent = '<br />--<br />'.$orig_htmlsignature;
    	                 } else {
    	                 		$ckEditorContent = array_var($rule_data, 'action_value');			                 
    	                 }
                    ?>
                        <div>
    			            <?php echo label_tag(lang('autoreply_text'), $genid . 'autoreply', false) ?>
    			            <div id="<?php echo $genid ?>ckcontainer">
    			                <textarea cols="60" id="<?php echo $genid ?>ckeditor" name="action_value_autoreply" rows="10"><?php echo clean($ckEditorContent) ?></textarea>
    			            </div>
    			        </div>
    			        
    			        <script>
    			            var h = document.getElementById("<?php echo $genid ?>ckcontainer").offsetHeight;
    			            var editor = CKEDITOR.replace('<?php echo $genid ?>ckeditor', {
    			                height: (h-200) + 'px',
    			            	allowedContent: true,
    			                enterMode: CKEDITOR.ENTER_BR,
    			                shiftEnterMode: CKEDITOR.ENTER_BR,
    			                disableNativeSpellChecker: false,
    			                language: '<?php echo $loc ?>',
    			                customConfig: '',
    			            	contentsCss: ['<?php echo get_javascript_url('ckeditor/contents.css').'?rev='.product_version_revision();?>', '<?php echo get_stylesheet_url('og/ckeditor_override.css').'?rev='.product_version_revision();?>'],
    			                toolbar: [
    						                   ['Font','FontSize','-','Bold','Italic','Underline', 'Blockquote','-',
    							                'SpellChecker','Scayt','-',
    			                                'TextColor','BGColor','RemoveFormat','-',
    			                                'Link','Unlink','-',
    			                                'JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock']
    			                        ],
    			                on: {
    			                        instanceReady: function(ev) {
    			                                og.adjustCkEditorArea('<?php echo $genid ?>');
    			                                editor.resetDirty();
    			                        }
    			                    },
    			    			fillEmptyBlocks: false,
    			    			removePlugins: 'scayt,liststyle,magicline',
    			                entities_additional : '#39,#336,#337,#368,#369'
    			            });
    			
    			            og.setDescription = function() {					            		
    			                    var form = Ext.getDom('<?php echo $genid ?>submit-edit-form');
    			                    if (form.preventDoubleSubmit) return false;
    			
    			                    setTimeout(function() {
    			                            form.preventDoubleSubmit = false;
    			                    }, 2000);
    			
    			                    var editor = og.getCkEditorInstance('<?php echo $genid ?>ckeditor');
    			                    form['action_value_autoreply'].value = editor.getData();				                  
    			
    			                    return true;
    			            };   
    			        </script>	      	    				         
                
        </div>
    </div> <!-- echo '<div class="coInputMainBlock">'; -->
            
            </div>
        </form>
    </div>
    </div>
</div>

<script>
	var div = document.getElementById('<?php echo $genid ?>mailRules');
	div.parentNode.style.backgroundColor = '#FFFFFF'; 
        
        $('#<?php echo $genid?>action').change(function() {
            if($(this).val() == "forward"){
                $('#<?php echo $genid;?>action_value_forward').show();
                $('#<?php echo $genid;?>action_value_classify').hide();
                $('#<?php echo $genid;?>action_value_autoreply').hide();                              
            }else if($(this).val() == "classify"){
                $('#<?php echo $genid;?>action_value_classify').show();
                $('#<?php echo $genid;?>action_value_forward').hide();
                $('#<?php echo $genid;?>action_value_autoreply').hide();
            }else if($(this).val() == "autoreply"){
                $('#<?php echo $genid;?>action_value_classify').hide();
                $('#<?php echo $genid;?>action_value_forward').hide();
                $('#<?php echo $genid;?>action_value_autoreply').show();
            }else{
                $('#<?php echo $genid;?>action_value_classify').hide();
                $('#<?php echo $genid;?>action_value_forward').hide();
                $('#<?php echo $genid;?>action_value_autoreply').hide();
            }
        });
</script>
