<?php
set_page_title(lang('mail rules'));
add_page_action(lang('add rule'), "javascript:og.render_modal_form('', {c:'mail_rules', a:'add_rule'});", 'ico-add',null,null,true);
$genid = gen_id();
?>

<div id="<?php echo $genid ?>mailRules" class="adminMailAccounts" style="height: 100%; background-color: white">
    <div class="coInputHeader">
        <div class="coInputTitle"><?php echo lang('mail rules') ?></div>
    </div>
    <div class="adminMainBlock">
        <?php if(isset($rules) && is_array($rules) && count($rules)) { ?>
        <table class="adminListing" style="min-width: 400px; margin-top: 10px;">
                <tr>
                        <th><?php echo lang('rule name') ?></th>
                        <th><?php echo lang('account') ?></th>
                        <th><?php echo lang('options') ?></th>
                </tr>
                <?php
                $isAlt = true;
                foreach($rules as $rule) {
                        $isAlt = !$isAlt;
                ?>
                <tr class="<?php echo $isAlt? 'altRow' : ''?>" id="<?php echo $genid ?>tr_<?php echo $rule["id"]?>">
                        <td><?php echo clean($rule["name"]) ?></td>
                        <td><?php echo $rule["email"] ?></td>
                        <?php
                        $options = array();
                        $options[] = '<a class="internalLink" href="javascript:og.render_modal_form(\'\', {c:\'mail_rules\', a:\'add_rule\', params: {rule_id:'. $rule["id"] .'}})">' . lang('edit') . '</a>';
                        
                        $options[] = '<a class="internalLink" href="javascript:og.DeleteRule(' . $rule["id"] . ')">' . lang('delete') . '</a>';
                        
                        ?>
                        <td style="font-size: 80%;"><?php echo implode(' | ', $options) ?></td>
                </tr>
                <?php } // foreach ?>
        </table>
        <?php } else { ?> <?php echo lang('no mail rules') ?> <?php } // if ?>
    </div>
</div>

<script>
	var div = document.getElementById('<?php echo $genid ?>mailRules');
	div.parentNode.style.backgroundColor = '#FFFFFF'; 
        
        og.DeleteRule = function(ruleId) {        
                                if (confirm(lang('delete rule'))) {
                                        og.openLink(og.getUrl('mail_rules', 'delete_rule', {
                                                rule_id : ruleId
                                        }));
                                        $('#<?php echo $genid ?>tr_'+ruleId).remove();
                                }
        };
        
//        og.DeleteRule = function(ruleId) {
//                Ext.MessageBox.confirm(
//	                    '',
//	                    '<?php echo lang('delete rule') ?>',
//	                    function(btn){
//	                    	if(btn == 'yes')
//	                    	{
//                                     og.openLink(og.getUrl('mail_rules', 'delete_rule', {
//                                            rule_id : ruleId
//                                     }));
//
//                                 }
//	    	        });
//        };
</script>
