<?php
/**
 * Created on 13/2/2012
 * @author Andres Botta 
 */
Hook::register ( "mail_rules" );

function mail_rules_delete_member($member){
    $sql = "SELECT * FROM ".TABLE_PREFIX."mail_rule_actions WHERE FIND_IN_SET( '" . $member->getId() . "', action_value) AND action = 'classify'";
    $member_delete_rule = DB::executeAll($sql);
    if(count($member_delete_rule) > 0){
        foreach ($member_delete_rule as $delete_rule){
            $rule = MailRules::findById($delete_rule['rule_id']);
            $rule->delete();
        }        
    }
}

function mail_rules_after_mail_download($mail, &$after_download_data){
    $mail_rules = MailAccountRules::getByAccount($mail->getAccountId());
    $log_data = array();
    foreach ($mail_rules as $rule){
        $rule_conditions = MailRuleConditions::getByRule($rule->getRuleId());
        
        $conditions = "object_id = ".$mail->getObjectId();
        if($rule_conditions){
        	$conditions .= " AND ";
        }
        $and = "";
        foreach ($rule_conditions as $condition){
        	switch($condition->getOperator()) {
        		case 'LIKE':
        			$operator = "LIKE '%".mysqli_real_escape_string(DB::connection()->getLink(), $condition->getValue())."%'";
        			break;
        		default:
        			$operator = "= '".mysqli_real_escape_string(DB::connection()->getLink(), $condition->getValue())."'";
        			break;
        	}
        	$conditions .= "".$and." `".$condition->getField()."` ".$operator."";
        	$and = " AND";
        }
        
        $mail_conditions = MailContents::getConditionsRules($conditions);
        
        if($mail_conditions){            
            $rule_actions = MailRuleActions::getByRule($rule->getRuleId());
            if($rule_actions){
	            $this_rule_log = array('id' => $rule->getRuleId(), 'action' => $rule_actions->getAction(), 'value' => $rule_actions->getActionValue());
                 switch($rule_actions->getAction()) {
                            case 'archive': 
                                    $object = Objects::findObject($mail->getObjectId());
                                    $object->archive();
                                    break;
                            case 'autoreply':                            	
                            	 	$utils = new MailUtilities();
                                    $account = MailAccounts::findById($mail->getAccountId());                            		
                                    $errorMailId = $mail->getId();
                                    $to = $mail->getFrom();                                    
                                    $from = array($account->getEmailAddress() => $account->getFromName());
                                    $subject = lang('reply to').$mail->getSubject();
                                    $body = $rule_actions->getActionValue();
                                    $cc = $mail->getCc();
                                    $bcc = $mail->getBcc();
                                    $type = $mail->getBodyHtml() != '' ? 'text/html' : 'text/plain';
                                    $msg_id = $mail->getMessageId();
                                    $in_reply_to_id = $mail->getInReplyToId();                                  
                                    $mail->setSentDate(DateTimeValueLib::now());
                                    $mail->setReceivedDate(DateTimeValueLib::now());									
                					if (defined('DEBUG') && DEBUG) {
                                    	file_put_contents(ROOT."/cache/log_mails.txt", gmdate("d-m-Y H:i:s") . " before sending autoreply: ".$mail->getId() . "\n", FILE_APPEND);
                                    }

                                    $utils->sendMail($account->getSmtpServer(), $to, $from, $subject, $body, $cc, $bcc, null, $account->getSmtpPort(), $account->smtpUsername(), $account->smtpPassword(), $type, $account->getOutgoingTrasnportType(), $msg_id, $in_reply_to_id, null, $complete_mail, null);
                                    break;                            		
                            case 'classify':
                            		if (Plugins::instance()->isActivePlugin('mail')) {
	                                    $mail_controller = new MailController();
	                                    $member_ids = array_filter(explode(',', $rule_actions->getActionValue()));
	                                    if (count($member_ids) > 0) {
											$mail_controller->do_classify_mail($mail, $member_ids, null, true, true);
	                                    }

										if (defined('DEBUG') && DEBUG) file_put_contents(ROOT."/cache/log_mails.txt", gmdate("d-m-Y H:i:s") . " email ".$mail->getId()." classified by rule: ".$rule->getRuleId()." in ".$rule_actions->getActionValue()."\n", FILE_APPEND);
                                    } else {
                                    	$account = MailAccounts::findById($mail->getAccountId());
	                            		$account_owner = Contacts::findById($account->getContactId());
	                                    $ctrl = new ObjectController() ;
	                                    $ctrl->add_to_members($mail, array($rule_actions->getActionValue()), $account_owner);
                                    }
                                    break;                                    
                            case 'forward':
                                    if (defined('DEBUG') && DEBUG) file_put_contents(ROOT."/cache/log_mails.txt", gmdate("d-m-Y H:i:s") . " before sending foward mail from rule: ".$mail->getId() . "\n", FILE_APPEND);

                                    MailUtilities::add_mail_foward($mail, $rule_actions->getActionValue());

                                    break;
                            case 'mark_read': 
                                    $read = true;
                                    $account = MailAccounts::findById($mail->getAccountId());
                                    $mark_conversation = user_config_option('show_emails_as_conversations');
                                    $obj = Objects::findObject($mail->getObjectId());
                                    if ($obj) {
                                            $obj->setIsRead($account->getContactId(), $read);
                                            if (Plugins::instance()->isActivePlugin('mail')) {
                                                    if ($obj instanceof MailContent && $mark_conversation) {
                                                            $emails_in_conversation = MailContents::getMailsFromConversation($obj);
                                                            foreach ($emails_in_conversation as $email) {
                                                                    $email->setIsRead($account->getContactId(), $read);
                                                            }
                                                    }
                                            }
                                    }
                                    break;
                            case 'mark_spam': 
                                    mark_spam_or_not_spam($mail,"spam","4");      
                                    break;
                            case 'mark_not_spam': 
                                    mark_spam_or_not_spam($mail,"no spam","0");  
                                    break;
                            case 'trash': 
                                    $object = Objects::findObject($mail->getObjectId());
                                    if (!logged_user() instanceof Contact) {
                                    	$account = MailAccounts::findById($mail->getAccountId());
                                    	$account_owner = $account ? Contacts::findById($account->getContactId()) : null;
                                    	if ($account_owner) CompanyWebsite::instance()->logUserIn($account_owner);
                                    }
                                    $object->trash();
                                    break;
                }
                
                $log_data[] = $this_rule_log;
            }
        }
    }
    
    if (count($log_data) > 0) {
    	$after_download_data .= "email rules applied = ".json_encode($log_data);
    }
}

function mark_spam_or_not_spam($mail,$state,$num_state){
    $spam_email = MailSpamFilters::getRow($mail);                                            
    if ($spam_email){
        $spam_email[0]->setSpamState($state);
        $spam_email[0]->save();

        $mail->setState($num_state);
        $mail->save();
    }else{
        $spam_filter = new MailSpamFilter();
        $spam_filter->setAccountId($mail->getAccountId());
        $spam_filter->setTextType('email_address');
        $spam_filter->setText($mail->getFrom());
        $spam_filter->setSpamState($state);
        $spam_filter->save();

        $mail->setState($num_state);
        $mail->save();
    }    
}

function readAttachmentsFromFileSystem(MailContent $mail, &$att_version) {
        $att_version = 2;
        if ($mail->getHasAttachments() && FileRepository::isInRepository($mail->getContentFileId())) {

                $attachments = array();
                $content = FileRepository::getFileContent($mail->getContentFileId());
                if (str_starts_with($content, "--")) {
                        $att_version = 1;
                } else if (str_starts_with($content, "#att_ver")) {
                        $att_version = trim(str_replace("#att_ver", "", substr($content, 0, strpos($content, "\n"))));
                }
                if ($att_version < 2) {
                        $i=0; $offset = 0;
                        while ($offset < strlen($content)) {
                                $delim = "--000000000000000000000000000$i";
                                if (strpos($content, $delim, $offset) !== FALSE) {
                                        $offset = strpos($content, $delim) + strlen($delim);
                                        $endline = strpos($content, ";", $offset);
                                        $name = substr($content, $offset + 1, $endline - $offset - 1);
                                        $pos = strpos($name, ":");
                                        $name = trim(substr($name, $pos+1, strlen($name) - $pos - 1));

                                        $offset = $endline + 1;
                                        $endline = strpos($content, ";", $offset);
                                        $type = substr($content, $offset + 1, $endline - $offset - 1);
                                        $pos = strpos($type, ":");
                                        $type = trim(substr($type, $pos+1, strlen($type) - $pos - 1));

                                        $offset = $endline + 1;
                                        $endline = strpos($content, "$delim--");
                                        $attachments[] = array('name' => $name, 'type' => $type, 'data' => base64_decode(trim(substr($content, $offset, $endline - $offset - 1))));
                                        $offset = strpos($content, "$delim--") + strlen("$delim--")+1;
                                } else break;
                                $i++;
                        }
                } else {
                        $lines = explode("\n", $content);
                        foreach ($lines as $line) {
                                if (!str_starts_with($line, "#") && trim($line) !== "") {
                                        $data = explode("|", $line);
                                        if (FileRepository::getBackend() instanceof FileRepository_Backend_FileSystem ) {
                                                $path = FileRepository::getBackend()->getFilePath($data[2]);
                                        } else {
                                                $path = ROOT."/tmp/".gen_id();
                                                file_put_contents($path, FileRepository::getFileContent($data[2]));
                                        }
                                        $attachments[] = array('name' => $data[0], 'type' => $data[1], 'path' => $path, 'repo_id' => $data[2]);
                                }
                        }
                }
        } else $attachments = null;

        return $attachments;
}

function  mail_rules_more_content_templates($object, &$more_content_templates) {
	if (Plugins::instance()->isActivePlugin('mail')) {
		if ($object instanceof MailContent && ($object->getState() == 3 || $object->getState() == 1)) {
			$more_content_templates[] = array(
					'mail_track_list',
					'mail_track',
					'mail_rules',
			);
		}
	}	
}


function mail_rules_override_email_list_filters($parameters, &$attributes) {
	// add the archived filter to the list parameters
	if (isset($_REQUEST['archived_filter']) && in_array($_REQUEST['archived_filter'], array('all','archived','unarchived'))) {
		$attributes['archivedType'] = array_var($_REQUEST, 'archived_filter');
	} else {
		$attributes['archivedType'] = user_config_option('mails archived filter');
	}
}





function mail_rules_after_classify_object($parameters){

	$members = $parameters['members'];
	$object = $parameters['object'];

	if (!$parameters['is_multiple_classify']){

		if (count($members) > 0 && $object instanceof MailContent){

			// create the email rule to classify future emails in the new member
			$rule_exists = MailRuleConditions::findOne(array("conditions" => array("`field`='from' AND `operator`='like' AND `value`=?", $object->getFrom())));
			if (!$rule_exists instanceof MailRuleCondition) {
				$member_ids = array();
				$member_names = array();
				foreach ($members as $member){
					$member_ids[] = $member->getId();
					$member_names[] = $member->getName();
				}
				$params = array(
					'params' => array(
						'from_clasify'=>1,
						'member_ids'=>$member_ids,
						'name'=>implode(", ", $member_names),
						'from'=>$object->getFrom()
					)
				);

				if(config_option('enable_suggestion_to_create_mail_rules')){
				    evt_add('ask to create email rules',$params);
                }
			}
		}
	}
}


