
/************************************************
Container for EventManager,
*************************************************/
og.EventManagerPanel = function() {
	this.doNotRemove = true;
	this.needRefresh = false;
	
	og.EventManagerPanel.superclass.constructor.call(this, {
		id: 'event-manager-container',
		layout: 'fit',
		border: false,
		bodyBorder: false,
		items: [
	        new Ext.TabPanel({
				id: 'events-tabs-panel',
				cls: 'subtab',
				activeTab: 0,
				enableTabScroll: false,
				items: [
				     {title:lang("association events"), id: 'event-tab-1', html:'<div id="event-tab-eventlist" style="height:100%;"></div>'},
				     {title:lang("agenda"), id: 'event-tab-2', html:'<div id="event-tab-calendar" style="height:100%;"></div>'}
				],
				listeners: {
					resize: function(tabp, adjWidth, adjHeight, rawWidth, rawHeight) {
						if (!tabp) return;
						var t = tabp.activeTab;
						if (!t) return;
						if (t.id == 'event-tab-1') {
							if (og.EventManagerPanel.event_list) og.EventManagerPanel.event_list.fireEvent("resize");
						}
					},
					tabchange: function(tabp, t) {
						if (t.id == 'event-tab-1') {
							
							if (!og.EventManagerPanel.event_list) {
								og.EventManagerPanel.event_list = new og.ObjectGrid({
									renderTo: 'event-tab-eventlist',
									url: og.getUrl('managed_events', 'list_all'),
									type_name: 'managed_event',
									response_objects_root: 'managed_events',
									grid_id: 'managed-events-manager',
									nameRenderer: og.gridManagedEventNameRenderer,
									fixed_height: true,
									forceFit: true,
									store_params: {
										url_controller: 'managed_events',
										url_action: 'list_all'
									},
									checkbox_sel_model: true,
									columns: og.managed_events.events_list_grid_config.columns,
									add_default_actions_column: false,
									tbar_items: og.managed_events.events_list_grid_config.tbar_items
								});
								og.EventManagerPanel.event_list.load();
							}
							og.EventManagerPanel.event_list.fireEvent('resize');
							
							
						} else if (t.id == 'event-tab-2') {
							
							og.openLink(og.getUrl('event','view_calendar'), {
								preventPanelLoad: true,
								callback: function(success, data) {
									$("#event-tab-calendar").html(data.current.data);
								}
							});
							
						}
					}
					
				},
				scope: this
			})
		],
		scope: this
	});
}

Ext.extend(og.EventManagerPanel, Ext.Panel, {
	load: function(params) {
		if (og.EventManagerPanel.event_list) og.EventManagerPanel.event_list.load(params);
		this.loadCalendar();
	},
	activate: function() {
		if (og.EventManagerPanel.event_list) og.EventManagerPanel.event_list.activate();
		this.loadCalendar();
	},	
	reset: function() {
		if (og.EventManagerPanel.event_list) og.EventManagerPanel.event_list.reset();
		this.loadCalendar();
	},
	loadCalendar: function() {
		og.openLink(og.getUrl('event','view_calendar'), {
			preventPanelLoad: true,
			callback: function(success, data) {
				$("#event-tab-calendar").html(data.current.data);
			}
		});
	},
	showMessage: function(text) {
	}
});

Ext.reg("events-containerpanel", og.EventManagerPanel);

