<?php

/**
 * MemberAssociationAttributes controller
 *
 * @version 1.0
 * @author Alvaro Torterola <alvaro.torterola@fengoffice.com>
 */
class MemberAssociationAttributesController extends ApplicationController {

	var $plugin_name = "member_association_attributes";
	
	/**
	 * Construct the MemberAssociationAttributesController
	 *
	 * @access public
	 * @param void
	 * @return MemberAssociationAttributesController
	 */
	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'website');
		
	} // __construct
	
	
	
	function get_all_associations_with_attributes() {
	
		ajx_current("empty");
		
		$assoc_attributes_data = array();
		$assoc_attributes = MemberAssociationAttributes::instance()->findAll(array("order" => "`order`"));
		
		foreach ($assoc_attributes as $assoc_attribute) {/* @var $assoc_attribute MemberAssociationAttribute */
			
			$data = $assoc_attribute->getArrayInfo();
			
			if (!isset($assoc_attributes_data[$data['association_id']])) $assoc_attributes_data[$data['association_id']] = array();
			$assoc_attributes_data[$data['association_id']][] = $data;
		}
		
		ajx_extra_data(array('association_attributes' => $assoc_attributes_data));
	}
	
	

} // MemberAssociationAttributesController

