<?php 

class MemberPropertyMemberAttributes extends BaseMemberPropertyMemberAttributes {
	
	
	static function getFormattedAttributeValues($assoc_id, $member_id, $assoc_member_id) {
		
		$sql = "
			SELECT * FROM ".TABLE_PREFIX."member_property_member_attributes v
			INNER JOIN ".TABLE_PREFIX."member_association_attributes a ON v.attribute_id = a.id
			INNER JOIN ".TABLE_PREFIX."member_property_members m ON v.mpm_id = m.id
			WHERE m.member_id='$member_id' AND m.property_member_id='$assoc_member_id' AND m.association_id='$assoc_id'
			ORDER BY `order`;
		";
		
		$all_rows = DB::executeAll($sql);
		
		$formatted_values = array();
		
		if (is_array($all_rows)) {
			foreach ($all_rows as $row) {
				$value = $row['value'];
				if ($value == '') continue;
				
				if ($row['type'] == 'date') {
					$dt_val = DateTimeValueLib::dateFromFormatAndString(DATE_MYSQL, $value);
					$value = format_date($dt_val, null, 0);
					
				} else if ($row['type'] == 'boolean') {
					$value = $value > 0 ? lang('yes') : lang('no');
				}
				
				$formatted_values[] = array(
						'id' => $row['attribute_id'],
						'name' => $row['name'],
						'value' => $value,
				);
			}
		}
		
		return $formatted_values;
	}
	
	
	static function getAttributeValue($mpm_id, $attribute_id) {
		$row = self::findOne(array("conditions" => array("mpm_id=? AND attribute_id=?", $mpm_id, $attribute_id)));
		
		$value = '';
		if ($row instanceof MemberPropertyMemberAttribute) {
			$value = $row->getValue();
		}
		
		return  $value;
	}
	
	
}
