<?php 

$ordered_member_types = array();
$object_types_tmp = ObjectTypes::instance()->findAll(array(
	"conditions" => "`type` IN ('dimension_group') 
		AND IF(plugin_id IS NULL OR plugin_id=0, true, (SELECT p.is_activated FROM ".TABLE_PREFIX."plugins p WHERE p.id=plugin_id) = true)
		AND name NOT IN ('project_folder', 'customer_folder', 'person', 'company')", 
	"order" => "name"
));
$object_types_tmp_ids = array();
foreach ($object_types_tmp as $ot) {
	$object_types_tmp_ids[] = $ot->getId();
}
foreach ($object_types_tmp as $ot) {
    $ot_id = $ot->getId();
    $dim_ids = DimensionObjectTypes::getDimensionIdsByObjectTypeId($ot_id);
    if (is_array($dim_ids) && count($dim_ids) > 0 ){
    	$dimension = Dimensions::getDimensionById($dim_ids[0]);
    	if ($dimension instanceof Dimension) {
	    	$dot_ids = DimensionObjectTypes::instance()->getObjectTypeIdsByDimension($dimension->getId());
	    	
	    	$no_folder_ots_count = 0;
	    	if (count($dot_ids) > 0) {
	    		$ots = ObjectTypes::findAll(array("conditions" => "id IN (".implode(',',$dot_ids).") AND id IN (".implode(',',$object_types_tmp_ids).")"));
	    		foreach ($ots as $ot) {
	    			if ($ot->getName() != 'folder' && $ot->getName() != 'project_folder' && $ot->getName() != 'customer_folder') {
	    				$no_folder_ots_count++;
	    			}
	    		}
	    	} else {
	    		$ots = array();
	    	}
	    	
	    	if ($no_folder_ots_count == 1 && $ot->getName() != 'folder') {
	    		$ot_label = $dimension->getName();
	    	} else {
	    		$ot_label = lang($ot->getName() . "s");
	    	}
	    	$ordered_member_types[$ot_id] = $ot_label;
    	} else {
    		$ordered_member_types[$ot_id] = lang($ot->getName() . "s");
    	}
    }else{
        $ordered_member_types[$ot_id] = lang($ot->getName() . "s");
    }
}
asort($ordered_member_types, SORT_STRING);

?>


	<div class="cp-admin-container member-cps-container">
	
		<div class="coInputHeader">
		  <div class="coInputHeaderUpperRow">
			<div class="coInputTitle">
				<?php echo lang('member custom properties') ?>
			</div>
		  </div>
		</div>
		
		<div class="coInputMainBlock adminMainBlock">
		  
			<ul class="object-type-list">
			<?php $cls = "odd";
				foreach ($ordered_member_types as $id => $name) {
					$cls = $cls == "even" ? 'odd' : "even";
					$url = get_url('member_custom_properties', 'list_custom_properties_for_type', array('id'=>$id));
			?>
				<li class="<?php echo $cls ?>">
					<a href="<?php echo $url ?>"><?php echo $name ?></a>
				</li>
				
			<?php } ?>
			</ul>
		  
		</div>
	
	</div>

