<div class="custom-properties"><?php
require_javascript("og/CustomProperties.js");

if ($member instanceof Member) {

	$ot = ObjectTypes::findById($member->getObjectTypeId());
	if ($ot->getName()=='project_folder' || $ot->getName()=='customer_folder') {
		$ot = ObjectTypes::findByName('folder');
	}
	
	if (!isset($genid)) $genid = gen_id();
	
	$cps = MemberCustomProperties::getAllMemberCustomPropertiesByObjectType($ot->getId(), $visibility);
	if ($visibility == 'others' && count($cps) == 0 && Plugins::instance()->isActivePlugin('member_custom_properties')) {
		echo "<div id='".$genid."_no_cp_msg'>" . lang('there are no custom properties defined message', strtolower(lang("the ".$ot->getName()."s")));
		echo '<br />'. lang('there are no custom properties defined link') . '</div>';
	}
	
	if (!$parent_member) $parent_member = 0;
	
	$ti = 0;
	
	if (!isset($startTi)) $startTi = 10000;
	
	if(count($cps) > 0){
		
		if (count($cps) > 10) {
			echo "<div class='cp-section cp-left'>";
		}
		$cp_idx = 0;
		
		$print_table_functions = false;
		foreach($cps as $customProp){
			if(!isset($required) || ($required && ($customProp->getIsRequired() || $customProp->getVisibleByDefault())) || (!$required && !($customProp->getIsRequired() || $customProp->getVisibleByDefault()))){
				$ti++;
				$cpv = MemberCustomPropertyValues::getMemberCustomPropertyValue($member->getId(), $customProp->getId());
				$default_value = $customProp->getDefaultValue();
				if($cpv instanceof MemberCustomPropertyValue){
					$default_value = $cpv->getValue();
				}
				$name = 'member_custom_properties['.$customProp->getId().']';
				echo '<div style="margin-top:12px">';
	
				if ($customProp->getType() == 'boolean'){
				    $id = $customProp->getId();
				    ?>
				    
            	    <select	id="<?php echo $genid .'cp'. $id?>" name="<?php echo $name; ?>">
            	    <option value ="0"></option>
            	    <option value ='1' <?php echo ($default_value == 1 ?  "selected"  : '' );?> > <?php echo lang('yes'); ?></option>
            	    <option value ='-1' <?php echo ($default_value == -1 ?  "selected" : ''); ?> > <?php echo lang('no'); ?></option>
            	    </select>
					
					<?php 
				}
					
	
				$label = clean($customProp->getName());
				if ($customProp->getIsSpecial()) {
					$label_code = str_replace("_special", "", $customProp->getCode());
					$label_value = Localization::instance()->lang($label_code);
					if (!is_null($label_value)) $label = $label_value;
				}
				
				echo label_tag($label, $genid . 'cp' . $customProp->getId(), $customProp->getIsRequired(), array('style' => 'display:inline;'), $customProp->getType() == 'boolean'?'':':');
				
				echo '</div>';
				
				switch ($customProp->getType()) {
					case 'text':
					case 'numeric':
					case 'memo':
						if($customProp->getIsMultipleValues()){
							$numeric = ($customProp->getType() == "numeric");
							echo "<table><tr><td>";
							echo '<div id="listValues'.$customProp->getId().'" name="listValues'.$customProp->getId().'">';
							$isMemo = $customProp->getType() == 'memo';
							$count = 0;
							$fieldValues = MemberCustomPropertyValues::getMemberCustomPropertyValues($member->getId(), $customProp->getId());
							if (!is_array($fieldValues) || count($fieldValues) == 0) {
								$def_cp_value = new MemberCustomPropertyValue();
								$def_cp_value->setValue($default_value);
								$fieldValues = array($def_cp_value);
							}
							foreach($fieldValues as $value){
								$value = str_replace('|', ',', $value->getValue());
								if($value != ''){
									echo '<div id="value'.$count.'">';
									if($isMemo){
										echo textarea_field($name.'[]', $value, array('id' => $name.'[]'));
									}else{
										echo text_field($name.'[]', $value, array('id' => $name.'[]'));
									}
									echo '&nbsp;<a href="#" class="link-ico ico-delete" onclick="og.removeCPValue('.$customProp->getId().','.($count).','.($isMemo ? 1 : 0).', 1)" ></a>';
									echo '</div>';
									$count++;
								}
							}
							echo '<div id="value'.$count.'">';
							if($customProp->getType() == 'memo'){
								echo textarea_field($name.'[]', '', array('id' => $name.'[]', 'class' => 'long'));
							}else{
								echo text_field($name.'[]', '', array('id' => $name.'[]'));
							}
							echo '&nbsp;<a href="#" class="link-ico ico-add" onclick="og.addCPValue('.$customProp->getId().',\''.$isMemo.'\', 1)">'.lang('add value').'</a><br/>';
							echo '</div>';
							echo '</div>';
							echo "</td></tr></table>";
							$include_script = true;
						} else {
							if($customProp->getType() == 'memo'){
								echo textarea_field($name, $default_value, array('class' => 'long', 'id' => $genid . 'cp' . $customProp->getId()));
							}else{
								echo text_field($name, $default_value, array('id' => $genid . 'cp' . $customProp->getId()));
							}
						}
						break;
					case 'boolean':
						break;
					case 'date':
					case 'datetime':
						// dates from table are saved as a string in "Y-m-d H:i:s" format
						if($customProp->getIsMultipleValues()){
							$name .= '[]';
							$count = 0;
							$fieldValues = MemberCustomPropertyValues::getMemberCustomPropertyValues($member->getId(), $customProp->getId());
							if (!is_array($fieldValues) || count($fieldValues) == 0) {
								$def_cp_value = new MemberCustomPropertyValue();
								$def_cp_value->setValue($default_value);
								$fieldValues = array($def_cp_value);
							}
							echo '<table id="table'.$genid.$customProp->getId().'">';
							$d_format = $customProp->getType() == 'datetime' ? "Y-m-d H:i:s" : "Y-m-d";
							foreach($fieldValues as $idx => $val){
								if (trim($val->getValue()) != '') {
									$value = DateTimeValueLib::dateFromFormatAndString($d_format, $val->getValue());
								} else {
									$value = "";
								}
								echo '<tr><td>';
								$d_name = str_replace('[]', '['.$idx.']', $name);
								
								echo pick_date_widget2($name, $value, null, null, null, $genid . 'cp' . $customProp->getId());
								if ($customProp->getType() == 'datetime') {
									$i_name = str_replace('['.$customProp->getId().'][]', '[time]['.$customProp->getId().']['.$idx.']', $name);
									echo '<div style="float:left;">'. pick_time_widget2($i_name, $value) . '</div><div class="clear"></div>';
								}
								echo '</td><td>';
								echo '<a href="#" class="link-ico ico-delete" onclick="og.removeCPDateValue(\''.$genid.'\','.$customProp->getId().','.$count.', 1)"></a>';
								echo '</td></tr>';
								$count++;
							}
							echo '</table>';
							$use_time = $customProp->getType() == 'datetime' ? "1" : "0";
							echo '&nbsp;<a href="#" class="link-ico ico-add" onclick="og.addCPDateValue(\''.$genid.'\','.$customProp->getId().', 1,'.$use_time.')">'.lang('add value').'</a><br/>';
						}else{
							$value = "";
							if ($default_value != '' && $default_value != EMPTY_DATE && $default_value != EMPTY_DATETIME) {
								try {
									$d_format = $customProp->getType() == 'datetime' ? "Y-m-d H:i:s" : "Y-m-d";
									$value = DateTimeValueLib::dateFromFormatAndString($d_format, $default_value);
								} catch (Exception $e) {
									try {
										$value = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), $default_value);
									} catch (Exception $e2) {
										Logger::log("Error when setting date custom property value:\n".$e2->getMessage()."\n\n".get_back_trace());
										$value = '';
									}
								}
								
							}
							$dval = isset ($value) && $value instanceof DateTimeValue && $value->toMySQL() != EMPTY_DATETIME ? $value : null;
							echo pick_date_widget2($name, $dval, null, null, null, $genid . 'cp' . $customProp->getId());
							if ($customProp->getType() == 'datetime') {
								$i_name = str_replace('['.$customProp->getId().']', '[time]['.$customProp->getId().']', $name);
								echo '<div style="float:left;">'. pick_time_widget2($i_name, $dval) . '</div><div class="clear"></div>';
							}
						}
						break;
					case 'list':
						$options = array();
						if(!$customProp->getIsRequired()){
							$options[] = '<option value=""></option>';
						}
						$totalOptions = 0;
						$multValues = MemberCustomPropertyValues::getMemberCustomPropertyValues($member->getId(), $customProp->getId());
						$toSelect = array();
						foreach ($multValues as $m){
							$toSelect[] = $m->getValue();
						}
						
						if($customProp->getIsMultipleValues()) {
							echo '<div class="multiple-list-custom-property">';
						}
						
						foreach(explode(',', $customProp->getValues()) as $value){
							
							$text = null;
							if (strpos($value, '@') !== false) {
								$exp = explode('@', $value);
								$value = array_var($exp, 0);
								$text = array_var($exp, 1);
							}
							
							$v = ($text == null ? $value : $text);
							if ($customProp->getCode() == "") {
								$text = $v;
							} else {
								$text = Localization::instance()->lang($v);
								if (is_null($text)) $text = $v;
							}
							
							
							$selected = ($value == $default_value) || ($customProp->getIsMultipleValues() && (in_array($value, explode(',', $default_value)))||in_array($value,$toSelect));
							
							if($selected){
								$options[] = '<option value="'. clean($value) .'" selected>'. clean($text) .'</option>';
							}else{
								$options[] = option_tag($text, $value);
							}
							
							if($customProp->getIsMultipleValues()) {
								echo '<div class="cp-list-multiple-option-container">';
								echo checkbox_field($name."[$value]", $selected, array('id' => "$genid-$name-$totalOptions", 'class' => "cp-list-multiple-checkbox"));
								echo '<span class="cp-list-multiple-option" onclick="document.getElementById(\''."$genid-$name-$totalOptions".'\').click();">' . $text . '</span>';
								echo '</div>';
							}
							
							$totalOptions++;
						}
						
						if($customProp->getIsMultipleValues()) {
							echo '</div><div class="clear"></div>';
						}
						
						if(!$customProp->getIsMultipleValues()){
							echo select_box($name, $options, array('style' => 'min-width:140px', 'id' => $genid . 'cp' . $customProp->getId()));
						}
						
						break;
					case 'table':
						$columnNames = explode(',', $customProp->getValues());
						$cell_width = (600 / count($columnNames)) . "px";
						$html = '<div class="og-add-custom-properties"><table><tr>';
						foreach ($columnNames as $colName) {
							$html .= '<th style="width:'.$cell_width.';min-width:120px;">'.$colName.'</th>';
						}
						
						$html .= '<th style="width:20px;"></th></tr>';
						$values = MemberCustomPropertyValues::getMemberCustomPropertyValues($member->getId(), $customProp->getId());
						if (trim($default_value) != '' && (!is_array($values) || count($values) == 0)) {
							$def_cp_value = new MemberCustomPropertyValue();
							$def_cp_value->setValue($default_value);
							$values = array($def_cp_value);
						}
						$rows = 0;
						if (is_array($values) && count($values) > 0) {
							foreach ($values as $val) {
								$html .= '<tr>';
								$col = 0;
								$values = str_replace("\|", "%%_PIPE_%%", $val->getValue());
								$exploded = explode("|", $values);
								foreach ($exploded as $v) {
									$v = str_replace("%%_PIPE_%%", "|", $v);
									$html .= '<td><input class="value" style="width:'.$cell_width.';min-width:120px;" name="'.$name."[$rows][$col]". '" value="'. clean($v) .'" /></td>';
									$col++;
								}
								$html .= '<td><div class="ico ico-delete" style="width: 20px;height: 20px;cursor: pointer;margin-left: 2px;margin-top: 1px;" 
											onclick="og.removeTableCustomPropertyRow(this.parentNode.parentNode);return false;">&nbsp;</div></td>';
								$rows++;
								$html .= '</tr>';
							}
						}
						$html .= '</table>';
						
						$html .= '<a href="#" id="'.$genid.'-add-row-'.$customProp->getId().'" class="link-ico ico-add" onclick="og.addTableCustomPropertyRow(this.parentNode, true, null, '.count($columnNames).', null, '.$customProp->getId().', 1);return false;">' . lang("add new row") . '</a></div>';
						$html .= '<div class="clear"></div>';
						
						if ($rows == 0) {
							// create first empty row
							$html .= '<script>if (!Ext.isIE) document.getElementById("'.$genid.'-add-row-'.$customProp->getId().'").onclick();</script>';
						}
						
						$print_table_functions = true;
						echo $html;
						break;
					
					case 'color':
						if ($member_is_new && $parent_member > 0) {
							$pmem = Members::findById($parent_member);
							if ($pmem instanceof Member) {
								$default_value = $pmem->getColor();
							}
						}
						
						$html = '<div><div id="'.$genid.'colorcontainer-cp'.$customProp->getId().'"></div><div class="x-clear"></div></div>';
						$html .= "<script>$(function(){";
						$html .= "var cont = document.getElementById('".$genid."colorcontainer-cp".$customProp->getId()."');";
						$html .= "if (cont) cont.innerHTML = og.getColorInputHtml('$genid', '$name', '$default_value', '', '');";
						$html .= '});</script>';
						echo $html;
						break;
						
					case 'address':
						$html = '<div id="'.$genid.'addresscontainer-cp'.$customProp->getId().'" class="address-input-container custom-property"></div>';
						$html .= "<div style='display:none;'>" . select_country_widget('template_country', '', array('id' => 'template_select_country')) . "</div>";
						$html .= "<script>$(function(){";
						
						$all_address_types = AddressTypes::getAllAddressTypesInfo();
						$html .= "og.address_types = Ext.util.JSON.decode('". json_encode($all_address_types) ."');";
						
						$values = MemberCustomPropertyValues::getMemberCustomPropertyValues($member->getId(), $customProp->getId());
						if (is_array($values) && count($values) > 0) {
							foreach ($values as $val) {
								$values = str_replace("\|", "%%_PIPE_%%", $val->getValue());
								$values = str_replace(array("\r","\n"), " ", $values);
								$exploded = explode("|", $values);
								foreach ($exploded as &$v) {
									$v = str_replace("%%_PIPE_%%", "|", $v);
									$v = escape_character($v);
								}
								if (count($exploded) > 0) {
									$address_type = array_var($exploded, 0, '');
									$street = array_var($exploded, 1, '');
									$city = array_var($exploded, 2, '');
									$state = array_var($exploded, 3, '');
									$country = array_var($exploded, 4, '');
									$zip_code = array_var($exploded, 5, '');
									$sel_data_str = "{street:'$street', city:'$city', state:'$state', zip_code:'$zip_code', country:'$country'}";
									$html .= "og.renderAddressInput('cp".$customProp->getId()."', '$name', '".$genid."addresscontainer-cp".$customProp->getId()."', '$address_type', $sel_data_str);";
								} else {
									$html .= "og.renderAddressInput('cp".$customProp->getId()."', '$name', '".$genid."addresscontainer-cp".$customProp->getId()."', '', {});";
								}
							}
						} else {
							$html .= "og.renderAddressInput('cp".$customProp->getId()."', '$name', '".$genid."addresscontainer-cp".$customProp->getId()."', '', {});";
						}
						$html .= '});</script>';
						echo $html;
						
						break;
					
					case 'user':
					case 'contact':
						$value = '0';
						$contact = null;
						$cp_value = MemberCustomPropertyValues::getMemberCustomPropertyValue($member->getId(), $customProp->getId());
						if ($cp_value instanceof MemberCustomPropertyValue && is_numeric($cp_value->getValue())) {
							$value = $cp_value->getValue();
							$contact = Contacts::findById($value);
						}
	
						$emtpy_text = lang('select contact');
						
						Hook::fire('member_contact_cp_filters', array('cp' => $customProp, 'member' => $member), $filters);
						
						if ($customProp->getType() == 'user') {
							$filters['is_user'] = 1;
							if ($member_is_new) {
								$filters['has_permissions'] = $parent_member;
							} else {
								$filters['has_permissions'] = $member->getId();
							}
							$emtpy_text = lang('select user');
						}
						
						if (is_array($filters) && count($filters) > 0) {
							$filters_str = '{';
							foreach ($filters as $k => $v) {
								if ($v == '') continue;
								$filters_str .= ($filters_str=='{' ? '' : ',') . "$k : $v";
							}
							$filters_str .= '}';
						} else {
							$filters_str = 'null';
						}
						
						$html = '<div id="'.$genid.'contacts_combo_container-cp'.$customProp->getId().'" style="width:500px;"></div><div class="clear"></div>';
						$html .= '<script>'.
						'$(function(){
						  og.renderContactSelector({
							genid: "'.$genid.'",
							id: "cp'.$customProp->getId().'",
							name: "'.$name.'",
							render_to: "contacts_combo_container-cp'.$customProp->getId().'",
							selected: '.(is_numeric($value) ? "$value" : "0").',
							selected_name: "'.($contact instanceof Contact ? clean($contact->getObjectName()) : '').'",
							empty_text: "'. $emtpy_text .'",
							listClass: "custom-prop",
							listAlign: "tr-br",
							cp_type: "'.$customProp->getType().'",
							filters: '.$filters_str.'
						  });
						});
						</script>';
						echo $html;
						break;
					default: break;
				}
				
				if (!isset ($value)) $value = "";
				$ret = null;
				Hook::fire('after_render_cp_input', array('custom_prop' => $customProp, 'value' => $value, 'input_name' => $name), $ret);
				
				if ($customProp->getDescription() != ''){
					// the label is set to pad the description 
					echo '<div><label>&nbsp;</label><span class="desc">' . clean($customProp->getDescription()) . '</span></div>';
				}
				
				echo '<div class="clear"></div>';
				
				$cp_idx++;
				if ($cp_idx == floor(count($cps)/2)) {
					echo "</div><div class='cp-section cp-right'>";
				}
			}
		}
		
		if (count($cps) > 10) {
			echo '</div><div class="clear"></div>';
		}
	}
	
	$null = null;
	Hook::fire('render_additional_member_custom_properties', array('member' => $member, 'genid' => $genid, 'ot' => $ot), $null);

}

?></div>