<?php 
	$genid = gen_id();
	$persons_dim = Dimensions::findByCode('feng_persons');
	$custom_ot_name = Members::getTypeNameToShowByObjectType($dimension_id, $object_type->getId());
	
	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.submit_modal_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	
	$task_templates = COTemplates::findAll(array('conditions' => 'trashed_by_id=0 AND archived_by_id=0'));
	
	if (!isset($dimension_associations)) $dimension_associations = array();
	foreach ($dimension_associations as $k => $a) { /* @var $a DimensionMemberAssociation */
		if ($a->getAssociatedDimensionMemberAssociationId() == $persons_dim->getId()) unset($dimension_associations[$k]);
	}
?>
<form class="add-member-template" id="<?php echo $genid ?>submit-edit-form" onsubmit="<?php echo $on_submit?>" action="<?php echo $member_template->isNew() ? get_url('member_templates', 'add') : get_url('member_templates', 'edit', array('id' => $member_template->getId())) ?>" method="post" enctype="multipart/form-data" >
<div class="member-template">
<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $member_template->isNew() ? lang('new x type template', $custom_ot_name) : lang('edit x type template', $custom_ot_name) ?>
	</div>
  </div>

  <div>
	<div class="coInputName">
		<?php echo text_field('template[name]', $member_template->getName(), array('id' => $genid . 'templateName', 'class' => 'title', 'placeholder' => lang('type name here'))) ?>
	</div>
		
	<div class="coInputButtons">
		<?php echo submit_button($member_template->isNew() ? lang('add new x type template', $custom_ot_name) : lang('save changes'),'s', array('style'=>'margin-top:0px;margin-left:10px')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>


<div class="coInputMainBlock">
	
	<input type="hidden" name="template[dimension_id]" value="<?php echo $dimension_id?>" />
	<input type="hidden" name="template[object_type_id]" value="<?php echo $object_type->getId()?>" />
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_template_details"><?php echo lang('initial data') ?></a></li>
			
			<?php if (count($dimension_associations) > 0) { ?>
			<li><a href="#<?php echo $genid?>add_template_workflow"><?php echo lang('workflow') ?></a></li>
			<?php } ?>
			
		</ul>
	
		<div id="<?php echo $genid ?>add_template_details" class="form-tab">
			<script>if (!og.tmp_selector_names) og.tmp_selector_names = [];</script>
		
		<?php $i=0;
			$enabled_dimensions = config_option("enabled_dimensions");
			foreach ($dimension_associations as $a) { /* @var $a DimensionMemberAssociation */
				if ($a->getAssociatedDimensionMemberAssociationId() == $persons_dim->getId()) continue;
				
				if (!in_array($a->getAssociatedDimensionMemberAssociationId(), $enabled_dimensions)) continue;

				$i++;
		?>
			<div class="dataBlock"><?php 
				$selector_genid = $genid."-$i";
				
				$label = "";
				$assoc_ot = ObjectTypes::findById($a->getAssociatedObjectType());
				if ($assoc_ot instanceof ObjectType) {
					//$label = lang($assoc_ot->getName());
				    $label = $assoc_ot->getObjectTypeName();
				}
				
				$dim = Dimensions::findById($a->getAssociatedDimensionMemberAssociationId());
				$type_sel_params = array('is_multiple' => false, 'allow_non_manageable' => true, 'label' => $label, 'hidden_field_name' => 'template[initial_associated_members]['.$a->getId().']', 'content_object_type_id' => $a->getAssociatedObjectType(),
					'select_function' => 'og.onTemplateAssociatedMemberSelect', 'listeners' => array('on_remove_relation' => "og.onTemplateAssociatedMemberRemove('".$selector_genid."');"));
	
				render_single_member_selector($dim, $selector_genid, $selected_member_ids, $type_sel_params, false);
				
				?>
				<script>og.tmp_selector_names['<?php echo $selector_genid?>'] = 'template[initial_associated_members][<?php echo $a->getId()?>]';</script>
			</div>
			<div class="clear"></div>
		<?php } ?>
			
			<div class="dataBlock"><?php
		
				echo label_tag(lang('task templates'));
				// task templates selector
			
				$sel_options = array(option_tag(" -- " . lang('select to add a template to the list') . " -- ", 0));
				foreach ($task_templates as $ttemplate) {
					$sel_options[] = option_tag($ttemplate->getObjectName(), $ttemplate->getId());
				}
				echo select_box('task_template_selector', $sel_options, array('id' => $genid . "task_template_selector"));
				
				?>
				<div id="<?php echo $genid?>selected_task_templates_container" class="task-templates-container"></div>
			</div>
			<div class="clear"></div>
			
			<?php
				Hook::fire("member_templates_form_more_template_selectors", array('genid'=>$genid, 'member_template'=>$member_template), $null);
			?>
			
			<?php 
				if (Plugins::instance()->isActivePlugin('mail')) {
					
					echo '<div class="dataBlock">'.label_tag(lang('can instantiate from email'), $genid.'inst_from_mail');
					echo "&nbsp;";
					echo checkbox_field('template[can_instantiate_from_mail]', $member_template->getCanInstantiateFromMail(), array('id' => $genid.'inst_from_mail', 'style' => "margin-top: 6px;"));
					echo '</div>';
				}
			?>
			
			<?php 
				if (Plugins::instance()->isActivePlugin('object_subtypes')) {
					$subtypes = ObjectSubtypes::findAll(array("conditions" => "object_type_id=".$object_type->getId()));
					if (count($subtypes) > 0) {
						$options = array(option_tag('', 0));
						foreach ($subtypes as $subtype) {
							$attributes = array();
							if ($subtype->getId() == $member_template->getObjectSubtypeId()) $attributes['selected'] = 'selected';
							$options[] = option_tag($subtype->getName(), $subtype->getId(), $attributes);
						}
						
						echo '<div class="dataBlock">'.label_tag(lang('subtype'), $genid.'object_subtype_id');
						echo "&nbsp;";
						echo select_box('template[object_subtype_id]', $options, array('id' => $genid.'object_subtype_id'));
						echo '</div>';
					}
				}
			?>
			
		</div>
		
		<?php if (count($dimension_associations) > 0) { ?>
		<div id="<?php echo $genid ?>add_template_workflow" class="form-tab">
			<div class="desc"><?php echo lang('workflow tab description', $custom_ot_name)?></div>
			<div id="<?php echo $genid ?>workflow_container" class="workflow-container"></div>
			<a class="link-ico ico-add" href="javascript:og.addWorkflowStep();"><?php echo lang('add new workflow step')?></a>
		</div>
		<?php } ?>
		<div class="clear"></div>
	</div>
	
</div>

</div>
</form>

<script>
var genid = '<?php echo $genid?>';

og.workflow_dim_associations = [];
<?php $j=0;
	foreach ($dimension_associations as $a) { /* @var $a DimensionMemberAssociation */
		if ($a->getAssociatedDimensionMemberAssociationId() == $persons_dim->getId()) continue;
		$j++;
?>
	og.workflow_dim_associations.push({
		id: <?php echo $a->getId()?>,
		dim_id: <?php echo $a->getAssociatedDimensionMemberAssociationId() ?>,
		ot_id: <?php echo $a->getAssociatedObjectType() ?>
	});
<?php } ?>


og.template_workflow_count = 0;
	
og.addWorkflowDimSelector = function(dim_id, hf_name, dim_assoc_id, object_type_id, selected_member_ids, step_count, condition_count) {
	if (og.config.enabled_dimensions.indexOf(dim_id+"") == -1) {
		return
	}
	
	var container_id = genid + 'workflow_step_' + step_count + '_' + dim_id;
	if (!selected_member_ids) selected_member_ids = [];
	
	$('#'+genid+'workflow_container').append('<div id="' + container_id + '" class="workflow-step-dim-container"></div>');

	og.openLink(og.getUrl('member_templates', 'render_single_member_selector_for_template', {
		dim_id: dim_id,
		hf_name: hf_name,
		dim_assoc_id: dim_assoc_id,
		object_type_id: object_type_id,
		selected_member_ids: selected_member_ids
	}), {
		preventPanelLoad: true,
		hideLoading: true,
		callback: function(success, data) {
			if (condition_count > 0) $("#" + container_id).append('<div style="margin-left:15px;">'+lang('and')+'</div>');
			$("#" + container_id).append(data.current.data);
		}
	});
	
}

og.addWorkflowStep = function(selected_members, selected_tasks) {
	if (!selected_members) selected_members = "";
	
	og.template_workflow_count = og.template_workflow_count + 1;

	if (og.workflow_dim_associations.length > 0) {
		$('#'+genid+'workflow_container').append('<div class="bold">'+lang('If')+':</div>');
	}
	// draw associated dimensions selectors
	var cond_count = 0;
	for (var i=0; i<og.workflow_dim_associations.length; i++) {
		var a = og.workflow_dim_associations[i];
		if (og.config.enabled_dimensions.indexOf(a.dim_id+"") != -1) {
			var hf_name = 'template[steps]['+og.template_workflow_count+'][members]['+a.id+']';
			og.addWorkflowDimSelector(a.dim_id, hf_name, a.id, a.ot_id, selected_members, og.template_workflow_count, cond_count);
			cond_count++;
		}
	}

	// draw task templates selector
	var tt_selector = $("#" + genid + "task_template_selector").clone();
	var current_step = og.template_workflow_count;
	var tt_selector_id = genid + "task_template_selector_" + og.template_workflow_count;
	$(tt_selector).attr('id', tt_selector_id);

	if (og.workflow_dim_associations.length > 0) {
		$('#'+genid+'workflow_container').append('<div class="bold">'+lang('Then')+':</div>');
	}
	$('#'+genid+'workflow_container').append('<label>' + lang('task templates to instatiate') + '</label>');
	$('#'+genid+'workflow_container').append(tt_selector);
	$('#'+genid+'workflow_container').append('<div id="'+genid+'selected_task_templates_container_'+og.template_workflow_count+'" class="task-templates-container"></div>');

	$("#" + tt_selector_id).change(function(){
		var task_template_id = $(this).val();
		var el = $(this)[0];
		var task_template_name = el.options[el.selectedIndex].text;
		og.addSelectedTaskTemplate(task_template_id, task_template_name, genid + 'selected_task_templates_container_'+current_step, 'template[steps]['+current_step+'][task_templates]');
		el.selectedIndex = 0;
	});

	
	if (selected_tasks) {
		if (typeof(selected_tasks) == 'string') {
			selected_tasks = selected_tasks.split(',');
		}
		
		for (var j=0; j<selected_tasks.length; j++) {
			var tid = selected_tasks[j];
			var tname = "";
			var options = document.getElementById(tt_selector_id).options;
			for (var k=0; k<options.length; k++) {
				if (options[k].value == tid) {
					tname = options[k].text;
					break;
				}
			}
			og.addSelectedTaskTemplate(tid, tname, genid + 'selected_task_templates_container_'+current_step, 'template[steps]['+current_step+'][task_templates]');
		}
	}
	
	// step separator
	$('#'+genid+'workflow_container').append('<div class="workflow-step-separator"></div>');
}

og.addSelectedTaskTemplate = function (tt_id, tt_name, container_id, hf_name) {
	if (tt_id > 0) {
		var html = '<div class="task-template"><input name="'+ hf_name +'['+tt_id+']" type="hidden" value="'+tt_id+'" /><span class="link-ico ico-template">&nbsp;</span>' +
			tt_name + '<div style="float:right" class="link-ico ico-delete remove-task-template">' + lang('remove') + '</div><div class="clear"></div></div>';
		
		$('#' + container_id).append(html);
		
		$('.remove-task-template').click(function(){ 
			$(this).parent().remove();
		});
	}
}


og.onTemplateAssociatedMemberRemove = function (genid){
	og.onAssociatedMemberTypeRemove(genid, og.tmp_selector_names[genid]);
}

og.onTemplateAssociatedMemberSelect = function (genid, dimension_id, member_id){
	og.onAssociatedMemberTypeSelect(genid, dimension_id, member_id, og.tmp_selector_names[genid]);
}


$(function() {
	$("#<?php echo $genid?>tabs").tabs();

	<?php if (isset($task_templates_info) && count($task_templates_info) > 0) { 
			foreach ($task_templates_info as $ttinfo) { ?>
		og.addSelectedTaskTemplate(<?php echo $ttinfo['id']?>, '<?php echo $ttinfo['name']?>', genid + 'selected_task_templates_container', 'template[initial_task_templates]');
	<?php 
			}
		} ?>

	$("#" + genid + "task_template_selector").change(function(){
		var task_template_id = $(this).val();
		var el = $(this)[0];
		var task_template_name = el.options[el.selectedIndex].text;
		og.addSelectedTaskTemplate(task_template_id, task_template_name, genid + 'selected_task_templates_container', 'template[initial_task_templates]');
	
		el.selectedIndex = 0;
	});

	<?php foreach ($steps_info as $step_info) { ?>
		og.addWorkflowStep('<?php echo implode(',', $step_info['members'])?>', '<?php echo implode(',', $step_info['task_templates'])?>');
	<?php } ?>

});


</script>
<div></div>
