<?php 

function microsoft_integrations_update_1_2() {
    $connect_systems_id = ContactConfigCategories::findOne(array('conditions' => "name='connected systems'"))->getId();
    $microsoft_ccc = ContactConfigCategories::findOne(array('conditions' => "name='microsoft_365'"));
	if (!$microsoft_ccc instanceof ContactConfigCategory) {
        // Add 'Microsoft 365' contact config category that located under 'Connect systems'
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."contact_config_categories (`name`, `is_system`, `type`, `category_order`, `located_under`) VALUES
				('microsoft_365', 1, 0, 1, ".$connect_systems_id.");
		");
	}
    
    $microsoft_calendar_id = ContactConfigCategories::findOne(array('conditions' => "name='microsoft_365'"))->getId();
	$microsoft_calendar_ccc = ContactConfigCategories::findOne(array('conditions' => "name='microsoft_calendar'"));
	if (!$microsoft_calendar_ccc instanceof ContactConfigCategory) {
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."contact_config_categories (`name`, `is_system`, `type`, `category_order`, `located_under`) VALUES
				('microsoft_calendar', 1, 0, 1, ".$microsoft_calendar_id.");
		");
    }
    
    $microsoft_event_co = ContactConfigOptions::findOne(array('conditions' => "name='sync_microsoft_event_user_created'"));
    if (!$microsoft_event_co instanceof ContactConfigOption) {
        DB::execute("
            INSERT INTO ".TABLE_PREFIX."contact_config_options (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
            ('microsoft_calendar', 'sync_microsoft_event_user_created', 0, 'BoolConfigHandler', 0, 1, NULL, NULL),
            ('microsoft_calendar', 'sync_microsoft_event_user_attend', 0, 'BoolConfigHandler', 0, 2, NULL, NULL),
            ('microsoft_calendar', 'sync_microsoft_event_user_subscribed', 0, 'BoolConfigHandler', 0, 3, NULL, NULL),
            ('microsoft_calendar', 'sync_microsoft_tasks_user_created', 0, 'BoolConfigHandler', 0, 4, NULL, NULL),
            ('microsoft_calendar', 'sync_tasks_assigned_to_me', 0, 'BoolConfigHandler', 0, 5, NULL, NULL);
        ");
    }
}

function microsoft_integrations_update_2_3() {
  // Check if microsoft_integrations config category is present
  $category = ConfigCategories::instance()->findOne(array("conditions" => "name='microsoft_integrations'"));
  
  // If not present, add the category and corresponding configurations
  if (!($category instanceof ConfigCategory)) {
    DB::execute("
      INSERT INTO
        ".TABLE_PREFIX."config_categories (`name`, `is_system`, `category_order`)
      VALUES
        ('microsoft_integrations', 1, 0)
      ON DUPLICATE KEY UPDATE
        `name` = `name`;
    ");

    // Asuming that if category does not exist, neither config options are.
    DB::execute(" 
      INSERT INTO
        ".TABLE_PREFIX."config_options (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`)
      VALUES
        ('microsoft_integrations', 'ms_client_id', '', 'StringConfigHandler', 1, 0, 'To be completed with corresponding Azure Portal App Registration client id', ''),
        ('microsoft_integrations', 'ms_client_secret_value', '', 'StringConfigHandler', 1, 0, 'To be completed with corresponding Azure Portal App Registration client secret value', ''),
        ('microsoft_integrations', 'ms_redirect_uri_suffix', 'microsoft_callback.php', 'StringConfigHandler', 1, 0, '', ''),
        ('microsoft_integrations', 'ms_webhook_redirect_uri_suffix', 'microsoft_webhook_callback.php', 'StringConfigHandler', 1, 0, '', ''),
        ('microsoft_integrations', 'ms_url_authorize', 'https://login.microsoftonline.com/common/oauth2/v2.0/authorize', 'StringConfigHandler', 1, 0, '', ''),
        ('microsoft_integrations', 'ms_url_access_token', 'https://login.microsoftonline.com/common/oauth2/v2.0/token', 'StringConfigHandler', 1, 0, '', ''),
        ('microsoft_integrations', 'ms_scopes', 'openid profile offline_access user.read mailboxsettings.read calendars.readwrite', 'StringConfigHandler', 1, 0, '', ''),
        ('microsoft_integrations', 'ms_url_resource_owner_details', '', 'StringConfigHandler', 1, 0, '', '')
      ON DUPLICATE KEY UPDATE
        `value` = VALUES(`value`),
        `config_handler_class` = VALUES(`config_handler_class`),
        `is_system` = VALUES(`is_system`),
        `option_order` = VALUES(`option_order`),
        `dev_comment` = VALUES(`dev_comment`),
        `options` = VALUES(`options`);
    ");
  }
}
