<?php

Hook::register("currencies");

function currencies_general_settings_additional_links($ignored, &$links) {
    $links[] = array(
        'name' => lang('currencies'),
        'desc' => lang('currencies desc'),
        'url' => get_url('currencies', 'list_all'),
    );
}

/**
 * Add currency columns to list in reports
 * @param type $params
 * @param type $ret
 */
function currencies_get_allow_columns_for_reports($params, &$ret) {

    if (Plugins::instance()->isActivePlugin('income')) {

        $allowed_columns = $ret[0];
        $option_groups = $ret[1];

        $object_type = array_var($params, 'object_type');
        $columns = array_var($params, 'columns');

        if ($object_type == IncomeInvoices::instance()->getObjectTypeId()) {
            $ts_group_count = count($allowed_columns);
            $managerCurrencyInstance = Currencies::instance();
            $columnCurr = $managerCurrencyInstance->getColumns();
            $columnsAux = explode(',', $columns);
            $conutDuplicated = 0;
            foreach ($columnCurr as $key => $value) {
                if (in_array('cur_' . $value, $columnsAux)) {
                    $conutDuplicated +=2;
                }
                $allowed_columns[] = array('id' => 'cur_' . $value, 'name' => $value, 'type' => $value);
            }
            $addMoreColumns = count($columnsAux) - $conutDuplicated;
            $option_groups = array(
                array('count' => $ts_group_count - count($columnCurr) - $addMoreColumns, 'name' => lang('invoice') . ' ' . lang('columns')),
                array('count' => floor(count($columnCurr) - ($conutDuplicated/2)), 'name' => lang('currency')),
            );
        }
        $ret[0] = $allowed_columns;
        $ret[1] = $option_groups;
    }
}

/**
 * 
 * @param type $params
 * @param type $results
 */
function currencies_get_columns_to_header_report($params, &$results) {

    $field = array_var($params, 'field');
    if (str_starts_with($field, 'cur_')) {
        $results['columns']['names'][$field] = lang(substr($field, 4));
        $results['columns']['order'][] = $field;
        $results['columns']['types'][$field] = Currencies::instance()->getColumnType(substr($field, 4));
    }
}

/**
 * 
 * @param type $params
 * @param type $row_values
 */
function currencies_get_value_columns_to_body_report($params, &$value) {

    $field = array_var($params, 'field');
    $object = array_var($params, 'object');
    if (str_starts_with($field, 'cur_')) {
        $idObject = $object->getColumnValue('id');
        $invoice = IncomeInvoices::instance()->findById($idObject);
        $currency = Currencies::instance()->findById($invoice->getColumnValue('currency_id'));
        $fieldAux = substr($field, 4);
        $value = $currency->getColumnValue($fieldAux);
    }
}
