<?php
	require_javascript('og/ObjectSelector.js');
	
	$genid = gen_id();
	$object = $newsletter;
	
	// on submit functions
	if (array_var($_REQUEST, 'modal')) {
		$on_submit = "og.setDescription(); og.submit_modal_form('".$genid."submit-edit-form'); return false;";
	} else {
		$on_submit = "return true;";
	}
	
	// for ckeditor language
	$loc = user_config_option('localization');
	if (strlen($loc) > 2) $loc = substr($loc, 0, 2);
	
	$categories = array();
	Hook::fire('object_edit_categories', $object, $categories);

	$main_cp_count = CustomProperties::countVisibleCustomPropertiesByObjectType($object->getObjectTypeId());
	$other_cp_count = CustomProperties::countHiddenCustomPropertiesByObjectType($object->getObjectTypeId());
	
	if (!$newsletter->isNew()) {
		// initialize object selector with the selected people of this newsletter.
		Env::useHelper('object_selector');
		save_tmp_objects_ids($newsletter_contact_ids, true, $genid);
	}
?>
<form class="add-newsletter" id="<?php echo $genid ?>submit-edit-form" onsubmit="<?php echo $on_submit?>" action="<?php echo $newsletter->isNew() ? get_url('newsletter', 'add') : $newsletter->getEditUrl() ?>" method="post" enctype="multipart/form-data" >
<div class="newsletter">
<div class="coInputHeader">

  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $object->getAddEditFormTitle(); ?>
	</div>
  </div>

  <div>
	<div class="coInputName">
		<?php echo text_field('newsletter[name]', $newsletter->getName(), array('id' => $genid . 'newsletterName', 'class' => 'title', 'placeholder' => lang('type name here'))) ?>
	</div>
		
	<div class="coInputButtons">
		<?php echo submit_button($object->getSubmitButtonFormTitle(),'s', array('style'=>'margin-top:0px;margin-left:10px')) ?>
	</div>
	<div class="clear"></div>
  </div>
</div>


<div class="coInputMainBlock">
	
	<input id="<?php echo $genid?>genid" type="hidden" name="genid" value="<?php echo $genid ?>">
	<input id="<?php echo $genid?>updated-on-hidden" type="hidden" name="updatedon" value="<?php echo !$newsletter->isNew() ? $newsletter->getUpdatedOn()->getTimestamp() : '' ?>">
	
	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>add_newsletter_details"><?php echo lang('details') ?></a></li>
			
			<li><a href="#<?php echo $genid?>add_newsletter_text"><?php echo lang('content') ?></a></li>

			<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
			<li><a href="#<?php echo $genid?>add_custom_properties_div"><?php echo lang('custom properties') ?></a></li>
			<?php } ?>
			
			<li><a href="#<?php echo $genid?>add_subscribers_div"><?php echo lang('object subscribers') ?></a></li>
			
			<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
			<li><a href="#<?php echo $genid?>add_linked_objects_div"><?php echo lang('linked objects') ?></a></li>
			<?php } ?>
			
			<?php foreach ($categories as $category) {
					if (array_var($category, 'hidden')) continue;
				?>
			<li><a href="#<?php echo $genid . $category['name'] ?>"><?php echo $category['name'] ?></a></li>
			<?php } ?>
		</ul>
	
		<div id="<?php echo $genid ?>add_newsletter_details" class="editor-container form-tab">
	
			<div id="<?php echo $genid ?>add_newsletter_select_context_div">
				<?php
				$listeners = array('on_selection_change' => 'og.reload_subscribers("'.$genid.'",'.$object->manager()->getObjectTypeId().')');
				if ($newsletter->isNew()) {
					render_member_selectors($newsletter->manager()->getObjectTypeId(), $genid, null, array('select_current_context' => true, 'listeners' => $listeners, 'object' => $object), null, null, false);
				} else {
					render_member_selectors($newsletter->manager()->getObjectTypeId(), $genid, $newsletter->getMemberIds(), array('listeners' => $listeners, 'object' => $object), null, null, false);
				} 
				?>
			</div>
			<div class="clear"></div>
			
			<div class="dataBlock"><?php
				
				echo label_tag(lang('subject'), $genid . 'newsletterSubject', true);
				echo text_field("newsletter[subject]", array_var($newsletter_data, 'subject'), array('id' => $genid . 'newsletterSubject', 'class' => 'title'));
				
			?></div>
			
			
			<div class="dataBlock"><?php
				
				echo label_tag(lang('account'));
				echo render_select_mail_account("newsletter[mail_account_id]", $mail_accounts, array_var($newsletter_data, 'mail_account_id'));
				
			?></div>
			
			<?php $null = null; Hook::fire('before_render_main_custom_properties', array('object' => $object), $null);?>
			
			<div class="main-custom-properties-div"><?php
				if ($main_cp_count) {
					echo render_object_custom_properties($object, false, null, 'visible_by_default');
				}
			?></div>


			<div class="dataBlock">
				<a href="#" onclick="og.addContactsToNewsletter(this);" class="link-ico ico-add"><?php echo lang('add recipients to this newsletter') ?></a>
			<?php 
			?></div>
		</div>

		<div id="<?php echo $genid ?>add_newsletter_text" class="editor-container form-tab">
		
		<?php
			if(config_option("wysiwyg_messages")){
				if($newsletter->isNew()) {
					$ckEditorContent = '';
				} else {
					if(array_var($newsletter_data, 'type_content') == "text"){
						$ckEditorContent = nl2br(htmlspecialchars(array_var($newsletter_data, 'text')));
					}else{
						$ckEditorContent = array_var($newsletter_data, 'text');
					}
				}
			?>
	        <div>
	            <div id="<?php echo $genid ?>ckcontainer" style="height: 400px">
	                <textarea cols="80" id="<?php echo $genid ?>ckeditor" name="newsletter[text]" rows="10"><?php echo clean($ckEditorContent) ?></textarea>
	            </div>
	        </div>
	        
	        <script>
	            var h = document.getElementById("<?php echo $genid ?>ckcontainer").offsetHeight;
	            var editor = CKEDITOR.replace('<?php echo $genid ?>ckeditor', {
	            	//height: (h-45) + 'px',
	            	height: '300px',
	            	allowedContent: true,
	            	resize_enabled: false,
					fullPage: true,
	            	enterMode: CKEDITOR.ENTER_BR,
	            	shiftEnterMode: CKEDITOR.ENTER_BR,
	            	disableNativeSpellChecker: false,
	            	language: '<?php echo $loc ?>',
	            	customConfig: '',
	            	contentsCss: ['<?php echo get_javascript_url('ckeditor/contents.css').'?rev='.product_version_revision();?>', '<?php echo get_stylesheet_url('og/ckeditor_override.css').'?rev='.product_version_revision();?>'],
	            	toolbar: [
								['Bold','Italic','Underline','Strike','-',
								 'Source', '-',
								 /*'Image', '-',*/
								 'Font','FontSize','-', 'Blockquote','-',
								 'SpellChecker', 'Scayt','-', 
								 'NumberedList','BulletedList','-',
								 'TextColor','BGColor','RemoveFormat','-',
								 'Link','Unlink','-',
								 'JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock']
	                        ],
	                on: {
	                        instanceReady: function(ev) {
	                                og.adjustCkEditorArea('<?php echo $genid ?>');
	                                editor.resetDirty();
	                        }
	                    },
    				fillEmptyBlocks: false,
    				removePlugins: 'scayt,liststyle,magicline',
	                entities_additional : '#39,#336,#337,#368,#369,#124'
	            });
	
	            og.setDescription = function() {
	                    var form = Ext.getDom('<?php echo $genid ?>submit-edit-form');
	                    if (form.preventDoubleSubmit) return false;
	
	                    setTimeout(function() {
	                            form.preventDoubleSubmit = false;
	                    }, 2000);
	
	                    var editor = og.getCkEditorInstance('<?php echo $genid ?>ckeditor');

	                    // remove title tag from header to prevent raise the spam score
						var content = editor.getData();
						content = content.replace(/<title>.*<\/title>/g, '');
	                    form['newsletter[text]'].value = content;
	
	                    return true;
	            };    
	        </script>
	        <?php }else{?>
	        <div>
	            <?php 
	                if(array_var($newsletter_data, 'type_content') == "text"){
	                    $content_text = array_var($newsletter_data, 'text');
	                }else{
	                    $content_text = html_to_text(html_entity_decode(nl2br(array_var($newsletter_data, 'text')), null, "UTF-8"));
	                }   
	            ?>
	            <?php echo label_tag(lang('text'), 'newsletterFormText', false) ?>
	            <?php echo editor_widget('newsletter[text]', $content_text, array('id' => $genid . 'newsletterFormText')) ?>
			</div>
	        <script>
	                og.setDescription = function() {
	                        return true;
	                };    
	        </script>
		<?php }?>
	
		</div>
		
		<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
		<div id="<?php echo $genid ?>add_custom_properties_div" class="form-tab other-custom-properties-div">
			<?php  echo render_object_custom_properties($object, false, null, 'other') ?>
			<?php  echo render_add_custom_properties($object); ?>
		</div>
		<?php } ?>
		
		<div id="<?php echo $genid ?>add_subscribers_div" class="form-tab">
			<div id="<?php echo $genid ?>add_subscribers_content">
				<?php echo render_add_subscribers($object, $genid); ?>
			</div>
		</div>
		
		<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
		<div id="<?php echo $genid ?>add_linked_objects_div" class="form-tab">
			<?php echo render_object_link_form($object) ?>
		</div>
		<?php } // if ?>
	
		<?php foreach ($categories as $category) { ?>
		<div id="<?php echo $genid . $category['name'] ?>" class="form-tab">
			<?php echo $category['content'] ?>
		</div>
		<?php } ?>

	
	<div class="clear"></div>
</div>
	<?php if (!array_var($_REQUEST, 'modal')) {
		echo submit_button($newsletter->isNew() ? lang('add newsletter') : lang('save changes'),'s', array('tabindex' => '20000')); 
	}?>
</div>

</div>
</form>

<script>
var genid = '<?php echo $genid?>';
$(function(){
	$("#<?php echo $genid?>tabs").tabs();
});

var newsletter_id = '<?php echo $newsletter->getId()?>';
var newsletter_object_type_id = '<?php echo Contacts::instance()->getObjectTypeId()?>';


og.addContactsToNewsletter = function(before) {
	og.newsletters.addContactsToNewsletter(before, newsletter_id,newsletter_object_type_id, genid);
};

</script>