
INSERT INTO `<?php echo $table_prefix ?>object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
 ('newsletter', 'Newsletters', 'newsletters', 'content_object', 'newsletter', (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='newsletters'), 0)
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
	SELECT
	 (SELECT `id` FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='customer_project'), `id`, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='newsletter'), 0, 1
	FROM `<?php echo $table_prefix ?>object_types`
	WHERE `type` IN ('dimension_object','dimension_group') AND `plugin_id` = (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='crpm')
ON DUPLICATE KEY UPDATE dimension_id=dimension_id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
	SELECT
	 (SELECT `id` FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='workspaces'), `id`, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='newsletter'), 0, 1
	FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='workspace'
ON DUPLICATE KEY UPDATE dimension_id=dimension_id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
	SELECT
	 (SELECT `id` FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='tags'), `id`, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='newsletter'), 0, 1
	FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='tag'
ON DUPLICATE KEY UPDATE dimension_id=dimension_id;

DELETE FROM `<?php echo $table_prefix ?>dimension_object_type_contents` WHERE `dimension_id`=0 OR dimension_id IS NULL;


INSERT INTO `<?php echo $table_prefix ?>tab_panels` (`id`,`title`,`icon_cls`,`refresh_on_context_change`,`default_controller`,`default_action`,`initial_controller`,`initial_action`,`enabled`,`type`,`ordering`,`plugin_id`,`object_type_id`) VALUES 
 ('newsletters-panel', 'newsletters', 'ico-newsletters', 1, 'newsletter', 'init', '', '', 1, 'system', 11, (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='newsletters'), (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='newsletter')) 
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('newsletter')
	 AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 0, 0
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('newsletter')
	 AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');

INSERT INTO <?php echo $table_prefix ?>role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('newsletter')
	AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');


-- add permissions to users where the users already have permissions (copy permissions from tasks)
INSERT INTO <?php echo $table_prefix ?>contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
 SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='newsletter'), cmp.can_delete, cmp.can_write 
 FROM <?php echo $table_prefix ?>contact_member_permissions cmp
 WHERE cmp.object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>contact_member_permissions.member_id=<?php echo $table_prefix ?>contact_member_permissions.member_id;

INSERT INTO <?php echo $table_prefix ?>tab_panel_permissions (permission_group_id, tab_panel_id)
 SELECT pg.id, 'newsletters-panel' FROM <?php echo $table_prefix ?>permission_groups pg WHERE pg.type='roles' AND pg.name IN ('Super Administrator','Administrator')
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;

INSERT INTO <?php echo $table_prefix ?>tab_panel_permissions (permission_group_id, tab_panel_id)
 SELECT c.permission_group_id, 'newsletters-panel' FROM <?php echo $table_prefix ?>contacts c 
 WHERE c.user_type IN (SELECT pg.id FROM <?php echo $table_prefix ?>permission_groups pg WHERE pg.type='roles' and pg.name IN ('Super Administrator','Administrator'))
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;



INSERT INTO `<?php echo $table_prefix ?>config_categories` (`name`, `is_system`, `category_order`) VALUES ('newsletters', 0, 70);

INSERT INTO `<?php echo $table_prefix ?>config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`) VALUES
 ('newsletters', 'newsletters_default_account', '0', 'NewsletterAccountConfigHandler', 0, 0, ''),
 ('newsletters', 'newsletters_emails_x_step', '30', 'IntegerConfigHandler', 0, 0, ''),
 ('newsletters', 'newsletters_persons_x_email', '20', 'IntegerConfigHandler', 0, 0, '')
ON DUPLICATE KEY UPDATE name=name;

INSERT INTO `<?php echo $table_prefix ?>cron_events` (`name`,`recursive`,`delay`,`is_system`,`enabled`) VALUES 
 ('send_newsletter_emails', 1, 1, 1, 1)
ON DUPLICATE KEY UPDATE name=name;

INSERT INTO `<?php echo $table_prefix ?>custom_properties` (`object_type_id`, `name`, `code`, `type`, `description`, `values`, `default_value`, `is_required`, `is_multiple_values`, `property_order`, `visible_by_default`, `is_special`, `is_disabled`) VALUES
((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='contact'),'Newsletter subscription','subs_newsletter','boolean','','','1',0,0,1,1,1,0);
