<?php 

function notifications_manager_update_1_2() {
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."notification_summaries` (
		  `id` int(11) NOT NULL AUTO_INCREMENT,
		  `name` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
		  `next_execution_date` datetime NOT NULL,
		  `delay` int(11) NOT NULL,
		  `enabled` tinyint(1) NOT NULL,
		  PRIMARY KEY (`id`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."notification_summaries_sent_logs` (
		  `summary_id` int(11) NOT NULL DEFAULT 0,
		  `application_log_id` int(11) NOT NULL DEFAULT 0,
		  PRIMARY KEY (`summary_id`, `application_log_id`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");
	
	DB::execute("
		UPDATE ".TABLE_PREFIX."contact_config_options
		SET `config_handler_class`='MultipleListConfigHandler', 
			`options`='Immediate,<dynamic_options:notification_summaries>',
			`default_value`='Immediate'
		WHERE `category_name`='notification_trigger_options'
	");
}

function notifications_manager_update_2_3() {
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
		 ('email_system_setup', 'minutes_for_consolidation', '6', 'IntegerConfigHandler', 0, 10, '', '')
		ON DUPLICATE KEY UPDATE category_name = category_name;
	");
	
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."cron_events` (`name`, `recursive`, `delay`, `is_system`, `enabled`, `date`) VALUES 
		('send_notification_summaries', 1, 15, 0, 1, now())
		ON DUPLICATE KEY UPDATE `name`=`name`;
	");
	
	DB::execute("
		UPDATE ".TABLE_PREFIX."contact_config_options
		SET `config_handler_class`='MultipleListConfigHandler', 
			`options`='Immediate,<dynamic_options:notification_summaries>',
			`default_value`='Immediate'
		WHERE `category_name`='notification_trigger_options'
	");
}


function notifications_manager_update_3_4() {
	
	if (!check_column_exists(TABLE_PREFIX."queued_emails", "log_action")) {
		DB::execute("
			ALTER TABLE `".TABLE_PREFIX."queued_emails`
			ADD `log_action` varchar(255) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '';
		");
	}
	
	$option = ContactConfigOptions::getByName('exclude_consolidation_add_close');
	if (!$option instanceof ContactConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
			 ('email_system_setup', 'exclude_consolidation_add_close', '0', 'BoolConfigHandler', 0, 20, '', '')
			ON DUPLICATE KEY UPDATE category_name = category_name;
		");
	}
}

function notifications_manager_update_4_5() {
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."contact_config_options` (`category_name`, `name`, `default_value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
		('notification_trigger_options', 'name_changed', 'Immediate', 'MultipleListConfigHandler', 0, 110, '', 'Immediate,<dynamic_options:notification_summaries>'),
		('notification_trigger_options', 'time_estimate_changed', 'Immediate', 'MultipleListConfigHandler', 0, 120, '', 'Immediate,<dynamic_options:notification_summaries>'),
		('notification_trigger_options', 'percent_completed_changed', 'Immediate', 'MultipleListConfigHandler', 0, 130, '', 'Immediate,<dynamic_options:notification_summaries>'),
		('notification_trigger_options', 'priority_changed', 'Immediate', 'MultipleListConfigHandler', 0, 140, '', 'Immediate,<dynamic_options:notification_summaries>');
	");
}
