<?php


function create_object_subtype_from_member(Member $member, $object_type_id) {
	$ot = ObjectTypes::findById($member->getObjectTypeId());
	$code = $ot->getName() ."_". $member->getId();
	$is_new = false;

	// Save subtype if not exists
	$subtype = ObjectSubtypes::instance()->findOne(array('conditions' => "code='$code'"));
	if (!$subtype instanceof ObjectSubtype) {
		$subtype_data = array(
				'code' => $code,
				'name' => $member->getName(),
				'gender' => 'm',
				'object_type_id' => $object_type_id,
				'created_on' => DateTimeValueLib::now(),
				'updated_on' => DateTimeValueLib::now(),
				'created_by_id' => logged_user()->getId(),
				'updated_by_id' => logged_user()->getId(),
		);

		$subtype = new ObjectSubtype();
		$subtype->setFromAttributes($subtype_data);
		$subtype->save();

		// add new subtype menu
		evt_add("reload object subtype menus");

		$is_new = true;
		alert("new subtype $code");
	}

	// save subtype custom properties
	$_REQUEST['ot_id'] = $object_type_id;
	$administration_controller = new AdministrationController();
	$administration_controller->save_custom_properties_for_type();

	if ($is_new) {
		$names = array();
		$cps = array_var($_REQUEST, 'custom_properties');
		foreach ($cps as $key => $cp) {
			if (is_numeric($key)) {
				$names[] = DB::escape($cp['name']);
			}
		}
		if (count($names) > 0) {
			DB::execute("UPDATE ".TABLE_PREFIX."custom_properties SET object_subtype_id=".$subtype->getId()."
					WHERE object_type_id=$object_type_id AND object_subtype_id=0 AND name IN (".implode(",", $names).")");
		}
	}
}



function associate_task_templates_to_object_subtype_from_member(Member $member, $object_type_id, $template_ids) {
	$ot = ObjectTypes::findById($member->getObjectTypeId());
	$code = $ot->getName() ."_". $member->getId();

	// get subtype and save the associations
	$subtype = ObjectSubtypes::instance()->findOne(array('conditions' => "code='$code'"));
	if ($subtype instanceof ObjectSubtype) {
		// clean associations
		ObjectSubtypeTaskTemplates::delete("object_type_id=$object_type_id AND object_subtype_id=".$subtype->getId());
		// save associations
		foreach ($template_ids as $tid) {
			$association = new ObjectSubtypeTaskTemplate();
			$association->setObjectTypeId($object_type_id);
			$association->setObjectSubtypeId($subtype->getId());
			$association->setTaskTemplateId($tid);
			$association->save();
		}
	}
}