<?php


  abstract class BaseObjectSubtype extends DataObject {
  
    // -------------------------------------------------------
    //  Access methods
    // -------------------------------------------------------
  
    function getId() {
      return $this->getColumnValue('id');
    }
    
    function setId($value) {
      return $this->setColumnValue('id', $value);
    }
    
    function getObjectTypeId() {
    	return $this->getColumnValue('object_type_id');
    }
    
    function setObjectTypeId($value) {
    	return $this->setColumnValue('object_type_id', $value);
    }
    
    function getName() {
        if ($this->getIsSpecial()) {
            $label = Localization::instance()->lang($this->getColumnValue('name'));
            if (!is_null($label)) {
                return $label;
            }
        }
        return $this->getColumnValue('name');
    }
    
    function setName($value) {
    	return $this->setColumnValue('name', $value);
    }
    
    function getCode() {
    	return $this->getColumnValue('code');
    }
    
    function setCode($value) {
    	return $this->setColumnValue('code', $value);
    }
    
    function getGender() {
    	return $this->getColumnValue('gender');
    }
    
    function setGender($value) {
    	return $this->setColumnValue('gender', $value);
    }


    /**
     * Return value of 'is_special' field
     *
     * @access public
     * @param void
     * @return boolean
     */
    function getIsSpecial() {
    	return $this->getColumnValue('is_special');
    }
    
    /**
     * Set value of 'is_special' field
     *
     * @access public
     * @param boolean $value
     * @return boolean
     */
    function setIsSpecial($value) {
    	return $this->setColumnValue('is_special', $value);
    }
    
    /**
     * Return value of 'sum_in_total' field
     *
     * @access public
     * @param void
     * @return boolean
     */
    function getSumInTotal() {
    	return $this->getColumnValue('sum_in_total');
    }
    
    /**
     * Set value of 'sum_in_total' field
     *
     * @access public
     * @param boolean $value
     * @return boolean
     */
    function setSumInTotal($value) {
    	return $this->setColumnValue('sum_in_total', $value);
    }
    
    function getMemberId() {
    	return $this->getColumnValue('member_id');
    }
    
    function setMemberId($value) {
    	return $this->setColumnValue('member_id', $value);
    }
    
    function getColor() {
    	return $this->getColumnValue('color');
    }
    
    function setColor($value) {
    	return $this->setColumnValue('color', $value);
    }
    
    
    
    function getCreatedOn() {
    	return $this->getColumnValue('created_on');
    }
    function setCreatedOn($value) {
    	return $this->setColumnValue('created_on', $value);
    }
    
    function getCreatedById() {
    	return $this->getColumnValue('created_by_id');
    }
    function setCreatedById($value) {
    	return $this->setColumnValue('created_by_id', $value);
    }
    
    function getUpdatedOn() {
    	return $this->getColumnValue('updated_on');
    }
    function setUpdatedOn($value) {
    	return $this->setColumnValue('updated_on', $value);
    }
    
    function getUpdatedById() {
    	return $this->getColumnValue('updated_by_id');
    }
    function setUpdatedById($value) {
    	return $this->setColumnValue('updated_by_id', $value);
    }
    
    
    

    function manager() {
      if(!($this->manager instanceof BaseObjectSubtypes)) $this->manager = BaseObjectSubtypes::instance();
      return $this->manager;
    } 
  } 
