<div class="subtype-container">
<div class="coInputTitle">
	<div class="subtype-name"><?php echo lang('custom properties for', $type_name) ?></div>
	<div class="subtype-actions">
		<a href="#" onclick="og.render_modal_form('', {c:'object_subtypes', a:'edit', params: {id:<?php echo $subtype->getId()?>}});" class="link-ico ico-edit"></a>
		<a href="#" onclick="og.object_subtypes.delete_object_subtype(<?php echo $subtype->getId()?>, '<?php echo escape_character($type_name)?>')" class="link-ico ico-delete"></a>
	</div>
	<div class="clear"></div>
</div>

<?php
	tpl_assign('genid', $genid);
	tpl_assign('type_name', $type_name);
	tpl_assign('additional_hidden_fields', $additional_hidden_fields);

	tpl_display(get_template_path('cp_table_template', 'administration'));
	
	$extra_conditions = " AND object_subtype_id=".$subtype->getId();
	$custom_properties = CustomProperties::getAllCustomPropertiesByObjectType($object_type->getId(), 'all', $extra_conditions);
	
	if (!isset($id_suffix)) $id_suffix = "";
	tpl_assign('id_suffix', $id_suffix);
?>

</div>

<script>

og.custom_props_table_genids.push('<?php echo $genid?>');

$(function() {

<?php 
	if (count($custom_properties) == 0) { // add one empty row

		?>og.addCustomPropertyRow('<?php echo $genid?>', null, '<?php echo $id_suffix?>');<?php
		
	} else {
		foreach ($custom_properties as $cp) { /* @var $cp CustomProperty */ ?>
		var prop = {
				id: '<?php echo $cp->getId()?>',
				name: '<?php echo escape_character($cp->getName())?>',
				type: '<?php echo $cp->getType()?>',
				description: '<?php echo str_replace('"', '\\"', escape_character($cp->getDescription()))?>',
				values: '<?php echo escape_character($cp->getValues())?>',
				default_value: '<?php echo escape_character($cp->getDefaultValue())?>',
				is_special: <?php echo $cp->getColumnValue('is_special') ? '1' : '0'?>,
				is_disabled: <?php echo $cp->getColumnValue('is_disabled') ? '1' : '0'?>,
				visible_by_default: <?php echo $cp->getVisibleByDefault() ? '1' : '0' ?>,
				show_in_lists: <?php echo $cp->getShowInLists() ? '1' : '0' ?>,
				is_required: <?php echo $cp->getIsRequired() ? '1' : '0' ?>,
				is_multiple_values: <?php echo $cp->getIsMultipleValues() ? '1' : '0' ?>
		};
		og.addCustomPropertyRow('<?php echo $genid?>', prop, '<?php echo $id_suffix?>');
	
	<?php }
	} ?>

	$( "#<?php echo $genid?>custom-properties-table" ).sortable({
		stop: function(event, object) {
			og.refreshTableRowsOrder(genid);
		},
		handle: ".handle",
		cursor: "move",
		cancel: "tr.header"
	});
});
</script>



