<?php

/**
 * MailTemplates class
 *
 * 
 */
class MailTemplates extends BaseMailTemplates {

	static function getByCode($code) {
		return self::findOne(array(
				"conditions" => array("code=?", $code)
		));
	}

	static function getById($id) {
		return self::findOne(array(
				"conditions" => array("id=?", $id)
		));
	}

	static function getByTemplateByStatus($object_type_id, $status) {
		
		$sql="  select *, ".TABLE_PREFIX."mail_templates.id mail_template_id
				from ".TABLE_PREFIX."mail_templates join ".TABLE_PREFIX."object_status_types
										on (".TABLE_PREFIX."mail_templates.object_status_types_id= ".TABLE_PREFIX."object_status_types.id)
				where ".TABLE_PREFIX."object_status_types.object_type_id ='$object_type_id'
				and   ".TABLE_PREFIX."object_status_types.status='$status';";
				
		$rows = DB::executeOne($sql);

		return $rows;
		
	}

	static function getAllByCode($code) {
		return self::findAll(array(
				"conditions" => array("code=?", $code)
		));
	}
	static function getAllById($id) {
		return self::findAll(array(
				"conditions" => array("id=?", $id)
		));
	}
	
	static function canManageMailTemplates($user) {
		Env::useHelper('functions', 'object_templates');
		return can_manage_mail_templates($user);
	}
	
	static function listAll($parameters) {

		$order = array_var($parameters, 'order');
		$order_dir = array_var($parameters, 'order_dir');
		$extra_conditions = array_var($parameters, 'extra_conditions', '');
		$count_results = array_var($parameters, 'count_results');
		$start = array_var($parameters, 'start', 0);
		$limit = array_var($parameters, 'limit', config_option('files_per_page'));
		
		if (!in_array($order, self::getColumns())) {
			$order = 'name';
		}
		if (!in_array(strtoupper($order_dir), array('ASC','DESC'))) {
			$order_dir = 'ASC';
		}
		
		// get template objects
		$mail_templates = self::findAll(array(
				"conditions" => "true $extra_conditions",
				"limit" => $limit,
				"offset" => $start,
				"order" => "$order $order_dir",
		));
		
		// get total
		if ($count_results) {
			$sql_total = "SELECT count(DISTINCT(id)) as total FROM ".TABLE_PREFIX."mail_templates WHERE true $extra_conditions;";
			$total_row = DB::executeOne($sql_total);
			$total = $total_row['total'];
		} else {
			$total = 10000000;
		}
		
		// build result
		$result = new stdClass;
		$result->objects = $mail_templates;
		$result->total = $total;
		
		return $result;
	}
}

