<?php
Hook::register('object_templates');

function object_templates_render_more_type_templates($parameters, &$ret) {

	tpl_display(get_template_path('administration', 'mail_template', 'object_templates'));
	
}


function object_templates_get_mail_template_data($parameters, &$mail_template_data) {
	Env::useHelper('functions', 'object_templates');

	$triggering_object = array_var($parameters, 'triggering_object');
	$template_code = array_var($parameters, 'template_code');
	$template_id = array_var($parameters, 'template_id');
	$template_parameters = array_var($parameters, 'template_parameters');
	
	$specific_template = null;
	$default_template = null;
	$triggering_obj_member_ids = $triggering_object instanceof ContentDataObject ? $triggering_object->getMemberIds() : array();

	if($template_id>0) 
	{
		$mail_template_objects = MailTemplates::getAllById($template_id);
	}else if ($template_code )
	{
		$mail_template_objects = MailTemplates::getAllByCode($template_code);
	}else{
		return;
	} 

	foreach ($mail_template_objects as $m_template) {
		/* @var $m_template MailTemplate */
		if ($m_template->getMemberId() == 0) {
			$default_template = $m_template;
		} else {
			if (count($triggering_obj_member_ids) > 0 && in_array($m_template->getMemberId(), $triggering_obj_member_ids)) {
				$specific_template = $m_template;
			}
		}
	}
	if ($specific_template instanceof MailTemplate) {
		// use the specific template if its member id is one of the triggering object's members
		$mail_template_object = $specific_template;
	} else {
		// use the default template (the one with member_id = 0)
		$mail_template_object = $default_template;
	}
	
	
	if ($mail_template_object instanceof MailTemplate && $mail_template_object->getEnabled()) {
		$to = array();
		if ($mail_template_object->getTo() != '') {
			$to = explode(',',replace_mail_template_variables($mail_template_object->getTo(), $triggering_object, $template_parameters));
		}

		$cc = array();
		if ($mail_template_object->getCc() != '') {
			$cc = explode(',',replace_mail_template_variables($mail_template_object->getCc(), $triggering_object, $template_parameters));
		}
		$bcc = array();
		if ($mail_template_object->getBcc() != '') {
			$bcc = explode(',',replace_mail_template_variables($mail_template_object->getBcc(), $triggering_object, $template_parameters));
		}
		
		$mail_account_id = 0;
		if ($mail_template_object->getMailAccountId() > 0) {
			$mail_account_id = $mail_template_object->getMailAccountId();
		}
		
		// replace from name variables with the parameters
		$from_name = replace_mail_template_variables($mail_template_object->getFromName(), $triggering_object, $template_parameters);
		
		// replace subject variables with the parameters
		$subject = replace_mail_template_variables($mail_template_object->getSubject(), $triggering_object, $template_parameters);
		
		// replace body variables with the parameters
		$body = replace_mail_template_variables($mail_template_object->getBody(), $triggering_object, $template_parameters);
		
		// build template data array to use
		$mail_template_data = array();
		if ($mail_account_id > 0) $mail_template_data['mail_account_id'] = $mail_account_id;
		if (!empty($subject)) $mail_template_data['subject'] = $subject;
		if (!empty($body)) $mail_template_data['body'] = $body;
		if (!empty($to)) $mail_template_data['to'] = $to;
		if (!empty($cc)) $mail_template_data['cc'] = $cc;
		if (!empty($bcc)) $mail_template_data['bcc'] = $bcc;
		if (!empty($from_name)) $mail_template_data['from_name'] = $from_name;
	}
	
}