<?php

include_once dirname(__FILE__)."/../../../application/helpers/plugin_installer_functions.php";

function object_templates_get_additional_install_queries($db_connection, $table_prefix) {
	
	$queries = array();
	
	if (!chcek_if_column_exists($db_connection, $table_prefix."system_permissions", 'can_manage_mail_templates')) {
		$queries[] = "ALTER TABLE `".$table_prefix."system_permissions` ADD `can_manage_mail_templates` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0;";
	}

    if (!chcek_if_column_exists($db_connection, $table_prefix."max_system_permissions", 'can_manage_mail_templates')) {
		$queries[] = "ALTER TABLE `".$table_prefix."max_system_permissions` ADD `can_manage_mail_templates` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0;";
	}

    if (!chcek_if_column_exists($db_connection, $table_prefix."mail_templates", 'object_status_types_id')) {
		$queries[] = "ALTER TABLE `".$table_prefix."mail_templates` ADD `object_status_types_id` INT(10) UNSIGNED NOT NULL DEFAULT 0;";
	}

    if (!chcek_if_column_exists($db_connection, $table_prefix."mail_templates", 'object_type_id')) {
		$queries[] = "ALTER TABLE `".$table_prefix."mail_templates` ADD `object_type_id` INT(10) UNSIGNED NOT NULL DEFAULT 0;";
	}

    if (!chcek_if_column_exists($db_connection, $table_prefix."mail_templates", 'is_notification_template')) {
		$queries[] = "ALTER TABLE `".$table_prefix."mail_templates` ADD `is_notification_template` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0;";
	}

    if (!chcek_if_column_exists($db_connection, $table_prefix."object_status_types", 'status')) {
		$queries[] = "ALTER TABLE `".$table_prefix."object_status_types` ADD `status` VARCHAR(100) NOT NULL DEFAULT '';";
	}


   $queries[]=" UPDATE `".$table_prefix."max_system_permissions` SET `can_manage_mail_templates`=1
            WHERE `permission_group_id` IN (
	                                        SELECT id FROM `".$table_prefix."permission_groups`
	                                        WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator','Manager','Executive')
            );";

 $queries[]=" UPDATE `".$table_prefix."system_permissions` SET `can_manage_mail_templates`=1
                WHERE `permission_group_id` IN (
                    SELECT id FROM `".$table_prefix."permission_groups`
                    WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator')
                );";

$queries[]=" INSERT INTO `".$table_prefix."object_status_types`
                (object_type_id, name, description, code, status, created_on, created_by_id, updated_on, updated_by_id)
            VALUES((SELECT id FROM `".$table_prefix."object_types` WHERE name = 'invoice'), 'send paid invoice', '', 'general_invoice_paid', 'confirmed', NULL, 0, NULL, 0);";

$queries[]=" INSERT INTO `".$table_prefix."object_status_types`
            (object_type_id, name, description, code, status, created_on, created_by_id, updated_on, updated_by_id)
            VALUES((SELECT id FROM `".$table_prefix."object_types` WHERE name = 'invoice'), 'send open invoice', '', 'general_invoice_pending', 'pending', NULL, 0, NULL, 0);";
	
	return $queries;

}
