<?php
if (isset($objective) && $objective instanceof Objective) {
	if (!$objective->isTrashed()){
		if($objective->canEdit(logged_user())) {
			add_page_action(lang('edit'), "javascript:og.render_modal_form('', {c:'objective', a:'edit', params: {id:".$objective->getId()."}});", 'ico-edit', null, null, true);
			/*
			if (!$objective->isArchived())
				add_page_action(lang('archive'), "javascript:if(confirm(lang('confirm archive object'))) og.openLink('" . $objective->getArchiveUrl() ."');", 'ico-archive-obj');
			else
				add_page_action(lang('unarchive'), "javascript:if(confirm(lang('confirm unarchive object'))) og.openLink('" . $objective->getUnarchiveUrl() ."');", 'ico-unarchive-obj');
				*/
		} // if
	}
	if ($objective->canDelete(logged_user())) {
		if ($objective->isTrashed()) {
			add_page_action(lang('restore from trash'), "javascript:if(confirm(lang('confirm restore objects'))) og.openLink('" . $objective->getUntrashUrl() ."');", 'ico-restore', null, null, true);
			add_page_action(lang('delete permanently'), "javascript:if(confirm(lang('confirm delete permanently'))) og.openLink('" . $objective->getDeletePermanentlyUrl() ."');", 'ico-delete', null, null, true);
		} else {
			add_page_action(lang('move to trash'), "javascript:if(confirm(lang('confirm move to trash'))) og.openLink('" . $objective->getTrashUrl() ."');", 'ico-trash', null, null, true);
		}
	}
?>

<div style="padding:7px">
<div class="objective">
    
<?php
	$content = '';
	$content .= '<div class="description"><span class="bold"></span>'.$objective->getDescription().'</div>';
	
	tpl_assign("content", $content);
	tpl_assign("object", $objective);
	tpl_assign('iconclass', $objective->isTrashed()? 'ico-large-objective-trashed' : ($objective->isArchived() ? 'ico-large-objective-archived' : 'ico-large-objective'));
	
	$this->includeTemplate(get_template_path('view', 'co'));
?>
</div>
</div>
<?php } //if isset ?>
