
INSERT INTO `<?php echo $table_prefix ?>object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`) VALUES
 ('objective', 'Objectives', 'objectives', 'content_object', 'objective', (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='objectives'))
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
	SELECT
	 (SELECT `id` FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='customer_project'), `id`, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='objective'), 0, 1
	FROM `<?php echo $table_prefix ?>object_types`
	WHERE `type` IN ('dimension_object','dimension_group') AND `plugin_id` = (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='crpm')
ON DUPLICATE KEY UPDATE dimension_id=dimension_id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
	SELECT
	 (SELECT `id` FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='workspaces'), `id`, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='objective'), 0, 1
	FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='workspace'
ON DUPLICATE KEY UPDATE dimension_id=dimension_id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
	SELECT
	 (SELECT `id` FROM `<?php echo $table_prefix ?>dimensions` WHERE `code`='tags'), `id`, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='objective'), 0, 1
	FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='tag'
ON DUPLICATE KEY UPDATE dimension_id=dimension_id;

DELETE FROM `<?php echo $table_prefix ?>dimension_object_type_contents` WHERE `dimension_id`=0 OR dimension_id IS NULL;

INSERT INTO `<?php echo $table_prefix ?>tab_panels` (`id`,`title`,`icon_cls`,`refresh_on_context_change`,`default_controller`,`default_action`,`initial_controller`,`initial_action`,`enabled`,`type`,`ordering`,`plugin_id`,`object_type_id`) VALUES 
 ('objectives-panel', 'objectives', 'ico-objectives', 1, 'objective', 'init', '', '', 1, 'system', 11, (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='objectives'), (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='objective')) 
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO `<?php echo $table_prefix ?>tab_panel_permissions` (`permission_group_id`, `tab_panel_id`)
 SELECT `c`.`permission_group_id`, 'objectives-panel'
 FROM `<?php echo $table_prefix ?>contacts` `c` WHERE `c`.`user_type` IN (
 	SELECT `id` FROM `<?php echo $table_prefix ?>permission_groups` WHERE `type`='roles' AND `name` IN ('Super Administrator','Administrator','Manager','Executive')
 )
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('objective')
	 AND p.`name` IN ('Super Administrator','Administrator','Manager');

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 0, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('objective')
	 AND p.`name` IN ('Executive');

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 0, 0
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('objective')
	 AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');

INSERT INTO <?php echo $table_prefix ?>role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('objective')
	AND p.`name` IN ('Super Administrator','Administrator','Manager');

INSERT INTO <?php echo $table_prefix ?>role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 0, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('objective')
	AND p.`name` IN ('Executive');

-- add permissions to users where the users already have permissions (copy permissions from tasks)
INSERT INTO <?php echo $table_prefix ?>contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
 SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='objective'), cmp.can_delete, cmp.can_write 
 FROM <?php echo $table_prefix ?>contact_member_permissions cmp
 WHERE cmp.object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>contact_member_permissions.member_id=<?php echo $table_prefix ?>contact_member_permissions.member_id;

INSERT INTO <?php echo $table_prefix ?>tab_panel_permissions (permission_group_id, tab_panel_id)
 SELECT pg.id, 'objectives-panel' FROM <?php echo $table_prefix ?>permission_groups pg WHERE pg.type='roles' AND pg.name IN ('Super Administrator','Administrator','Manager','Executive')
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;