<?php
function get_allowed_object_types_to_import() {
    $allowed_object_types_to_import = array('task','message','objective','form', 'project', 'supplier', 'customer', 'payment_receipt');
    Hook::fire('add_allowed_object_types_to_import', array(), $allowed_object_types_to_import);
    $ob_types = array();
    //$object_types = ObjectTypes::getAvailableObjectTypes();
    $object_types = ObjectTypes::getAvailableObjectTypesWithDimensionObjects();

    foreach ($object_types as $ot) {
        if(in_array($ot->getName(), $allowed_object_types_to_import)){
            $ob_types[] = array($ot->getId(), lang($ot->getName()));
        }
    }

    // Add timeslots to the allowed object types
    $timeslot_ot = ObjectTypes::findByName('timeslot');
    $ob_types[] = array($timeslot_ot->getId(), lang($timeslot_ot->getName()));

    $enabled_dimensions = config_option('enabled_dimensions');
    foreach($enabled_dimensions as $dim_id){
        $dimension_object_type_ids = DimensionObjectTypes::getObjectTypeIdsByDimension($dim_id);
        foreach($dimension_object_type_ids as $dim_ot_id){
            $ot = ObjectTypes::findById($dim_ot_id);
            if(!in_array($ot->getName(), $allowed_object_types_to_import)){
                $custom_name = DimensionObjectTypeOptions::findOne(array('conditions' => 'object_type_id='.$ot->getId().' AND `name`="custom_object_type_name"'));
                if($custom_name instanceof DimensionObjectTypeOption && $custom_name->getValue() != '') {
                    $ob_types[] = array($ot->getId(), $custom_name->getValue());
                } else {
                    $ob_types[] = array($ot->getId(), lang($ot->getName()));
                }
            }
        }
    }

    return $ob_types;
}