<?php
$submit_url = get_url('objects_import', 'import_from_csv_file');
$genid = gen_id();

$i = 0;
$options = array(option_tag('', ''));
if (isset($titles)){
    foreach ($titles as $k => $t){
        $options[] = option_tag($t, $k);
        $i++;
    }
}

$project_ot_id = ObjectTypes::findByName('project')->getId();
$client_ot_id = ObjectTypes::findByName('customer')->getId();
if (Plugins::instance()->isActivePlugin('suppliers')) {
    $supplier_ot_id = ObjectTypes::findByName('supplier')->getId();
}
if (Plugins::instance()->isActivePlugin('income')) {
    $income_taxes = IncomeTaxes::findAll(array('condition' => array('removed_by_id = 0')));
    $taxes = array();
    foreach ($income_taxes as $tax) {
        $tax_record = $tax->getRecord()->getArrayInfo();
        $taxes[] = array(
            'id' => $tax->getId(),
            'name' => $tax->getName(),
            'select' => $tax->getSelectDefault(),
            'is_default' => $tax->getSelectDefault(),
            'type' => $tax_record['type'],
            'value' => $tax_record['value'],
        );
    }
}
?>

<form style="height:100%;background-color:white" id="<?php echo $genid ?>obcsvimport" name="<?php echo $genid ?>obcsvimport" class="internalForm objectImportForm" action="<?php echo $submit_url ?>" method="post" enctype="multipart/form-data">

    <div class="file objects-import-form">
        <div class="coInputHeader">
            <div class="coInputHeaderUpperRow">
                <div class="title">
                    <?php echo lang('import objects from csv');?>
                </div>
            </div>
		</div>
		<div class="coInputMainBlock adminMainBlock">
            <?php if (!isset($titles) && !isset($import_result)) { ?>
                <div class="dataBlock">
                    <?php

                    echo label_tag(lang('object type'), $genid . 'reportFormObjectType', true,array('class' => 'coInputTitle1'));

                    $selected_option=null;
                    $options = array();
                    foreach ($object_types as $type) {
                        $options[] = '<option value="'.$type[0].'">'.$type[1].'</option>';
                    }

                    $context_menu_style = "font-weight:normal";
                    $context_div_display ="display:none;";
                    $strDisabled = count($options) > 1 ? '' : 'disabled';
                    echo select_box('objectTypeSel', $options, array('id' => $genid.'objectTypeSel' , 'style' => 'width:200px;', $strDisabled => '', 'tabindex' => '10'));
                    ?>
                </div>
                <div class="clear"></div>



            <div id="<?php echo $genid ?>first_record_has_names_div" class="dataBlock">
                <?php echo label_tag(lang('first record contains field names'), $genid . 'first_record_has_names',false,array('class' => 'coInputTitle1')) ?>
                <?php echo yes_no_widget('first_record_has_names', $genid.'first_record_has_names', true, lang('yes'), lang('no'), 20) ?>
            </div>
            <div id="<?php echo $genid ?>delimiter_div" class="dataBlock">
                <?php echo label_tag(lang('field delimiter'), $genid . 'delimiter',false,array('class' => 'coInputTitle1')) ?>
                <?php echo text_field('delimiter', '', array('id' => $genid.'delimiter', 'style' => 'width:10px;', 'tabindex' => 30)) ?>

            </div>
            <div id="<?php echo $genid ?>to_assign_country_use_div" class="dataBlock">
                <?php echo label_tag(lang('to assign country use'), $genid . 'to_assign_country_use',false,array('class' => 'coInputTitle1')) ?>

                <?php 
                $assign_country_options = array(array(0, lang('country code')), array(1, lang('country name')));
                echo simple_select_box('to_assign_country_use', $assign_country_options,0); ?>
            </div>
            <div id="<?php echo $genid ?>decimal_separator_div" class="dataBlock">
                <?php echo label_tag(lang('decimal separator'), $genid . 'decimal_separator',false,array('class' => 'coInputTitle1')) ?>

                <?php 
                $decimal_separator_options = array(array(0, '.'), array(1, ','));
                echo simple_select_box('decimal_separator', $decimal_separator_options,0); ?>
            </div>
            <div id="<?php echo $genid ?>thousand_separator_div" class="dataBlock">
                <?php echo label_tag(lang('thousand separator'), $genid . 'thousand_separator',false,array('class' => 'coInputTitle1')) ?>

                <?php 
                $thousand_separator_options = array(array(0, ','), array(1, '.'));
                echo simple_select_box('thousand_separator', $thousand_separator_options,0); ?>
            </div>
            <div id="<?php echo $genid ?>date_format_div" class="dataBlock">
                <?php echo label_tag(lang('user config option name date_format'), $genid . 'date_format',false,array('class' => 'coInputTitle1')) ?>
                <?php 
                	$handler = new DateFormatConfigHandler();
                	echo $handler->render('date_format');
                ?>
            </div>

            <?php if(Plugins::instance()->isActivePlugin('income') && count($taxes)) { ?>
            <div id="<?php echo $genid ?>taxes_div" class="dataBlock">
                <?php echo label_tag(lang('tax')) ?>
                <div style="float:left"><?php

                        foreach ($taxes as $tax) { ?>
                            <?php
                            echo checkbox_field('tax_' . $tax['id'] . '_check', $tax['select'], array('id' => $genid.'_tax_'.$tax['id'].'_check', 'style' => 'float: left; margin-top: 2px;',
                            'onchange' => "document.getElementById('".$genid."_tax_".$tax['id']."').value=(this.checked ? 1 : 0);"));
                            ?>
                            <input type="hidden" id="<?php echo $genid?>_tax_<?php echo $tax['id']?>" name="taxes[<?php echo $tax['id']?>]" value="<?php echo $tax['select']?>"/>
                            <label for="<?php echo $genid?>_tax_<?php echo $tax['id']?>_check" class="checkbox-label" style="padding-left: 5px; color: #333;"><?php echo $tax['name']?></label>
                            <div class="clear"></div>
                            <?php
                        }
                ?></div>
                <div class="clear"></div>
            </div>
            <?php } ?>

            <div id="<?php echo $genid ?>selectFileControlDiv" class="dataBlock">
                <?php echo label_tag(lang('file'), $genid . 'filenamefield',true,array('class' => 'coInputTitle1')) ?>
                <?php echo file_field('csv_file', null, array('id' => $genid . 'filenamefield', 'class' => '', 'tabindex' => 10, 'size' => '88', "onchange" => 'javascript:og.obSubmitCsvImport(\'' . $genid .'\')')) ?>
            </div>
            <?php } //if ?>
        </div>

        <?php if (isset($titles)) { ?>
            <div class="coInputMainBlock adminMainBlock">
                <?php
                // Assign proper section and table names based on object type
                if ($content_object_type_id == $project_ot_id) {
                    $select_section_name = lang('select the parent project');
                    $select_section_description = lang('if you want your projects to be nested under a parent project, please select it here.');
                    $fields_table_name = lang('project fields match');
                    $fields_table_description = lang('you must match the project fields with file fields before executing the import process');
                    $fields_table_first_column_name = lang('project fields');
                } else if ($content_object_type_id == $client_ot_id) {
                    $select_section_name = '';
                    $select_section_description = '';
                    $fields_table_name = lang('client fields match');
                    $fields_table_description = lang('you must match the client fields with file fields before executing the import process');
                    $fields_table_first_column_name = lang('client fields');
                } else {
                    $select_section_name = lang('select where to classify objects');
                    $select_section_description = '';
                    $fields_table_name = lang('object fields match');
                    $fields_table_description = lang('you must match the object fields with file fields before executing the import process');
                    $fields_table_first_column_name = lang('object fields');
                }
                ?>
                
                    <div class="coInputTitle">
                    <?php echo $select_section_name; ?>
                </div>

                <div>
                    <p>
                        <b><?php echo $select_section_description; ?></b>
                    </p>
                    <br>
                </div> 

                <?php 
                
                if ($content_object_type_id == $project_ot_id) {
                    $dimension = Dimensions::findOne(array('conditions'=>'code="customer_project"'));
                    if($dimension instanceof Dimension) {
                        render_single_member_selector($dimension, $genid, null, array('is_multiple'=>false));
                    }
                } else if ($content_object_type_id == $client_ot_id) {
                    echo '';
                } else {
                    render_member_selectors($content_object_type_id, $genid,null, array('select_current_context' => true),null,null,false);
                } ?>

                
                <div class="coInputTitle">
                    <?php echo $fields_table_name; ?>
                </div>

                <div>
                    <p>
                        <b><?php echo $fields_table_description; ?></b>
                    </p>
                    <br>
                </div>
                <table class="objectFields">
                    <?php //Titles ?>
                    <tr class="header">
                        <th><?php echo $fields_table_first_column_name; ?></th>
                        <th><?php echo lang('fields from file'); ?></th>
                    </tr>

                    <?php //Object Properties
                    $isAlt = false;
                    ?>
                    <?php  foreach ($object_fields as $object_field_info) {?>
                        <?php  if(!array_key_exists('cp_field',$object_field_info) && !array_key_exists('member_cp_field',$object_field_info) && !array_key_exists('assoc_dim',$object_field_info) && !array_key_exists('client_field',$object_field_info) && !array_key_exists('cp_field_address',$object_field_info) && !array_key_exists('member_cp_field_address',$object_field_info) && !array_key_exists('content_object_dim',$object_field_info) && !array_key_exists('project_template_field',$object_field_info)) {?>
                        <tr<?php echo ($isAlt ? ' class="alt"': '') ?>>
                            <td>
                                <?php echo $object_field_info['name']; if($object_field_info['is_required']){ echo' <span class="label_required">*</span>';} ?>
                            </td>
                            <td>
                                <?php 
                                $required_attr = $object_field_info['is_required'] ? array('required' => 'true') : null;
                                echo select_box('select_object_fields['.$object_field_info['id'].']', $options, $required_attr); ?>
                            </td>
                        </tr>
                        <?php  } else if (array_key_exists('cp_field',$object_field_info)){?>
                            <tr<?php echo ($isAlt ? ' class="alt"': '') ?>>
                                <td><?php echo $object_field_info['name']; if($object_field_info['is_required']){ echo' <span class="label_required">*</span>';}?></td>
                                <td><?php 
                                $required_attr = $object_field_info['is_required'] ? array('required' => 'true') : null;
                                echo select_box('select_custom_properties['.$object_field_info['id'].']', $options, $required_attr); ?></td>
                            </tr>
                        <?php  } else if (array_key_exists('cp_field_address',$object_field_info)){?>
                            <tr<?php echo ($isAlt ? ' class="alt"': '') ?>>
                                <td><?php echo $object_field_info['name'] ?></td>
                                <td><?php echo select_box('select_custom_properties['.$object_field_info['id'].']['.$object_field_info['sub_id'].']', $options); ?></td>
                            </tr>
                        <?php } else if (array_key_exists('member_cp_field',$object_field_info)){?>
                            <tr<?php echo ($isAlt ? ' class="alt"': '') ?>>
                                <td><?php echo $object_field_info['name'] ?></td>
                                <td><?php echo select_box('select_member_custom_properties['.$object_field_info['id'].']', $options); ?></td>
                            </tr>
                        <?php  } else if (array_key_exists('member_cp_field_address',$object_field_info)){?>
                            <tr<?php echo ($isAlt ? ' class="alt"': '') ?>>
                                <td><?php echo $object_field_info['name'] ?></td>
                                <td><?php echo select_box('select_member_custom_properties['.$object_field_info['id'].']['.$object_field_info['sub_id'].']', $options); ?></td>
                            </tr>
                        <?php } else if(array_key_exists('assoc_dim',$object_field_info)) {?>
                            <tr<?php echo ($isAlt ? ' class="alt"': '') ?>>
                                <td><?php echo $object_field_info['name'] ?></td>
                                <td><?php echo select_box('select_associated_dimension['.$object_field_info['assoc_id'].']', $options); ?></td>
                            </tr>
                        <?php } else if(array_key_exists('content_object_dim',$object_field_info)) {?>
                            <tr<?php echo ($isAlt ? ' class="alt"': '') ?>>
                                <td><?php echo $object_field_info['name'] ?></td>
                                <td><?php echo select_box('select_content_object_member['.$object_field_info['dim_and_ot_id'].']', $options); ?></td>
                            </tr>
                        <?php } else if(array_key_exists('project_template_field',$object_field_info)) {?>
                            <tr<?php echo ($isAlt ? ' class="alt"': '') ?>>
                                <td><?php echo lang($object_field_info['name']); ?></td>
                                <td><?php echo select_box('select_object_fields['.$object_field_info['name'].']', $options); ?></td>
                            </tr>
                        <?php } else if(array_key_exists('client_field',$object_field_info)) {?>
                            <tr<?php echo ($isAlt ? ' class="alt"': '') ?>>
                                <td><?php echo lang($object_field_info['name']); ?></td>
                                <td><?php echo select_box('select_client_contact_info['.$object_field_info['name'].']', $options); ?></td>
                            </tr>
                        <?php  } ?>
                    <?php $isAlt = !$isAlt; } ?>
                </table>
            </div>
        <?php } //if?>

	    <div class="coInputMainBlock adminMainBlock">
        <?php
	    if (!isset($titles) && !isset($import_result)) { ?>
		    <p><b><?php echo lang('select a file in order to load its data') ?></b></p>
        <?php	}  ?>


	    </div>
        <div class="coInputMainBlock adminMainBlock">
            <?php
            if (isset($import_result)) {
                if (count($import_result['import_ok'])) {
                $isAlt = false;
            ?>
                <table class="objectFields">
                    <tr class="header">
                        <th style="text-align:center"><?php echo lang('objects successfully imported')?></th>
                        <th style="text-align:center"><?php echo lang('status') ?></th>
                    </tr>
                    <?php
                    foreach ($import_result['import_ok'] as $reg) { csv_row_number ?>
                        <tr<?php echo ($isAlt ? ' class="alt"': '') ?>>
                            <td style="padding-left:10px;"><?php echo array_var($reg, 'csv_row_number').')'.array_var($reg, 'name')?></td>
                            <td style="padding-left:10px;"><span class="desc"><?php echo array_var($reg, 'import_status') ?></span></td>
                        </tr>
                        <?php 			$isAlt = !$isAlt;
                    } ?>
                </table><br>
            <?php 	} //if
                if (count($import_result['import_fail'])) {
                $isAlt = false;
                ?>
                <table class="objectFields">
                    <tr class="header">
                        <th style="text-align:center"><?php echo lang('objects import fail')?></th>
                        <th style="text-align:center"><?php echo lang('import fail reason') ?></th>
                    </tr>
                    <?php
                    foreach ($import_result['import_fail'] as $reg) { ?>
                        <tr<?php echo ($isAlt ? ' class="alt"': '') ?>>
                            <td style="padding-left:10px;"><?php echo array_var($reg, 'csv_row_number').')'.array_var($reg, 'name')?></td>
                            <td style="padding-left:10px;"><?php echo array_var($reg, 'fail_message') ?></td></tr>
                        <?php 			$isAlt = !$isAlt;
                    } ?>
                </table>
            <?php 	}
            } //if?>
        </div>
    </div>

    <?php if (isset($titles)) { ?>
        <?php echo submit_button(lang('import'), 's', array('class'=>'add-first-btn blue','style'=>'margin-top:0px;margin-left:10px','id' => $genid.'csv_import_submit1', 'tabindex' => 40)) ?>
    <?php } ?>
    <div class="clear"></div>
</form>

