<?php
	class OvertimeHour extends BaseOvertimeHour {
		
		function getEditUrl() {
			return null;
		}
		
		function canAdd(Contact $user, $context, &$notAllowedMember = ''){
			return can_add($user, $context, StatusesPaymentReceipts::instance()->getObjectTypeId(), $notAllowedMember);
		}
		
		/**
		 * Returns true if $user can access it
		 *
		 * @param Contact $user
		 * @return boolean
		 */
		function canView(Contact $user) {
			return can_read($user, $this->getMembers(), $this->getObjectTypeId());
		} // canView
	
		/**
		 * Check if specific user can edit it
		 *
		 * @access public
		 * @param Contact $user
		 * @return boolean
		 */
		function canEdit(Contact $user) {
			return can_write($user, $this->getMembers(), $this->getObjectTypeId());
		} // canEdit
	
	
		/**
		 * Check if specific user can delete it
		 *
		 * @access public
		 * @param Contact $user
		 * @return boolean
		 */
		function canDelete(Contact $user) {
			return can_delete($user, $this->getMembers(), $this->getObjectTypeId());
		} // canDelete
	
		/**
		 * Check if specific user can comment on it
		 *
		 * @access public
		 * @param void
		 * @return boolean
		 */
		function canAddComment(Contact $user) {
			return can_write($user, $this->getMembers(), $this->getObjectTypeId());
		} // canAddComment



		function getAdditionalCustomPropertyValues($cp) {
			$cp_values = array();
			if ($cp instanceof CustomProperty) {
				$cp_values = CustomPropertyValues::getCustomPropertyValues($this->getContactId(), $cp->getId());
			}
			return $cp_values;
		}
		
	}