<?php
	Env::useHelper('format');
	
	$date_format = user_config_option('date_format');

	if (array_var($post, 'due_date_type') == 6) {
		if ($start_time instanceof DateTimeValue) $start_time->advance(-1 * logged_user()->getUserTimezoneValue(), true);
		if ($end_time instanceof DateTimeValue) $end_time->advance(-1 * logged_user()->getUserTimezoneValue(), true);
	}
	
	if (isset($start_time) && $start_time instanceof DateTimeValue) { ?>
		<span class="bold"><?php echo lang('from')?></span>:&nbsp;<?php echo $start_time->format($date_format) ?>
	<?php }
	if (isset($end_time) && $end_time instanceof DateTimeValue) { ?>
		<span class="bold" style="padding-left:10px"><?php echo lang('to date')?></span>:&nbsp;<?php echo $end_time->format($date_format) ?>
	<?php } ?>
	
	<?php if (count(active_context_members(false)) > 0) : ?>
	<div class="clear"></div>
	<div style="margin-bottom: 10px; padding-bottom: 5px; float:left;">
		<h5><?php echo lang('showing information for')?>:</h5>
		<ul>
		<?php
			$context = active_context();
			foreach ($context as $selection) :
				if ($selection instanceof Member) : ?>
					<li><span class="coViewAction <?php echo $selection->getIconClass()?>"><?php echo $selection->getName()?></span></li>
		<?php 	endif;
			endforeach;
		?>
		</ul>
	</div>
	<div class="clear"></div>
	<?php endif; ?>
	
	<div>
		<table style="" class="report custom-report">
		<thead>
			<tr class="custom-report-table-heading no-details">
				<th><?php echo 'PayGroup' ?></th>
				<th><?php echo 'Department' ?></th>
				<th><?php echo 'Key' ?></th>
				<th><?php echo lang('name') ?></th>
				<th class="center"><?php echo lang('regular')?></th>
				<th class="center"><?php echo lang('overtime')?></th>
				<th class="center"><?php echo lang('double overtime')?></th>
			<?php foreach ($non_worked_columns as $col_id => $col_name): ?>
				<th class="center"><?php echo $col_name ?></th>
			<?php endforeach;?>
				<th class="center"><?php echo 'Miles'?></th>
				<th class="center"><?php echo lang('total')?></th>
			</tr>
		</thead>
		<tbody class="report-data">
	<?php
		$alt = "alt";
		foreach ($all_accumulated_minutes as $data) {
			$alt = $alt == "" ? "alt" : "";
			
			$regular = $data['regular'] > 0 ? format_time_column_value($data['regular']) : "--";
			$overtime = $data['overtime'] > 0 ? format_time_column_value($data['overtime']) : "--";
			$double_overtime = $data['double_overtime'] > 0 ? format_time_column_value($data['double_overtime']) : "--";
			$total = $data['total'] > 0 ? format_time_column_value($data['total']) : "--";
	?>
			<tr class="report-row-tbody <?php echo $alt ?>">
				<td><?php echo array_var($data, 'paygroup') ?></td>
				<td><?php echo array_var($data, 'department') ?></td>
				<td><?php echo array_var($data, 'key') ?></td>
				<td><?php echo array_var($data, 'name') ?></td>
				<td class="right"><?php echo $regular ?></td>
				<td class="right"><?php echo $overtime ?></td>
				<td class="right"><?php echo $double_overtime ?></td>
				<?php foreach ($non_worked_columns as $col_id => $col_name): ?>
				<td class="right"><?php echo format_time_column_value(array_var($data, $col_id)) ?></td>
				<?php endforeach;?>
				<td class="right"><?php echo array_var($data, 'miles') ?></td>
				<td class="right"><?php echo $total ?></td>
			</tr>
	<?php 
		}
	?>
	<?php if (isset($totals)) {
		
			$totals_regular = $totals['regular'] > 0 ? format_time_column_value($totals['regular']) : "--";
			$totals_overtime = $totals['overtime'] > 0 ? format_time_column_value($totals['overtime']) : "--";
			$totals_double_overtime = $totals['double_overtime'] > 0 ? format_time_column_value($totals['double_overtime']) : "--";
			$totals_total = $totals['total'] > 0 ? format_time_column_value($totals['total']) : "--";
	?>
			<tr class="list-totals-row">
				<td class="textrow"></td>
				<td class="textrow"></td>
				<td class="textrow"></td>
				<td class="textrow"></td>
				<td><?php echo $totals_regular ?></td>
				<td><?php echo $totals_overtime ?></td>
				<td><?php echo $totals_double_overtime ?></td>
				<?php foreach ($non_worked_columns as $col_id => $col_name): ?>
				<td><?php echo format_time_column_value(array_var($totals, $col_id)) ?></td>
				<?php endforeach;?>
				<td><?php echo array_var($totals, 'miles') ?></td>
				<td><?php echo $totals_total ?></td>
			<tr>
	<?php } ?>
		</tbody>
		</table>
	</div>
	<script>
	$(function() {
		eval('<?php echo $crumbJs; ?>');
		og.eventManager.fireEvent('replace all empty breadcrumb');
	});
	</script>
<?php //} ?>