<?php

class PaemfeController extends ApplicationController {

	function __construct() {
		parent::__construct();
		prepare_company_website_controller($this, 'dialog');
		Env::useHelper('constants', 'paemfe');
	}
	

	function start_service() {
		
		$task = ProjectTasks::findById(get_id());
		if(!($task instanceof ProjectTask)) {
			flash_error(lang('task list dnx'));
			ajx_current("empty");
			return;
		} // if

		if(!$task->canEdit(logged_user())) {
			flash_error(lang('no access permissions'));
			ajx_current("empty");
			return;
		}
		
		try {
			DB::beginWork();
			$cp_value = CustomPropertyValues::getCustomPropertyValue($task->getId(), SERVICE_STARTDATE_CP_ID);
			if (!$cp_value instanceof CustomPropertyValue) {
				$cp_value = new CustomPropertyValue();
				$cp_value->setObjectId($task->getId());
				$cp_value->setCustomPropertyId(SERVICE_STARTDATE_CP_ID);
			}
			if (trim($cp_value->getValue() == '')) {
				$cp_value->setValue(DateTimeValueLib::now()->toMySQL());
				$cp_value->save();
			}
			DB::commit();
			ajx_current("reload");
			
		} catch(Exception $e) {
			DB::rollback();
			flash_error($e->getMessage());
			ajx_current("empty");
		}
	}
}
