<?php echo stylesheet_tag(get_public_url('assets/css/paemfe.css', 'paemfe')); ?>
<?php if (is_array($dev_data)) $dev_data = array_shift($dev_data) ?>
<?php 
	$client_address = null;
	if ($client instanceof Contact) {
		$addresses = ContactAddresses::instance()->getByContact($client);
		if (count($addresses) > 0) $client_address = $addresses[0];
	}
?>
<?php foreach ($copies as $copy_label) { ?>
<div class="print-receipt" style="max-height: <?php echo $page_height ?>px; min-height: <?php echo $page_height ?>px;">
	<div class="print-receipt-header">
		<table style="width:100%;">
			<tr>
				<td style="width: 33%;"><img src="<?php echo $company_logo_url1 ?>" /></td>
				<td style="width: 33%;"><img src="<?php echo $company_logo_url2 ?>" /></td>
				<td align="right" style="padding-right: 20px;">
					<table cellpadding="3" style="font-weight: bold;">
						<tr><td><?php echo lang('receipt num') ?></td><td align="right"><?php echo $task->getUniqueObjectId() ?></td></tr>
					</table>
				</td>
			</tr>
		</table>
		<table style="width:100%;" cellpadding="0" cellspacing="0">
			<tr>
				<td style="width:60%; vertical-align:bottom;">
					<div style="border-bottom: 3px solid blue; width:100%; max-height: 1px; margin:1px 0;"></div>
					<div style="border-bottom: 1px solid black; width:100%; max-height: 1px; margin:1px 0;"></div>
				</td>
				<td align="center"><?php echo lang('print title dev') ?></td>
				<td style="width:30px; vertical-align:bottom;">
					<div style="border-bottom: 3px solid blue; width:100%; max-height: 1px; margin:1px 0;"></div>
					<div style="border-bottom: 1px solid black; width:100%; max-height: 1px; margin:1px 0;"></div>
				</td>
			</tr>
		</table>
	</div>
	
	<div>
		<table style="width:100%;">
			<tr><td style="width:60%;vertical-align: top;">
				<fieldset><legend><?php echo lang('institution data') ?></legend>
					<table style="width:100%">
					<tr>
						<td class="print-receipt-label"><?php echo lang('name') ?></td>
						<td class="print-receipt-fill-data" colspan="2" style="min-width: 150px;">
							<?php echo ($client instanceof Contact ? $client->getName() : '&nbsp;') ?>
						</td>
						<td class="print-receipt-label"><?php echo lang('dependency abr') ?></td>
						<td class="print-receipt-fill-data">&nbsp;
							<?php echo $dependency ?>
						</td>
					</tr><tr>
						<td class="print-receipt-label"><?php echo lang('address') ?></td>
						<td class="print-receipt-fill-data" colspan="4">
							<?php echo ($client_address instanceof ContactAddress ? $client_address->getStreet() : '&nbsp;') ?>
						</td>
					</tr><tr>
						<td class="print-receipt-label"><?php echo lang('department abr') ?></td>
						<td class="print-receipt-fill-data" colspan="2">
							<?php echo ($client_address instanceof ContactAddress ? $client_address->getState() : '&nbsp;') ?>
						</td>
						<td class="print-receipt-label"><?php echo lang('city') ?></td>
						<td class="print-receipt-fill-data">
							<?php echo ($client_address instanceof ContactAddress ? $client_address->getCity() : '&nbsp;') ?>
						</td>
					</tr><tr>
						<td class="print-receipt-label"><?php echo lang('phone') ?></td>
						<td class="print-receipt-fill-data">
							<?php echo ($client instanceof Contact ? $client->getPhoneNumber('work', false, false) : '&nbsp;') ?>
						</td>
						<td class="print-receipt-label" style="width:35px;"><?php echo lang('email label') ?></td>
						<td class="print-receipt-fill-data" colspan="2">
							<?php echo ($client instanceof Contact ? $client->getEmailAddress() : '&nbsp;') ?>
						</td>
					</tr>
					</table>
				</fieldset>
			</td><td style="vertical-align: top;">
				<fieldset><legend><?php echo lang('devolution data') ?></legend>
					<table style="width:100%">
					<tr>
						<td class="print-receipt-label"><?php echo lang('date') ?></td>
						<td class="print-receipt-fill-data"><?php echo ($task->getStartDate() ? format_date($task->getStartDate(), null, 0) : '&nbsp;') ?></td>
					</tr><tr>
						<td class="print-receipt-label"><?php echo lang('name') ?></td>
						<td class="print-receipt-fill-data"><?php echo $task->getAssignedToName() ?></td>
					</tr><tr>
						<td class="print-receipt-label"><?php echo lang('doc id') ?></td>
						<td class="print-receipt-fill-data"><?php echo (isset($user_doc_id) ? $user_doc_id : '') ?>&nbsp;</td>
					</tr><tr>
						<td class="print-receipt-label"><?php echo lang('signature') ?></td>
						<td class="print-receipt-fill-data">&nbsp;</td>
					</tr>
					</table>
				</fieldset>
			</td></tr>
		</table>
	</div>
	
	<div>
	<fieldset class="container">
		<table style="width:100%; border-bottom: 1px solid black;" cellpadding="0" cellspacing="0">
			<tr>
				<td align="center" class="print-receipt-body-title" style="width:70px;"><?php echo lang('equipment') ?></td>
				<td colspan="2" align="center" class="print-receipt-body-title"><?php echo lang('description') ?></td>
				<td align="center" class="print-receipt-body-title" style="width:130px;"><?php echo lang('serial number') ?></td>
				<td align="center" class="print-receipt-body-title" style="width:100px;"><?php echo lang('code') ?></td>
			</tr>
			<?php
				$i = 1;
				while (count($devolutions) < 8) $devolutions[] = '';
				foreach ($devolutions as $eq) {
			?>
				<tr>
					<td align="center" class="print-receipt-body-data" style="border-left: 1px solid black;"><?php echo $i++ ?>&nbsp;</td>
					<td colspan="2" class="print-receipt-body-data"><?php echo array_var($eq, 'description') ?>&nbsp;</td>
					<td class="print-receipt-body-data" ><?php echo array_var($eq, 'serial_num') ?>&nbsp;</td>
					<td class="print-receipt-body-data" style="border-right: 1px solid black;"><?php echo array_var($eq, 'code') ?>&nbsp;</td>
				</tr>
				<tr>
					<td class="print-receipt-label" style="border: 1px solid black;border-right: 0;padding: 0 5px;">&nbsp;</td>
					<td align="right" class="print-receipt-label" style="border: 1px solid black;border-left: 0;padding: 0 5px; width:110px;"><?php echo lang('status') ?></td>
					<td colspan="3" class="print-receipt-body-data" style="border-left: 1px solid black;border-right: 1px solid black;"><?php echo array_var($eq, 'fail') ?>&nbsp;</td>
				</tr>
				
			<?php } ?>
		</table>
	</fieldset>	
	</div>
	
	<div>
		<table style="width:100%;">
			<tr><td style="width:60%;">
				<fieldset><legend><?php echo lang('devolution by') ?></legend>
					<table style="width:100%">
					<tr>
						<td colspan="1" class="print-receipt-label" style="width:40%;"><?php echo lang('by'). ": $dev_by" ?>&nbsp;</td>
						<td class="print-receipt-label" style="width:80px;"><?php echo lang('arch num') ?></td>
						<td class="print-receipt-fill-data"><?php echo $arch_num ?>&nbsp;</td>
					</tr>
					<tr><td colspan="3">&nbsp;</td></tr>
					<tr>
						<td class="print-receipt-label" style="width:180px;"><?php echo lang('by institution') ?></td>
						<td colspan="2" class="print-receipt-fill-data">&nbsp;</td>
					</tr>
					<tr>
						<td class="print-receipt-label"><?php echo lang('doc id') ?></td>
						<td colspan="2" class="print-receipt-fill-data">&nbsp;</td>
					</tr>
					<tr>
						<td class="print-receipt-label"><?php echo lang('signature') ?></td>
						<td colspan="2" class="print-receipt-fill-data">&nbsp;</td>
					</tr>
					</table>
				</fieldset>
			</td><td align="center" style="vertical-align: bottom;">
				<div style="background-color: #CCC; text-align: center; height: 50px; width: 85%; border: 1px dotted black;">
					<div style="margin-top:17px; "><?php echo $copy_label ?></div>
				</div>				
			</td></tr>
		</table>
	</div>
	
	<div style="padding-left: 100px; height: 40px; font-style: italic; font-weight: bold;">
		<?php echo lang('message') .": $note" ?>
	</div>
	
	<div class="print-receipt-footer">
		<div style="border-bottom: 1px solid black; width:100%; max-height: 1px;"></div>
		<div style="border-bottom: 3px solid blue; width:100%; max-height: 1px; margin:1px 0 5px;"></div>
	<?php 
		$addresses = ContactAddresses::instance()->getByContact(owner_company());
		echo owner_company()->getName();
		if (count($addresses) > 0) echo " - " . $addresses[0]->getStreet();
		if (owner_company()->getPhoneNumber('work', false, false)) echo " - " . lang('phone') . owner_company()->getPhoneNumber('work', false, false);
		if (owner_company()->getEmailAddress()) echo " - " . owner_company()->getEmailAddress();
		if (count($addresses) > 0) echo " - " . $addresses[0]->getCity(); 
	?> 
	</div>
	
</div>
<?php
	}
?>
<script>
	window.print();
</script>