<?php
	$genid = gen_id();
	$project_id = 0;

	$report_data = array_var($_SESSION, 'services_report_data', array());
	
	if (active_project() instanceof Project) {
		$project_id = active_project()->getId();
	}
	if (!isset($report_data['date_type'])) {
		$report_data['date_type'] = 6;
	}
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('print_receipt_reports', 'services_report') ?>" method="post" enctype="multipart/form-data">

	<div class="coInputHeader" style="margin-bottom:20px;">
		<div class="coInputHeaderUpperRow">
			<div class="coInputTitle"><?php echo lang('services report') ?></div>
		</div>
		<div style="padding:0"><?php echo lang('services report desc') ?></div>
	</div>
	
	<div class="coInputMainBlock">
		
		<table>
			<?php
				if (array_var($report_data, "date_type") == 6) {
					$style = "";
			       	$st = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'start_value'));
			       	$et = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'end_value'));
				} else {
					$style = 'display:none;';
					$st = DateTimeValueLib::now();
					$et = $st;
				} 
			?>
			<tr class="dateTr"  style="<?php echo $style ?>">
				<td style="padding-bottom:5px;"><b><?php echo lang("start date") ?>:&nbsp;</b></td>
				<td><?php echo pick_date_widget2('report[start_value]', $st, $genid);?></td>
			</tr>
			<tr class="dateTr"  style="<?php echo $style ?>">
				<td style="padding-bottom:5px;"><b><?php echo lang("end date") ?>:&nbsp;</b></td>
				<td><?php echo pick_date_widget2('report[end_value]', $et, $genid);?></td>
			</tr>
			
			<tr>
				<td style="padding-bottom:5px;"><b><?php echo lang("workspace") ?>:&nbsp;</b></td>
				<td><?php 
					$ws_dim = Dimensions::findByCode('workspaces');
					$selected_members = json_decode(array_var($report_data, 'workspaces'), true);
					render_single_member_selector($ws_dim, $genid, $selected_members, array('hide_label' => true, 'hidden_field_name' => 'report[workspaces]'));
					?>
				</td>
			</tr>
			
		</table>
	
	<?php echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;margin-left:0px')) ?>
	</div>

</form>