<?php
echo stylesheet_tag("og/reporting.css");
require_javascript("og/ReportingFunctions.js");
$genid = gen_id();
if (!isset($conditions)) $conditions = array();

$project_ot = ObjectTypes::findByName('project');
$projects_dim = Dimensions::findByCode('customer_project');

$report_data = array_var($_SESSION, 'ar_ledger_report_data');
$report_key = 'ar_ledger_report_data_'.IncomeInvoices::instance()->getObjectTypeId();
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('project_reports', 'ar_ledger_report') ?>" method="post" enctype="multipart/form-data">

<input type="hidden" id="<?php echo $genid?>report[report_object_type_id]" name="report[report_object_type_id]" value="<?php echo IncomeInvoices::instance()->getObjectTypeId()?>"/>

<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo $title; ?>
	</div>
</div>
<div class="coInputSeparator"></div>

<div class="coInputMainBlock">

	<div class="dataBlock">
		
		<table class="ar-ledger-report-params">
			<tr>
				<td class="label"><span class="bold"><?php echo $project_ot->getObjectTypeName(); ?>:&nbsp;</span></td>
				<td align='left'><?php 
					render_single_member_selector($projects_dim, $genid, active_context_members(false), array('is_multiple' => false, 'is_required' => false, 'hide_label'=>true, 'hidden_field_name' => 'report[project_member_id]'));
				?></td>
			</tr>
			<tr>
				<td class="label"><span class="bold"><?php echo lang("date range") ?>:&nbsp;</span></td>
				<td align='left'><?php 
					echo select_box('report[date_type]', array(
						option_tag(lang('no filter'), 0, array_var($report_data, "date_type") == 0 ? array('selected' => 'selected'):null),
						option_tag(lang('today'), 1, array_var($report_data, "date_type") == 1 ? array('selected' => 'selected'):null),
						option_tag(lang('this week'), 2, array_var($report_data, "date_type") == 2 ? array('selected' => 'selected'):null),
						option_tag(lang('last week'), 3, array_var($report_data, "date_type") == 3 ? array('selected' => 'selected'):null),
						option_tag(lang('this month'), 4, array_var($report_data, "date_type") == 4 ? array('selected' => 'selected'):null),
						option_tag(lang('last month'), 5, array_var($report_data, "date_type") == 5 ? array('selected' => 'selected'):null),
						option_tag(lang('select dates...'), 6, array_var($report_data, "date_type") == 6 ? array('selected' => 'selected'):null)
					), array('onchange' => 'og.dateselectchange(this)'));
				?></td>
			</tr>
			<?php
				if (array_var($report_data, "date_type") == 6) {
					$style = "";
					$st = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'start_value'));
					$et = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'end_value'));
				} else {
					$style = 'display:none;';
					$st = DateTimeValueLib::now();
					$et = $st;
				} 
			?>
			<tr class="dateTr" style="<?php echo $style ?>">
				<td class="label"><span class="bold"><?php echo lang("start date") ?>:&nbsp;</span></td>
				<td align='left'><?php echo pick_date_widget2('report[start_value]', $st, $genid);?></td>
			</tr>
			<tr class="dateTr" style="<?php echo $style ?>">
				<td class="label"><span class="bold"><?php echo lang("end date") ?>:&nbsp;</span></td>
				<td align='left'><?php echo pick_date_widget2('report[end_value]', $et, $genid);?></td>
			</tr>
		</table>
	</div>

	<?php echo submit_button(lang('generate report'),'s',array('onclick'=>'og.setMemoryFilttersReport(this,"'.$report_key.'")','style'=>'margin-top:0px;')) ?>
</div>


</form>
<script>
	og.loadFiltersReport("<?php echo $report_key; ?>");
</script>