<?php
echo stylesheet_tag("og/reporting.css");
require_javascript("og/ReportingFunctions.js");
$genid = gen_id();
if (!isset($conditions)) $conditions = array();

$report_data = array_var($_SESSION, 'budget_report_data');
$report_key = 'budget_report'.ProjectTasks::instance()->getObjectTypeId();
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('project_reports', 'budget_report') ?>" method="post" enctype="multipart/form-data">
<input type="hidden" id="<?php echo $genid?>report[report_object_type_id]" name="report[report_object_type_id]" value="<?php echo ProjectTasks::instance()->getObjectTypeId()?>"/>
<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo $title ?>
	</div>
</div>
<div class="coInputSeparator"></div>
<div class="coInputMainBlock">
	
	<?php if (count(active_context_members(false)) > 0) : ?>
	<div style="margin-bottom: 15px; padding-bottom: 5px; border-bottom:1px dotted #aaa;">
		<h5><?php echo lang('showing information for')?>:</h5>
		<ul>
		<?php
			$context = active_context();
			foreach ($context as $selection) :
				if ($selection instanceof Member) : ?>
					<li><span class="coViewAction <?php echo $selection->getIconClass()?>"><?php echo $selection->getName()?></span></li>	
		<?php 	endif;
			endforeach;
		?>
		</ul>
	</div>
	<?php else: ?>
	<div style="padding:5px;"></div>
	<?php endif; 
	
	$projects_dim = Dimensions::findByCode('customer_project');
	render_single_member_selector($projects_dim, $genid, active_context_members(false), array('is_multiple' => false, 'is_required' => true, 'hidden_field_name' => 'report[project_member_ids]'));
	?>

	<div class="dataBlock">
		<label><?php echo lang('include main project information')?>:</label>
		<?php echo checkbox_field('report[show_main_project_info]', array_var($report_data, 'show_main_project_info'))?>
	</div>

	<?php
		$product_type_name = lang('product type');
		if (Plugins::instance()->isActivePlugin('expense_categories')) {
			$expense_category_name = ObjectTypes::findByName('expense_category')->getObjectTypeName();
			$expenses_select_array = array(array(0,$product_type_name), array(1, $expense_category_name));
		} else {
			$expenses_select_array = array(array(0,$product_type_name));
		}
	?>
	<div class="dataBlock">
		<label><?php echo lang('group expenses by')?>:</label>
		<?php echo simple_select_box('report[group_expenses_by]', $expenses_select_array, array_var($report_data, 'group_expenses_by'))?>
	</div>

	<?php
		$enabled_dimensions = config_option('enabled_dimensions');
		$job_phase_dim = Dimensions::findByCode('job_phases');
		if ($job_phase_dim instanceof Dimension && in_array($job_phase_dim->getId(), $enabled_dimensions)){
			$columns_select_array = array(array(0,$job_phase_dim->getName()), array(1, lang('subprojects')));
		} else {
			$columns_select_array = array(array(1, lang('subprojects')));
		}
		
		$columns_attributes = array() ;
		$columns_attributes['id'] = 'budget_report_columns';
	?>
	<div class="dataBlock">
		<label><?php echo lang('group columns by')?>:</label>
		<?php echo simple_select_box('report[group_columns_by]', $columns_select_array, array_var($report_data, 'group_columns_by'), $columns_attributes)?>
	</div>

	<?php

		$subprojects_select_array = array(array(0,lang('consolidate')), array(1, lang('list separately')));
		$subprojects_attributes = array();
		$subprojects_attributes['id'] = 'budget_report_subprojects_setting'
	?>
	<div class="dataBlock">
		<label><?php echo lang('subprojects')?>:</label>
		<?php echo simple_select_box('report[list_supbrojects]', $subprojects_select_array, array_var($report_data, 'list_supbrojects'), $subprojects_attributes)?>
	</div>
<br/>
<?php echo submit_button(lang('generate report'),'s',array('onclick'=>'og.setMemoryFilttersReport(this,"'.$report_key.'")','style'=>'margin-top:0px;')) ?>
</div>
</div>

</form>

<script>
	og.loadFiltersReport("<?php echo $report_key; ?>");
	
	if($('#budget_report_columns').val() == 0){
		$('#budget_report_subprojects_setting').attr("disabled", false);
	} else if ($('#budget_report_columns').val() == 1){
		$('#budget_report_subprojects_setting').attr("disabled", true);
	}


	$('#budget_report_columns').on('change', function(){
		if($('#budget_report_columns').val() == 0){
			$('#budget_report_subprojects_setting').attr("disabled", false);
		} else if ($('#budget_report_columns').val() == 1){
			$('#budget_report_subprojects_setting').attr("disabled", true);
		}
	});
</script>