<?php
echo stylesheet_tag("og/reporting.css");
require_javascript("og/ReportingFunctions.js");
$genid = gen_id();
if (!isset($conditions)) $conditions = array();

$report_data = array_var($_SESSION, 'invoice_report_data');
$report_key = 'invoice_report_'.ProjectTasks::instance()->getObjectTypeId();
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('project_reports', 'invoice_report') ?>" method="post" enctype="multipart/form-data">
<input type="hidden" id="<?php echo $genid?>report[report_object_type_id]" name="report[report_object_type_id]" value="<?php echo ProjectTasks::instance()->getObjectTypeId()?>"/>
<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo $title ?>
	</div>
</div>
<div class="coInputSeparator"></div>
<div class="coInputMainBlock">
	
	<?php if (count(active_context_members(false)) > 0) : ?>
	<div style="margin-bottom: 15px; padding-bottom: 5px; border-bottom:1px dotted #aaa;">
		<h5><?php echo lang('showing information for')?>:</h5>
		<ul>
		<?php
			$context = active_context();
			foreach ($context as $selection) :
				if ($selection instanceof Member) : ?>
					<li><span class="coViewAction <?php echo $selection->getIconClass()?>"><?php echo $selection->getName()?></span></li>	
		<?php 	endif;
			endforeach;
		?>
		</ul>
	</div>
	<?php else: ?>
	<div style="padding:5px;"></div>
	<?php endif; 
	$listeners = array('on_selection_change' => 'og.hide_report_form_options()', 'on_remove_relation' => 'og.hide_report_form_options()');
	$projects_dim = Dimensions::findByCode('customer_project');
	render_single_member_selector($projects_dim, $genid, active_context_members(false), 
									array('is_multiple' => false,
									'root_lang' => lang('All'),
									'listeners' => $listeners,
									'is_required' => false,
									'hidden_field_name' => 'report[project_member_ids]'));
	?>

	<?php 
	if(true){
		$group_by_columns_select_array = array(array(1, lang('none')), array(2, lang('projects')), array(3, lang('clients')), array(4, lang('clients and projects')));
	?>
		<div class="dataBlock" id="group_invoices_by">
			<label><?php echo lang('group invoices by')?>:</label>
			<?php echo simple_select_box('report[group_report_by]', $group_by_columns_select_array, array_var($report_data, 'group_report_by'))?>
		</div>
	<?php } ?>

	<div class="dataBlock">
		<label><?php echo lang('include main project information')?>:</label>
		<?php echo checkbox_field('report[show_main_project_info]', array_var($report_data, 'show_main_project_info'))?>
	</div>

	<?php 
	$use_custom_budget_total = false;
	$project_object_type = ObjectTypes::findOne(array("conditions" => "`name`='project'"));
	if($project_object_type instanceof ObjectType){
		$cp_object_type_id = $project_object_type->getId();
		$custom_props = CustomProperties::getAllCustomPropertiesByObjectType($cp_object_type_id);
		foreach ($custom_props as $c_prop) {
			if($c_prop->getCode() == 'budget_total'){
				$use_custom_budget_total = true;
				$budget_custom_property = $c_prop;
				break;
			}
		}
	}
	
	if($use_custom_budget_total){
		$columns_budget_select_array = array(array(0, lang('sum of budgeted tasks + expenses')), array(1, $budget_custom_property->getName()));
	?>
		<div class="dataBlock">
			<label><?php echo lang('for budget, use')?>:</label>
			<?php echo simple_select_box('report[use_budget_total_custom_property]', $columns_budget_select_array, array_var($report_data, 'use_budget_total_custom_property'))?>
		</div>
	<?php } ?>


    <div class="dataBlock">
		<label><?php echo lang('group invoices by month')?>:</label>
		<?php echo checkbox_field('report[group_invoices_by_month]', array_var($report_data, 'group_invoices_by_month'))?>
	</div>

	<?php
		$enabled_dimensions = config_option('enabled_dimensions');
		$job_phase_dim = Dimensions::findByCode('job_phases');
		if ($job_phase_dim instanceof Dimension && in_array($job_phase_dim->getId(), $enabled_dimensions)){
			$columns_select_array = array(array(0,$job_phase_dim->getName()), array(1, lang('subprojects')));
		} else {
			$columns_select_array = array(array(1, lang('subprojects')));
		}

	?>
	<div class="dataBlock" id="group_columns_by">
		<label><?php echo lang('group columns by')?>:</label>
		<?php echo simple_select_box('report[group_columns_by]', $columns_select_array, array_var($report_data, 'group_columns_by'))?>
	</div>

	
<br/>
<?php echo submit_button(lang('generate report'),'s',array('onclick'=>'og.setMemoryFilttersReport(this,"'.$report_key.'")', 'style'=>'margin-top:0px;')) ?>
</div>
</div>

<script>
	og.loadFiltersReport("<?php echo $report_key; ?>");

	og.hide_report_form_options = function () {
		var selected_project = document.getElementById('<?php echo $genid; ?>report[project_member_ids]');
	
		if (selected_project.value.length == 2){
			$('#group_invoices_by').show(); //children().prop('disabled',false);
			$('#group_columns_by').hide(); //children().prop('disabled',true);
		} else {
			$('#group_invoices_by').hide(); //children().prop('disabled',true);
			$('#group_columns_by').show(); //children().prop('disabled',false);
		}
	}
	
	og.hide_report_form_options();


</script>

</form>
