<?php
echo stylesheet_tag("og/reporting.css");
require_javascript("og/ReportingFunctions.js");
$genid = gen_id();
if (!isset($conditions)) $conditions = array();

$report_data = array_var($_SESSION, 'project_earnings_report_data');
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('project_reports', 'project_earnings_report') ?>" method="post" enctype="multipart/form-data">
<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo $title ?>
	</div>
</div>
<div class="coInputSeparator"></div>
<div class="coInputMainBlock">
<?php
    $project_ot = ObjectTypes::findByName('project');
    // Get custom property 'project_manager'
    $cp_project_manager = CustomProperties::findOne(array('conditions' => 'object_type_id='.$project_ot->getId().' AND `code`="project_manager"'));
    $contact_select_array = array(array(0, ucfirst(lang('all'))));
    if($cp_project_manager instanceof CustomProperty){
         // Find project manager contact ids
        $pm_cp_values = CustomPropertyValues::findAll((array('conditions' => '`custom_property_id`='.$cp_project_manager->getId())));
        $pm_all_ids = array_map('get_cp_value', $pm_cp_values);
        $pm_contact_ids = array_unique($pm_all_ids);
        foreach($pm_contact_ids as $contact_id){
            $contact = Contacts::findById($contact_id);
            if($contact instanceof Contact){
                $contact_select_array[] = array($contact_id, $contact->getName());
            }
        }
    }
    $pm_label_name = $cp_project_manager instanceof CustomProperty ? $cp_project_manager->getName() : lang('project manager');
	?>
    <!-- Project Manager selector -->
	<div class="dataBlock">
		<label><?php echo $pm_label_name; ?>:</label>
		<?php echo simple_select_box('report[project_manager_id]', $contact_select_array, array_var($report_data, 'project_manager_id'))?>
	</div>

    <!-- Include projects with unset 'budget_total' custom property -->
    <?php
        $project_ot_id = ObjectTypes::findByName('project')->getId();
        $contract_amount_cp = CustomProperties::instance()->getCustomPropertyByCode($project_ot_id, 'budget_total');
        if($contract_amount_cp){
    ?>
    <div class="dataBlock">
		<label><?php echo lang('include projects with unset ') . '\'' . $contract_amount_cp->getName() . '\''; ?>:</label>
		<?php echo checkbox_field('report[include_unset_total_budget]', array_var($report_data, 'include_unset_total_budget'))?>
	</div>
    <?php } ?>

<?php echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;')) ?>
</div>

</form>
