<?php
echo stylesheet_tag("og/reporting.css");
require_javascript("og/ReportingFunctions.js");
$genid = gen_id();
if (!isset($conditions)) $conditions = array();

$report_data = array_var($_SESSION, 'project_forecast_report_data');
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('project_reports', 'project_forecast_report') ?>" method="post" enctype="multipart/form-data">
<input type="hidden" id="<?php echo $genid?>report[report_object_type_id]" name="report[report_object_type_id]" value="<?php echo ProjectTasks::instance()->getObjectTypeId()?>"/>

<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo $title; ?>
	</div>
</div>
<div class="coInputSeparator"></div>
<div class="coInputMainBlock">
	
	<?php if (count(active_context_members(false)) > 0) : ?>
	<div style="margin-bottom: 15px; padding-bottom: 5px; border-bottom:1px dotted #aaa;">
		<h5><?php echo lang('showing information for')?>:</h5>
		<ul>
		<?php
			$context = active_context();
			foreach ($context as $selection) :
				if ($selection instanceof Member) : ?>
					<li><span class="coViewAction <?php echo $selection->getIconClass()?>"><?php echo $selection->getName()?></span></li>	
		<?php 	endif;
			endforeach;
		?>
		</ul>
	</div>
	<?php else: ?>
	<div style="padding:5px;"></div>
	<?php endif; 
	
	$projects_dim = Dimensions::findByCode('customer_project');
	render_single_member_selector($projects_dim, $genid, active_context_members(false), array('is_multiple' => false, 'hidden_field_name' => 'report[project_member_ids]'));
	?>
	<div class="dataBlock" id="type_report">
		<label>Type report :</label>
		<label>
			<?php echo radio_field('report[type_report]', true, ['value'=>'cost']); ?> <?php echo "Cost"; /*lang('fixed cost')*/; ?>
		</label>
		<label>
			<?php echo radio_field('report[type_report]', false, ['value'=>'revenue']); ?> <?php echo "Revenue"; /*lang('fixed cost')*/; ?>
		</label>
	</div>
	<?php 
		$labor_group_columns_select_array = array(array('hours', lang('hours')), array('estimated_cost', lang('estimated cost')));
	?>
	<div class="dataBlock" id="group_labor_by">
		<label><?php echo lang('group labor by')?>:</label>
		<?php echo simple_select_box('report[group_labor_by]', $labor_group_columns_select_array, array_var($report_data, 'group_labor_by'))?>
	</div>

	<?php 
		$expenses_group_columns_select_array = array(array('units', lang('units')), array('estimated_cost', lang('budgeted cost')));
	?>
	<div class="dataBlock" id="group_expenses_by">
		<label><?php echo lang('group expenses by')?>:</label>
		<?php echo simple_select_box('report[group_expenses_by]', $expenses_group_columns_select_array, array_var($report_data, 'group_expenses_by'))?>
	</div>

	<?php
		if (array_var($report_data, 'start_value')) {
			
			$st = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'start_value'));
			$et = DateTimeValueLib::dateFromFormatAndString(user_config_option('date_format'), array_var($report_data, 'end_value'));
		} else {
			
			$st = DateTimeValueLib::now();
			$et = $st->add('m', 12);
		} 
	?>
	<div class="dataBlock">
		<label><?php echo lang("start date") ?>:</label>
		<?php echo pick_date_widget2('report[start_value]', $st, $genid);?>
	</div>
	<div class="dataBlock">
		<label><?php echo lang("end date") ?>:</label>
		<?php echo pick_date_widget2('report[end_value]', $et, $genid);?>
	</div>

	<?php 
		$project_ot_id = ObjectTypes::findByName('project')->getId();
		$proj_id_cp = CustomProperties::findOne(array('conditions' => '`object_type_id`='.$project_ot_id.' AND `code`="project_id"'));
		if($proj_id_cp instanceof CustomProperty){ 
			$project_sort_select_array = array(array('name', lang('project name')), array('project_id', $proj_id_cp->getName())); 
	?>
	<div class="dataBlock">
		<label><?php echo lang("order by") ?>:</label>
		<?php echo simple_select_box('report[sort_projects_by]', $project_sort_select_array, array_var($report_data, 'sort_projects_by'));?>
	</div>
	<?php } ?>
<br/>
<?php echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;')) ?>
</div>
</div>

</form>
