<?php
echo stylesheet_tag("og/reporting.css");
require_javascript("og/ReportingFunctions.js");
$genid = gen_id();
if (!isset($conditions)) $conditions = array();

$report_data = array_var($_SESSION, 'project_management_report_data');
$report_key = "project_".Timeslots::instance()->getObjectTypeId();
$project_management_report = Reports::findOne(array("conditions" => "`code` = 'project_management_report'"));
$report_title = $project_management_report->getObjectName();
$report_id = $project_management_report->getId();
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('project_reports', 'project_management_report') ?>" method="post" enctype="multipart/form-data">
<style>
	.coInputMainBlock label{min-width: 270px;}
</style>
<input type="hidden" id="<?php echo $genid?>report[report_object_type_id]" name="report[report_object_type_id]" value="<?php echo Timeslots::instance()->getObjectTypeId()?>"/>
<input type="hidden" id="<?php echo $genid?>report[report_id]" name="report[report_id]" value="<?php echo $report_id ?>"/>
<input type="hidden" id="<?php echo $genid?>report[report_title]" name="report[report_title]" value="<?php echo $report_title ?>"/>

<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo $title; ?>
	</div>
</div>
<div class="coInputSeparator"></div>
<div class="coInputMainBlock">
	
	<?php if (count(active_context_members(false)) > 0) : ?>
	<div style="margin-bottom: 15px; padding-bottom: 5px; border-bottom:1px dotted #aaa;">
		<h5><?php echo lang('showing information for')?>:</h5>
		<ul>
		<?php
			$context = active_context();
			foreach ($context as $selection) :
				if ($selection instanceof Member) : ?>
					<li><span class="coViewAction <?php echo $selection->getIconClass()?>"><?php echo $selection->getName()?></span></li>	
		<?php 	endif;
			endforeach;
		?>
		</ul>
	</div>
	<?php else: ?>
	<div style="padding:5px;"></div>
	<?php endif; 
	
	$projects_dim = Dimensions::findByCode('customer_project');
	render_single_member_selector($projects_dim, $genid, active_context_members(false), array('is_multiple' => false, 'hidden_field_name' => 'report[project_member_ids]'));
	?>

	<?php 
	$has_budget_total_cp = false;
	$project_object_type = ObjectTypes::findOne(array("conditions" => "`name`='project'"));
	if($project_object_type instanceof ObjectType){
		$cp_object_type_id = $project_object_type->getId();
		$budget_custom_property = CustomProperties::findOne(array('conditions' => '`object_type_id`='.$cp_object_type_id. ' AND `code`="budget_total"'));
		if($budget_custom_property instanceof CustomProperty){
			$has_budget_total_cp = true;
		}
	}
	
	if($has_budget_total_cp){
		$columns_budget_select_array = array(array('none', lang('none')), array('tasks_expenses', lang('sum of budgeted tasks + expenses')), array('budget_total_cp', $budget_custom_property->getName()));
	} else {
		$columns_budget_select_array = array(array('none', lang('none')), array('tasks_expenses', lang('sum of budgeted tasks + expenses')));
	}
	?>
	<div class="dataBlock">
		<label><?php echo lang('for budget, use')?>:</label>
		<?php echo simple_select_box('report[for_budget_use]', $columns_budget_select_array, array_var($report_data, 'for_budget_use'))?>
	</div>


	<div class="dataBlock">
		<label><?php echo lang('include main project information')?></label>
		<?php echo checkbox_field('report[show_main_project_info]', array_var($report_data, 'show_main_project_info'))?>
	</div>
	
	<div class="dataBlock">
		<label><?php echo lang('include subprojects information')?></label>
		<?php echo checkbox_field('report[include_subproject_info]', array_var($report_data, 'include_subproject_info'))?>
	</div>

	<?php 
		$miles_cp = CustomProperties::getCustomPropertyByCode(Timeslots::instance()->getObjectTypeId(), 'miles');
		if ($miles_cp instanceof CustomProperty) { ?>
		<div class="dataBlock">
			<label><?php echo lang('include miles')?></label>
			<?php echo checkbox_field('report[include_miles]', array_var($report_data, 'include_miles'))?>
		</div>
	<?php } ?>

	<div class="dataBlock" id='include_invoicing_details'>
		<label><?php echo lang('include invoicing details')?></label>
		<?php echo checkbox_field('report[include_invoicing_details]', array_var($report_data, 'include_invoicing_details'))?>
	</div>
	
	<div class="dataBlock">
		<label><?php echo lang('include billing rate name')?></label>
		<?php echo checkbox_field('report[include_billing_rate_name]', array_var($report_data, 'include_billing_rate_name'))?>
	</div>

	<div class="dataBlock">
		<label><?php echo lang('include time/expenses description')?></label>
		<?php echo checkbox_field('report[include_time_description]', array_var($report_data, 'include_time_description'))?>
	</div>
	
	<div class="dataBlock">
		<label><?php echo lang('include estimated time')?></label>
		<?php echo checkbox_field('report[include_estimated_time]', array_var($report_data, 'include_estimated_time'))?>
	</div>

	<div class="dataBlock">
		<label><?php echo lang('include estimated billing')?></label>
		<?php echo checkbox_field('report[include_estimated_billing]', array_var($report_data, 'include_estimated_billing'))?>
	</div>

	<div class="dataBlock">
		<label><?php echo lang('include pending time')?></label>
		<?php echo checkbox_field('report[include_pending_time]', array_var($report_data, 'include_pending_time'))?>
	</div>

	<div class="dataBlock">
		<label><?php echo lang('include pending billing')?></label>
		<?php echo checkbox_field('report[include_pending_billing]', array_var($report_data, 'include_pending_billing'))?>
	</div>

	<div class="dataBlock">
		<label><?php echo lang('insert page break for each project')?></label>
		<?php echo checkbox_field('report[project_page_break]', array_var($report_data, 'project_page_break'))?>
	</div>
	
<br/>
<?php echo submit_button(lang('generate report'),'s',array('onclick'=>'og.setMemoryFilttersReport(this,"'.$report_key.'")','style'=>'margin-top:0px;')) ?>
</div>
</div>

</form>
<script>
	og.loadFiltersReport("<?php echo $report_key; ?>");
</script>