<?php
// columns and report data
$columns = array_var($data, 'columns');
$utilization_data = array_var($data, 'utilization_data');

$from_date_str = format_date($data['from_date']);
$to_date_str = format_date($data['to_date']);

// Render report title
echo '<div class="project-report-title">'.$title.'</div>';

// Render date of the report
$today_dtv = DateTimeValueLib::now();
$today_date = format_date($today_dtv);
echo '<div class="project-report-info" style="float: right;">'.lang('report date').': '.$today_date.'</div>';

echo '<div class="project-report-info">'.lang('showing data from x to y', $from_date_str, $to_date_str).'</div>';

?>
<div class="clear"></div>


<table class="utilization-table">
	<tr>
<?php

foreach ($columns as $col_code => $col_name) { 
	$cell_class = '';
	if ($col_code == 'contact_name') {
		$cell_class .= ' name';
	} else {
		$cell_class .= ' center';
	}
?>
		<th class="<?php echo $cell_class ?>"><?php echo $col_name ?></th>
<?php
}
?>
	</tr>
<?php

foreach ($utilization_data as $contact_id => $contact_data) { ?>
	<tr>
<?php

	foreach ($columns as $col_code => $col_name) { 
			$cell_value = $contact_data[$col_code];
			$cell_class = '';

			if ($col_code == 'billable_utilization' || $col_code == 'utilization_goal') {
				$cell_value .= ' %';
			}
			if ($col_code == 'billable_utilization') {
				if ($contact_data[$col_code] < $contact_data['utilization_goal']) {
					$cell_class .= ' red-text';
				}
			}
			if ($col_code == 'variation') {
				$cell_value .= ' %';
				if ($contact_data[$col_code] < 0) {
					$cell_class .= ' red-text';
				}
			}
			if ($col_code == 'contact_name') {
				$cell_class .= ' name';
			} else {
				$cell_class .= ' report-number';
			}
		?>
		<td class="<?php echo $cell_class ?>"><?php 
			echo $cell_value;
		?></td>
<?php
	}
?>
	</tr>
<?php

}


?>
</table>