
og.project_reports = {
		init: function() {
			
			if (!og.reports.additional_print_window_css) {
				og.reports.additional_print_window_css = [];
			}
			og.reports.additional_print_window_css.push('/plugins/project_reports/public/assets/css/project_reports.css');

			$(document).on('change', "#type_report input[type=radio]", function(){
				var value = $(this).val();

				if(value == 'cost'){
					$('[name="report[group_labor_by]"] option:eq(1)', document).text(lang('estimated cost'));
					$('[name="report[group_expenses_by]"] option:eq(1)', document).text(lang('budgeted cost'));
				}else{
					$('[name="report[group_labor_by]"] option:eq(1)', document).text(lang("estimated revenue"));
					$('[name="report[group_expenses_by]"] option:eq(1)', document).text(lang("budgeted price"));
				}
			});
		},

		export_fixed_report_excel(genid) {
			var form_id = 'form' + genid;
			var form = document.getElementById(form_id);
			
			form.action = form.action.replace(/_print/ig, '_excel');
			
			og.advanced_reports.submit_csv_form(genid);

			form.action = form.action.replace(/_excel/ig, '_print');
			
			return false;
		},

		export_fixed_report_pdf(genid, controller, action) {
			var params = og.get_report_parameters_of_form(genid);
			params['exportPDF'] = true;
			params['pdfPageLayout'] = $("#"+genid+"pdfPageLayout").val();
			params['pdfPageSize'] = $("#"+genid+"pdfPageSize").val();

			var report_id = $("#report_id_"+genid).val();
			og.openLink(og.getUrl(controller, action), {
				post: params,
				callback: function(success, data) {
					var $form = $("<form></form>");
					$form.attr("action", og.getUrl('reporting', 'download_file'));
					$form.attr("method", "post");
					$form.append('<input type="text" name="file_name" value="'+data.filename+'" />');
					$form.append('<input type="text" name="file_type" value="application/pdf" />');
					
					$form.appendTo('body').submit().remove();

					$("#pdf_options_close_link").click();
				}
			});
			return false;
		},
		
		export_project_management_report_excel: function(genid) {
			return og.project_reports.export_fixed_report_excel(genid);
		},
		
		export_project_management_report_pdf: function(genid) {
			return og.project_reports.export_fixed_report_pdf(genid, 'project_reports', 'project_management_report_print');
		},

		export_budget_report_excel: function(genid) {
			return og.project_reports.export_fixed_report_excel(genid);
		},

		export_budget_report_pdf: function(genid) {
			return og.project_reports.export_fixed_report_pdf(genid, 'project_reports', 'budget_report_print');
		},

		export_invoice_report_excel: function(genid) {
			return og.project_reports.export_fixed_report_excel(genid);
		},

		export_invoice_report_pdf: function(genid) {
			return og.project_reports.export_fixed_report_pdf(genid, 'project_reports', 'invoice_report_print');
		},

		export_aging_invoices_report_pdf: function(genid) {
			return og.project_reports.export_fixed_report_pdf(genid, 'project_reports', 'aging_invoices_report_print');
		},

		export_aging_invoices_report_excel: function(genid) {
			return og.project_reports.export_fixed_report_excel(genid);
		},

		export_utilization_report_pdf: function(genid) {
			return og.project_reports.export_fixed_report_pdf(genid, 'project_reports', 'utilization_report_print');
		},

		export_utilization_report_excel: function(genid) {
			return og.project_reports.export_fixed_report_excel(genid);
		},

		export_ar_ledger_report_pdf: function(genid) {
			return og.project_reports.export_fixed_report_pdf(genid, 'project_reports', 'ar_ledger_report_print');
		},

		export_ar_ledger_report_excel: function(genid) {
			return og.project_reports.export_fixed_report_excel(genid);
		},

		export_project_detail_jdt_report_pdf: function(genid) {
			return og.project_reports.export_fixed_report_pdf(genid, 'project_reports', 'project_detail_jdt_report_print');
		},

		export_project_detail_jdt_report_excel: function(genid) {
			return og.project_reports.export_fixed_report_excel(genid);
		},

		export_project_earnings_report_pdf: function(genid) {
			return og.project_reports.export_fixed_report_pdf(genid, 'project_reports', 'project_earnings_report_print');
		},

		export_project_earnings_report_excel: function(genid) {
			return og.project_reports.export_fixed_report_excel(genid);
		},

		export_project_forecast_report_pdf: function(genid) {
			return og.project_reports.export_fixed_report_pdf(genid, 'project_reports', 'project_forecast_report_print');
		},

		export_project_forecast_report_excel: function(genid) {
			return og.project_reports.export_fixed_report_excel(genid);
		}
}
