<?php
$permission_group_roles = PermissionGroups::findAll(array('conditions' => "`type`='roles' AND `parent_id`>0"));

$group_id = $property_group->isNew() ? 0 :$property_group->getId();

$permissions = PropertyGroupPermissions::getByPropertyGroupId($group_id);
$selected_pgs_view = array();
$selected_pgs_edit = array();
$found_pgs = array();
foreach ($permissions as $p) {
	if ($p->getCanView()) $selected_pgs_view[] = $p->getPermissionGroupId();
	if ($p->getCanEdit()) $selected_pgs_edit[] = $p->getPermissionGroupId();
	$found_pgs[] = $p->getPermissionGroupId();
}
// if permission not defined => give permissions to the pg
foreach ($permission_group_roles as $pg) {/* @var $pg PermissionGroup */
	if (!in_array($pg->getId(), $found_pgs)) {
		$selected_pgs_view[] = $pg->getId();
		$selected_pgs_edit[] = $pg->getId();
	}
}

?>


<div class="dataBlock">
	<?php echo label_tag(lang('permissions')) ?>

	<table class="property-group-permissions">
		<tr><th><?php echo lang('user type')?></th><th><?php echo lang('can view')?></th><th><?php echo lang('can edit')?></th></tr>
	<?php 
	foreach ($permission_group_roles as $pg) {/* @var $pg PermissionGroup */
	?>
		<tr>
			<td><?php echo $pg->getName() ?></td>
			<td><?php 
				$checked = (array_search($pg->getId(), $selected_pgs_view) !== false);
				echo checkbox_field('property_group[permissions][view][' . $pg->getId () . ']', $checked, array('id' => $genid.'_can_view_property_group_'.$pg->getId()));
			?></td>
			<td><?php 
				$checked = (array_search($pg->getId(), $selected_pgs_edit) !== false);
				echo checkbox_field('property_group[permissions][edit][' . $pg->getId () . ']', $checked, array('id' => $genid.'_can_edit_property_group_'.$pg->getId()));
			?></td>
		</tr>
	<?php
	}
	?>
	
	</table>
</div>


























