<?php
Hook::register('property_groups_permissions');

function property_groups_permissions_before_property_group_delete($property_group, &$ignored) {
	if ($property_group instanceof PropertyGroup) {
		PropertyGroupPermissions::deleteByGroup($property_group->getId());
	}
}


function property_groups_permissions_additional_property_group_sections($params, &$ignored) {
	if (config_option('use_property_groups_permissions')) {
		$genid = array_var($params, 'genid');
		$property_group = array_var($params, 'property_group');
		
		tpl_assign('genid', $genid);
		tpl_assign('property_group', $property_group);
		tpl_display(get_template_path('property_group_permissions', 'property_group_permissions', 'property_groups_permissions'));
	}
}

function property_groups_permissions_after_property_group_save($params, &$ignored) {
	if (config_option('use_property_groups_permissions')) {
		$data = array_var($params, 'data');
		$property_group = array_var($params, 'property_group');
		
		$group_id = $property_group->getId();
		$view_permissions = array_var(array_var($data, 'permissions'), 'view');
		$edit_permissions = array_var(array_var($data, 'permissions'), 'edit');
		
		$permissions_controller = new PropertyGroupPermissionsController();
		$permissions_controller->save_property_group_permissions($group_id, $view_permissions, $edit_permissions);
		
	}
}

function property_groups_permissions_check_property_group_permissions($params, &$permission) {
	if (config_option('use_property_groups_permissions')) {
		$user = array_var($params, 'user');
		$property_group = array_var($params, 'property_group');
		
		$group_id = $property_group instanceof PropertyGroup ? $property_group->getId() : $property_group['id'];
		
		$permission = PropertyGroupPermissions::getPermissionForUserAndGroupId($user, $group_id);
		
		return $permission;
	}
	return null;
}

function property_groups_permissions_check_property_group_property_permissions($params, &$permission) {
	if (config_option('use_property_groups_permissions')) {
		$user = array_var($params, 'user');
		$property_group = array_var($params, 'property_group');
		$property_id = array_var($params, 'property_id');
		
		$group_id = $property_group instanceof PropertyGroup ? $property_group->getId() : $property_group['id'];
		
		$permission = PropertyGroupPropertiesPermissions::getPermissionForUserGroupIdAndProperty($user, $group_id, $property_id);
		
		return $permission;
	}
	return null;
}


