<?php

if (isset($purchase_order) && $purchase_order instanceof PurchaseOrder) {/* @var $purchase_order PurchaseOrder */
	
	if (!$purchase_order->isTrashed()){
		if($purchase_order->canEdit(logged_user())) {
			add_page_action(lang('edit'), "javascript:og.render_modal_form('', {c:'purchase_order', a:'edit', params: {id:".$purchase_order->getId()."}});", 'ico-edit', null, null, true);
		}
	}
	if ($purchase_order->canDelete(logged_user())) {
		if ($purchase_order->isTrashed()) {
			add_page_action(lang('restore from trash'), "javascript:if(confirm(lang('confirm restore objects'))) og.openLink('" . $purchase_order->getUntrashUrl() ."');", 'ico-restore', null, null, true);
			add_page_action(lang('delete permanently'), "javascript:if(confirm(lang('confirm delete permanently'))) og.openLink('" . $purchase_order->getDeletePermanentlyUrl() ."');", 'ico-delete', null, null, true);
		} else {
			add_page_action(lang('move to trash'), "javascript:if(confirm(lang('confirm move to trash'))) og.openLink('" . $purchase_order->getTrashUrl() ."');", 'ico-trash', null, null, true);
		}
	}
?>

<div style="padding:7px">
<div class="purchase-order">
<?php
	$title = lang('purchase order').': '.$purchase_order->getDescription();
	$content = '<table class="purchase-order-data">';
	
	$content .= '<tr><td><span class="bold">'.lang('number').': </span></td><td>'. str_pad($purchase_order->getNumber(), 7, '0', STR_PAD_LEFT) .'</td></tr>';
	$content .= '<tr><td><span class="bold">'.lang('date').': </span></td><td>'. format_date($purchase_order->getDate(), 0, logged_user()->getUserTimezoneHoursOffset()*-1) .'</td></tr>';
	
	$ordered_by_name = $purchase_order->getOrderedByName();
	if ($ordered_by_name != "") {
		$content .= '<tr><td><span class="bold">'.lang('ordered by').': </span></td><td>'.$ordered_by_name.'</td></tr>';
	}
	
	$content .= '<tr><td><span class="bold">'.lang('net amount').': </span></td><td>'.$purchase_order->getNetAmount().'</td></tr>';
	//$content .= '<tr><td><span class="bold">'.lang('vat amount').': </span></td><td>'.$purchase_order->getVatAmount().'</td></tr>';
	$content .= '<tr><td><span class="bold">'.lang('gross amount').': </span></td><td>'.$purchase_order->getGrossAmount().'</td></tr>';
	$content .= '<tr><td><span class="bold">'.lang('estimated cost').': </span></td><td>'.$purchase_order->getEstimatedCost().'</td></tr>';
	$content .= '<tr><td><span class="bold">'.lang('invoiced').': </span></td><td>'.($purchase_order->getInvoiced() ? lang('yes') : lang('no')).'</td></tr>';
	
	$content .= '</table>';
	
	tpl_assign("title", $title);
	tpl_assign("content", $content);
	tpl_assign("object", $purchase_order);
	tpl_assign('iconclass', $purchase_order->isTrashed()? 'ico-large-purchase-order-trashed' : ($purchase_order->isArchived() ? 'ico-large-purchser-order-archived' : 'ico-large-purchser-order'));
	
	$this->includeTemplate(get_template_path('view', 'co'));
?>
</div>
</div>
<?php } //if isset ?>
