<?php 

function purchase_orders_update_1_2() {
	DB::executeAll("INSERT INTO ".TABLE_PREFIX."max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
		 SELECT rtp.role_id, (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='purchase_order'), can_delete, can_write
		 FROM ".TABLE_PREFIX."max_role_object_type_permissions rtp WHERE rtp.object_type_id=(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='task')
		ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."max_role_object_type_permissions.role_id=".TABLE_PREFIX."max_role_object_type_permissions.role_id;");
}

function purchase_orders_update_2_3() {
	DB::execute("
		INSERT INTO ".TABLE_PREFIX."dimension_object_type_options (`dimension_id`, `object_type_id`, `name`, `value`) VALUES
		 ((SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='suppliers'), (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='supplier'),'select_after_creation','1')
		ON DUPLICATE KEY UPDATE `value`=`value`;
	");
}

function purchase_orders_update_3_4() {
	if (!check_column_exists(TABLE_PREFIX.'suppliers', 'contact_object_type_id'))
	DB::execute("
		ALTER TABLE `".TABLE_PREFIX."suppliers` ADD COLUMN `contact_object_type_id` INTEGER UNSIGNED NOT NULL DEFAULT 0;
	");
}

function purchase_orders_update_4_5() {
	// allow to add all content objects in suppliers
	DB::execute("
		INSERT INTO `".TABLE_PREFIX."dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
		 SELECT
		 	(SELECT `id` FROM `".TABLE_PREFIX."dimensions` WHERE `code`='suppliers'),
		 	(SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='supplier'),
		 	`id`, 0, 1
		 FROM `".TABLE_PREFIX."object_types`
		 WHERE  `type` IN ('content_object', 'comment', 'located')
		ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
	");
	
	// replicate purchase order permission in suppliers for the other object types
	$ot_ids = ObjectTypes::findAll(array('id'=>true, 'conditions' => "type IN ('content_object', 'located') AND name NOT IN ('purchase_order', 'file revision', 'template', 'template_task', 'template_milestone')"));
	foreach ($ot_ids as $ot_id) {
		$sql = "
			INSERT INTO ".TABLE_PREFIX."contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
			 SELECT cmp.permission_group_id, cmp.member_id, $ot_id, cmp.can_delete, cmp.can_write
			 FROM ".TABLE_PREFIX."contact_member_permissions cmp
			 WHERE cmp.object_type_id = (SELECT `id` FROM `".TABLE_PREFIX."object_types` WHERE `name`='purchase_order') 
				AND cmp.member_id IN (SELECT m.id FROM ".TABLE_PREFIX."members m WHERE m.dimension_id=(SELECT d.id FROM ".TABLE_PREFIX."dimensions d WHERE d.code='suppliers'))
			ON DUPLICATE KEY UPDATE ".TABLE_PREFIX."contact_member_permissions.member_id=".TABLE_PREFIX."contact_member_permissions.member_id;
		";
		DB::execute($sql);
	}
}

function purchase_orders_update_5_6() {
	// set suppliers plugin as installed, active and in the first version before updating it.
	$p = Plugins::instance()->findOne(array("conditions" => "name='suppliers'"));
	if ($p instanceof Plugin) {
		$p->setIsInstalled(true);
		$p->setIsActivated(true);
		$p->setVersion(1);
		$p->save();
		
		$p->update();
	}
	
	@unlink(ROOT . '/cache/autoloader.php');
}
