<?php

require_once(dirname(__FILE__) . '/plugins/quickbooks/library/qbo_sdk/qbo_sdk.php');
use QuickBooksOnline\API\DataService\DataService;

//session_start();

function getQboConfigFromDatabase() {
	
	include_once dirname(__FILE__) . '/config/config.php';
	$config = array();
	
	$link =  @mysqli_connect(DB_HOST, DB_USER, DB_PASS, DB_NAME);
	
	$res = mysqli_query($link, "SELECT * FROM ".TABLE_PREFIX."config_options WHERE name LIKE 'qbo_%'");
	if ($res) {
		while ($row = mysqli_fetch_array($res)) {
			if ($row['name'] == 'qbo_client_id') $config['client_id'] = $row['value'];
			if ($row['name'] == 'qbo_client_secret') $config['client_secret'] = $row['value'];
			if ($row['name'] == 'qbo_oauth_redirect_uri') $config['oauth_redirect_uri'] = $row['value'];
			if ($row['name'] == 'qbo_oauth_scope') $config['oauth_scope'] = $row['value'];
			if ($row['name'] == 'qbo_authorization_request_url') $config['authorizationRequestUrl'] = $row['value'];
			if ($row['name'] == 'qbo_token_endpoint_url') $config['tokenEndPointUrl'] = $row['value'];
			if ($row['name'] == 'qbo_base_url') $config['baseUrl'] = $row['value'];
		}
	}
	
	return $config;
}


function saveQboAccessTokenToDatabase($accessToken) {
	$log_file = dirname(__FILE__)."/cache/qbo.log";
	include_once dirname(__FILE__) . '/config/config.php';
	
	$link =  @mysqli_connect(DB_HOST, DB_USER, DB_PASS, DB_NAME);
	if (mysqli_connect_errno()) {
		file_put_contents($log_file, "Failed to connect to MySQL".mysqli_connect_error()."\n", FILE_APPEND);
	}
	
	$serialized_token = base64_encode(serialize($accessToken));
	
	$res = mysqli_query($link, "UPDATE ".TABLE_PREFIX."config_options SET `value`='$serialized_token' WHERE `name` = 'qbo_access_token'");
	if (!$res) {
		file_put_contents($log_file, "Error updating access token in DB:\n". mysqli_error($link)."\n", FILE_APPEND);
	}
}

function processQuickbooksOnlineResponse()
{
	$log_file = dirname(__FILE__)."/cache/qbo.log";
	try {
		
		$parseUrl = null;
		parse_str($_SERVER['QUERY_STRING'], $parseUrl);
		
		$config = getQboConfigFromDatabase();
		
		$dataService = DataService::Configure(array(
				'auth_mode' => 'oauth2',
				'ClientID' => $config['client_id'],
				'ClientSecret' =>  $config['client_secret'],
				'RedirectURI' => $config['oauth_redirect_uri'],
				'scope' => $config['oauth_scope'],
				'baseUrl' => $config['baseUrl'], // production,development
		));
		
		$OAuth2LoginHelper = $dataService->getOAuth2LoginHelper();
		
		/*
		 * Update the OAuth2Token
		 */
		$accessToken = $OAuth2LoginHelper->exchangeAuthorizationCodeForToken($parseUrl['code'], $parseUrl['realmId']);
		$dataService->updateOAuth2Token($accessToken);
		
		/*
		 * Setting the accessToken for session variable
		 */
		$_SESSION['QBOsessionAccessToken'] = $accessToken;
		
		/*
		 * Persist the accessToken in database, to simplify incoming data synchronization
		 */
		saveQboAccessTokenToDatabase($accessToken);
		
	} catch (Error $e) {
		file_put_contents($log_file, "Error processing QBO response:\n". $e->getMessage()."\n", FILE_APPEND);
	} catch (Exception $e) {
		file_put_contents($log_file, "Error processing QBO response:\n". $e->getMessage()."\n", FILE_APPEND);
	}
}


processQuickbooksOnlineResponse();

?>