<?php 


function render_qbo_invoice_matching_properties($id, $order, $value) {
	
	$ot_id = IncomeInvoices::instance()->getObjectTypeId();
	$invoice_cps = CustomProperties::getAllCustomPropertiesByObjectType($ot_id);
	$project_ot_id = Projects::instance()->getObjectTypeId();
	$project_cps = CustomProperties::getAllCustomPropertiesByObjectType($project_ot_id);
	
	$option_groups = array(option_group_tag('', array(option_tag("", ""))));
	
	$value_id = end(explode("_", $value));
	//$options = array(option_tag("", ""));
	$options = array();
	foreach ($invoice_cps as $cp) {
		$attr = $value_id == $cp->getId() ? array("selected" => "selected") : null;
		$options[] = option_tag($cp->getName(), "cp_" . $cp->getId(), $attr);
	}
	$option_groups[] = option_group_tag(lang('invoice'), $options);
	
	$options = array();
	foreach ($project_cps as $cp) {
		$attr = $value_id == $cp->getId() ? array("selected" => "selected") : null;
		$options[] = option_tag($cp->getName(), "project_cp_" . $cp->getId(), $attr);
	}
	$option_groups[] = option_group_tag(lang('project'), $options);
	
	return select_box("custom_field_match[$id][$order]", $option_groups);
	
}


function render_qbo_item_selector($user_id, $user_item_id, $qbo_items) {
	
	$options = array(option_tag("", ""));
	
	foreach ($qbo_items as $qbo_item) {
		$attr = $user_item_id == $qbo_item->Id ? array("selected" => "selected") : null;
		$options[] = option_tag($qbo_item->Name, $qbo_item->Id, $attr);
	}
	
	return select_box("items_match[$user_id]", $options);
	
}


function render_qbo_tax_selector($feng_tax_id, $qbo_tax_id, $qbo_taxes) {
	
	$options = array(option_tag("", ""));
	
	foreach ($qbo_taxes as $qbo_tax) {
		$attr = $qbo_tax_id == $qbo_tax->Id ? array("selected" => "selected") : null;
		$options[] = option_tag($qbo_tax->Name, $qbo_tax->Id, $attr);
	}
	
	return select_box("taxes_match[$feng_tax_id]", $options);
	
}


function draw_category_item_match_table_row(Member $category, $qbo_income_cat_item_matches, $qbo_expense_cat_item_matches, $qbo_income_items, $qbo_expense_items, $labor_categories_by_parent, $income_accounts_by_item_id=array(), $expense_accounts_by_item_id=array()) {

	$item_id = array_var($qbo_income_cat_item_matches, $category->getId());
	$padding_left = 10 * $category->getDepth();
	?>
	<tr><td style="padding-left: <?php echo $padding_left ?>px; width:300px;"><?php echo $category->getName() ?></td>
		<td><?php 
			echo render_qbo_category_item_selector($category->getId(), $item_id, $qbo_income_items, 'income_item'); 
		?></td>
		<td style="min-width:150px;"><span id="item_account_name_<?php echo $category->getId() ?>_income_item"><?php 
			// put the income account of the selected item
			$account = array_var($income_accounts_by_item_id, $item_id);
			if ($account) {
				echo ($account->AcctNum ? $account->AcctNum." - " : "") . $account->Name;
			}
		?></span></td>

		<td><?php 
			$exp_item_id = array_var($qbo_expense_cat_item_matches, $category->getId());
			echo render_qbo_category_item_selector($category->getId(), $exp_item_id, $qbo_expense_items, 'expense_item'); 
		?></td>
		<td style="min-width:150px;"><span id="item_account_name_<?php echo $category->getId() ?>_expense_item"><?php 
			// put the income account of the selected item
			$account = array_var($expense_accounts_by_item_id, $exp_item_id);
			if ($account) {
				echo ($account->AcctNum ? $account->AcctNum." - " : "") . $account->Name;
			}
		?></span></td>
	</tr>
	<?php 

	if (isset($labor_categories_by_parent[$category->getId()])) {
		foreach ($labor_categories_by_parent[$category->getId()] as $sub_cat) {
			draw_category_item_match_table_row($sub_cat, $qbo_income_cat_item_matches, $qbo_expense_cat_item_matches, $qbo_income_items, $qbo_expense_items, $labor_categories_by_parent, $income_accounts_by_item_id, $expense_accounts_by_item_id);
		}
	}

}

function render_qbo_category_item_selector($category_id, $item_id, $qbo_items, $item_type) {
	
	$html = '<span id="qbo_account_selector_container'.$category_id."_".$item_type.'" class=""></span>';
	$html .= '<input id="qbo_account_selector_input'.$category_id."_".$item_type.'" name="category_match['.$category_id.']['.$item_type.']" type="hidden" value="'.$item_id.'"/>';
	$html .= "
	<script>
	var accounts_store = [['0', lang('none')]];
	";
	
	$i=1;
	foreach ($qbo_items as $qbo_item) {
		
		$exploded_name = explode(':', $qbo_item->FullyQualifiedName);
		$padding = 10 * (count($exploded_name) - 1);
		
		$item_name = '<span style="padding-left:'.$padding.'px">' . escape_character($qbo_item->Name) . '</span>';

		$html .= "accounts_store[$i] = ['".$qbo_item->Id."', '". $item_name . " (".$qbo_item->Type.")" ."'];";
		$i++;
	}

	$html .= "
	new Ext.form.ComboBox({
		name: 'qbo_account_selector[$category_id][$item_type]',
		renderTo: 'qbo_account_selector_container".$category_id."_".$item_type."',
		id: 'qbo_account_selector".$category_id."_".$item_type."',
		store: accounts_store,
		hidden: false,
		width: 300,
		listWidth: 300,
		displayField: 'text',
        mode: 'local',
        triggerAction: 'all',
        selectOnFocus:true,
        value: '$item_id',
		emptyText: '',
	    valueNotFoundText: '',
		//tabIndex:1000,
		listeners: {
			'select': function(combo, record){
				var hf = document.getElementById('qbo_account_selector_input".$category_id."_".$item_type."');
				if (hf) hf.value = combo.getValue();

				var str_input = document.getElementById('qbo_account_selector".$category_id."_".$item_type."');
				if (str_input) {
					var str = str_input.value;
					str_input.value = str.replace( /(<([^>]+)>)/ig, '');
				}
				var acc_name = '';
				var item_id = combo.getValue();
				if (item_id) {
					if ('$item_type' == 'income_item') {
						if (og.quickbooks.income_accounts_by_item_id[item_id]) {
							acc_name = og.quickbooks.income_accounts_by_item_id[item_id];
						}
					}
					if ('$item_type' == 'expense_item') {
						if (og.quickbooks.expense_accounts_by_item_id[item_id]) {
							acc_name = og.quickbooks.expense_accounts_by_item_id[item_id];
						}
					}
				}
				$('#item_account_name_".$category_id."_".$item_type."').html(acc_name);
			},
			'render': function(combo){
				setTimeout(function() {
					var str_input = document.getElementById('qbo_account_selector".$category_id."_".$item_type."');
					if (str_input) {
						var str = str_input.value;
						str_input.value = str.replace( /(<([^>]+)>)/ig, '');
					}
				}, 10);
			}
		}
	});
	
	</script>
	";

	return $html;
}


function render_qbo_account_selector($category_id, $account_id, $qbo_accounts) {

	$html = '<span id="qbo_account_selector_container'.$category_id.'" class=""></span>';
	$html .= '<input id="qbo_account_selector_input'.$category_id.'" name="category_match['.$category_id.']" type="hidden" value="'.$account_id.'"/>';
	$html .= "
	<script>
	var accounts_store = [['0', lang('none')]];
	";
	
	$i=1;
	foreach ($qbo_accounts as $qbo_account) {
		
		$exploded_name = explode(':', $qbo_account->FullyQualifiedName);
		$padding = 10 * (count($exploded_name) - 1);
		//$account_name = implode(' / ', $exploded_name);
		$account_name = '<span style="padding-left:'.$padding.'px">' . escape_character($qbo_account->Name) . '</span>';

		$html .= "accounts_store[$i] = ['".$qbo_account->Id."', '". $account_name . " (".$qbo_account->AccountType.")" ."'];";
		$i++;
	}

	$html .= "
	new Ext.form.ComboBox({
		name: 'qbo_account_selector[$category_id]',
		renderTo: 'qbo_account_selector_container".$category_id."',
		id: 'qbo_account_selector".$category_id."',
		store: accounts_store,
		hidden: false,
		width: 400,
		listWidth: 400,
		displayField: 'text',
        mode: 'local',
        triggerAction: 'all',
        selectOnFocus:true,
        value: '$account_id',
		emptyText: '',
	    valueNotFoundText: '',
		//tabIndex:1000,
		listeners: {
			'select': function(combo, record){
				var hf = document.getElementById('qbo_account_selector_input".$category_id."');
				if (hf) hf.value = combo.getValue();

				var str_input = document.getElementById('qbo_account_selector".$category_id."');
				if (str_input) {
					var str = str_input.value;
					str_input.value = str.replace( /(<([^>]+)>)/ig, '');
				}
			},
			'render': function(combo){
				setTimeout(function() {
					var str_input = document.getElementById('qbo_account_selector".$category_id."');
					if (str_input) {
						var str = str_input.value;
						str_input.value = str.replace( /(<([^>]+)>)/ig, '');
					}
				}, 10);
			}
		}
	});
	
	</script>
	";

	return $html;
}
