<?php
	chdir($argv[1]);
	define("CONSOLE_MODE", true);
	define('PUBLIC_FOLDER', 'public');
	include "init.php";
	
	session_commit(); // we don't need sessions
	@set_time_limit(0); // don't limit execution of cron, if possible
	ini_set('memory_limit', '1024M');
	
	Env::useHelper('permissions');
	
	$user_id = array_var($argv, 2);
	$token = array_var($argv, 3);
	
	// log user in
	$user = Contacts::findById($user_id);
	if(!($user instanceof Contact) || !$user->isValidToken($token)) {
		die();
	}
	CompanyWebsite::instance()->setLoggedUser($user, false, false, false);
	
	$ids = array();
	
	// get the invoice ids
	$object_id = array_var($argv, 4);
	if (is_numeric($object_id)) {
		$ids[] = $object_id;
	} else {
		$ids = explode(',', $object_id);
	}

	$qbo_controller = new QuickbooksController();
	$data_service = get_qbo_data_service();
	
	foreach ($ids as $id) {
		$invoice = IncomeInvoices::findById($id);
		if ($invoice instanceof IncomeInvoice) {
			try {
				DB::beginWork();
				
				//$qbo_controller->save_invoice_to_quickbooks($invoice);
				save_invoice_to_qbo($invoice, $data_service);
				sleep(1); // wait to send the next invoice
				
				DB::commit();
			} catch (Exception $e) {
				DB::rollback();
				Logger::log("Error saving invoive to QBO: invoice_id: $id - ".$e->getMessage()."\n".$e->getTraceAsString());
			}
		}
	}
