<?php
function draw_category_account_match_table_row(Member $category, $qbo_cat_account_matches, $qbo_accounts, $labor_categories_by_parent) {

	$account_id = array_var($qbo_cat_account_matches, $category->getId());
	$padding_left = 10 * $category->getDepth();
	?>
	<tr><td style="padding-left: <?php echo $padding_left ?>px; width:300px;"><?php echo $category->getName() ?></td>
		<td><?php echo render_qbo_account_selector($category->getId(), $account_id, $qbo_accounts); ?></td>
	</tr>
	<?php 

	if (isset($labor_categories_by_parent[$category->getId()])) {
		foreach ($labor_categories_by_parent[$category->getId()] as $sub_cat) {
			draw_category_account_match_table_row($sub_cat, $qbo_cat_account_matches, $qbo_accounts, $labor_categories_by_parent);
		}
	}

}

?>
<style>
	.adminMainBlock .config-table td, .adminMainBlock .config-table th {
		padding: 1px 5px;
	}
</style>

<div class="adminConfiguration" style="height:100%;background-color:white">

<form class="internalForm" action="<?php echo get_url('quickbooks','edit_account_categories_match') ?>" method="post">

<div class="coInputHeader">
	  <div>
		<div class="coInputName">
			<div class="coInputTitle">
				<?php echo lang('account categories matching') ?>
			</div>
		</div>
		<div class="coInputButtons">
			<?php echo submit_button(lang('save'), 's', array('style' => 'margin-top:0px;')) ?>
		</div>
		<div class="clear"></div>
	  </div>
	</div>
	
	<div class="adminMainBlock">

	<?php if (count($labor_categories_by_parent) > 0) { ?>
		<h1><?php echo $labor_categories_dim->getName() ?></h1>
		<table class="config-table">
			<tr><th><?php echo lang('category') ?></th><th><?php echo lang('quickbooks account') ?></th></tr>
		<?php 
			foreach ($labor_categories_by_parent[0] as $category) {
				draw_category_account_match_table_row($category, $qbo_cat_account_matches, $qbo_accounts, $labor_categories_by_parent);
			}
		?>
		</table>
	<?php } ?>

	<?php if (count($expense_categories_by_parent) > 0) { ?>
		<h1><?php echo $expense_categories_dim->getName() ?></h1>
		<table class="config-table">
			<tr><th><?php echo lang('category') ?></th><th><?php echo lang('quickbooks account') ?></th></tr>
		<?php 
			foreach ($expense_categories_by_parent[0] as $category) {
				draw_category_account_match_table_row($category, $qbo_cat_account_matches, $qbo_accounts, $expense_categories_by_parent);
			}
		?>
		</table>
	<?php } ?>

	</div>

</form>
</div>