og.quickbooks_desktop = {
	
	init: function() {		
		// var quickbooks_export_bill = new Ext.Action({
		// 	id: 'export_to_quickbooks_bill',
		// 	text: lang('export as bill'),
		//     tooltip: lang('export as bill'),
		// 	handler: function() {
		// 		alert("under development");
		// 	}
		// });
		
		// var quickbooks_export_item = new Ext.Action({
		// 	id: 'export_to_quickbooks_item',
		// 	text: lang('export as item receipt'),
		//     tooltip: lang('export as item receipt'),
		// 	handler: function() {
		// 		alert("under development");
		// 	}
		// });
		
		// if (!og.expenses2.more_payment_receipt_list_toolbar_items) {
		// 	og.expenses2.more_payment_receipt_list_toolbar_items = [];
		// }

		var quickbooks_export_item = new Ext.Action({
			id: 'export_to_quickbooks_expenses',
			text: lang('export to quickbooks'),
		    tooltip: lang('export to quickbooks'),
			handler: function() {
				og.quickbooks_desktop.export_actual_expenses('payment-receipt-manager');
			}
		});

		if (!og.expenses2.more_payment_receipt_list_toolbar_items) {
			og.expenses2.more_payment_receipt_list_toolbar_items = [];
		}
		
		og.expenses2.more_payment_receipt_list_toolbar_items.push(quickbooks_export_item);
		
		og.additional_list_actions.invoice.push(
			new Ext.Action({
				id: 'export_invoices_to_quickbooks',
				text: lang('export to quickbooks'),
				tooltip: lang('export to quickbooks'),
				handler: function() {
					og.quickbooks_desktop.export_invoices('invoice-manager');
				}
			})
		);

		// Add qb item column to product types list
		if (!og.expenses2.more_product_type_columns) og.expenses2.more_product_type_columns = [];
		og.expenses2.more_product_type_columns.push('qbd_item');

		// Add qb item column to billing categories list
		if (!og.advanced_billing.more_billing_cat_columns) og.advanced_billing.more_billing_cat_columns = [];
		og.advanced_billing.more_billing_cat_columns.push('qbd_item');
	},
	
	export_invoices: function(panel_id) {
		var grid = Ext.getCmp(panel_id);

		var params = {
			sent_filter: grid.actual_sent_filter,
			status_filter: grid.actual_status_filter,
			period_filter: grid.period_filter,
			from_filter: grid.from_filter,
			to_filter: grid.to_filter
		};
		
		og.openLink(og.getUrl('quickbooks_desktop', 'export_invoices', params), {
			callback: function(success, data) {
				if (success && data) {
					og.quickbooks_desktop.download_exported_file(data);
				}
			}
		});
	},
	
	export_actual_expenses: function(panel_id) {
		var grid = Ext.getCmp(panel_id);
		
		var params = {
			pr_from_filter: grid.filters.pr_from_filter.value ?? '',
			pr_to_filter: grid.filters.pr_to_filter.value ?? '',
			pr_user_filter: grid.filters.pr_user_filter.value ?? '',
			text_filter: grid.filters.text_filter.value ?? '',
			expense_invoicing_status_filter: grid.filters.expense_invoicing_status_filter.value ?? ''
		};

		console.log(params);
		
		og.openLink(og.getUrl('quickbooks_desktop', 'export_actual_expenses', params), {
			callback: function(success, data) {
				if (success && data) {
					og.quickbooks_desktop.download_exported_file(data);
				}
			}
		});
	},
	
	export_timeslots: function(panel_id) {
		var grid = Ext.getCmp(panel_id);

		var params = {
			type_filter: grid.filters.type_filter.value,
			user_filter: grid.filters.user_filter.value,
			period_filter: grid.filters.period_filter.value,
			from_filter: grid.filters.from_filter.value,
			to_filter: grid.filters.to_filter.value
		}
		
		og.openLink(og.getUrl('quickbooks_desktop', 'export_timeslots', params), {
			callback: function(success, data) {
				if (success && data) {
					og.quickbooks_desktop.download_exported_file(data);
				}
			}
		});
	},
	
	download_exported_file: function(data) {
		if (data.filename) {
			var $form = $("<form></form>");
			$form.attr("action", og.getUrl('reporting', 'download_file'));
			$form.attr("method", "post");
			$form.append('<input type="text" name="file_name" value="'+data.filename+'" />');
			$form.append('<input type="text" name="file_type" value="'+data.type+'" />');
			if (data.size) {
				$form.append('<input type="text" name="file_size" value="'+data.size+'" />');
			}

			$form.appendTo('body').submit().remove();
		}
	}
	
}

















