<?php 


function quickbooks_desktop_update_1_2() {

	$config_cat = ConfigCategories::instance()->findOne(array("conditions" => array("name=?", 'quickbooks_desktop')));
	if (!$config_cat) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_categories` (`name`, `is_system`, `category_order`) VALUES ('quickbooks_desktop', 0, 45);
		");
	}

	$config_option_exists = ConfigOptions::getByName("qbd_dimension_for_classes");
	if (!$config_option_exists instanceof ConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
			('quickbooks_desktop', 'qbd_dimension_for_classes', (SELECT id FROM ".TABLE_PREFIX."dimensions WHERE code='countries'), 'SingleDimensionConfigHandler', 0, 0, '', '')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}

	$config_option_exists = ConfigOptions::getByName("qbd_default_income_account");
	if (!$config_option_exists instanceof ConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
			('quickbooks_desktop', 'qbd_default_income_account', 'ACCOUNTS RECEIVABLE', 'StringConfigHandler', 0, 0, '', '')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}

	$config_option_exists = ConfigOptions::getByName("qbd_default_income_item");
	if (!$config_option_exists instanceof ConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
			('quickbooks_desktop', 'qbd_default_income_item', '', 'StringConfigHandler', 0, 0, '', '')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}

	$country_ot = ObjectTypes::findByName('country');
	$cp = MemberCustomProperties::getCustomPropertyByCode($country_ot->getId(), 'qbd_class');
	if (!$cp) {
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."member_custom_properties (object_type_id, name, code, type, is_system, is_required) VALUES
			((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='country'), 'Quickbooks Class', 'qbd_class', 'text', 1, 0);
		");
	}

	$labor_cat_ot = ObjectTypes::findByName('hour_type');
	$cp = MemberCustomProperties::getCustomPropertyByCode($labor_cat_ot->getId(), 'qbd_item');
	if (!$cp) {
		DB::execute("
			INSERT INTO ".TABLE_PREFIX."member_custom_properties (object_type_id, name, code, type, is_system, is_required) VALUES
			((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='hour_type'), 'Quickbooks Service/Item', 'qbd_item', 'text', 1, 0);
		");
	}

	if (Plugins::instance()->isActivePlugin('advanced_core')) {
		Env::useHelper('functions', 'advanced_core');
		fill_property_groups_default_data();
	}
}

function quickbooks_desktop_update_2_3() {

	if (Plugins::instance()->isActivePlugin('advanced_billing')) {
		if (!check_column_exists(TABLE_PREFIX . "billing_definitions", 'qbd_item')) {
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."billing_definitions`
				ADD `qbd_item` varchar(255) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '';
			");
		}
	}

	if (Plugins::instance()->isActivePlugin('expenses2')) {
		if (!check_column_exists(TABLE_PREFIX . "product_types", 'qbd_item')) {
			DB::execute("
				ALTER TABLE `".TABLE_PREFIX."product_types`
				ADD `qbd_item` varchar(255) COLLATE 'utf8_unicode_ci' NOT NULL DEFAULT '';
			");
		}
	}

	$exp_cat_ot = ObjectTypes::findByName('expense_category');
	if ($exp_cat_ot instanceof ObjectType) {

		$cp = MemberCustomProperties::getCustomPropertyByCode($exp_cat_ot->getId(), 'qbd_item');
		if (!$cp) {
			DB::execute("
				INSERT INTO ".TABLE_PREFIX."member_custom_properties (object_type_id, name, code, type, is_system, is_required) VALUES
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='expense_category'), 'Quickbooks Service/Item', 'qbd_item', 'text', 1, 0);
			");
		}
	
		if (Plugins::instance()->isActivePlugin('advanced_core')) {
			Env::useHelper('functions', 'advanced_core');
			fill_property_groups_default_data();
		}
	}
}

function quickbooks_desktop_update_3_4() {

	// TODO
	// 	Append to fo_custom_properties id 98 Invoice number code invoice_number 



	$config_option_exists = ConfigOptions::getByName("qbd_default_expense_account");
	if (!$config_option_exists instanceof ConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
			('quickbooks_desktop', 'qbd_default_expense_account', '', 'StringConfigHandler', 0, 0, '', '')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}



	$exp_cat_ot = ObjectTypes::findByName('expense_category');
	if ($exp_cat_ot instanceof ObjectType) {

		$cp = MemberCustomProperties::getCustomPropertyByCode($exp_cat_ot->getId(), 'qbd_expense_acct');
		if (!$cp) {
			DB::execute("
				INSERT INTO ".TABLE_PREFIX."member_custom_properties (object_type_id, name, code, type, is_system, is_required) VALUES
				((SELECT id FROM ".TABLE_PREFIX."object_types WHERE name='expense_category'), 'QBD Expense account', 'qbd_expense_acct', 'text', 1, 0);
			");
		}
	
		if (Plugins::instance()->isActivePlugin('advanced_core')) {
			Env::useHelper('functions', 'advanced_core');
			fill_property_groups_default_data();
		}
	}

	// new config option to specify which types of expenses are going to be sync
	$config_option_exists = ConfigOptions::getByName("qbd_expense_types_to_sync");
	if (!$config_option_exists instanceof ConfigOption) {
		DB::execute("
			INSERT INTO `".TABLE_PREFIX."config_options` (`category_name`, `name`, `value`, `config_handler_class`, `is_system`, `option_order`, `dev_comment`, `options`) VALUES
			('quickbooks_desktop', 'qbd_expense_types_to_sync', '', 'MultipleListConfigHandler', 0, 0, '', 'reimbursable,direct_to_vendor,rental_consumable,credit_card_purchase')
			ON DUPLICATE KEY UPDATE `category_name`=`category_name`;
		");
	}

	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."qbd_vendor_by_employee` (
		`eployee_id` int(11) NOT NULL,
		`vendor_name` varchar(255) NOT NULL,
		PRIMARY KEY (`eployee_id`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");

	DB::execute("
		CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."qbd_default_account_by_type` (
		`transaction_type` varchar(64) NOT NULL,
		`account` varchar(256) NOT NULL,
		PRIMARY KEY (`transaction_type`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
	");

	DB::execute("
		UPDATE `".TABLE_PREFIX."member_custom_properties` SET
		`description` = 'This value will be used if the Product Type doesn\'t have a specific Service/Item assigned'
		WHERE `code` = 'qbd_item'
	");
}