og.roles_dimension = {
	init: function () {
		
		if (!og.on_ts_contact_combo_select) og.on_ts_contact_combo_select = [];
		og.on_ts_contact_combo_select.push(og.roles_dimension.select_role_by_contact);
		
		if (!og.time_quick_add_user_combo_listeners) og.time_quick_add_user_combo_listeners = {};
		og.time_quick_add_user_combo_listeners['select'] = og.roles_dimension.quick_add_user_combo_select;

		
		if (!og.after_assigned_to_change_fn) og.after_assigned_to_change_fn = [];
		og.after_assigned_to_change_fn.push(function(genid, combo, selected) {
			if (selected && selected.data) {
				var params = {genid: genid, selected_user_id: selected.data.value, combo: combo, task_id:0};
				og.roles_dimension.select_role_by_contact(params);
			}
		});
		
		if (!og.more_add_task_form_init_fn) og.more_add_task_form_init_fn = [];
		og.more_add_task_form_init_fn.push(function(genid) {
			var combo = Ext.getCmp(genid + 'taskFormAssignedToCombo');
			if (combo) {
				var params = {genid: genid, selected_user_id: combo.getValue(), combo: combo, task_id:0};
				og.roles_dimension.select_role_by_contact(params);
			}
		});
	},
	
	quick_add_user_combo_select: function(combo, record, index) {
		var params = {genid: combo.genid, selected_user_id: combo.getValue(), combo: combo, task_id:0};
		og.roles_dimension.select_role_by_contact(params);
	},
	
	member_selector_add_relation: function(ignored1, ignored2, data) {
		member_selector.add_relation(data.dimension_id, data.genid, data.member_id);
	},
	
	select_role_by_contact: function(params) {
		var genid = params.genid;
		var selected_user_id = params.selected_user_id;
		var combo = params.combo;
		var task_id = params.task_id;
		
		if (selected_user_id > 0) {
			og.openLink(og.getUrl('role', 'get_user_default_role', {user_id: selected_user_id, genid: genid, task_id: task_id}), {
				hideLoading: true,
				callback: function(success, data) {
					
					if (data && data.member_id) {
						
						member_selector.remove_all_dimension_selections(data.genid, data.dimension_id);
						
						if (og.dimensions && og.dimensions[data.dimension_id] && og.dimensions[data.dimension_id][data.member_id]) {
							// if member data already in cache -> use it and select the member
							member_selector.add_relation(data.dimension_id, data.genid, data.member_id);
						} else {
							// go to server and get the member data and then select the member
							og.getMemberFromServer(data.member_id, og.roles_dimension.member_selector_add_relation, data);
						}
						
						$("#"+data.genid+"-member-chooser-panel-"+data.dimension_id+"-tree-current-selected .empty-text").hide();
					
					} else if (data.remove_on_empty) {
						
						member_selector.remove_all_dimension_selections(data.genid, data.dimension_id);
						$("#"+data.genid+"-member-chooser-panel-"+data.dimension_id+"-tree-current-selected .empty-text").show();
					}
				}
			});
		}
	}
}