<?php

function classify_timeslot_in_invoiced_status_member($object) {
	if ($object instanceof Timeslot && $object->getColumnValue('invoicing_status') == 'invoiced') {
	
		Env::useHelper('functions', 'income');
		$invoiced_timeslots_member_id = income_config_option('invoiced_timeslots_member_id');
		$invoiced_timeslots_member = Members::getMemberById($invoiced_timeslots_member_id);
		if (!$invoiced_timeslots_member instanceof Member) return;
	
		$classified_in_invoiced = false;
		$members_to_remove = array();
	
		$members = $object->getMembers();
		foreach ($members as $m) {
			if ($m->getId() == $invoiced_timeslots_member_id) {
				$classified_in_invoiced = true;
			}
			if ($m->getDimensionId() == $invoiced_timeslots_member->getDimensionId()) {
				$members_to_remove[] = $m->getId();
			}
		}
	
		if (!$classified_in_invoiced) {
			ObjectMembers::removeObjectFromMembers($object, logged_user(), array(), $members_to_remove);
			$object->addToMembers(array($invoiced_timeslots_member));
			$object->addToSharingTable();
		}
	
	}
}