
INSERT INTO `<?php echo $table_prefix ?>object_types` (`name`,`handler_class`,`table_name`,`type`,`icon`,`plugin_id`,`uses_order`) VALUES
 ('ticket', 'Tickets', 'tickets', 'content_object', 'ticket', (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='tickets'), 0)
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO `<?php echo $table_prefix ?>dimension_object_type_contents` (`dimension_id`,`dimension_object_type_id`,`content_object_type_id`, `is_required`, `is_multiple`)
 SELECT dimension_id, dimension_object_type_id, (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='ticket'), 0, 1
 FROM `<?php echo $table_prefix ?>dimension_object_type_contents` x
 WHERE x.`content_object_type_id` = (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>dimension_object_type_contents.dimension_id=<?php echo $table_prefix ?>dimension_object_type_contents.dimension_id;

DELETE FROM `<?php echo $table_prefix ?>dimension_object_type_contents` WHERE `dimension_id`=0 OR dimension_id IS NULL;

INSERT INTO `<?php echo $table_prefix ?>dimension_content_object_options` (`dimension_id`,`content_object_type_id`,`option`,`value`)
	SELECT d.id, ot.id, 'hide_member_selector_in_forms', '0'
	FROM <?php echo $table_prefix ?>dimensions d LEFT JOIN <?php echo $table_prefix ?>object_types ot ON true
	WHERE ot.name IN ('ticket')
ON DUPLICATE KEY UPDATE `value`=`value`;

INSERT INTO `<?php echo $table_prefix ?>tab_panels` (`id`,`title`,`icon_cls`,`refresh_on_context_change`,`default_controller`,`default_action`,`initial_controller`,`initial_action`,`enabled`,`type`,`ordering`,`plugin_id`,`object_type_id`) VALUES 
 ('tickets-panel', 'tickets', 'ico-tickets', 1, 'ticket', 'init', '', '', 1, 'system', 11, (SELECT `id` FROM `<?php echo $table_prefix ?>plugins` WHERE `name`='tickets'), (SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='ticket')) 
ON DUPLICATE KEY UPDATE id=id;

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('ticket')
	 AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');

INSERT INTO <?php echo $table_prefix ?>max_role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 0, 0
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('ticket')
	 AND p.`name` IN ('Collaborator Customer','Internal Collaborator','External Collaborator','Guest Customer');

INSERT INTO <?php echo $table_prefix ?>role_object_type_permissions (role_id, object_type_id, can_delete, can_write)
SELECT p.id, o.id, 1, 1
FROM `<?php echo $table_prefix ?>object_types` o JOIN `<?php echo $table_prefix ?>permission_groups` p
WHERE o.`name` IN ('ticket')
	AND p.`name` IN ('Super Administrator','Administrator','Manager','Executive');


-- add permissions to users where the users already have permissions (copy permissions from tasks)
INSERT INTO <?php echo $table_prefix ?>contact_member_permissions (permission_group_id, member_id, object_type_id, can_delete, can_write)
 SELECT cmp.permission_group_id, cmp.member_id, (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='ticket'), cmp.can_delete, cmp.can_write 
 FROM <?php echo $table_prefix ?>contact_member_permissions cmp
 WHERE cmp.object_type_id = (SELECT `id` FROM `<?php echo $table_prefix ?>object_types` WHERE `name`='task')
ON DUPLICATE KEY UPDATE <?php echo $table_prefix ?>contact_member_permissions.member_id=<?php echo $table_prefix ?>contact_member_permissions.member_id;

INSERT INTO <?php echo $table_prefix ?>tab_panel_permissions (permission_group_id, tab_panel_id)
 SELECT pg.id, 'tickets-panel' FROM <?php echo $table_prefix ?>permission_groups pg WHERE pg.type='roles' AND pg.name IN ('Super Administrator','Administrator','Manager','Executive')
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;

INSERT INTO <?php echo $table_prefix ?>tab_panel_permissions (permission_group_id, tab_panel_id)
 SELECT c.permission_group_id, 'tickets-panel' FROM <?php echo $table_prefix ?>contacts c 
 WHERE c.user_type IN (SELECT pg.id FROM <?php echo $table_prefix ?>permission_groups pg WHERE pg.type='roles' and pg.name IN ('Super Administrator','Administrator','Manager','Executive'))
ON DUPLICATE KEY UPDATE tab_panel_id=tab_panel_id;

INSERT INTO `<?php echo $table_prefix ?>custom_properties` (`object_type_id`,`name`,`code`,`type`,`description`,`values`,`default_value`,`is_required`,`is_multiple_values`,`property_order`,`visible_by_default`, `is_special`, `is_disabled`) VALUES 
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='ticket'),'Assigned to','assigned_to_special','user','','','',0,0,0,1, 1,0),
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='ticket'),'Internal status','internal_status_special','list','','New,Acknowledged,Feedback,Assigned,In Progress,Resolved,Closed','New',1,0,2,1, 1,0),
 ((SELECT id FROM <?php echo $table_prefix ?>object_types WHERE name='ticket'),'Requested by','requested_by_special','contact','','','',1,0,4,1, 1,0)
ON DUPLICATE KEY UPDATE object_type_id=object_type_id;
