<?php
Hook::register('time_intervals');

/**
 * 
 * @param array $params
 * @param string $field
 */
function time_intervals_override_minute_field($params, &$field){
    $name = array_var($params, 'name');
    $value = array_var($params, 'value');
    $attributes = array_var($params, 'attributes');
    
    $options = array();
    $intervals = array(0, 15, 30, 45);
    
    foreach ($intervals as $interval) {
        $option_attributes = $interval == $value ? array('selected' => true) : null;
        //$zone_description = Timezones::getFormattedDescription($zone);
        
        $options[] = option_tag($interval, $interval, $option_attributes);
    }
    
    //$options = array(0, 15, 30, 45);
    //option_tag($zone_description, $zone['id'], $option_attributes);
    //Hook::fire('override_minute_field', array('name' => $name, 'value' => $value, 'attributes' => $attributes), $field);
    
    //select_box($name, $options, $attributes = null) {
    $field = select_box($name, $options, $attributes);
    
    //function select_box($name, $options, $attributes = null) {
}

function time_intervals_round_minutes_to_fifteen($params, $minutes){

    // Check if minutes are not in interval to show message 
    if(!in_array($minutes % 60, array(0, 15, 30, 45))){
        flash_success(lang('time will be rounded to 15 minutes'));
    }

    $timeslot = array_var($params, 'timeslot');
    $remainder = $timeslot->getSeconds()%900;
    if($remainder > 0){
        $seconds_to_add = 900 - $remainder;
        $adjusted_end_time = $timeslot->getEndTime()->add('s', $seconds_to_add);
        $timeslot->setEndTime($adjusted_end_time);
    }
}

function time_intervals_get_hour_minutes_rounded($minutes, &$ret){

    // Check if minutes are not in interval to show message 
    if(!in_array($minutes % 60, array(0, 15, 30, 45))){
        flash_success(lang('time will be rounded to 15 minutes'));
    }

    $round = 15*60;
    $data = explode(":", date("H:i", round(strtotime(floor($minutes / 60).":".$minutes % 60) / $round) * $round));
    $hours_r = (int)$data[0];
    $minutes_r = (int)$data[1];
    $total_minutes = $hours_r * 60 + $minutes_r;

    $ret = array("hours" => $hours_r, "minutes" => $minutes_r, "total_minutes" => $total_minutes);
    return $ret;
}

function time_intervals_override_minute_options($params, &$minuteOptions){
    $minuteOptions = array(0, 15, 30, 45);
}
