<?php
Hook::register("global_account");

define('FENG_SITE_URL', 'https://www.fengoffice.com/web/');

function global_account_after_object_save($object,&$ignored) {
	$root_exploded = @explode("/", ROOT);
	$install = end ($root_exploded);
	// 2022-01-06 Luis Casamayou:  agregado para tener en cuenta los sitios de test
	$subdir = prev( $root_exploded );
	if( $subdir == 'test_installations' ){
	  $install = 'testing-' . $install;
	}
	// FIN AGREGADO	
	Env::useHelper('functions', 'web');
	
	if($object instanceof Contact && $object->isUser()) {
		
		if ($object->getEmailAddress() == '' || $object->getToken() == '') return;
		
		$all = array();
		$all_res = DB::executeAll("SELECT object_id FROM ".TABLE_PREFIX."contacts WHERE user_type != 0");
		foreach($all_res as $row) {
			$all[] = $row['object_id'];
		}
		
		$parameters = array(
			'method' => 'global_account_services',
			'action' => 'udpate_user_installations',
			'url' => ROOT_URL,
			'installation' => $install,
			'id' => $object->getId(),
			'email' => $object->getEmailAddress(),
			'token' => $object->getToken(),
			'twister' => $object->getTwister(),
			'salt' => $object->getSalt(),
			'all' => implode(",", $all),
		);
		
		
		$url_params = http_build_query($parameters);
		$url = FENG_SITE_URL . "services/services.php?".$url_params;
		make_request_wget($url);
		
		//$result = HttpRequest(FENG_SITE_URL . "services/services.php", 'POST', $parameters);
		
	} else if ($object instanceof ContactPassword) {
		if ($object->password_temp) {
			$user = Contacts::findById($object->getContactId());
			if ($user instanceof Contact) {
				
				$parameters = array(
					'method' => 'global_account_services',
					'action' => 'udpate_user_installations_users',
					'url' => ROOT_URL,
					'installation' => $install,
					'id' => $user->getId(),
					'email' => $user->getEmailAddress(),
					'token' => $user->getToken(),
					'twister' => $user->getTwister(),
					'salt' => $user->getSalt(),
					'n' => $user->getDisplayName(),
					'p' => md5($object->password_temp),
				);
				
				$url_params = http_build_query($parameters);
				$url = FENG_SITE_URL . "services/services.php?".$url_params;
				make_request_wget($url);
				
				//$result = HttpRequest(FENG_SITE_URL . "services/services.php", 'POST', $parameters);
				
			}
		}
	}
}

function global_account_after_action($args,&$ret){
	
	if($args['controller']->getControllerName() == "user" && $args['action'] == "delete"){
		
		$all = array();
		$all_res = DB::executeAll("SELECT object_id FROM ".TABLE_PREFIX."contacts WHERE user_type != 0");
		foreach($all_res as $row) {
			$all[] = $row['object_id'];
		}
		
		$root_exploded = @explode("/", ROOT);
		$install = end ($root_exploded);
    // 2022-01-06 Luis Casamayou:  agregado para tener en cuenta los sitios de test
		$subdir = prev( $root_exploded );
		if( $subdir == 'test_installations' ){
	    $install = 'testing-' . $install;
		}
		// FIN AGREGADO
		$parameters = array(
			'method' => 'global_account_services',
			'action' => 'delete_after_delete',
			'url' => ROOT_URL,
			'installation' => $install,
			'all' => implode(",", $all),
		);
		
		Env::useHelper('functions', 'web');
		$url_params = http_build_query($parameters);
		$url = FENG_SITE_URL . "services/services.php?".$url_params;
		make_request_wget($url);
		
		//$result = HttpRequest(FENG_SITE_URL . "services/services.php", 'POST', $parameters);
		
	}
	
}