<?php

	Hook::register ( 'infobar' );
	
	if (!defined('SAVE_PERMISSIONS_IN_BACKGROUND')) {
		define('SAVE_PERMISSIONS_IN_BACKGROUND', true);
	}
	
	define('WEB_SITE_URL', 'https://www.fengoffice.com/web/');
	define('MIN_OBJECTS_TO_ADD_TO_CRON', 10);
	
	function infobar_render_page_header($args, &$ret) {
		Env::useHelper('functions', 'web');
		
		$local = Localization::instance ()->getLocale ();
		if ($local == 'es_la' || $local == 'es_es') {
			$infobar_days_left = "Dias restantes de la prueba gratuita";
			$box_left = '38%';
		} else {
			$infobar_days_left = "Free trial's days left";
			$box_left = '41%';
		}
		$infobar_faqs = "FAQs";
		$infobar_demo = "Demo";
		// account owner = first contact with user_type > 0
		$super_admin_user = Contacts::findOne(array("conditions"=>"user_type > 0", 'order' => 'object_id'));
		//if ( logged_user()->getId() != $super_admin_user->getId() ) return false;
		$email = logged_user()->getEmailAddress();
		$token = logged_user()->getToken ();
		
		$root_exploded = @explode("/", ROOT);
		$install = end ($root_exploded);
		
		//$result = HttpRequest(WEB_SITE_URL . "services/services.php", 'POST', array('method' => 'check_is_trial', 'installation_name' => $install));
		//$info = json_decode(array_var($result, 'body'));
		
		$parameters = array('method' => 'check_is_trial', 'installation_name' => $install);
		$url_params = http_build_query($parameters);
		$url = WEB_SITE_URL . "services/services.php?".$url_params;
		$info = (object)make_request_wget_json($url);
		
		$_SESSION['trial_information'] = $info;
	
		if ($info->is_trial || $info->is_full) {
			// check for object count and add to backupable installations
			$co = ConfigOptions::instance()->getByName('added_to_cron');
			if (!$co instanceof ConfigOption) {
				$co = new ConfigOption();
				$co->setFromAttributes(array('category_name' => 'system', 'name' => 'added_to_cron', 'value' => 0, 'config_handler_class' => 'BoolConfigHandler', 'is_system' => 1, 'dev_comment' => ''));
				$co->save();
			}
			if (!$co->getValue()) {
				$object_count = Objects::instance()->count();
				if ($object_count > MIN_OBJECTS_TO_ADD_TO_CRON) {
					//$result = HttpRequest(WEB_SITE_URL . "services/services.php", 'POST', array('method' => 'add_to_cron', 'installation_name' => $install));
					//$info_result = json_decode(array_var($result, 'body'));
					$parameters = array('method' => 'add_to_cron', 'installation_name' => $install);
					$url_params = http_build_query($parameters);
					$url = WEB_SITE_URL . "services/services.php?".$url_params;
					$info_result = (object)make_request_wget_json($url);
					
					if (isset($info_result->success) && $info_result->success) {
						$co->setValue(1);
						$co->save();
						
						// Set send notifications through cron
						$event = CronEvents::instance()->getByName('send_notifications_through_cron');
						if ($event instanceof CronEvent) {
							$event->setEnabled(true);
							$event->save();
						}
					}
				}
			}
			
			// enable mail download only for the last 15 days
			$co = ConfigOptions::instance()->getByName('first_mail_date_imap');
			if (!$co instanceof ConfigOption) {
				$co = new ConfigOption();
				$date = DateTimeValueLib::now();
				$date->add('d', -15);
				$co->setFromAttributes(array(
						'category_name' => 'system', 
						'name' => 'first_mail_date_imap', 
						'value' => $date->format('d-M-Y'), 
						'config_handler_class' => 'StringConfigHandler', 'is_system' => 1, 'dev_comment' => ''));
				$co->save();
			}
		}
		
		if (!$info->is_trial) {
			return false;
		}
		
		//Calc values
		define ( "OLARK_CHAT_ENABLED", 1 );
		$date_now = date ( "Y-m-d H:i:s" );
		$date_trial = date ( $info->created_on );
		$diff = strtotime ( $date_now ) - strtotime ( $date_trial );
		$days = 30 - floor ( ($diff) / (60 * 60 * 24) );
		if ($days < 0) $days = 0;
		
		$log_count = ApplicationLogs::instance()->count();
		if($log_count< 4){
			$parameters = array('method' => 'step3_completed', 'installation_name' => $install);
			$url_params = http_build_query($parameters);
			$url = WEB_SITE_URL . "services/services.php?".$url_params;
			make_request_wget_json($url);
			//$result = HttpRequest(WEB_SITE_URL . "services/services.php", 'POST', array('method' => 'step3_completed', 'installation_name' => $install));
		}
		
		if ($days <= 10) {
			include_once PLUGIN_PATH."/web/application/views/infobar.php";
		}
	}
	
	
	function infobar_render_administration_icons($ignored, &$icons) {
		Env::useHelper('functions', 'web');
		$root_exploded = @explode ( "/", ROOT );
		$install = end ($root_exploded);
		//$result = HttpRequest(WEB_SITE_URL . "services/services.php", 'POST', array('method' => 'check_is_trial', 'installation_name' => $install));
		//$info = json_decode(array_var($result, 'body'));
		$parameters = array('method' => 'check_is_trial', 'installation_name' => $install);
		$url_params = http_build_query($parameters);
		$url = WEB_SITE_URL . "services/services.php?".$url_params;
		$info = (object)make_request_wget_json($url);
		
		if ($info->is_trial) {
			foreach ($icons as $k => &$icon) {
				if (array_var($icon, 'ico') == 'ico-large-cron') unset($icons[$k]);
			}
		}
	}
	
	
	function infobar_render_help_and_support_links($ignored, &$links) {
		
		$info = array_Var($_SESSION, 'trial_information');
		if ($info && $info->is_trial) {
			
			$email = logged_user()->getEmailAddress();
			$token = logged_user()->getToken();
			
			$date_now = date ( "Y-m-d H:i:s" );
			$date_trial = date ( $info->created_on );
			$diff = strtotime ( $date_now ) - strtotime ( $date_trial );
			$days = 30 - floor ( ($diff) / (60 * 60 * 24) );
			if ($days < 0) $days = 0;
		
			$links[] = array(
				'ico' => 'ico-large-upgrade',
				'url' => '#',
				'onclick' => 'document.getElementById(\'buy_form\').submit(); return false;',
				'name' => lang('subscribe'),
				'target' => '_blank',
				'additional_html' => '<form target="_blank" id="buy_form" action="'. WEB_SITE_URL .'/inc/_session_recover.php" method="post" style="display:none;">
						<input type="hidden" name="infobar_email" value="'.$email.'" />
						<input type="hidden" name="infobar_token" value="'.$token.'" />
						<input type="hidden" name="infobar_redirect" value="sign-up.php" />
					</form>',
			);
			
			$links[] = array(
					'ico' => 'ico-large-faqs',
					'url' => '#',
					'onclick' => 'document.getElementById(\'faq_form\').submit(); return false;',
					'name' => lang('faqs'),
					'target' => '_blank',
					'additional_html' => '<form target="_blank" id="faq_form" action="'. WEB_SITE_URL .'/inc/_session_recover.php" method="post" style="display:none;">
						<input type="hidden" name="infobar_email" value="'.$email.'" />
						<input type="hidden" name="infobar_token" value="'.$token.'" />
						<input type="hidden" name="infobar_redirect" value="support/documents.php?faq=0" />
					</form>',
			);
		}
	}
	