<?php
Hook::register('notifications_account');

function notifications_account_override_notifier_mailer_parameters($ignored, &$parameters) {
	
	// if already using an smtp account => don't override the account configuration
	if (is_array($parameters) && isset($parameters['smtp_server']) 
		&& isset($parameters['smtp_port']) && isset($parameters['smtp_secure_connection']) 
		&& isset($parameters['smtp_username']) && isset($parameters['smtp_password'])) {
		
		return;
	}

    if(config_option('mail_transport') == Notifier::MAIL_TRANSPORT_SMTP){
	    return;
	}

	if (Plugins::instance()->isActivePlugin('evx_edition')) {
		$config_filename = "/datos/notifications_account_evx.config";
	} else {
		$config_filename = "/datos/notifications_account.config";
	}
	if (file_exists($config_filename)) {
		
		$config_str = file_get_contents($config_filename);
		
		// server|port|transport|username|password
		$config_array = explode("|", $config_str);
				
		if (is_array($config_array) && count($config_array) >= 5) {
			
			if (!is_array($parameters)) $parameters = array();
			
			$parameters['smtp_server'] = trim($config_array[0]);
			$parameters['smtp_port'] = trim($config_array[1]);
			$parameters['smtp_secure_connection'] = trim($config_array[2]);
			$parameters['smtp_username'] = trim($config_array[3]);
			$parameters['smtp_password'] = trim($config_array[4]);

			// our mail server doesn't allow to send emails with "from" different than the one that authenticates
			$parameters['from_override'] = array(
				'address' => $parameters['smtp_username'],
				'name' => product_name(),
			);
		}
		
	}
	
}
