<?php

function can_approve_summaries(Contact $user) {
	return SystemPermissions::userHasSystemPermission($user, 'can_approve_summaries');
}

function can_edit_approved_summaries(Contact $user) {
	return SystemPermissions::userHasSystemPermission($user, 'can_edit_approved_summaries');
}

function news_type_group_select_box($name, $selected = null, $attributes = null, $add_none_option = false) {
	$options = array();
	if ($add_none_option) {
		$options[] = option_tag(lang('none', 0));
	}
	$groups = NewsTypeGroups::findAll(array('conditions' => 'enabled=1'));
	foreach ($groups as $group) {
		$sel = array();
		if ($selected == $group->getId()) $sel['selected'] = 'selected';
		$text = $group->getName();
		$options[] = option_tag($text, $group->getId(), $sel);
	}
	return select_box($name, $options, $attributes);
}

function person_hierarchy_group_select_box($name, $selected = null, $attributes = null, $add_none_option = false) {
	$options = array();
	if ($add_none_option) {
		$options[] = option_tag(lang('none', 0));
	}
	$groups = PersonHierarchyGroups::findAll(array('conditions' => 'enabled=1'));
	foreach ($groups as $group) {
		$sel = array();
		if ($selected == $group->getId()) $sel['selected'] = 'selected';
		$text = $group->getCode() . ' - ' . $group->getName();
		$options[] = option_tag($text, $group->getId(), $sel);
	}
	return select_box($name, $options, $attributes);
}


function news_type_select_box($name, $selected = null, $attributes = null, $add_none_option = false, $extra_conditions = "", $none_lang=null) {
	$options = array();
	if ($add_none_option) {
		if (!$none_lang) $none_lang = lang('none');
		$options[] = option_tag($none_lang, 0);
	}
	
	$types = NewsTypes::findAll(array('conditions' => 'enabled=1 '.$extra_conditions, 'order' => 'description'));
	foreach ($types as $type) {
		$sel = array();
		if ($selected == $type->getId()) $sel['selected'] = 'selected';
		$text = $type->getDescription();
		$options[] = option_tag($text, $type->getId(), $sel);
	}
	return select_box($name, $options, $attributes);
}


function person_hierarchy_select_box($name, $selected = null, $attributes = null, $add_none_option = false) {
	$options = array();
	if ($add_none_option) {
		$options[] = option_tag(lang('none', 0));
	}
	$groups = PersonHierarchies::findAll(array('conditions' => 'enabled=1'));
	foreach ($groups as $group) {
		$sel = array();
		if ($selected == $group->getId()) $sel['selected'] = 'selected';
		$text = $group->getCode() . ' - ' . $group->getName();
		$options[] = option_tag($text, $group->getId(), $sel);
	}
	return select_box($name, $options, $attributes);
}