<?php 
$genid = gen_id();
if(can_manage_security(logged_user())) {
	add_page_action(lang('add news type'), get_url('news_type', 'add'), 'ico-add');
}
?>
<div id="<?php echo $genid ?>adminContainer" class="adminGroups" style="height:100%;background-color:white">
  <div class="coInputHeader">
  	<div class="coInputTitle"><?php echo lang('news types') ?></div>
  </div>
  
  <div class="adminMainBlock">
<?php if(isset($groups) && is_array($groups) && count($groups) > 0) { ?>
	<table style="min-width:600px;margin-top:10px;">
	  <tr>
	    <th><?php echo lang('name') ?></th>
	    <th style="text-align: center"><?php echo lang('options') ?></th>
	  </tr>
<?php
	$isAlt = true;
	foreach($groups as $group) {
		$isAlt = !$isAlt;
?>
	  <tr class="<?php echo ($isAlt? 'altRow' : '') . ($group->getIsPresentType() ? " present-type" : "")?>">
	    <td><a class="internalLink" href="<?php echo get_url('news_type', 'edit', array('id'=>$group->getId()))?>"><?php
	    echo clean($group->getDescription()) . ($group->getEnabled() ? '':'&nbsp;<span class="desc">('.lang('disabled').')</span>') 
	    ?></a></td>
	<?php 
		$options = array(); 
		if(can_manage_security(logged_user())) {
			$options[] = '<a class="internalLink" href="' . get_url('news_type', 'edit', array('id'=>$group->getId())) . '">' . lang('edit') . '</a>';
			$options[] = '<a class="internalLink" href="' . get_url('news_type', 'delete', array('id'=>$group->getId())) . '" onclick="return confirm(\'' . escape_single_quotes(lang('confirm delete group')) . '\')">' . lang('delete') . '</a>';
		}
	?>
	    <td style="font-size:80%;text-align: center;"><?php echo implode(' | ', $options) ?></td>
	  </tr>
<?php } ?>
	</table>
<?php } else { ?>
<?php echo lang('no news types') ?>
<?php } ?>
  </div>
</div>

<script>
	var div = document.getElementById('<?php echo $genid ?>adminContainer');
	div.parentNode.style.backgroundColor = '#FFFFFF'; 
</script>