<?php
	Env::useHelper('functions', 'work_time_registration');
	$ws_dim = Dimensions::findByCode('workspaces');
	$ws_ot = ObjectTypes::findByName('workspace');
	if (!isset($genid)) $genid = gen_id();
?>

<div class="person_form_additional_data">
	<div class="dataBlock">
		<?php echo label_tag(lang('nii'))?>
		<?php echo text_field('contact[nii]', $contact->getColumnValue('nii'))?>
	</div>
	
	<div class="dataBlock">
		<?php echo label_tag(lang('document type'))?>
		<?php echo text_field('contact[document_type]', $contact->getColumnValue('document_type'), array('class' => 'short'))?>
	</div>
	
	<div class="dataBlock">
		<?php echo label_tag(lang('document number'))?>
		<?php echo text_field('contact[document_number]', $contact->getColumnValue('document_number'))?>
	</div>
	
	<div class="dataBlock">
		<?php echo label_tag(lang('person hierarchy'))?>
		<?php echo person_hierarchy_select_box('contact[hierarchy_id]', $contact->getColumnValue('hierarchy_id'))?>
	</div>
	
	<div class="dataBlock">
		<?php echo label_tag(lang('speciality'))?>
		<?php echo text_field('contact[speciality]', $contact->getColumnValue('speciality'))?>
	</div>
	
	<div class="dataBlock">
	<tr><?php echo label_tag(lang('is active'))?>
		<?php echo yes_no_widget('contact[is_active]', $genid.'contact[is_active]', $contact->isNew() ? true : $contact->getColumnValue('is_active'), lang('yes'), lang('no'))?>
	</div>
	
	<div class="dataBlock">
		<?php echo label_tag(lang('internal destiny'))?>
		<?php // $genid-member-selectors-panel-$content_object_type_id?>
		<?php render_single_member_selector($ws_dim, $genid, array($contact->getColumnValue('internal_destiny')), array(
					'is_required' => true,
					'is_multiple' => false,
					'hide_label' => true,
					'hidden_field_name' => 'contact_internal_destiny',
					'content_object_type_id' => $contact->getObjectTypeId(),
					'allowedMemberTypes' => array($ws_ot->getId()),
					'select_function' => 'og.onInternalDestinySelect',
					'listeners' => array('on_remove_relation' => "og.onInternalDestinyRemove('".$genid."',".$ws_dim->getId().");")
		), false); 
		?>
		<input type="hidden" id="<?php echo $genid?>int_dest" name="contact[internal_destiny]" value="<?php echo $contact->getColumnValue('internal_destiny')?>" />
	</div>

</div>


<script>
og.onInternalDestinyRemove = function (genid, dimension_id){
	og.onAssociatedMemberTypeRemove(genid, dimension_id, "contact_internal_destiny");
	document.getElementById(genid + 'int_dest').value=0;
}

og.onInternalDestinySelect = function (genid, dimension_id, member_id){
	og.onAssociatedMemberTypeSelect(genid, dimension_id, member_id, "contact_internal_destiny");
	document.getElementById(genid + 'int_dest').value=member_id;
}
</script>