<?php
	$ws_dim = Dimensions::findByCode('workspaces'); 
	$genid = gen_id();
	$object = $detail;
	$visible_cps = CustomProperties::countVisibleCustomPropertiesByObjectType($detail->getObjectTypeId());
	
	$selected_person_name = '';
	if ($detail->getPersonId() > 0) {
		$selected_person = Contacts::findById($detail->getPersonId());
		if ($selected_person instanceof Contact) $selected_person_name = $selected_person->getObjectName();
	}
	$categories = array();
	Hook::fire('object_edit_categories', $object, $categories);

	$main_cp_count = CustomProperties::countVisibleCustomPropertiesByObjectType($object->getObjectTypeId());
	$other_cp_count = CustomProperties::countHiddenCustomPropertiesByObjectType($object->getObjectTypeId());
?>
<form class="add-news-detail" id="<?php echo $genid ?>submit-edit-form" style='height:100%;background-color:white' onsubmit="return og.beforeSavingDetail();" 
	action="<?php echo $detail->isNew() ? get_url('time_registration', 'add') : get_url('time_registration', 'edit', array('id' => $detail->getId())) ?>" method="post" enctype="multipart/form-data" >
<div class="registration">


<div class="coInputHeader">
  <div class="coInputHeaderUpperRow">
	<div class="coInputTitle">
		<?php echo $object->getAddEditFormTitle(); ?>
	</div>
	<div class="clear"></div>
  </div>
</div>


<div class="coInputMainBlock">
	
	<input id="<?php echo $genid?>genid" type="hidden" name="genid" value="<?php echo $genid ?>">
	<input id="<?php echo $genid?>updated-on-hidden" type="hidden" name="updatedon" value="<?php echo !$detail->isNew() ? $detail->getUpdatedOn()->getTimestamp() : '' ?>">

	<div id="<?php echo $genid?>tabs" class="edit-form-tabs">
	
		<ul id="<?php echo $genid?>tab_titles">
		
			<li><a href="#<?php echo $genid?>details"><?php echo lang('details') ?></a></li>
			
			<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
			<li><a href="#<?php echo $genid?>add_custom_properties_div"><?php echo lang('custom properties') ?></a></li>
			<?php } ?>
			
			<li><a href="#<?php echo $genid?>add_subscribers_div"><?php echo lang('object subscribers') ?></a></li>
			
			<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
			<li><a href="#<?php echo $genid?>add_linked_objects_div"><?php echo lang('linked objects') ?></a></li>
			<?php } ?>
			
			<?php foreach ($categories as $category) {
					if (array_var($category, 'hidden')) continue;
				?>
			<li><a href="#<?php echo $genid . $category['name'] ?>"><?php echo $category['name'] ?></a></li>
			<?php } ?>
		</ul>
	

		<div id="<?php echo $genid?>details" class="form-tab">
		
			<div style="float:left;" class="dataBlock">
			<table><tr>
				<td><?php echo label_tag(lang('contact'), $genid . 'newsDetailContact', true)?></td>
				<td><div id="<?php echo $genid?>contacts_combo_container"></div></td>
			</tr></table>
			<?php //echo user_select_box('detail[person_id]', null, array('style' => 'margin:0; height:22px;', 'id' => $genid . 'newsDetailContact'));?>
			</div>
			
			<div style="display:none;float:left;margin-left:70px;background-color:#eee;padding:1px 5px;border-radius:3px;" id="<?php echo $genid?>newsDetailDestiny" class="member-path-dim-block">
			<?php echo label_tag(lang('internal destiny'))?>
				<div id="<?php echo $genid?>newsDetailDestinyContent"></div>
			</div>
			<input type="hidden" id="<?php echo $genid?>newsDetailDestinyId" value=""/>
			
			<div class="clear"></div>
			
			<div class="dataBlock">
			<?php echo label_tag(lang('date'), $genid . 'newsDetailDate', true)?>
			<?php echo pick_date_widget2('detail[date]', $detail->getDate() instanceof DateTimeValue ? $detail->getDate() : DateTimeValueLib::now(), $genid);?>
			</div>
			
			<div class="dataBlock">
			<?php echo label_tag(lang('hour'), $genid . 'newsDetailHour', true)?>
			<?php 
			if ($detail->isNew()) {
				$now = DateTimeValueLib::now();
				$now->advance(logged_user()->getUserTimezoneValue(), true);
				$hhmm = str_pad($now->getHour(), 2, 0, STR_PAD_LEFT).':'.str_pad($now->getMinute(), 2, 0, STR_PAD_LEFT);
			} else {
				$hhmm = str_pad($detail->getHour(), 2, 0, STR_PAD_LEFT).':'.str_pad($detail->getMinute(), 2, 0, STR_PAD_LEFT);
			}
			?>
			<?php echo pick_time_widget2('detail[hh_mm]', $hhmm, $genid);?>
			</div>
			
			<div class="dataBlock">
			<?php echo label_tag(lang('type'), $genid . 'newsDetailType')?>
				<div id="<?php echo $genid?>newsDetailTypeContainer">
			<?php echo news_type_select_box('detail[news_type_id]', $detail->getNewsTypeId(), array('style' => 'margin:0; height:22px;', 'id' => $genid.'newsDetailType'));?>
				</div>
			</div>
			
			<div class="clear"></div>
			
			<div style="display:none;" class="dataBlock">
			<?php echo label_tag(lang('comment'), $genid . 'newsDetailComment')?>
			<?php echo textarea_field('detail[comment]', $detail->getComment(), array('id' => $genid . 'newsDetailComment', 'class' => 'long')) ?>
			</div>
			
			<div class="dataBlock" id="<?php echo $genid?>newsDetailObsContainer">
			<?php echo label_tag(lang('observations'), $genid . 'newsDetailObs')?>
			<?php echo textarea_field('detail[observations]', $detail->getObservations(), array('id' => $genid . 'newsDetailObs', 'class' => 'long')) ?>
			</div>
			
			
			<?php $null = null; Hook::fire('before_render_main_custom_properties', array('object' => $object), $null);?>
			
			<div class="dataBlock main-custom-properties-div"><?php
				if ($main_cp_count) {
					echo render_object_custom_properties($object, false, null, 'visible_by_default');
				}
			?></div>
			
			<div class="clear"></div>
		</div>
		
		<div id="<?php echo $genid ?>add_subscribers_div" style="display:none" class="form-tab">
			<div id="<?php echo $genid ?>add_subscribers_content">
				<?php echo render_add_subscribers($object, $genid); ?>
			</div>
		</div>
		
		<?php if ($other_cp_count || config_option('use_object_properties')) { ?>
		<div id="<?php echo $genid ?>add_custom_properties_div" class="form-tab other-custom-properties-div">
			<?php  echo render_object_custom_properties($object, false, null, 'other') ?>
			<?php  echo render_add_custom_properties($object); ?>
		</div>
		<?php } ?>
		
		<?php if($object->isNew() || $object->canLinkObject(logged_user())) { ?>
		<div style="display:none" id="<?php echo $genid ?>add_linked_objects_div" class="form-tab">
			<?php echo render_object_link_form($object) ?>	
		</div>
		<?php } // if ?>
		
		
		<div class="clear"></div>
		
		<?php foreach ($categories as $category) { ?>
		<div id="<?php echo $genid . $category['name'] ?>" class="form-tab">
			<?php echo $category['content'] ?>
		</div>
		<?php } ?>
		
		<input type="hidden" id="<?php echo $genid?>needs_observations" value="<?php echo ($needs_observations ? '1' : '0')?>"/>
	
		<div>
		<?php echo submit_button($detail->isNew() ? lang('add news detail') : lang('save changes')) ?>
		</div>
		
		<div class="clear"></div>
	</div>
	
</div>
</div>
</form>
<script>
var ws_dim = <?php echo $ws_dim->getId()?>;
var genid = '<?php echo $genid?>';
$(function() {

	og.beforeSavingDetail = function() {

		var needs_obs = $("#"+genid+"needs_observations").val();
		var obs_text = $("#"+genid+"newsDetailObs").val();
		if (needs_obs == '1' && obs_text == '') {
			og.err(lang('you have to fill observations input'));
			return false;
		}
		return true;
	}

	og.checkForObservations = function() {
		var int_dest = $("#"+genid+"newsDetailDestinyId").val();

		var date_picker = Ext.getCmp(genid + "detail[date]Cmp");
		var date_str = date_picker.getValue().format('Y-m-d');

		og.openLink(og.getUrl('time_registration', 'check_needs_observations', {idest: int_dest, date: date_str}), {
			hideLoading: true,
			callback: function(success, data) {
				$("#"+genid+"needs_observations").val(data.needs_observations == true ? '1' : '0');
			}
		});
		
	}

	og.onAddDetailPersonChange = function(person_id) {
		var sel_el = document.getElementById(genid+'newsDetailType');
		var sel_id = sel_el ? sel_el.value : 0;
		og.openLink(og.getUrl('time_registration', 'reload_news_type_selector', {p: person_id, sel: sel_id, genid: genid}), {
			callback: function(success, data) {
				$("#"+genid+"newsDetailTypeContainer").html(data.html);
				$("#"+genid+"newsDetailDestinyContent").html(data.dest);
				$("#"+genid+"newsDetailDestinyId").val(data.dest_id);
				$("#"+genid+"newsDetailDestiny").show();

				og.checkForObservations();
			}
		});
	}

	// filter contacts by current workspace
	var ctx = Ext.util.JSON.decode(og.contextManager.plainContext());
	var member_id = null;
	for (var i=0; i<ctx[ws_dim].length; i++) {
		if (!isNaN(ctx[ws_dim][i]) && ctx[ws_dim][i] > 0) {
			member_id = ctx[ws_dim][i];
			break;
		}
	}
	var filters = {
		is_active: 1,
		user_type: 0
	};
	var plugin_filters = {};
	if (member_id != null) {
		plugin_filters['internal_destiny'] = member_id;
	}
	
	og.renderContactSelector({
		genid: genid,
		id: 'newsDetailContact',
		name: 'detail[person_id]',
		render_to: "contacts_combo_container",
		selected: <?php echo ($detail->getPersonId() > 0 ? $detail->getPersonId() : '0')?>,
		selected_name: '<?php echo $selected_person_name?>',
		onchange_fn: og.onAddDetailPersonChange,
		filters: filters,
		plugin_filters: plugin_filters
	});

	$("#<?php echo $genid?>tabs").tabs();
});
</script>