<?php 
$genid = gen_id();

$hierarchy_groups = array();
$hierarchy_groups_tmp = PersonHierarchyGroups::findAll();
foreach ($hierarchy_groups_tmp as $hg) {
	$hierarchy_groups[$hg->getId()] = $hg;
}

$news_type_groups = array();
$news_type_groups_tmp = NewsTypeGroups::findAll();
foreach ($news_type_groups_tmp as $nt) {
	$news_type_groups[$nt->getId()] = $nt;
}

if (!isset($totals_by_hierarchy)) $totals_by_hierarchy = array();
if (!isset($totals_by_news_type)) $totals_by_news_type = array();
?>
<div class="summary-container">
<table><tr>

<td class="left-stats">
	<div style="padding-left: 5px;" class="stats-container"><?php 
		if ($workspace instanceof Member) {
			$cp = CustomProperties::findOne(array('conditions' => "code = 'responsible'"));
			$cp_val = CustomPropertyValues::getCustomPropertyValue($workspace->getObjectId(), $cp->getId());
			if ($cp_val instanceof CustomPropertyValue) {
				$resp = Contacts::findById($cp_val->getValue());
				if ($resp instanceof Contact) {
					echo '<div style="min-height:20px;margin-top:5px;"><span class="bold">'.lang('responsible').':</span> '. $resp->getObjectName() .'</div>';
				}
			}
			
			$cp = CustomProperties::findOne(array('conditions' => "code = 'auxiliar'"));
			$cp_val = CustomPropertyValues::getCustomPropertyValue($workspace->getObjectId(), $cp->getId());
			if ($cp_val instanceof CustomPropertyValue) {
				$aux = Contacts::findById($cp_val->getValue());
				if ($aux instanceof Contact) {
					echo '<div style="min-height:20px;"><span class="bold">'.lang('auxiliar').':</span> '. $aux->getObjectName() .'</div>';
				}
			}
		}
		
		if (isset($summary) && $summary instanceof NewsSummary) {
			$today = DateTimeValueLib::now()->beginningOfDay();
				
			?><div style="height:25px;"><div class="bold" style="height:25px;float:left; padding-top:4px;"><?php echo lang('summary status')?>:</div><?php 
			
			if ($summary->getStatus() == 'pending') {
				
				if ($summary->getDate()->getTimestamp() < $today->getTimestamp()) $class = "late-pending";
				else $class = "today-pending";
				
				if (can_approve_summaries(logged_user()) && !$for_widget) {
					$options = array(
						option_tag(lang('summary status pending'), 'pending', array('selected' => 'selected')),
						option_tag(lang('summary status approved'), 'approved'),
					);
					echo "<div class='$class' style='float:left; padding:1px; margin-left:3px;'>";
					echo select_box('summary_status', $options, array('onchange' => 'og.work_time_registration.status_combo_change(this)'));
					echo "</div>";
				} else {
					
				?>&nbsp;<span class="<?php echo $class?>" style="vertical-align:sub;"><?php echo lang('summary status '.$summary->getStatus())?></span><?php
				 
				}
			} else {
				
				$class = 'approved';
	/*			if (can_edit_approved_summaries(logged_user())) {
					$options = array(
						option_tag(lang('summary status pending'), 'pending'),
						option_tag(lang('summary status approved'), 'approved', array('selected' => 'selected')),
					);
					echo "<div class='$class' style='float:left; padding:1px;'>";
					echo select_box('summary_status', $options, array('onchange' => 'og.work_time_registration.status_combo_change(this)'));
					echo "</div>";
				} else {
	*/
				?><div style="float:left; padding-top:4px; margin-left:2px;">
					<span class="<?php echo $class?>"><?php echo lang('summary status '.$summary->getStatus())?></span></div><?php
			//	}
			}
	?>
		<script><?php echo 'var is_today = '.($summary->getDate()->getTimestamp() < $today->getTimestamp() ? '0' : '1').';'?></script>
		</div>
		<div class="clear"></div>
		
	<?php } else {
			if (!$for_widget) {
				?><div style="height:25px;"><div class="bold" style="height:25px;float:left; padding-top:4px;"><?php echo lang('summary status')?>:</div><?php
				$options = array(option_tag(lang('summary status pending'), 'pending', array('selected' => 'selected')), option_tag(lang('summary status approved'), 'approved'),);
				echo "<div class='today-pending' style='float:left; padding:1px; margin-left:3px;'>";
				echo select_box('summary_status', $options, array('onchange' => 'og.work_time_registration.create_approved_summary(this)'));
				echo "</div><div class='clear'></div>";
			} 
	?>
	<?php } ?>

		<table class="date-row-container"><tr><td><span class="bold"><?php echo lang('date')?>:</span>
		<td><div id="<?php echo $genid?>date_picker_summary"></div></td>
		</tr></table>
	</div>
</td>

<td class="center-stats">
	<div class="stats-container">
		<table><tr><th></th><th class="num"><?php echo lang('total persons')?></th>
				<th class="num"><?php echo lang('presents')?></th><th class="num"><?php echo lang('abscents')?></th></tr>
		</table>
		<div class="table-container" style="border-bottom:1px solid #ddd;overflow-y:auto;">
		<table>
<?php
		$total_persons = 0;
		$total_absences = 0;
		$alt = '';
		foreach ($totals_by_hierarchy as $hid => $hpersons) {?>
			<tr<?php echo $alt?>><td><?php echo $hierarchy_groups[$hid]->getName()?></td><td class="num"><?php echo $hpersons->getTotal()?></td>
				<td class="num"><?php echo $hpersons->getTotal() - $hpersons->getTotalAbsences()?></td><td class="num"><?php echo $hpersons->getTotalAbsences()?></td></tr>
	<?php	
			$total_persons += $hpersons->getTotal();
			$total_absences += $hpersons->getTotalAbsences();
			$alt = $alt == "" ? ' class="alt"' : "";
		}
		if ($total_persons > 0) {
			$abs_p = number_format($total_absences * 100 / $total_persons, 2);
		} else {
			$abs_p = 0;
		}
		?>
		</table>
		</div>
		<table style="overflow: overlay;">
			<tr><td><?php echo lang('total')?></td><td class="num"><?php echo $total_persons?></td>
				<td class="num"><?php echo $total_persons - $total_absences?></td><td class="num"><?php echo $total_absences . " ($abs_p %)"?></td>
				<?php if (count($totals_by_hierarchy) > 3) { ?>
				<td style="width:13px;">&nbsp;</td>
				<?php } ?>
			</tr>
		</table>
	</div>
</td>

<td class="right-stats">
	<div class="stats-container">
		<div class="abs-title"><?php echo lang('general statistics')?></div>
		<table><tr><th><?php //echo lang('cause')?></th></tr></table>
		<div class="table-container">
		<table>
<?php
		$alt = '';
		$with_no_cause = 0;
		foreach ($totals_by_news_type as $ntid => $nt_total) {
			if ($ntid == 0) {
				$with_no_cause = $nt_total;
				continue;
			}
		?>
			<tr<?php echo $alt?>><td><?php echo $news_type_groups[$ntid]->getName()?></td><td><?php echo $nt_total?></td>
<?php		$alt = $alt == "" ? ' class="alt"' : "";
		}
		if ($with_no_cause > 0) {?>
			<tr<?php echo $alt?>><td><?php echo lang('without cause')?></td><td><?php echo $with_no_cause?></td>
<?php 
		}
		?><tr<?php echo $alt?>><td><?php echo lang('presents')?></td><td><?php echo ($total_persons - $total_absences)?></td>
		
		</table>
		</div>
	</div>
</td>

</tr></table>
</div>


<script>
var date_val = '<?php echo ($summary_date instanceof DateTimeValue ? $summary_date->format(user_config_option('date_format')) : '') ?>';
var genid = '<?php echo $genid?>';
var sum_id = '<?php echo (isset($summary) && $summary instanceof NewsSummary ? $summary->getId() : 0)?>';
var dim_id = '<?php echo ($workspace instanceof Member ? $workspace->getDimensionId() : '0')?>';

og.work_time_registration.status_combo_change = function(el) {
	
	var val = el.options[el.selectedIndex].value;
	
	og.openLink(og.getUrl('time_registration', 'change_summary_status', {id: sum_id, st: val}), {callback: function(success, data) {
		if (success && !data.sub_sum_pending) {
			if (val == 'approved') {
				el.parentNode.className = 'approved';
				el.parentNode.innerHTML = lang('summary status approved');
				var tree = Ext.getCmp("dimension-panel-" + dim_id);
				if (tree) {
					var selected_node = tree.getSelectionModel().getSelectedNode();
					if (selected_node) selected_node.getUI().removeClass('pending-summary-node');
				}
			} else {
				el.parentNode.className = is_today ? 'today-pending' : 'late-pending';
			}
		} else {
			el.selectedIndex = 0;
			
			if (val == 'approved' && data.sub_sum_pending) {
				Ext.Msg.show({
					title: '',
					msg: lang('do you want to approve summaries of all sub internal destiny'),
					buttons: Ext.Msg.YESNO,
					fn: function(button, text){
						if (button == 'yes') {
							og.openLink(og.getUrl('time_registration', 'change_summary_status', {id: sum_id, st: val, approve_sub:1}), {callback: function(success, data) {
								if (success) {
									el.parentNode.className = 'approved';
									el.parentNode.innerHTML = lang('summary status approved');

									var tree = Ext.getCmp("dimension-panel-" + dim_id);
									if (tree) {
										var selected_node = tree.getSelectionModel().getSelectedNode();
										if (selected_node) {
											selected_node.getUI().removeClass('pending-summary-node');
											selected_node.cascade(function(){this.getUI().removeClass('pending-summary-node')});
										}
									}
								}
							}});
						}
					},
					icon: Ext.MessageBox.QUESTION
				});
			}
		} 
	}});
}

og.work_time_registration.create_approved_summary = function(el) {
	
	var val = el.options[el.selectedIndex].value;
	if (val == 'approved') {
		var d = Ext.getCmp(genid + 'summary_date').getValue().format('Y-m-d');
		og.openLink(og.getUrl('time_registration', 'create_approved_summary', {date: d, st: val}));
	}
}

og.work_time_registration.reload_news_list = function(date) {
	var panel = Ext.getCmp('time-reg-manager-container');
	panel.setDateFilter(date.format(og.preferences['date_format']));
	panel.reset();
};

var summary_date_picker = new og.DateField({
	renderTo: genid + 'date_picker_summary',
	displayField:'text',
 	emptyText: og.preferences['date_format_tip'],
	name: 'summary_date',
	id: genid + 'summary_date',		
	allowBlank: true,
	value: date_val,	
	listeners: {
		'change':function(component, newValue, oldValue){
			this.setValue(newValue);
			og.work_time_registration.reload_news_list(newValue);
		}
	},
	menuListeners: {
		select:function(component, val) {
			this.setValue(val);
			og.work_time_registration.reload_news_list(val);
		} 
	}
});
$(function() {
<?php if ($for_widget) { ?>
	summary_date_picker.hide();
	$('<div>'+date_val+'</div>').appendTo($('#' + genid + 'date_picker_summary'));
<?php } ?>
});
</script>