<?php
if (isset($object) && $object instanceof NewsDetail) {
	if (!$object->isTrashed()){
		if($object->canEdit(logged_user())) {
			add_page_action(lang('edit'), get_url('time_registration', 'edit', array('id' => $object->getId())), 'ico-edit', null, null, true);
		} // if
	}
	if ($object->canDelete(logged_user())) {
		if ($object->isTrashed()) {
			add_page_action(lang('restore from trash'), "javascript:if(confirm(lang('confirm restore objects'))) og.openLink('" . $object->getUntrashUrl() ."');", 'ico-restore', null, null, true);
			add_page_action(lang('delete permanently'), "javascript:if(confirm(lang('confirm delete permanently'))) og.openLink('" . $object->getDeletePermanentlyUrl() ."');", 'ico-delete', null, null, true);
		} else {
			add_page_action(lang('move to trash'), "javascript:if(confirm(lang('confirm move to trash'))) og.openLink('" . $object->getTrashUrl() ."');", 'ico-trash', null, null, true);
		}
	}
?>

<div style="padding:7px">
<div class="time-registration">
<?php
	$nt = NewsTypes::findById($object->getNewsTypeId());
	$nt_name = $nt instanceof NewsType ? $nt->getDescription() : lang('without cause');
	
	$div_cls = 'class="time-registration-content"';
	
	$content = '';
	$content .= '<div '.$div_cls.'><span class="bold ">'.lang('news type').': </span>'.$nt_name.'</div>';
	$content .= '<div '.$div_cls.'><span class="bold ">'.lang('date').': </span>'.format_date($object->getDate(), null, 0).'</div>';
	$content .= '<div '.$div_cls.'><span class="bold ">'.lang('hour').': </span>'.$object->getHour().':'.$object->getMinute().'</div>';
	if ($object->getComment() != '') {
		$content .= '<div '.$div_cls.'><span class="bold ">'.lang('news detail comment').': </span>'.$object->getComment().'</div>';
	}
	if ($object->getObservations() != '') {
		$content .= '<div '.$div_cls.'><span class="bold ">'.lang('observations').': </span>'.$object->getObservations().'</div>';
	}
	
	$content .= "<br /><br />";
	
	$person = Contacts::findById($object->getPersonId());
	$title = $person->getObjectName() . ' - ' . format_date($object->getDate(), null, 0);
	
	tpl_assign("title", $title);
	tpl_assign("content", $content);
	tpl_assign("object", $object);
	tpl_assign('iconclass', 'ico-large-news-detail');
	
	$this->includeTemplate(get_template_path('view', 'co'));
?>
</div>
</div>
<?php } //if isset ?>
