<style>
.presents-by-hierarchy-group-report-container td, .presents-by-hierarchy-group-report-container th {
	text-align: center;
}
.presents-by-hierarchy-group-report-container td.left {
	text-align: left;
}
.presents-by-hierarchy-group-report-container td.right {
	text-align: right;
}
.presents-by-hierarchy-group-report-container table {
	margin-top: 15px;
}
.presents-by-hierarchy-group-report-container table tr.totals {
	font-weight: bold;
}
.presents-by-hierarchy-group-report-container .total-presents {
	font-weight: bold;
	font-size: 125%;
	margin: 15px;
}
</style>
<?php	
	
	function print_hierarchy_group_table($hg, $data, $hierarchies_by_group) {
		
		$hg_object = PersonHierarchyGroups::findById($hg);
		
		$html = '<h1>'.$hg_object->getName().'</h1>';
		
		$html .= '<table><tr><th></th>';
		foreach ($hierarchies_by_group[$hg] as $hg_id => $hg_obj) {
			$html .= '<th>'.$hg_obj->getName().'</th>';
		}
		$html .= '<th>'.lang('total').'</th><th style="width:70px;">%</th></tr>';
		
		$total = 0;
		$totals_by_idest = array();
		$totals_by_h = array();
		foreach ($data as $idest => $vals) {
			$m = Members::findById($idest);
			$html .= '<tr><td class="left">'.$m->getName().'</td>';
			$st = 0;
			foreach ($hierarchies_by_group[$hg] as $h_id => $h_obj) {
				$v = array_var($data[$idest], $h_id, 0);
				
				if (!isset($totals_by_h[$h_id])) $totals_by_h[$h_id] = 0;
				$totals_by_h[$h_id] = $totals_by_h[$h_id] + $v;
				
				$html .= '<td>'. $v . '</td>';
				$st += $v;
			}
			$html .= '<td class="bold">'.$st.'</td><td class="bold right">__perc'.$idest.'__</td></tr>';
			$total += $st;
			$totals_by_idest[$idest] = $st;
		}
		
		// print totals
		$html .= '<tr class="totals"><td class="left">'.lang('totals').'</td>';
		$general_total = 0;
		foreach ($totals_by_h as $h_id => $total1) {
			$html .= '<td class="bold">'. $total1 . '</td>';
			$general_total += $total1;
		}
		$html .= '<td>'.$general_total.'</td><td class="right">100.00%</td></tr>';
		
		// calculate percentage and replace in table
		foreach ($data as $idest => $vals) {
			if ($total == 0) $p = 0;
			else $p = number_format($totals_by_idest[$idest] * 100 / $total, 2);
			$html = str_replace("__perc".$idest."__", "$p%", $html);
		}
		
		$html .= '</table>';
		echo $html;
		
		return $general_total;
	}
	
	
	function print_total_line($total) {
		echo '<div class="total-presents">'.lang('total presents').': '.$total.'</div>';
	}
	
	
	function print_percent_table($totals_by_hg, $total) {
		$html = '<div style="max-width:50%;"><h1>'.lang('percentages').'</h1>';
		$html .= '<table><tr><th>'.lang('group').'</th><th style="width:70px;">%</th></tr>';
		foreach ($totals_by_hg as $hg => $hg_total) {
			$hg_object = PersonHierarchyGroups::findById($hg);
			$p = number_format($hg_total * 100 / $total, 2);
			
			$html .= '<tr><td>'.$hg_object->getName().'</td><td class="right">'.$p.'%</td></tr>';
		}
		$html .= '<tr class="totals"><td></td><td class="bold right">100.00%</td></tr></table></div>';
		echo $html;
	}

?>
<div class="summary-report-container">
	<div class="presents-by-hierarchy-group-report-container">
<?php
	$options = array_var($_SESSION, 'presents_by_hierarchy_group', array());
	
	$date_format = user_config_option('date_format');
	if ($date instanceof DateTimeValue) {
		echo '<span class="bold">'. lang('date').'</span>:&nbsp;'. $date->format($date_format);
	}
	
	echo '<br ><span class="bold">'. lang('internal destiny').'</span>:&nbsp;' . ($main_idest instanceof Member ? $main_idest->getName() : lang('all'));
	echo '<br />';
	
	$totals_by_hg = array();
	$total = 0;	
	foreach ($count_by_hierarchy_group as $hg => $data) {
		$totals_by_hg[$hg] = print_hierarchy_group_table($hg, $data, $hierarchies_by_group);
		$total += $totals_by_hg[$hg];
	}
	print_percent_table($totals_by_hg, $total);
	print_total_line($total);
	
?>
	</div>
</div>

