<?php
	require_javascript("og/ReportingFunctions.js");
	$genid = gen_id();
	if (!isset($conditions)) $conditions = array();
	
	$report_data = array_var($_SESSION, 'presents_by_hierarchy_group');
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('time_registration_reports', 'presents_by_hierarchy_group') ?>" method="post" enctype="multipart/form-data">

<div class="reportTotalTimeParams">
<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo lang('presents by hierarchy group report') ?>
		
	</div>
	<div style="padding:5px 0"><?php echo lang('presents by hierarchy group report description') ?></div>
</div>

<div class="">
	
	<?php if (count(active_context_members(false)) > 0) : ?>
	<div style="margin-bottom: 15px; padding-bottom: 5px; border-bottom:1px dotted #aaa;">
		<h5><?php echo lang('showing information for')?>:</h5>
		<ul>
		<?php
			$context = active_context();
			foreach ($context as $selection) :
				if ($selection instanceof Member) : ?>
					<li><span class="coViewAction <?php echo $selection->getIconClass()?>"><?php echo $selection->getName()?></span></li>	
		<?php 	endif;
			endforeach;
		?>
		</ul>
	</div>
	<?php else: ?>
	<div style="padding:5px;"></div>
	<?php endif; ?>

	<table>
		<?php 
			$date = getDateValue($report_data['date']);
			if (!$date instanceof DateTimeValue) {
				$date = DateTimeValueLib::now();
			}
		?>
		<tr class="dateTr">
			<td><span class="bold"><?php echo lang("date") ?>:&nbsp;</span></td>
			<td align='left' style="padding-left:10px;"><?php echo pick_date_widget2('report[date]', $date, $genid);?></td>
		</tr>
		
		
		<tr style='height:30px;'>
			<td><span class="bold"><?php echo lang('include subworkspaces') ?></span></td>
			<td align='left' style="padding-left:10px;">
				<?php echo checkbox_field('report[include_subdest]', array_var($report_data, 'include_subdest', true), array("id" => "report[include_subdest]")); ?> 
			</td>
		</tr>
		
	</table>
	
<br/>
<?php echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;', 'class'=>"blue")) ?>
</div>
</div>

</form>

