<?php
	
	function print_summary_info_list($info, $date, $internal_dest, $hgs, $ntgs, $nts) {
		$member = Members::findById($internal_dest);
		echo '<div style="float:left;"><span class="bold">'.$member->getName().'</span></div>';
		echo '<div style="float:right;"><span class="bold">'.format_date($date, null, 0).'</span></div>';
		echo '<div class="clear"></div>';
		
		$print = in_array($internal_dest, active_context_members(false));
		
		if ($print) {
		//	echo '<h1>'.lang('summary report').'</h1>';
		}
		$report_totals = print_summary_info_totals_by_hierarchy_list(array_var($info, 'totals_by_hg'), $hgs, $print);
		
		print_summary_info_totals_by_news_type_group_list(array_var($info, 'totals_by_ntg'), $ntgs, $report_totals);
		
		$options = array_var($_SESSION, 'summary_report', array());
		if (array_var($options, 'show_details') == 'checked') {
			print_summary_info_details_list(array_var($info, 'details'), $hgs, $ntgs, $nts);
		}
		
		print_summary_info_obs_list(array_var($info, 'observations'));
		
		// echo '<div style="margin:20px 0; border-top: 5px double #aaa;"></div>';
	}
	
	function print_summary_info_totals_by_hierarchy_list($totals_by_hg, $hgs, $print) {
		
		$report_totals = array('t' => 0, 'a' => 0, 'p' => 0);
		
		$html = '<table><tr><th rowspan="2" class="border">'.lang('person hierarchy group').'</th><th rowspan="2" class="center border">'.lang('total').
		'</th><th colspan="2" class="center">'.lang('abscents').'</th><th colspan="2" class="center">'.lang('presents').'</th></tr>';
		$html .= '<tr><th class="center border">'.lang('total').'</th><th class="center border">%</th><th class="center border">'.lang('total').'</th><th class="center border">%</th></tr>';
		
		foreach ($totals_by_hg as $hg => $tot) {
			$html .= '<tr><td>'.$hgs[$hg]->getName().'</td><td class="center">'.$tot->getTotal().'</td>';
			
			$p1 = number_format($tot->getTotalAbsences()*100/$tot->getTotal(), 2);
			$html .= '<td class="center">'.$tot->getTotalAbsences().'</td><td class="center">'.$p1.'%</td>';
			
			$p2 = number_format(100 - $p1, 2);
			$html .= '<td class="center">'.($tot->getTotal() - $tot->getTotalAbsences()).'</td><td class="center">'.$p2.'%</td>';
			
			$html .= '</tr>';
			
			$report_totals['t'] = $report_totals['t'] + $tot->getTotal();
			$report_totals['a'] = $report_totals['a'] + $tot->getTotalAbsences();
			$report_totals['p'] = $report_totals['p'] + $tot->getTotal() - $tot->getTotalAbsences();
		}
		
		$html .= '<tr class="bold totals"><td>'.lang('totals').'</td><td class="center">'.$report_totals['t'].'</td>';
		
		$p1 = number_format($report_totals['a']*100/$report_totals['t'], 2);
		$html .= '<td class="center">'.$report_totals['a'].'</td><td class="center">'.$p1.'%</td>';
		
		$p2 = number_format(100 - $p1, 2);
		$html .= '<td class="center">'.$report_totals['p'].'</td><td class="center">'.$p2.'%</td>';
		
		$html .= '</tr></table>';
		
		if ($print) {
			echo $html;
		}
		return $report_totals;
	}
	
	
	function print_summary_info_totals_by_news_type_group_list($totals_by_ntg, $ntgs, $report_totals) {
		
		//echo '<h1>'.lang('general statistics').'</h1>';
		
		$report_total = array_var($report_totals, 'p', 0);
		foreach ($totals_by_ntg as $ntg => $tot) {
			$report_total += $tot;
		}
		
		$html = '<table><tr><th rowspan="2" class="border">'.lang('news type group').'</th>'.'<th colspan="2" class="center">'.lang('news details').'</th></tr>';
		$html .= '<tr><th class="center border">'.lang('total').'</th><th class="center border">%</th></tr>';
		
		foreach ($totals_by_ntg as $ntg => $tot) {
			$name = $ntg == 0 ? lang('without cause') : $ntgs[$ntg]->getName();
			$html .= '<tr><td>'.$name.'</td><td class="center">'.$tot.'</td><td class="center">'. number_format($tot * 100/$report_total, 2) .'%</td></tr>';
		}
		
		$p = array_var($report_totals, 'p', 0);
		$html .= '<tr><td>'.lang('presents').'</td><td class="center">'. $p .'</td><td class="center">'. number_format($p * 100/$report_total, 2) .'%</td></tr>';
		
		$html .= '<tr class="bold totals"><td>'.lang('totals').'</td><td class="center">'.$report_total.'</td><td class="center">100%</td></tr>';
		
		$html .= '</table>';
		
		echo $html;
	}
	
	
	function print_summary_info_details_list($details, $hgs, $ntgs, $nts) {
		$hgs_by_code = array();
		foreach ($hgs as $hg) $hgs_by_code[$hg->getCode()] = $hg;
		
		//echo '<h1>'.lang('summary news details list').'</h1>';
		
		echo '<table><tr class="border"><th>'.lang('person hierarchy').'</th><th>'.lang('surname').'</th><th>'.lang('first_name').'</th><th>'
			.lang('news detail').'</th><th>'.lang('internal_destiny').'</th><th>'.lang('observation').'</th></tr>';
		
		$grouped_details = group_details_by_hierarchy_group_list($details, $hgs);
		
		foreach ($grouped_details as $hg_code => $hg_info) {
			// hierarchy group header
			//echo '<tr><th class="hgname" colspan="6">'.$hgs_by_code[$hg_code]->getName().'</th></tr>';
			// details
			foreach ($hg_info as $h_code => $h_info) {
				foreach ($h_info as $cname => $info) {
					$d = DateTimeValueLib::dateFromFormatAndString(DATE_MYSQL, $info['det']['date']);
					echo '<tr>';
					//echo '<td>'. ($d instanceof DateTimeValue ? format_date($d,null,0) : '') .'</td>';
					echo '<td>'. $info['h_name'] .'</td>';
					echo '<td>'. $info['contact']['surname'] .'</td>';
					echo '<td>'. $info['contact']['firstname'] .'</td>';
					$nt_name = $info['det']['news_type_id'] == 0 ? lang('without cause') : $nts[$info['det']['news_type_id']]->getDescription();
					echo '<td>'. $nt_name .'</td>';
					echo '<td>'. $info['det']['internal_destiny_name'] .'</td>';
					echo '<td>'. $info['det']['observations'] .'</td>';
					echo '</tr>';
				}
			}
		}
		
		echo '</table>';
		
	}
	
	function print_summary_info_obs_list($obs) {
		if ($obs != "") {
			echo '<h1>'.lang('general observations').'</h1>';
			echo $obs;
		}
	}
	
	function group_details_by_hierarchy_group_list($details, $hgs) {
		$grouped_details = array();
		
		foreach ($details as $detail) {
			$contact = Contacts::findById($detail['person_id']);
			$h = PersonHierarchies::findById($contact->getColumnValue('hierarchy_id'));
			$hg_id = $h->getHierarchyGroupId();
			$hg = $hgs[$hg_id];
			
			if (!isset($grouped_details[$hg->getCode()])) $grouped_details[$hg->getCode()] = array();
			$contact_name = strtolower($contact->getSurname().' '.$contact->getFirstName());
			$grouped_details[$hg->getCode()][$h->getCode()][$contact_name] = array(
				'det' => $detail,
				'h_name' => $h->getName(),
				'contact' => array('surname' => $contact->getSurname(), 'firstname' => $contact->getFirstName())
			);
		}
		
		// order by hierarchy group code, hierarchy code, person surname and firstname
		foreach ($grouped_details as $k => &$gd) {
			// order by person surname, firstname
			foreach ($gd as &$d) ksort($d, SORT_STRING | SORT_FLAG_CASE);
			// order by hierarchy code
			ksort($gd, SORT_STRING | SORT_FLAG_CASE);
		}
		// order by hierarchy group code
		ksort($grouped_details, SORT_STRING | SORT_FLAG_CASE);
		
		return $grouped_details;
	}

	$date_format = user_config_option('date_format');
	?>
	
	<div class="summary-report-container">
<?php
	$crumbJs = "";
	
	// hierarchy groups
	$hgs = array();
	$hgs_tmp = PersonHierarchyGroups::findAll(array('conditions' => 'enabled=1'));
	foreach ($hgs_tmp as $hg) {
		$hgs[$hg->getId()] = $hg;
	}
	// news type groups
	$ntgs = array();
	$ntgs_tmp = NewsTypeGroups::findAll(array('conditions' => 'enabled=1'));
	foreach ($ntgs_tmp as $ntg) {
		$ntgs[$ntg->getId()] = $ntg;
	}
	// news types
	$nts = array();
	$nts_tmp = NewsTypes::findAll(array('conditions' => 'enabled=1'));
	foreach ($nts_tmp as $nt) {
		$nts[$nt->getId()] = $nt;
	}
	
	foreach ($summaries_info as $k => $group) {
		if (is_numeric($k)) $internal_dest = $k;
		else $date = DateTimeValueLib::makeFromString($k);
		
		foreach ($group as $key => $info) {
			if (is_numeric($key)) $internal_dest = $key;
			else $date = DateTimeValueLib::makeFromString($key);
			
			print_summary_info_list($info, $date, $internal_dest, $hgs, $ntgs, $nts);
		}
	}
	
?>
	</div>
	<script>eval('<?php echo $crumbJs; ?>');</script>



