<?php
	require_javascript("og/ReportingFunctions.js");
	$genid = gen_id();
	
	$report_data = array_var($_SESSION, 'summary_report');
?>
<form style='height:100%;background-color:white' class="internalForm" action="<?php echo get_url('time_registration_reports', 'summary_report') ?>" method="post" enctype="multipart/form-data">

<div class="reportTotalTimeParams">
<div class="coInputHeader">
	<div class="coInputHeaderUpperRow">
		<div class="coInputTitle"><?php echo lang('summary report') ?>
		
	</div>
	<div style="padding:5px 0"><?php echo lang('summary report description') ?></div>
</div>

<div class="">
	
	<?php 
		$contact_options = array(option_tag(lang('all'), 0));
		if (count(active_context_members(false)) > 0) : ?>
	<div style="margin-bottom: 15px; padding-bottom: 5px; border-bottom:1px dotted #aaa;">
		<h5><?php echo lang('showing information for')?>:</h5>
		<ul>
		<?php
			$idest = null;
			$ws_ot = ObjectTypes::findByName('workspace');
			$context = active_context();
			foreach ($context as $selection) :
				if ($selection instanceof Member) : ?>
					<li><span class="coViewAction <?php echo $selection->getIconClass()?>"><?php echo $selection->getName()?></span></li>	
		<?php 		if ($selection->getObjectTypeId() == $ws_ot->getId()) {
						$idest = $selection;
					}
				endif;
			endforeach;
			
			$contact_conditions = "user_type=0";
			if ($idest instanceof Member) {
				$member_ids = array($idest->getId());
				$member_ids = array_merge($member_ids, $idest->getAllChildrenIds(true));
				$contact_conditions .= " AND internal_destiny IN (".implode(',', $member_ids).")";
			}
			$contacts = Contacts::findAll(array('conditions' => $contact_conditions, 'order' => 'surname, first_name'));
			foreach ($contacts as $c) {
				$attr = array();
				if (array_var($report_data, 'person_id') == $c->getId()) $attr['selected'] = 'selected';
				$o = option_tag($c->getSurname()." ".$c->getFirstName(), $c->getId(), $attr);
				$contact_options[] = $o;
			}
		?>
		</ul>
	</div>
	<?php else: ?>
	<div style="padding:5px;"></div>
	<?php endif; ?>

	<table>
		
		<?php
			$st = getDateValue(array_var($report_data, 'date_start'));
			if (!$st instanceof DateTimeValue) $st = DateTimeValueLib::now();
			$et = getDateValue(array_var($report_data, 'date_end'));
			if (!$et instanceof DateTimeValue) $et = DateTimeValueLib::now();
		?>
		<tr style="height:25px;" class="dateTr">
			<td><span class="bold"><?php echo lang("start date") ?>:&nbsp;</span></td>
			<td align='left' style="padding-left:10px;"><?php echo pick_date_widget2('date_start', $st, $genid);?></td>
		</tr>
		<tr style="height:25px;" class="dateTr">
			<td><span class="bold"><?php echo lang("end date") ?>:&nbsp;</span></td>
			<td align='left' style="padding-left:10px;"><?php echo pick_date_widget2('date_end', $et, $genid);?></td>
		</tr>
		
		<tr style="height:25px;">
			<td><span class="bold"><?php echo lang("person") ?>:&nbsp;</span></td>
			<td align='left' style="padding-left:10px;"><?php echo isset($contact_options) ? select_box("person_id", $contact_options) : "<span class='desc'>".lang('internal destiny not selected to filter people')."</span>";?></td>
		</tr>
		
		<tr style="height:25px;">
			<td><span class="bold"><?php echo lang("news type") ?>:&nbsp;</span></td>
			<td align='left' style="padding-left:10px;"><?php echo news_type_select_box("news_type_id", array_var($report_data, 'news_type_id'), null, true, null, lang('all'));?></td>
		</tr>
		
		<tr style="height:25px;">
			<td><span class="bold"><?php echo lang('show news detail list') ?></span></td>
			<td align='left' style="padding-left:10px;">
				<?php echo checkbox_field('show_details', array_var($report_data, 'show_details') == 'checked', array("id" => "report[show_details]")); ?> 
			</td>
		</tr>
		
		<tr style="height:25px;">
			<td><span class="bold"><?php echo lang('show news detail presents') ?></span></td>
			<td align='left' style="padding-left:10px;">
				<?php echo checkbox_field('show_present_news', array_var($report_data, 'show_present_news') == 'checked', array("id" => "report[show_present_news]")); ?> 
			</td>
		</tr>
		
	</table>
	
<br/>
<?php echo submit_button(lang('generate report'),'s',array('style'=>'margin-top:0px;', 'class'=>"blue")) ?>
</div>
</div>

</form>
