-- <?php echo $table_prefix ?> 
-- <?php echo $default_charset ?> DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci
-- <?php echo $default_collation ?> collate utf8_unicode_ci
-- <?php echo $engine ?> InnoDB
-- varchar cannot be larger than 256
-- blob/text cannot have default values
-- sql queries must finish with ;\n (line break inmediately after ;)

CREATE TABLE `<?php echo $table_prefix ?>person_hierarchy_groups` (
  `id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `code` VARCHAR(255) NOT NULL,
  `name` VARCHAR(255) NOT NULL,
  `enabled` tinyint(1) NOT NULL,
  `created_by_id` int(10) unsigned NOT NULL,
  `created_on` datetime NOT NULL,
  `updated_by_id` int(10) unsigned NOT NULL,
  `updated_on` datetime NOT NULL,
  PRIMARY KEY (`id`)
)
ENGINE = <?php echo $engine ?>;

CREATE TABLE `<?php echo $table_prefix ?>person_hierarchies` (
  `id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `code` VARCHAR(255) NOT NULL,
  `name` VARCHAR(255) NOT NULL,
  `long_name` VARCHAR(255) NOT NULL,
  `hierarchy_group_id` int(10) unsigned NOT NULL,
  `enabled` tinyint(1) NOT NULL,
  `created_by_id` int(10) unsigned NOT NULL,
  `created_on` datetime NOT NULL,
  `updated_by_id` int(10) unsigned NOT NULL,
  `updated_on` datetime NOT NULL,
  PRIMARY KEY (`id`)
)
ENGINE = <?php echo $engine ?>;

CREATE TABLE `<?php echo $table_prefix ?>news_type_groups` (
  `id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(255) NOT NULL,
  `enabled` tinyint(1) NOT NULL,
  `created_by_id` int(10) unsigned NOT NULL,
  `created_on` datetime NOT NULL,
  `updated_by_id` int(10) unsigned NOT NULL,
  `updated_on` datetime NOT NULL,
  PRIMARY KEY (`id`)
)
ENGINE = <?php echo $engine ?>;


CREATE TABLE  `<?php echo $table_prefix ?>news_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `description` text NOT NULL,
  `days_to_generate_abscence` int(10) unsigned NOT NULL,
  `generates_abscence` tinyint(1) NOT NULL,
  `hierarchy_group_id` int(10) unsigned NOT NULL,
  `news_type_group_id` int(10) unsigned NOT NULL,
  `is_present_type` tinyint(1) NOT NULL,
  `enabled` tinyint(1) NOT NULL,
  `created_by_id` int(10) unsigned NOT NULL,
  `created_on` datetime NOT NULL,
  `updated_by_id` int(10) unsigned NOT NULL,
  `updated_on` datetime NOT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=<?php echo $engine ?> DEFAULT CHARSET=latin1;


CREATE TABLE  `<?php echo $table_prefix ?>news_details` (
  `object_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `date` datetime NOT NULL,
  `hour` int(10) unsigned NOT NULL,
  `minute` int(10) unsigned NOT NULL,
  `comment` text NOT NULL,
  `person_id` int(10) unsigned NOT NULL,
  `news_type_id` int(10) unsigned NOT NULL,
  `observations` text NOT NULL,
  PRIMARY KEY (`object_id`),
  KEY `date` (`date`)
) ENGINE=<?php echo $engine ?> DEFAULT CHARSET=latin1;

CREATE TABLE `<?php echo $table_prefix ?>news_summary` (
  `object_id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `date` DATETIME NOT NULL,
  `internal_destiny` INTEGER UNSIGNED NOT NULL,
  `total_presents` INTEGER UNSIGNED NOT NULL,
  `status` ENUM('pending','approved') NOT NULL,
  `observations` text NOT NULL,
  PRIMARY KEY (`object_id`),
  INDEX `date`(`date`)
)
ENGINE = <?php echo $engine ?>;

CREATE TABLE `<?php echo $table_prefix ?>news_summary_total_abs` (
  `summary_id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `news_type_id` INTEGER UNSIGNED NOT NULL,
  `total` INTEGER UNSIGNED NOT NULL,
  PRIMARY KEY (`summary_id`, `news_type_id`)
)
ENGINE = <?php echo $engine ?>;

CREATE TABLE `<?php echo $table_prefix ?>news_summary_total_persons` (
  `summary_id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `hierarchy_group_id` INTEGER UNSIGNED NOT NULL,
  `total` INTEGER UNSIGNED NOT NULL,
  PRIMARY KEY (`summary_id`, `hierarchy_group_id`)
)
ENGINE = <?php echo $engine ?>;

CREATE TABLE `<?php echo $table_prefix ?>news_summary_total_persons_by_hierarchy` (
  `summary_id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `hierarchy_id` INTEGER UNSIGNED NOT NULL,
  `total` INTEGER UNSIGNED NOT NULL,
  PRIMARY KEY (`summary_id`, `hierarchy_id`)
)
ENGINE = <?php echo $engine ?>;

CREATE TABLE `<?php echo $table_prefix ?>news_summary_total_abs_by_hierarchy` (
  `summary_id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `hierarchy_id` INTEGER UNSIGNED NOT NULL,
  `total` INTEGER UNSIGNED NOT NULL,
  PRIMARY KEY (`summary_id`, `hierarchy_id`)
)
ENGINE = <?php echo $engine ?>;

CREATE TABLE `<?php echo $table_prefix ?>news_details_history` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `object_id` int(10) unsigned NOT NULL,
  `date` datetime NOT NULL,
  `hour` int(10) unsigned NOT NULL,
  `minute` int(10) unsigned NOT NULL,
  `comment` text NOT NULL,
  `person_id` int(10) unsigned NOT NULL,
  `news_type_id` int(10) unsigned NOT NULL,
  `observations` text NOT NULL,
  `modificated_on` datetime NOT NULL,
  `modificated_by_id` int(10) unsigned NOT NULL,
  `action` varchar(50) NOT NULL,
  `modification_log` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `object_id` (`object_id`),
  KEY `modificated_on` (`modificated_on`)
) ENGINE=<?php echo $engine ?>;


ALTER TABLE `<?php echo $table_prefix ?>contacts` ADD COLUMN `nii` INTEGER UNSIGNED NOT NULL,
 ADD COLUMN `hierarchy_id` INTEGER UNSIGNED NOT NULL,
 ADD COLUMN `document_type` VARCHAR(50) NOT NULL,
 ADD COLUMN `document_number` VARCHAR(50) NOT NULL,
 ADD COLUMN `speciality` VARCHAR(255) NOT NULL,
 ADD COLUMN `is_active` BOOLEAN NOT NULL,
 ADD COLUMN `internal_destiny` INTEGER UNSIGNED NOT NULL;


ALTER TABLE `<?php echo $table_prefix ?>system_permissions`
 ADD COLUMN `can_approve_summaries` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0,
 ADD COLUMN `can_edit_approved_summaries` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0;

ALTER TABLE `<?php echo $table_prefix ?>max_system_permissions`
 ADD COLUMN `can_approve_summaries` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0,
 ADD COLUMN `can_edit_approved_summaries` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0;