<?php
if ($workflow_permission->getType() == 'permission_group_list') {
	$permission_action_name_own = $workflow_permission->getActionName('their own');
	$permission_action_name_others = $workflow_permission->getActionName();
	if ($workflow_permission->getAction() == 'edit') {
		$own_label_text = lang("action x", $permission_action_name_own, strtolower($ot_name));
	} else {
		$own_label_text = lang("action their own x", $permission_action_name_own, strtolower($ot_name));
	}
	$others_label_text = lang("action x for other users", $permission_action_name_others, strtolower($ot_name));
	
}
$permission_lang = lang('can action x', strtolower($workflow_permission->getActionName()), strtolower($ot_name));

?>
	
<div class="workflow-permission-container" id="<?php echo $genid ?>wp-container-<?php echo $workflow_permission->getId() ?>">

	<label><?php echo $permission_lang ?></label>
	<div style="display: inline-block">
	<?php
	
	$attributes = array("id" => $genid . "workflow_permissions_selectbox_".$workflow_permission->getId());
	
	$options = array(
			option_tag(lang('no'), 0, ($workflow_permission_bool_value == 0 ? array('selected' => 'selected') : null)),
			option_tag(lang('yes'), 1, ($workflow_permission_bool_value == 1 ? array('selected' => 'selected') : null)),
	);
	echo select_box('workflow_permissions['.$workflow_permission->getId().'][bool_value]', $options, $attributes);
	?>
	</div>
	
	<?php if ($workflow_permission->getType() == 'permission_group_list') {
		
		$own_data = in_array($current_pg_id, $workflow_permission_value_pgs);
	
		if ($own_data) {
			$workflow_permission_value_pgs = array_diff($workflow_permission_value_pgs, array($current_pg_id));
		}
		?>
	
	<div class="workflow-permission-options" style="<?php if ($workflow_permission_bool_value==0) echo 'display:none;'?>">
	
		<div class="sub-option">
			<label><?php echo $own_label_text ?></label>
			<div style="display: inline-block">
			<?php
			$options = array(
					option_tag(lang('no'), 0, (!$own_data ? array('selected' => 'selected') : null)),
					option_tag(lang('yes'), 1, ($own_data ? array('selected' => 'selected') : null)),
			);
			echo select_box('workflow_permissions['.$workflow_permission->getId().'][pgs]['.$current_pg_id.']', $options);
			?>
			</div>
		</div>
		<div class="clear"></div>
		
		<div class="sub-option">
			<label class="others"><?php echo $others_label_text ?></label>
			<div style="display: inline-block;width: 80%;" id="<?php echo $genid . "workflow_permissions_pgs_" . $workflow_permission->getId() ?>">
			</div>
			<div class="clear"></div>
			<label>&nbsp;</label><a id="<?php echo $genid."add_pg_users".$workflow_permission->getId(); ?>" href="#"><?php echo lang('add users')?></a>
		</div>
		<div class="clear"></div>
		
		<input type="hidden" name="workflow_permissions[<?php echo $workflow_permission->getId()?>][pgs][other]" 
			value="" id="<?php echo $genid."other_pgs_input_".$workflow_permission->getId(); ?>" />
		
	</div>
	
	<script>

	$(function() {
		<?php 
		foreach ($workflow_permission_value_pgs as $affected_pg_id) {
			$group = PermissionGroups::findById($affected_pg_id);
			if ($group->getType() == 'user_groups') {
				$group_name = escape_character($group->getName());
				$group_type = 'group';
			} else if ($group->getType() == 'permission_groups') {
				$contact = Contacts::findById($group->getContactId());
				if (!$contact instanceof Contact) continue;
				$group_name = escape_character($contact->getName());
				$group_type = 'contact';
			}
		?>
		og.workflow_permissions.render_pg_box('<?php echo $affected_pg_id?>', '<?php echo $group_name ?>', '<?php echo $genid?>', '<?php echo $workflow_permission->getId()?>');
		<?php
		}
		?>
	});


	$("#<?php echo $genid . "workflow_permissions_selectbox_".$workflow_permission->getId() ?>").change(function () {
		var show_pgs = parseInt($(this).val());
		if (show_pgs > 0) {
			$("#<?php echo $genid . "wp-container-".$workflow_permission->getId() ?> .workflow-permission-options").show();
		} else {
			$("#<?php echo $genid . "wp-container-".$workflow_permission->getId() ?> .workflow-permission-options").hide();
		}
	});

	$("#<?php echo $genid."add_pg_users".$workflow_permission->getId() ?>").click(function () {
		og.ObjectPicker.show(function (objs) {
			
			if (objs && objs.length > 0) {
				for (var i=0; i<objs.length; i++) {
					var obj = objs[i];

					var pg_id = obj.id;
					var pg_name = obj.data.name;

					og.workflow_permissions.render_pg_box(pg_id, pg_name, '<?php echo $genid?>', '<?php echo $workflow_permission->getId()?>');
				}
			}
		}, null, {
			hide_date_updated_col: true,
			ignore_context: true,
    		hideFilters: true,
    		sort: 'name',
    		dir: 'ASC',
    		url_controller: 'group',
    		url_action: 'list_all_permission_groups',
		}, null, <?php echo $current_pg_id ?>);

		// hide "last updated by" column
		og.ObjectPicker.dialog.grid.view.updateColumnHidden(3, true);
	});
	
	</script>
	
	<?php } ?>
</div>


