<?php

include_once dirname(__FILE__)."/../../../application/helpers/plugin_installer_functions.php";


function workflow_permissions_get_additional_install_queries($db_connection, $table_prefix) {
	
	$queries = array();
	
	if (check_is_installed_plugin($db_connection, $table_prefix, 'expenses2')) {
		$queries[] = "
			INSERT INTO `".$table_prefix."workflow_permissions` (`name`, `object_type_id`, `type`, `action`, `member_id`) VALUES
			('can_edit_locked_expenses', (SELECT id FROM ".$table_prefix."object_types WHERE name='payment_receipt'), 'permission_group_list', 'edit', (SELECT `value` FROM ".$table_prefix."config_options WHERE name='time_bulk_action_locked_member_id')),
			('can_edit_review_expenses', (SELECT id FROM ".$table_prefix."object_types WHERE name='payment_receipt'), 'permission_group_list', 'edit', (SELECT `value` FROM ".$table_prefix."config_options WHERE name='time_bulk_action_review_member_id')),
			('can_approve_expenses', (SELECT id FROM ".$table_prefix."object_types WHERE name='payment_receipt'), 'permission_group_list', 'approve', (SELECT `value` FROM ".$table_prefix."config_options WHERE name='time_bulk_action_approved_member_id')),
			('can_edit_approved_expenses', (SELECT id FROM ".$table_prefix."object_types WHERE name='payment_receipt'), 'permission_group_list', 'edit', (SELECT `value` FROM ".$table_prefix."config_options WHERE name='time_bulk_action_approved_member_id')),
			('can_invoice_expenses', (SELECT id FROM ".$table_prefix."object_types WHERE name='payment_receipt'), 'permission_group_list',	'invoice', (SELECT `value` FROM ".$table_prefix."config_options WHERE name='time_bulk_action_invoiced_member_id')),
			('can_edit_invoiced_expenses', (SELECT id FROM ".$table_prefix."object_types WHERE name='payment_receipt'), 'permission_group_list', 'edit', (SELECT `value` FROM ".$table_prefix."config_options WHERE name='time_bulk_action_invoiced_member_id'));
		";
		
		$queries[] = "
			INSERT INTO `".$table_prefix."dimension_object_type_contents` (`dimension_id`, `dimension_object_type_id`, `content_object_type_id`, `is_required`, `is_multiple`) VALUES
			((SELECT id FROM ".$table_prefix."dimensions WHERE code='status_timesheet'), (SELECT id FROM ".$table_prefix."object_types WHERE name='status_timesheet'), (SELECT id FROM ".$table_prefix."object_types WHERE name='payment_receipt'), '0', '0')
			ON DUPLICATE KEY UPDATE dimension_id=dimension_id;
		";
		
		$queries[] = "
			INSERT INTO ".$table_prefix."workflow_permission_values(workflow_permission_id, permission_group_id, bool_value)
			SELECT wp.id, u.permission_group_id, true
			FROM ".$table_prefix."contacts u
			JOIN ".$table_prefix."workflow_permissions wp
			WHERE u.user_type IN (1,2);
		";
		$queries[] = "
			INSERT INTO ".$table_prefix."workflow_permission_value_pgs (workflow_permission_value_id, affected_permission_group_id)
			SELECT wpv.id, au.permission_group_id
			FROM ".$table_prefix."workflow_permission_values wpv
			INNER JOIN ".$table_prefix."contacts u ON u.permission_group_id = wpv.permission_group_id
			JOIN ".$table_prefix."contacts au
			WHERE u.user_type IN (1,2) AND au.user_type > 0;
		";
		$queries[] = "
			INSERT INTO ".$table_prefix."workflow_permission_values(workflow_permission_id, permission_group_id, bool_value)
			SELECT wp.id, u.permission_group_id, true
			FROM ".$table_prefix."contacts u
			JOIN ".$table_prefix."workflow_permissions wp
			WHERE u.user_type IN (3)
			AND wp.name IN ('can_edit_locked_expenses','can_edit_review_expenses','can_approve_expenses');
		";
		$queries[] = "
			INSERT INTO ".$table_prefix."workflow_permission_value_pgs (workflow_permission_value_id, affected_permission_group_id)
			SELECT wpv.id, au.permission_group_id
			FROM ".$table_prefix."workflow_permission_values wpv
			INNER JOIN ".$table_prefix."workflow_permissions wp ON wp.id = wpv.workflow_permission_id
			INNER JOIN ".$table_prefix."contacts u ON u.permission_group_id = wpv.permission_group_id
			JOIN ".$table_prefix."contacts au
			WHERE u.user_type IN (3) AND au.user_type >= 3 AND au.object_id<>u.object_id
			AND wp.name IN ('can_edit_locked_expenses','can_edit_review_expenses','can_approve_expenses');
		";
	}
	
	return $queries;

}
?>